*-------------------------------
* CAB.EDITOR
*-------------------------------
 DAT
 LST OFF

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE VARS
 USE LIB.JMP
 USE TABLES
 USE CAB.DSECT

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/CAB.EDITOR
 fin

NUMCAB = 9

FILET MAC
 DFB ]1
 ASC ]2
 <<<

 MODID "CAB.EDITOR"

START JSR PRINT
 HOME
 BOX "Cabinet Editor"
 NULL

 LDX #0
 JSR LOADCAB
 LDA MISCBUFF
 STA NUMFILECAB
 JMP :FORW1

:BOT JSR PRINT
 GOTOXY 1;1
 ASC "Total in file : "
 COLOR YELLOW
 DEC8 NUMFILECAB
 COLOR WHITE
 GOTOXY 0;23
 CLEOS
 ASC "[A]dd, [J]ump, [S]ave, [L]ist, [RETURN]-edit, "
 MTON
 INVERSE
 ASC "H"
 NORMAL
 ASC ", "
 INVERSE
 ASC "U"
 NORMAL
 MTOFF
 ASC ", [H]elp, [Q]uit : "
 CURSORON
 NULL
 LDA CH
 STA :BGOTO+2
:GETKEY JSR PRINT
:BGOTO GOTOXY 0;23
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 LDX :KEYS
]LOOP2 CMP :KEYS,X
 BEQ :GOTONE
 DEX
 BNE ]LOOP2
 JMP ]LOOP
:GOTONE DEX
 TXA
 ASL
 TAX
 JMP (:TABLE,X)

:KEYS DFB :ENDKEYS-*-1
 DFB "Q"
 DFB "A"
 DFB "L"
 DFB "J"
 DFB "S"
 DFB "H"-$40
 DFB "U"-$40
 DFB "K"-$40
 DFB "J"-$40
 DFB "M"-$40
 DFB "H"
:ENDKEYS

:TABLE DA EXIT
 DA :ADD
 DA :LIST
 DA :LOAD
 DA :SAVE
 DA :BACK1
 DA :FORW1
 DA :UP
 DA :DOWN
 DA :EDIT
 DA :HELP

:HELP JSR PRINT
 GOTOXY 0;4
 CLEOS
 NULL
 JSR GETFILE
 DFB 4,22 ;Use lines x to y
 STR "HELP/CAB.ED"
 JSR PRINT
 GOTOXY 0;23
 COLOR PINK
 NULL
 GETRETURN
 JSR PRINT
 GOTOXY 0;4
 COLOR WHITE
 CLEOS
 NULL
 JMP :PNBACK

:DOPOINT LDA :OLDPNTR
 CMP #19
 BCC :PLEFT
 LDA #40
 STA :CH+2
 LDA :OLDPNTR
 SEC
 SBC #15
 STA :CV+2
 BRA :DOP1
:PLEFT STZ :CH+2
 LDA :OLDPNTR
 CLC
 ADC #3
 STA :CV+2
:DOP1 JSR PRINT
 NORMAL
 MTOFF
:CH HTAB 0
:CV VTAB 0
 ASC " "
 NULL
 LDA :PNTR
 CMP #19
 BCC :PLEFT2
 LDA #40
 STA :CH2+2
 LDA :PNTR
 SEC
 SBC #15
 STA :CV2+2
 BRA :DOP2
:PLEFT2 STZ :CH2+2
 LDA :PNTR
 CLC
 ADC #3
 STA :CV2+2
:DOP2 JSR PRINT
:CH2 HTAB 0
:CV2 VTAB 0
 NULL
 JSR SHOWPNTR
 LDA :PNTR
 STA :OLDPNTR
 RTS
:OLDPNTR DFB 1
:PNTR DFB 1

:UP LDA NUMFILECAB
 BEQL :BOT
 LDA :PNTR
 CMP #1
 BNE :UPOK
 LDA #NUMCAB+1
:UPOK DEC
 STA :PNTR
 JSR :DOPOINT
 JMP :GETKEY

:DOWN LDA NUMFILECAB
 BEQL :BOT
 LDA :PNTR
 CMP #NUMCAB
 BNE :DNOK
 LDA #0
:DNOK INC
 STA :PNTR
 JSR :DOPOINT
 JMP :GETKEY

:EDIT LDA NUMFILECAB
 BEQL :BOT
 LDA :PNTR
 DEC
 ASL
 TAX
 JMP (:EDITS,X)

:EDITS DA :FREE
 DA :PFROM
 DA :PTO
 DA :DATE
 DA :FTYPE
 DA :BLOCKS
 DA :DESCR
 DA :FNAME
 DA :DLOADS

:LOAD LDA NUMFILECAB
 BEQL :BOT
 JSR PRINT
 GOTOXY 0;23
 CLEOS
 ASC "Jump to cabinet file #"
 CURSORON
 NULL
 GETLINE #5
 JSR GETNUM
 CPX #0
 BNE :LOK
:LOK CPX NUMFILECAB
 BEQ :RNGOK
 BCC :RNGOK
 JSR PRINT
 COLOR PINK
 ASC " No such cabinet file. "
 COLOR WHITE
 NULL
 GETRETURN
 JMP :BOT
:RNGOK STX :CAB
 JSR LOADCAB
 JSR :DISPLAY
 STZ :FLAG
 JMP :BOT

:SAVE LDA NUMFILECAB
 BEQL :BOT
 BIT :FLAG
 BPLL :GETKEY
:SAVE2 LDX :CAB
 JSR SAVECAB
 STZ :FLAG
 JMP :BOT

:BACK1 LDA NUMFILECAB
 BEQL :BOT
 LDA :CAB
 CMP #2
 BCS :GOB
 JMP :BOT
:GOB DEC :CAB
 LDX :CAB
 JMP :LOK

:FORW1 LDA NUMFILECAB
 BEQL :BOT
 LDA :CAB
 CMP NUMFILECAB
 BCC :GOF
 JMP :BOT
:GOF INC :CAB
 LDX :CAB
 JMP :LOK

:LIST LDA NUMFILECAB
 BEQL :BOT
 JSR PRINT
 GOTOXY 0;23
 CLEOS
 ASC "Start from cabinet file #1"
 CURSORLEFT
 NULL
 LDA PADFLAG
 STA TEMP
 LDA #$FF
 STA PADFLAG
 LDA PADCHAR
 STA TEMP+1
 LDA #" "
 STA PADCHAR
 LDA #1
 STA :TOREAD
 GETLINE #5
 BCSL :LEXIT
 CPX #0
 BEQ :FROM1
 JSR GETNUM
 STX :TOREAD
:FROM1 LDA :TOREAD
 CMP NUMFILECAB
 BCC :VGO
 BEQ :VGO
 JSR PRINT
 ASC " - "
 COLOR PINK
 ASC "Last cabinet file is #"
 COLOR YELLOW
 DEC8 NUMFILECAB
 COLOR PINK
 ASC ". "
 COLOR WHITE
 NULL
 GETRETURN
 JSR PRINT
 ZAPLINE
 NULL
 JMP :LEXIT
:VGO LDA :TOREAD
 STA :PNCNTR
 JSR PRINT
 GOTOXY 0;3
 CLEOS
 CR
 COLOR AQUAMARINE
 NULL
 JSR PRINT
 LINE "   #  ? Frm To  Date      Blocks Typ Dload Description"
 COLOR WHITE
 CURSOROFF
 NULL
]LOOP LDA :PNCNTR
 CMP NUMFILECAB
 BCC :RREAD
 BEQ :RREAD
 JMP :RDONE
:RREAD LDX :TOREAD
 JSR LOADCAB
 INC :TOREAD
 BIT $C061
 BPL :LSHOW
 BIT CABFREE
 BMIL :VOK2
:LSHOW LDA CV
 CMP #21
 BNE :VOK
 JSR PRINT
 CR
 CR
 CURSORON
 COLOR YELLOW
 CENTER "[SPACE]-continue, [ESC]-exit : "
 COLOR WHITE
 NULL
]LOOP3 JSR KEYIN
 CMP #$9B
 BEQL :RESC
 CMP #" "
 BNE ]LOOP3
 JSR PRINT
 GOTOXY 0;5
 CLEOS
 CURSOROFF
 NULL
:VOK JSR PRINT
 CR
 ASC " "
 COLOR YELLOW
 DEC8 :PNCNTR
 COLOR WHITE
 ASC ") "
 PRFLAG CABFREE
 ASC " "
 NULL
 LDA CABPARTY
 BNE :OKP
 JSR PRINT
 COLOR PINK
 ASC " GM"
 NULL
 BRA :CTO
:OKP JSR PRINT
 COLOR YELLOW
 DEC8 CABPARTY
 NULL
:CTO JSR PRINT
 ASC " "
 NULL
 LDA CABPARTY2
 BNE :TONUM
 JSR PRINT
 COLOR AQUAMARINE
 ASC "All"
 NULL
 BRA :CDATE
:TONUM CMP CABPARTY
 BEQ :TOME
 JSR PRINT
 COLOR YELLOW
 DEC8 CABPARTY2
 NULL
 BRA :CDATE
:TOME CMP CABPARTY ;To GM?
 BEQ :TOGM
 JSR PRINT
 COLOR PINK
 ASC "GM "
 NULL
 BRA :CDATE
:TOGM JSR PRINT
 COLOR PINK
 ASC " GM"
 NULL
:CDATE JSR PRINT
 ASC " "
 COLOR ORANGE
 DATE CABDATE
 ASC " "
 COLOR YELLOW
 DEC16 CABBLOCKS
 ASC "  "
 COLOR GREEN
 NULL
 JSR PRFTYPE ;Print filetype
 JSR PRINT
 ASC " "
 COLOR YELLOW
 DEC16 CABDLOADS
 COLOR WHITE
 ASC " "
 PRSTRING CABDESCR
 NULL
:VOK2 INC :PNCNTR
 LDA $C000
 BPLL ]LOOP
 STA $C010
 CMP #$9B
 BEQ :RDONE
 JMP ]LOOP
:RESC JSR PRINT
 ZAPLINE
 CURSORON
 NULL
 BRA :RDONE2
:RDONE JSR PRINT
 GOTOXY 0;23
 COLOR PINK
 CURSORON
 NULL
 GETRETURN
 JSR PRINT
 COLOR WHITE
 NULL
:RDONE2 LDA TEMP
 STA PADFLAG
 LDA TEMP+1
 STA PADCHAR
 LDX :CAB
 JMP :LOK
:LEXIT LDA TEMP
 STA PADFLAG
 LDA TEMP+1
 STA PADCHAR
 JMP :BOT
:LFLAG DS 1
:PNCNTR DS 1
:TOREAD DA 1

:DISPLAY LDA NUMFILECAB
 BEQL :BOT
 JSR PRINT
 GOTOXY 60;1
 ASC "File #"
 COLOR YELLOW
 DEC8 :CAB
 COLOR WHITE
 ASC " "
 GOTOXY 0;4
 CLEOS
 CURSOROFF
 ASC "  1 - Free..........."
 PRFLAG CABFREE
 CR
 ASC "  2 - From party....."
 COLOR YELLOW
 DEC8 CABPARTY
 COLOR WHITE
 CR
 ASC "  3 - To party......."
 COLOR YELLOW
 DEC8 CABPARTY2
 COLOR WHITE
 CR
 ASC "  4 - Date uploaded.."
 COLOR GREEN
 DATE CABDATE
 COLOR WHITE
 CR
 ASC "  5 - File type......"
 COLOR YELLOW
 DEC8 CABFTYPE
 COLOR WHITE
 ASC " ("
 COLOR AQUAMARINE
 ASC "$"
 HEX8 CABFTYPE
 COLOR WHITE
 ASC ")"
 CR
 ASC "  6 - Xfer blocks...."
 COLOR PINK
 DEC32 CABBLOCKS
 COLOR WHITE
 CR
 ASC "  7 - Description...."
 COLOR AQUAMARINE
 PRSTRING CABDESCR
 COLOR WHITE
 CR
 ASC "  8 - File name......"
 COLOR AQUAMARINE
 PRSTRING CABFNAME
 COLOR WHITE
 CR
 ASC "  9 - Downloads......"
 COLOR YELLOW
 DEC16 CABDLOADS
 COLOR WHITE
 CR
 CURSORON
 NULL
 JMP :DOPOINT
:CAB DS 1

:PNBACK JSR PRINT
 GOTOXY 0;23
 CLEOS
 NULL
 JSR :DISPLAY
 LDA #$FF
 STA :FLAG
 JMP :BOT

:ADD JSR PRINT
 GOTOXY 0;23
 CLEOS
 ASC "Add - [N]ext free one, [E]nd of file, [ESC] Exit : "
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 CMP #$9B
 BEQL :BOT
 CMP #"N"
 BEQ :ANEXT
 CMP #"E"
 BNE ]LOOP
 JSR COUT
:AEND LDA NUMFILECAB
 CMP #$FF
 BCC :AEOK
 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 COLOR PINK
 ASC "Cannot add any more parties. "
 COLOR WHITE
 NULL
 GETRETURN
 JMP :ADD
:AEOK INC NUMFILECAB
 LDX NUMFILECAB
 STX MISCBUFF
 STX :CAB
 LDX #0
 JSR SAVECAB
:AGOTIT LDX #0
]LOOP STZ MISCBUFF,X
 INX
 BNE ]LOOP
 JSR :DISPLAY
 JMP :SAVE2
:ANEXT JSR COUT
 LDX :CAB
 STX :PNN
]LOOP LDA :PNN
 CMP NUMFILECAB
 BEQ :NRNGOK
 BCSL :AEND
:NRNGOK LDX :PNN
 JSR LOADCAB
 INC :PNN
 LDA CABFREE
 BPL ]LOOP
 DEC :PNN
 LDA :PNN
 STA :CAB
 JMP :AGOTIT
:PNN DS 1

:FREE LDX #1
 LDY #1
 JSR ASK
 GETLINE #1
 CPX #0
 BEQL :PNBACK
 LDA $200
 CMP #"1"
 BEQ :A1
 CMP #"0"
 BNE :FREE
 LDA #0
 STA CABFREE
 JMP :PNBACK
:A1 LDA #$FF
 STA CABFREE
 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 COLOR PINK
 ASC "Delete file as well (y/N)? : "
 COLOR WHITE
 NULL
 JSR KEYIN
 JSR UPPER
 CMP #"Y"
 BNEL :PNBACK
 JSR PRINT
 ASC "Yes"
 NULL
 LDX CABFNAME
]LOOP LDA CABFNAME,X
 STA :PATH2-1,X
 DEX
 BNE ]LOOP
 LDA #:PATH2-:PATH-1
 CLC
 ADC CABFNAME
 STA :PATH
 MLI_DESTROY :DPARMS
 JMP :PNBACK
:DPARMS DFB 1
 DA :PATH
:PATH STR "DRAWER/"
:PATH2 DS 15

:PFROM LDX #5
 LDY #2
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :PFRTS
 JSR GETNUM
 STX CABPARTY
:PFRTS JMP :PNBACK

:PTO LDX #5
 LDY #3
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :PTRTS
 JSR GETNUM
 STX CABPARTY2
:PTRTS JMP :PNBACK

:DATE LDX #3
 LDY #4
 JSR ASK
 GETLINE #6
 CPX #6
 BNE :DCRTS
 LDX #3
]LOOP LDA $200+2,X
 STA :DENTRY,X
 DEX
 BPL ]LOOP
 LDA #$8D
 STA $202
 LDX #2
 JSR GETNUM
 STX :DDAY
 LDA :DENTRY
 STA $200
 LDA :DENTRY+1
 STA $201
 LDX #2
 JSR GETNUM
 STX :DMONTH
 LDA :DENTRY+2
 STA $200
 LDA :DENTRY+3
 STA $201
 LDX #2
 JSR GETNUM
 STX :DYEAR
 LDA :DMONTH
 ASL
 ASL
 ASL
 ASL
 ASL
 ROL :DYEAR
 ORA :DDAY
 STA CABDATE
 LDA :DYEAR
 STA CABDATE+1
:DCRTS JMP :PNBACK

:FTYPE LDX #5
 LDY #5
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :CRTS
 JSR GETNUM
 STX CABFTYPE
:CRTS JMP :PNBACK

:BLOCKS LDX #5
 LDY #6
 JSR ASK
 GETLINE #5
 CPX #0
 BEQ :BLKRTS
 JSR GETNUM
 STX CABBLOCKS
 STY CABBLOCKS+1
:BLKRTS JMP :PNBACK

:DESCR LDX #2
 LDY #7
 JSR ASK
 GETLINE #35
 CPX #0
 BEQ :NWRTS
 STX CABDESCR
]LOOP LDA $200-1,X
 STA CABDESCR,X
 DEX
 BNE ]LOOP
:NWRTS JMP :PNBACK

:FNAME LDX #2
 LDY #8
 JSR ASK
 GETLINE #15
 CPX #0
 BEQ :PRTS
 STX CABFNAME
]LOOP LDA $200-1,X
 STA CABFNAME,X
 DEX
 BNE ]LOOP
 JSR GETBLKS
:PRTS JMP :PNBACK

:DLOADS LDX #5
 LDY #9
 JSR ASK
 GETLINE #5
 CPX #0
 BEQ :DLRTS
 JSR GETNUM
 STX CABDLOADS
 STA CABDLOADS+1
:DLRTS JMP :PNBACK

:FLAG DS 1
:DDAY DS 1
:DMONTH DS 1
:DYEAR DS 1
:DENTRY DS 9

EXIT JSR PRINT
 NORMAL
 MTOFF
 HOME
 NULL
 RETURN

LOADCAB STX :REC
 JSR LOADSLICE
 STR "CAB.FILES"
 DA MISCBUFF
:REC DA 0
 DA CABRECLEN
 RTS

SAVECAB STX :REC
 JSR SAVESLICE
 STR "CAB.FILES"
 DA MISCBUFF
:REC DA 0
 DA CABRECLEN
 RTS

PRFTYPE LDA #<FTYPES
 STA CADD
 LDA #>FTYPES
 STA CADD+1
]LOOP LDA (CADD)
 CMP CABFTYPE
 BNE :FNEXT
 LDY #1
 LDA (CADD),Y
 JSR COUT
 INY
 LDA (CADD),Y
 JSR COUT
 INY
 LDA (CADD),Y
 JSR COUT
 BRA :FIN
:FNEXT INY
 LDA (CADD),Y
 BEQ :UNKNOWN
 LDA CADD
 CLC
 ADC #4
 STA CADD
 LDA CADD+1
 ADC #0
 STA CADD+1
 BRA ]LOOP
:UNKNOWN JSR PRINT
 ASC "$"
 HEX8 CABFTYPE
 NULL
:FIN RTS

FTYPES FILET $00;"NON"
 FILET $01;"BAD"
 FILET $04;"TXT"
 FILET $06;"BIN"
 FILET $0F;"DIR"
 FILET $19;"ADB"
 FILET $1A;"AWP"
 FILET $1B;"ASP"
 FILET $B0;"SRC"
 FILET $B1;"OBJ"
 FILET $B2;"LIB"
 FILET $B3;"S16"
 FILET $B5;"EXE"
 FILET $B6;"PIF"
 FILET $B7;"TIF"
 FILET $B8;"NDA"
 FILET $B9;"CDA"
 FILET $BA;"TOL"
 FILET $BB;"DRV"
 FILET $BD;"FST"
 FILET $BF;"DOC"
 FILET $C0;"PNT"
 FILET $C1;"PIC"
 FILET $C8;"FON"
 FILET $CA;"ICN"
 FILET $FC;"BAS"
 FILET $FD;"VAR"
 FILET $FF;"SYS"
 DFB 0,0

NUMFILECAB DS 1
TEMP DS 2

GETBLKS LDX CABFNAME
]LOOP LDA CABFNAME,X
 STA :FNAME-1,X
 DEX
 BNE ]LOOP
 LDA #:FNAME-:PATH-1
 CLC
 ADC CABFNAME
 STA :PATH
 JSR CLOSEALL
 MLI_GET_FILE_INFO :IPARMS
 BCS :SKIPI
 LDA :IPARMS+4
 STA CABFTYPE
:SKIPI MLI_OPEN :OPARMS
 BCS :ERR
 LDA :OPARMS+5
 STA :EPARMS+1
 STA :CPARMS+1
 MLI_GET_EOF :EPARMS
 BCS :ERR
 MLI_CLOSE :CPARMS
 BCS :ERR
 LDA :EOF
 ROL
 LDA :EOF+1
 ROL
 STA :BLOCKS
 LDA :EOF+2
 ROL
 STA :BLOCKS+1
 ROL
 AND #1
 STA :BLOCKS+2
 LDA :EOF ;Partial block left out?
 AND #$7F
 BEQ :BLKSDONE ;Add it in then....
 INC :BLOCKS
 BNE :BLKSDONE
 INC :BLOCKS+1
 BNE :BLKSDONE
 INC :BLOCKS+2
:BLKSDONE LDX :BLOCKS
 LDA :BLOCKS+1
 STX CABBLOCKS
 STA CABBLOCKS+1
:ERR RTS

:IPARMS DFB $A
 DA :PATH
 DS 5
 DS 2
 DS 8

:OPARMS DFB 3
:PATHPTR DA :PATH
 DA IOBUFFER
 DS 1

:EPARMS DFB 2
 DS 1
:EOF DS 3

:CPARMS DFB 1
 DS 1

:BLOCKS DS 3

:PATH STR "DRAWER/"
:FNAME DS 15

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/CAB.EDITOR
 fin

 END
