*-------------------------------
* EQUATES
*-------------------------------
M16PLUS = 1 ;Assembly - 0=DSK, 1=SAV

LAUNCHER EQU $300
IOBUFFER EQU $800
PLRBUFF EQU $C00
MONBUFF EQU $D00
MON2BUFF EQU $E00
VARS EQU $F00
LIBRARY EQU $1000
SPELLBUFF EQU $6000
LOGBUFF EQU $6100
STBUFF EQU $6200
TABLES EQU $6300
SCENBUFF EQU $6C00
PNBUFF EQU $6D00
ITEMBUFF EQU $6E00
ITEM2BUFF EQU $6F00
MSGINDXBUFF EQU $7000
MSGBUFF EQU $7100
BITMAPBUFF EQU $7500
MISCBUFF EQU $7600
SCRNBUFF EQU $7800
MODULE EQU $8000
PGSAVE EQU $B900
STARTUPCODE EQU $BA05
STARTUPBAUD EQU $BA06
STARTUPPATH EQU $BA07
CLIP EQU $BAB0
MAP EQU $BB00
MAP2 EQU $BC00
VARS2 EQU $BD00
INBUFF EQU $BE00

TBCBUFF EQU $010800
CSAVE EQU $011000
MSAVE EQU $011100
M2SAVE EQU $011200
SHAPEMAP EQU $011300
TEXTSHAPES EQU $011C00
SHAPES EQU $01A000

INFOBYTE = $82
COLORBYTE = $83
SOUNDBYTE = $90
ENDSESSIONBYTE = $92
SHAPEBYTE = $93

*
* Non standalone startup functions
*
FUNC_NORMAL = 0 ;Sit on front screen
FUNC_CHECK = 1 ;Execute Gameturn if needed, then exit
FUNC_USER = 2 ;User logon (remote)

NUMFILES = 8+1+1 ;Pageout area & Font

FILEITEMS = 1
FILEPLRS = 2
FILEMONS = 3
FILEMONS2 = 4
FILEITEMS2 = 5
FILESPELLS = 6
FILEBITMAP = 7
FILEPN = 8
FILEMOD = 9
FILEFONT = 10

PLRRECLEN = $100 ;Player
MONRECLEN = $100 ;Monster
MON2RECLEN = $100 ;Maze Monster
ITEMRECLEN = $100 ;Item
ITEM2RECLEN = $100 ;Maze Item
MAPRECLEN = $100 ;Map
MAP2RECLEN = $100 ;Map2
STRECLEN = $10 ;Stairs.Teleport
SCRECLEN = $100 ;Scenario
PNRECLEN = $100 ;Party.Names
SPELLRECLEN = $20 ;Spell
HOFRECLEN = $100 ;Hall Of Fame
MSGINDXRECLEN = 16 ;Msg index
MSGRECLEN = 12*80+2 ;Msg
BITMAPRECLEN = $100 ;(fits with buffer)
LOGRECLEN = 80
GLRECLEN = $200 ;Glossary
SIGNRECLEN = $200 ;Sign
SDRECLEN = $200 ;Spell description
INVRECLEN = $10 ;Inventory
WLRECLEN = $100 ;Wish list
CABRECLEN = $50 ;Cabinet

 DUM 0
CADD DS 2
CADD2 DS 2
CADD3 DS 2
CADD4 DS 2
CADD6 DS 4
SCRNPNTR DS 4 ;Pointer to SHR screen table
FONTLOC DS 4
 DEND

BAS EQU $28

VMODE EQU $4FB
CV EQU $5FB
CH EQU $57B

MLI EQU $BF00

GET816LEN EQU $F890 ;Calc length of 65816 instr
INSTDSP EQU $F8D0 ;Display disassembled instr
PCADJ EQU $F953 ;Adjust monitor PC
WAIT EQU $FCA8
KEYIN EQU $FD18
PRBYTE EQU $FDDA
COUT EQU $FDED

SHRLOC EQU $010000

]SLOT EQU 2
TDREG EQU ]SLOT*$10+$C088
RDREG EQU ]SLOT*$10+$C088
STATUS EQU ]SLOT*$10+$C089
COMMAND EQU ]SLOT*$10+$C08A
CONTROL EQU ]SLOT*$10+$C08B

SCCCOMMAND EQU ]SLOT-1!1+$C038
SCCDATA EQU ]SLOT-1!1+$C03A

ZSCCRX = %0000_0001
ZSCCTX = %0000_0100
ZSCCDCD = %0000_1000
ZSCCDSR = %0010_0000

*-------------------------------------------------
* Shapes : byte format - xxxn_nnnn (n = shape, x = type of shape)
*
* 00 - Wall
*      0 = Square (normal)
*      1 = Bendy (top-left)
*      2 = Bendy (top-right)
*      3 = Bendy (bottom-left)
*      4 = Bendy (bottom-right)
*      5 = Secret
*      6 = Secret (visible)
*
* 01 - Space
*      0 = Normal
*
* 02 - Stairs
*      0 = Up
*      1 = Down
*
* 03 - Force field
*      0 = Horizontal
*      1 = Vertical
*      2 = Diminished (horizontal)
*      3 = Diminished (vertical)
*
* 04 - Dark area
*      0 = Normal
*
* 05 - Sign post
*      0 = Normal
*
* 06 - Swamp
*      0 = Normal
*
* 07 - Player
*      0 = Normal
*      1 = Current
*
* 08 - Unknown (can't see this square)
*      0 = Normal
*
* 09 - Water
*      0 = Shallow
*      1 = Deep
*
* 0A - Teleport
*      0 = Normal
*
* 0B - Hills
*      0 = Normal
*
* 0C - Monster
*      0 = Normal
*
* 0D - Player & Monster
*      0 = Normal
*
* 0E - Item
*      0 = Normal
*
* 0F - Gate
*      0 = Closed
*      1 = Open
*
* 10 - Monster generator
*      0 = Normal
*      1 = Guardian
*
* 11 - Holy ground
*      0 = Normal
*
* 12 - Altar
*      0 = Normal
*
* 13 - Fountain
*      0 = Normal
*-------------------------------------------------
SHPWALL = $00 ;Wall
SHPSPACE = $01 ;Space
SHPSTAIRS = $02 ;Stairs
SHPFF = $03 ;Force field
SHPDARK = $04 ;Dark area
SHPSIGN = $05 ;Sign post
SHPSWAMP = $06 ;Swamp
SHPPLR = $07 ;Player
SHPVOID = $08 ;Void
SHPWATER = $09 ;Water
SHPTPORT = $0A ;Teleport
SHPHILLS = $0B ;Hills
SHPMON = $0C ;Monster
SHPPLRMON = $0D ;Player & monster
SHPITEM = $0E ;Item
SHPGATE = $0F ;Gate
SHPMONGEN = $10 ;Monster generator
SHPSAFETY = $11 ;Holy ground (safety zone)
SHPALTAR = $12 ;Altar
SHPFOUNTAIN = $13 ;Water fountain

WALLNORMAL = 0
WALLTOPLEFT = 1
WALLTOPRIGHT = 2
WALLBOTLEFT = 3
WALLBOTRIGHT = 4
WALLSECRET = 5
WALLSECRETVIS = 6

SPACENORMAL = 0

STAIRSUP = 0
STAIRSDOWN = 1

FFHORIZ = 0
FFVERT = 1
FFDIMHORIZ = 2
FFDIMVERT = 3

DARKNORMAL = 0

SIGNNORMAL = 0

SWAMPNORMAL = 0

PLRNORMAL = 0
PLRCURRENT = 1
PLRMINE = 2

VOIDNORMAL = 0

WATERSHALLOW = 0
WATERDEEP = 1

TPORTNORMAL = 0

HILLSNORMAL = 0

MONNORMAL = 0

PLRMONNORMAL = 0

ITEMNORMAL = 0

GATECLOSED = 0
GATEOPEN = 1

MONGENNORMAL = 0
MONGENGUARDIAN = 1

SAFETYNORMAL = 0

ALTARNORMAL = 0

FOUNTAINNORMAL = 0
