*-------------------------------
* GAME.ALLOCM
*-------------------------------
 DAT
 LST OFF

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE VARS
 USE LIB.JMP
 USE MON.DSECT
 USE MON2.DSECT
 USE SCEN.DSECT
 USE PLR.DSECT

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/GAME.ALLOCM
 fin

 MODID "GAME.ALLOCM"

START JSR PRINT
 HOME
 COLOR WHITE
 ASC "Monster allocation.."
 NULL
 NOTELOG $3;"Monster allocation.."

 LDX #0
 JSR LDSCEN
 LDA SCENBUFF
 STA SCEN ;Number of scenarios
 BEQ :DOMAP
 LDX #0 ;Load monsters 'to kill' into table
]LOOP INX
 PHX
 JSR LDSCEN
 PLX
 LDA SCMON2KILL
 STA SCENMONS-1,X
 CPX SCEN
 BNE ]LOOP

:DOMAP JSR MAPBOX
 JSR BOTLINES

 LDX #0
 LDA #0
 JSR LOADMON

 LDA MONBUFF
 STA MONSTERS
 LDA MONBUFF+1
 STA MONSTERS+1
 BNE :THERE
 LDA MONBUFF
 BNE :THERE
 JSR PRINT
 HOME
 COLOR PINK
 LINE "No monsters to allocate."
 COLOR WHITE
 NULL
 NOTELOG $F;"No monsters to allocate"
 JMP EXIT

:THERE LDX #0
 JSR LDMAP
 LDA MAP ;Number of levels in maze
 STA NUMLVLS
 STA LEVEL

 LDA #$FF
 STA MAPLOOK

 LDX SCENARIO
 LDA #0
 JSR LOADSCEN

 LDX #0
]LOOP LDA SCMONPERLVL,X
 STA MONPERLVL,X
 INX
 CPX MAP
 BNE ]LOOP

 LDX #0
 LDA #0
 JSR LOADMON2
 LDA MON2BUFF+1
 STA MAZEMONSTERS+1
 LDA MON2BUFF
 STA MAZEMONSTERS

 JSR SCROLL
 JSR PRINT
 LINE "Checking existing monsters.."
 NULL

 LDX SCENARIO
 LDA M2KILLDEAD-1,X ;Monster to kill dead?
 BPL :ITSALIVE
 STA ALLOC ;Yep, so don't 'issue' another one

:ITSALIVE STZ ERASED
 STZ TEMP
 STZ TEMP+1
]LOOP LDA TEMP+1
 CMP MAZEMONSTERS+1
 BNE :OK
 LDA TEMP
 CMP MAZEMONSTERS
 BEQ :DONE
:OK INCR TEMP
 LDX TEMP
 LDA TEMP+1
 JSR LOADMON2
 LDA MTYPE ;Already erased?
 ORA MTYPE+1
 BEQ ]LOOP ;You bet..
 LDA MCOND
 AND #%1000_0000 ;Is this monster dead?
 BEQ :ALIVE
 STZ MTYPE ;Erase monster type
 STZ MTYPE+1
 LDX TEMP
 LDA TEMP+1
 JSR SAVEMON2
 INC ERASED
 BRA ]LOOP
:ALIVE LDX MZPOS
 INC THERE,X
 LDX MTYPE
 LDA MTYPE+1
 JSR LOADMON
 LDA MLEVEL
 BNE :ALIVE2
 LDX MZPOS
 INC ONGUARDS,X
 DEC THERE,X
:ALIVE2 LDX SCENARIO
 LDA SCENMONS-1,X
 CMP MTYPE
 BNE ]LOOP
 LDA #$FF
 STA ALLOC ;Monster to kill for this scenario is there
 BRA ]LOOP

:DONE JSR SCROLL
 LDA ERASED
 BEQ :NOZ
 NOTELOGNUM $D;"Monsters erased - #";ERASED
:NOZ LDX NUMLVLS
]LOOP STX VTEMP
 LDA THERE,X
 STA VTEMP+1
 PHX
 JSR SCROLL
 PLX
 PHX
 LDA ONGUARDS,X
 STA TEMP
 JSR PRINT
 ASC "Monsters on level "
 DEC8 VTEMP
 ASC " : "
 COLOR YELLOW
 DEC8 VTEMP+1
 COLOR WHITE
 ASC " (guardians : "
 COLOR YELLOW
 DEC8 TEMP
 COLOR WHITE
 ASC ")"
 NULL
:GNOPE PLX
 DEX
 BNE ]LOOP
 JSR SCROLL
 JSR SEARCH ;Find a blank space to put next monster

TOPLOOP JSR SCROLL
 LDX LEVEL
 LDA MONPERLVL-1,X
 STA VTEMP
 LDA THERE,X
 STA VTEMP+1
 NOTELOGNUM $D;"Level ";LEVEL
 JSR PRINT
 ASC "Level "
 DEC8 LEVEL
 LINE ".."
 NULL
 JSR SCROLL
 LDX LEVEL
 LDA ONGUARDS,X
 STA TEMP
 JSR PRINT
 ASC "Monsters: "
 COLOR YELLOW
 DEC8 VTEMP+1
 COLOR WHITE
 ASC ", ceiling = "
 COLOR YELLOW
 DEC8 VTEMP
 COLOR WHITE
 ASC "; Guardians : "
 COLOR YELLOW
 DEC8 TEMP
 COLOR WHITE
 ASC ", ceiling = "
 COLOR YELLOW
 DEC8 SCGUARDSPERLVL
 COLOR WHITE
 LINE ".."
 NULL
 JSR LOG200
 LDX LEVEL
 JSR LDMAP
 LDX LEVEL
 JSR LDMAP2

 JSR DOJAIL ;Place jail guards if there is a jail
 JSR DOGENS ;Do generators for this level
*
 JMP :UPPER ;Skip random monster placement
*===============================

 STZ TEMP2 ;Retry count
 LDX LEVEL
 LDA MONPERLVL-1,X
 STA TEMP
]LOOP LDX LEVEL
 LDA THERE,X
 CMP MONPERLVL-1,X
 BCSL :DONE
 INC TEMP2
 LDA TEMP2
 BMIL :DONE
 LDX MONSTERS
 LDA MONSTERS+1
 JSR RANDOM ;Pick one at random
 STX MONSTER
 STA MONSTER+1
:THEMON JSR LOADMON
 LDA MFREE
 BMI ]LOOP ;Monster "doesn't exist" on file
 LDA MLEVEL
 CMP LEVEL
 BNE ]LOOP
 LDA MSCENARIO
 CMP #$FF
 BEQ :SCENOK
 CMP SCENARIO
 BNE ]LOOP
:SCENOK LDX SCEN
]LOOPM LDA SCENMONS-1,X
 CMP MONSTER
 BEQ :CHECK
 DEX
 BNE ]LOOPM
 BRA :CONT
:CHECK LDA ALLOC ;Have we allocated THE monster?
 BMI ]LOOP
 CPX SCENARIO ;This the current scenario?
 BNE ]LOOP
:CONT STZ TEMP4
 LDX MHP
]LOOP3 PHX
 RANDNUM #6 ;HP = HPd6 + (HP+1)
 TXA
 CLC
 ADC TEMP4
 STA TEMP4
 PLX
 DEX
 BNE ]LOOP3
 LDA TEMP4
 CLC
 ADC MHP+1
 STA HP
 STZ TEMP2+1
]LOOP2 INC TEMP2+1
 LDA TEMP2+1
 BMIL :DONE
 LDX #16
 LDA #0
 JSR RANDOM
 DEX
 STX YLOC
 LDX #16
 LDA #0
 JSR RANDOM
 DEX
 STX XLOC
 LDX XLOC
 LDY YLOC
 JSR GETMAP ;Check if this square is ok
 STA BYTE
 LDX #-1
]LOOP3 INX
 LDA OKSHAPES,X
 CMP #$FF
 BEQ ]LOOP2
 CMP BYTE
 BNE ]LOOP3

 LDA MHABITAT ;1=Land, 2=Water, 3=Hills, 4=Air, 5=Dark
 BEQL :DONE ;Unknown (data on monster is incomplete)
 CMP #1
 BNE :WATER
 LDA BYTE
 CMP #SHPSPACE
 BNEL ]LOOP2 ;Can't put land monster in water
 JMP :SHPOK
:WATER CMP #2
 BNE :HILLS
 LDA BYTE
 CMP #SHPWATER
 BNEL ]LOOP2 ;...
 JMP :SHPOK
:HILLS CMP #3
 BNE :AIR
 LDA BYTE
 CMP #SHPHILLS
 BNEL ]LOOP2 ;...
 JMP :SHPOK
:AIR CMP #4
 BNE :DARK
 LDA BYTE
 CMP #SHPDARK
 BEQL ]LOOP2 ;...
 JMP :SHPOK
:DARK CMP #5
 BNE :SWAMP
 LDA BYTE
 CMP #SHPDARK
 BNEL ]LOOP2
 JMP :SHPOK
:SWAMP CMP #6
 BNEL ]LOOP2
 LDA BYTE
 CMP #SHPSWAMP
 BNEL ]LOOP2

:SHPOK LDX XLOC
 LDY YLOC
 JSR GETMAP2
 CMP #10 ;A crowded square
 BCSL ]LOOP2 ;Can't put monster here - won't fit

 LDX XLOC
 LDY YLOC
 LDA #1
 JSR PUTMAP2M ;Add monster to this square

 LDX XLOC
 LDY YLOC
 LDA LEVEL
 JSR DOALL

 LDA MONSTER
 STA MTYPE
 LDA MONSTER+1
 STA MTYPE+1
 LDA XLOC
 STA MXPOS
 LDA YLOC
 STA MYPOS
 LDA LEVEL
 STA MZPOS
 LDA HP
 STA MCURHP
 RANDNUM #9
 STX MDIR
 STZ MCOND
 LDX #7
]LOOPC STZ MCONDX,X
 DEX
 BPL ]LOOPC
 STZ MARRESTCHAR
 STZ MARRESTCHAR+1

 JSR SCROLL
 JSR PRINT
 ASC "Monster #"
 NULL

 BIT MONFLAG ;Did we find a blank space in file?
 BPL :NOFREE ;No, we didn't
 JSR PRINT
 COLOR YELLOW
 DEC16 MMREC
 COLOR WHITE
 NULL
 LDX MMREC
 LDA MMREC+1
 JSR SAVEMON2
 BRA :DISPIT
:NOFREE INCR MAZEMONSTERS ;Add to end of file
 JSR PRINT
 COLOR YELLOW
 DEC16 MAZEMONSTERS
 COLOR WHITE
 NULL
 LDX MAZEMONSTERS
 LDA MAZEMONSTERS+1
 JSR SAVEMON2
 JSR INCREC0 ;For PRMAPALL ('coz it reads record 0)

:DISPIT JSR PRINT
 ASC " ("
 COLOR YELLOW
 DEC16 MONSTER
 COLOR WHITE
 ASC "/"
 COLOR AQUAMARINE
 PRSTRING MNAME
 COLOR WHITE
 ASC ") put at "
 PAD2 MXPOS
 ASC ","
 PAD2 MYPOS
 NULL
 JSR LOG200

 LDX SCENARIO
 LDA SCENMONS-1,X
 CMP MONSTER
 BNE :NOTHE
 LDA #$FF ;Monster to kill has been allocated
 STA ALLOC

:NOTHE LDX LEVEL
 INC ADDED,X
 INC THERE,X

 JSR SEARCH ;Find a blank space to put next monster

:DONE DEC TEMP ;Number of monsters left to deploy this lvl
 LDA TEMP
 BNEL ]LOOP
 LDA LEVEL ;Check if we have deployed monster to kill
 CMP NUMLVLS ; on the bottom level
 BNE :UPPER
 LDA ALLOC
 BMI :UPPER
 INC ADDTHE
 LDA ADDTHE
 BMI :WOOPS
 LDX SCEN
 LDA SCENMONS-1,X
 TAX
 STX MONSTER
 LDA #0
 STA MONSTER+1
 JMP :THEMON ;We have to get this monster allocated
:WOOPS LDA MONSTER
 STA NUM
 STZ NUM+1
 STZ NUM+2
 STZ NUM+3
 NOTELOGNUM $1;"Couldn't allocate monster to kill - #";NUM
:UPPER LDX LEVEL
 LDA ADDED,X
 STA VTEMP
 JSR SVMAP2 ;Save it
 JSR SCROLL
 JSR PRINT
 COLOR YELLOW
 DEC8 VTEMP
 COLOR WHITE
 ASC " monsters added"
 NULL
 LDA GUARDS
 BEQ :UPGO
 JSR PRINT
 ASC " (guards added : "
 COLOR YELLOW
 DEC8 GUARDS
 COLOR WHITE
 ASC ")"
 NULL
 LDA GUARDS
 CLC
 ADC TOTGUARDS
 STA TOTGUARDS
:UPGO BIT GENFLAG
 BMI :UPPER2
 JSR PRINT
 COLOR PINK
 ASC " <no generator>"
 COLOR WHITE
 NULL
 NOTELOG $B;"No generator on this level"
:UPPER2 JSR PRINT
 LINE "."
 NULL
 JSR SCROLL
 LDX LEVEL
 LDA ADDED,X
 STA NUM
 NOTELOGNUM $B;"Monsters added - #";NUM
 LDA GUARDS
 BEQ :NOGADD
 STA NUM
 NOTELOGNUM $B;"Guards added - #";NUM
:NOGADD STZ GUARDS
 DEC LEVEL
 LDA LEVEL
 BNEL TOPLOOP

EXIT JSR SCROLL
 JSR PRINT
 LINE "Finished."
 NULL
 STZ NUM
 LDX NUMLVLS
]LOOP STX TEMP
 LDA ADDED,X
 CLC
 ADC NUM
 STA NUM
 DEC TEMP
 LDX TEMP
 BNE ]LOOP
 JSR SCROLL
 JSR PRINT
 ASC "Total monsters allocated : "
 COLOR YELLOW
 DEC32 NUM
 COLOR WHITE
 NULL
 LDA TOTGUARDS
 BEQ :NOG
 JSR PRINT
 ASC " (guards : "
 COLOR YELLOW
 DEC8 TOTGUARDS
 COLOR WHITE
 ASC ")"
 NULL
:NOG JSR PRINT
 LINE "."
 NULL
 NOTELOGNUM $B;"Monsters allocated (total) - #";NUM
 LDA TOTGUARDS
 BEQ :NOG2
 NOTELOGNUM $B;"Guardians allocated (total) - #";TOTGUARDS
:NOG2 STZ MAPLOOK
 RETURN
NUM DS 4

LDMAP LDA #0
 JMP LOADMAP

LDMAP2 LDA #0
 JMP LOADMAP2

SVMAP2 LDA #0
 JMP SAVEMAP2

SEARCH LDA MONFLAG ;Do we search?
 BMI :GO ;Yes
 RTS
:GO LDA MMREC+1
 CMP MAZEMONSTERS+1
 BNE :OK
 LDA MMREC
 CMP MAZEMONSTERS
 BEQ :NOPE
:OK INCR MMREC
 LDX MMREC
 LDA MMREC+1
 JSR LOADMON2
 LDA MTYPE+1
 BNE SEARCH
 LDA MTYPE
 BNE SEARCH
 RTS
:NOPE STZ MONFLAG ;Tell SEARCH not to search anymore
 RTS
MONFLAG DFB $FF
MMREC DA 0 ;Record for SEARCH

NUMLVLS DS 1 ;Number of levels in maze
LEVEL DS 4 ;Current level

MONSTERS DS 2 ;Number of monsters in file
MAZEMONSTERS DS 2 ;Number of maze monsters in file

HP DS 1

XLOC DS 1
YLOC DS 1

OKSHAPES DFB SHPSPACE,SHPSTAIRS,SHPDARK,SHPSIGN,SHPWATER,SHPHILLS
 DFB SHPSWAMP
 DFB $FF

ADDED DS 1+16
THERE DS 1+16
ONGUARDS DS 1+16
TEMP DS 2
TEMP2 DS 2
TEMP3 DS 1
TEMP4 DS 1
BYTE DS 1
MONSTER DS 2

DOGENS STZ GENFLAG
 LDX #0
 LDY #0
]LOOP STX :X
 STY :Y
 JSR GETMAP
 CMP #SHPMONGEN
 BNE :NEXT
 CPX #MONGENNORMAL
 BEQL :GEN
:NEXT LDX :X
 LDY :Y
 INX
 CPX #$10
 BNE ]LOOP
 LDX #0
 INY
 CPY #$10
 BNE ]LOOP
:RTS BIT ALLOC ;Is it there?
 BPL :NOPE
 RTS
:NOPE LDX SCENARIO ;Put it first available square then
 LDA SCENMONS-1,X
 TAX
 LDA #0
 STX MONSTER
 STA MONSTER+1
 JSR LOADMON
 LDX #0
 LDY #0
]LOOP STX :DGX
 STY :DGY
 JSR GETMAP
 STA BYTE
 LDA MHABITAT ;1=Land, 2=Water, 3=Hills, 4=Air, 5=Dark
 BEQL :MGERR ;Unknown (data on monster is incomplete)
 CMP #1
 BNE :DWATER
 LDA BYTE
 CMP #SHPSPACE
 BNE :DNEXTG ;Can't put land monster in water
 JMP :DSHPOK
:DWATER CMP #2
 BNE :DHILLS
 LDA BYTE
 CMP #SHPWATER
 BNE :DNEXTG
 JMP :DSHPOK
:DHILLS CMP #3
 BNE :DAIR
 LDA BYTE
 CMP #SHPHILLS
 BNE :DNEXTG
 JMP :DSHPOK
:DAIR CMP #4
 BNE :DDARK
 LDA BYTE
 CMP #SHPDARK
 BEQ :DNEXTG
 JMP :DSHPOK
:DDARK CMP #5
 BNE :DSWAMP
 LDA BYTE
 CMP #SHPDARK
 BNE :DNEXTG
 JMP :DSHPOK
:DSWAMP CMP #6
 BNE :DNEXTG
 LDA BYTE
 CMP #SHPSWAMP
 BNE :DNEXTG

:DSHPOK LDX :DGX
 STX :XPOS
 LDX :DGY
 STY :YPOS
 JSR GETMAP2
 CMP #4 ;A crowded square
 BCS :DNEXTG ;Can't put monster here - won't fit
 JMP :SHPOK2
:DNEXTG LDX :DGX
 LDY :DGY
 INX
 CPX #$10
 BNEL ]LOOP
 LDX #0
 INY
 CPY #$10
 BNEL ]LOOP
:MGERR2 NOTELOGNUM $1;"Couldn't allocate monster to kill - #";NUM
 RTS
:MGERR NOTELOG $1;"Data error (HABITAT)."
 BRA :MGERR2
:DGX DS 1
:DGY DS 1

:GEN LDA #$FF
 STA GENFLAG
 LDA :X ;Begin from top-left of generator
 DEC
 STA :XPOS
 LDA :Y
 DEC
 STA :YPOS
 STZ :CNTRX
 STZ :CNTRY

 STZ TEMP3
]LOOP INC TEMP3
 LDA TEMP3
 CMP #16
 BCSL :NEXTG
 LDX LEVEL ;Got enough monsters this level already?
 LDA THERE,X
 CMP MONPERLVL-1,X
 BCSL :RTS ;If so, no point in checking any more

 LDX :XPOS
 LDY :YPOS
 CPX #$10 ;On map?
 BCSL :NEXTG ;Nup
 CPY #$10
 BCSL :NEXTG
 JSR GETMAP
 CMP #SHPWALL ;No walls please
 BEQL :NEXTG
 CMP #SHPMONGEN ;No generators either
 BEQL :NEXTG
 LDX :XPOS
 LDY :YPOS
 JSR GETMAP2 ;Any monsters there already?
 AND #$F0
 BNEL :NEXTG ;Yep

 STZ TEMP2 ;Retry count
]LOOP2 INC TEMP2
 LDA TEMP2
 BMIL :NEXTG
 LDX MONSTERS
 LDA MONSTERS+1
 JSR RANDOM ;Pick one at random
 STX MONSTER
 STA MONSTER+1
 JSR LOADMON
 LDA MFREE
 BMI ]LOOP2 ;Monster "doesn't exist" on file
 LDA MLEVEL
 CMP LEVEL
 BNE ]LOOP2
 LDA MSCENARIO
 CMP #$FF
 BEQ :SCENOK
 CMP SCENARIO
 BEQ :SCENOK
 LDA MSCENARIO+1
 CMP SCENARIO
 BNE ]LOOP2
:SCENOK LDX SCEN
]LOOPM LDA SCENMONS-1,X
 CMP MONSTER
 BEQ :CHECK
 DEX
 BNE ]LOOPM
 BRA :CONT
:CHECK LDA ALLOC ;Have we allocated THE monster?
 BMIL ]LOOP
 CPX SCENARIO ;This the current scenario?
 BNEL ]LOOP
:CONT LDX MHP
 LDA #0
 JSR RANDOM ;HP = (RND(HP)) + HP+1
 TXA
 CLC
 ADC MHP+1
 STA HP

 LDX :XPOS
 LDY :YPOS
 JSR GETMAP ;Check if this square is ok
 STA BYTE
 LDX #-1
]LOOP3 INX
 LDA OKSHAPES,X
 CMP #$FF
 BEQL :NEXTG ;Unknown shape, then skip it
 CMP BYTE
 BNE ]LOOP3

 LDA MHABITAT ;1=Land, 2=Water, 3=Hills, 4=Air, 5=Dark
 BEQL :NEXTG ;Unknown (data on monster is incomplete)
 CMP #1
 BNE :WATER
 LDA BYTE
 CMP #SHPSPACE
 BNEL ]LOOP2 ;Can't put land monster in water
 JMP :SHPOK
:WATER CMP #2
 BNE :HILLS
 LDA BYTE
 CMP #SHPWATER
 BNEL ]LOOP2 ;...
 JMP :SHPOK
:HILLS CMP #3
 BNE :AIR
 LDA BYTE
 CMP #SHPHILLS
 BNEL ]LOOP2 ;...
 JMP :SHPOK
:AIR CMP #4
 BNE :DARK
 LDA BYTE
 CMP #SHPSPACE
 BEQ :SHPOK
 CMP #SHPHILLS
 BNEL ]LOOP2 ;...
 JMP :SHPOK
:DARK CMP #5
 BNE :SWAMP
 LDA BYTE
 CMP #SHPDARK
 BNEL ]LOOP2
 JMP :SHPOK
:SWAMP CMP #6
 BNEL ]LOOP2
 LDA BYTE
 CMP #SHPSWAMP
 BNEL ]LOOP2

:SHPOK LDX :XPOS
 LDY :YPOS
 JSR GETMAP2
 CMP #4 ;A crowded square
 BCSL :NEXTG ;Can't put monster here - won't fit
 BRA :SHPOK3

:SHPOK2 LDX MHP
 LDA #0
 JSR ROLLD6 ;HP = HPd6 + (HP+1)
 LDA VTEMP
 CLC
 ADC MHP+1
 STA HP
:SHPOK3 LDX :XPOS
 LDY :YPOS
 LDA #1
 JSR PUTMAP2M ;Add monster to this square

 LDX :XPOS
 LDY :YPOS
 LDA LEVEL
 JSR DOALL

 LDA MONSTER
 STA MTYPE
 LDA MONSTER+1
 STA MTYPE+1
 LDA :XPOS
 STA MXPOS
 LDA :YPOS
 STA MYPOS
 LDA LEVEL
 STA MZPOS
 LDA HP
 STA MCURHP
 RANDNUM #9
 STX MDIR
 STZ MCOND
 LDX #7
]LOOPC STZ MCONDX,X
 DEX
 BPL ]LOOPC
 STZ MARRESTCHAR
 STZ MARRESTCHAR+1

 JSR SCROLL
 JSR PRINT
 ASC "Monster #"
 NULL

 BIT MONFLAG ;Did we find a blank space in file?
 BPL :NOFREE ;No, we didn't
 JSR PRINT
 COLOR YELLOW
 DEC16 MMREC
 COLOR WHITE
 NULL
 LDX MMREC
 LDA MMREC+1
 JSR SAVEMON2
 BRA :DISPIT
:NOFREE INCR MAZEMONSTERS ;Add to end of file
 JSR PRINT
 COLOR YELLOW
 DEC16 MAZEMONSTERS
 COLOR WHITE
 NULL
 LDX MAZEMONSTERS
 LDA MAZEMONSTERS+1
 JSR SAVEMON2
 JSR INCREC0 ;For PRMAPALL ('coz it reads record 0)

:DISPIT JSR PRINT
 ASC " ("
 COLOR YELLOW
 DEC16 MONSTER
 COLOR WHITE
 ASC "/"
 COLOR AQUAMARINE
 PRSTRING MNAME
 COLOR WHITE
 ASC ") put at "
 PAD2 :XPOS
 ASC ","
 PAD2 :YPOS
 NULL
 JSR LOG200

 LDX SCENARIO
 LDA SCENMONS-1,X
 CMP MONSTER
 BNE :NOTHE
 LDA #$FF ;Monster to kill has been allocated
 STA ALLOC

:NOTHE LDX LEVEL
 INC ADDED,X
 INC THERE,X

 BIT GENFLAG
 BMI :DOS
 JSR SEARCH ;Find a blank space to put next monster
 BIT ALLOC
 BPLL :MGERR2
 RTS

:DOS JSR SEARCH ;Find a blank space to put next monster

:NEXTG INC :XPOS
 INC :CNTRX
 LDA :CNTRX
 CMP #2
 BEQ :MIDDLE
 CMP #3
 BNEL ]LOOP
 LDA :XPOS
 SEC
 SBC #3
 STA :XPOS
 STZ :CNTRX
 INC :YPOS
 INC :CNTRY
 LDA :CNTRY
 CMP #3
 BNEL ]LOOP
 JMP :NEXT
:MIDDLE LDA :YPOS ;Skip middle square (the generator)
 CMP #2
 BEQ :NEXTG
 JMP ]LOOP
:X DS 1 ;Map
:Y DS 1
:XPOS DS 1 ;Map (generator)
:YPOS DS 1
:CNTRX DS 1 ;Counters (relative)
:CNTRY DS 1

MAPBOX JSR PRINT
 NORMAL
 MTOFF
 CURSOROFF
 GOTOXY 4;1
 LUP 18
 ASC "_"
 --^
 CR
 MTON
 INVERSE
 NULL
 LDX #9
]LOOP JSR PRINT
 HTAB 3
 ASC "Z"
 HTAB 22
 ASC "_"
 CR
 NULL
 DEX
 BNE ]LOOP
 JSR PRINT
 HTAB 4
 LUP 18
 ASC "L"
 --^
 NORMAL
 MTOFF
 CR
 HTAB 4
 ASC "Loc: ??,??  Lvl: ?"
 NULL
 RTS

BOTLINES JSR PRINT
 GOTOXY 0;14
 INVERSE
 COLOR YELLOW
 ZAPLINE
 GOTOXY 0;23
 ZAPLINE
 COLOR WHITE
 NORMAL
 NULL
 RTS

DOALL PHA
 LDA CH
 STA :HV+2
 LDA CV
 STA :HV+3
 PLA
 STX PLRXPOS
 STY PLRYPOS
 JSR SHOWMAP
 JSR PRINT
:HV GOTOXY 0;0
 NULL
 RTS
:X DS 1
:Y DS 1

SCROLL LDX #16
]LOOP PHX
 TXA
 DEX
 STX :V+3
 LDX #0
 LDY #79
 JSR PICKLINE ;A=line, X=from, Y=to
 JSR PRINT
:V GOTOXY 0;15
 NULL
 LDX #0
]LOOP2 LDA $200,X
 JSR COUT
 INX
 CPX #80
 BNE ]LOOP2
 PLX
 INX
 CPX #23
 BNE ]LOOP
 JSR PRINT
 GOTOXY 0;22
 ZAPLINE
 NULL
 RTS

LOG200 LDX #0 ;Log monster move (in the LOG)
 LDY #79
 LDA #22
 JSR PICKLINE
 LDX #79
]LOOP LDA $200,X
 CMP #" "
 BNE :OK
 DEX
 BNE ]LOOP
 LDX #0
:OK INX
 STX MISCBUFF
]LOOP LDA $200,X
 STA MISCBUFF+1,X
 DEX
 BPL ]LOOP
 NOTELOGBUFF $A;MISCBUFF
 RTS

INCREC0 LDX #0
 LDA #0
 JSR LOADMON2
 INCR MON2BUFF
 LDX #0
 LDA #0
 JMP SAVEMON2

LDSCEN LDA #0
 JMP LOADSCEN

GENFLAG DS 1
ADDTHE DS 1
ALLOC DS 1
SCEN DS 1
ERASED DS 4
MONPERLVL DS 16
SCENMONS DS 9

DOJAIL STZ :CNTR
 STZ :CNTR+1
 STZ :CNTR2
]LOOP LDA :CNTR+1
 CMP MAZEMONSTERS+1
 BNE :JOK
 LDA :CNTR
 CMP MAZEMONSTERS
 BEQ :JMDONE
:JOK INCR :CNTR
 LDX :CNTR
 LDA :CNTR+1
 JSR LOADMON2
 LDA MCOND
 AND #%1000_0000 ;Dead?
 BNE ]LOOP
 LDA MTYPE
 ORA MTYPE+1
 BEQ ]LOOP
 LDA MZPOS
 CMP LEVEL
 BNE ]LOOP
 LDX MTYPE
 LDA MTYPE+1
 JSR LOADMON
 LDA MLEVEL ;Level found = 0 means it's a guradian monster
 BNE ]LOOP
 INC :CNTR2
 BRA ]LOOP
:JMDONE LDX SCENARIO
 LDA #0
 JSR LOADSCEN
 LDA :CNTR2
 CMP SCGUARDSPERLVL
 BCC :GOGO
 RTS

:GOGO STZ :XLOC
 STZ :YLOC
]LOOP LDX :XLOC
 LDY :YLOC
 JSR GETMAP
 CMP #SHPMONGEN
 BNE :GGNO
 CPX #MONGENGUARDIAN
 BEQ :GEN
:GGNO INC :XLOC
 LDA :XLOC
 CMP #$10
 BNE ]LOOP
 STZ :XLOC
 INC :YLOC
 LDA :YLOC
 CMP #$10
 BNE ]LOOP
 RTS ;No jail guard generator this level
:XLOC DS 1
:YLOC DS 1

:GEN STZ :CNTR
 STZ :CNTR+1
]LOOP LDA :CNTR+1
 CMP MONSTERS+1
 BNE :OK
 LDA :CNTR
 CMP MONSTERS
 BNE :OK
 RTS ;No guards found to generate
:OK INCR :CNTR
 LDX :CNTR
 LDA :CNTR+1
 JSR LOADMON
 LDA MFREE
 BMI ]LOOP
 LDA MLEVEL ;Level found = 0 means it's a guardian monster
 BNE ]LOOP

 LDX :XLOC
 LDY :YLOC
 LDA #1
 JSR PUTMAP2M ;Add monster to this square

 LDX :XLOC
 LDY :YLOC
 LDA LEVEL
 JSR DOALL

 LDA :CNTR ;Set up monster data
 STA MTYPE
 STA MONSTER
 LDA :CNTR+1
 STA MTYPE+1
 STA MONSTER+1

 LDA :XLOC
 STA MXPOS
 LDA :YLOC
 STA MYPOS
 LDA LEVEL
 STA MZPOS

 LDX MHP
 LDA #0
 JSR ROLLD6 ;HP = HPd6 + (HP+1)
 LDA VTEMP
 CLC
 ADC MHP+1
 STA MCURHP

]LOOPC RANDNUM #9
 CPX #5
 BEQ ]LOOPC
 STX MDIR
 STZ MCOND
 LDX #7
]LOOPC STZ MCONDX,X
 DEX
 BPL ]LOOPC

 JSR SCROLL ;Update screen, and save it
 JSR PRINT
 ASC "Monster #"
 NULL

 BIT MONFLAG ;Did we find a blank space in file?
 BPL :NOFREE ;No, we didn't
 JSR PRINT
 COLOR YELLOW
 DEC16 MMREC
 COLOR WHITE
 NULL
 LDX MMREC
 LDA MMREC+1
 JSR SAVEMON2
 BRA :DISPIT
:NOFREE INCR MAZEMONSTERS ;Add to end of file
 JSR PRINT
 COLOR YELLOW
 DEC16 MAZEMONSTERS
 COLOR WHITE
 NULL
 LDX MAZEMONSTERS
 LDA MAZEMONSTERS+1
 JSR SAVEMON2
 JSR INCREC0 ;For PRMAPALL ('coz it reads record 0)

:DISPIT JSR PRINT
 ASC " ("
 COLOR YELLOW
 DEC16 MONSTER
 COLOR WHITE
 ASC "/"
 COLOR AQUAMARINE
 PRSTRING MNAME
 COLOR WHITE
 ASC ") put at "
 PAD2 MXPOS
 ASC ","
 PAD2 MYPOS
 NULL
 JSR LOG200

 INC GUARDS
 JMP SEARCH ;Find a blank space to put next monster

:CNTR DS 2
:CNTR2 DS 1

GUARDS DS 1
TOTGUARDS DS 4

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/GAME.ALLOCM
 fin

 END
