*-------------------------------
* GAME.CAB
*-------------------------------
 DAT
 LST OFF

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE VARS
 USE LIB.JMP
 USE CAB.DSECT
 USE PN.DSECT

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/GAME.CAB
 fin

 MODID "GAME.CAB"

FILET MAC
 DFB ]1
 ASC ]2
 <<<

START JSR CLOSEALL
 LDX #0
 JSR LOADCAB
 LDA MISCBUFF
 STA TOTRECS

TOP JSR PRINT
 HOME
 LINE "The Filing Cabinet"
 CR
 LINE "[U]pload a file"
 LINE "[D]ownload a file"
 CR
 LINE "[L]ist files"
 LINE "[S]-list files to/from you"
 LINE "[*]-list latest files"
 LINE "[Z]-delete a file"
 CR
 LINE "[Q]uit"
 CR
 ASC "Select an option : "
 NULL

]LOOP JSR KEYIN
 JSR UPPER
 LDX :KEYS
]LOOP2 CMP :KEYS,X
 BEQ :GOTONE
 DEX
 BNE ]LOOP2
 BRA ]LOOP
:GOTONE DEX
 TXA
 ASL
 TAX
 JMP (:TABLE,X)

:KEYS DFB :ENDKEYS-*-1
 DFB "Q"
 DFB "U"
 DFB "D"
 DFB "L"
 DFB "S"
 DFB "*"
 DFB "Z"
:ENDKEYS

:TABLE DA EXIT
 DA UPLOAD
 DA DOWNLOAD
 DA LIST
 DA LISTYOURS
 DA LISTNEW
 DA ZAP

EXIT JSR CLOSEALL
 RETURN

UPLOAD JSR PRINT
 HOME
 ASC "Enter a description of the file : "
 NULL
 GETLINE #35
 CPX #0
 BEQL TOP
 STX :DESCR
]LOOP LDA $200-1,X
 STA :DESCR,X
 DEX
 BNE ]LOOP
:PFNAME JSR PRINT
 CR
 ASC "Enter a ProDOS filename for the file : "
 NULL
 GETLINE #15
 BCSL TOP
 CPX #0
 BEQ :PFNAME
 STX :FNAME
]LOOP LDA $200-1,X
 JSR UPPER
 STA :FNAME,X
 STA :FNAME2-1,X
 DEX
 BNE ]LOOP
 LDA #:FNAME2-:PATH-1
 CLC
 ADC :FNAME
 STA :PATH
 MLI_GET_FILE_INFO :IPARMS
 BCS :PNUM
 JSR PRINT
 CR
 COLOR PINK
 LINE "File already exists."
 COLOR WHITE
 NULL
 JMP :PFNAME

:PNUM JSR PRINT
 CR
 ASC "Enter party to receive file (0=everyone, GM=GameMaster) : "
 NULL
 GETLINE #3
 BCSL TOP
 CPX #0
 BEQ :PNUM
 CPX #2
 BNE :NNOT2
 LDA $200
 JSR UPPER
 CMP #"G"
 BNE :NNOT2
 LDA $201
 JSR UPPER
 CMP #"M"
 BNE :NNOT2
 LDX PARTYNUM
 BRA :PN2
:NNOT2 JSR GETNUM
:PN2 STX :PARTY2
 LDX :FNAME
 STX VTEMP
]LOOP LDA :FNAME,X
 STA $200-1,X
 DEX
 BNE ]LOOP
 CALL "GAME.XR"
 LDA VTEMP+1
 BNEL :ERR
 JSR PRINT
 CR
 ASC "Wait.."
 NULL
 JSR GETFREEREC
 STX :REC
 STZ CABFREE
 LDA PARTYNUM
 STA CABPARTY
 LDA :PARTY2
 STA CABPARTY2
 MLI_GET_TIME
 LDA $BF90
 STA CABDATE
 LDA $BF91
 STA CABDATE+1
 LDA $200+4
 STA CABFTYPE
 JSR FIXBLOCKS
 LDX :DESCR
 STX CABDESCR
]LOOP LDA :DESCR,X
 STA CABDESCR,X
 DEX
 BNE ]LOOP
 LDX :FNAME
 STX CABFNAME
]LOOP LDA :FNAME,X
 STA CABFNAME,X
 DEX
 BNE ]LOOP
 STZ CABDLOADS
 STZ CABDLOADS+1
 LDX :REC
 JSR SAVECAB
 NOTELOGSTR $7;"Uploaded file : ";:FNAME
 JSR PRINT
 CR
 ASC "Saved as file #"
 DEC8 :REC
 ASC ". "
 NULL
 GETRETURN
 JMP TOP
:ERR LDA #:FNAME2-:PATH-1
 CLC
 ADC :FNAME
 STA :PATH
 MLI_DESTROY :DPARMS
 JMP TOP

:DPARMS DFB 1
 DA :PATH

:IPARMS DFB $A
 DA :PATH
 DS 5
 DS 2
 DS 8

:PARTY2 DS 1
:DESCR DS 1+35
:FNAME DS 1+15
:PATH STR 'DRAWER/'
:FNAME2 DS 15
:REC DS 1

DOWNLOAD JSR PRINT
 HOME
 ASC "Enter file to download : "
 NULL
 GETLINE #3
 CPX #0
 BEQL TOP
 JSR GETNUM
 CPX #0
 BEQ :NOSUCH
 CPX TOTRECS
 BCCL :OK
 BEQL :OK
:NOSUCH JSR PRINT
 CR
 COLOR PINK
 ASC "No such file (last file is #"
 COLOR YELLOW
 DEC8 TOTRECS
 COLOR PINK
 ASC "). "
 COLOR WHITE
 NULL
 GETRETURN
 JMP DOWNLOAD
:NOEXIST JSR PRINT
 CR
 COLOR PINK
 ASC "That file doesn't exist. "
 COLOR WHITE
 NULL
 GETRETURN
 JMP DOWNLOAD
:OK STX :REC
 JSR LOADCAB
 LDA CABFREE
 BMI :NOEXIST
 LDA CABPARTY2
 BEQ :GO
 LDA PARTYNUM
 CMP CABPARTY ;Yours?
 BEQ :GO
 CMP CABPARTY2 ;To you?
 BEQ :GO
 BRA :NOEXIST
:GO LDX CABFNAME
 STX VTEMP
]LOOP LDA CABFNAME,X
 STA $200-1,X
 DEX
 BNE ]LOOP
 CALL "GAME.XS"
 LDA VTEMP+1 ;Downloaded OK?
 BNE :NOTOK
 INCR CABDLOADS
 LDX :REC
 JSR SAVECAB
:NOTOK JSR PRINT
 CR
 NULL
 GETRETURN
 JMP TOP
:REC DS 1

ZAP LDA :PATH
 STA :PATHLEN
 JSR PRINT
 HOME
 ASC "Delete file #"
 NULL
 GETLINE #5
 CPX #0
 BEQL TOP
 JSR GETNUM
 CPX #0
 BEQ :NOSUCH
 CPX TOTRECS
 BCC :OK
 BEQ :OK
:NOSUCH JSR PRINT
 CR
 COLOR PINK
 ASC "Last file is "
 COLOR YELLOW
 DEC16 TOTRECS
 COLOR PINK
 ASC ". "
 COLOR WHITE
 NULL
 GETRETURN
 JMP ZAP
:OK STX :REC
 JSR LOADCAB
 LDA CABFREE
 BMI :NOEXIST
 LDA CABPARTY
 CMP PARTYNUM
 BEQ :OK2
 LDA CABPARTY2
 CMP PARTYNUM
 BEQ :OK2
 JSR PRINT
 CR
 COLOR PINK
 ASC "File belongs to another party. "
 COLOR WHITE
 NULL
 GETRETURN
 JMP ZAP
:NOEXIST JSR PRINT
 CR
 COLOR PINK
 ASC "File doesn't exist. "
 COLOR WHITE
 NULL
 GETRETURN
 JMP ZAP
:OK2 LDA #$FF
 STA CABFREE
 LDX :REC
 JSR SAVECAB
 JSR PRINT
 CR
 COLOR GREEN
 ASC "Deleted. "
 COLOR WHITE
 NULL
 LDY :PATHLEN
 LDX #0
]LOOP INX
 INY
 LDA CABFNAME,X
 STA :PATH,Y
 TXA
 CMP CABFNAME
 BNE ]LOOP
 LDA :PATHLEN
 CLC
 ADC CABFNAME
 STA :PATH
 MLI_DESTROY :DPARMS
 BCC :DONE
 CMP #$46 ;File not found
 BEQ :DONE
 NOTELOGSTR $D;"Error trying to delete file : ";:PATH
:DONE GETRETURN
 LDA :PATHLEN
 STA :PATH
 JMP ZAP
:REC DS 2
:PATHLEN DS 1
:DPARMS DFB 1
 DA :PATH
:PATH STR 'DRAWER/'
 DS 15

LISTNEW LDA #$FF
 STA LISTNEWFLAG
 BRA LIST

LISTYOURS LDA PARTYNUM
 HEX 2C
LIST LDA #0
 STA :PARTY
 LDX #1
 STX :REC
 JSR PRINT
 HOME
 NULL
 LDA LISTNEWFLAG
 BMI :VGO
 JSR PRINT
 ASC "List files, starting from file #1"
 CURSORLEFT
 NULL
 GETLINE #5
 BCSL TOP
 CPX #0
 BEQ :FROM1
 JSR GETNUM
 STX :REC
:FROM1 LDX :REC
 CPX TOTRECS
 BCC :VGO
 BEQ :VGO
 JSR PRINT
 CR
 COLOR PINK
 ASC "Last file is #"
 COLOR YELLOW
 DEC16 TOTRECS
 COLOR PINK
 ASC ". "
 COLOR WHITE
 NULL
 GETRETURN
 JMP LIST

:VGO JSR PRINT
 GOTOXY 0;2
 CLEOS
 LINE "  # From  To    Date      Blocks Typ Down'd Description"
 COLOR ORANGE
 MTON
 INVERSE
 ASC "LLL"
 CURSORRIGHT
 ASC "LLLLL"
 CURSORRIGHT
 ASC "LLLLL"
 CURSORRIGHT
 ASC "LLLLLLLLL"
 CURSORRIGHT
 ASC "LLLLLL"
 CURSORRIGHT
 ASC "LLL"
 CURSORRIGHT
 ASC "LLLLLL"
 CURSORRIGHT
 ASC "LLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLL"
 NORMAL
 MTOFF
 COLOR WHITE
 CR
 CURSOROFF
 NULL

 LDA PADFLAG
 PHA
 LDA PADCHAR
 PHA
 LDA #$FF
 STA PADFLAG
 LDA #" "
 STA PADCHAR

]LOOP LDX :REC
 JSR LOADCAB
 LDA CABFREE
 BMIL :NEXT
 LDA :PARTY
 BEQ :CHECK
 CMP CABPARTY
 BEQ :SHOWIT
 CMP CABPARTY2
 BEQ :SHOWIT
 JMP :NEXT

:CHECK LDA CABPARTY2 ;0=All
 BEQ :SHOWIT
 LDA CABPARTY
 CMP PARTYNUM
 BEQ :SHOWIT
 LDA CABPARTY2
 CMP PARTYNUM
 BNEL :NEXT

:SHOWIT LDA LISTNEWFLAG
 BPL :SHOWOK
 JSR :GETFDATES
 JSR :CHECKF
 BCCL :NEXT

:SHOWOK JSR PRINT
 DEC8 :REC
 ASC " "
 NULL
 LDA CABPARTY
 BNE :OKP
 JSR PRINT
 COLOR PINK
 ASC "   GM"
 NULL
 BRA :CTO
:OKP JSR PRINT
 COLOR YELLOW
 DEC16 CABPARTY
 NULL
:CTO JSR PRINT
 ASC " "
 NULL
 LDA CABPARTY2
 BNE :TONUM
 JSR PRINT
 COLOR AQUAMARINE
 ASC "  All"
 NULL
 BRA :CDATE
:TONUM CMP PARTYNUM
 BEQ :TOME
 JSR PRINT
 COLOR YELLOW
 DEC16 CABPARTY2
 NULL
 BRA :CDATE
:TOME CMP CABPARTY ;To GM?
 BEQ :TOGM
 JSR PRINT
 COLOR GREEN
 ASC "  You"
 NULL
 BRA :CDATE
:TOGM JSR PRINT
 COLOR PINK
 ASC "   GM"
 NULL
:CDATE JSR PRINT
 ASC " "
 COLOR ORANGE
 DATE CABDATE
 ASC " "
 COLOR YELLOW
 DEC16 CABBLOCKS
 ASC "  "
 COLOR GREEN
 NULL
 JSR PRFTYPE ;Print filetype
 JSR PRINT
 ASC " "
 COLOR YELLOW
 DEC16 CABDLOADS
 ASC "  "
 COLOR WHITE
 PRSTRING CABDESCR
 CR
 NULL

:NEXT LDA CV
 CMP #22
 BCC :VOK
 LDX :REC
 CPX TOTRECS
 BEQ :FIN
 JSR PRINT
 CR
 CURSORON
 CENTER "[RETURN]-continue, [ESC]-exit : "
 NULL
]LOOP2 JSR KEYIN
 CMP #$9B
 BEQ :ESC
 CMP #" "
 BEQ :CONT
 CMP #$8D
 BNE ]LOOP2
:CONT JSR PRINT
 GOTOXY 0;4
 CLEOS
 CURSOROFF
 NULL

:VOK INC :REC
 LDX :REC
 CPX TOTRECS
 BEQL ]LOOP
 BCCL ]LOOP
:FIN JSR PRINT
 GOTOXY 0;23
 CURSORON
 NULL
 GETRETURN
:ESC PLA
 STA PADCHAR
 PLA
 STA PADFLAG
 STZ LISTNEWFLAG
 JMP TOP

:GETFDATES LDA CABDATE+1
 LSR
 STA :YEAR
 LDA CABDATE
 PHA
 AND #%0001_1111
 STA :DAY
 PLA
 LUP 4
 ROL
 --^
 AND #%0000_1111
 STA :MONTH
 LDA PNLASTON+1
 LSR
 STA :PNYEAR
 LDA PNLASTON
 PHA
 AND #%0001_1111
 STA :PNDAY
 PLA
 LUP 4
 ROL
 --^
 AND #%0000_1111
 STA :PNMONTH
 RTS

:CHECKF LDA :YEAR
 CMP :PNYEAR
 BEQ :DOMONTH
 BCS :SHOWITF
 RTS
:DOMONTH LDA :MONTH
 CMP :PNMONTH
 BEQ :DODAY
 BCS :SHOWITF
 RTS
:DODAY LDA :DAY
 CMP :PNDAY
:SHOWITF RTS

:DAY DS 1 ;File upload date
:MONTH DS 1
:YEAR DS 1
:PNDAY DS 1 ;Party last call date
:PNMONTH DS 1
:PNYEAR DS 1

:REC DS 2
:PARTY DS 1

LOADCAB STX :REC
 JSR LOADSLICE
 STR "CAB.FILES"
 DA MISCBUFF
:REC DA 0
 DA CABRECLEN
 RTS

SAVECAB STX :REC
 JSR SAVESLICE
 STR "CAB.FILES"
 DA MISCBUFF
:REC DA 0
 DA CABRECLEN
 RTS

PRFTYPE LDA #<FTYPES
 STA CADD4
 LDA #>FTYPES
 STA CADD4+1
]LOOP LDA (CADD4)
 CMP CABFTYPE
 BNE :FNEXT
 LDY #1
 LDA (CADD4),Y
 JSR COUT
 INY
 LDA (CADD4),Y
 JSR COUT
 INY
 LDA (CADD4),Y
 JSR COUT
 BRA :FIN
:FNEXT INY
 LDA (CADD4),Y
 BEQ :UNKNOWN
 LDA CADD4
 CLC
 ADC #4
 STA CADD4
 LDA CADD4+1
 ADC #0
 STA CADD4+1
 BRA ]LOOP
:UNKNOWN JSR PRINT
 ASC "$"
 HEX8 CABFTYPE
 NULL
:FIN RTS

FTYPES FILET $00;"NON"
 FILET $01;"BAD"
 FILET $04;"TXT"
 FILET $06;"BIN"
 FILET $0F;"DIR"
 FILET $19;"ADB"
 FILET $1A;"AWP"
 FILET $1B;"ASP"
 FILET $B0;"SRC"
 FILET $B1;"OBJ"
 FILET $B2;"LIB"
 FILET $B3;"S16"
 FILET $B5;"EXE"
 FILET $B6;"PIF"
 FILET $B7;"TIF"
 FILET $B8;"NDA"
 FILET $B9;"CDA"
 FILET $BA;"TOL"
 FILET $BB;"DRV"
 FILET $BD;"FST"
 FILET $BF;"DOC"
 FILET $C0;"PNT"
 FILET $C1;"PIC"
 FILET $C8;"FON"
 FILET $CA;"ICN"
 FILET $FC;"BAS"
 FILET $FD;"VAR"
 FILET $FF;"SYS"
 DFB 0,0

GETFREEREC STZ :REC
]LOOP LDA :REC
 CMP TOTRECS
 BEQ :ADD1
 INC :REC
 LDX :REC
 JSR LOADCAB
 LDA CABFREE
 BPL ]LOOP
 LDX :REC
 RTS
:ADD1 INC :REC
 LDA :REC
 STA MISCBUFF
 STZ MISCBUFF+1
 LDX #0
 JSR SAVECAB
 LDX :REC
 STX TOTRECS
 RTS
:REC DS 1

FIXBLOCKS LDA $200+$12
 ORA $200+$12+1
 ORA $200+$12+2
 BNE :OK
 LDA $200+8
 STA $200+$12+1
 LDA $200+9
 STA $200+$12+2
 ASL $200+$12+1
 ROL $200+$12+2
:OK LDA $200+$12
 ROL
 LDA $200+$12+1
 ROL
 STA CABBLOCKS
 LDA $200+$12+2
 ROL
 STA CABBLOCKS+1
 ROL
 AND #1
 STA CABBLOCKS+2
 LDA $200+$12 ;Partial block left out?
 AND #$7F
 BEQ :DONE ;Add it in then....
 INC CABBLOCKS
 BNE :DONE
 INC CABBLOCKS+1
 BNE :DONE
 INC CABBLOCKS+2
:DONE RTS

TOTRECS DS 2

LISTNEWFLAG DS 1

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/GAME.CAB
 fin

 END
