*-------------------------------
* GAME.CASTLE
*-------------------------------
 DAT
 LST OFF

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE VARS
 USE LIB.JMP
 USE PLR.DSECT
 USE SCEN.DSECT
 USE PN.DSECT
 USE HOF.DSECT
 USE LOG.DSECT

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/GAME.CASTLE
 fin

 MODID "GAME.CASTLE"

KPMAX = 8

START LDA SCENARIO
 BEQ :NO
 LDX #0
 LDA #0
 JSR LOADSCEN
 LDA SCENBUFF
 BEQ :NO
 CMP SCENARIO
 BCS :SCENOK
:NO JMP START2

:SCENOK LDX SCENARIO
 LDA #0
 JSR LOADSCEN
 LDX #0
]LOOP PHX
 LDA CURPARTY2,X
 STA :REC+1
 LDA CURPARTY,X
 STA :REC
 BNE :OK
 LDA :REC+1
 BEQ :NEXT
:OK LDX :REC
 LDA :REC+1
 JSR LOADPLR
 LDA PLRZPOS
 BNE :NEXT ;In dungeon, so skip
 LDX #0
]LOOP2 LDA PLRITEM,X
 BEQ :NXTI
 CMP SCITEM
 BEQ :GOTIT ;Player has the 'item to get' for this scenario
:NXTI INX
 CPX #8
 BNE ]LOOP2
:NEXT PLX
 INX
 CPX NUMPARTY
 BNE ]LOOP
 JMP START2
:REC DS 2

:GOTIT LDA PLRITEM+1,X ;Give the item to Castle
 STA PLRITEM,X
 LDA PLRITEMX+1,X
 STA PLRITEMX,X
 INX
 CPX #7
 BCC :GOTIT
 STZ PLRITEM+7
 STZ PLRITEMX+7
 LDX :REC
 LDA :REC+1
 JSR SAVEPLR
 PLX ;(have to)
 JSR PRINT
 NORMAL
 MTOFF
 HOME
 SOUND $22;FOREVER;$80
 CURSORON
 COLOR PINK
 CENTER "Congratulations!"
 CURSOROFF
 SOUND $12;1;LOUD
 COLOR WHITE
 NULL
 NOTELOGSTR $1;"Item to get brought back by ";PLRNAME
 JSR PRINT
 CURSORON
 NULL
 LDA SCENARIO
 ORA #"0"
 STA :FILE+16 ;Make sure offset matches -\
 JSR GETFILE ;                          |
 DFB 2,22 ;                          |
:FILE STR "FILES/END.SCEN.0" ;  <---------------/
 JSR PRINT
 GOTOXY 0;23
 ASC "Wait.."
 CURSOROFF
 NULL
 LDX SCENARIO
 LDA #$FF
 STA QUESTDONE-1,X
 JSR SAVEVARS
 LDX #0
]LOOP PHX
 LDA PARTY2,X
 STA :REC+1
 LDA PARTY,X
 STA :REC
 BNE :OK2
 LDA :REC+1
 CMP #0
 BEQ :NEXT2
:OK2 LDX :REC
 LDA :REC+1
 JSR LOADPLR
 CLC
 XCE
 REP #$30
 LDA SCENARIO
 AND #$FF
 DEC
 ASL
 TAX
 LDA ENDQUESTEXP,X
 STA :ENDEXP
 LDA PLREXP
 CLC
 ADC :ENDEXP ;Add exp to Party for end of quest..
 STA PLREXP
 LDA PLREXP+2
 ADC #0
 STA PLREXP+2
 SEC
 XCE
 INC PLRCREDITS
 LDX :REC
 LDA :REC+1
 JSR SAVEPLR
:NEXT2 PLX
 INX
 CPX NUMPARTY
 BNE ]LOOP
 LDX PARTYNUM
 LDA #0
 JSR LOADPN
 INC PNCREDITS
 LDX PARTYNUM
 LDA #0
 JSR SAVEPN
 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 CURSORON
 NULL
 GETRETURN
 JSR PRINT
 CURSOROFF
 ZAPLINE
 NULL
 STZ VTEMP
 STZ VTEMP+1
 CALL "GAME.CHKEXP"
 JSR PRINT
 GOTOXY 0;2
 CLEOS
 CURSORON
 ASC "For your efforts, the party is awarded "
 COLOR YELLOW
 DEC16 :ENDEXP
 COLOR WHITE
 ASC " exp. each. To mark this event in the history books "
 ASC "you will be placed in the Hall Of Fame. Along with this you "
 ASC "may add a 'comment' to be displayed with your name."
 CR
 CR
 ASC "If you do not wish to leave a comment, just press [RETURN]."
 NULL
 LDX #0
 LDA #0
 JSR LOADHOF
 INC MISCBUFF
 LDA MISCBUFF
 STA :HOF
 LDX #0
 LDA #0
 JSR SAVEHOF
:COMMENT JSR PRINT
 GOTOXY 0;8
 CLEOS
 COLOR ORANGE
 ASC "Comment :"
 COLOR WHITE
 ASC " "
 NULL
 GETLINE #63
 STX HOFCOMMENT
 JSR PRINT
 GOTOXY 0;10
 COLOR PINK
 ASC "Ok (y/n)? : "
 COLOR WHITE
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 CMP #"Y"
 BEQ :YEPOK
 CMP #"N"
 BEQ :COMMENT
 BRA ]LOOP
:YEPOK JSR PRINT
 ASC "Yes"
 NULL
 LDX HOFCOMMENT
 BEQ :NOCOMNT
]LOOP LDA $200-1,X
 STA HOFCOMMENT,X
 DEX
 BNE ]LOOP
:NOCOMNT JSR PRINT
 GOTOXY 0;23
 COLOR PINK
 ASC "Wait.."
 COLOR WHITE
 CURSOROFF
 NULL
 LDA SCENARIO
 STA HOFGAME
 LDA SCENARIO
 DEC
 ASL
 TAX
 LDA GAMETURN,X
 STA HOFTURN
 MLI_GET_TIME
 LDX #3
]LOOP LDA $BF90,X
 STA HOFDATE,X
 DEX
 BPL ]LOOP
 LDX PARTYNUM
 LDA #0
 JSR LOADPN
 LDX PNNAME
 STX HOFNAME
]LOOP LDA PNNAME,X
 STA HOFNAME,X
 DEX
 BNE ]LOOP
 LDX SCNAME
 STX HOFSCEN
]LOOP LDA SCNAME,X
 STA HOFSCEN,X
 DEX
 BNE ]LOOP
 LDX :HOF
 LDA #0
 JSR SAVEHOF
 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 CURSORON
 ASC "You have been added to the Hall Of Fame. "
 SOUND $15;1;LOUD
 NULL
 GETRETURN
 JSR PRINT
 HOME
 ASC "Wait.."
 CURSOROFF
 NULL
 LDA SCENARIO
 STA :GAME
 LDA PARTYNUM ;Log all Party logs - "Game over"
 PHA
 LDX #0
 LDA #0
 JSR LOADPN
 LDA PNBUFF
 STA :PARTYS
]LOOP LDX :PARTYS
 LDA :PARTYS+1
 JSR LOADPN
 BIT PNFREE
 BMI :NEXTP
 LDA PLRSCENARIO
 CMP :GAME
 BNE :NEXTP
 LDA :PARTYS
 STA PARTYNUM
 PNOTELOGNUM $E;"*** End of game #";:GAME
:NEXTP DEC :PARTYS
 LDA :PARTYS
 BNE ]LOOP
 PLA
 STA PARTYNUM
 LDA SCENARIO
 STA LOGCALL
 STZ LOGCALL+1
 LDX :ENDGAMETXT
 STX LOGTEXT
]LOOP LDA :ENDGAMETXT,X
 STA LOGTEXT,X
 DEX
 BNE ]LOOP
 LDA #2 ;Entry with data
 JSR LOGFILENOTE
 LDX #0 ;Put all active players back into the Castle
 LDA #0
 JSR LOADPLR
 LDA PLRBUFF
 STA :REC
 LDA PLRBUFF+1
 STA :REC+1
]LOOP LDA :REC
 ORA :REC+1
 BEQ :DONEP
 LDX :REC
 LDA :REC+1
 JSR LOADPLR
 LDA PLRFREE
 BMI :NXTP
 LDA PLRSCENARIO
 CMP SCENARIO
 BNE :NXTP
 STZ PLRXPOS
 STZ PLRYPOS
 STZ PLRZPOS
 LDA PLRCOND
 AND #%1000_0000
 STA PLRCOND
 BMI :DED1
 LDA PLRHP+1
 STA PLRHP
:DED1 LDX #6
]LOOP2 STZ PLRCONDX,X
 DEX
 BPL ]LOOP2
 LDX :REC
 LDA :REC+1
 JSR SAVEPLR
:NXTP DECR :REC
 JMP ]LOOP
:DONEP STZ VTEMP
 CALL "GAME.PRECSTLE" ;Fix up party
 JMP START2
:HOF DS 1
:PARTYS DS 2
:GAME DS 4
:ENDEXP DS 2
:ENDGAMETXT STR "End of game #"

START2 JSR PRINT
 NORMAL
 MTOFF
 HOME
 SOUND $1C;FOREVER;$50
 CURSOROFF
 INVERSE
 COLOR YELLOW
 ZAPLINE
 COLOR WHITE
 NORMAL
 CENTER " Castle "
 GOTOXY 0;18
 INVERSE
 COLOR YELLOW
 ZAPLINE
 NORMAL
 GOTOXY 10;2
 COLOR WHITE
 CURSORON
 LINE "System Info"
 CR
 HTAB 10
 LINE "Inn"
 CR
 HTAB 10
 LINE "Holy Church"
 CR
 HTAB 10
 LINE "Shoppe"
 CR
 HTAB 10
 LINE "Dungeon"
 CR
 HTAB 10
 LINE "Towne jail"
 CR
 HTAB 10
 LINE "Help"
 CR
 HTAB 10
 LINE "Leave town (logoff)"
 GOTOXY 0;23
 CENTER "Use arrow keys to move pointer; [RETURN] to make selection."
 CURSOROFF
 NULL

DOKEY JSR DOPOINT

]LOOP JSR KEYIN
 JSR UPPER
 LDX :KEYS
]LOOP2 CMP :KEYS,X
 BEQ :GOTONE
 DEX
 BNE ]LOOP2
 LDX PNTR
 LDY #KPMAX
 JSR KPCHECK
 BCC ]LOOP
 STX PNTR
 BRA DOKEY
:GOTONE DEX
 TXA
 ASL
 TAX
 JMP (:TABLE,X)

:KEYS DFB :ENDKEYS-*-1
 DFB "K"-$40
 DFB "J"-$40
 DFB "M"-$40
:ENDKEYS

:TABLE DA UP
 DA DOWN
 DA DONE

UP LDA PNTR
 BNE :OK
 LDA #KPMAX
:OK DEC
 STA PNTR
 JMP DOKEY

DOWN LDA PNTR
 CMP #KPMAX-1
 BNE :OK
 LDA #$FF
:OK INC
 STA PNTR
 JMP DOKEY

DONE JSR PRINT
 CURSORLEFT
 ASC "x"
 NULL
 LDA PNTR
 ASL
 TAX
 JMP (:OPTIONS,X)

:OPTIONS DA INFO
 DA INN
 DA CHURCH
 DA SHOP
 DA DUNGEON
 DA JAIL
 DA HELP
 DA LOGOFF

DOPOINT LDA OLDPNTR
 ASL
 CLC
 ADC #2
 STA :CV+2
 JSR PRINT
 NORMAL
 MTOFF
 HTAB 8
:CV VTAB 0
 ASC " "
 NULL
 LDA PNTR
 ASL
 CLC
 ADC #2
 STA :CV2+2
 JSR PRINT
 HTAB 8
:CV2 VTAB 0
 NULL
 JSR SHOWPNTR
 LDA PNTR
 STA OLDPNTR
 RTS
PNTR DS 1
OLDPNTR DS 1

JAIL JSR PRINT
 HOME
 CURSORON
 NULL
 CALL "GAME.JAIL"
 JMP START

SHOP JSR PRINT
 HOME
 CURSORON
 NULL
 CALL "GAME.SHOP"
 JMP START

HELP JSR PRINT
 HOME
 CURSORON
 NULL
 CALL "GAME.HELP"
 JMP START

INFO JSR PRINT
 HOME
 CURSORON
 NULL
 CALL "GAME.INFO"
 JMP START

INN JSR PRINT
 HOME
 CURSORON
 NULL
 CALL "GAME.INN"
 JMP START

CHURCH JSR PRINT
 HOME
 CURSORON
 NULL
 CALL "GAME.CHURCH"
 JMP START

LOGOFF JSR PRINT
 GOTOXY 0;20
 CURSORON
 SOUND $13;1;$80
 COLOR PINK
 ASC "Logoff. Are you sure (y/n)? : "
 COLOR WHITE
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 CMP #"Y"
 BEQ :OFF
 CMP #"N"
 BNE ]LOOP
 JSR PRINT
 ASC "No"
 CURSOROFF
 ZAPLINE
 NULL
 JMP DOKEY
:OFF JSR PRINT
 ASC "Yes"
 NULL
 CALL "GAME.GOODBYE"
 JMP DROP

DUNGEON LDX NUMPARTY
 DEX
]LOOP LDA CURPARTY2,X
 BNE :OK
 LDA CURPARTY,X
 BNE :OK
 DEX
 BPL ]LOOP
 JSR PRINT
 GOTOXY 0;20
 CURSORON
 COLOR PINK
 ASC "You must Add people to your party first. "
 SOUND $02;1;LOUD
 COLOR WHITE
 NULL
 GETRETURN
:EXIT JSR PRINT
 CURSOROFF
 ZAPLINE
 NULL
 JMP DOKEY
:OK LDX SCENARIO
 LDA QUESTDONE-1,X
 BPL :OK2
 JSR PRINT
 GOTOXY 0;20
 CURSORON
 COLOR PINK
 ASC "You must wait until the next quest. "
 COLOR WHITE
 NULL
 GETRETURN
 BRA :EXIT
:OK2 STZ :CNTR
 STZ :CNTRD
 LDX #0
]LOOP PHX
 STX VTEMP
 LDA CURPARTY2,X
 STA :REC+1
 LDA CURPARTY,X
 STA :REC
 BNE :POK
 LDA :REC+1
 BEQ :NEXT
:POK LDX :REC
 LDA :REC+1
 JSR LOADPLR
 LDA PLRZPOS
 BNE :NEXTD
 INC VTEMP
 LDA :CNTR
 BNE :POK2
 JSR PRINT
 CURSORON
 HOME
 COLOR YELLOW
 CENTER "The dungeon.."
 COLOR WHITE
 GOTOXY 0;2
 NULL
:POK2 LDX :CNTR
 PLA
 PHA
 STA :TBL,X
 INC :CNTR
 JSR PRINT
 ASC "  "
 DEC8 :CNTR
 ASC ") "
 PRSTRING PLRNAME
 CR
 NULL
 BRA :NEXT
:NEXTD INC :CNTRD
:NEXT PLX
 INX
 CPX NUMPARTY
 BNE ]LOOP
 LDA :CNTR
 BNE :SOME
 JSR PRINT
 HOME
 CURSOROFF
 NULL
 EXEC "GAME.DUNGEON"
:SOME JSR PRINT
 CR
 COLOR AQUAMARINE
 LINE "Select characters you wish to take into the dungeon."
 MTON
 INVERSE
 ASC "K"
 NORMAL
 ASC ", "
 INVERSE
 ASC "J"
 NORMAL
 MTOFF
 ASC ", [SPACE]-toggle dungeon entry, [RETURN]-go, [ESC]-exit"
 COLOR WHITE
 CURSOROFF
 GOTOXY 0;2
 INVERSE
 ASC " "
 NORMAL
 NULL
 LDA #1
 STA :PNTR
]LOOP JSR KEYIN
 CMP #" "
 BEQ :TOGGLE
 CMP #$8D
 BEQL :GO
 CMP #$9B
 BEQL START2
 CMP #"K"-$40
 BEQ :GOUP
 CMP #"J"-$40
 BEQ :GODOWN
 BRA ]LOOP

:TOGGLE JSR :GETP
 CMP #' '
 BNE :SPC
 JSR PRINT
 CURSORLEFT
 MTON
 INVERSE
 ASC "E"
 NORMAL
 MTOFF
 NULL
 JMP ]LOOP
:SPC JSR PRINT
 CURSORLEFT
 INVERSE
 ASC " "
 NORMAL
 NULL
 JMP ]LOOP

:GOUP JSR :GETP
 CMP #' '
 BEQ :USP
 JSR PRINT
 CURSORLEFT
 MTON
 INVERSE
 ASC "D"
 NORMAL
 MTOFF
 NULL
 BRA :UCONT
:USP JSR PRINT
 CURSORLEFT
 ASC " "
 NULL
:UCONT LDA :PNTR
 CMP #1
 BNE :UP2
 LDA :CNTR
 CLC
 ADC #1
 STA :HV+3
 JSR PRINT
:HV GOTOXY 0;0
 NULL
 LDA :CNTR
 INC
:UP2 DEC
 STA :PNTR
 JSR :SHOWC
 JMP ]LOOP

:GODOWN JSR :GETP
 CMP #' '
 BEQ :DSP
 JSR PRINT
 CURSORLEFT
 MTON
 INVERSE
 ASC "D"
 NORMAL
 MTOFF
 NULL
 BRA :DCONT
:DSP JSR PRINT
 CURSORLEFT
 ASC " "
 NULL
:DCONT LDA :PNTR
 CMP :CNTR
 BNE :DOWN2
 JSR PRINT
 GOTOXY 0;2
 NULL
 LDA #0
:DOWN2 INC
 STA :PNTR
 JSR :SHOWC
 JMP ]LOOP

:SHOWC LDA :PNTR
 CLC
 ADC #1
 STA :SHV+3
 JSR PRINT
:SHV GOTOXY 0;0
 NULL
 JSR :GETP
 CMP #" "
 BEQ :SHSP
 JSR PRINT
 MTON
 INVERSE
 ASC "E"
 NORMAL
 MTOFF
 NULL
 RTS
:SHSP JSR PRINT
 INVERSE
 ASC " "
 NORMAL
 NULL
 RTS

:GETP LDA :PNTR
 CLC
 ADC #1
 LDX #0
 LDY #0
 JSR PICKLINE
 LDA $200
 RTS

:GO JSR :GETP
 CMP #' '
 BEQ :GSP
 JSR PRINT
 CURSORLEFT
 MTON
 INVERSE
 ASC "D"
 NORMAL
 MTOFF
 NULL
 BRA :GCONT
:GSP JSR PRINT
 CURSORLEFT
 ASC " "
 NULL
:GCONT STZ :PNTR ;Line pointer
 STZ :CNTRGO ;"Who's going?" counter
]LOOP INC :PNTR
 JSR :GETP
 CMP #" "
 BNE :GNEXT
 LDX :PNTR
 LDA :TBL-1,X
 TAX
 STZ CURPARTY,X ;Not going.. and that's final!
 STZ CURPARTY2,X
 BRA :GNEXT2
:GNEXT LDX :PNTR
 LDA :TBL-1,X
 TAX
 LDA CURPARTY2,X
 PHA
 LDA CURPARTY,X
 TAX
 PLA
 JSR LOADPLR
 INC :CNTRGO
 LDY #1
 LDX #0
]LOOP2 LDA PLRNAME+1,X
 STA MISCBUFF,Y
 INY
 INX
 CPX PLRNAME
 BNE ]LOOP2
 LDX #0
]LOOP2 LDA :ENTDG+1,X
 STA MISCBUFF,Y
 INY
 INX
 CPX :ENTDG
 BNE ]LOOP2
 DEY
 STY MISCBUFF
 PNOTELOGBUFF $A;MISCBUFF
:GNEXT2 LDA :PNTR
 CMP :CNTR
 BNE ]LOOP
 LDA :CNTRGO ;Anyone going?
 BNE :GOK
 JSR PRINT ;No..
 GOTOXY 0;23
 CURSORON
 COLOR PINK
 ASC "None selected. Continuing with current party. "
 COLOR WHITE
 NULL
 GETRETURN

:GOK STZ :COUNT
 LDX #0 ;Crunch
]LOOP PHX
 LDA CURPARTY2,X
 STA :REC+1
 LDA CURPARTY,X
 STA :REC
 BNE :GGOK
 LDA :REC+1
 BNE :GGOK
]LOOP2 CPX NUMPARTY
 BEQ :GGOKC
 LDA CURPARTY+1,X
 STA CURPARTY,X
 LDA CURPARTY2+1,X
 STA CURPARTY2,X
 INX
 BRA ]LOOP2
:GGOKC LDX NUMPARTY
 STZ CURPARTY-1,X
 STZ CURPARTY2-1,X
 PLX ;Any more zeros?
 INC :COUNT
 LDA :COUNT
 CMP NUMPARTY
 BCC ]LOOP
 STZ :COUNT
 PHX
:GGOK PLX
 INX
 CPX NUMPARTY
 BNE ]LOOP

:GOGO LDA :CNTRGO ;Anyone going?
 BEQ :GGZERO
:GOGODUNG JSR PRINT
 HOME
 CURSORON
 NULL
 LDA CURPARTY
 STA MPLR
 LDA CURPARTY2
 STA MPLR+1
 EXEC "GAME.DUNGEON"
:GGZERO LDA CURPARTY
 ORA CURPARTY+1
 BNE :GOGODUNG
 JMP START2

:ENTDG STR " enters the Dungeon"
:CNTR DS 1
:CNTRD DS 1
:CNTRGO DS 1
:PNTR DS 1
:REC DS 2
:TBL DS 8
:COUNT DS 1

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/GAME.CASTLE
 fin

 END
