*-------------------------------
* GAME.CHURCH
*-------------------------------
 DAT
 LST OFF

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE VARS
 USE PLR.DSECT
 USE LIB.JMP
 USE TABLES
 USE SPELL.DSECT

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/GAME.CHURCH
 fin

 MODID "GAME.CHURCH"

KPMAX = 5

START JSR PRINT
 NORMAL
 MTOFF
 HOME
 SOUND $1D;FOREVER;$60
 CURSOROFF
 INVERSE
 COLOR YELLOW
 ZAPLINE
 COLOR WHITE
 NORMAL
 CENTER " Holy Church "
 GOTOXY 0;12
 INVERSE
 COLOR YELLOW
 ZAPLINE
 NORMAL
 GOTOXY 10;2
 COLOR WHITE
 CURSORON
 HTAB 10
 LINE "Pray to the gods"
 CR
 HTAB 10
 LINE "Change class"
 CR
 HTAB 10
 LINE "Party stats"
 CR
 HTAB 10
 LINE "Resurrection"
 CR
 HTAB 10
 LINE "Leave"
 GOTOXY 0;23
 CENTER "Use arrow keys to move pointer; [RETURN] to make selection."
 CURSOROFF
 NULL

DOKEY JSR DOPOINT

]LOOP JSR KEYIN
 JSR UPPER
 LDX :KEYS
]LOOP2 CMP :KEYS,X
 BEQ :GOTONE
 DEX
 BNE ]LOOP2
 LDX PNTR
 LDY #KPMAX
 JSR KPCHECK
 BCC ]LOOP
 STX PNTR
 BRA DOKEY
:GOTONE DEX
 TXA
 ASL
 TAX
 JMP (:TABLE,X)

:KEYS DFB :ENDKEYS-*-1
 DFB "K"-$40
 DFB "J"-$40
 DFB "M"-$40
:ENDKEYS

:TABLE DA UP
 DA DOWN
 DA DONE

UP LDA PNTR
 BNE :OK
 LDA #KPMAX
:OK DEC
 STA PNTR
 JMP DOKEY

DOWN LDA PNTR
 CMP #KPMAX-1
 BNE :OK
 LDA #$FF
:OK INC
 STA PNTR
 JMP DOKEY

DONE JSR PRINT
 CURSORLEFT
 ASC "x"
 NULL
 LDA PNTR
 ASL
 TAX
 JMP (:OPTIONS,X)

:OPTIONS DA PRAY
 DA CHANGE
 DA STATS
 DA RAISE
 DA LEAVE

DOPOINT LDA OLDPNTR
 ASL
 CLC
 ADC #2
 STA :CV+2
 JSR PRINT
 NORMAL
 MTOFF
 HTAB 8
:CV VTAB 0
 ASC " "
 NULL
 LDA PNTR
 ASL
 CLC
 ADC #2
 STA :CV2+2
 JSR PRINT
 HTAB 8
:CV2 VTAB 0
 NULL
 JSR SHOWPNTR
 LDA PNTR
 STA OLDPNTR
 RTS
PNTR DS 1
OLDPNTR DS 1

CHANGE JSR PRINT
 GOTOXY 0;14
 CLEOS
 CURSORON
 NULL
 LDX NUMPARTY
]LOOP LDA CURPARTY2-1,X
 BNE :OK
 LDA CURPARTY-1,X
 BNE :OK
 DEX
 BNE ]LOOP
:OK STX :PLRS
 CPX #0
 BNE :OK2
 JSR PRINT
 COLOR PINK
 ASC "No-one in the party. "
 SOUND $02;1;$80
 COLOR WHITE
 NULL
 GETRETURN
:EXIT JSR PRINT
 GOTOXY 0;14
 CLEOS
 CURSOROFF
 NULL
 JMP DOKEY
:OK2 JSR SHOWNAMES
 JSR PRINT
 ASC "Who will change class (1-"
 DEC8 :PLRS
 ASC ")? : "
 NULL
]LOOP JSR KEYIN
 CMP #$9B
 BEQ :EXIT
 SEC
 SBC #"1"
 CMP :PLRS
 BCS ]LOOP
 PHA
 CLC
 ADC #"1"
 JSR COUT
 JSR PRINT
 CLEOS
 NULL
 PLX
 LDA CURPARTY,X
 STA :REC
 TAY
 LDA CURPARTY2,X
 STA :REC+1
 TYX
 JSR LOADPLR
 LDA PLRCOND
 AND #%1000_0000 ;Dead?
 BEQ :ALIVE
 JSR PRINT
 CR
 COLOR PINK
 PRSTRING PLRNAME
 ASC " is dead. "
 SOUND $13;1;$80
 COLOR WHITE
 NULL
 GETRETURN
 JMP CHANGE
:ALIVE LDA PLRZPOS ;In Castle?
 BEQ :CASTLE
 JSR PRINT
 CR
 COLOR PINK
 PRSTRING PLRNAME
 ASC " is not here. "
 SOUND $02;1;$80
 COLOR WHITE
 NULL
 GETRETURN
 JMP CHANGE
:CASTLE JSR PRINT
 GOTOXY 0;14
 ZAPLINE
 NULL
 LDX #9
]LOOP STZ :QUALS-1,X
 DEX
 BNE ]LOOP
 LDA PLRLVLREAL ;Must be lvl 2 or greater
 CMP #2
 BCCL :DONE ;Don't qualify
 STZ :CNTR
]LOOP INC :CNTR
 LDA :CNTR
 DEC
 ASL
 ASL
 TAX
 LDA MINATTR,X
 CMP #$FF
 BEQ :DONE
 LDY #0
]LOOP2 LDA PLRST,Y
 CMP MINATTR,X
 BCC ]LOOP
 INY
 CPY #4
 BNE ]LOOP2
 LDA :CNTR
 CMP PLRCLASS
 BEQ ]LOOP
 JSR PRINT
 HTAB 50
 DEC8 :CNTR
 ASC ") "
 PRTABLE :CNTR;CLASSTABLE
 CR
 NULL
 LDX :CNTR
 LDA #$FF
 STA :QUALS-1,X
 JMP ]LOOP

:DONE LDX #9
]LOOP LDA :QUALS-1,X
 BNE :OK3
 DEX
 BNE ]LOOP
 JSR PRINT
 GOTOXY 0;14
 CURSORON
 COLOR PINK
 PRSTRING PLRNAME
 ASC " doesn't qualify for any other classes. "
 SOUND $13;1;$80
 COLOR WHITE
 NULL
 GETRETURN
 JMP CHANGE
:EX JSR PRINT
 CURSOROFF
 NULL
 JMP DOKEY
:OK3 JSR PRINT
 GOTOXY 0;14
 ASC "Choose a class, "
 PRSTRING PLRNAME
 CR
 ASC "(level "
 DEC8 PLRLVLREAL
 ASC " "
 PRTABLE PLRCLASS;CLASSTABLE
 ASC ") : "
 NULL
]LOOP JSR KEYIN
 CMP #$9B
 BEQL CHANGE
 CMP #"1"
 BCC ]LOOP
 CMP #"9"+1
 BCS ]LOOP
 SEC
 SBC #"0"
 STA :CNTR
 TAX
 LDA :QUALS-1,X
 BEQ ]LOOP
 JSR PRINT
 DEC8 :CNTR
 CR
 COLOR YELLOW
 PRTABLE :CNTR;CLASSTABLE
 ASC ". "
 COLOR PINK
 ASC "Are you sure (y/n)? : "
 COLOR WHITE
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 CMP #"Y"
 BEQ :YES
 CMP #"N"
 BNE ]LOOP
 JMP CHANGE
:YES JSR PRINT
 ASC "Yes"
 NULL
 LDA :CNTR
 STA PLRCLASS
 LDA #1
 STA PLRLVLREAL ;Reset experience level

 DEC PLRST
 DEC PLRDX
 DEC PLRIQ
 DEC PLRHT

*-------------------------------------------------
 do 0 ;Change if wanted
 LDA PLRCLASS
 DEC
 ASL
 ASL
 TAX
 LDY #0 ;Reset attributes to minimum values
]LOOP LDA MINATTR,X
 CMP #10
 BCS :MINOK
 LDA #10 ;10 minimum (bit unfair otherwise)
:MINOK STA PLRST,Y
 INX
 INY
 CPY #4
 BNE ]LOOP
 fin
*-------------------------------------------------

 LDA PLRMAGIC
 BEQ :NOMAG
 RANDNUM #6 ;New spell points = 1d6+4
 TXA
 CLC
 ADC #4
 STA PLRMAGIC
 STA PLRMAGICMAX
:NOMAG LDX #3 ;Zap experience
]LOOP STZ PLREXP,X
 DEX
 BPL ]LOOP
 LDX #8 ;Unequipp all items
]LOOP STZ PLRITEMX-1,X
 DEX
 BNE ]LOOP
 JSR CALCPLR
 LDA PLRCURRPNTS ;Make sure current action points are <= max points
 CMP PLRMAXPNTS
 BCC :PNTSOK
 LDA PLRMAXPNTS
 STA PLRCURRPNTS
:PNTSOK LDX :REC
 LDA :REC+1
 JSR SAVEPLR
 JSR PRINT
 GOTOXY 0;14
 CLEOS
 COLOR ORANGE
 PRSTRING PLRNAME
 ASC " is now a "
 PRTABLE PLRCLASS;CLASSTABLE
 ASC ". "
 SOUND $10;1;$80
 SOUND $15;1;LOUD
 COLOR WHITE
 NULL
 STZ :FLAG
 LDX #0
 LDY #79
 LDA #14
 JSR PICKLINE
 LDX #78
]LOOP LDA $200,X
 STA $200+1,X
 BIT :FLAG
 BMI :NXT1
 CMP #" "
 BEQ :NXT1
 LDA #$FF
 STA :FLAG
 TXY
:NXT1 DEX
 BPL ]LOOP
 STY $200
 PNOTELOGBUFF $D;$200
 GETRETURN
 JMP :EXIT

:REC DS 2
:PLRS DS 1
:CNTR DS 1
:QUALS DS 9
:FLAG DS 1
MINATTR DFB 11,08,06,06 ;Fighter
 DFB 06,11,07,06 ;Thief
 DFB 06,07,11,06 ;Wizard
 DFB 07,06,11,07 ;Priest
 DFB 14,16,10,10 ;Ninja
 DFB 11,12,13,10 ;Sage
 DFB 13,11,14,10 ;High Mage
 DFB 13,10,14,11 ;High Priest
 DFB 16,16,16,16 ;Lord
 DFB $FF

STATS JSR PRINT
 GOTOXY 0;14
 CLEOS
 NULL
 CALL "GAME.PLRSTAT"
 JMP DOKEY

RAISE JSR PRINT
 GOTOXY 0;14
 CLEOS
 CURSORON
 NULL
 LDX NUMPARTY
]LOOP LDA CURPARTY2-1,X
 BNE :OK
 LDA CURPARTY-1,X
 BNE :OK
 DEX
 BNE ]LOOP
:OK STX :PLRS
 CPX #0
 BNE :OK2
 JSR PRINT
 COLOR PINK
 ASC "No-one is here. "
 SOUND $02;1;$80
 COLOR WHITE
 NULL
 GETRETURN
:EXIT JSR PRINT
 GOTOXY 0;14
 CLEOS
 CURSOROFF
 NULL
 JMP DOKEY
:OK2 STZ :CNTR
 LDX #0
]LOOP STX VTEMP
 LDA :CNTR
 CLC
 ADC #14
 STA :V+3
 LDA CURPARTY,X
 STA :REC
 LDA CURPARTY2,X
 STA :REC+1
 LDX :REC
 LDA :REC+1
 JSR LOADPLR
 LDA PLRCOND
 AND #%1000_0000 ;Dead bit
 BEQ :NEXT
 LDA PLRZPOS ;In Castle?
 BNE :NEXT
 INC :CNTR ;Update table
 JSR PRINT
:V GOTOXY 40;14
 DEC8 :CNTR
 ASC ") "
 PRSTRING PLRNAME
 NULL
 LDA :CNTR
 DEC
 ASL
 TAX
 LDA :REC
 STA :TBL,X
 LDA :REC+1
 STA :TBL+1,X
 LDA PLRLVLREAL
 DEC
 ASL
 ASL
 TAX
 LDY #0
]LOOP2 LDA RAISECOST,X
 STA :COST,Y
 INX
 INY
 CPY #4
 BNE ]LOOP2
 JSR PRINT
 HTAB 65
 DEC32 :COST
 ASC " GP"
 NULL
:NEXT LDX VTEMP
 INX
 CPX :PLRS
 BNEL ]LOOP
 LDA :CNTR
 BNE :OK3
 JSR PRINT
 GOTOXY 0;14
 COLOR AQUAMARINE
 ASC "All party members are alive or not here. "
 SOUND $25;1;LOUD
 COLOR WHITE
 NULL
 GETRETURN
 JMP :EXIT

:OK3 JSR PRINT
 GOTOXY 0;14
 ASC "Resurrect [ESC-exit] : "
 NULL

]LOOP JSR KEYIN
 CMP #$9B
 BEQL :EXIT
 CMP #"1"
 BCC ]LOOP
 CMP #"8"+1
 BCS ]LOOP
 SEC
 SBC #"1"
 STA :CNTR2
 CLC
 ADC #14
 LDX #40
 LDY #41
 JSR PICKLINE
 LDA $200
 CMP #" "
 BEQ ]LOOP

 LDA :CNTR2
 ASL
 TAX
 LDA :TBL,X
 STA :REC
 LDA :TBL+1,X
 STA :REC+1
 LDX :REC
 LDA :REC+1
 JSR LOADPLR
 LDA PLRLVLREAL
 DEC
 ASL
 ASL
 TAY
 LDX #0
]LOOP2 LDA RAISECOST,Y
 STA :COST,X
 STZ :CASH,X
 INY
 INX
 CPX #4
 BNE ]LOOP2

 STZ :FLAG
 LDX :PLRS
]LOOP PHX
 LDA CURPARTY-1,X
 TAY
 LDA CURPARTY2-1,X
 TYX
 JSR LOADPLR
 LDA PLRZPOS ;Must be in the Castle
 BNE :C2
 CLC
 XCE
 REP #$30
 LDA :CASH
 CLC
 ADC PLRGOLD
 STA :CASH
 LDA PLRGOLD+2
 ADC :CASH+2
 STA :CASH+2
 BCC :C2
 LDA #$FFFF
 STA :FLAG
:C2 SEC
 XCE
:NXTC PLX
 DEX
 BNE ]LOOP

 LDA :FLAG
 BNE :CANPAY
 LDX #3
]LOOP LDA :COST,X
 CMP :CASH,X
 BEQ :MAYBE
 BCC :CANPAY
 BCS :CANTPAY
:MAYBE DEX
 BPL ]LOOP
 JMP :CANPAY

:CANTPAY JSR PRINT
 GOTOXY 0;14
 CLEOS
 COLOR PINK
 ASC "Party has only "
 DEC32 :CASH
 ASC " GP. "
 SOUND $25;1;$80
 COLOR WHITE
 NULL
 GETRETURN
 JMP :EXIT

:CANPAY LDX :REC
 LDA :REC+1
 JSR LOADPLR
 LDA PLRHT
 CMP #2
 BCC :BHELP
 LDA PLRHP+1
 CMP #2
 BCS :CANPAY2
:BHELP JSR PRINT
 GOTOXY 0;14
 CLEOS
 COLOR PINK
 PRSTRING PLRNAME
 ASC " is beyond our help. "
 SOUND $13;1;$80
 COLOR WHITE
 NULL
 GETRETURN
 JMP RAISE
:CANPAY2 JSR PRINT
 GOTOXY 0;14
 CLEOS
 ASC "Raising "
 PRSTRING PLRNAME
 ASC " will cost "
 DEC32 :COST
 ASC " GP. Ok (y/n)? : "
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 CMP #"Y"
 BNEL RAISE
 JSR PRINT
 ASC "Yes"
 GOTOXY 0;14
 CLEOS
 SOUND RESET
 COLOR WHITE
 ASC "The Great Priest raises his hands.."
 PRPAUSE 4
 ASC "."
 PRPAUSE 4
 ASC "."
 PRPAUSE 4
 CR
 ASC "He intones the mystic words of healing..."
 PRPAUSE 2
 CR
 CR
 QUOTE
 COLOR AQUAMARINE
 ASC "Ahnal nathrak."
 PRPAUSE 3
 ASC "."
 PRPAUSE 6
 ASC " oothvas bethahd."
 PRPAUSE 3
 ASC "."
 PRPAUSE 6
 ASC " dokiel tienveih."
 PRPAUSE 3
 ASC "."
 PRPAUSE 6
 ASC "."
 COLOR WHITE
 QUOTE
 PRPAUSE 8
 CR
 CR
 NULL
 LDX #3
 JSR ROLLD6
 LDA VTEMP
 INC
 CMP PLRHT
 BCC :ALIVE
 RANDNUM #100
 CPX PLRAGE
 BCS :ALIVE
 JSR PRINT
 COLOR PINK
 PRSTRING PLRNAME
 ASC " could not be resurrected. "
 SOUND $13;1;LOUD
 COLOR WHITE
 NULL
 JMP :SAVEC
:ALIVE JSR PRINT
 COLOR AQUAMARINE
 PRSTRING PLRNAME
 ASC " is alive! "
 SOUND $15;1;$80
 COLOR WHITE
 SOUND $1D;FOREVER;$60
 NULL
 PNOTELOGSTR $9;"Ressurected character : ";PLRNAME
 LDA #0
 STA PLRCOND
 LDX #7
]LOOP STZ PLRCONDX,X
 DEX
 BPL ]LOOP
 LDA PLRHP+1 ;Drop HP by one
 SEC
 SBC #1
 STA PLRHP+1
 STA PLRHP
:SAVEC DEC PLRHT
 JSR CALCPLR
 LDX :REC
 LDA :REC+1
 JSR SAVEPLR

 STZ :FLAG
 LDX #0
]LOOP PHX
 LDA CURPARTY,X
 STA :REC
 LDA CURPARTY2,X
 STA :REC+1
 LDX :REC
 LDA :REC+1
 JSR LOADPLR
 LDA PLRZPOS
 BNE :NXTG2
 CLC
 XCE
 REP #$30
 LDA PLRGOLD+2
 CMP :COST+2
 BEQ :G2
 BCS :ENUFF
 BCC :SCAB
:G2 LDA PLRGOLD
 CMP :COST
 BCS :ENUFF
:SCAB LDA :COST
 SEC
 SBC PLRGOLD
 STA :COST
 LDA :COST+2
 SBC PLRGOLD+2
 STA :COST+2
 STZ PLRGOLD
 STZ PLRGOLD+2
 BRA :NXTG
:ENUFF LDA PLRGOLD
 SEC
 SBC :COST
 STA PLRGOLD
 LDA PLRGOLD+2
 SBC :COST+2
 STA PLRGOLD+2
 LDA #$FFFF
 STA :FLAG
:NXTG SEC
 XCE
 LDX :REC
 LDA :REC+1
 JSR SAVEPLR
:NXTG2 PLX
 LDA :FLAG
 BNE :DONEG
 INX
 CPX :PLRS
 BNE ]LOOP
:DONEG LDA #$FF
 STA VTEMP
 STA VTEMP+1
 CALL "GAME.CHKEXP"
 GETRETURN
 JMP :EXIT

:REC DS 2
:CNTR DS 1
:CNTR2 DS 1
:COST DS 4
:CASH DS 4
:FLAG DS 2
:PLRS DS 1
:TBL DS 8*2

PRAY JSR PRINT
 GOTOXY 0;14
 CLEOS
 CURSORON
 NULL
 LDX NUMPARTY
]LOOP LDA CURPARTY2-1,X
 BNE :OK
 LDA CURPARTY-1,X
 BNE :OK
 DEX
 BNE ]LOOP
:OK STX :PLRS
 CPX #0
 BNE :OK2
 JSR PRINT
 COLOR PINK
 ASC "No-one in the party to pray. "
 SOUND $02;1;$80
 COLOR WHITE
 NULL
 GETRETURN
 JSR PRINT
 ZAPLINE
 CURSOROFF
 NULL
 JMP DOKEY
:OK2 JSR SHOWNAMES
 JSR PRINT
 ASC "Who will pray (1-"
 DEC8 :PLRS
 ASC ")? : "
 NULL
]LOOP JSR KEYIN
 CMP #$9B
 BEQL :EXIT
 SEC
 SBC #"1"
 CMP :PLRS
 BCS ]LOOP
 PHA
 CLC
 ADC #"1"
 JSR COUT
 JSR PRINT
 CLEOS
 NULL
 PLX
 LDA CURPARTY,X
 STA :REC
 TAY
 LDA CURPARTY2,X
 STA :REC+1
 TYX
 JSR LOADPLR
 LDA PLRCOND
 AND #%1000_0000 ;Dead?
 BEQ :ALIVE
 JSR PRINT
 CR
 COLOR PINK
 PRSTRING PLRNAME
 ASC " is dead. "
 SOUND $13;1;LOUD
 COLOR WHITE
 NULL
 GETRETURN
 JMP PRAY
:ALIVE LDA PLRZPOS ;In Castle?
 BEQ :CASTLE
 JSR PRINT
 CR
 COLOR PINK
 PRSTRING PLRNAME
 ASC " is not here. "
 SOUND $13;1;LOUD
 COLOR WHITE
 NULL
 GETRETURN
 JMP PRAY
:CASTLE JSR PRINT
 GOTOXY 0;14
 CLEOS
 PRSTRING PLRNAME
 ASC " is praying.."
 PRPAUSE 2
 NULL
 CALL "GAME.PRAY"
 LDX :REC
 LDA :REC+1
 JSR SAVEPLR
 JMP DOKEY
:EXIT JSR PRINT
 CURSOROFF
 GOTOXY 0;14
 CLEOS
 NULL
 JMP DOKEY
:PLRS DS 1
:REC DS 2

LEAVE JSR PRINT
 HOME
 CURSORON
 NULL
 RETURN

SHOWNAMES LDX NUMPARTY
]LOOP LDA CURPARTY2-1,X
 ORA CURPARTY-1,X
 BNE :OK
 DEX
 BNE ]LOOP
 RTS
:OK STX :TEMP
 LDA CH
 STA :HV+2
 LDA CV
 STA :HV+3
 STZ :NUM
 LDX #0
]LOOP PHX
 LDA CURPARTY,X
 TAY
 LDA CURPARTY2,X
 TYX
 JSR LOADPLR
 INC :NUM
 JSR PRINT
 HTAB 40
 NULL
 LDA PLRZPOS
 BEQ :CASTLE
 JSR PRINT
 COLOR PINK
 NULL
 BRA :CONT
:CASTLE JSR PRINT
 COLOR AQUAMARINE
 NULL
:CONT JSR PRINT
 DEC8 :NUM
 ASC ") "
 PRSTRING PLRNAME
 CR
 NULL
 PLX
 INX
 CPX :TEMP
 BNE ]LOOP
 JSR PRINT
 COLOR WHITE
:HV GOTOXY 0;0
 NULL
 RTS
:TEMP DS 1
:NUM DS 1

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/GAME.CHURCH
 fin

 END
