*-------------------------------
* GAME.CRDEL
*-------------------------------
 DAT
 LST OFF

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE VARS
 USE PLR.DSECT
 USE LIB.JMP
 USE TABLES
 USE PN.DSECT

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/GAME.CRDEL
 fin

 MODID "GAME.CRDEL"

START JSR CLRBOT
 JSR PRINT
 GOTOXY 0;15
 COLOR WHITE
 CURSORON
 ASC "Party limit "
 COLOR YELLOW
 DEC8 NUMPARTY
 COLOR WHITE
 LINE " characters."
 ASC "[C]reate, [D]elete, [ESC]-exit : "
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 CMP #"C"
 BEQL CREATE
 CMP #"D"
 BEQL DELETE
 CMP #$9B
 BNE ]LOOP
EXIT JSR PRINT
 CURSOROFF
 ZAPLINE
 NULL
 RETURN

CREATE LDX NUMPARTY
 DEX
]LOOP LDA PARTY2,X
 BNE :NEXT
 LDA PARTY,X
 BEQ :OK
:NEXT DEX
 BPL ]LOOP
 JSR CLRBOT
 JSR PRINT
 CURSORON
 COLOR PINK
 ASC "You cannot create any more characters. "
 SOUND $13;1;LOUD
 COLOR WHITE
 NULL
 GETRETURN
 JSR PRINT
 CURSOROFF
 ZAPLINE
 NULL
 JMP START
:OK JSR PRINT
 HOME
 CURSORON
 NULL
 CALL "GAME.NEWPLR"
 JMP EXIT

DELETE JSR CLRBOT
 JSR PRINT
 CURSORON
 NULL
 LDX NUMPARTY
]LOOP LDA PARTY2-1,X
 BNE :OK
 LDA PARTY-1,X
 BNE :OK
 DEX
 BNE ]LOOP
 JSR CLRBOT
 JSR PRINT
 CURSORON
 COLOR PINK
 ASC "No characters in the party to delete. "
 SOUND $02;1;LOUD
 COLOR WHITE
 NULL
 GETRETURN
 JSR PRINT
 CURSOROFF
 ZAPLINE
 NULL
 JMP START
:OK STX :PLRS
 LDX #0
 STX :CNTR
]LOOP LDA PARTY,X
 TAY
 LDA PARTY2,X
 TYX
 JSR LOADPLR
 LDA :CNTR
 CLC
 ADC #15
 STA :V+3
 INC :CNTR
 JSR PRINT
:V GOTOXY 40;15
 DEC8 :CNTR
 ASC ") "
 NULL
 LDA PLRZPOS ;Can only delete if player is in the castle!
 BEQ :INCST
 LDA PLRCOND
 AND #%1000_0000 ;Dead?
 BNE :INCST ;OK, allowed to delete then
:INCNO JSR PRINT
 COLOR PINK
 NULL
 BRA :CCONT
:INCST LDA PLRARRESTFLAG
 AND #%0100_0000
 BNE :INCNO
 JSR PRINT
 COLOR AQUAMARINE
 NULL
:CCONT JSR PRINT
 PRSTRING PLRNAME
 NULL
 LDX :CNTR
 CPX :PLRS
 BNE ]LOOP
 JSR PRINT
 GOTOXY 0;15
 ASC "Delete character (1-"
 DEC8 :PLRS
 ASC ")? : "
 NULL
]LOOP JSR KEYIN
 CMP #$9B
 BEQL START
 SEC
 SBC #"1"
 CMP :PLRS
 BCS ]LOOP
 STA :PLR
 PHA
 JSR PRINT
 CURSOROFF
 NULL
 PLX
 LDA PARTY,X
 STA :CHAR
 TAY
 LDA PARTY2,X
 STA :CHAR+1
 TYX
 JSR LOADPLR
 JSR CLRBOT
 LDA PLRZPOS ;Can only delete if player is in the castle!
 BEQ :INCSTLE
 LDA PLRCOND
 AND #%1000_0000 ;Dead?
 BNE :INCSTLE ;OK, allowed to delete then
 JSR PRINT
 CURSORON
 COLOR PINK
 PRSTRING PLRNAME
 ASC " is alive or not in the Castle. "
 SOUND $13;1;LOUD
 COLOR WHITE
 NULL
 GETRETURN
 JMP DELETE
:INCSTLE LDA PLRARRESTFLAG
 AND #%0100_0000
 BEQ :CSTLE2
 JSR PRINT
 CURSORON
 COLOR PINK
 PRSTRING PLRNAME
 ASC " is in Jail. "
 SOUND $13;1;LOUD
 COLOR WHITE
 NULL
 GETRETURN
 JMP DELETE
:CSTLE2 JSR PRINT
 CURSORON
 COLOR PINK
 ASC "Delete "
 PRSTRING PLRNAME
 ASC " (y/n)? : "
 COLOR WHITE
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 CMP #"Y"
 BEQ :YES
 CMP #"N"
 BNE ]LOOP
 JMP DELETE
:YES JSR PRINT
 ASC "Yes"
 CURSOROFF
 COLOR PINK
 CR
 NULL
 LDA #$FF
 STA PLRFREE
 LDX :CHAR
 LDA :CHAR+1
 JSR SAVEPLR
 JSR PRINT
 CURSORON
 COLOR PINK
 ASC "Deleted. "
 SOUND $0F;1;LOUD
 COLOR WHITE
 NULL
 NOTELOGSTR $1;"Deleted character : ";PLRNAME
 PNOTELOGSTR $1;"Deleted character : ";PLRNAME
 GETRETURN
 DEC PLAYERS ;(Vars)
 LDX #0 ;Update curparty (in VARS)
]LOOP LDA CURPARTY,X
 CMP :CHAR
 BNE :NOTME
 LDA CURPARTY2,X
 CMP :CHAR+1
 BEQ :DONE
:NOTME INX
 CPX NUMPARTY
 BNE ]LOOP
 BRA :NOTINC
:DONE
]LOOP INX
 CPX NUMPARTY
 BEQ :DONE2
 LDA CURPARTY,X
 STA CURPARTY-1,X
 LDA CURPARTY2,X
 STA CURPARTY2-1,X
 BRA ]LOOP
:DONE2 STZ CURPARTY-1,X
 STZ CURPARTY2-1,X
:NOTINC LDX :PLR ;Update party (in VARS)
]LOOP INX
 CPX NUMPARTY
 BEQ :DONEME
 LDA PARTY,X
 STA PARTY-1,X
 LDA PARTY2,X
 STA PARTY2-1,X
 BRA ]LOOP
:DONEME STZ PARTY-1,X
 STZ PARTY2-1,X
 JSR PRINT
 HOME
 ASC "Calling the spirits to remove the body.."
 SOUND $10;1;LOUD
 NULL
 LDA DUMBTERM
 PHA
 LDA #$FF
 STA DUMBTERM ;Can't show RECLAIM as it shows total lvs in dungeon
 JSR PRINT
 CR
 NULL
 JSR RECLAIM
 PLA
 STA DUMBTERM
 JSR PRINT
 CR
 CR
 ASC "Removed.. "
 NULL
 LDA #$FF
 STA VTEMP
 STZ VTEMP+1
 CALL "GAME.CHKEXP"
 GETRETURN
:EXIT JSR PRINT
 HOME
 NULL
 RETURN
:PLRS DS 1
:PLR DS 1
:CHAR DA 1
:CNTR DS 1

CLRBOT JSR PRINT
 GOTOXY 0;22
 LUP 7
 ZAPLINE
 CURSORUP
 --^
 ZAPLINE
 NULL
 RTS

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/GAME.CRDEL
 fin

 END
