*-------------------------------
* GAME.INIT
*-------------------------------
 DAT
 LST OFF

 XC
 XC

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE VARS
 USE LIB.JMP
 USE SCEN.DSECT
 USE PN.DSECT

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/GAME.INIT
 fin

 MODID "GAME.INIT"

START LDA STARTUPCODE
 CMP #$FF
 BEQL QUIT

 JSR PRINT
 HOME
 NULL

 JSR LOADVARS

 STZ CONNECTED
 LDA #$FF
 STA DUMBTERM
 STA MODEMOK
 STZ SYSOPFLAG
 STZ MAPLOOK
 LDA #$FF
 STA ECHO

 STZ PADFLAG
 LDA #" "
 STA PADCHAR

 MLI_GET_TIME ;Store 'wait' date/time
 LDX #3
]LOOP LDA $BF90,X
 STA WAITDATE,X
 DEX
 BPL ]LOOP
 JSR GETTIME
 LDA SECOND
 STA WAITTIME+2
 LDA CURRDAY
 STA WAITDAYE

 JSR SAVEVARS

 LDA STARTUPCODE
 CMP #FUNC_USER
 BEQ UPDATE
 CMP #FUNC_CHECK
 BEQ UPDATE

 LDA PARTYNUM
 BNE UPDATEP
 LDA #%1100_0000 ;Update everything
 HEX 2C
UPDATEP LDA #%1000_0000 ;Update all, but reclaim only one map
 HEX 2C
UPDATE LDA #0 ;No map reclaim
 STA VTEMP
 CALL "GAME.UPDATE"
 LDA VTEMP
 STA GMNOTREAD
 LDA VTEMP+1
 STA GMTOTAL

 STZ PARTYNUM
 STZ MAPLOOK

INIT0 LDX SCENARIO
 STX SCEN
 CPX #0
 BEQ :INITHZ
 LDA #0
 JSR LOADSCEN
 LDX SCNAME
 STX SCENAME
 BEQ :SNSKIP
]LOOP LDA SCNAME,X
 STA SCENAME,X
 DEX
 BNE ]LOOP
:SNSKIP LDA #15
 CLC
 ADC SCNAME
 LSR
 STA VTEMP
 LDA SCNAME
 BNE :NOK
 LDA VTEMP
 CLC
 ADC #5
 STA VTEMP
:NOK LDA #40
 SEC
 SBC VTEMP
 STA SCHTAB
 LDX SCEN
 LDA QUESTDONE-1,X
 BPL :INITHZ
 LDA SCHTAB
 SEC
 SBC #3
 STA SCHTAB

:INITHZ JSR SAVEVARS

:INITH JSR INITHOOK

INIT JSR PRINT
 COLOR WHITE
 MTOFF
 NORMAL
 HOME
 CURSORON
 NULL
 STZ TURN
 STZ TURN+1
 LDA SCEN
 BEQ :OK
 DEC
 ASL
 TAX
 LDA GAMETURN,X
 STA TURN
 LDA GAMETURN+1,X
 STA TURN+1
:OK LDA #%0000_1111
 TRB $C034 ;Make it black

 LDA STARTUPCODE
 CMP #FUNC_USER
 BEQL ONLINE2
 CMP #FUNC_CHECK
 BEQL DOCHECK

 LDA TESTFLAG
 ORA $C061
 BMIL TOP
 LDA STARTUPPATH
 BNEL TOP
 JSR PRINT
 ASC "Initializing modem..."
 NULL

 JSR HANGUP
 JSR READSTRINGS ;Read in file to get responses
 LDA INITRATE ;Init coms card
 STA BAUDRATE
 JSR INITCARD
 JSR GETALL
 LDA #8 ;Retry count
 STA :TRY
 LDX #<INITSTRING ;Send init string to modem
 LDA #>INITSTRING
 JSR SENDSTRING
]LOOP JSR GETSTRING ;Get next line from modem
 LDA $200
 BNE :LOOK
 BCS :NO2
:LOOK LDA $200 ;Look for 'OK' type message
 BEQ :NO
 CMP OKSTRING
 BNE :NO
 TAX
]LOOP2 LDA OKSTRING,X
 AND #$7F
 CMP $200,X
 BNE :NO
 DEX
 BNE ]LOOP2
 JSR GETALL
 JMP :INITOK
:NO LDX #1
 JSR XWAIT
:NO2 DEC :TRY
 BNE ]LOOP
 JSR PRINT
 CR
 COLOR PINK
 ASC "Could not initialize modem..."
 PRPAUSE 4
 COLOR WHITE
 NULL
 STZ MODEMOK
 NOTELOG $F;"Modem offline (could not be initialized)"
 JMP TOP
:TRY DS 1

:INITOK BIT SMARTMODEM
 BPL TOP
 JSR READY

TOP JSR PRINT
 HOME
 CURSOROFF
 COLOR WHITE
 NULL
 LDA SYSTEMNAME
 BEQ :NOSYSNAME
 LDA #80
 SEC
 SBC SYSTEMNAME
 SBC #17
 LSR
 STA :SNHTAB+2
 JSR PRINT
:SNHTAB GOTOXY 0;0
 ASC "The Complex II : "
 PRSTRING SYSTEMNAME
 NULL
 BRA :NCONT
:NOSYSNAME JSR PRINT
 CENTER "The Complex II"
 NULL
:NCONT JSR PRINT
 GOTOXY 0;2
 MTON
 INVERSE
 COLOR ORANGE
 LUP 80
 ASC "S"
 --^
 NORMAL
 MTOFF
 COLOR YELLOW
 OPT 1;"Q";"Quit"
 HTAB 26
 OPT 1;"@";"Reboot"
 HTAB 52
 OPT 0;"*";"Monitor"
 CR
 OPT 0;"L";"View log"
 HTAB 26
 OPT 0;"A";"Add log note"
 HTAB 52
 OPT 0;"D";"Dumbterm"
 CR
 OPT 0;"M";"Map Editor"
 HTAB 26
 OPT 0;"V";"Vars Editor"
 HTAB 52
 OPT 0;"P";"Player Editor"
 CR
 OPT 0;"I";"Item Editor"
 HTAB 26
 OPT 0;"N";"Monster Editor"
 HTAB 52
 OPT 0;"O";"Maze Mon Editor"
 CR
 OPT 0;"S";"Scenario Editor"
 HTAB 26
 OPT 0;"F";"File Peeker"
 HTAB 52
 OPT 0;"J";"Party Names Editor"
 CR
 OPT 0;"Y";"Maze Item Editor"
 HTAB 26
 OPT 0;"H";"HelpFile Editor"
 HTAB 52
 OPT 0;"C";"H.O.F. Editor"
 CR
 OPT 1;"F";"Force NextTurn"
 HTAB 26
 OPT 0;"/";"View logfile"
 HTAB 52
 OPT 0;"W";"View map"
 CR
 OPT 1;"Z";"Misc. Utilities"
 HTAB 26
 OPT 0;"?";"Technical Info"
 HTAB 52
 OPT 0;"B";"Msg Base Editor"
 CR
 OPT 1;"C";"Inv. Editor"
 HTAB 26
 OPT 1;"R";"Reclaim maps"
 HTAB 52
 OPT 1;"S";"Sysop module"
 CR
 OPT 0;"G";"Glossary Editor"
 HTAB 26
 OPT 0;"U";"Sign Editor"
 HTAB 52
 OPT 0;"E";"Spell Descr Editor"
 CR
 MTON
 INVERSE
 COLOR ORANGE
 LUP 80
 ASC "S"
 --^
 NORMAL
 MTOFF
 COLOR WHITE
 ASC "Total - Calls  : "
 COLOR YELLOW
 DEC16 CALLS
 COLOR WHITE
 HTAB 40
 ASC "This session - Calls  : "
 COLOR YELLOW
 DEC16 CALLSTS
 COLOR WHITE
 CR
 ASC "        Logons : "
 COLOR YELLOW
 DEC16 LOGONS
 COLOR WHITE
 HTAB 40
 ASC "               Logons : "
 COLOR YELLOW
 DEC16 LOGONSTS
 COLOR WHITE
 CR
 CR
 ASC "Turn #"
 COLOR YELLOW
 DEC16 TURN
 COLOR WHITE
 ASC ". Active parties : "
 COLOR YELLOW
 NULL
 LDX SCENARIO
 LDA PARTIES-1,X
 STA VTEMP
 JSR PRINT
 DEC8 VTEMP
 COLOR WHITE
 ASC " ("
 COLOR YELLOW
 NULL
 LDA SCEN
 DEC
 ASL
 TAX
 LDA PLAYERS,X
 STA VTEMP
 LDA PLAYERS+1,X
 STA VTEMP+1
 JSR PRINT
 DEC16 VTEMP
 COLOR WHITE
 ASC " players). GM-mail : "
 NULL
 LDA GMNOTREAD
 BEQ :OVERGM
 JSR PRINT
 COLOR YELLOW
 DEC8 GMNOTREAD
 COLOR WHITE
 ASC " new msgs ("
 COLOR YELLOW
 DEC8 GMTOTAL
 COLOR WHITE
 ASC ")"
 NULL
 BRA :OVERGM2
:OVERGM JSR PRINT
 ASC "<"
 COLOR AQUAMARINE
 ASC "no new msgs"
 COLOR WHITE
 ASC ">"
 NULL
:OVERGM2 JSR PRINT
 CR
 CR
 ASC "Wait-loop entered : "
 COLOR ORANGE
 NULL
 JSR SHOWTIME2
 JSR PRINT
 COLOR WHITE
 CR
 ASC "Current date/time : "
 NULL
 LDA WAITDAY
 BNE :DAYOK
 LDA CURRDAY
 STA WAITDAY
:DAYOK LDA CV
 STA :V+3
 INC
 INC
 STA :V3+3
 JSR PRINT
 CR
 CR
 ASC "Time to next turn : "
 GOTOXY 1;0
 COLOR AQUAMARINE
 ASC "Written by;"
 CR
 COLOR GREEN
 ASC " Sean Craig"
 COLOR WHITE
 NULL
 LDA #79
 SEC
 SBC VERSION
 STA :VC+2
 JSR PRINT
:VC GOTOXY 70;0
 COLOR AQUAMARINE
 PRSTRING VERSION
 GOTOXY 65;1
 COLOR GREEN
 ASC "Gen: "
 PRSTRING GENDATE
 COLOR WHITE
 NULL
 LDA SCEN
 BEQ :NOSCEN
 LDA SCHTAB
 STA :SCHTAB+2
 JSR PRINT
:SCHTAB GOTOXY 28;1
 COLOR PINK
 ASC "Scenario #"
 DEC8 SCENARIO
 ASC " : "
 PRSTRING SCENAME
 COLOR WHITE
 NULL
 LDX SCEN
 LDA QUESTDONE-1,X
 BPL :NOSCEN
 JSR PRINT
 COLOR ORANGE
 ASC " <done>"
 COLOR WHITE
 NULL
:NOSCEN BIT TESTFLAG
 BMI :TESTING
 BIT MODEMOK
 BMI :OK2
 JSR PRINT
 VTAB 23
 COLOR PINK
 CENTER "-- Modem is not online --"
 COLOR WHITE
 NULL
 BRA :GOGO
:TESTING JSR PRINT
 VTAB 23
 COLOR PINK
 CENTER "-- Test status : modem is not being polled --"
 COLOR WHITE
 NULL

:GOGO MLI_GET_TIME

 LDA $BF92
 STA WAITMIN

:OK2 BIT $C010
 JSR BOTSTUFF
]LOOP JSR PRINT
:V GOTOXY 20;0
 COLOR YELLOW
 NULL
 JSR SHOWTIME
 JSR PRINT
 COLOR WHITE
 NULL
 LDA DAYSTOGO
 BEQ :OVER
 LDA CURRDAY
 CMP WAITDAY
 BNEL DOTURN
 BRA :HOHUM
:OVER BIT XTRATIME
 BPLL DOTURN2
 MLI_GET_TIME
 LDA $BF93
 CMP TURNTIME+1
 BEQ :HMM
 BCSL DOTURN2
 BCC :HOHUM
:HMM LDA $BF92
 CMP TURNTIME
 BCSL DOTURN2
:HOHUM JSR PRINT
:V3 GOTOXY 20;0
 NULL
 LDA PREVSECOND
 CMP SECOND
 BEQ :NAHH
 JSR TILLNEXT
 LDA SECOND
 STA PREVSECOND
:NAHH LDA $C000
 BMIL :KEY
 LDA $BF92
 CMP WAITMIN
 BEQ :SAME
 STA WAITMIN
 BIT MODEMOK ;Couldn't init modem?
 BPLL INIT ;Try again
:SAME BIT TESTFLAG ;Don't poll if 'testing'
 BMIL ]LOOP
 BIT SMARTMODEM
 BMI :SMART
 GETREG #0
 AND #ZSCCDCD
 BEQL ]LOOP
 JMP :CALL

:SMART LDA SCCCOMMAND
 AND #%1000_0000
 CMP #%1000_0000 ;Off
 BEQ :OFF
 CMP #%0000_0000 ;On
 BEQ :ON
 JMP ]LOOP

:OFF BIT MODEMOK
 BPLL ]LOOP ;Nothing has changed
 STZ MODEMOK
 NOTELOG $F;"Modem went offline"
 JMP TOP
:ON BIT MODEMOK
 BMI :OK3 ;Nothing changed
 LDA #$FF
 STA MODEMOK
 NOTELOG $F;"Modem now online"
 JMP INIT

:OK3 JSR GETSTRING ;Get next line from modem
 LDX $200 ;Look for 'RING' type message
 BEQL ]LOOP ;Nothing
 CPX RINGSTRING
 BNEL ]LOOP
]LOOP2 LDA RINGSTRING,X
 AND #$7F
 CMP $200,X
 BNEL ]LOOP
 DEX
 BNE ]LOOP2
 JSR GETALL

 NOTELOG $D;"Phone rang.."
 JSR PRINT
 HOME
 COLOR WHITE
 ASC "Incoming call..."
 NULL
 INCR CALLSTS
 JSR SAVEVARS
 JSR MODEMTALK2 ;Talk to me modem..
 BCSL INIT
:CALL INCR CALLS
 JSR SAVEVARS
 LDA CALLS
 STA MISCBUFF
 LDA CALLS+1
 STA MISCBUFF+1
 STZ MISCBUFF+2
 STZ MISCBUFF+3
 NOTELOGNUM $F;"Connection established - Call #";MISCBUFF
 BIT SMARTMODEM
 BPL :DUMB
 LDA CONNECTRATE
 ASL
 TAX
 LDA :BAUDS,X
 STA MISCBUFF
 LDA :BAUDS+1,X
 STA MISCBUFF+1
 STZ MISCBUFF+2
 STZ MISCBUFF+3
 NOTELOGNUM $E;"Baud rate = ";MISCBUFF
:DUMB JMP ONLINE
:BAUDS DA 0
 DA 300
 DA 1200
 DA 2400
 DA 4800
 DA 7200
 DA 9600
 DA 12000
 DA 14400
 DA 19200

:KEY STA $C010
 JSR UPPER
 LDX :KEYS
]LOOP2 CMP :KEYS,X
 BEQ :GOTONE
 DEX
 BNE ]LOOP2
 JMP ]LOOP
:GOTONE DEX
 TXA
 ASL
 TAX
 JMP (:TABLE,X)

:KEYS DFB :ENDKEYS-*-1
 DFB "Q"-$40
 DFB "@"-$40
 DFB "*"
 DFB "L"
 DFB "A"
 DFB "M"
 DFB "V"
 DFB "P"
 DFB "I"
 DFB "D"-$40
 DFB "R"-$40
 DFB "D"
 DFB "Z"-$40
 DFB "N"
 DFB "F"-$40
 DFB "O"
 DFB "/"
 DFB "W"
 DFB "S"
 DFB "F"
 DFB "J"
 DFB "Z"-$40
 DFB "Y"
 DFB "H"
 DFB "C"
 DFB "?"
 DFB "B"
 DFB "S"-$40
 DFB "G"
 DFB "U"
 DFB "E"
 DFB "I"-$40
 DFB "C"-$40
:ENDKEYS

:TABLE DA QUIT
 DA REBOOT
 DA MONITOR
 DA VIEWLOG
 DA ADDLOG
 DA MAPED
 DA VARSED
 DA PLRED
 DA ITEMED
 DA DFLAG
 DA START
 DA DUMB
 DA MOKFLAG
 DA MONED
 DA NEXTURN
 DA MON2ED
 DA VIEWLOGF
 DA VIEWMAP
 DA SCENED
 DA FPEEKER
 DA PNED
 DA UTIL
 DA ITEM2ED
 DA HELPED
 DA HOFED
 DA TECHO
 DA MSGED
 DA SYSOP
 DA GLOSSED
 DA SIGNED
 DA SPDESCED
 DA TOGGLEGM
 DA INVED

ONLINE JSR PRINT
 CR
 COLOR WHITE
 ASC "Connected at "
 DEC16 MISCBUFF
 ASC " baud.."
 NULL
ONLINE3 LDA #$FF
 STA CONNECTED
 STZ DUMBTERM
CONNECT LDA #$FF
 STA DELAYFLAG
 EXEC "GAME.LOGON"

ONLINE2 LDA STARTUPBAUD
 CMP #10
 BCC :BOK
 LDA #0
:BOK STA CONNECTRATE
 LDA MODEMCSFLAG
 BMI :FIN
 LDA CONNECTRATE ;Put in if 'constant mode' on modem is OFF
 STA BAUDRATE
:FIN JSR INITCARD
 JSR GETALL
 LDA STARTUPBAUD ;Dumbterm
 BEQ CONNECT
 JMP ONLINE3

GETTIME CLC
 XCE
 REP #$30
 PushWord #0
 PushWord #0
 PushWord #0
 PushWord #0
 Tool $0D03 ;ReadTimeHex
 SEC
 XCE
 PLA
 STA SECOND
 PLA
 PLA
 PLA
 PLA
 PLA
 PLA
 PLA
 STA CURRDAY
 RTS

SHOWTIME JSR GETTIME
 LDA CURRDAY
 DEC
 ASL
 ASL
 ASL
 TAX
]LOOP LDA DAYS,X
 BEQ :DONE
 JSR COUT
 INX
 BRA ]LOOP
:DONE JSR PRINT
 ASC "day, "
 CURRDATE
 ASC "  "
 CURRTIME
 NULL
 JSR PRINT
 ASC ":"
 PAD2 SECOND
 NULL
 RTS

SHOWTIME2 LDA WAITDAYE
 DEC
 ASL
 ASL
 ASL
 TAX
]LOOP LDA DAYS,X
 BEQ :DONE
 JSR COUT
 INX
 BRA ]LOOP
:DONE JSR PRINT
 ASC "day, "
 DATE WAITDATE
 ASC "  "
 TIME WAITTIME
 NULL
 JSR PRINT
 ASC ":"
 PAD2 WAITTIME+2
 NULL
 RTS

DAYS DAY8 "Sun"
 DAY8 "Mon"
 DAY8 "Tues"
 DAY8 "Wednes"
 DAY8 "Thurs"
 DAY8 "Fri"
 DAY8 "Satur"

CURRDAY DS 1
SECOND DS 1
PREVSECOND DS 1

MONITOR JSR HANGUP
 LDX #2
]LOOP LDA :VECTOR,X
 STA $3F8,X
 DEX
 BPL ]LOOP
 STA $C001
 STA $C00C
 JSR $FE89
 JSR $FE93
 JSR $FB2F
 JSR $FC58
 JSR SHOWTEXT
 JSR PRINT
 ASC "When you get there, you will understand everything.."
 HEX 8D
 NULL
 JMP $FF69

:VECTOR JMP :RETURN

:RETURN JSR INITHOOK
 JMP INIT

VIEWLOG JSR HANGUP
 CALL "VIEWLOG"
 JMP INIT

ADDLOG JSR HANGUP
 CALL "ADDLOG"
 JMP INIT

MAPED JSR HANGUP
 CALL "MAP.EDITOR"
 JMP INIT0

VARSED JSR HANGUP
 CALL "VARS.EDITOR"
 JMP INIT0

PLRED JSR HANGUP
 CALL "PLR.EDITOR"
 JMP INIT

MONED JSR HANGUP
 CALL "MON.EDITOR"
 JMP INIT

MON2ED JSR HANGUP
 CALL "MON2.EDITOR"
 JMP INIT0

ITEMED JSR HANGUP
 CALL "ITEM.EDITOR"
 JMP INIT

VIEWLOGF JSR HANGUP
 CALL "VIEWLOGFILE"
 JMP INIT0

VIEWMAP JSR HANGUP
 CALL "VIEW.MAP"
 STZ MAPLOOK
 JMP INIT0

SCENED JSR HANGUP
 CALL "SCEN.EDITOR"
 JMP INIT0

FPEEKER JSR HANGUP
 CALL "FILE.PEEKER"
 JMP INIT

PNED JSR HANGUP
 CALL "PN.EDITOR"
 JMP INIT

ITEM2ED JSR HANGUP
 CALL "ITEM2.EDITOR"
 JMP INIT0

HELPED JSR HANGUP
 CALL "HELP.EDITOR"
 JMP INIT

HOFED JSR HANGUP
 CALL "HOF.EDITOR"
 JMP INIT

TECHO JSR HANGUP
 CALL "TECHO.INFO"
 JMP INIT

MSGED JSR HANGUP
 CALL "MSG.EDITOR"
 JMP UPDATE

GLOSSED JSR HANGUP
 CALL "GLOSS.EDITOR"
 JMP INIT

SIGNED JSR HANGUP
 CALL "SIGN.EDITOR"
 JMP INIT0

INVED JSR HANGUP
 CALL "INV.EDITOR"
 JMP INIT

SPDESCED JSR HANGUP
 CALL "SPDESC.EDITOR"
 JMP INIT

UTIL JSR HANGUP
 CALL "UTIL.MOD"
 JMP INIT

SYSOP JSR HANGUP
 LDA #$FF
 STA SYSOPFLAG
 CALL "GAME.SYSOP"
 STZ SYSOPFLAG
 JMP INIT0

NEXTURN JSR HANGUP
 JSR PRINT
 HOME
 COLOR PINK
 ASC "Force Next Turn. Are you sure (y/n)? : "
 COLOR WHITE
 CURSORON
 NULL
 JSR KEYIN
 JSR UPPER
 CMP #"Y"
 BNE :NO
 JSR PRINT
 ASC "Yes"
 NULL
 NOTELOG $E;"Next turn forced on master console"
 CALL "GAME.NEXTURN"
 STZ PARTYNUM
:NO JMP INIT0

DUMB JSR HANGUP
 JSR PRINT
 GOTOXY 0;23
 CLEOS
 COLOR WHITE
 ASC "Dumbterm.."
 PRPAUSE 4
 NULL
 NOTELOG $F;"Dumbterm entered on master console"
 EXEC "GAME.LOGON"

DFLAG LDA DELAYFLAG
 EOR #$FF
 STA DELAYFLAG
 JMP TOP

MOKFLAG LDA MODEMOK
 EOR #$FF
 STA MODEMOK
 BMI :OK
 JSR HANGUP
 JMP TOP
:OK JSR READY
 JMP TOP

DOTURN JSR PRINT
 HOME
 COLOR WHITE
 ASC "Wait.."
 NULL
 CALL "GAME.CHKJAIL"
 LDA CURRDAY ;Update today's day number
 STA WAITDAY
 DEC DAYSTOGO
 BMI DOTURN2
 BNE :OK
 BIT XTRATIME
 BPL DOTURN2
:OK JSR SAVEVARS
 LDA STARTUPCODE
 CMP #FUNC_CHECK
 BEQ :OUT
 STZ PARTYNUM
 JMP INIT
:OUT LDA #$FF
 STA STARTUPCODE
 STZ PARTYNUM
 JSR SAVEVARS
 JMP START

DOTURN2 JSR PRINT
 HOME
 COLOR WHITE
 ASC "Wait.."
 NULL
 JSR HANGUP
 CALL "GAME.NEXTURN"
 LDA STARTUPCODE
 CMP #FUNC_CHECK
 BEQ :OUT
 JMP INIT0
:OUT LDA #$FF
 STA STARTUPCODE
 STZ PARTYNUM
 JSR SAVEVARS
 JMP START

TILLNEXT MLI_GET_TIME
 LDA #23
 STA :TURNHOUR
 LDA #59
 STA :TURNMIN
 LDA DAYSTOGO
 BNE :NOX
 BIT XTRATIME
 BPL :NOX
 LDA TURNTIME+1
 DEC
 BPL :THOK
 LDA #23
:THOK STA :TURNHOUR
 LDA TURNTIME
 DEC
 BPL :TMOK
 LDA #59
:TMOK STA :TURNMIN
:NOX LDA DAYSTOGO
 BEQ :TIME
 DEC
:TIME STA :DAYS
 LDA #60
 SEC
 SBC SECOND
 STA :SS
 LDA :TURNMIN
 SEC
 SBC $BF92
 STA :MM
 LDA :TURNHOUR
 SBC $BF93
 STA :HH
 LDA :SS
 CMP #60
 BNE :OKX
 STZ :SS
 INC :MM
 LDA :MM
 CMP #60
 BNE :OKX
 STZ :MM
 INC :HH
:OKX BIT XTRATIME
 BPL :SAYIT
 LDA DAYSTOGO
 BEQ :SAYIT
 LDA :MM
 CLC
 ADC TURNTIME
 STA :MM
 CMP #60
 BCC :OK
 SBC #60
 STA :MM
 INC :HH
:OK LDA :HH
 CLC
 ADC TURNTIME+1
 STA :HH
 CMP #24
 BCC :SAYIT
 SBC #24
 STA :HH
 INC :DAYS
:SAYIT LDA CURRDAY
 CMP WAITDAY
 BEQ :SAYIT2
 DEC :DAYS
:SAYIT2 LDA :DAYS
 BEQ :HRS
 BMI :NOW
 JSR PRINT
 COLOR YELLOW
 DEC8 :DAYS
 COLOR WHITE
 ASC " days, "
 NULL
:HRS LDA :HH
 BEQ :MINS
 BMI :MINS
 JSR PRINT
 COLOR YELLOW
 PAD2 :HH
 COLOR WHITE
 ASC " hours, "
 NULL
:MINS LDA :MM
 BEQ :SECS
 BMI :NOW
 JSR PRINT
 COLOR YELLOW
 PAD2 :MM
 COLOR WHITE
 ASC " minutes, "
 NULL
:SECS JSR PRINT
 COLOR YELLOW
 PAD2 :SS
 COLOR WHITE
 ASC " seconds"
 CLEOL
 NULL
 RTS

:NOW JSR PRINT
 CLEOL
 COLOR PINK
 ASC "<none>"
 COLOR WHITE
 NULL
 RTS

:DAYS DS 1
:HH DS 1
:MM DS 1
:SS DS 1

:TURNHOUR DS 1
:TURNMIN DS 1

SCHTAB DS 1
SCEN DS 1
SCENAME DS 1+40

SHOWTEXT LDA $C029
 AND #%0111_1111
 STA $C029
 LDA BORDER
 STA $C034
 RTS

FLICKER LDA $C029
 EOR #%1000_0000
 STA $C029
 BPL :TEXT
 LDA BORDER
 AND #%1111_0000
 STA $C034
 RTS
:TEXT LDA BORDER
 STA $C034
 RTS

WAITMIN DS 1

GMNOTREAD DS 1 ;Messages to the GM (not read yet)
GMTOTAL DS 1 ;                   (total)

WAITDAYE DS 1
WAITDATE DS 2
WAITTIME DS 3

BOTSTUFF BIT SHRFLAG
 BMI :HOT
 BIT GMSTATUS
 BMI :TIN
:TOUT LDA #"O"
 HEX 2C
:TIN LDA #"I"
 BIT $C055
 STA $7D0+39
 BIT $C054
 RTS
:HOT JSR PRINT
 GOTOXY 0;24
 HOME
 COLOR YELLOW
 ASC "Leading party"
 COLOR WHITE
 ASC " : "
 COLOR AQUAMARINE
 NULL
 LDX SCENARIO
 LDA LEADPRTY-1,X
 TAX
 CPX #0
 BEQ :NOLEAD
 LDA #0
 JSR LOADPN
 LDA SCENARIO
 DEC
 ASL
 ASL
 TAX
 LDY #0
]LOOP LDA LEADEXP,X
 STA :EXP,Y
 INX
 INY
 CPY #4
 BNE ]LOOP
 JSR PRINT
 PRSTRING PNNAME
 COLOR WHITE
 ASC " with "
 COLOR YELLOW
 DEC32 :EXP
 COLOR WHITE
 ASC " exp."
 NULL
 BRA :CONT
:NOLEAD JSR PRINT
 COLOR PINK
 ASC "<none>"
 COLOR WHITE
 NULL
:CONT JSR PRINT
 COLOR WHITE
 HTAB 70
 COLOR YELLOW
 ASC "GM"
 COLOR WHITE
 ASC " : "
 NULL
 BIT GMSTATUS
 BMI :IN
:OUT JSR PRINT
 COLOR AQUAMARINE
 ASC "Out"
 NULL
 BRA :CONT2
:IN JSR PRINT
 COLOR PINK
 ASC "In"
 NULL
:CONT2 JSR PRINT
 COLOR WHITE
 GOTOXY 0;0
 NULL
 RTS
:EXP DS 4

TOGGLEGM LDA GMSTATUS
 EOR #$FF
 STA GMSTATUS
 JSR SAVEVARS
 JMP TOP

TURN DS 2

XWAIT LDY #60
]LOOP LDA $C061
 BMI :EXIT
 LDA $C019
 BPL ]LOOP
]LOOP2 LDA $C061
 BMI :EXIT
 LDA $C019
 BMI ]LOOP2
 DEY
 BNE ]LOOP
 DEX
 BNE XWAIT
:EXIT RTS

DOCHECK LDA WAITDAY
 BNE :DAYOK
 LDA CURRDAY
 STA WAITDAY
:DAYOK LDA DAYSTOGO
 BEQ :OVER
 LDA CURRDAY
 CMP WAITDAY
 BNEL DOTURN
 BRA :HOHUM
:OVER BIT XTRATIME
 BPLL DOTURN2
 LDA CURRDAY
 CMP WAITDAY
 BNEL DOTURN
 MLI_GET_TIME
 LDA $BF93
 CMP TURNTIME+1
 BEQ :HMM
 BCSL DOTURN2
 BCC :HOHUM
:HMM LDA $BF92
 CMP TURNTIME
 BCSL DOTURN2
:HOHUM LDA #$FF
 STA STARTUPCODE
 JSR PRINT
 CR
 LINE "System checked - gameturn not executed"
 PRPAUSE 4
 NULL
 STZ PARTYNUM
 JSR SAVEVARS
 JMP START

GETSTRING STZ $200
]LOOP JSR CHECKIN ;Char waiting?
 BCC :DONE ;No
 AND #$7F
 CMP #'M'-$40
 BEQ :DONE
 CMP #' '
 BCC ]LOOP
 INC $200
 LDX $200
 STA $200,X
 BRA ]LOOP
:DONE RTS

SENDSTRING STX CADD2 ;Send a pascal string to the modem
 STA CADD2+1
 JSR GETALL ;Make sure nothing is there
 LDA (CADD2) ;Send the string
 STA :LEN
 LDY #0
]LOOP LDA :LEN
 BEQ :DONE
 INY
 LDA (CADD2),Y
 PHY
 JSR MSENDBYTE
 PLY
 DEC :LEN
 BRA ]LOOP
:DONE LDX #1
 JSR DELAY
 JSR GETALL ;Make sure nothing is there
 LDA #"M"-$40
 JMP MSENDBYTE
:LEN DS 1

*
* Check response from modem. Use file "MODEM.CONNECT" to work out connect rate
*
* File format : {modem_response}={connect rate}
*     Example : CONNECT 12000/REL=12000             (verbal responses)
*     Example : 12=9600                             (numeric responses)
*
MODEMTALK2 JSR CLOSEALL
 MLI_OPEN :OPARMS
 BCSL :ERR
 LDA :OPARMS+5
 STA :RPARMS+1
 STA :CPARMS+1
 MLI_READ :RPARMS
 BCC :ROK
 CMP #$4C
 BNEL :ERRC
:ROK MLI_CLOSE :CPARMS
 BCSL :ERRC
 LDA #<MISCBUFF
 STA CADD6
 LDA #>MISCBUFF
 STA CADD6+1

 LDA #60
 STA :CNTR
]LOOP STZ :Y
 STZ :Y+1
 LDX #3 ;Get line from modem
 JSR DELAY
 JSR GETSTRING ;Get next line from modem
 JSR :CHECKNC ;Got a 'NO CARRIER' type message?
 BCS :EXITNC ;Yes
]LOOP2 JSR :GETBIT ;Get 'model' response (eg; "CONNECT 9600/REL")
 LDX :LINE ;Check with what we got from modem
 CPX $200
 BNE :NEXT
]LOOP3 LDA :LINE,X
 CMP $200,X
 BNE :NEXT
 DEX
 BNE ]LOOP3
 BRA :FOUND
:NEXT JSR :GETBIT ;Setup pointer for next line in file
 LDXA :Y
 CPXA :ACTLEN
 BCC ]LOOP2
 DEC :CNTR ;Loop for a maximum of 60 seconds (just in case)
 BNE ]LOOP ;Keep going
:EXITNC SEC ;Did not connect... :(
 JMP :EXIT

:FOUND JSR :GETBIT ;Get connect rate from file
 LDA #<BAUDTABLE ;Try to match it with entry in table
 STA CADD4
 LDA #>BAUDTABLE
 STA CADD4+1
 LDX #0
]LOOP LDA (CADD4)
 BEQ :NOTFOUND
 TAY
 CMP :LINE
 BNE :FNEXT
]LOOP2 LDA (CADD4),Y
 AND #$7F
 CMP :LINE,Y
 BNE :FNEXT
 DEY
 BNE ]LOOP2
 STX CONNECTRATE ;Got it!
 LDA MODEMCSFLAG
 BMI :DOCARD
 LDA CONNECTRATE ;Put in if 'constant mode' on modem is OFF
 STA BAUDRATE
:DOCARD JSR INITCARD
 CLC ;Cool! :)
 JMP :EXIT
:FNEXT LDA (CADD4)
 SEC
 ADC CADD4
 STA CADD4
 LDA CADD4+1
 ADC #0
 STA CADD4+1
 INX
 BRA ]LOOP

:NOTFOUND JSR PRINT
 CR
 CR
 COLOR PINK
 ASC "Connection rate "
 COLOR YELLOW
 PRSTRING :LINE
 COLOR PINK
 ASC " in file "
 PRSTRING :PATH
 ASC " is unknown "
 ASC " (not found in file) - cannot answer call (hanging up)."
 NULL
 NOTELOG $F;"Unknown connection rate (had to hang up)"
 JMP :ERR2

:GETBIT CLC
 XCE
 REP $10
 SEP $20
 LDX #0
 LDY :Y
]LOOP CPY :ACTLEN
 BCS :EOBIT
 LDA (CADD6),Y
 INY
 AND #$7F
 CMP #$D
 BEQ :EOBIT
 CMP #'='
 BEQ :EOBIT
 CPX #80
 BCS ]LOOP ;Ignore rest of line (should NEVER be this long!)
 INX
 STA :LINE,X
 BRA ]LOOP
:EOBIT TXA
 STA :LINE
 STY :Y
 SEC
 XCE
 RTS

:ERRC PHA
 MLI_CLOSE :CPARMS
 PLA
:ERR STA :ERROR
 JSR PRINT
 CR
 CR
 COLOR PINK
 ASC "Error $"
 COLOR YELLOW
 HEX8 :ERROR
 COLOR PINK
 ASC " trying to use file '"
 PRSTRING :PATH
 ASC "' - cannot answer call (hanging up)."
 NULL
 LDA :ERROR
 STA MISCBUFF
 STZ MISCBUFF+1
 STZ MISCBUFF+2
 STZ MISCBUFF+3
 NOTELOGNUM $F;"Error using 'MODEM.CONNECT' file - error ";MISCBUFF
:ERR2 JSR PRINT
 COLOR WHITE
 NULL
 LDA #4
 STA :CNTR
]LOOP JSR HANGUP
 LDX #7
 JSR DELAY
 JSR GETSTRING ;Get next line from modem
 JSR :CHECKNC ;Got a 'NO CARRIER' type message?
 BCS :ERRFIN
 DEC :CNTR
 BNE ]LOOP
:ERRFIN SEC ;Not ok
 JMP :EXIT

:CHECKNC LDA $200 ;Look for 'NO CARRIER' type message
 BEQ :NO
 CMP NOCARRIERSTRING
 BNE :NO
 TAX
]LOOP2 LDA NOCARRIERSTRING,X
 AND #$7F
 CMP $200,X
 BNE :NO
 DEX
 BNE ]LOOP2
 SEC
 RTS
:NO CLC
 RTS

:EXIT RTS

:CNTR DS 2
:ERROR DS 2
:Y DS 2
:LINE DS 1+80
:PATH STR "FILES/MODEM.CONNECT"

:OPARMS DFB 3
 DA :PATH
 DA IOBUFFER
 DS 1

:RPARMS DFB 4
 DS 1
 DA MISCBUFF
 DA $200
:ACTLEN DS 2

:CPARMS DFB 1
 DS 1

READSTRINGS JSR CLOSEALL
 MLI_OPEN :OPARMS
 BCSL :ERR
 LDA :OPARMS+5
 STA :RPARMS+1
 STA :CPARMS+1
 MLI_READ :RPARMS
 BCC :ROK
 CMP #$4C
 BNEL :ERRC
:ROK MLI_CLOSE :CPARMS
 BCSL :ERRC
 LDA #<MISCBUFF
 STA CADD6
 LDA #>MISCBUFF
 STA CADD6+1
 LDY #0
 LDXA #OKSTRING
 JSR :GET
 LDXA #RINGSTRING
 JSR :GET
 LDXA #NOCARRIERSTRING
 JSR :GET
:ERRC MLI_CLOSE :CPARMS
:ERR RTS

:GET STXA CADD4
 STZ :LEN
]LOOP CPY :ACTLEN
 BCS :DONE
 LDA (CADD6),Y
 ORA #$80
 CMP #$8D
 BEQ :FIN
 CMP #" "
 BCC :NEXT
 JSR UPPER
 PHY
 INC :LEN
 LDY :LEN
 STA (CADD4),Y
 PLY
:NEXT INY
 BRA ]LOOP
:FIN INY
:DONE LDA :LEN
 BEQ :DONE2
 STA (CADD4)
:DONE2 RTS

:LEN DS 1

:OPARMS DFB 3
 DA :PATH
 DA IOBUFFER
 DS 1

:RPARMS DFB 4
 DS 1
 DA MISCBUFF
 DA $FF
:ACTLEN DS 2

:CPARMS DFB 1
 DS 1

:PATH STR "FILES/MODEM.STRINGS"

OKSTRING STR "OK" ;'OK' string from modem
 DS OKSTRING-*+41

RINGSTRING STR "RING" ;For an incoming call
 DS RINGSTRING-*+41

NOCARRIERSTRING STR "NO CARRIER" ;String expected upon no connection
 DS NOCARRIERSTRING-*+41

BAUDTABLE STR "dumbterm"
 STR "300"
 STR "1200"
 STR "2400"
 STR "4800"
 STR "7200"
 STR "9600"
 STR "12000"
 STR "14400"
 STR "19200"
 DFB 0

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/GAME.INIT
 fin

 END
