*-------------------------------
* GAME.INN
*-------------------------------
 DAT
 LST OFF

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE VARS
 USE PLR.DSECT
 USE LIB.JMP
 USE TABLES
 USE PN.DSECT
 USE SPELL.DSECT
 USE ITEM.DSECT

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/GAME.INN
 fin

 MODID "GAME.INN"

KPMAX = 6

START JSR PRINT
 NORMAL
 MTOFF
 HOME
 SOUND $1F;FOREVER;$50
 CURSOROFF
 INVERSE
 COLOR YELLOW
 ZAPLINE
 COLOR WHITE
 NORMAL
 CENTER " The Inn "
 GOTOXY 0;14
 INVERSE
 COLOR YELLOW
 ZAPLINE
 NORMAL
 GOTOXY 10;2
 COLOR WHITE
 CURSORON
 HTAB 10
 LINE "Add a party member"
 CR
 HTAB 10
 LINE "Remove a party member"
 CR
 HTAB 10
 LINE "Party stats"
 CR
 HTAB 10
 LINE "Trade stuff"
 CR
 HTAB 10
 LINE "Create/delete a character"
 CR
 HTAB 10
 LINE "Leave"
 GOTOXY 0;23
 CENTER "Use arrow keys to move pointer; [RETURN] to make selection."
 CURSOROFF
 NULL

DOKEY JSR DOPOINT

]LOOP JSR KEYIN
 JSR UPPER
 LDX :KEYS
]LOOP2 CMP :KEYS,X
 BEQ :GOTONE
 DEX
 BNE ]LOOP2
 LDX PNTR
 LDY #KPMAX
 JSR KPCHECK
 BCC ]LOOP
 STX PNTR
 BRA DOKEY
:GOTONE DEX
 TXA
 ASL
 TAX
 JMP (:TABLE,X)

:KEYS DFB :ENDKEYS-*-1
 DFB "K"-$40
 DFB "J"-$40
 DFB "M"-$40
:ENDKEYS

:TABLE DA UP
 DA DOWN
 DA DONE

UP LDA PNTR
 BNE :OK
 LDA #KPMAX
:OK DEC
 STA PNTR
 JMP DOKEY

DOWN LDA PNTR
 CMP #KPMAX-1
 BNE :OK
 LDA #$FF
:OK INC
 STA PNTR
 JMP DOKEY

DONE JSR PRINT
 CURSORLEFT
 ASC "x"
 NULL
 LDA PNTR
 ASL
 TAX
 JMP (:OPTIONS,X)

:OPTIONS DA ADD
 DA REMOVE
 DA STATS
 DA TRADE
 DA CRDEL
 DA LEAVE

DOPOINT LDA OLDPNTR
 ASL
 CLC
 ADC #2
 STA :CV+2
 JSR PRINT
 NORMAL
 MTOFF
 HTAB 8
:CV VTAB 0
 ASC " "
 NULL
 LDA PNTR
 ASL
 CLC
 ADC #2
 STA :CV2+2
 JSR PRINT
 HTAB 8
:CV2 VTAB 0
 NULL
 JSR SHOWPNTR
 LDA PNTR
 STA OLDPNTR
 RTS
PNTR DS 1
OLDPNTR DS 1

ADD LDX NUMPARTY
 DEX
]LOOP LDA CURPARTY2,X
 BNE :ANEXT
 LDA CURPARTY,X
 BEQ :OK
:ANEXT DEX
 BPL ]LOOP
 JSR PRINT
 GOTOXY 0;15
 CLEOS
 CURSORON
 COLOR PINK
 ASC "Your party is full. "
 SOUND $25;1;LOUD
 COLOR WHITE
 NULL
 GETRETURN
 JSR PRINT
 CURSOROFF
 ZAPLINE
 NULL
 JMP DOKEY
:OK JSR PRINT
 GOTOXY 0;15
 CLEOS
 NULL
 STZ :CNTR
 LDX #0
 STX :X ;Check each member of the party list
]LOOP LDA PARTY,X ; to see if they have been added already
 STA :REC ; If not, then display their name and add
 LDA PARTY2,X ; person to table
 STA :REC+1
 BNE :CHAR
 LDA :REC
 BEQ :NEXT
:CHAR LDY #0
]LOOP2 LDA CURPARTY,Y
 CMP :REC
 BNE :NEXT1
 LDA CURPARTY2,Y
 CMP :REC+1
 BEQ :NEXT ;There, so skip
:NEXT1 INY
 CPY NUMPARTY
 BNE ]LOOP2
 LDX :REC
 LDA :REC+1
 JSR LOADPLR
 BIT PLRARRESTFLAG ;In jail?
 BVS :NEXT
 LDA :CNTR ;Store number in table
 ASL
 TAX
 LDA :REC
 STA :TABLE,X
 LDA :REC+1
 STA :TABLE+1,X
 LDA :CNTR
 CLC
 ADC #15
 STA :V+3
 INC :CNTR
 JSR PRINT ;Show name
:V GOTOXY 40;16
 DEC8 :CNTR
 ASC ") "
 PRSTRING PLRNAME
 NULL
:NEXT INC :X
 LDX :X
 CPX NUMPARTY
 BNE ]LOOP
 JSR PRINT
 GOTOXY 0;15
 CURSORON
 NULL
 LDA :CNTR
 STA :CNTR2
 BNE :SOME
 JSR PRINT
 COLOR PINK
 ASC "None to add to party. "
 SOUND $02;1;LOUD
 COLOR WHITE
 NULL
 GETRETURN
:ESC JSR PRINT
 GOTOXY 0;15
 CURSOROFF
 CLEOS
 NULL
 JMP DOKEY
:SOME LDA :CNTR2
 BEQ :ESC
 JSR PRINT
 GOTOXY 0;15
 CURSORON
 ASC "Add (1-"
 DEC8 :CNTR
 ASC ")? : "
 NULL
]LOOP JSR KEYIN
 CMP #$9B
 BEQ :ESC
 SEC
 SBC #"1"
 CMP :CNTR
 BCS ]LOOP
 STA VTEMP
 JSR PRINT
 CURSOROFF
 NULL
 LDX #40
 LDY #41
 LDA #15
 CLC
 ADC VTEMP
 STA :V2+3
 JSR PICKLINE
 LDA $200
 CMP #" "
 BEQ :SOME
 LDY #0
]LOOP LDA CURPARTY2,Y
 BNE :NXT
 LDA CURPARTY,Y
 BEQ :PUT
:NXT INY
 CPY NUMPARTY
 BNE ]LOOP
 DEATH ;Should never happen
:PUT LDA VTEMP
 ASL
 TAX
 LDA :TABLE,X
 STA CURPARTY,Y
 STA :REC
 LDA :TABLE+1,X
 STA CURPARTY2,Y
 LDX :REC
 JSR LOADPLR
 JSR PRINT
:V2 GOTOXY 40;15
 CLEOL
 NULL
 DEC :CNTR2
 JMP :SOME
:X DS 1
:REC DS 2
:TABLE DS 8*2
:CNTR DS 1
:CNTR2 DS 1

TRADE CALL "GAME.TRADE"
 JSR PRINT
 SOUND $1F;FOREVER;$60
 NULL
 JMP DOKEY

CRDEL CALL "GAME.CRDEL"
 JMP START

REMOVE LDX NUMPARTY
 DEX
]LOOP LDA CURPARTY2,X
 BNE :OK
 LDA CURPARTY,X
 BNE :OK
 DEX
 BPL ]LOOP
 JSR PRINT
 GOTOXY 0;15
 CURSORON
 COLOR PINK
 ASC "No-one to remove. "
 SOUND $02;1;LOUD
 COLOR WHITE
 NULL
 GETRETURN
 JSR PRINT
 CURSOROFF
 ZAPLINE
 NULL
 JMP DOKEY
:OK JSR PRINT
 GOTOXY 0;15
 CLEOS
 NULL
 STZ :CNTR
 LDX #0
 STX :X
]LOOP LDA CURPARTY,X
 STA :REC
 LDA CURPARTY2,X
 STA :REC+1
 BNE :ROK
 LDA :REC
 BEQ :NEXT
:ROK LDX :REC
 LDA :REC+1
 JSR LOADPLR
 LDA PLRZPOS
 BNE :NEXT ;Not in Castle!
 LDA :CNTR ;Number in table
 ASL
 TAX
 LDA :REC
 STA :TABLE,X
 LDA :REC+1
 STA :TABLE+1,X
 LDA :CNTR
 CLC
 ADC #15
 STA :V+3
 INC :CNTR
 JSR PRINT ;Show name
 CURSORON
:V GOTOXY 40;17
 DEC8 :CNTR
 ASC ") "
 PRSTRING PLRNAME
 NULL
:NEXT INC :X
 LDX :X
 CPX NUMPARTY
 BNE ]LOOP
 LDA :CNTR
 BNE :INCSTLE
 JSR PRINT
 CURSORON
 COLOR PINK
 ASC "Nobody here. "
 SOUND $25;1;LOUD
 COLOR WHITE
 NULL
 GETRETURN
 JMP :ESC
:INCSTLE STA :CNTR2
:SOME LDA :CNTR2
 BEQ :ESC
 JSR PRINT
 GOTOXY 0;15
 CURSORON
 ASC "Remove (1-"
 DEC8 :CNTR
 ASC ")? : "
 NULL
]LOOP JSR KEYIN
 CMP #$9B
 BEQ :ESC
 SEC
 SBC #"1"
 CMP :CNTR
 BCS ]LOOP
 STA VTEMP
 JSR PRINT
 CURSOROFF
 NULL
 LDX #40
 LDY #41
 LDA #15
 CLC
 ADC VTEMP
 JSR PICKLINE
 LDA $200
 CMP #" "
 BEQ :SOME
 LDA VTEMP
 CLC
 ADC #15
 STA :V2+3
 LDA VTEMP
 ASL
 TAX
 LDY #0
]LOOP LDA CURPARTY,Y
 STA :REC
 CMP :TABLE,X
 BNE :NXT
 LDA CURPARTY2,Y
 STA :REC+1
 CMP :TABLE+1,X
 BEQ :GOTIT
:NXT INY
 CPY NUMPARTY
 BNE ]LOOP
 DEATH
:ESC JSR PRINT
 GOTOXY 0;15
 CURSOROFF
 CLEOS
 NULL
 JMP DOKEY
:GOTIT INY
 LDA CURPARTY,Y
 STA CURPARTY-1,Y
 LDA CURPARTY2,Y
 STA CURPARTY2-1,Y
 CPY NUMPARTY
 BNE :GOTIT
 LDA #0
 STA CURPARTY,Y
 STA CURPARTY2,Y
 LDX :REC
 LDA :REC+1
 JSR LOADPLR
 JSR PRINT
:V2 GOTOXY 40;15
 CLEOL
 NULL
 DEC :CNTR2
 JMP :SOME
:X DS 1
:REC DS 2
:TABLE DS 8*2
:CNTR DS 1
:CNTR2 DS 1

STATS JSR PRINT
 GOTOXY 0;15
 CLEOS
 NULL
 CALL "GAME.PLRSTAT"
 JMP DOKEY

LEAVE JSR PRINT
 HOME
 CURSORON
 NULL
 RETURN

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/GAME.INN
 fin

 END
