*-------------------------------
* GAME.LINKTP
*-------------------------------
 DAT
 LST OFF

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE VARS
 USE LIB.JMP
 USE PN.DSECT
 USE SCEN.DSECT

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/GAME.LINKTP
 fin

 MODID "GAME.LINKTP"

START STZ COMSPROG ;PFPE support
 STZ SOUNDFLAG ;PFPE sound
 STZ SPECFLAG ;IIgs special

 STZ :RETRY

 JSR PRINT
 HOME
 NULL

 LDA DUMBTERM
 PHA
 LDA #$FF
 STA DUMBTERM
 JSR PRINT
 ASC "Trying to link to user.."
 CURSOROFF
 NULL
 PLA
 STA DUMBTERM

:DO123 STZ :CNTR
]LOOP PAUSE 1
 LDX :CNTR
 LDA :OUTS,X
 JSR MSENDBYTE
 JSR :WAIT4IT
 BCCL :NOPE
 LDX :CNTR
 CMP :INS,X
 BNEL :NOPE
 INC :CNTR
 LDA :CNTR
 CMP :LIMIT
 BNE ]LOOP

 LDA #$FF
 STA COMSPROG
 NOTELOG $9;"* User has a Terminal Program *"

 LDA DUMBTERM
 PHA
 LDA #$FF
 STA DUMBTERM
 JSR PRINT
 CR
 CR
 LINE "User has a terminal program."
 NULL
 PLA
 STA DUMBTERM

 STZ :RETRY
 STZ :BADFLAG

:RLOOP PAUSE 1
 JSR GETALL

*-------------------------------------------------
 LDA DUMBTERM
 PHA
 LDA #$FF
 STA DUMBTERM
 JSR PRINT
 ASC "Sending revision level : "
 HEX8 REVBYTE
 ASC " "
 HEX8 HOSTREVLVL
 CR
 NULL
 PLA
 STA DUMBTERM
*-------------------------------------------------
 LDA REVBYTE ;Request revsion level from terminal program
 JSR MSENDBYTE
 LDA HOSTREVLVL ;Send our revision level
 JSR MSENDBYTE

 JSR :WAIT4IT ;Wait for response
 BCCL :WRONGV
 STA TPREVLVL
 LDX #0
]LOOP LDA :RLVLS,X
 BEQL :WRONGV ;Unknown or illegal version
 CMP TPREVLVL
 BEQ :GOTLVL
 INX
 BRA ]LOOP

:GOTLVL LDA :LVLWORDS,X
 ASL ;Get number of bytes
 STA :REVBYTES

 LDA DUMBTERM
 PHA
 LDA #$FF
 STA DUMBTERM
 JSR PRINT
 ASC "Known revision level : "
 HEX8 TPREVLVL
 CR
 NULL
 PLA
 STA DUMBTERM

 LDX :REVBYTES
 LDY #0
]LOOP STX :TEMPX
 STY :TEMPY
 JSR :WAIT4IT
 BCCL :WRONGV
 LDX :TEMPX
 LDY :TEMPY
 STA TPSUPPORT,Y
 INY
 DEX
 BNE ]LOOP
*-------------------------------------------------
 LDA DUMBTERM
 PHA
 LDA #$FF
 STA DUMBTERM
 JSR PRINT
 ASC "Received revision bytes : "
 HEX8 TPSUPPORT
 ASC " "
 HEX8 TPSUPPORT+1
 CR
 NULL
 PLA
 STA DUMBTERM
*-------------------------------------------------

 LDX :REVBYTES
 LDY #0
]LOOP STX :TEMPX
 STY :TEMPY
 JSR :WAIT4IT
 BCCL :WRONGV
 LDX :TEMPX
 LDY :TEMPY
 STA VTEMP,Y
 LDA TPSUPPORT,Y
 EOR #$FF
 CMP VTEMP,Y
 BEQ :YEAH
 LDA #$FF
 STA :BADFLAG
:YEAH INY
 DEX
 BNE ]LOOP
*-------------------------------------------------
 LDA DUMBTERM
 PHA
 LDA #$FF
 STA DUMBTERM
 JSR PRINT
 ASC "Received revision XOR bytes : "
 HEX8 VTEMP
 ASC " "
 HEX8 VTEMP+1
 CR
 NULL
 PLA
 STA DUMBTERM
*-------------------------------------------------
 BIT :BADFLAG
 BPL :LVLOK
 LDA :RETRY
 EOR #$FF
 STA :RETRY
 BMIL :RLOOP
 JMP :WRONGV

:LVLOK LDA TPSUPPORT+1
 AND #%0000_0100
 BEQL :DOCONFIG

*-------------------------------------------------
 LDA DUMBTERM
 PHA
 LDA #$FF
 STA DUMBTERM
 JSR PRINT
 ASC "Getting TP version pstring"
 CR
 NULL
 PLA
 STA DUMBTERM
*-------------------------------------------------
 STZ :CNTR ;get "configuration (pstring)"
]LOOP JSR :WAIT4IT ;Check to see if it's the same
 BCCL :WRONGV
 LDX :CNTR
 AND #$7F
 STA :TPVER,X
 INC :CNTR
 LDA :CNTR
 CMP :TPVER
 BCC ]LOOP
 BEQ ]LOOP

*-------------------------------------------------
 LDA DUMBTERM
 PHA
 LDA #$FF
 STA DUMBTERM
 JSR PRINT
 ASC "Getting serial number, ROM version and pstring"
 CR
 NULL
 PLA
 STA DUMBTERM
*-------------------------------------------------
 STZ :CNTR ;Get serial number stuff
]LOOP JSR :WAIT4IT
 BCCL :WRONGV
 LDX :CNTR
 STA SNBITS,X
 INC :CNTR
 LDA :CNTR
 CMP #2+1+1+65
 BNE ]LOOP

 LDX SNBITS+3 ;Make sure 'prefix' is hi ASCII
]LOOP CPX #0
 BEQ :PUDONE
 LDA SNBITS+3,X
 ORA #$80
 STA SNBITS+3,X
 DEX
 BRA ]LOOP
:PUDONE
 LDA SNBITS+2
 CMP #$10 ;MAC?
 BEQ :SKIPTPVER
 CMP #$20 ;IBM?
 BEQ :SKIPTPVER
 STZ :CNTR
]LOOP LDX :CNTR
 LDA :TPVER,X
 CMP TPVER,X
 BNEL :WRONGV
 INC :CNTR
 LDA :CNTR
 CMP TPVER
 BCC ]LOOP
 BEQ ]LOOP
:SKIPTPVER

*-------------------------------------------------
 LDA DUMBTERM
 PHA
 LDA #$FF
 STA DUMBTERM
 JSR PRINT
 ASC "Serial number "
 HEX16 SNBITS
 ASC ", ROM "
 HEX8 SNBITS+2
 LINE " machine."
 ASC "Prefix : "
 PRSTRING SNBITS+3
 CR
 NULL
 PLA
 STA DUMBTERM
*-------------------------------------------------
 JSR LOGSTUFF ;Log "Serial number xxxx, ROM xx machine" & prefix

 LDA SNBITS ;Check serial number
 ORA SNBITS+1
 BNE :HASN

 INCR SERIAL

 LDA #$FF ;No serial number, so give it one
 JSR MSENDBYTE
 LDA SERIAL
 JSR MSENDBYTE
 LDA SERIAL+1
 JSR MSENDBYTE

 LDA DUMBTERM
 PHA
 LDA #$FF
 STA DUMBTERM
 JSR PRINT
 ASC "Given serial number "
 HEX16 SERIAL
 CR
 NULL
 PLA
 STA DUMBTERM
 JSR LOGSTUFF2 ;Log "Given serial number xxxx"

 JSR :WAIT4IT

 BRA :SYSINFO

:HASN LDA #0 ;No update to serial number
 JSR MSENDBYTE

*
* Send system info :
*
* - system name (pstring)
* - scenario name (pstring)
* - party name user logged on as (pstring)
*
:SYSINFO LDX PARTYNUM
 BEQ :SICONT
 LDA #0
 JSR LOADPN
 LDX PNSCENARIO
 LDA #0
 JSR LOADSCEN
:SICONT LDA #INFOBYTE ;Send system info
 JSR MSENDBYTE
 LDA SYSTEMNAME ;System name
 JSR MSENDBYTE
 LDX #0
]LOOP CPX SYSTEMNAME
 BEQ :SI2
 PHX
 LDA SYSTEMNAME+1,X
 AND #$7F
 JSR MSENDBYTE
 PLX
 INX
 BRA ]LOOP
:SI2 LDA SCNAME ;Scenario name
 JSR MSENDBYTE
 LDX #0
]LOOP CPX SCNAME
 BEQ :SI3
 PHX
 LDA SCNAME+1,X
 AND #$7F
 JSR MSENDBYTE
 PLX
 INX
 BRA ]LOOP
:SI3 LDA PNNAME
 JSR MSENDBYTE
 LDX #0
]LOOP CPX PNNAME
 BEQ :SI4
 PHX
 LDA PNNAME+1,X
 AND #$7F
 JSR MSENDBYTE
 PLX
 INX
 BRA ]LOOP
:SI4 JSR :WAIT4IT ;Wait for OK
* BCCL :NOPE
* CMP #0
* BNEL :NOPE

 LDA DUMBTERM
 PHA
 LDA #$FF
 STA DUMBTERM
 JSR PRINT
 CR
 LINE "User has latest TC II Terminal Program"
 NULL
 PLA
 STA DUMBTERM

:DOCONFIG LDA TPSUPPORT+1
 AND #%0000_0001 ;Is sound supported?
 BEQ :NOSOUND
 LDA #$FF
 HEX 2C
:NOSOUND LDA #0
 STA SOUNDFLAG
 STA PNSOUNDL
 STA PNSOUNDS

 LDA TPSUPPORT
 AND #%1000_0000 ;IIgs special?
 BEQ :NOSPEC
 LDA #$FF
 HEX 2C
:NOSPEC LDA #0
 STA SPECFLAG

 LDA TPSUPPORT
 AND #%0000_0001 ;PFP?
 BEQL :NOPFP

* LDA SNBITS+2
* CMP #$10 ;MAC?
* BNE :ZX
* STZ COMSPROG ;PFPE support
* STZ SOUNDFLAG ;PFPE sound
* STZ SPECFLAG ;IIgs special
:ZX JMP :EXIT

:WRONGV STZ COMSPROG ;PFPE support
 STZ SOUNDFLAG ;PFPE sound
 STZ SPECFLAG ;IIgs special

 LDX :REVBYTES
]LOOP CPX #0
 BEQ :RVDONE
 STZ TPSUPPORT-1,X
 DEX
 BRA ]LOOP

:RVDONE LDA DUMBTERM
 PHA
 LDA #$FF
 STA DUMBTERM
 JSR PRINT
 CR
 LINE "Unknown / incorrect version"
 NULL
 PLA
 STA DUMBTERM

 PAUSE 6

 JSR GETALL
 JSR PRINT
 NORMAL
 MTOFF
 CURSORON
 HOME
 ASC "You are connected to The Complex gaming system."
 CR
 CR
 ASC "The Terminal Program you are using now is NOT the latest "
 ASC "version. You MUST use this if you are going to use the "
 ASC "system to it's full potential."
 CR
 CR
 ASC "Current version : "
 QUOTE
 PRSTRING TPVER
 QUOTE
 NULL
 JMP :GOGET

:NOPFP JSR GETALL
 JSR PRINT
 NORMAL
 MTOFF
 CURSORON
 HOME
 ASC "You are connected to The Complex gaming system."
 CR
 CR
 ASC "The Terminal Program you are using does not support the "
 ASC "Pascal Firmware Protocol (PFP 1.1). This is the minimum "
 ASC "requirement to use the system."
 NULL
 JMP :GOGET

:NOPE LDA :RETRY
 EOR #$FF
 STA :RETRY
 BMIL :DO123
:SAYIT JSR GETALL
 JSR PRINT
 NORMAL
 MTOFF
 CURSORON
 HOME
 ASC "You are connected to The Complex gaming system."
 CR
 CR
 ASC "To make full use of the system, you should use The Complex "
 ASC "Terminal Program, or use a program that interprets the "
 ASC "Pascal Firmware Protocol (PFP 1.1)."
 CR
 CR
 ASC "The terminal program is not essential, but highly "
 ASC "recommended (for the Apple IIgs, //e, //c, or the Macintosh)."
 ASC " The Apple IIgs version supports super hi-res graphics and "
 ASC "digitized sound."
 CR
 NULL
:GOGET JSR PRINT
 CR
 CR
 LINE "You may : A) Download the Terminal Program (using XMODEM)"
 LINE "          B) Try to 'link' to the system (Terminal Program)"
 LINE "          C) Continue on (logon)"
 LINE "          D) Leave (logoff).."
 CR
 ASC "Select an option : "
 NULL
]LOOP GETLINE #1
 CPX #0
 BEQ ]LOOP
 LDA $200
 JSR UPPER
 CMP #"A"
 BEQ :DOWNIT
 CMP #"B"
 BEQ :TRY
 CMP #"C"
 BEQL :EXIT
 CMP #"D"
 BEQ :BYE
 JMP :GOGET

:BYE JSR PRINT
 HOME
 LINE "Goodbye.."
 PRPAUSE 1
 NULL
 JMP DROP

:TRY JSR PRINT
 HOME
 NULL
 JMP START

:DOWNIT JSR PRINT
 PRPAUSE 1
 NULL
 CALL "GAME.XSEND"
 JSR PRINT
 HOME
 ASC "Run the terminal program now. When you are ready to start, "
 ASC "press [ESC].."
 NULL
]LOOP JSR KEYIN
 CMP #$9B
 BNE ]LOOP
 JSR PRINT
 HOME
 NULL
 JMP START

:RETRY DS 1

:BADFLAG DS 1
:REVBYTES DS 1

:TEMPX DS 1
:TEMPY DS 1

:EXIT JSR CLOSEALL
 RETURN

:WAIT4IT STZ :WCNTR
 STZ :WCNTR+1
]LOOP JSR CHECKIN2 ;Get a character in from modem?
 BCS :YES
 LDA $C019
 BPL ]LOOP
 INCR :WCNTR
 LDA :WCNTR
 BNE ]LOOP
 LDA :WCNTR+1
 BPL ]LOOP
 CLC
 RTS
:YES SEC
 RTS
:WCNTR DS 2

:CNTR DS 1
:LIMIT DFB 3
:OUTS DFB $01,$02,$03
:INS DFB $81,$82,$83

:RLVLS DFB $10
 DFB 0
:LVLWORDS DFB 1

:TPVER DS 1+255

TPVER STR '2.2' ;Make sure this is in TP.VARS as well!

REVBYTE DFB $85

HOSTREVLVL DFB $10 ;Host revision level 1.0

SNBITS DS 2+1+1+65

LOGSTUFF LDY #0
 INY
 LDX #0
]LOOP LDA :STR1+1,X
 STA MISCBUFF,Y
 INY
 INX
 CPX :STR1
 BNE ]LOOP

 LDA SNBITS+1
 JSR CONVERT
 STA MISCBUFF,Y
 INY
 TXA
 STA MISCBUFF,Y
 INY
 LDA SNBITS
 JSR CONVERT
 STA MISCBUFF,Y
 INY
 TXA
 STA MISCBUFF,Y
 INY
 LDX #0
]LOOP LDA :STR2+1,X
 STA MISCBUFF,Y
 INY
 INX
 CPX :STR2
 BNE ]LOOP
 LDA SNBITS+2
 JSR CONVERT
 STA MISCBUFF,Y
 INY
 TXA
 STA MISCBUFF,Y
 INY
 LDX #0
]LOOP LDA :STR3+1,X
 STA MISCBUFF,Y
 INY
 INX
 CPX :STR3
 BNE ]LOOP
 DEY
 STY MISCBUFF
 NOTELOGBUFF $9;MISCBUFF

 LDA SNBITS+3 ;Prefix?
 BEQ :EXIT
 NOTELOGSTR $9;"Prefix ";SNBITS+3

:EXIT RTS

:STR1 STR "Serial number "
:STR2 STR ", ROM "
:STR3 STR " machine"

LOGSTUFF2 LDY #0
 INY
 LDX #0
]LOOP LDA :STR1+1,X
 STA MISCBUFF,Y
 INY
 INX
 CPX :STR1
 BNE ]LOOP

 LDA SERIAL+1
 JSR CONVERT
 STA MISCBUFF,Y
 INY
 TXA
 STA MISCBUFF,Y
 INY
 LDA SERIAL
 JSR CONVERT
 STA MISCBUFF,Y
 INY
 TXA
 STA MISCBUFF,Y
 STY MISCBUFF
 NOTELOGBUFF $9;MISCBUFF
 RTS

:STR1 STR "Given serial number "

CONVERT PHA
 AND #$0F
 JSR :DO
 TAX
 PLA
 LSR
 LSR
 LSR
 LSR
:DO ORA #"0"
 CMP #":"
 BCC :SKIP
 ADC #6
:SKIP RTS

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/GAME.LINKTP
 fin

 END
