*-------------------------------
* GAME.MOVE
*-------------------------------
 DAT
 LST OFF

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE VARS
 USE LIB.JMP
 USE PLR.DSECT
 USE ST.DSECT
 USE MON.DSECT
 USE MON2.DSECT
 USE PN.DSECT
 USE ITEM2.DSECT

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/GAME.MOVE
 fin

 MODID "GAME.MOVE"

START LDX NUMPARTY
]LOOP LDA CURPARTY2-1,X
 BNE :GOTP
 LDA CURPARTY-1,X
 BNE :GOTP
 DEX
 BPL ]LOOP
:GOTP STX NPRTY

 LDA MPLR
 STA INDIV
 LDA MPLR+1
 STA INDIV+1
 LDX MPLR
 LDA MPLR+1
 JSR LOADPLR

 LDX PLRZPOS
 JSR LDMAP
 LDX PLRZPOS
 JSR LDMAP2
 JSR PRINT
 GOTOXY 0;14
 CURSOROFF
 COLOR ORANGE
 CENTER " Movement "
 COLOR YELLOW
 CR
 COLOR AQUAMARINE
 CURSORON
 LINE " 7 8 9"
 LINE "  \|/"
 LINE " 4-x-6"
 LINE "  /|\"
 LINE " 1 2 3"
 COLOR WHITE
 GOTOXY 10;15
 ASC "[V]iew :"
 GOTOXY 10;16
 ASC "[P]ull/drag"
 GOTOXY 10;17
 ASC "[H]elp   [E]xit"
 GOTOXY 10;18
 ASC "[RETURN]-move"
 NULL

 LDA #4
 STA XLOC
 STA YLOC

TOP JSR PRINT
 GOTOXY 10;19
 CURSORON
 ASC "Points left : "
 NULL
 LDX MPLR
 LDA MPLR+1
 JSR LOADPLR
 LDA PLRXPOS ;Record player pos
 STA VTEMP ; to check if everyone else in the party
 LDA PLRYPOS ; are all in the same square
 STA VTEMP+1 ; for a 'group' move
 LDX #0
 LDY #0
]LOOP PHX
 STX :PN
 PHY
 LDA CURPARTY,X
 TAY
 LDA CURPARTY2,X
 TYX
 JSR LOADPLR
 INC :PN
 JSR PRINT
 ASC "#"
 COLOR YELLOW
 DEC8 :PN
 COLOR WHITE
 MTON
 INVERSE
 ASC "I"
 NORMAL
 MTOFF
 COLOR PINK
 DEC8NEG PLRCURRPNTS
 COLOR WHITE
 NULL
 LDA PLRCOND
 AND #%1100_1001 ;Can you physically move?
 BEQ :FINE
 PLY
 INY
 PHY
:FINE LDA PLRCURRPNTS
 DEC
 BMI :NOTSAME ;Action points 0 or negative?
 LDA PLRZPOS ;We all in the same square?
 CMP MAPLVL
 BNE :NOTSAME
 LDA PLRXPOS
 CMP VTEMP
 BNE :NOTSAME
 LDA PLRYPOS
 CMP VTEMP+1
 BNE :NOTSAME
 LDA PLRARRESTFLAG
 BPL :PLUS2
:NOTSAME LDA #$FF ;...no.
 STA MOVETYPE ;Movement now 'individual'
:PLUS2 PLY
 PLX
 INX
 CPX NPRTY
 BEQ :PNTSOK
 JSR PRINT
 MTON
 INVERSE
 ASC "Z_"
 NORMAL
 MTOFF
 NULL
 BRA ]LOOP
:PN DS 1

:PNTSOK JSR PRINT
 CLEOL
 NULL

 LDA NPRTY
 CMP #1
 BEQ :IND ;1 person doesn't make a group
 LDA MOVETYPE ;Group or individual?
 BPL :GRP
:IND LDX INDIV
 LDA INDIV+1
 JSR LOADPLR
 JSR PRINT
 GOTOXY 19;15
 CLEOL
 PRSTRING PLRNAME
 NULL
 LDA #$FF ;Force individual - can get here is only one person
 STA MOVETYPE ; is in the party (group of 1)
 BRA :GO
:GRP CPY NPRTY ;Everyone in party is in same square
 BNE :PCONT
 LDA #$FF
 STA MOVETYPE
 BRA :IND
:PCONT JSR PRINT
 GOTOXY 19;15
 CLEOL
 ASC "<"
 COLOR AQUAMARINE
 ASC "group"
 COLOR WHITE
 ASC ">"
 CLEOL
 NULL

:GO LDX PLRXPOS
 LDY PLRYPOS
 JSR GETMAP
 CMP #SHPSTAIRS
 BNE :NONE
 CPX #STAIRSUP
 BEQ :UP
 CPX #STAIRSDOWN
 BNE :NONE
 JSR PRINT
 GOTOXY 40;16
 CLEOL
 ASC "[D]own"
 NULL
 BRA :GO2
:UP JSR PRINT
 GOTOXY 40;16
 CLEOL
 ASC "[U]p"
 NULL
 BRA :GO2
:NONE JSR PRINT
 GOTOXY 40;16
 CLEOL
 NULL

:GO2 JSR SHOWTHEMAP

GETCMD JSR PRINT
 GOTOXY 68;12
 CLEOL
 CURSORON
 NULL
 LDA PREVSND ;Pending sound?
 BEQ :CONT
 CMP #1 ;Footsteps
 BNE :NO
* JSR PRINT
* SOUND $1B;1;LOUD
* NULL
 BRA :CONT
:NO CMP #2 ;Water slosh?
 BNE :CONT
* JSR PRINT
* SOUND $26;1;LOUD
* NULL
:CONT STZ PREVSND
 BIT DRAGFLAG
 BPL GETKEY
 LDX MPLR
 LDA MPLR+1
 JSR LOADPLR
 STZ DRAGFLAG
 JMP START

GETKEY LDA PLRXPOS
 SEC
 SBC #4
 STA ANKX
 LDA PLRYPOS
 SEC
 SBC #4
 STA ANKY

 STZ CNTR

KEYTOP STZ STPORT
 STZ DRAGFLAG
 JSR PRINT
 GOTOXY 68;12
 CLEOL
 INVERSE
 ASC " "
 NORMAL
 CURSOROFF
 NULL
]LOOP JSR TICKTOCK
 JSR WAITIN
 BCS :YES2
 JSR GETLOC
 JSR DOSPC
 JSR WAITIN
 BCS :YES
 JSR GETLOC
 JSR DOSHP
 JMP ]LOOP
:YES PHA
 JSR GETLOC
 JSR DOSHP
 PLA
 JMP GOTKEY
:YES2 PHA
 JSR GETLOC
 JSR DOSPC
 PLA
 BRA :YES

WAITIN STZ :FLAG
 STZ :CNTR
 STZ :CNTR2
]LOOP BIT DUMBTERM
 BMI :OVER
 JSR CHECKCTRLX
 JSR CHECKIN ;Did we get something from the modem?
 BCS :KEY
:OVER LDA $C000
 BMI :KEY
 BIT :FLAG
 BMI :MINUS
:PLUS LDA $C019
 BPL ]LOOP
 LDA #$FF
 STA :FLAG
 BRA ]LOOP
:MINUS LDA $C019
 BMI ]LOOP
 INC :CNTR
 LDA :CNTR
 BNE ]LOOP
 INC :CNTR2
 LDA :CNTR2
 CMP #16
 BNE ]LOOP
 CLC
 RTS
:KEY SEC
 RTS
:FLAG DS 1
:CNTR DS 1
:CNTR2 DS 1

GETLOC LDA ANKX
 CLC
 ADC XLOC
 TAX
 LDA ANKY
 CLC
 ADC YLOC
 TAY
 JSR GETMAP
 LDX XLOC
 LDY YLOC
 RTS

GOTKEY STA $C010
 PHA
 JSR INITCNTR
 JSR PRINT
 MTOFF
 NORMAL
 COLOR WHITE
 NULL
 PLA
 JSR UPPER
 LDX :KEYS
]LOOP2 CMP :KEYS,X
 BEQ :GOTONE
 DEX
 BNE ]LOOP2
 CMP #"1"
 BCCL KEYTOP
 CMP #"9"+1
 BCSL KEYTOP
:KEYUP SEC
 SBC #"1"
 ASL
 TAX
 LDA XLOC
 LDY YLOC
 JMP (:NKEYS,X)
:GOTONE DEX
 TXA
 ASL
 TAX
 JMP (:TABLE,X)

:KEYS DFB :ENDKEYS-*-1
 DFB "H"
 DFB "E"
 DFB "U"
 DFB "D"
 DFB "V"
 DFB $9B
 DFB "H"-$40
 DFB "U"-$40
 DFB "J"-$40
 DFB "K"-$40
 DFB "P"
 DFB "W"-$40
 DFB "M"-$40
:ENDKEYS

:TABLE DA HELP
 DA EXIT
 DA UP
 DA DOWN
 DA MOVET
 DA EXIT
 DA :KEY4
 DA :KEY6
 DA :KEY2
 DA :KEY8
 DA PULLDRAG
 DA :REFRESH
 DA MOVEIT

:KEY4 LDA #"4"
 BRA :KEYUP
:KEY6 LDA #"6"
 BRA :KEYUP
:KEY2 LDA #"2"
 BRA :KEYUP
:KEY8 LDA #"8"
 BRA :KEYUP

:NKEYS DA KEY1
 DA KEY2
 DA KEY3
 DA KEY4
 DA KEY5
 DA KEY6
 DA KEY7
 DA KEY8
 DA KEY9

:REFRESH JSR REFRESH
 JMP TOP

MOVEIT LDA YLOC
 SEC
 SBC #3
 TAY
 LDA #0
]LOOP CPY #0
 BEQ :DONE
 CLC
 ADC #3
 DEY
 BRA ]LOOP
:DONE CLC
 ADC XLOC
 SEC
 SBC #3
 ASL
 TAX
 JMP (:TBL,X)

:TBL DA GO7
 DA GO8
 DA GO9
 DA GO4
 DA GO5
 DA GO6
 DA GO1
 DA GO2
 DA GO3

KEY1 DEC
 INY
 BRA DOKEY

KEY2 INY
 BRA DOKEY

KEY3 INC
 INY
 BRA DOKEY

KEY4 DEC
 BRA DOKEY

KEY5 JMP KEYTOP

KEY6 INC
 BRA DOKEY

KEY7 DEC
 DEY
 BRA DOKEY

KEY8 DEY
 BRA DOKEY

KEY9 INC
 DEY
 BRA DOKEY

DOKEY CMP #9
 BCS :NOX
 STA XLOC
:NOX CPY #9
 BCS :NOY
 STY YLOC
:NOY LDA XLOC
 CMP #3
 BCS :X2
 LDA #3
 STA XLOC
:X2 CMP #6
 BCC :Y1
 LDA #5
 STA XLOC
:Y1 LDA YLOC
 CMP #3
 BCS :Y2
 LDA #3
 STA YLOC
:Y2 CMP #6
 BCC :FIN
 LDA #5
 STA YLOC
:FIN JMP KEYTOP

PULLDRAG LDA PLRXPOS
 STA :X
 LDA PLRYPOS
 STA :Y
 LDA PLRZPOS
 STA :Z
 LDX #0
 LDA #0
 JSR LOADPLR
 LDA PLRBUFF
 STA :CNTR
 LDA PLRBUFF+1
 STA :CNTR+1
 STZ :INDX
 STZ :INDX+1
]LOOP LDA :CNTR ;Read all players in this square into a table
 ORA :CNTR+1
 BEQ :DONE
 LDA :CNTR+1
 CMP INDIV+1
 BNE :PLOK
 LDA :CNTR
 CMP INDIV
 BEQ :NEXT
:PLOK LDX :CNTR
 LDA :CNTR+1
 JSR LOADPLR
 LDA PLRFREE
 BMI :NEXT
 LDA PLRXPOS
 CMP :X
 BNE :NEXT
 LDA PLRYPOS
 CMP :Y
 BNE :NEXT
 LDA PLRZPOS
 CMP :Z
 BNE :NEXT
 LDA PLRCOND
 AND #%1100_1000 ;Can you physically move?
 BEQ :NEXT
 CLC
 XCE
 REP #$30
 LDA :INDX
 ASL
 TAX
 LDA :CNTR
 STA :TABLE,X
 INC :INDX
 SEC
 XCE
:NEXT DECR :CNTR
 BRA ]LOOP

:DONE STZ :LINE
 STZ :OLDLINE
 LDA #1
 STA :CNTR
 STZ :CNTR+1
 LDA :INDX
 ORA :INDX+1
 BNE :YEPOK
 JSR CLRBOT
 JSR PRINT
 CURSORON
 COLOR PINK
 ASC "No-one to drag. "
 SOUND $13;1;LOUD
 COLOR WHITE
 NULL
 GETRETURN
 BRA :EXIT

:YEPOK JSR :SHOWBIT
 JSR PRINT
 GOTOXY 0;15
 CURSORON
 LINE "Use arrow keys to move pointer;"
 LINE "[RETURN]-drag, [ESC]-exit"
 CURSOROFF
 NULL
]TOPLOOP JSR :DOPOINT
]KEYLOOP JSR KEYIN
 CMP #$9B
 BEQ :EXIT
 CMP #"J"-$40
 BEQ :DOWN
 CMP #"K"-$40
 BEQ :UP
 CMP #$8D
 BEQL :DRAG
 BRA ]KEYLOOP

:EXIT JSR PRINT
 CURSORON
 NULL
 JSR CLRBOT
 LDX MPLR
 LDA MPLR+1
 JSR LOADPLR
 JMP START

:UP LDA :LINE
 BEQ :UPZ
 DEC :LINE
 DECR :CNTR
 JMP ]TOPLOOP
:UPZ LDA :CNTR+1
 BNE :UPOK
 LDA :CNTR
 CMP #1
 BNE :UPOK
 JMP ]KEYLOOP
:UPOK LDA :CNTR
 SEC
 SBC #8
 STA :CNTR
 LDA :CNTR+1
 SBC #0
 STA :CNTR+1
 LDA #7
 STA :LINE
 JMP :YEPOK

:DOWN LDA :LINE
 CMP #7
 BEQ :DOWNZ
 LDA :CNTR+1
 CMP :INDX+1
 BNE :DOWNOK1
 LDA :CNTR
 CMP :INDX
 BNE :DOWNOK1
 JMP ]KEYLOOP
:DOWNOK1 INC :LINE
 INCR :CNTR
 JMP ]TOPLOOP
:DOWNZ LDA :CNTR+1
 CMP :INDX+1
 BNE :DOWNOK
 LDA :CNTR
 CMP :INDX
 BNE :DOWNOK
 JMP ]KEYLOOP
:DOWNOK STZ :LINE
 INCR :CNTR
 JMP ]TOPLOOP

:DRAG CLC
 XCE
 REP #$30
 LDA :CNTR
 DEC
 ASL
 TAX
 LDA :TABLE,X
 PHA
 SEC
 XCE
 PLX
 STX DRAGPLR
 PLA
 STA DRAGPLR+1
 JSR LOADPLR
 JSR CLRBOT
 JSR PRINT
 CURSORON
 ASC "Drag "
 PRSTRING PLRNAME
 ASC " (y/N)? : "
 NULL
 JSR KEYIN
 JSR UPPER
 CMP #"Y"
 BNEL :DONE
 JSR CLRBOT
 JSR PRINT
 COLOR AQUAMARINE
 LINE " 7 8 9"
 LINE "  \|/"
 LINE " 4-x-6"
 LINE "  /|\"
 LINE " 1 2 3"
 COLOR WHITE
 NULL
 LDX PLRXPOS
 LDY PLRYPOS
 JSR GETMAP
 CMP #SHPSTAIRS
 BNE :GO2
 CPX #STAIRSUP
 BEQ :SHUP
 CPX #STAIRSDOWN
 BNE :GO2
:SHDOWN JSR PRINT
 GOTOXY 40;16
 CLEOL
 ASC "[D]own"
 NULL
 BRA :GO2
:SHUP JSR PRINT
 GOTOXY 40;16
 CLEOL
 ASC "[U]p"
 NULL
:GO2 JSR PRINT
 GOTOXY 20;15
 ASC "Drag "
 COLOR GREEN
 PRSTRING PLRNAME
 COLOR WHITE
 ASC " in which direction? : "
 NULL
 LDX INDIV
 LDA INDIV+1
 JSR LOADPLR
 LDA #$FF
 STA DRAGFLAG
]LOOP JSR KEYIN
 JSR UPPER
:KEYDIR LDX :KEYS
]LOOP2 CMP :KEYS,X
 BEQ :GOTONE
 DEX
 BNE ]LOOP2
 BRA ]LOOP
:GOTONE CPX #10
 BCS :GOTONE2
 PHX
 TXA
 ORA #"0"
 JSR COUT
 PLX
:GOTONE2 DEX
 TXA
 ASL
 TAX
 JMP (:KEYTBL,X)

:KEYS DFB :ENDKEYS-*-1
 DFB "1"
 DFB "2"
 DFB "3"
 DFB "4"
 DFB "5"
 DFB "6"
 DFB "7"
 DFB "8"
 DFB "9"
 DFB "U"
 DFB "D"
 DFB $9B
 DFB "H"-$40
 DFB "U"-$40
 DFB "J"-$40
 DFB "K"-$40
:ENDKEYS

:KEYTBL DA GO1
 DA GO2
 DA GO3
 DA GO4
 DA GO5
 DA GO6
 DA GO7
 DA GO8
 DA GO9
 DA :DUP
 DA :DDOWN
 DA :DONE
 DA :DGO4
 DA :DGO6
 DA :DGO2
 DA :DGO8

:DGO4 LDA #"4"
 HEX 2C
:DGO6 LDA #"6"
 HEX 2C
:DGO2 LDA #"2"
 HEX 2C
:DGO8 LDA #"8"
 JMP :KEYDIR

:DUP JSR PRINT
 ASC "U"
 NULL
 JMP UP
:DDOWN JSR PRINT
 ASC "D"
 NULL
 JMP DOWN

:DOPOINT LDA :OLDLINE
 CLC
 ADC #15
 STA :V+3
 JSR PRINT
:V GOTOXY 38;0
 ASC " "
 NULL
 LDA :LINE
 CLC
 ADC #15
 STA :V2+3
 JSR PRINT
:V2 GOTOXY 38;0
 NULL
 LDA :LINE
 STA :OLDLINE
 JMP SHOWPNTR
:LINE DS 1
:OLDLINE DS 1

:SHOWBIT JSR CLRBOT
 LDA :CNTR
 PHA
 LDA :CNTR+1
 PHA
]LOOP CLC
 XCE
 REP #$30
 LDA :CNTR
 CMP :INDX
 BEQ :BITOK
 BCS :FIN
:BITOK LDA :CNTR
 DEC
 ASL
 TAX
 LDA :TABLE,X
 PHA
 SEC
 XCE
 PLX
 PLA
 JSR LOADPLR
 JSR PRINT
 HTAB 40
 DEC16 :CNTR
 ASC ") "
 PRSTRING PLRNAME
 CR
 NULL
 INC :CNTR
 LDA CV
 CMP #23
 BNE ]LOOP
:FIN SEC
 XCE
 PLA
 STA :CNTR+1
 PLA
 STA :CNTR
 RTS

:X DS 1
:Y DS 1
:Z DS 1
:INDX DS 2
:CNTR DS 2
:NUM DS 2
:TABLE DS $200

DRAGFLAG DFB 0 ;Dragging someone
DRAGPLR DS 2 ;Plr being dragged

GO1 LDX #-1
 LDY #1
 JMP GOGO

GO2 LDX #0
 LDY #1
 JMP GOGO

GO3 LDX #1
 LDY #1
 JMP GOGO

GO4 LDX #-1
 LDY #0
 JMP GOGO

GO5 JMP KEYTOP

GO6 LDX #1
 LDY #0
 JMP GOGO

GO7 LDX #-1
 LDY #-1
 LDA #7
 JMP GOGO

GO8 LDX #0
 LDY #-1
 JMP GOGO

GO9 LDX #1
 LDY #-1
 JMP GOGO

UP LDA MOVETYPE
 BPL :GROUP
 LDA PLRCURRPNTS
 DEC
 BMI :NOGO ;Action points 0 or negative?
 LDA PLRCOND
 AND #%1100_1001 ;Can you physically move?
 BEQ :GROUP
 JSR PRINT
 GOTOXY 10;21
 CLEOL
 COLOR PINK
 ASC "You cannot move."
 SOUND $13;1;LOUD
 COLOR WHITE
 NULL
 JMP GETCMD
:NOGO JSR PRINT
 GOTOXY 10;21
 CLEOL
 COLOR PINK
 ASC "No points left."
 SOUND $13;1;LOUD
 COLOR WHITE
 NULL
 JMP GETCMD
:GROUP LDX PLRXPOS
 LDY PLRYPOS
 JSR GETMAP
 CMP #SHPSTAIRS
 BNEL GETCMD
 CPX #STAIRSUP
 BNEL GETCMD
 STX SHAPETYPE
 JSR GETST
 LDA #$FF
 STA STPORT
 JMP GOSHP2

DOWN LDA MOVETYPE
 BPL :GROUP
 LDA PLRCURRPNTS
 DEC
 BMI :NOGO ;Action points 0 or negative?
 LDA PLRCOND
 AND #%1100_1001 ;Can you physically move?
 BEQ :GROUP
 JSR PRINT
 GOTOXY 10;21
 CLEOL
 COLOR PINK
 ASC "You cannot move."
 SOUND $02;1;LOUD
 COLOR WHITE
 NULL
 JMP GETCMD
:NOGO JSR PRINT
 GOTOXY 10;21
 CLEOL
 COLOR PINK
 ASC "No points left."
 SOUND $02;1;LOUD
 COLOR WHITE
 NULL
 JMP GETCMD
:GROUP LDX PLRXPOS
 LDY PLRYPOS
 JSR GETMAP
 CMP #SHPSTAIRS
 BNEL GETCMD
 CPX #STAIRSDOWN
 BNEL GETCMD
 STX SHAPETYPE
 JSR GETST
 LDA #$FF
 STA STPORT
 JMP GOSHP2

GOGO STX GOTOX ;X and Y come as offsets
 STY GOTOY
 LDX INDIV
 LDA INDIV+1
 JSR LOADPLR
 LDA PLRXPOS ;Re-calculate position
 CLC
 ADC GOTOX
 STA GOTOX
 LDA PLRYPOS
 CLC
 ADC GOTOY
 STA GOTOY
 LDA MOVETYPE
 BPL :GRP
 LDA PLRCURRPNTS
 DEC
 BMI :NOGO ;Action points 0 or negative?
 LDA PLRCOND
 AND #%1100_1001 ;Can you physically move?
 BEQ :GRP
 JSR PRINT
 GOTOXY 10;21
 CLEOL
 COLOR PINK
 ASC "You cannot move."
 SOUND $02;1;LOUD
 COLOR WHITE
 NULL
 JMP GETCMD
:NOGO JSR PRINT
 GOTOXY 10;21
 CLEOL
 COLOR PINK
 ASC "No points left."
 SOUND $02;1;LOUD
 COLOR WHITE
 NULL
 JMP GETCMD
:GRP BIT PLRARRESTFLAG
 BPLL :GRP2
 JSR GETGUARD
 LDA MCOND
 AND #%1100_1000 ;Dead, paralyzed, asleep
 BNE :ESCAPE
 LDA PLRST
 CMP #16
 BCCL :GRIP
 RANDNUM #100
 CPX #95
 BCC :GRIP
:ESCAPE STZ PLRARRESTFLAG
 LDX INDIV
 LDA INDIV+1
 JSR SAVEPLR
 JSR PRINT
 GOTOXY 10;21
 CLEOL
 COLOR PINK
 ASC "You escaped from the guard! "
 SOUND $02;1;LOUD
 COLOR WHITE
 CURSORON
 NULL
 PNOTELOGSTR $E;"Escaped from guard : ";PLRNAME
 NOTELOGSTR $E;"Escaped from guard : ";PLRNAME
 JSR RESETGUARD ;Reset guards direction
 GETRETURN
 BRA :GRP2
:GRIP JSR PRINT
 GOTOXY 10;21
 CLEOL
 COLOR PINK
 ASC "Guards grip is too strong."
 SOUND $13;1;LOUD
 COLOR WHITE
 NULL
 JMP GETCMD
:GRP2 LDX GOTOX
 LDY GOTOY
 JSR CHECKPOS ;Place to move to on the map (within 16 x 16)?
 BCS :NOTOK
 LDX GOTOX
 LDY GOTOY
 JSR GETMAP2
 AND #$0F
 CMP #8 ;Players
 BCS :CROWDED
 LDX GOTOX
 LDY GOTOY
 JSR GETMAP2
 LSR
 LSR
 LSR
 LSR
 CMP #4 ;Monsters
 BCS :CROWDED
 LDX GOTOX
 LDY GOTOY
 JSR GETMAP ;Get square
 STA SHAPE
 STX SHAPETYPE
 ASL
 TAX
 JMP (:SHAPES,X)
:NOTOK JMP GOSHP0

:CROWDED JSR PRINT
 GOTOXY 10;21
 COLOR PINK
 ASC "Too crowded"
 SOUND $25;1;LOUD
 COLOR WHITE
 NULL
 JMP GETCMD

:SHAPES DA GOSHP0 ; 0 = Wall
 DA GOSHP1 ; 1 = Space
 DA GOSHP2 ; 2 = Stairs
 DA GOSHP3 ; 3 = Force field
 DA GOSHP4 ; 4 = Dark area
 DA GOSHP5 ; 5 = Sign post
 DA GOSHP6 ; 6 = Swamp
 DA GOSHP7 ; 7 = Player
 DA GOSHP8 ; 8 = Unknown (can't see this square)
 DA GOSHP9 ; 9 = Water
 DA GOSHPA ; A = Teleport
 DA GOSHPB ; B = Hills
 DA GOSHPC ; C = Monster
 DA GOSHPD ; D = Player & monster
 DA GOSHPE ; E = Item
 DA GOSHPF ; F = Gate
 DA GOSHP10 ;10 = Monster generator
 DA GOSHP11 ;11 = Holy ground (safety zone)
 DA GOSHP12 ;12 = Altar
 DA GOSHP13 ;13 = Fountain

* Wall
GOSHP0 LDA SHAPETYPE
 CMP #WALLSECRETVIS
 BEQL SHAPEOK
 JSR PRINT
 GOTOXY 10;21
 CLEOL
 COLOR PINK
 ASC "Can't move through walls."
 SOUND $25;1;LOUD
 COLOR WHITE
 NULL
 JMP GETCMD

* Space
GOSHP1 JMP SHAPEOK

* Stairs
GOSHP2 JMP SHAPEOK

* Force field
GOSHP3 LDA PLRCLASS
 CMP #6 ;Sage
 BEQ :OK
 LDA SHAPETYPE
 CMP #FFDIMHORIZ
 BEQ :OK
 CMP #FFDIMVERT
 BEQ :OK
 JSR PRINT
 GOTOXY 10;21
 CLEOL
 COLOR PINK
 ASC "You bounce off the force field."
 SOUND $25;1;LOUD
 COLOR WHITE
 NULL
 JMP GETCMD
:OK JMP SHAPEOK

* Dark area
GOSHP4 JMP SHAPEOK

* Sign post
GOSHP5 JMP SHAPEOK

* Swamp
GOSHP6 JMP SHAPEOK

* Water
GOSHP9 JMP SHAPEOK

* Teleport
GOSHPA JMP SHAPEOK

* Hills
GOSHPB JMP SHAPEOK

* Gate
GOSHPF LDA SHAPETYPE
 CMP #GATEOPEN
 BEQL SHAPEOK
 CMP #GATECLOSED
 BNEL ILLEGAL
 JSR PRINT
 GOTOXY 10;21
 CLEOL
 COLOR PINK
 ASC "The gate is locked."
 SOUND $25;1;LOUD
 COLOR WHITE
 NULL
 JMP GETCMD

* Holy ground
GOSHP11 JMP SHAPEOK

* Altar
GOSHP12 JMP SHAPEOK

* Fountain
GOSHP13 JMP SHAPEOK

* Monster generator
GOSHP10 JSR PRINT
 GOTOXY 10;21
 CLEOL
 COLOR PINK
 ASC "You can't go there."
 SOUND $25;1;$80
 COLOR WHITE
 NULL
 JMP GETCMD

GOSHP7 ;Player
GOSHP8 ;Unknown (void)
GOSHPC ;Monster
GOSHPD ;Player & Monster
GOSHPE ;Item
ILLEGAL JSR PRINT
 GOTOXY 10;21
 CLEOL
 COLOR PINK
 ASC "That is an illegal move."
 COLOR WHITE
 NULL
 JMP GETCMD

SHAPEOK LDA SHAPE
 STA VTEMP
 ASL
 ASL
 ASL
 CLC
 ADC SHAPETYPE
 TAX
 LDA COST,X
 STA VTEMP+1
 BIT DRAGFLAG
 BPL :NODRAG
 ASL VTEMP+1 ;Dragging cost 2x
:NODRAG LDA PLRZPOS
 STA GOTOZ

 LDA STPORT
 BPL :NOSTAIR
 LDA VTEMP
 CMP #SHPTPORT
 BEQL :TPORT
 JSR PRINT
 GOTOXY 68;12
 CLEOL
 NULL
 JSR UPORDOWN
 JSR PRINT
 GOTOXY 10;21
 CURSORON
 CLEOL
 ASC "Take stairs "
 NULL
 JSR UPORDOWN
 BRA :STCONT

:NOSTAIR JSR PRINT
 GOTOXY 10;21
 CURSORON
 CLEOL
 ASC "Move"
 NULL
 BIT DRAGFLAG
 BPL :NODR
 JSR PRINT
 ASC "/drag"
 NULL
:NODR JSR PRINT
 ASC " to "
 COLOR YELLOW
 PAD2 GOTOX
 ASC ","
 PAD2 GOTOY
 COLOR WHITE
 NULL
:STCONT JSR PRINT
 ASC " (y/n)? : "
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 CMP #"Y"
 BEQ :MYES
 CMP #"N"
 BNE ]LOOP
:MNO JSR PRINT
 GOTOXY 10;21
 CURSOROFF
 CLEOL
 NULL
 JMP GETCMD

:MYES JSR PRINT
 ASC "Yes"
 CURSOROFF
 NULL
 LDA #1
 STA PREVSND
:TPORT LDA MOVETYPE
 BPL :GRPMOVE
 LDX INDIV
 LDA INDIV+1
 JSR LOADPLR
 LDA PLRCURRPNTS
 DEC
 BPL :COSTOK
 JSR PRINT
 GOTOXY 10;21
 CLEOL
 COLOR PINK
 ASC "Not enough points."
 SOUND $25;1;LOUD
 COLOR WHITE
 NULL
 JMP GETCMD
:COSTOK LDX PLRXPOS
 LDY PLRYPOS
 LDA #$FF ;Subtract (we're leaving this square)
 JSR PUTMAP2
 BRA :MOVE2

:GRPMOVE LDX NPRTY ;Number of people in party
]LOOP PHX
 LDX PLRXPOS
 LDY PLRYPOS
 LDA #$FF ;Subtract (we're leaving this square)
 JSR PUTMAP2
 PLX
 DEX
 BNE ]LOOP
:MOVE2 BIT DRAGFLAG
 BPL :NODR2
 LDX PLRXPOS ;One more for the invalid..
 LDY PLRYPOS
 LDA #$FF
 JSR PUTMAP2

:NODR2 JSR SVMAP2
 LDX STPORT ;Stairs or Teleport?
 BPL :OK
 LDA #1 ;Stair / Teleport movement cost
 STA VTEMP+1
 LDA STGOTOX
 STA GOTOX
 LDA STGOTOY
 STA GOTOY
 LDA STGOTOZ
 STA GOTOZ
:OK JSR PLOGMOVE
 LDA MOVETYPE
 BPL :GRPM2
 JSR CHECKLEV
 LDA PLRCURRPNTS
 SEC
 SBC VTEMP+1
 STA PLRCURRPNTS
 LDA GOTOX
 STA PLRXPOS
 LDA GOTOY
 STA PLRYPOS
 LDA GOTOZ
 STA PLRZPOS
 CLC
 XCE
 REP #$30
 LDA VTEMP+1 ;exp = exp + (movement cost * 2)
 AND #$FF
 ASL
 CLC ;Add experience for simply moving around
 ADC PLREXP
 STA PLREXP
 LDA PLREXP+2
 ADC #0
 STA PLREXP+2
 SEC
 XCE
 LDX INDIV
 LDA INDIV+1
 JSR SAVEPLR
 LDX INDIV
 LDA INDIV+1
 JSR CHECKWATER
 BRA :CHEKC
:TEMP DS 2

:GRPM2 LDX #0
]LOOP PHX
 LDA CURPARTY,X
 STA :TEMP
 LDA CURPARTY2,X
 STA :TEMP+1
 BNE :POK
 LDA :TEMP
 BEQ :NEXT
:POK LDX :TEMP
 LDA :TEMP+1
 JSR LOADPLR
 LDA PLRCOND
 AND #%1100_1000
 BNE :GMNOP
 JSR CHECKLEV
 LDA PLRCURRPNTS
 SEC
 SBC VTEMP+1
 STA PLRCURRPNTS
:GMNOP LDA GOTOX ;Update position (for entire party)
 STA PLRXPOS
 LDA GOTOY
 STA PLRYPOS
 LDA GOTOZ
 STA PLRZPOS
 CLC
 XCE
 REP #$30
 INCR PLREXP ;Add 1 experience for simply moving around
 SEC
 XCE
 LDX :TEMP
 LDA :TEMP+1
 JSR SAVEPLR
 LDX :TEMP
 LDA :TEMP+1
 JSR CHECKWATER
:NEXT PLX
 INX
 CPX NUMPARTY
 BNE ]LOOP

:CHEKC BIT DRAGFLAG
 BPL :CHEKC2
 LDX DRAGPLR
 LDA DRAGPLR+1
 JSR LOADPLR
 LDA PARTYNUM
 CMP PLRPARTY
 BEQ :INSAMEP
 LDA PARTYNUM
 PHA
 LDA PLRPARTY
 STA PARTYNUM
 JSR PLOGDRAG ;Log drag in other party's log
 PLX
 STX PARTYNUM
 LDA #0
 JSR LOADPN
:INSAMEP LDX DRAGPLR
 LDA DRAGPLR+1
 JSR LOADPLR
 LDA GOTOX
 STA PLRXPOS
 LDA GOTOY
 STA PLRYPOS
 LDA GOTOZ
 STA PLRZPOS
 LDX DRAGPLR
 LDA DRAGPLR+1
 JSR SAVEPLR
 PNOTELOGSTR $A;"Dragged along - ";PLRNAME
:CHEKC2 LDA PLRZPOS
 BNEL :LVLOK
 STZ VTEMP
 CALL "GAME.PRECSTLE" ;Update conds, points, HP, etc
 LDX DRAGPLR
 LDA DRAGPLR+1
 JSR LOADPLR
 LDA PLRPARTY
 CMP PARTYNUM
 BEQ :GOPOP
 LDA PLRPASSAULTS
 ORA PLRPASSAULTS+1
 ORA PLRPKILLS
 ORA PLRPKILLS+1
 BEQ :GOPOP
 LDA #$FF
 STA VTEMP
 CALL "GAME.PRECSTLE" ;Sentence other guy (jail)
 LDX DRAGPLR
 LDA DRAGPLR+1
 JSR SAVEPLR
 STZ VTEMP ;Reward given to player
 CALL "GAME.REWARD"
 LDX INDIV
 LDA INDIV+1
 JSR LOADPLR
 CLC
 XCE
 REP #$30
 LDA PLRGOLD
 CLC
 ADC $200
 STA PLRGOLD
 LDA PLRGOLD+2
 ADC #0
 STA PLRGOLD+2
 SEC
 XCE
 LDX INDIV
 LDA INDIV+1
 JSR SAVEPLR
 JSR PRINT
 HOME
 NULL
:GOPOP JSR POPMOD
 EXEC "GAME.CASTLE"

:LVLOK LDX GOTOZ
 JSR LDMAP2
 LDA MOVETYPE
 BPL :GRPM3
 LDX GOTOX
 LDY GOTOY
 LDA #1 ;Add (we're entering this square)
 JSR PUTMAP2
 BRA :SM

:GRPM3 LDX NPRTY ;Number of people in party
]LOOP PHX
 LDX GOTOX
 LDY GOTOY
 LDA #1 ;Add (we're entering this square)
 JSR PUTMAP2
 PLX
 DEX
 BNE ]LOOP
:SM BIT DRAGFLAG
 BPL :SM2
 LDX DRAGPLR
 LDA DRAGPLR+1
 JSR LOADPLR
 LDX GOTOX
 LDY GOTOY
 LDA #1 ;Add invalid to map
 JSR PUTMAP2
:SM2 JSR SVMAP2
 LDX GOTOZ
 CPX MAPLVL
 BEQ :SAMELVL
 JSR LDMAP
:SAMELVL LDX INDIV
 LDA INDIV+1
 JSR LOADPLR

 JSR PRINT
 GOTOXY 10;21
 CURSOROFF
 CLEOL
 NULL

 LDA VTEMP
 CMP #SHPTPORT
 BNEL TOP
 LDA STPORT
 EOR #$FF
 STA STPORT
 BPLL TOP

 JSR SHOWTHEMAP
 JSR GETST
 LDA #$0A
 STA SHAPE
 LDA #$00
 STA SHAPETYPE
 JMP GOSHPA

UPORDOWN LDA SHAPETYPE
 CMP #STAIRSUP ;Up
 BNE :DOWN
 JSR PRINT
 ASC "Up"
 NULL
 RTS
:DOWN JSR PRINT
 ASC "Down"
 NULL
 RTS

GETST LDX #0
 LDA #0
 JSR LOADST
 LDA STBUFF
 STA :RECS
 LDA STBUFF+1
 STA :RECS+1
 STZ :REC
 STZ :REC+1
]LOOP LDA :REC+1
 CMP :RECS+1
 BNE :LOAD
 LDA :REC
 CMP :RECS
 BNE :LOAD
 NOTELOG $1;"Error in STAIRS.TELEPORT file. Location not found."
 DEATH
:LOAD INCR :REC
 LDX :REC
 LDA :REC+1
 JSR LOADST
 LDA STXPOS
 CMP PLRXPOS
 BNE ]LOOP
 LDA STYPOS
 CMP PLRYPOS
 BNE ]LOOP
 LDA STZPOS
 CMP PLRZPOS
 BNEL ]LOOP
 LDA STGOTOX
 STA GOTOX
 LDA STGOTOY
 STA GOTOY
 LDA STGOTOZ
 STA GOTOZ
 RTS
:REC DA 0
:RECS DS 2

CHECKPOS CPX #$10
 BCS :RTS
 CPY #$10
:RTS RTS

HELP JSR PRINT
 ASC "Help"
 NULL
 JSR CLRBOT
 JSR GETFILE
 DFB 15,22 ;Use lines x to y
 STR "HELP/MOVE"
 JSR PRINT
 COLOR YELLOW
 CURSOROFF
 GOTOXY 0;23
 COLOR PINK
 CENTER " Press [RETURN] "
 COLOR WHITE
 NULL
]LOOP JSR KEYIN
 CMP #$8D
 BEQ :YEP
 CMP #$9B
 BNE ]LOOP
:YEP JSR PRINT
 INVERSE
 COLOR YELLOW
 ZAPLINE
 COLOR WHITE
 NORMAL
 NULL
 JSR CLRBOT
 JMP START

MOVET JSR PRINT
 GOTOXY 0;21
 CURSORON
 ZAPLINE
 CR
 ZAPLINE
 ASC "Who will move (1-"
 DEC8 NPRTY
 ASC ", 0=group)? : "
 NULL
]LOOP JSR KEYIN
 CMP #$9B
 BEQ :ESC
 CMP #"0"
 BEQ :GRP
 SEC
 SBC #"1"
 CMP NPRTY
 BCS ]LOOP
 TAX
 LDA CURPARTY,X
 STA INDIV
 STA MPLR
 LDA CURPARTY2,X
 STA INDIV+1
 STA MPLR+1
 JSR PRINT
 ZAPLINE
 NULL
 LDX INDIV
 LDA INDIV+1
 JSR LOADPLR
 LDA PLRZPOS
 BEQ :OK
 CMP MAPLVL
 BEQ :OK
 LDX PLRZPOS
 JSR LDMAP
 LDX PLRZPOS
 JSR LDMAP2
:OK LDA #$FF
 HEX 2C
:GRP LDA #0
 STA MOVETYPE
 LDA #4
 STA XLOC
 STA YLOC
:ESC JSR PRINT
 ZAPLINE
 NULL
 JMP TOP

EXIT JSR PRINT
 GOTOXY 68;12
 CLEOL
 ASC "Exit"
 CURSOROFF
 NULL
 JSR SVMAP2
 RETURN

CLRBOT JSR PRINT
 GOTOXY 0;22
 LUP 7
 ZAPLINE
 CURSORUP
 --^
 ZAPLINE
 NULL
 RTS

LDMAP STX MAPLVL
 LDA #0
 JMP LOADMAP
MAPLVL DS 1

LDMAP2 STX MAPLVL2
 LDA #0
 JMP LOADMAP2
MAPLVL2 DS 1

SVMAP2 LDX MAPLVL2
 LDA #0
 JMP SAVEMAP2

PLOGMOVE BIT MOVETYPE
 BPL :GRPMOVE
:INDIV LDY #0
]LOOP LDA PLRNAME+1,Y
 STA MISCBUFF+1,Y
 INY
 CPY PLRNAME
 BNE ]LOOP
 BRA :CONT
:GRPMOVE LDX #0
 LDY #0
]LOOP LDA :STR0+1,X
 STA MISCBUFF+1,Y
 INY
 INX
 CPX :STR0
 BNE ]LOOP
:CONT INY
 LDX #0
]LOOP LDA :STR1+1,X
 STA MISCBUFF,Y
 INY
 INX
 CPX :STR1
 BNE ]LOOP
 LDA PLRXPOS
 JSR CONVERT
 STA MISCBUFF,Y
 INY
 TXA
 STA MISCBUFF,Y
 INY
 LDA #","
 STA MISCBUFF,Y
 INY
 LDA PLRYPOS
 JSR CONVERT
 STA MISCBUFF,Y
 INY
 TXA
 STA MISCBUFF,Y
 INY
 LDX #0
]LOOP LDA :STR2+1,X
 STA MISCBUFF,Y
 INY
 INX
 CPX :STR2
 BNE ]LOOP
 LDA MAPLVL
 JSR CONVERT
 STA MISCBUFF,Y
 INY
 TXA
 STA MISCBUFF,Y
 INY
 LDX #0
]LOOP LDA :STR3+1,X
 STA MISCBUFF,Y
 INY
 INX
 CPX :STR3
 BNE ]LOOP
 LDA GOTOZ
 BNE :LVLOK
 LDX #0
]LOOP LDA :STRC+1,X
 STA MISCBUFF,Y
 INY
 INX
 CPX :STRC
 BNE ]LOOP
 JMP :DONE
:LVLOK LDA GOTOX
 JSR CONVERT
 STA MISCBUFF,Y
 INY
 TXA
 STA MISCBUFF,Y
 INY
 LDA #","
 STA MISCBUFF,Y
 INY
 LDA GOTOY
 JSR CONVERT
 STA MISCBUFF,Y
 INY
 TXA
 STA MISCBUFF,Y
 INY
 LDX #0
]LOOP LDA :STR4+1,X
 STA MISCBUFF,Y
 INY
 INX
 CPX :STR4
 BNE ]LOOP
 LDA GOTOZ
 JSR CONVERT
 STA MISCBUFF,Y
 INY
 TXA
 STA MISCBUFF,Y
 INY
 LDX #0
]LOOP LDA :STR5+1,X
 STA MISCBUFF,Y
 INY
 INX
 CPX :STR5
 BNE ]LOOP
:DONE DEY
 STY MISCBUFF
 PNOTELOGBUFF $A;MISCBUFF
 RTS
:STR0 STR "Party"
:STR1 STR " moved from "
:STR2 STR " (lvl "
:STR3 STR ") to "
:STR4 STR " (lvl "
:STR5 STR ")"
:STRC STR "the Castle"

CONVERT STZ :CHAR+1
 CMP #10
 BCC :LESS
 INC :CHAR+1
 SEC
 SBC #10
:LESS STA :CHAR
 ORA #"0"
 TAX
 LDA :CHAR+1
 ORA #"0"
 RTS
:CHAR DS 2

CHECKLEV LDA PLRCOND
 AND #%0000_0100 ;Is player levitating?
 BEQ :NO
 LDA SHAPE
 CMP #$0A
 BNE :SKIP
 LDA SHAPETYPE
 CMP #0
 BEQ :NO
:SKIP LDA #1 ;If we're levitating then cost is 1
 STA VTEMP+1
 BIT DRAGFLAG
 BPL :NO
 LDA #2
 STA VTEMP+1
:NO RTS

CHECKWATER STX :TEMP
 STA :TEMP+1
 LDA VTEMP
 STA :VTSAVE
 LDA VTEMP+1
 STA :VTSAVE+1
 LDX PLRZPOS
 CPX MAPLVL
 BEQ :LVLOK
 JSR LDMAP
:LVLOK LDX PLRXPOS
 LDY PLRYPOS
 JSR GETMAP
 CMP #SHPWATER
 BEQ :YES
 RTS

:YES STX SHAPETYPE
 LDA PLRCOND ;Are they levitating or dead?
 AND #%1000_0100
 BEQ :SWIM ;No
 RTS
:SWIM LDA #2
 STA PREVSND
 LDA PLRST ;See if they can swim
 SEC
 SBC #5
 STA VTEMP
 LDA PLRDX
 SEC
 SBC #4
 CMP VTEMP
 BCS :WTHIS1
 LDA VTEMP
:WTHIS1 STA :WROLL
 LDX #7 ;Subtract encumberance level (sort of..)
]LOOP PHX ;ie. the more equipment you have, the
 LDA PLRITEM,X ;    less chance you have of swimming
 BEQ :WNXT
 LDY #0
 LDA PLRITEM,X
 CMP #1 ;Weapon
 BEQ :WWEAP
 CMP #2 ;Armour
 BEQ :WARM
 BNE :WOTHER
:WARM INY
:WWEAP INY
:WOTHER INY
 STY VTEMP
 LDA :WROLL
 SEC
 SBC VTEMP
 STA :WROLL
:WNXT PLX
 DEX
 BPL ]LOOP
 LDA SHAPETYPE
 CMP #WATERDEEP
 BNE :NOTDEEP
 LSR :WROLL ;1/2 as much chance of swimming in deep water
:NOTDEEP LDX #3
 JSR ROLLD6 ;Roll vs Health
 LDA VTEMP
 CMP :WROLL
 BEQL :WRTS ;Successful roll
 BCCL :WRTS
 JSR PRINT
 GOTOXY 0;22
 CURSORON
 CLEOL
 COLOR PINK
 PRSTRING PLRNAME
 ASC " is drowning.. "
* SOUND $26;1;LOUD
 COLOR WHITE
 NULL
 PNOTELOGSTR $1;"Party member drowning - ";PLRNAME
 LDX PLRHT
 LDA :WTBL,X
 STA VTEMP
 LDA PLRHP
 CLC
 ADC VTEMP
 STA PLRHP
 DEC
 CMP #$80
 BCCL :WRTS1
 LDA PLRHP
 EOR #$FF
 INC
 STA :NEGHP
 CMP PLRHP+1 ;HP gone full negative?
 BCS :DEAD
 LDX #3
 JSR ROLLD6 ;Roll vs Health
 LDA VTEMP
 CMP :NEGHP
 BEQ :WRTS1
 BCC :WRTS1
 NOTELOGSTR $1;"Roll vs health failed.. Player died #";PLRNAME
 PNOTELOGSTR $1;"Party member died - ";PLRNAME
 JSR PRINT
 COLOR PINK
 ASC "and has died! "
 SOUND $0D;1;LOUD
 COLOR WHITE
 NULL
:DEAD LDA PLRCOND
 ORA #%1000_0000 ;Dead
 STA PLRCOND
 LDA #$FF
 STA PLRCONDX+7 ;Dead 'forever' (+7 coz it's bit 7)
 JSR CHARITEMS
:WRTS1 LDX :TEMP
 LDA :TEMP+1
 JSR SAVEPLR
 LDA CH
 STA :WCHV+2
 LDA CV
 STA :WCHV+3
 LDA #$FF ;Draw player stats only
 STA VTEMP
 CALL "DRAW.SCREEN"
 LDX :TEMP
 LDA :TEMP+1
 JSR LOADPLR
 JSR PRINT
:WCHV GOTOXY 0;0
 NULL
 GETRETURN
 JSR PRINT
 ZAPLINE
 NULL
:WRTS JSR PRINT
 CURSOROFF
 NULL
 LDA :VTSAVE
 STA VTEMP
 LDA :VTSAVE+1
 STA VTEMP+1
 RTS
:VTSAVE DS 2
:WATERZ DS 1
:WROLL DS 1
:NEGHP DS 1
:TEMP DS 2
:WTBL DFB -25,-25,-25,-25,-20,-20,-15,-10,-5 ;(1 - 9)
 DFB -4,-4,-3,-3,-2,-2,-1,-1,-1 ;(10 - 18)
 DFB -1,-1 ;(19 - 20)

SHOWTHEMAP LDA PARTYNUM
 PHA
 BIT MOVETYPE ;Group or individual?
 BMI :INDIV
 STZ PARTYNUM ;Display map if group (at least 1 plr can see)
:INDIV LDX PLRXPOS
 LDY PLRYPOS
 LDA PLRZPOS
 JSR SHOWMAP
 PLA
 STA PARTYNUM
 RTS

COST DFB 0,0,0,0,0,1,1,0 ; 0 = Wall
 DFB 1,0,0,0,0,0,0,0 ; 1 = Space
 DFB 1,1,0,0,0,0,0,0 ; 2 = Stairs
 DFB 1,1,1,1,0,0,0,0 ; 3 = Force field
 DFB 1,0,0,0,0,0,0,0 ; 4 = Dark area
 DFB 1,0,0,0,0,0,0,0 ; 5 = Sign post
 DFB 1,0,0,0,0,0,0,0 ; 6 = Swamp
 DFB 0,0,0,0,0,0,0,0 ; 7 = Player
 DFB 0,0,0,0,0,0,0,0 ; 8 = Unknown (can't see this square)
 DFB 2,4,0,0,0,0,0,0 ; 9 = Water
 DFB 0,0,0,0,0,0,0,0 ; A = Teleport
 DFB 2,0,0,0,0,0,0,0 ; B = Hills
 DFB 0,0,0,0,0,0,0,0 ; C = Monster
 DFB 0,0,0,0,0,0,0,0 ; D = Player & monster
 DFB 0,0,0,0,0,0,0,0 ; E = Item
 DFB 1,1,0,0,0,0,0,0 ; F = Gate
 DFB 0,0,0,0,0,0,0,0 ;10 = Monster generator
 DFB 1,0,0,0,0,0,0,0 ;11 = Holy ground (safety zone)
 DFB 1,0,0,0,0,0,0,0 ;12 = Altar
 DFB 1,0,0,0,0,0,0,0 ;13 = Fountain

GOTOX DS 1
GOTOY DS 1
GOTOZ DS 1

MOVETYPE DFB 0 ;00=Group, FF=Individual
NPRTY DS 1 ;Number of people in party
INDIV DS 2 ;'Individual'

STPORT DS 1 ;Stair/Teleport flag

PREVSND DS 1 ;Pending sound?

GETGUARD LDX #0
 LDA #0
 JSR LOADMON2
 LDA MON2BUFF
 STA :RECS
 LDA MON2BUFF+1
 STA :RECS+1
]LOOP LDA :RECS
 ORA :RECS+1
 BEQ :DONE
 LDX :RECS
 LDA :RECS+1
 JSR LOADMON2
 LDA MTYPE
 ORA MTYPE+1
 BEQ :NEXT
 LDA MZPOS
 CMP PLRZPOS
 BNE :NEXT
 LDA MXPOS
 CMP PLRXPOS
 BNE :NEXT
 LDA MYPOS
 CMP PLRYPOS
 BNE :NEXT
 LDA MLEVEL
 BNE :NEXT
 LDA MDIR
 CMP #10
 BCC :NEXT
 LDA MARRESTCHAR
 CMP INDIV
 BNE :NEXT
 LDA MARRESTCHAR+1
 CMP INDIV+1
 BNE :NEXT
 LDX :RECS
 LDA :RECS+1
 BRA :DONE
:NEXT DECR :RECS
 BRA ]LOOP
:DONE RTS
:RECS DS 2

RESETGUARD JSR GETGUARD
 PHA
 PHX
 RANDNUM #9
 STX MDIR
 STZ MARRESTCHAR
 STZ MARRESTCHAR+1
 PLX
 PLA
 JMP SAVEMON2

XLOC DS 1
YLOC DS 1
ANKX DS 1
ANKY DS 1
CNTR DS 1

PLOGDRAG
* LDX PARTYNUM
* LDA #0
* JSR LOADPN
 LDY #0
]LOOP LDA PLRNAME+1,Y
 STA MISCBUFF+1,Y
 INY
 CPY PLRNAME
 BNE ]LOOP
 INY
 LDX #0
]LOOP LDA :STR1+1,X
 STA MISCBUFF,Y
 INY
 INX
 CPX :STR1
 BNE ]LOOP
 LDA PLRXPOS
 JSR CONVERT
 STA MISCBUFF,Y
 INY
 TXA
 STA MISCBUFF,Y
 INY
 LDA #","
 STA MISCBUFF,Y
 INY
 LDA PLRYPOS
 JSR CONVERT
 STA MISCBUFF,Y
 INY
 TXA
 STA MISCBUFF,Y
 INY
 LDX #0
]LOOP LDA :STR11+1,X
 STA MISCBUFF,Y
 INY
 INX
 CPX :STR11
 BNE ]LOOP
 LDA PLRZPOS
 JSR CONVERT
 STA MISCBUFF,Y
 INY
 TXA
 STA MISCBUFF,Y
 INY
 LDX #0
]LOOP LDA :STR2+1,X
 STA MISCBUFF,Y
 INY
 INX
 CPX :STR2
 BNE ]LOOP
 LDX #0
]LOOP LDA PNNAME+1,X
 STA MISCBUFF,Y
 INY
 INX
 CPX PNNAME
 BNE ]LOOP
 LDX #0
]LOOP LDA :STR3+1,X
 STA MISCBUFF,Y
 INY
 INX
 CPX :STR3
 BNE ]LOOP
 LDA GOTOZ
 BNE :ALEVEL
 LDX #0
]LOOP LDA :STR6+1,X
 STA MISCBUFF,Y
 INY
 INX
 CPX :STR6
 BNE ]LOOP
 BRA :FINIT
:ALEVEL LDA GOTOX
 JSR CONVERT
 STA MISCBUFF,Y
 INY
 TXA
 STA MISCBUFF,Y
 INY
 LDA #","
 STA MISCBUFF,Y
 INY
 LDA GOTOY
 JSR CONVERT
 STA MISCBUFF,Y
 INY
 TXA
 STA MISCBUFF,Y
 INY
 LDX #0
]LOOP LDA :STR4+1,X
 STA MISCBUFF,Y
 INY
 INX
 CPX :STR4
 BNE ]LOOP
 LDA GOTOZ
 JSR CONVERT
 STA MISCBUFF,Y
 INY
 TXA
 STA MISCBUFF,Y
 INY
 LDX #0
]LOOP LDA :STR5+1,X
 STA MISCBUFF,Y
 INY
 INX
 CPX :STR5
 BNE ]LOOP
:FINIT DEY
 STY MISCBUFF
 PNOTELOGBUFF $1;MISCBUFF
 RTS
:STR1 STR " at "
:STR11 STR " (level "
:STR2 STR ") dragged by Party '"
:STR3 STR "' to "
:STR4 STR " (level "
:STR5 STR ")"
:STR6 STR "Castle"

SHAPE DS 1
SHAPETYPE DS 1

CHARITEMS LDX #0
 LDA #0
 JSR LOADITEM2
 LDA ITEM2BUFF
 STA IRECS
 LDA PLRGOLD
 ORA PLRGOLD+1
 ORA PLRGOLD+2
 ORA PLRGOLD+3
 BEQ :NOGOLD
 JSR GETITEM
 STZ INUM ;0 = gold
 LDA PLRXPOS
 STA IXPOS
 LDA PLRYPOS
 STA IYPOS
 LDA PLRZPOS
 STA IZPOS
 LDX #3
]LOOP LDA PLRGOLD,X
 STA IDATA,X
 DEX
 BPL ]LOOP
 STZ IFREE
 STZ IBURIED
 JSR SAVEI
:NOGOLD LDX #0 ;Put all chars items into maze item file
]LOOP LDA PLRITEM ;ie. drop all his items (or hers)
 BEQ :DONE
 JSR GETITEM
 LDA PLRITEM
 STA INUM
 LDA PLRXPOS
 STA IXPOS
 LDA PLRYPOS
 STA IYPOS
 LDA PLRZPOS
 STA IZPOS
 STZ IDATA
 STZ IDATA+1
 STZ IDATA+2
 STZ IDATA+3
 STZ IFREE
 STZ IBURIED
 PHX
 JSR SAVEI
 LDX #0
]LOOP2 LDA PLRITEM+1,X ;Crunch items
 STA PLRITEM,X
 LDA PLRITEMX+1,X
 STA PLRITEMX,X
 INX
 CPX #7
 BNE ]LOOP2
 STZ PLRITEM+7
 STZ PLRITEMX+7
 PLX
 INX
 CPX #8
 BNE ]LOOP
:DONE LDA IRECS ;Update Maze Items (total)
 STA ITEM2BUFF
 STZ ITEM2BUFF+1
 LDX #0
 LDA #0
 JSR SAVEITEM2
 LDA PLRITEM ;Got anything?
 BEQ :NONE
 JSR PRINT
 SOUND $0E;1;$80
 NULL
 RTS
:NONE JSR PRINT
 SOUND $0D;1;$80
 NULL
 RTS

GETITEM LDA IRECS
 BEQ :NEXT
 LDA :RECS
 CMP IRECS
 BEQ :NEXT
]LOOP INC :RECS
 LDX :RECS
 LDA #0
 JSR LOADITEM2
 LDA IFREE
 BMI :GOTIT
 LDA :RECS
 CMP IRECS
 BCC ]LOOP
:NEXT INC IRECS
 LDA IRECS
 STA NEWITEM
 STA :RECS
 RTS
:GOTIT LDA :RECS
 STA NEWITEM
 RTS
:RECS DS 1

IRECS DS 2
NEWITEM DS 1

SAVEI LDX NEWITEM
 LDA #0
 JMP SAVEITEM2

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/GAME.MOVE
 fin

 END
