*-------------------------------
* GAME.MOVEMON
*-------------------------------
 DAT
 LST OFF

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE VARS
 USE LIB.JMP
 USE PLR.DSECT
 USE MON.DSECT
 USE MON2.DSECT
 USE ITEM.DSECT
 USE ITEM2.DSECT
 USE SCEN.DSECT
 USE ST.DSECT

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/GAME.MOVEMON
 fin

 MODID "GAME.MOVEMON"

START JSR PRINT
 HOME
 LINE "Monster movement.."
 CR
 NULL
 NOTELOG $3;"Monster movement.."

 JSR MAPBOX
 JSR BOTLINES

 LDX #0
 LDA #0
 JSR LOADMON2
 LDA MON2BUFF
 BNE :OK
 LDA MON2BUFF+1
 BNE :OK
 JSR PRINT
 HOME
 COLOR PINK
 ASC "No monsters in maze to move.."
 COLOR WHITE
 NULL
 NOTELOG $1;"No monsters to move"
 JMP EXIT

:OK LDA MON2BUFF
 STA MONSTERS
 LDA MON2BUFF+1
 STA MONSTERS+1
 LDX #0
 JSR LDMAP
 LDA MAP ;Number of levels in maze
 STA LEVEL

 LDX SCENARIO
 LDA #0
 JSR LOADSCEN

 LDX #0
 LDA #0
 JSR LOADITEM
 LDA ITEMBUFF
 STA MAXITEMS

 LDX #0
 LDA #0
 JSR LOADITEM2
 LDA ITEM2BUFF
 STA IRECS

TOPLOOP JSR SCROLL
 JSR SCROLL
 JSR PRINT
 ASC "Level "
 COLOR YELLOW
 DEC8 LEVEL
 COLOR WHITE
 LINE ".."
 NULL
 NOTELOGNUM $D;"Level ";LEVEL
 LDA LEVEL
 STA GLEVEL

 LDA $C025
 AND #%0000_0010
 BEQ :CSKIP
 JSR PRINT
 COLOR PINK
 GOTOXY 20;22
 CURSORON
 ASC "Skip this level (y/n)? : "
 COLOR WHITE
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 CMP #"N"
 BEQ :SKIPNO
 CMP #"N"-$40
 BEQ :SKIPNO
 CMP #"Y"-$40
 BEQ :SKIPY
 CMP #"Y"
 BNE ]LOOP
:SKIPY JSR PRINT
 ASC "Yes"
 CURSOROFF
 NULL
 JMP :DONE

:SKIPNO JSR PRINT
 ASC "No"
 CURSOROFF
 NULL

:CSKIP LDX LEVEL
 JSR LDMAP
 LDX LEVEL
 JSR LDMAP2

 LDA MONSTERS
 STA :CNTR
 LDA MONSTERS+1
 STA :CNTR+1

]LOOP LDA :CNTR+1
 BNE :OK
 LDA :CNTR
 BEQL :DONE
:OK LDX :CNTR
 LDA :CNTR+1
 JSR LOADMON2 ;Get this monster
 LDA MTYPE
 BNE :OKM
 LDA MTYPE+1
 BEQL :NEXTM
:OKM LDA MZPOS
 CMP LEVEL ;Monster on this level?
 BNEL :NEXTM
 LDA MCOND
 AND #%1000_0000 ;Dead?
 BNEL :NEXTM
 LDX MXPOS
 LDY MYPOS
 JSR GETMAP2 ;Double check to see if monster is there
 AND #$F0
 BEQL MERROR ;If monster isn't there, something is wrong!

 LDA SKIPMON ;Do we skip any?
 BEQ :N2SKIP
 LDX SKIPMON
]LOOP3 DEX
 BMI :N2SKIP
 LDA SKIPMONS,X
 CMP :CNTR
 BNE ]LOOP3
 LDA SKIPMONS+1,X
 CMP :CNTR+1
 BNE ]LOOP3
 JMP :NEXTM

:N2SKIP LDX MTYPE
 LDA MTYPE+1
 JSR LOADMON

 STZ ATTFLAG ;"Attacked?" flag
 STZ MOVEFLAG

 LDX MXPOS
 STX PLRXPOS
 LDY MYPOS
 STY PLRYPOS
 LDA LEVEL
 STA PLRZPOS
 STZ PARTYNUM
 JSR SHOWMAP

 JSR SCROLL
 JSR PRINT
 ASC "Monster #"
 COLOR YELLOW
 DEC16 :CNTR
 COLOR WHITE
 ASC " ("
 COLOR YELLOW
 DEC16 MTYPE
 COLOR WHITE
 ASC "/"
 COLOR AQUAMARINE
 PRSTRING MNAME
 COLOR WHITE
 ASC ") at "
 COLOR YELLOW
 PAD2 MXPOS
 ASC ","
 PAD2 MYPOS
 COLOR WHITE
 NULL
 LDA CH
 STA HV+2
 LDA CV
 STA HV+3

 LDA MCOND
 AND #%1100_1001
 BEQ :CANMOVE
 JSR DOHV
 JSR PRINT
 ASC " - can't move ("
 COLOR PINK
 PRCOND MCOND
 COLOR WHITE
 LINE ")"
 SOUND $13;1;$FF
 NULL
 JSR DOCONDS
:NOGO LDX :CNTR
 LDA :CNTR+1
 JSR SAVEMON2
 JSR LOG200
 INCR NOTMOVED
 JMP :NEXTM

:CANMOVE JSR DOCONDS
 BCS :NOGO
 LDX :CNTR
 LDA :CNTR+1
 JSR SAVEMON2
 LDX MXPOS
 LDY MYPOS
 LDA #-1
 JSR PUTMAP2M ;Subtract monster from this square

 LDA #$FF
 STA PLRPOS
 STA PLRPOS+1
 STA PLRPOS+2

 LDA MDIR
 CMP #10
 BNE :ZITZOT
 LDA MLEVEL
 BNE :ZITZOT
 LDX MARRESTCHAR
 LDA MARRESTCHAR+1
 JSR LOADP
 LDA PLRXPOS
 STA PLRPOS
 LDA PLRYPOS
 STA PLRPOS+1
 LDA PLRZPOS
 STA PLRPOS+2
 LDX PLRXPOS ;Subtract person from this square
 LDY PLRYPOS
 LDA #-1
 JSR PUTMAP2

:ZITZOT STZ CNTR
 LDA MSPEED
 STA CNTRM

 STZ :SEECHAR
 STZ SAIDIT

:PICKDIR INC CNTR
 LDA CNTR
 CMP #20
 BEQL :DONEXT ;Monster may be stuck!

 BIT :SEECHAR ;Can see a char, but path may be blocked
 BPL :NOCHARS
 STZ :SEECHAR ;Pretend monster can't see anyone and move in any
 BRA :NOCHAR ; direction he feels like

:NOCHARS LDA #5
 STA :MDIR
 LDA MLEVEL
 BNE :NOCHARS2
 JSR CLOSEGATES ;If any open gates nearby, close them
 LDA MDIR ;Have arrested a char?
 CMP #10
 BNE :NOCHARS2
 LDA MARRESTCHAR
 ORA MARRESTCHAR+1
 BEQ :NOCHARS1
 JSR GETJAILCHAR ;Find the person guard is taking
 BIT SAIDIT
 BMI :BINSAID
 JSR DOHV
 JSR PRINT
 ASC " with "
 COLOR AQUAMARINE
 PRSTRING PLRNAME
 COLOR WHITE
 NULL
 LDA CH
 STA HV+2
 LDA CV
 STA HV+3
 LDA #$FF
 STA SAIDIT
:BINSAID JSR GETJAILPATH
 JMP :DODIR2
:NOCHARS1 RANDNUM #9
 TXA
 BRA :NOCHARS3
:NOCHARS2 JSR FINDCHAR ;See if we can see any characters
 BCC :NOCHAR
:NOCHARS3 STA :MDIR
 JSR ATTACK ;Kill!
 BCS :PREATT ;Monster has attacked
 LDA #$FF
 STA :SEECHAR ;We can see a character
 LDA :MDIR
 JMP :DODIR2 ;Out of range, so move

:PREATT LDA MLEVEL
 BEQ :NOCHARS ;Move along.. move along..
 JMP :ATT

:NOCHAR LDX MIQ
 CPX #4
 BCS :IQOK
 LDX #4
:IQOK LDA #0
 JSR RANDOM
 CPX #1
 BEQ :BACK
 CPX #2
 BEQ :RIGHT
 CPX #3
 BEQ :LEFT
:FORW LDA MDIR
 BRA :DODIR
:BACK LDA #10
 SEC
 SBC MDIR
 BRA :DODIR
:LEFT LDX MDIR
 LDA :TL-1,X
 BRA :DODIR
:RIGHT LDX MDIR
 LDA :TR-1,X
 BRA :DODIR

:TR DFB 7,4,1,8,5,2,9,6,3
:TL DFB 3,6,9,2,5,8,1,4,7

:TDIR DFB 1,2,4,5
 DFB 2,3,1,5
 DFB 3,6,2,5
 DFB 4,7,1,5
 DFB 5,5,5,5
 DFB 6,9,3,5
 DFB 7,8,4,5
 DFB 8,7,9,5
 DFB 9,8,6,5

:DODIR STA :MDIR
 DEC
 ASL
 ASL
 STA VTEMP
 RANDNUM #3
 DEX
 TXA
 CLC
 ADC VTEMP
 TAX ;If char seen, move stright towards char
 LDA :TDIR,X
:DODIR2 DEC
 ASL
 TAX
 LDA MXPOS
 LDY MYPOS
 JMP (:DIR,X)

:DIR DA :DIR1
 DA :DIR2
 DA :DIR3
 DA :DIR4
 DA :DIR5
 DA :DIR6
 DA :DIR7
 DA :DIR8
 DA :DIR9

:DIR1 DEC
 INY
 BRA :DIRCONT

:DIR2 INY
 BRA :DIRCONT

:DIR3 INC
 INY
 BRA :DIRCONT

:DIR4 DEC
 BRA :DIRCONT

:DIR5 RANDNUM #6
 CPX #1
 BNE :DIR5S
 RANDNUM #9
 STX MDIR
 LDX :CNTR
 LDA :CNTR+1
 JSR SAVEMON2
:DIR5S JMP :STILL

:DIR6 INC
 BRA :DIRCONT

:DIR7 DEC
 DEY
 BRA :DIRCONT

:DIR8 DEY
 BRA :DIRCONT

:DIR9 INC
 DEY
 BRA :DIRCONT

:DIRCONT TAX
 CPX #$10
 BCSL :PICKDIR
 CPY #$10
 BCSL :PICKDIR
 STX TEMPXLOC
 STY TEMPYLOC
 JSR GETMAP
 STA BYTE
 LDA MLEVEL ;Guardian 'okshapes' different
 BEQ :GSHAPES
 LDX #-1
]LOOP3 INX
 LDA OKSHAPES,X
 CMP #$FF
 BEQL :PICKDIR
 CMP BYTE
 BNE ]LOOP3
 BRA :ITSOK

:GSHAPES LDX #-1
]LOOP3 INX
 LDA OKSHAPESG,X
 CMP #$FF
 BEQL :PICKDIR
 CMP BYTE
 BNE ]LOOP3
 JMP :SHPOK

:ITSOK LDA MHABITAT ;1=Land, 2=Water, 3=Hills, 4=Air
 BEQL :NEXTM ;Unknown (data on monster is incomplete)
 CMP #1
 BNE :WATER
 LDA BYTE
 CMP #SHPSPACE
 BNEL :PICKDIR ;Can't put land monster in water
 JMP :SHPOK
:WATER CMP #2
 BNE :HILLS
 LDA BYTE
 CMP #SHPWATER
 BNEL :PICKDIR ;...
 JMP :SHPOK
:HILLS CMP #3
 BNE :AIR
 LDA BYTE
 CMP #SHPHILLS
 BNEL :PICKDIR ;...
 JMP :SHPOK
:AIR CMP #4
 BNE :DARK
 LDA BYTE
 CMP #SHPDARK
 BEQL :PICKDIR ;...
 JMP :SHPOK
:DARK CMP #5
 BNE :SWAMP
 LDA BYTE
 CMP #SHPDARK
 BNEL :PICKDIR ;...
 JMP :SHPOK
:SWAMP CMP #6
 BNEL :PICKDIR ;Wot then?
 LDA BYTE
 CMP #SHPSWAMP
 BNEL :PICKDIR ;...

:SHPOK LDA MLEVEL
 BEQ :OVERIDE
 LDX TEMPXLOC
 LDY TEMPYLOC
 JSR GETMAP2
 STA BYTE ;Ok to use this again
 AND #$F0 ;Monsters
 CMP #$30 ;A crowded square
 BCSL :PICKDIR ;Can't put monster here - won't fit
 LDA BYTE
 AND #$0F ;Characters
 CMP #3 ;A crowded square
 BCSL :PICKDIR ;Can't put monster here - won't fit

:OVERIDE LDA MDIR
 CMP #10 ;Guardian with arrest char
 BEQ :OVERDIR
 LDA :MDIR ;Update direction of movement
 STA MDIR

:OVERDIR LDA TEMPXLOC
 STA XLOC
 LDA TEMPYLOC
 STA YLOC

 LDX XLOC
 STX MXPOS
 LDY YLOC
 STY MYPOS
 LDA #1
 JSR PUTMAP2M ;Add monster to this square

 LDA MDIR
 CMP #10
 BNE :MTHEN
 LDA MLEVEL
 BNE :MTHEN
 LDX XLOC ;Add person to this square
 LDY YLOC
 LDA #1
 JSR PUTMAP2
 LDX MARRESTCHAR
 LDA MARRESTCHAR+1
 JSR LOADP
 LDA XLOC
 STA PLRXPOS
 LDA YLOC
 STA PLRYPOS
 LDX MARRESTCHAR
 LDA MARRESTCHAR+1
 JSR SAVEPLR

:MTHEN LDX XLOC
 STX PLRXPOS
 LDY YLOC
 STY PLRYPOS
 LDA LEVEL
 STA PLRZPOS
 STZ PARTYNUM
 JSR SHOWMAP

 LDX XLOC
 LDY YLOC
 LDA #-1
 JSR PUTMAP2M ;Subtract monster from this square

 LDA MLEVEL
 BNE :DMTHEN
 LDA MDIR
 CMP #10
 BNE :DMTHEN
 LDX XLOC ;Subtract person from this square
 LDY YLOC
 LDA #-1
 JSR PUTMAP2

 LDX XLOC ;We back in the jail 'square'?
 LDY YLOC
 JSR GETDATA
 CMP #0
 BNE :DMTHEN
 JSR :MOVEGUP

:DMTHEN LDA #$FF
 STA MOVEFLAG

 STZ :SEECHAR

 DEC CNTRM ;Speed/move counter
 LDA CNTRM
 BNEL :PICKDIR

:MOVED LDA MZPOS
 BEQ :LOGIT
 LDA MLEVEL
 BNE :MOVED2
 BIT SAIDIT
 BPL :MOVED2
 JSR LOG200
 JSR SCROLL
 BRA :MOVED3
:MOVED2 JSR DOHV
:MOVED3 JSR PRINT
 ASC " - moved to "
 COLOR YELLOW
 PAD2 XLOC
 ASC ","
 PAD2 YLOC
 COLOR WHITE
 NULL
 LDA PLRPOS+2
 BMI :LOGIT
 JSR PRINT
 ASC " lvl "
 COLOR YELLOW
 DEC8 PLRPOS+2
 COLOR WHITE
 NULL
:LOGIT JSR LOG200
 LDA #$A
 STA LOGCOLOR
 LDX XLOC
 LDY YLOC
 LDA #1
 JSR PUTMAP2M ;Put monster back

 LDA MDIR
 CMP #10
 BNE :MTHENA
 LDA MLEVEL
 BNE :MTHENA
 LDX XLOC ;Put player back
 LDY YLOC
 LDA #1
 JSR PUTMAP2

:MTHENA BIT ATTFLAG
 BMIL :ATT2
 INCR MOVED

 LDA MDIR
 CMP #10
 BNE :ATT2
 LDA MLEVEL
 BNE :ATT2
 BRA :ATT3

:ATT LDA #$FF
 STA ATTFLAG
 LDX MXPOS
 LDY MYPOS
 LDA #1
 JSR PUTMAP2M ;Put monster back

:ATT2 BIT ATTFLAG
 BPL :ATT3
 BIT MOVEFLAG
 BPL :ATT3
 LDA MLEVEL
 BEQ :ATT3
 DECR ATTACKED
 INCR ATTMOVE

:ATT3 LDX :CNTR
 LDA :CNTR+1
 JSR SAVEMON2
 LDA MLEVEL
 BNE :NEXTM
 LDA MDIR
 CMP #10
 BNE :NEXTM
 LDX MARRESTCHAR
 LDA MARRESTCHAR+1
 JSR LOADP
 JSR PLOGDRAG

:NEXTM LDX GLEVEL
 CPX LEVEL
 BEQ :NEXTM2
 LDX LEVEL
 LDA #0
 JSR SAVEMAP2
 LDX GLEVEL
 LDA #0
 JSR LOADMAP
 LDX GLEVEL
 LDA #0
 JSR LOADMAP2
 LDA GLEVEL
 STA LEVEL
:NEXTM2 DECR :CNTR
 LDA :CNTR+1
 BNE :Z
 LDA :CNTR
 BEQ :DONE
:Z JMP ]LOOP
:DONEXT LDA CNTRM
 CMP MSPEED
 BNEL :MOVED
:STILL JSR DOHV
 JSR PRINT
 ASC " - "
 COLOR PINK
 ASC "didn't move"
 COLOR WHITE
 SOUND $25;1;$FF
 CR
 NULL
 JSR LOG200
 INCR NOTMOVED
 LDX MXPOS
 LDY MYPOS
 LDA #1
 JSR PUTMAP2M ;Put monster back
 JMP :NEXTM

:DONE JSR SCROLL
 JSR PRINT
 COLOR YELLOW
 DEC16 MOVED
 COLOR WHITE
 ASC " moved, "
 COLOR YELLOW
 DEC16 NOTMOVED
 COLOR WHITE
 ASC " didn't move, "
 COLOR YELLOW
 DEC16 ATTACKED
 COLOR WHITE
 ASC " attacked, "
 COLOR YELLOW
 DEC16 ATTMOVE
 COLOR WHITE
 ASC " moved & attacked."
 NULL
 NOTELOGNUM $B;"Monster status for Level ";LEVEL
 LDA LOGCOLOR
 PHA
 LDA #$B
 STA LOGCOLOR
 JSR LOG200
 PLA
 STA LOGCOLOR
 STZ MOVED
 STZ MOVED+1
 STZ NOTMOVED
 STZ NOTMOVED+1
 STZ ATTACKED
 STZ ATTACKED+1
 STZ ATTMOVE
 STZ ATTMOVE+1
 LDX LEVEL
 JSR SVMAP2
 DEC LEVEL
 LDA LEVEL
 BNEL TOPLOOP
 JMP EXIT
:CNTR DS 2
:MDIR DS 1
:SEECHAR DS 1

:MOVEGUP LDA LEVEL
 CMP #1
 BNEL :GOUP1
 JSR LOG200
 JSR SCROLL
 LDX MARRESTCHAR ;Put player in Castle
 LDA MARRESTCHAR+1
 JSR LOADP
 JSR PRINT
 COLOR AQUAMARINE
 PRSTRING PLRNAME
 COLOR WHITE
 ASC " has been jailed"
 SOUND $28;1;$FF
 NULL
 STZ PLRXPOS
 STZ PLRYPOS
 STZ PLRZPOS
 LDA #$FF
 STA VTEMP
 CALL "GAME.PRECSTLE" ;Sentence char, log notes...
 LDX MARRESTCHAR
 LDA MARRESTCHAR+1
 JSR SAVEPLR
 STZ MTYPE ;Delete guardian
 STZ MTYPE+1
 STZ MCURHP
 LDA #5
 STA MDIR
 LDA #%1000_0000
 STA MCOND
 LDA #$FF
 STA MCONDX+7
 STZ MARRESTCHAR
 STZ MARRESTCHAR+1
 STZ MXPOS
 STZ MYPOS
 STZ MZPOS
 LDX :CNTR
 LDA :CNTR+1
 JSR SAVEMON2
 LDA #1
 STA CNTRM
 LDX XLOC
 STX PLRXPOS
 LDY YLOC
 STY PLRYPOS
 LDA LEVEL
 STA PLRZPOS
 STZ PARTYNUM
 JSR SHOWMAP
 JSR SCROLL
 RTS
:GOUP1 LDX LEVEL
 LDA #0
 JSR SAVEMAP2
 DEC LEVEL
 LDX LEVEL
 STX MZPOS
 LDA #0
 JSR LOADMAP
 LDX LEVEL
 LDA #0
 JSR LOADMAP2
 LDX MARRESTCHAR ;Put player on map
 LDA MARRESTCHAR+1
 JSR LOADP
 LDA XLOC
 STA PLRXPOS
 LDA YLOC
 STA PLRYPOS
 LDA LEVEL
 STA PLRZPOS
 LDX MARRESTCHAR
 LDA MARRESTCHAR+1
 JSR SAVEPLR
 LDA SKIPMON ;Add to table so we don't move it again
 ASL
 TAX
 LDA :CNTR
 STA SKIPMONS,X
 LDA :CNTR+1
 STA SKIPMONS+1,X
 INC SKIPMON
 LDX XLOC
 LDY YLOC
 LDA #1
 JSR PUTMAP2M ;Add monster to this square
 LDX XLOC ;Add person to this square
 LDY YLOC
 LDA #1
 JSR PUTMAP2
 LDX XLOC
 STX PLRXPOS
 LDY YLOC
 STY PLRYPOS
 LDA LEVEL
 STA PLRZPOS
 STZ PARTYNUM
 JSR SHOWMAP
 LDX XLOC
 LDY YLOC
 LDA #-1
 JSR PUTMAP2M ;Subtract monster from this square
 LDX XLOC ;Subtract person from this square
 LDY YLOC
 LDA #-1
 JSR PUTMAP2
 RTS

SKIPMON DS 1
SKIPMONS DS 2*128

DOHV JSR PRINT
HV GOTOXY 0;0
 NULL
 RTS

MERROR JSR SCROLL
 JSR PRINT
 HOME
 COLOR PINK
 LINE "Map2 monster logic error."
 COLOR WHITE
 SOUND $02;1;$FF
 NULL
 NOTELOGNUM $1;"Map2 monster logic error, level #";LEVEL
 JMP EXIT ;Don't keep going

LDMAP LDA #0
 JMP LOADMAP

LDMAP2 LDA #0
 JMP LOADMAP2

SVMAP2 LDA #0
 JMP SAVEMAP2

LEVEL DS 4 ;Used for NOTELOGNUM as well
GLEVEL DS 1
MONSTERS DS 2

TEMPXLOC DS 1
TEMPYLOC DS 1
XLOC DS 1
YLOC DS 1
BYTE DS 1
CNTR DS 1
CNTRM DS 1
MOVED DS 4
ATTACKED DS 4
NOTMOVED DS 4
ATTMOVE DS 4
OKSHAPES DFB SHPSPACE,SHPSTAIRS,SHPDARK,SHPSIGN,SHPWATER,SHPHILLS
 DFB SHPSWAMP,SHPSIGN,SHPGATE
 DFB $FF
OKSHAPESG DFB SHPSPACE,SHPSTAIRS,SHPDARK,SHPSIGN,SHPWATER,SHPHILLS
 DFB SHPSWAMP,SHPGATE,SHPSAFETY,SHPMONGEN,SHPFF,SHPALTAR
 DFB SHPFOUNTAIN
 DFB $FF

MAPBOX JSR PRINT
 NORMAL
 MTOFF
 CURSOROFF
 GOTOXY 4;1
 LUP 18
 ASC "_"
 --^
 CR
 MTON
 INVERSE
 NULL
 LDX #9
]LOOP JSR PRINT
 HTAB 3
 ASC "Z"
 HTAB 22
 ASC "_"
 CR
 NULL
 DEX
 BNE ]LOOP
 JSR PRINT
 HTAB 4
 LUP 18
 ASC "L"
 --^
 NORMAL
 MTOFF
 CR
 HTAB 4
 ASC "Loc: ??,??  Lvl: ?"
 NULL
 RTS

BOTLINES JSR PRINT
 GOTOXY 0;14
 INVERSE
 COLOR YELLOW
 ZAPLINE
 GOTOXY 0;23
 ZAPLINE
 COLOR WHITE
 NORMAL
 NULL
 RTS

SCROLL LDX #16
]LOOP PHX
 TXA
 DEX
 STX :V+3
 LDX #0
 LDY #79
 JSR PICKLINE ;A=line, X=from, Y=to
 JSR PRINT
:V GOTOXY 0;15
 NULL
 LDX #0
]LOOP2 LDA $200,X
 JSR COUT
 INX
 CPX #80
 BNE ]LOOP2
 PLX
 INX
 CPX #23
 BNE ]LOOP
 JSR PRINT
 GOTOXY 0;22
 ZAPLINE
 NULL
 RTS

LOG200 LDA LOGCOLOR
 STA :COLOR+3
 LDA #22 ;Log monster move (in the LOG)
 LDX #0
 LDY #79
 JSR PICKLINE
 LDX #79
]LOOP LDA $200,X
 CMP #" "
 BNE :OK
 DEX
 BNE ]LOOP
 RTS ;Blank line
:OK INX
 STX MISCBUFF
]LOOP LDA $200,X
 STA MISCBUFF+1,X
 DEX
 BPL ]LOOP
:COLOR NOTELOGBUFF $A;MISCBUFF
 RTS
LOGCOLOR DFB $A

FINDCHAR LDA MCOND
 AND #%0000_0010 ;Blind?
 BEQ :CANSEE
 CLC
 RTS
:CANSEE STZ :FLAG
 LDA #$FF
 STA DIST
 STA DISTK
 STA DISTA
 LDA MXPOS
 SEC
 SBC #4
 STA :ANKX
 LDA MYPOS
 SEC
 SBC #4
 STA :ANKY
 LDX #0
 LDA #0
 JSR LOADP
 LDA PLRBUFF
 STA :PLRS
 LDA PLRBUFF+1
 STA :PLRS+1
 LDX #0
 LDY #0
]LOOP STX :X
 STY :Y
 JSR GETGRID
 CMP #$FF
 BEQL :NOSEE
 LDA :X
 CLC
 ADC :ANKX
 STA :XLOC
 CMP #$10
 BCSL :NOSEE
 TAX
 LDA :Y
 CLC
 ADC :ANKY
 STA :YLOC
 CMP #$10
 BCSL :NOSEE
 TAY
 PHY
 PHX
 JSR GETMAP2
 PLX
 PLY
 AND #$F
 BEQL :NOSEE ;No chars here
 JSR GETMAP
 AND #%1_1111
 CMP #SHPWALL
 BEQL :NOSEE

 LDA :PLRS
 STA :CNTRP
 LDA :PLRS+1
 STA :CNTRP+1
 BRA :KEEPON3

:KEEPON JSR :INVIS
 BCS :KEEPON1
 LDA MLEVEL
 BNE :GCONTZ
 LDA PLRPKILLS ;On the hot list?
 BNE :GCONTZ
 LDA PLRPASSAULTS ;Attacked anyone?
 BNE :GCONTZ
:KEEPON2 DECR :CNTRP
 BRA :KEEPON3
:KEEPON1 CMP #$FF
 BEQ :KEEPON2
:KEEPON3 LDA :CNTRP
 ORA :CNTRP+1
 BEQL :NOSEE
 BRA :KEEPON

:GCONTZ BIT PLRARRESTFLAG ;Already under arrest?
 BMI :KEEPON2

:GCONT LDA :XLOC ;Get distance to char
 SEC
 SBC MXPOS
 BCS :DOY
 EOR #$FF
 INC
:DOY STA VTEMP
 LDA :YLOC
 SEC
 SBC MYPOS
 BCS :POK
 EOR #$FF
 INC
:POK CMP VTEMP
 BCS :TAKEY
 LDA VTEMP
:TAKEY STA VTEMP
 LDA MLEVEL
 BNE :TAKEAWAY
 LDA PLRPKILLS ;On the hot list?
 BEQ :GASS
 LDA VTEMP
 CMP DISTK
 BCS :NOSEE ;Someone else closer on hit list
 STA DISTK
 LDA :XLOC
 STA XCHARK
 LDA :YLOC
 STA YCHARK
 BRA :GOT1
:GASS LDA PLRPASSAULTS ;Attacked anyone?
 BEQ :NOSEE ;Means guards has found someone NOT on hot list
 LDA VTEMP
 CMP DISTA
 BCS :NOSEE ;Someone else closer on hit list
 STA DISTA
 LDA :XLOC
 STA XCHARA
 LDA :YLOC
 STA YCHARA
 BRA :GOT1
:TAKEAWAY LDA VTEMP
 CMP DIST
 BCS :NOSEE ;Char further away or just as far, so forget it
 STA DIST
 LDA :XLOC
 STA XCHAR
 LDA :YLOC
 STA YCHAR
:GOT1 LDA #$FF ;'We found one'
 STA :FLAG
 LDA :CNTRP
 STA KACHAR
 LDA :CNTRP+1
 STA KACHAR+1

:NOSEE LDX :X
 LDY :Y
 INX
 CPX #9
 BNEL ]LOOP
 LDX #0
 INY
 CPY #9
 BNEL ]LOOP
 BIT :FLAG
 BMI :GOTONE
 CLC
 RTS

:GOTONE LDA DISTK
 CMP #$FF
 BEQ :GOTONE2
 STA DIST
 LDA MYPOS ;Work out which direction to take
 CMP YCHARK ; to get to character
 BCC :PK123
 BEQ :PK456
:PK789 LDA MXPOS
 CMP XCHARK
 BCCL :P9
 BEQL :P8
 BCSL :P7
:PK456 LDA MXPOS
 CMP XCHARK
 BCCL :P6
 BEQL :P5
 BCSL :P4
:PK123 LDA MXPOS
 CMP XCHARK
 BCC :P3
 BEQ :P2
 BCS :P1

:GOTONE2 LDA DISTA
 CMP #$FF
 BEQ :GOTONE3
 STA DIST
 LDA MYPOS ;Work out which direction to take
 CMP YCHARA ; to get to character
 BCC :PA123
 BEQ :PA456
:PA789 LDA MXPOS
 CMP XCHARA
 BCC :P9
 BEQ :P8
 BCS :P7
:PA456 LDA MXPOS
 CMP XCHARA
 BCC :P6
 BEQ :P5
 BCS :P4
:PA123 LDA MXPOS
 CMP XCHARA
 BCC :P3
 BEQ :P2
 BCS :P1

:GOTONE3 LDA MYPOS ;Work out which direction to take
 CMP YCHAR ; to get to character
 BCC :P123
 BEQ :P456
:P789 LDA MXPOS
 CMP XCHAR
 BCC :P9
 BEQ :P8
 BCS :P7
:P456 LDA MXPOS
 CMP XCHAR
 BCC :P6
 BEQ :P5
 BCS :P4
:P123 LDA MXPOS
 CMP XCHAR
 BCC :P3
 BEQ :P2
 BCS :P1

:P9 LDA #9
 HEX 2C
:P8 LDA #8
 HEX 2C
:P7 LDA #7
 HEX 2C
:P6 LDA #6
 HEX 2C
:P5 LDA #5
 HEX 2C
:P4 LDA #4
 HEX 2C
:P3 LDA #3
 HEX 2C
:P2 LDA #2
 HEX 2C
:P1 LDA #1
 SEC
 RTS

:INVIS
]LOOP2 LDX :CNTRP
 LDA :CNTRP+1
 JSR LOADP
 LDA PLRZPOS
 CMP LEVEL
 BNE :NXTP
 LDA PLRXPOS
 CMP :XLOC
 BNE :NXTP
 LDA PLRYPOS
 CMP :YLOC
 BNE :NXTP
 LDA MLEVEL ;Guardian can move thru safety zones
 BEQ :IHMM
 LDX PLRXPOS ;Ignore if in a safety zone
 LDY PLRYPOS
 JSR GETMAP
 CMP #SHPSAFETY
 BEQ :NXTP
:IHMM LDA PLRCOND
 AND #%1001_0000 ;Dead or Invisible?
 BEQ :NOPE
 LDA #$FF
 SEC ;Yep
 RTS
:NOPE CLC
 RTS
:NXTP DECR :CNTRP
 LDA :CNTRP
 ORA :CNTRP+1
 BNE ]LOOP2
 LDA #0
 SEC
 RTS

:ANKX DS 1 ;Anchor for map grid
:ANKY DS 1 ;
:X DS 1 ;Grid
:Y DS 1
:XLOC DS 1 ;Char location (current checking one)
:YLOC DS 1
:FLAG DS 1 ;Did we find a chracter?
:DIR DS 1 ;Direction to char
:PLRS DS 2
:CNTRP DS 2

DIST DS 1 ;Distance to char
DISTK DS 1 ;Distance to char (hot list)
DISTA DS 1 ;Distance to char (people basher)
XCHAR DS 1 ;Location of closest char
YCHAR DS 1
XCHARK DS 1 ;Location of closest char (hot list)
YCHARK DS 1
XCHARA DS 1 ;Location of closest char (people basher)
YCHARA DS 1
KACHAR DS 2 ;Hot list / people basher char number

ATTACK LDA MREACH ;Monster within range to attack?
 CMP DIST
 BCS :ATAK
 RTS
:ATAK JSR DOHV
 LDA MLEVEL
 BNEL :ATAK2
 LDA DISTK
 CMP #$FF
 BEQ :ATX2
 LDX XCHARK
 LDY YCHARK
 BRA :ATAKG
:ATX2 LDX XCHARA
 LDY YCHARA
:ATAKG STX XCHAR
 STY YCHAR
 JSR PRINT ;Guardian!
 ASC " - makes an arrest at "
 COLOR YELLOW
 PAD2 XCHAR
 ASC ","
 PAD2 YCHAR
 COLOR WHITE
 SOUND $13;1;$FF
 NULL
 INCR ARRESTED
 LDX KACHAR
 LDA KACHAR+1
 JSR LOADPLR
 LDA #%1000_0000 ;You have the right to remain silent...
 TSB PLRARRESTFLAG
 LDX KACHAR
 LDA KACHAR+1
 JSR SAVEPLR
 JSR LOG200
 JSR SCROLL
 JSR PRINT
 ASC "Player #"
 COLOR YELLOW
 DEC16 KACHAR
 COLOR WHITE
 ASC ", "
 COLOR GREEN
 PRSTRING PLRNAME
 COLOR PINK
 ASC " has been arrested"
 COLOR WHITE
 SOUND $0A;1;$FF
 NULL
 JSR PLOGARREST ;Note in Party's History Log
 LDX KACHAR
 STX :VICTIM
 STX MARRESTCHAR
 LDA KACHAR+1
 STA :VICTIM+1
 STA MARRESTCHAR+1
 LDA #10 ;Made an arrest, so go back to jail
 STA MDIR
 LDA #$FF
 STA SAIDIT
 LDA #9
 STA LOGCOLOR
 LDA PLRXPOS
 STA PLRPOS
 LDA PLRYPOS
 STA PLRPOS+1
 LDA PLRZPOS
 STA PLRPOS+2
 JMP :GOBACKNOL

:ATAK2 JSR PRINT
 ASC " - attacks "
 COLOR YELLOW
 PAD2 XCHAR
 ASC ","
 PAD2 YCHAR
 COLOR WHITE
 NULL
 INCR ATTACKED
 JSR LOG200
 JSR SCROLL
 LDX XCHAR
 LDY YCHAR
 JSR GETMAP2
 AND #$0F
 TAX
 LDA #0
 JSR RANDOM ;Attack someone at random
 STX TEMP
 STZ :DEADFLAG
:TRY2 LDX #0
 LDA #0
 JSR LOADP
 LDA PLRBUFF
 STA VTEMP
 LDA PLRBUFF+1
 STA VTEMP+1
]LOOP LDA VTEMP
 ORA VTEMP+1
 BNE :OKLOAD
 LDA :DEADFLAG
 EOR #$FF
 STA :DEADFLAG
 BMI :TRY2
 CLC ;Just in case they're all dead, sir..
 RTS
:OKLOAD LDX VTEMP
 LDA VTEMP+1
 JSR LOADP
 BIT PLRFREE
 BMI :LNEXT
 LDA PLRSCENARIO
 CMP SCENARIO
 BNE :LNEXT
 LDA PLRZPOS
 CMP LEVEL
 BNE :LNEXT
 LDA PLRXPOS
 CMP XCHAR
 BNE :LNEXT
 LDA PLRYPOS
 CMP YCHAR
 BNE :LNEXT
 LDA PLRCOND
 AND #%1000_0000 ;Dead?
 BNE :LNEXT
 BIT :DEADFLAG
 BMI :GOTCHAR ;Second time through, attack first live one
 DEC TEMP
 LDA TEMP
 BEQ :GOTCHAR
:LNEXT DECR VTEMP
 JMP ]LOOP
:GOTCHAR LDA VTEMP
 STA :VICTIM
 LDA VTEMP+1
 STA :VICTIM+1
 JSR PRINT
 ASC "Player #"
 COLOR YELLOW
 DEC16 :VICTIM
 COLOR WHITE
 ASC ", "
 COLOR GREEN
 PRSTRING PLRNAME
 COLOR WHITE
 ASC " "
 NULL
 JSR PLOGATTACK ;Note in Party's History Log

* LDA MDAM
* STA IDAT1 ;Damage amount
* LDA MDAMMOD
* STA IDAT2 ;Damage modifier
* LDA #0
* STA IDAT3 ;Skill level
* LDA MDAMTYPE
* STA IDAT4 ;Damage type (eg; crush)
* LDA MDX
* CLC
* ADC IDAT3 ;Weapon skill
* STA :SKILL ;Effective skill

 LDA MDX
 STA :SKILL

 LDA PLRCOND
 AND #%0100_1011 ;Paralyzed, asleep, blind, stunned?
 BEQ :NC1
 INC :SKILL
:NC1 LDA PLRCOND
 AND #%0000_0100 ;Levitating?
 BEQ :NC2
 DEC :SKILL
:NC2
 LDX #3
 JSR ROLLD6 ;Get Attack Roll (3d6)
 LDA VTEMP ;If roll <= :SKILL then HIT
 CMP :SKILL
 BEQ :AOK
 BCC :AOK
 JMP :MISS

:AOK LDX :VICTIM
 LDA :VICTIM+1
 JSR LOADP
 STZ :PD
 STZ :DR
 LDX #0
]LOOP STX VTEMP
 LDA PLRITEM,X
 BEQ :NO
 TAX
 LDA #0
 JSR LOADITEM
 LDA ITYPE
 CMP #2
 BCC :NO
 CMP #6
 BCS :NO
 LDX VTEMP
 LDA PLRITEMX,X
 CMP #1 ;Equipped?
 BNE :NO
 LDA :PD
 CLC
 ADC IDAT1 ;Passive defense
 STA :PD
 LDA :DR
 CLC
 ADC IDAT2 ;Damage resistance
 STA :DR
:NO INC VTEMP
 LDX VTEMP
 CPX #8
 BNE ]LOOP

* LDA :PD
* CLC
* ADC PLRSPEED
* STA :PD

 LDA PLRAC ;Use AC to see if player gets hit
 EOR #$FF ;_AC__Calc for defense roll (3d6)
 INC ;-10   20  : almost impossible to hit
 CLC ;  0   10  : about 50% chance of being hit
 ADC #10 ; 10    0  : almost certain to be hit
 STA :PD

 LDX #3
 JSR ROLLD6 ;Calculate Defense Roll (3d6)
 LDA VTEMP ;If roll <= PD then BLOCKED
 CMP #18 ;Critical success
 BEQ :BL
 CMP #3 ;Critical failure
 BEQ :HIT2
 CMP :PD ;else HIT
 BEQ :BL
 BCS :HIT2
:BL JMP :BLOCKED

:HIT2 LDA MDAM
 STA :DIEDAM
 LDA MDAMMOD
 STA :DAMMOD

 LDX :DIEDAM
 JSR ROLLD6 ;Calculate damage
 LDA VTEMP
 CLC
 ADC :DAMMOD
 BMI :MINUS
 CMP :DIEDAM
 BCS :DICEOK
:MINUS LDA :DIEDAM
:DICEOK STA VTEMP

 LDA PLRCOND
 AND #%0000_1000 ;Asleep?
 BEQ :AWAKE
 LDA VTEMP
 LSR
 CLC
 ADC VTEMP ;Dam inc by 50%
 STA VTEMP
:AWAKE LDA VTEMP
 SEC
 SBC :DR ;Subtract DR
 STA :DAMAGE
 DEC
 CMP #$80
 BCC :HIT3
 JMP :REFLECTED ;Hit bounced off armour or something

:HIT3 LDA MDAMTYPE ;Damage type (IDAT4)
 CMP #1
 BEQ :IMPALE
 CMP #3 ;Crush has no damage bonuses
 BEQ :CONT2
:CUT LDA :DAMAGE ;Damage increased by 50%
 LSR
 CLC
 ADC :DAMAGE
 STA :DAMAGE
 BRA :CONT2
:IMPALE LDA :DAMAGE ;Damage x 2 (increased by 100%)
 CLC
 ADC :DAMAGE
 STA :DAMAGE
:CONT2 JSR PRINT
 ASC "is hit for "
 COLOR PINK
 DEC8 :DAMAGE
 COLOR WHITE
 ASC " damage"
 NULL
 JSR RANDHITSND
 PNOTELOGNUM $1;"Damage taken (HP) - ";:DAMAGE
 LDX :VICTIM
 LDA :VICTIM+1
 JSR LOADP
 LDA PLRHP ;Subtract damage
 SEC
 SBC :DAMAGE
 STA PLRHP
 DEC
 CMP #$80
 BCC :ALIVE
 LDA PLRHP
 EOR #$FF
 INC
 CMP PLRHP+1 ;HP gone full negative?
 BCCL :UNCON
 LDX #7
]LOOP STZ PLRCONDX,X
 DEX
 BPL ]LOOP
 LDA #%1000_0000 ;Dead
 STA PLRCOND
 LDA #$FF
 STA PLRCONDX+7
 JSR PRINT
 COLOR PINK
 ASC " and dies!"
 COLOR WHITE
 NULL
 PNOTELOG $1;"..and dies!"
 JSR CHARITEMS ;Drop everything
 JMP :GOBACK
:ALIVE LDA #$80
 STA :ANDX
 STZ :SPFLAG
 LDX #7
]LOOP PHX
 LDA MSPECDAM
 AND :ANDX
 BEQL :NXTSP
 RANDNUM #4 ;25% chance special damage is incurred
 CPX #4
 BNE :NXTSP
 LDA :SPFLAG
 BMI :NOSCR
 LDA LOGCOLOR
 PHA
 LDA #9 ;Orange
 STA LOGCOLOR
 JSR LOG200 ;Log it
 PLA
 STA LOGCOLOR
 JSR SCROLL
 JSR PRINT
 ASC "..and is "
 NULL
 LDA #$FF
 STA :SPFLAG
 BRA :NOSCR2
:NOSCR JSR PRINT
 ASC ", "
 NULL
:NOSCR2 PLX
 PHX
 LDA PLRCOND
 ORA :ANDX ;Special damage incurred
 STA PLRCOND
 CPX #4 ;Upper 4 conditions are 'forever' ones
 BCS :FOREVA
 RANDNUM #3 ;Condition incurred for 1 to 3 turns
 TXA
 HEX 2C
:FOREVA LDA #$FF ;'Forever'
 PLX
 PHX
 STA PLRCONDX,X
 STA TEMP
 TXA
 ASL
 ASL
 ASL
 ASL
 TAY
 LDA :CNAMES,Y
 TAX
]LOOP2 INY
 LDA :CNAMES,Y
 JSR COUT
 DEX
 BNE ]LOOP2
 LDA TEMP
 CMP #$FF
 BEQ :NXTSP
 JSR PRINT
 ASC "("
 COLOR PINK
 DEC8 TEMP
 COLOR WHITE
 ASC ")"
 NULL
:NXTSP PLX
 LSR :ANDX
 DEX
 BPLL ]LOOP
 BIT :SPFLAG
 BPL :NAH
 LDX #0
 LDY #79
 LDA #22
 JSR PICKLINE
 LDX #79
]LOOP LDA $200,X
 CMP #" "
 BNE :AYEH
 DEX
 BPL ]LOOP
 DEATH
:AYEH INX
 STZ :FLAGBR
 LDY #0
]LOOP LDA $200,Y
 CMP #"("
 BNE :NOBR
 LDA #$FF
 STA :FLAGBR
 BRA :OVERBR
:NOBR CMP #")"
 BNE :NOBR2
 STZ :FLAGBR
 BRA :OVERBR
:NOBR2 BIT :FLAGBR
 BMI :OVERBR
 STA MISCBUFF+1,Y
 INY
:OVERBR DEX
 BPL ]LOOP
 STY MISCBUFF
 PNOTELOGBUFF $1;MISCBUFF
:NAH JMP :GOBACK
:FLAGBR DS 1
:ANDX DS 1
:SPFLAG DS 1
:DEADFLAG DS 1

:CNAMES PAD16 "stunned" ;  0 (bit representation)
 PAD16 "blinded" ;  1
 PAD16 "invisible" ;  2
 PAD16 "knocked out" ; 3
 PAD16 "levitated" ;  4
 PAD16 "poisoned" ;  5
 PAD16 "paralyzed" ; 6
 PAD16 "killed" ;  7

:UNCON LDX #3
 JSR ROLLD6 ;Roll vs Health
 LDA VTEMP
 CMP PLRHT
 BEQL :CONC
 BCCL :CONC
 LDA PLRCOND
 AND #%0000_1000 ;Unconscious?
 BEQ :UNCON2
 JSR PRINT
 COLOR PINK
 ASC " (still unconscious)"
 COLOR WHITE
 NULL
 PNOTELOG $1;"..(still unconscious)"
 JMP :GOBACK
:UNCON2 LDA PLRCOND
 ORA #%0000_1000 ;Unconscious
 STA PLRCOND
 JSR PRINT
 COLOR PINK
 ASC " and falls unconscious.."
 COLOR WHITE
 NULL
 PNOTELOG $1;"..and falls unconscious"
 JSR CHARITEMS
 JMP :GOBACK
:CONC JSR PRINT
 COLOR PINK
 ASC " and stumbles.."
 COLOR WHITE
 NULL
 PNOTELOG $1;"..and stumbles"
 JMP :GOBACK

:MISS JSR PRINT
 COLOR PINK
 ASC "is missed"
 COLOR WHITE
 SOUND $09;1;$FF
 NULL
 PNOTELOG $1;"Missed.."
 JMP :GOBACK

:BLOCKED JSR PRINT
 COLOR PINK
 ASC "blocks the attack"
 COLOR WHITE
 SOUND $0C;1;$FF
 NULL
 PNOTELOG $1;"Attack is blocked!"
 JMP :GOBACK

:REFLECTED JSR PRINT
 COLOR PINK
 COLOR WHITE
 ASC "is hit, but takes no damage"
 SOUND $0B;1;$FF
 NULL
 PNOTELOG $1;"..is hit, but takes no damage!"
:GOBACK LDA LOGCOLOR
 PHA
 LDA #9 ;Orange
 STA LOGCOLOR
 JSR LOG200 ;Log it (of course)
 PLA
 STA LOGCOLOR
:GOBACKNOL LDA #%0001_0000
 TRB PLRCOND ;Become 'visible' if attacked (remove invisible)
 LDX :VICTIM ;Save out player hit
 LDA :VICTIM+1
 JSR SAVEPLR
 SEC
 RTS

:VICTIM DS 2
:SKILL DS 1
:PD DS 1
:DR DS 1
:DIEDAM DS 1
:DAMMOD DS 1
:DAMAGE DS 4

TEMP DS 1
ATTFLAG DS 1
MOVEFLAG DS 1

PLOGARREST LDY #0
]LOOP LDA PLRNAME+1,Y
 STA MISCBUFF+1,Y
 INY
 CPY PLRNAME
 BNE ]LOOP
 INY
 LDX #0
]LOOP LDA :STR1+1,X
 STA MISCBUFF,Y
 INY
 INX
 CPX :STR1
 BNE ]LOOP
 LDA XCHAR
 JSR CONVERT
 STA MISCBUFF,Y
 INY
 TXA
 STA MISCBUFF,Y
 INY
 LDA #","
 STA MISCBUFF,Y
 INY
 LDA YCHAR
 JSR CONVERT
 STA MISCBUFF,Y
 INY
 TXA
 STA MISCBUFF,Y
 INY
 LDX #0
]LOOP LDA :STR2+1,X
 STA MISCBUFF,Y
 INY
 INX
 CPX :STR2
 BNE ]LOOP
 LDA LEVEL
 JSR CONVERT
 STA MISCBUFF,Y
 INY
 TXA
 STA MISCBUFF,Y
 INY
 LDX #0
]LOOP LDA :STR3+1,X
 STA MISCBUFF,Y
 INY
 INX
 CPX :STR3
 BNE ]LOOP
 LDA PLRPKILLS
 BEQ :NOK
 LDX #0
]LOOP LDA :STR4+1,X
 STA MISCBUFF,Y
 INY
 INX
 CPX :STR4
 BNE ]LOOP
:NOK LDA PLRPASSAULTS
 BEQ :NOA
 LDA PLRPKILLS
 BEQ :AONLY
 LDX #0
]LOOP LDA :STR5+1,X
 STA MISCBUFF,Y
 INY
 INX
 CPX :STR5
 BNE ]LOOP
:AONLY LDX #0
]LOOP LDA :STR6+1,X
 STA MISCBUFF,Y
 INY
 INX
 CPX :STR6
 BNE ]LOOP
:NOA DEY
 STY MISCBUFF
 LDA PARTYNUM
 PHA
 LDA PLRPARTY
 STA PARTYNUM
 PNOTELOGBUFF $1;MISCBUFF
 PLA
 STA PARTYNUM
 RTS
:STR1 STR " at "
:STR2 STR " lvl "
:STR3 STR " is arrested for "
:STR4 STR "murder"
:STR5 STR " and "
:STR6 STR "assault"

PLOGATTACK LDY #0
]LOOP LDA PLRNAME+1,Y
 STA MISCBUFF+1,Y
 INY
 CPY PLRNAME
 BNE ]LOOP
 INY
 LDX #0
]LOOP LDA :STR1+1,X
 STA MISCBUFF,Y
 INY
 INX
 CPX :STR1
 BNE ]LOOP
 LDA XCHAR
 JSR CONVERT
 STA MISCBUFF,Y
 INY
 TXA
 STA MISCBUFF,Y
 INY
 LDA #","
 STA MISCBUFF,Y
 INY
 LDA YCHAR
 JSR CONVERT
 STA MISCBUFF,Y
 INY
 TXA
 STA MISCBUFF,Y
 INY
 LDX #0
]LOOP LDA :STR2+1,X
 STA MISCBUFF,Y
 INY
 INX
 CPX :STR2
 BNE ]LOOP
 LDX #0
]LOOP LDA MNAME+1,X
 STA MISCBUFF,Y
 INY
 INX
 CPX MNAME
 BNE ]LOOP
 LDX #0
]LOOP LDA :STR3+1,X
 STA MISCBUFF,Y
 INY
 INX
 CPX :STR3
 BNE ]LOOP
 LDA MXPOS
 JSR CONVERT
 STA MISCBUFF,Y
 INY
 TXA
 STA MISCBUFF,Y
 INY
 LDA #","
 STA MISCBUFF,Y
 INY
 LDA MYPOS
 JSR CONVERT
 STA MISCBUFF,Y
 INY
 TXA
 STA MISCBUFF,Y
 INY
 LDX #0
]LOOP LDA :STR4+1,X
 STA MISCBUFF,Y
 INY
 INX
 CPX :STR4
 BNE ]LOOP
 LDA LEVEL
 JSR CONVERT
 STA MISCBUFF,Y
 INY
 TXA
 STA MISCBUFF,Y
 INY
 LDX #0
]LOOP LDA :STR5+1,X
 STA MISCBUFF,Y
 INY
 INX
 CPX :STR5
 BNE ]LOOP
 DEY
 STY MISCBUFF
 PNOTELOGBUFF $D;MISCBUFF
 RTS
:STR1 STR " at "
:STR2 STR " attacked by "
:STR3 STR " at "
:STR4 STR " (level "
:STR5 STR ")"

CONVERT STZ :CHAR+1
 CMP #10
 BCC :LESS
 INC :CHAR+1
 SEC
 SBC #10
:LESS STA :CHAR
 ORA #"0"
 TAX
 LDA :CHAR+1
 ORA #"0"
 RTS
:CHAR DS 2

LOADP JSR LOADPLR
 LDA PLRPARTY
 STA PARTYNUM
 RTS

DOCONDS LDA MTYPE
 CMP SCMON2KILL
 BNE :NOTIT
 LDA MCOND
 AND #%0110_1011
 BEQ :ITOK
 LDA #%0110_1011 ;Monster to kill is strong!
 TRB MCOND
 NOTELOGSTR $7;"Monster to kill; conditions reset - ";MNAME
:ITOK CLC
 RTS
:NOTIT LDA MCOND ;Check conditions
 AND #%0010_0000 ;Poisoned?
 BEQ :OK
 RANDNUM #2
 STX :POISON
 LDA MHP
 SEC
 SBC :POISON
 STA MHP
 BCS :OK
 LDA #%1000_0000 ;Died..
 STA MCOND
 LDX #7
]LOOP STZ MCONDX,X
 DEX
 BPL ]LOOP
 LDA #$FF
 STA MCONDX+7
 JSR PRINT
 ASC " - "
 COLOR PINK
 ASC "dies from poisoning"
 COLOR WHITE
 SOUND $0D;1;$FF
 NULL
 SEC
 RTS
:OK LDA #$80
 STA :ANDX
 LDX #7
]LOOP LDA MCOND
 AND :ANDX
 BEQ :NXTCON
 CPX #7 ;Dead
 BEQ :NOMOVE
 DEC MCONDX,X
 LDA MCONDX,X
 BNE :NXTCON
 LDA :ANDX ;Condition has 'expired'
 TRB MCOND ;So clear it
:NXTCON LSR :ANDX
 DEX
 BPL ]LOOP
:NOMOVE CLC
 RTS
:ANDX DS 1
:POISON DS 1

EXIT STZ MAPLOOK
 RETURN

GETJAILPATH ;Find fastest path back to jail (it's hot!)
 LDX #0 ;Set up map data
 LDA #$FF ;Values cannot reach $FF with this method
]LOOP STA MAZEDATA,X ; (if maze if 16 x 16)
 INX
 BNE ]LOOP

 STZ JAILX
 STZ JAILY

 LDA LEVEL
 CMP #1
 BNE :SMILIE

 LDX #0
 LDY #0
]LOOP PHX
 PHY
 JSR GETMAP
 CMP #SHPSTAIRS ;Look for stairs up to Castle
 BNE :UMNO
 CPX #STAIRSUP
 BEQ :CHKUP
:UMNO PLY
 PLX
 INX
 CPX #$10
 BNE ]LOOP
 LDX #0
 INY
 CPY #$10
 BNE ]LOOP
 BRA :JCONT
:CHKUP PLA
 STA JAILY
 PLA
 STA JAILX
 LDX #0
 LDA #0
 JSR LOADST
 LDA STBUFF
 BEQ :JCONT
 TAX
]LOOP2 PHX
 LDA #0
 JSR LOADST
 LDA STZPOS
 CMP LEVEL
 BNE :NEXTST
 LDA STXPOS
 CMP JAILX
 BNE :NEXTST
 LDA STYPOS
 CMP JAILY
 BNE :NEXTST
 LDA STGOTOZ
 BNE :NEXTST
 PLX
 BRA :JCONT
:NEXTST PLX
 DEX
 BNE ]LOOP2
 LDX :SMILEX
 DEX
 JMP ]LOOP
:JX DS 1
:JY DS 1
:SMILEX DS 1

:SMILIE LDX #0
 LDY #0
]LOOP PHX
 PHY
 JSR GETMAP
 CMP #SHPMONGEN
 BNE :SMNO
 CPX #MONGENGUARDIAN
 BEQ :AJAIL
:SMNO PLY
 PLX
 INX
 CPX #$10
 BNE ]LOOP
 LDX #0
 INY
 CPY #$10
 BNE ]LOOP
 BRA :JCONT
:AJAIL PLA
 STA JAILY
 PLA
 STA JAILX

:JCONT LDX JAILX
 LDY JAILY
 LDA #0 ;Lowest number
 JSR PUTDATA

 STZ :VALUE ;Look for this
]TOPLOOP STZ :X
 STZ :Y
 STZ :FLAG
]LOOP LDX :X
 LDY :Y
 JSR GETDATA
 CMP :VALUE
 BNE :NEXT

 LDA :X
 DEC
 STA :XREL
 LDA :Y
 DEC
 STA :YREL
 STZ :CNTRH
 STZ :CNTRV
]LOOP2 LDX :XREL
 CPX #16
 BCS :NEXT1
 LDY :YREL
 CPY #16
 BCS :NEXT1
 JSR GETDATA
 CMP #$FF
 BNE :NEXT1 ;Already given a value
 LDX :XREL
 LDY :YREL
 JSR GETMAP
 STA BYTE ;Is it ok?
 LDX #-1
]LOOP3 INX
 LDA OKSHAPESG,X
 CMP #$FF
 BEQ :NEXT1
 CMP BYTE
 BNE ]LOOP3
 LDA :VALUE
 INC
 LDX :XREL
 LDY :YREL
 JSR PUTDATA ;Put this value there
 LDA #$FF
 STA :FLAG
:NEXT1 INC :CNTRH
 INC :XREL
 LDA :CNTRH
 CMP #3
 BNE ]LOOP2
 STZ :CNTRH
 LDA :XREL
 SEC
 SBC #3
 STA :XREL
 INC :CNTRV
 INC :YREL
 LDA :CNTRV
 CMP #3
 BNE ]LOOP2

:NEXT INC :X
 LDA :X
 CMP #16
 BNEL ]LOOP
 STZ :X
 INC :Y
 LDA :Y
 CMP #16
 BNEL ]LOOP

 BIT :FLAG
 BPL :FINZ

 INC :VALUE
 LDA :VALUE
 BNEL ]TOPLOOP

:FINZ LDX MXPOS ;Find out what value monster is on
 LDY MYPOS
 JSR GETDATA
 STA :VAL

 STZ :X
]LOOP LDX :X
 LDA :XOFFS,X
 CLC
 ADC MXPOS
 CMP #16
 BCS :NEXTO
 STA :XREL
 LDA :YOFFS,X
 CLC
 ADC MYPOS
 CMP #16
 BCS :NEXTO
 STA :YREL
 LDX :XREL
 LDY :YREL
 JSR GETDATA
 CMP :VAL ;Is it less?
 BCS :NEXTO
 LDX :X
 LDA :OFFDIR,X
 RTS
:NEXTO INC :X
 LDX :X
 CPX #9
 BNE ]LOOP
 RANDNUM #9 ;Might not be any path to jail
 TXA
 RTS ;Just in case..

:XOFFS DFB -1,0,1,-1,0,1,-1,0,1
:YOFFS DFB -1,-1,-1,0,0,0,1,1,1
:OFFDIR DFB 7,8,9,4,5,6,1,2,3

:X DS 1
:Y DS 1
:XREL DS 1
:YREL DS 1
:VALUE DS 1
:CNTRH DS 1
:CNTRV DS 1
:VAL DS 1
:FLAG DS 1

GETDATA JSR CALCDATA
 LDA MAZEDATA,X
 RTS

PUTDATA PHA
 JSR CALCDATA
 PLA
 STA MAZEDATA,X
 RTS

CALCDATA TXA
 AND #$F
 STA :VAL
 TYA
 AND #$F
 ASL
 ASL
 ASL
 ASL
 ORA :VAL
 TAX
 RTS
:VAL DS 1

JAILX DS 1 ;Jail location in maze
JAILY DS 1
ARRESTED DS 2 ;Total arrested this level

MAZEDATA DS 16*16

GETJAILCHAR LDX MARRESTCHAR
 LDA MARRESTCHAR+1
 JSR LOADP
 RTS

CHARITEMS STZ :FLAG
 LDA PLRGOLD
 ORA PLRGOLD+1
 ORA PLRGOLD+2
 ORA PLRGOLD+3
 BEQ :NOGOLD
 JSR GETITEM
 STZ INUM ;0 = gold
 LDA PLRXPOS
 STA IXPOS
 LDA PLRYPOS
 STA IYPOS
 LDA PLRZPOS
 STA IZPOS
 LDX #3
]LOOP LDA PLRGOLD,X
 STA IDATA,X
 DEX
 BPL ]LOOP
 STZ IFREE
 JSR SAVEI
 DEC :FLAG
:NOGOLD LDX #0 ;Put all chars items into maze item file
]LOOP LDA PLRITEM ;ie. drop all his items (or hers)
 BEQ :DONE
 JSR GETITEM
 LDA PLRITEM
 STA INUM
 LDA PLRXPOS
 STA IXPOS
 LDA PLRYPOS
 STA IYPOS
 LDA PLRZPOS
 STA IZPOS
 STZ IDATA
 STZ IDATA+1
 STZ IDATA+2
 STZ IDATA+3
 STZ IBURIED
 STZ IFREE
 PHX
 JSR SAVEI
 DEC :FLAG
 LDX #0
]LOOP2 LDA PLRITEM+1,X ;Crunch items
 STA PLRITEM,X
 LDA PLRITEMX+1,X
 STA PLRITEMX,X
 INX
 CPX #7
 BNE ]LOOP2
 STZ PLRITEM+7
 STZ PLRITEMX+7
 PLX
 INX
 CPX #8
 BNE ]LOOP
:DONE LDA IRECS ;Update Maze Items (total)
 STA ITEM2BUFF
 STZ ITEM2BUFF+1
 LDX #0
 LDA #0
 JSR SAVEITEM2
 JSR CALCPLR
 BIT :FLAG ;Got anything?
 BEQ :NONE
 JSR PRINT
 SOUND $0E;1;$80
 NULL
 RTS
:NONE JSR PRINT
 SOUND $0D;1;$80
 NULL
 RTS
:FLAG DS 1

GETITEM LDA IRECS
 BEQ :NEXT
 LDA :RECS
 CMP IRECS
 BEQ :NEXT
]LOOP INC :RECS
 LDX :RECS
 LDA #0
 JSR LOADITEM2
 LDA IFREE
 BMI :GOTIT
 LDA :RECS
 CMP IRECS
 BCC ]LOOP
:NEXT INC IRECS
 LDA IRECS
 STA NEWITEM
 STA :RECS
 RTS
:GOTIT LDA :RECS
 STA NEWITEM
 RTS
:RECS DS 1

SAVEI LDX NEWITEM
 LDA #0
 JMP SAVEITEM2

NEWITEM DS 1
MAXITEMS DS 1
IRECS DS 1

RANDHITSND RANDNUM #6 ;Random hit sound (1 of 6)
 TXA
 CLC
 ADC #2
 STA :S+2
 JSR PRINT
:S SOUND $0;1;$FF
 NULL
 RTS

CLOSEGATES LDA MXPOS
 DEC
 STA :XPOS
 LDA MYPOS
 DEC
 STA :YPOS
 STZ :FLAG
 LDX #3
 LDY #3
]LOOP PHX
 PHY
 LDX :XPOS
 LDY :YPOS
 JSR GETMAP
 CMP #SHPGATE
 BNE :NEXT
 CPX #GATEOPEN
 BNE :NEXT
 LDX :XPOS
 LDY :YPOS
 LDA #GATECLOSED
 XBA
 LDA #SHPGATE
 JSR PUTMAP
 LDA #$FF
 STA :FLAG
:NEXT PLY
 PLX
 INC :XPOS
 DEX
 BNE ]LOOP
 LDA :XPOS
 SEC
 SBC #3
 STA :XPOS
 INC :YPOS
 LDX #3
 DEY
 BNE ]LOOP
 BIT :FLAG
 BPL :OK
 LDX LEVEL
 LDA #0
 JSR SAVEMAP
:OK RTS

:XPOS DS 1
:YPOS DS 1
:FLAG DS 1

SAIDIT DS 1

PLOGDRAG LDA PLRXPOS
 CMP PLRPOS
 BNE :GO
 LDA PLRYPOS
 CMP PLRPOS+1
 BNE :GO
 LDA PLRZPOS
 CMP PLRPOS+2
 BNE :GO
 RTS
:GO LDY #0
]LOOP LDA PLRNAME+1,Y
 STA MISCBUFF+1,Y
 INY
 CPY PLRNAME
 BNE ]LOOP
 INY
 LDX #0
]LOOP LDA :STR1+1,X
 STA MISCBUFF,Y
 INY
 INX
 CPX :STR1
 BNE ]LOOP
 LDX #0
]LOOP LDA MNAME+1,X
 STA MISCBUFF,Y
 INY
 INX
 CPX MNAME
 BNE ]LOOP
 LDX #0
]LOOP LDA :STR2+1,X
 STA MISCBUFF,Y
 INY
 INX
 CPX :STR2
 BNE ]LOOP
 LDA PLRPOS
 JSR CONVERT
 STA MISCBUFF,Y
 INY
 TXA
 STA MISCBUFF,Y
 INY
 LDA #","
 STA MISCBUFF,Y
 INY
 LDA PLRPOS+1
 JSR CONVERT
 STA MISCBUFF,Y
 INY
 TXA
 STA MISCBUFF,Y
 INY
 LDX #0
]LOOP LDA :STR3+1,X
 STA MISCBUFF,Y
 INY
 INX
 CPX :STR3
 BNE ]LOOP
 LDA PLRPOS+2
 JSR CONVERT
 STA MISCBUFF,Y
 INY
 TXA
 STA MISCBUFF,Y
 INY
 LDX #0
]LOOP LDA :STR4+1,X
 STA MISCBUFF,Y
 INY
 INX
 CPX :STR4
 BNE ]LOOP
 LDA MXPOS
 JSR CONVERT
 STA MISCBUFF,Y
 INY
 TXA
 STA MISCBUFF,Y
 INY
 LDA #","
 STA MISCBUFF,Y
 INY
 LDA MYPOS
 JSR CONVERT
 STA MISCBUFF,Y
 INY
 TXA
 STA MISCBUFF,Y
 INY
 LDX #0
]LOOP LDA :STR5+1,X
 STA MISCBUFF,Y
 INY
 INX
 CPX :STR5
 BNE ]LOOP
 LDA LEVEL
 JSR CONVERT
 STA MISCBUFF,Y
 INY
 TXA
 STA MISCBUFF,Y
 STY MISCBUFF
 LDA PLRPARTY
 STA PARTYNUM
 PNOTELOGBUFF $1;MISCBUFF
 RTS
:STR1 STR " dragged by "
:STR2 STR " from "
:STR3 STR " lvl "
:STR4 STR " to "
:STR5 STR " lvl "

PLRPOS DS 3

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/GAME.MOVEMON
 fin

 END
