*-------------------------------
* GAME.NEWPLR
*-------------------------------
 DAT
 LST OFF

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE VARS
 USE PLR.DSECT
 USE LIB.JMP
 USE TABLES
 USE ITEM.DSECT
 USE PN.DSECT

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/GAME.NEWPLR
 fin

 MODID "GAME.NEWPLR"

START LDX #0
 LDA #0
 JSR LOADPLR
 LDA PLRBUFF
 STA PLRS
 LDA PLRBUFF+1
 STA PLRS+1

 STZ PLRFREE

 MLI_GET_TIME
 LDA $BF91
 STA PLRMADE+1
 LDA $BF90
 STA PLRMADE

 LDA #1
 STA PLRLEVEL
 STA PLRLVLREAL

 STZ PLRXPOS
 STZ PLRYPOS
 STZ PLRZPOS

 STZ PLREXP+3
 STZ PLREXP+2
 STZ PLREXP+1
 STZ PLREXP

 STZ PLRCLASS

 LDA #10
 STA PLRST
 STA PLRDX
 STA PLRIQ
 STA PLRHT

 STZ PLRCOND

 LDX #7
]LOOP STZ PLRCONDX,X
 DEX
 BPL ]LOOP

 LDX #7
]LOOP STZ PLRITEM,X
 STZ PLRITEMX,X
 DEX
 BPL ]LOOP

 LDX #3
]LOOP LDA STARTGOLD,X
 STA PLRGOLD,X
 DEX
 BPL ]LOOP

 LDA NEWPOINTS
 LSR
 AND #%1111_1110
 STA POINTSMIN

 STZ PLRMAGIC
 STZ PLRMAGICMAX

 LDX #3
]LOOP STZ PLRSPELWIZ,X
 STZ PLRSPELCLE,X
 STZ PLRSPELSAG,X
 DEX
 BPL ]LOOP

 STZ PLRCREDITS

 STZ PLRPKILLS
 STZ PLRPKILLS+1
 STZ PLRPASSAULTS
 STZ PLRPASSAULTS+1
 STZ PLRJAILED
 STZ PLRJAILED+1
 STZ PLRARRESTFLAG
 STZ PLRPKILLSMAX
 STZ PLRPKILLSMAX+1
 STZ PLRPASSAULTSMAX
 STZ PLRPASSAULTSMAX+1

 STZ PLRQUOTE

 LDA PNSCENARIO
 STA PLRSCENARIO

 JSR PRINT
 HOME
 SOUND $1A;FOREVER;$80
 COLOR WHITE
 CENTER "- Character Creation -"
 CR
 CR
 ASC "You have "
 COLOR ORANGE
 DEC8 NEWPOINTS
 COLOR WHITE
 ASC " points to allocate to four attributes. This "
 ASC "determines your strengths and weaknesses."
 CR
 CR
 COLOR AQUAMARINE
 LINE " Attribute          Cost    Class"
 CR
 COLOR WHITE
 LINE " Strength  = 10        0"
 CR
 LINE " Dexterity = 10        0"
 CR
 LINE " IQ        = 10        0"
 CR
 LINE " Health    = 10        0"
 CR
 COLOR GREEN
 ASC " Total cost :     "
 COLOR ORANGE
 ASC "0"
 COLOR WHITE
 NULL

 LDA PADFLAG
 STA CPADFLAG
 LDA PADCHAR
 STA CPADCHAR
 LDA #$FF
 STA PADFLAG
 LDA #" "
 STA PADCHAR

 JSR PRINT
 GOTOXY 0;17
 ASC "Use arrow keys to move pointer, + (or =) and - will alter "
 ASC "point values."
 CR
 LINE "Press [RETURN] when done, [ESC] to exit."
 CURSOROFF
 NULL

DOKEY JSR DOPOINT

GETKEY
]LOOP JSR KEYIN
 JSR UPPER
 LDX :KEYS
]LOOP2 CMP :KEYS,X
 BEQ :GOTONE
 DEX
 BNE ]LOOP2
 BRA ]LOOP
:GOTONE DEX
 TXA
 ASL
 TAX
 JMP (:TABLE,X)

:KEYS DFB :ENDKEYS-*-1
 DFB "K"-$40
 DFB "J"-$40
 DFB "M"-$40
 DFB $9B
 DFB "+"
 DFB "="
 DFB "-"
:ENDKEYS

:TABLE DA UP
 DA DOWN
 DA DONE
 DA ESC
 DA PLUS
 DA PLUS
 DA MINUS

UP LDA PNTR
 BNE :OK
 LDA #4
:OK DEC
 STA PNTR
 JMP DOKEY

DOWN LDA PNTR
 CMP #3
 BNE :OK
 LDA #$FF
:OK INC
 STA PNTR
 JMP DOKEY

PLUS LDX PNTR
 LDA PLRST,X
 CMP #18
 BEQ :NO
 INC PLRST,X
 JMP UPDATE
:NO JMP GETKEY

MINUS LDX PNTR
 LDA PLRST,X
 CMP #1
 BEQ :NO
 DEC PLRST,X
 JMP UPDATE
:NO JMP GETKEY

UPDATE LDA PNTR
 ASL
 TAX
 JMP (:UPDATES,X)

:UPDATES DA UPDST
 DA UPDDX
 DA UPDIQ
 DA UPDHT

UPDST LDA PLRST
 DEC
 ASL
 TAX
 LDA TABLE,X
 STA COSTST
 LDA TABLE+1,X
 STA COSTST+1
 JSR PRINT
 GOTOXY 12;7
 DEC8 PLRST
 HTAB 21
 DEC8NEG COSTST
 NULL
 JMP DISPTOT

UPDDX LDA PLRDX
 DEC
 ASL
 TAX
 LDA TABLE,X
 STA COSTDX
 LDA TABLE+1,X
 STA COSTDX+1
 JSR PRINT
 GOTOXY 12;9
 DEC8 PLRDX
 HTAB 21
 DEC8NEG COSTDX
 NULL
 JMP DISPTOT

UPDIQ LDA PLRIQ
 DEC
 ASL
 TAX
 LDA TABLE,X
 STA COSTIQ
 LDA TABLE+1,X
 STA COSTIQ+1
 JSR PRINT
 GOTOXY 12;11
 DEC8 PLRIQ
 HTAB 21
 DEC8NEG COSTIQ
 NULL
 JMP DISPTOT

UPDHT LDA PLRHT
 DEC
 ASL
 TAX
 LDA TABLE,X
 STA COSTHT
 LDA TABLE+1,X
 STA COSTHT+1
 JSR PRINT
 GOTOXY 12;13
 DEC8 PLRHT
 HTAB 21
 DEC8NEG COSTHT
 NULL
 JMP DISPTOT

DISPTOT JSR PRINT
 GOTOXY 14;15
 NULL
 STZ TOTALCOST
 STZ TOTALCOST+1
 LDX #6
]LOOP LDA COSTST,X
 CLC
 ADC TOTALCOST
 STA TOTALCOST
 LDA COSTST+1,X
 ADC TOTALCOST+1
 STA TOTALCOST+1
:CONT2 DEX
 DEX
 BPL ]LOOP
 LDA TOTALCOST+1
 BPL :POS
 JSR PRINT
 COLOR ORANGE
 ASC "-"
 NULL
 LDA TOTALCOST+1 ;Two's complement
 EOR #$FF
 STA TOTALCOST+1
 LDA TOTALCOST
 EOR #$FF
 STA TOTALCOST
 INCR TOTALCOST
:POS JSR PRINT
 CLEOL
 COLOR ORANGE
 DEC16 TOTALCOST
 COLOR WHITE
 NULL

 LDX #8
]LOOP STZ CLASS,X
 DEX
 BPL ]LOOP

 STZ VTEMP+1
 LDX #0
]LOOP2 STX VTEMP
 LDY #0
]LOOP LDA MINATTR,X
 CMP #$FF
 BEQ :FIN
 LDA PLRST,Y
 CMP MINATTR,X
 BCC :NEXT
 INX
 INY
 CPY #4
 BNE ]LOOP
 LDA #$FF
 HEX 2C
:NEXT LDA #0
 LDX VTEMP+1
 STA CLASS,X
 LDX VTEMP
 INX
 INX
 INX
 INX
 INC VTEMP+1
 BRA ]LOOP2
:FIN LDX #1
]LOOP STX VTEMP+1
 LDA CLASS-1,X
 BPL :NOPE
 LDX #28
 LDY #28
 LDA VTEMP+1
 ASL
 CLC
 ADC #5
 STA :V+3
 JSR PICKLINE
 LDA $200
 CMP #" "
 BNE :FCONT
 JSR PRINT
:V GOTOXY 26;7
 COLOR YELLOW
 DEC8 VTEMP+1
 ASC ") "
 PRTABLE VTEMP+1;CLASSTABLE
 COLOR WHITE
 NULL
 BRA :FCONT
:NOPE LDA VTEMP+1
 ASL
 CLC
 ADC #5
 STA :V2+3
 JSR PRINT
:V2 GOTOXY 28;7
 CLEOL
 NULL
:FCONT LDX VTEMP+1
 INX
 CPX #5
 BNE ]LOOP
 JMP GETKEY

DONE LDA TOTALCOST+1
 BNE :NOTOK
 LDA TOTALCOST
 CMP NEWPOINTS
 BEQ :OK
 BCC :OK
:NOTOK JSR PRINT
 GOTOXY 0;23
 CURSORON
 COLOR YELLOW
 ASC "You must allocate no more than "
 COLOR ORANGE
 DEC8 NEWPOINTS
 COLOR YELLOW
 ASC " points. "
 COLOR PINK
 NULL
:GOBACK GETRETURN
:GOBACK2 JSR PRINT
 COLOR WHITE
 CURSOROFF
 ZAPLINE
 NULL
 JMP GETKEY
:OK CMP POINTSMIN
 BCS :OK2
 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 CURSORON
 COLOR PINK
 ASC "You must allocate at least "
 COLOR YELLOW
 DEC8 POINTSMIN
 COLOR PINK
 ASC " points. "
 COLOR WHITE
 NULL
 BRA :GOBACK
:OK2 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 CURSORON
 COLOR PINK
 ASC "Finished (y/n)? : "
 COLOR WHITE
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 CMP #"Y"
 BEQ :YES
 CMP #"N"
 BEQL :GOBACK2
 BRA ]LOOP
:YES JSR PRINT
 GOTOXY 0;20
 CLEOS
 NULL
 LDX #9
]LOOP LDA CLASS-1,X
 BMI :CLOK
 DEX
 BNE ]LOOP
 JSR PRINT
 CURSORON
 COLOR PINK
 ASC "You must qualify for a class. "
 COLOR WHITE
 NULL
 GETRETURN
 JSR PRINT
 ZAPLINE
 CURSOROFF
 NULL
 JMP DOKEY
:CLOK JSR PRINT
 ASC "Choose a class : "
 NULL
]LOOP JSR KEYIN
 CMP #"1"
 BCC ]LOOP
 CMP #"9"+1
 BCS ]LOOP
 SEC
 SBC #"0"
 TAX
 LDA CLASS-1,X
 BPL ]LOOP ;Didn't qualify
 STX PLRCLASS
 JSR PRINT
 COLOR YELLOW
 PRTABLE PLRCLASS;CLASSTABLE
 COLOR WHITE
 NULL

 LDA PLRHT
 STA PLRHP
 STA PLRHP+1
 RANDNUM #3
 TXA
 CLC
 ADC #17
 STA PLRAGE ;Age between 18 and 20

GETNAME JSR PRINT
 GOTOXY 0;21
 CLEOS
 LINE "What name shall this character have?"
 NULL
]LOOP JSR PRINT
 GOTOXY 0;22
 ZAPLINE
 ASC "> "
 NULL
 GETLINE #20
 CPX #0
 BEQ ]LOOP
 STX PLRNAME
]LOOP LDA $200-1,X
 STA PLRNAME,X
 JSR UPPER
 STA $200-1,X
 DEX
 BNE ]LOOP

 JSR PRINT
 GOTOXY 0;23
 ASC "Name OK (y/n)? : "
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 CMP #"N"
 BEQ GETNAME
 CMP #"Y"
 BNE ]LOOP

 JSR PRINT
 COLOR PINK
 ASC "Yes"
 COLOR WHITE
 CURSOROFF
 NULL

 CLC ;Copy PLRBUFF to MISCBUFF
 XCE
 REP #$30
 SEP #$20
 LDX #0
]LOOP LDA PLRBUFF,X
 STA MISCBUFF,X
 INX
 CPX #PLRRECLEN
 BNE ]LOOP
 SEC
 XCE

 STZ REC+1
 STZ REC

 STZ FREEREC+1
 STZ FREEREC

]LOOP LDA REC+1
 CMP PLRS+1
 BNE LOAD
 LDA REC
 CMP PLRS
 BNE LOAD
 JMP FINISHED
LOAD INCR REC
 LDX REC
 LDA REC+1
 JSR LOADPLR

 LDA PLRFREE ;Player is free?
 BMI :FREE

 LDA PLRNAME
 CMP MISCBUFF+1
 BNE ]LOOP
 TAX
]LOOP2 LDA PLRNAME,X
 JSR UPPER
 CMP $200-1,X
 BNE ]LOOP
 DEX
 BNE ]LOOP2
 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 CURSORON
 COLOR PINK
 ASC "That name is already in use; use another. "
 COLOR WHITE
 NULL
 GETRETURN
 CLC ;Copy back PLRBUFF from MISCBUFF
 XCE
 REP #$30
 SEP #$20
 LDX #0
]LOOP2 LDA MISCBUFF,X
 STA PLRBUFF,X
 INX
 CPX #PLRRECLEN
 BNE ]LOOP2
 SEC
 XCE
 JMP GETNAME
:FREE LDA FREEREC+1
 BNE :NO
 LDA FREEREC
 BNE :NO
 LDA REC+1
 STA FREEREC+1
 LDA REC
 STA FREEREC
:NO JMP ]LOOP
FREEREC DS 2
REC DA 0

FINISHED CLC ;Copy back PLRBUFF from MISCBUFF
 XCE
 REP #$30
 SEP #$20
 LDX #0
]LOOP LDA MISCBUFF,X
 STA PLRBUFF,X
 INX
 CPX #PLRRECLEN
 BNE ]LOOP
 SEC
 XCE

 JSR PRINT
 HOME
 ASC "Wait.."
 CURSOROFF
 NULL

 JSR CALCPLR ;Calculate anything necessary (eg; Speed)
 LDA PLRSPEED
 STA PLRCURRPNTS
 STA PLRMAXPNTS

 LDA PLRCLASS
 DEC
 ASL
 TAX
 JMP (:ADJ,X)

:ADJ DA :ADJFIG
 DA :ADJTHI
 DA :ADJWIZ
 DA :ADJCLE

:ADJFIG INC PLRHP
 INC PLRHP+1
 JMP :ADJCONT

:ADJTHI INC PLRCURRPNTS
 INC PLRMAXPNTS
 JMP :ADJCONT

:ADJWIZ
:ADJCLE
 RANDNUM #6 ;Magic points = 1d6+4
 TXA
 CLC
 ADC #4
 STA PLRMAGIC
 STA PLRMAGICMAX

 LDA PLRIQ
 SEC
 SBC #10
 AND #%0000_1111
 ASL
 TAX
 LDA #0
 JSR RANDOM
 TXA
 ORA #%0000_1100 ;Must know at least two spells
 ASL ;and may know 1 or 2 other 1st level spells
 ASL ;depending on your IQ
 ASL
 ASL
 LDX PLRCLASS
 CPX #3
 BNE :CLERIC
 STA PLRSPELWIZ
 BRA :ADJCONT
:CLERIC STA PLRSPELCLE

:ADJCONT LDA PARTYNUM
 STA PLRPARTY

 LDX #0 ;Give a weapon and armour to char
 LDA #0
 JSR LOADITEM
 LDA ITEMBUFF
 STA :ITEMS
 STZ :NUM
]LOOP LDA :NUM
 CMP :ITEMS
 BEQ :GETARMA
 INC :NUM
 LDX :NUM
 LDA #0
 JSR LOADITEM
 LDA ITYPE
 CMP #1 ;Weapon?
 BNE ]LOOP
 LDA PLRCLASS
 JSR CHECKUSE ;Can we use this item?
 BCS ]LOOP
 LDA :NUM
 STA PLRITEM
 STZ PLRITEMX ;Can use it

:GETARMA LDX #0
 LDA #0
 JSR LOADITEM
 LDA ITEMBUFF
 STA :ITEMS
 STZ :NUM
]LOOP LDA :NUM
 CMP :ITEMS
 BEQ :IDONE
 INC :NUM
 LDX :NUM
 LDA #0
 JSR LOADITEM
 LDA ITYPE
 CMP #2 ;Armour?
 BNE ]LOOP
 LDA PLRCLASS
 JSR CHECKUSE ;Can we use this item?
 BCS ]LOOP
 LDA PLRITEM
 BNE :HASW
 LDA :NUM
 STA PLRITEM
 STZ PLRITEMX ;Can use it
 BRA :IDONE
:HASW LDA :NUM
 STA PLRITEM+1
 STZ PLRITEMX+1 ;Can use it

:IDONE JSR CALCPLR
 JSR SAVEPLAYER

 LDX #0
]LOOP LDA PARTY2,X
 BNE :GOTNO
 LDA PARTY,X
 BEQ :PUT
:GOTNO INX
 CPX NUMPARTY
 BNE ]LOOP
 JSR PRINT
 COLOR PINK
 ASC "Error : party limit exceeded."
 COLOR WHITE
 NULL
 DEATH
:PUT LDA REC
 STA PARTY,X
 LDA REC+1
 STA PARTY2,X

:FIN LDA CPADFLAG
 STA PADFLAG
 LDA CPADCHAR
 STA CPADCHAR

 LDA REC
 STA :NUM
 LDA REC+1
 STA :NUM+1
 NOTELOGNUM $D;"Created NEW User #";:NUM
 NOTELOGSTR $D;"Name = ";PLRNAME
 PNOTELOGSTR $D;"Created character : ";PLRNAME

 INC PLAYERS

 LDA #$FF
 STA VTEMP
 JMP EXIT
:NUM DS 4
:ITEMS DS 1

ESC JSR PRINT
 GOTOXY 0;23
 COLOR PINK
 ASC "Abort this character (y/n)? : "
 COLOR WHITE
 CURSORON
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 CMP #"Y"
 BEQ :YES
 CMP #"N"
 BNE ]LOOP
 JSR PRINT
 ASC "No"
 CURSOROFF
 ZAPLINE
 NULL
 JMP GETKEY
:YES JSR PRINT
 ASC "Yes"
 SOUND $13;1;$80
 NULL
 NOTELOG $D;"Character creation aborted."
 LDA CPADFLAG
 STA PADFLAG
 LDA CPADCHAR
 STA CPADCHAR
 LDA #0
 STA VTEMP
 JMP EXIT

DOPOINT LDA OLDPNTR
 ASL
 CLC
 ADC #7
 STA :CV+2
 JSR PRINT
 NORMAL
 MTOFF
 HTAB 0
:CV VTAB 0
 ASC " "
 NULL
 LDA PNTR
 ASL
 CLC
 ADC #7
 STA :CV2+2
 JSR PRINT
 HTAB 0
:CV2 VTAB 0
 NULL
 JSR SHOWPNTR
 LDA PNTR
 STA OLDPNTR
 RTS
PNTR DS 1
OLDPNTR DS 1

SAVEPLAYER LDA FREEREC+1
 BNE :FREE
 LDA FREEREC
 BEQ :NOFREE
:FREE STA REC
 LDA FREEREC+1
 STA REC+1
 JMP :CONT
:NOFREE INCR REC
 LDA REC+1
 CMP #2
 BCCL :CONT
 JSR PRINT
 HOME
 CURSORON
 ASC "Sorry, but the system database is full. This character cannot "
 ASC "be accommodated at this time. There may be a vacancy in about "
 DEC8 DAYSTOGO
 LINE " days. The GameMaster has been notified of this condition."
 CR
 NULL
 NOTELOG $1;"** Limit reached : 'Players' **"
 GETRETURN
 RTS
:CONT LDX REC
 LDA REC+1
 JSR SAVEPLR ;Save player's stats out

 LDA FREEREC+1
 BNE :OK
 LDA FREEREC
 BNE :OK
 LDA REC+1
 STA PLRBUFF+1
 LDA REC
 STA PLRBUFF
 LDX #0
 LDA #0
 JSR SAVEPLR
 LDX REC
 LDA REC+1
 JSR LOADPLR
:OK RTS

EXIT JSR PRINT
 NORMAL
 HOME
 CURSORON
 NULL
 RETURN

COSTST DS 2
COSTDX DS 2
COSTIQ DS 2
COSTHT DS 2
TOTALCOST DS 2

TABLE DA -80 ;1     ..for attribute costs
 DA -70 ;2
 DA -60 ;3
 DA -50 ;4
 DA -40 ;5
 DA -30 ;6
 DA -20 ;7
 DA -15 ;8
 DA -10 ;9
 DA 0 ;10
 DA 10 ;11
 DA 20 ;12
 DA 30 ;13
 DA 45 ;14
 DA 60 ;15
 DA 80 ;16
 DA 100 ;17
 DA 125 ;18

POINTSMIN DS 1

*--------------------------------
* Minimum attr ST/DX/IQ/HT  Class
*--------------------------------
MINATTR DFB 11,08,06,06 ;Fighter
 DFB 06,11,07,06 ;Thief
 DFB 06,07,11,06 ;Wizard
 DFB 07,06,11,07 ;Cleric
 DFB $FF ;------------- Basic classes for NEW players only
 DFB 14,16,10,10 ;Ninja
 DFB 11,12,13,10 ;Sage
 DFB 13,11,14,10 ;High Mage
 DFB 13,10,14,11 ;High Priest
 DFB 16,16,16,16 ;Lord
 DFB $FF

CLASS DS 9

CPADFLAG DS 1
CPADCHAR DS 1

PLRS DS 2

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/GAME.NEWPLR
 fin

 END
