*-------------------------------
* GAME.NEXTURN
*-------------------------------
 DAT
 LST OFF

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE VARS
 USE LIB.JMP
 USE PLR.DSECT
 USE PN.DSECT
 USE LOG.DSECT
 USE SCEN.DSECT
 USE MSG.DSECT
 USE ITEM2.DSECT
 USE INV.DSECT

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/GAME.NEXTURN
 fin

 MODID "GAME.NEXTURN"

START LDX #0
 LDA #0
 JSR LOADSCEN
 LDA SCENBUFF
 BNE :SCENOK
 JSR PRINT
 HOME
 COLOR PINK
 CENTER "*** No scenarios are setup ***"
 PRPAUSE 10
 CR
 CR
 CENTER "Turns will not be initiated"
 COLOR WHITE
 PRPAUSE 32
 HOME
 NULL
 NOTELOG $1;"No scenarios - turns not initiated"
 RETURN

:SCENOK STA SCENARIO
 STA SCEN

 JSR PRINT
 HOME
 ASC "Gameturn in progress.."
 CR
 CR
 ASC "Checking Party Names.."
 CURSOROFF
 NULL
 JSR CHECKPN ;Check last log date
* JSR PRINT
* CR
* CR
* ASC "Checking Message Base.."
* NULL
* JSR CHECKMB

]TOPLOOP LDX SCENARIO
 STX SCEN
 LDA QUESTDONE-1,X
 BMIL :DONE
 LDX SCENARIO
 LDA #0
 JSR LOADSCEN
 BIT SCFREE
 BPL :WORKING
 JSR PRINT
 HOME
 ASC "Scenario #"
 COLOR YELLOW
 DEC8 SCENARIO
 COLOR WHITE
 ASC " ("
 COLOR AQUAMARINE
 PRSTRING SCNAME
 COLOR WHITE
 ASC ") is inactive.."
 COLOR PINK
 ASC " <skipped>"
 COLOR WHITE
 PRPAUSE 10
 NULL
 NOTELOGNUM $1;"Skipped inactive scenario #";SCEN
 JMP :BOTDEC
:WORKING LDA $C025
 AND #%0000_0010 ;CONTROL
 BEQL :CSKIP
 JSR PRINT
 HOME
 ASC "Scenario #"
 COLOR YELLOW
 DEC8 SCENARIO
 COLOR WHITE
 ASC " ("
 COLOR AQUAMARINE
 PRSTRING SCNAME
 COLOR WHITE
 ASC ")"
 CR
 CR
 COLOR PINK
 ASC "Skip this scenario (y/N)? : "
 COLOR WHITE
 CURSORON
 NULL
 JSR KEYIN
 JSR UPPER
 CMP #"Y"
 BEQ :SKIPIT
 CMP #"Y"-$40
 BEQ :SKIPIT
 JSR PRINT
 ASC "No"
 CURSOROFF
 NULL
 BRA :CSKIP
:SKIPIT JSR PRINT
 ASC "Yes"
 CURSOROFF
 NULL
 NOTELOGNUM $1;"Sysop skipped scenario #";SCEN
 JMP :BOTDEC

:CSKIP LDA SKIPNOPARTYSCEN
 BPLL :CSKIP2
 LDA SCENARIO
 DEC
 ASL
 TAX
 LDA GAMETURN,X
 ORA GAMETURN+1,X
 BEQ :CSKIP2 ;Must do turn if #0
 JSR FINDPARTY
 BCC :CSKIP2
 JSR PRINT
 HOME
 ASC "Scenario #"
 COLOR YELLOW
 DEC8 SCENARIO
 COLOR WHITE
 ASC " ("
 COLOR AQUAMARINE
 PRSTRING SCNAME
 COLOR WHITE
 ASC ") has no active parties"
 COLOR PINK
 ASC " <skipped>"
 COLOR WHITE
 PRPAUSE 10
 NULL
 NOTELOGNUM $1;"Skipped 'no party' scenario #";SCEN
 JMP :BOTDEC

:CSKIP2 JSR INCTURN
 JSR PRINT
 HOME
 ASC "Scenario #"
 DEC8 SCENARIO
 ASC " - initiating turn #"
 COLOR YELLOW
 DEC16 TURN
 COLOR WHITE
 ASC ".."
 PRPAUSE 4
 NULL

 LDA TURN
 STA LOGCALL
 LDA TURN+1
 STA LOGCALL+1
 LDX TURNTXT
 STX LOGTEXT
]LOOP LDA TURNTXT,X
 STA LOGTEXT,X
 DEX
 BNE ]LOOP
 LDA #2 ;Entry with data
 JSR LOGFILENOTE

 JSR FIXDAYS

 JSR PRINT
 CR
 CR
 ASC "Logging Party History files.."
 NULL
 JSR LOGPARTYHIST ;Put "Start of turn #x" in every Party History Log

 JSR PRINT
 CR
 ASC "Checking Players.."
 NULL
 JSR CHECKPLRS ;Check player conditions

 JSR PRINT
 CR
 CR
 ASC "Adding 'stock' to The Shoppe.."
 NULL
 JSR STOCKUP ;Put more items in shop

 JSR PRINT
 CR
 CR
 ASC "Reclaiming.."
 NULL
 JSR RECLAIM ;Good idea..

 CALL "GAME.ALLOCM" ;Allocate monsters (if necessary)
 CALL "GAME.MOVEMON" ;Move monsters! Let's party...!

 JSR PRINT
 HOME
 ASC "Logging Party History files.."
 NULL
 JSR LOGPARTYHIST2 ;Put "End of turn #x" in every Party History Log

 NOTELOGNUM $F;"Turn completed : Scenario #";SCEN

 CLC
 XCE
 REP #$30
 LDA SCENARIO
 DEC
 ASL
 TAX
 LDA ENDQUESTEXP,X ;Add experience
 CLC
 ADC TURNEXP
 STA ENDQUESTEXP,X
 SEC
 XCE
 JSR SAVEVARS

:BOTDEC DEC SCENARIO
 BNEL ]TOPLOOP

 MLI_GET_PREFIX :PFXPARMS
 JSR MLIERR
 LDX :PREFIX
]LOOP LDA :PREFIX,X
 ORA #%1000_0000
 STA :PREFIX,X
 DEX
 BNE ]LOOP
 NOTELOGSTR $7;"// Prefix ";:PREFIX
 LDX #0
]LOOP INX
 LDA :PREFIX+1,X
 CMP #"/"
 BEQ :SLASH
 CPX :PREFIX
 BNE ]LOOP
 DEX
:SLASH INX
 STX :PREFIX
 MLI_GET_FILE_INFO :GETPARMS
 JSR MLIERR
 LDA :GETPARMS+5
 STA :BLOCKS
 LDA :GETPARMS+6
 STA :BLOCKS+1
 NOTELOGNUM $7;"// Total blocks : ";:BLOCKS
 LDA :GETPARMS+5
 SEC
 SBC :GETPARMS+8
 STA :FREBLOCKS
 LDA :GETPARMS+6
 SBC :GETPARMS+9
 STA :FREBLOCKS+1
 NOTELOGNUM $7;"// Free blocks  : ";:FREBLOCKS

 JSR PRINT
 HOME
 NULL
 LDA #$FF
 STA VTEMP
 CALL "GAME.UPDATE"
 JMP EXIT

:PFXPARMS DFB 1
 DA :PREFIX

:PREFIX DS 1+63

:GETPARMS DFB $A
 DA :PREFIX
 DS 15
:BLOCKS DS 4
:FREBLOCKS DS 4

:DONE JSR PRINT
 HOME
 ASC "Scenario #"
 COLOR YELLOW
 DEC8 SCENARIO
 COLOR WHITE
 ASC " is over.. Resetting.."
 NULL
 NOTELOGNUM $F;"Scenario completed #";SCEN
 LDA SCENARIO
 DEC
 ASL
 TAX
 STZ GAMETURN,X ;Reset game turn
 STZ GAMETURN+1,X
 LDA SCENARIO
 STA LOGCALL
 STZ LOGCALL+1
 LDX GAMETXT
 STX LOGTEXT
]LOOP LDA GAMETXT,X
 STA LOGTEXT,X
 DEX
 BNE ]LOOP
 LDA #2 ;Entry with data
 JSR LOGFILENOTE

 LDA SCENARIO
 STA :SCENARIO
 LDX #0
 LDA #0
 JSR LOADSCEN
 LDA SCENBUFF
 STA :SCENS
]LOOP LDA :SCENARIO ;Find next available scenario
 CMP :SCENS
 BNE :OK
 LDA #0
:OK INC
 STA :SCENARIO ;Inc scenario
 LDX :SCENARIO
 LDA #0
 JSR LOADSCEN
 BIT SCFREE
 BMI ]LOOP

 LDX #0 ;Find out which players are playing this scenario,
 LDA #0 ; and allow them to play the next one IF they meet
 JSR LOADPLR ; the 'entry level' experience wise
 LDA PLRBUFF
 STA :PLRS
 LDA PLRBUFF+1
 STA :PLRS+1
]LOOP LDA :PLRS
 ORA :PLRS+1
 BEQL :PFIN
 LDX :PLRS
 LDA :PLRS+1
 JSR LOADPLR
 BIT PLRFREE
 BMIL :NNEXTP
 LDA PLRSCENARIO ;Playing this one?
 CMP SCENARIO
 BNEL :NNEXTP
 LDA PLRPARTY
 STA :PRTYUP
 JSR CALCPLR
 LDA PLRLEVEL ;Calculated experience level
 CMP SCMINEXPLVL ;Minimum exp level to play scenario
 BCCL :NNEXTP
 LDX :PRTYUP
 LDA #0
 JSR LOADPN
 LDA :SCENARIO
 STA PNSCENARIO
 LDX :PRTYUP
 LDA #0
 JSR SAVEPN
 LDA :PRTYUP
 STA PARTYNUM
 PNOTELOGNUM $F;"Party has advanced to scenario #";:SCENARIO

 LDX #0
 LDA #0
 JSR LOADPLR
 LDA PLRBUFF
 STA :PLRS2
 LDA PLRBUFF+1
 STA :PLRS2+1
]LOOP2 LDA :PLRS2
 ORA :PLRS2+1
 BEQ :NNEXTP
 LDX :PLRS2
 LDA :PLRS2+1
 JSR LOADPLR
 BIT PLRFREE
 BMI :NNEXTP2
 LDA PLRPARTY
 CMP :PRTYUP
 BNE :NNEXTP2
 LDA :SCENARIO
 STA PLRSCENARIO
 JSR CALCPLR
 LDA #%0111_1111 ;Reset stuff
 TRB PLRCOND
 LDX #6
]LOOP3 STZ PLRCONDX,X
 DEX
 BPL ]LOOP3
 LDA PLRCOND
 AND #%1000_0000
 BMI :DEDD
 LDA PLRMAXPNTS
 STA PLRCURRPNTS
 LDA PLRMAGICMAX
 STA PLRMAGIC
:DEDD LDX :PLRS2
 LDA :PLRS2+1
 JSR SAVEPLR
:NNEXTP2 DECR :PLRS2
 BRA ]LOOP2

:NNEXTP DECR :PLRS
 JMP ]LOOP

:PFIN LDX #0
 LDA #0
 JSR LOADMAP
 LDX SCENARIO
 LDA MAP
 STA MAPLEVELS-1,X
 STZ MON2BUFF ;Get rid of maze monsters
 STZ MON2BUFF+1
 LDX #0
 LDA #0
 JSR SAVEMON2
 STZ ITEM2BUFF ;Get rid of maze items
 STZ ITEM2BUFF+1
 LDX #0
 LDA #0
 JSR SAVEITEM2
 LDX SCENARIO
 STZ QUESTDONE-1,X
 STZ M2KILLDEAD-1,X
 LDA SCENARIO
 DEC
 ASL
 TAX
 LDA #<1000 ;Reset end-quest experience points given
 STA ENDQUESTEXP,X
 LDA #>1000
 STA ENDQUESTEXP+1,X
 JSR SAVEVARS

 JSR :LOGPHIST

 LDX #0 ;Put all players in Castle
 LDA #0
 JSR LOADPLR
 LDA PLRBUFF
 STA :TEMP
 LDA PLRBUFF+1
 STA :TEMP+1
]LOOP LDA :TEMP
 ORA :TEMP+1
 BEQ :FIN
 LDX :TEMP
 LDA :TEMP+1
 JSR LOADPLR
 LDA PLRFREE
 BMI :NEXT
 LDA PLRSCENARIO
 CMP SCENARIO
 BNE :NEXT
 STZ PLRXPOS ;Put 'em back in the Castle
 STZ PLRYPOS
 STZ PLRZPOS
 JSR CALCPLR
 LDA #%1000_0000
 TRB PLRARRESTFLAG ;Lucky..
 LDX :TEMP
 LDA :TEMP+1
 JSR SAVEPLR
:NEXT DECR :TEMP
 JMP ]LOOP

:FIN JSR SAVEVARS
 JMP ]TOPLOOP ;Let's go..
:TEMP DS 4
:SCENS DS 1
:SCENARIO DS 4
:PLRS DS 2
:PLRS2 DS 2
:PRTYUP DS 1

:LOGPHIST LDA PARTYNUM
 PHA
 LDX #0
 LDA #0
 JSR LOADPN
 LDA PNBUFF
 STA :PARTYS
]LOOP LDX :PARTYS
 LDA :PARTYS+1
 JSR LOADPN
 BIT PNFREE
 BMI :NEXTP
 LDA PLRSCENARIO
 CMP SCENARIO
 BNE :NEXTP
 LDA :PARTYS
 STA PARTYNUM
 PNOTELOG $F;"** Start of scenario **"
:NEXTP DEC :PARTYS
 LDA :PARTYS
 BNE ]LOOP
 PLA
 STA PARTYNUM
 RTS
:PARTYS DS 2

SCEN DS 4
TURN DS 4

TURNTXT STR "Start of turn #"
GAMETXT STR "Start of scenario #"

INCTURN CLC
 XCE
 REP #$30
 LDA SCENARIO
 AND #$FF
 DEC
 ASL
 TAX
 INC GAMETURN,X
 LDA GAMETURN,X
 STA TURN
 SEC
 XCE
 NOTELOGNUM $F;">> Scenario #";SCEN
 NOTELOGNUM $F;"Start of turn #";TURN
 RTS

FIXDAYS LDA TURNDAYS
 STA DAYSTOGO
 RTS

CHECKPLRS LDX #0
 LDA #0
 JSR LOADPLR
 LDA PLRBUFF
 STA :TEMP
 LDA PLRBUFF+1
 STA :TEMP+1
 STZ :WATERZ
]LOOP LDA :TEMP
 ORA :TEMP+1
 BEQL :DONE
 LDX :TEMP
 LDA :TEMP+1
 JSR LOADPLR
 LDA PLRFREE
 BMIL :NEXT
 LDA PLRSCENARIO
 CMP SCENARIO
 BNEL :NEXT
 LDA PLRCOND
 AND #%1000_0000 ;Dead
 BMIL :SAVE
 LDA PLRPARTY
 STA PARTYNUM
 JSR :WATER
 LDA PLRHP
 DEC
 CMP #$80
 BCS :HPBAD
 JSR :POISON
 LDA PLRHP
 DEC
 CMP #$80
 BCS :HPBAD
 JSR :STUN
 JSR :CONDS
 LDA PLRCOND ;Dead, so no need to check neg HP
 AND #%1000_0000
 BNEL :SAVE
 LDA PLRHP
 DEC
 CMP #$80
 BCCL :SAVE
:HPBAD LDA PLRHP
 EOR #$FF
 INC
 STA :NEGHP
 CMP PLRHP+1 ;HP gone full negative?
 BCS :DEAD
 LDX #3
 JSR ROLLD6 ;Roll vs Health
 LDA VTEMP
 CMP :NEGHP
 BEQ :SAVE
 BCC :SAVE
 NOTELOGNUM $1;"Roll vs health failed.. Player died #";:TEMP
 PNOTELOGSTR $1;"Party member died - ";PLRNAME
:DEAD LDA #%1000_0000 ;Dead
 STA PLRCOND
 LDX #7
]LOOP2 STZ PLRCONDX,X
 DEX
 BPL ]LOOP2
 LDA #$FF
 STA PLRCONDX+7 ;Dead 'forever' (+7 coz it's bit 7)
 JSR CHARITEMS
:SAVE LDA PLRCURRPNTS
 CLC
 ADC PLRMAXPNTS
 CMP PLRMAXPNTS
 BCC :PNTSOK
 LDA PLRMAXPNTS
:PNTSOK STA PLRCURRPNTS
 LDA PLRMAGICMAX
 STA PLRMAGIC
 LDX :TEMP
 LDA :TEMP+1
 JSR SAVEPLR
:NEXT DECR :TEMP
 JMP ]LOOP
:DONE RTS
:TEMP DS 4
:NEGHP DS 1

:WATER LDA PLRZPOS ;Someone in water?
 BEQL :WRTS
 CMP :WATERZ
 BEQ :WLOK
 LDX PLRZPOS
 STX :WATERZ
 LDA #0
 JSR LOADMAP
:WLOK LDX PLRXPOS
 LDY PLRYPOS
 JSR GETMAP
 STX SHAPETYPE
 CMP #SHPWATER
 BNEL :WRTS
 LDA PLRCOND
 AND #%0000_0100 ;Levitating?
 BNEL :WRTS ;Yep
 LDA PLRST ;See if they can swim
 SEC
 SBC #5
 STA VTEMP
 LDA PLRDX
 SEC
 SBC #4
 CMP VTEMP
 BCS :WTHIS1
 LDA VTEMP
:WTHIS1 STA :WROLL
 LDX #7 ;Subtract encumberance level (sort of..)
]LOOP PHX ;ie. the more equipment you have, the
 LDA PLRITEMX,X ;    less chance you have of swimming
 BEQ :WNXT
 LDY #0
 LDA PLRITEM,X
 CMP #1 ;Weapon
 BEQ :WWEAP
 CMP #2 ;Armour
 BEQ :WARM
 BNE :WOTHER
:WARM INY
:WWEAP INY
:WOTHER INY
 STY VTEMP
 LDA :WROLL
 CLC
 ADC VTEMP
 STA :WROLL
:WNXT PLX
 DEX
 BPL ]LOOP
 LDA SHAPETYPE
 CMP #WATERDEEP
 BNE :NOTDEEP
 LSR :WROLL ;1/2 as much chance of swimming in deep water
:NOTDEEP LDX #3
 JSR ROLLD6 ;Roll vs Health
 LDA VTEMP
 CMP :WROLL
 BEQ :WRTS ;Successful roll
 BCC :WRTS
 PNOTELOGSTR $1;"Party member drowning - ";PLRNAME
 LDX PLRHT
 LDA :WTBL,X
 STA VTEMP
 LDA PLRHP
 CLC
 ADC VTEMP
 STA PLRHP
:WRTS RTS
:WATERZ DS 1
:WROLL DS 1
:WTBL DFB -25,-25,-25,-25,-20,-20,-15,-10,-5 ;(1 - 9)
 DFB -4,-4,-3,-3,-2,-2,-1,-1,-1 ;(10 - 18)
 DFB -1,-1 ;(19 - 20)

:POISON LDA PLRCOND ;Decrement HP if poisoned
 AND #%0010_0000
 BEQ :NOP
 RANDNUM #3 ;1 to 3 HP per turn
 STX :HPLOST
 LDA PLRHP
 SEC
 SBC :HPLOST ;HP lost per turn
 STA PLRHP
:NOP RTS
:HPLOST DS 1

:STUN LDA PLRCOND ;May be able to snap out of it
 AND #%0000_0001
 BEQ :NOPS
 LDX #3
 JSR ROLLD6
 LDA VTEMP
 CMP PLRIQ
 BEQ :SNAP
 BCS :NOPS
:SNAP LDA PLRCOND
 AND #%1111_1110
 STA PLRCOND
 STZ PLRCONDX
 PNOTELOGSTR $7;"Snapped out of stun - ";PLRNAME
:NOPS RTS

:CONDS LDA #$80
 STA :ANDX
 STZ :CFLAG
 LDX #7
]LOOP LDA PLRCOND
 AND :ANDX
 BEQ :NXTCON
 LDA PLRCONDX,X
 CMP #$FF ;A 'forever' condition
 BEQ :NXTCON
 DEC
 STA PLRCONDX,X
 CMP #0
 BNE :NXTCON
 LDA :ANDX ;Condition has 'expired'
 EOR #$FF ;So clear it
 AND PLRCOND
 STA PLRCOND
 LDA #$FF
 STA :CFLAG
:NXTCON LSR :ANDX
 DEX
 BPL ]LOOP
 BIT :CFLAG
 BPL :CRTS
 PNOTELOGSTR $7;"Conditions changed - ";PLRNAME
:CRTS RTS
:ANDX DS 1
:CFLAG DS 1

CHECKPN LDX #0
 LDA #0
 JSR LOADPLR
 LDA PLRBUFF
 STA :PLRS
 LDA PLRBUFF+1
 STA :PLRS+1
 LDX SCENARIO
 LDA #0
 JSR LOADSCEN
 LDX #0
 LDA #0
 JSR LOADPN
 LDA PNBUFF
 STA :PARTIES
 BNE :OK
 RTS
:OK LDX :PARTIES
]LOOP STX :X
 LDA #0
 JSR LOADPN
 LDA PNFREE
 BMIL :NEXT
 JSR :LOGDATE
 CMP #$FF
 BNEL :NEXT
 STA PNFREE ;Player hasn't logged on within required period
 NOTELOGNUM $1;"Party has expired.. Party freed #";:X
 LDX :X
 LDA #0
 JSR SAVEPN
 JSR :DELFILES
 JSR :DELMSGS ;Delete any messages to/from this party
 LDA :PLRS
 STA :X2
 LDA :PLRS+1
 STA :X2+1
]LOOP2 LDA :X2+1
 BNE :PLROK
 LDA :X2
 BEQ :NEXT
:PLROK LDX :X2
 LDA :X2+1
 JSR LOADPLR
 LDA PLRPARTY
 CMP :X
 BNE :NXTP
 JSR :CHEKI2GET ;CHeck to see if player has 'item to get'
 LDA #$FF ;Free players from this Party
 STA PLRFREE
 LDX :X2
 LDA :X2+1
 JSR SAVEPLR
 NOTELOGNUM $1;"Player freed #";:X2
:NXTP DECR :X2
 BRA ]LOOP2
:NEXT DEC :X
 LDX :X
 CPX #0
 BNEL ]LOOP
 RTS

:CHEKI2GET LDX #0
]LOOP PHX
 LDA PLRITEM,X
 BEQ :I2NEXT
 CMP SCITEM
 BNE :I2NEXT
 PHA
 LDX #0
 LDA #0
 JSR LOADITEM2
 LDA ITEM2BUFF
 STA :MAXI2
 STZ :I2CNTR
]LOOP2 INC :I2CNTR
 LDA :I2CNTR
 CMP :MAXI2
 BEQ :DIOK
 BCS :ADD1
:DIOK LDX :I2CNTR
 LDA #0
 JSR LOADITEM2
 LDA IFREE
 BPL ]LOOP2
:PUT1 PLA
 STA INUM
 STZ IFREE
 LDA PLRXPOS
 STA IXPOS
 LDA PLRYPOS
 STA IYPOS
 LDA PLRZPOS
 STA IZPOS
 STZ IDATA
 STZ IDATA+1
 STZ IDATA+2
 STZ IDATA+3
 LDX :I2CNTR
 LDA #0
 JSR SAVEITEM2
 PLA
 RTS

:ADD1 INC :MAXI2
 LDA :MAXI2
 STA ITEM2BUFF
 STZ ITEM2BUFF+1
 LDX #0
 LDA #0
 JSR SAVEITEM2
 BRA :PUT1

:I2NEXT PLX
 INX
 CPX #8
 BNE ]LOOP
 RTS
:MAXI2 DS 1
:I2CNTR DS 1

:DELFILES LDA :X ;Delete necessary files
 JSR GETHEX
 STX :PATH+14 ;Make sure these match -\
 STY :PATH+15 ;                       |
 STX :PATH2+15 ;Make sure these match -\
 STY :PATH2+16 ;                       |
 MLI_DESTROY :DPARMS
 CMP #$46
 BEQ :PATHOK
 JSR MLIERR
:PATHOK MLI_DESTROY :DPARMS2
 CMP #$46
 BEQ :PATHOK2
 JSR MLIERR
:PATHOK2 RTS
:DPARMS DFB 1
 DA :PATH
:DPARMS2 DFB 1
 DA :PATH2
:CRPARMS DFB 7
 DA :PATH2
 DFB %11000011 ;Access bits ($C3)
 DFB $F2 ;Filetype
 DA LOGRECLEN ;Aux type
 DFB 1 ;Storage type
 DA 0 ;Creation date
 DA 0 ;     & time
:PATH STR "DATA/NOTEPAD.XX" ;<---------------/
:PATH2 STR "DATA/PARTYLOG.XX" ;<---------------/

:DELMSGS LDX #0
 LDA #0
 JSR LOADMSGINDX
 LDA MSGINDXBUFF
 STA :INDX
 LDA MSGINDXBUFF+1
 STA :INDX+1
]LOOP LDX :INDX
 LDA :INDX+1
 JSR LOADMSGINDX
 LDA MSGFROM
 CMP :X
 BEQ :YEP
 LDA MSGTO
 CMP :X
 BNE :NEXTIN
:YEP LDA #$FF
 STA MSGFREE
 LDX :INDX
 LDA :INDX+1
 JSR SAVEMSGINDX
 LDX MSGNUM
 LDA MSGNUM+1
 JSR MARKFREE ;Mark this message as being free
:NEXTIN DECR :INDX
 LDA :INDX+1
 BNE ]LOOP
 LDA :INDX
 BNE ]LOOP
 RTS
:INDX DS 2
:X DS 4 ;For NOTELOG reasons (4 bytes)
:X2 DS 4 ;(ditto)
:PARTIES DS 1
:PLRS DS 2

:LOGDATE LDX $BF90
 LDY $BF91
 JSR :JULDATE
 STY :JUL1 ;today
 STX :JUL1+1
 STA :JUL1+2
 LDX PNLASTON
 LDY PNLASTON+1
 JSR :JULDATE
 STY :JUL2 ;plrlaston
 STX :JUL2+1
 STA :JUL2+2

 CLC
 XCE
 REP #$30
 LDA :JUL1+1 ;if today - plrlaston > allocday  then free plr
 SEC
 SBC :JUL2+1
 STA :GONE
 BCS :CSET
 ADC #365
 STA :GONE
 SEC
 XCE
 BIT :LEAP
 BPL :CSET
 INCR :GONE
:CSET SEC
 XCE
 LDA :GONE+1
 BNE :FREEUP
 LDA :GONE
 CMP ALLOCDAY
 BCS :FREEUP
 LDA #0
 HEX 2C
:FREEUP LDA #$FF
 RTS

:JULDATE TYA
 LSR
 STA :YY
 TXA
 PHA
 AND #%0001_1111
 STA :DAYS
 PLA
 ROL
 ROL
 ROL
 ROL
 AND #%0000_1111
 TAX
 STZ :JUL
 STZ :JUL+1
]LOOP LDA :JUL
 CLC
 ADC :DAYS,X
 STA :JUL
 LDA :JUL+1
 ADC #0
 STA :JUL+1
 DEX
 BPL ]LOOP
 STZ :LEAP
 LDA :YY
 AND #%0000_0011
 BNE :NOLEAP
 INCR :JUL
 DEC :LEAP
:NOLEAP LDX :JUL
 LDA :JUL+1
 LDY :YY
 RTS
:JUL DS 2
:LEAP DS 1

:DAYS DFB 0,31,28,31,30,31,30,31,31,30,31,30,31
:YY DS 1

:JUL1 DS 3
:JUL2 DS 3
:GONE DS 2

LOGPARTYHIST LDX #0 ;Put "Turn xxx" in every Party History Log
 LDA #0
 JSR LOADPN
 LDA PNBUFF
 STA :PARTIES
 BNE :OK
 RTS
:OK LDA SCENARIO
 DEC
 ASL
 TAX
 LDA GAMETURN,X
 STA :TURN
 LDA GAMETURN+1,X
 STA :TURN+1
]LOOP LDX :PARTIES
 LDA :PARTIES+1
 JSR LOADPN
 BIT PNFREE
 BMI :NEXTP
 LDA PNSCENARIO
 CMP SCENARIO
 BNE :NEXTP
 LDA :PARTIES
 STA PARTYNUM
 PNOTELOGNUM $F;"Start of turn #";:TURN
:NEXTP DEC :PARTIES
 LDA :PARTIES
 BNE ]LOOP
 RTS
:PARTIES DS 2
:TURN DS 4

LOGPARTYHIST2 LDX #0
 LDA #0
 JSR LOADPN
 LDA PNBUFF
 STA :PARTIES
 BNE :OK
 RTS
:OK LDA SCENARIO
 DEC
 ASL
 TAX
 LDA GAMETURN,X
 STA :GAME
 LDA GAMETURN+1,X
 STA :GAME+1
]LOOP LDX :PARTIES
 LDA :PARTIES+1
 JSR LOADPN
 BIT PNFREE
 BMI :NEXTP
 LDA PNSCENARIO
 CMP SCENARIO
 BNE :NEXTP
 LDA :PARTIES
 STA PARTYNUM
 PNOTELOGNUM $F;"End of turn #";:GAME
:NEXTP DEC :PARTIES
 LDA :PARTIES
 BNE ]LOOP
 RTS
:PARTIES DS 2
:GAME DS 4

CHECKMB LDX #0
 LDA #0
 JSR LOADMSGINDX
 LDA MSGINDXBUFF
 STA :INDX
 LDA MSGINDXBUFF+1
 STA :INDX+1
 LDA :INDX
 ORA :INDX+1
 BNE :GOGO
 RTS
:GOGO STZ :CNTR
 STZ :CNTR+1
 STZ :NFRE1
 STZ :NFRE1+1
]LOOP LDA :CNTR+1
 CMP :INDX+1
 BNE :OK
 LDA :CNTR
 CMP :INDX
 BEQL :DONE
:OK INCR :CNTR
 LDX :CNTR
 LDA :CNTR+1
 JSR LOADMSGINDX
 BIT MSGFREE ;This msg free?
 BPL :USED
:FREE LDA :CNTR
 STA :NFRE1
 LDA :CNTR+1
 STA :NFRE1+1
 JMP ]LOOP

:USED LDX MSGFROM ;Either party free?
 LDA MSGFROM+1
 JSR LOADPN
 BIT PNFREE
 BMI :FREPN
 LDX MSGTO
 LDA MSGTO+1
 JSR LOADPN
 BIT PNFREE
 BPL :USE2
:FREPN LDA #$FF
 STA MSGFREE
 LDX :CNTR ;Free up old slot
 LDA :CNTR+1
 JSR SAVEMSGINDX
 JMP :FREE

:USE2 LDA :NFRE1
 ORA :NFRE1+1
 BEQL ]LOOP
 LDX :NFRE1 ;Save in next free slot
 STX :THIS1
 LDA :NFRE1+1
 STA :THIS1+1
 JSR SAVEMSGINDX
 LDA #$FF
 STA MSGFREE
 LDX :CNTR ;Free up old slot
 LDA :CNTR+1
 JSR SAVEMSGINDX
 LDA :CNTR ;Update next free slot marker
 STA :NFRE1
 LDA :CNTR+1
 STA :NFRE1+1

 JSR GETFREEMSG ;Get the next free message from 'msg map'
 BCSL ]LOOP ;Message base full
 STX :NEWMSG
 STA :NEWMSG+1

 LDX MSGNUM ;Read in message
 LDA MSGNUM+1
 JSR LOADMSG
 LDX MSGNUM
 LDA MSGNUM+1
 JSR MARKFREE ;Mark this message as being free

 LDX :NEWMSG
 LDA :NEWMSG+1
 JSR SAVEMSG ;Save message in new area
 LDX :NEWMSG
 LDA :NEWMSG+1
 JSR MARKUSED ;Mark this message as being used
 LDX :THIS1
 LDA :THIS1+1
 JSR LOADMSGINDX
 LDA :NEWMSG ;Update index to point to new message
 STA MSGNUM
 LDA :NEWMSG+1
 STA MSGNUM+1
 LDX :THIS1
 LDA :THIS1+1
 JSR SAVEMSGINDX

 INCR :CRUNCHED

 JMP ]LOOP

:DONE LDA :NFRE1
 ORA :NFRE1+1
 BEQL :NOFREES
 DECR :NFRE1
 LDA :NFRE1 ;Update total in file
 STA MSGINDXBUFF
 LDA :NFRE1+1
 STA MSGINDXBUFF+1
 LDX #0
 LDA #0
 JSR SAVEMSGINDX
 LDA :NFRE1 ;Update total in file
 STA MSGBUFF
 LDA :NFRE1+1
 STA MSGBUFF+1
 LDX #0
 LDA #0
 JSR SAVEMSG

 CLC
 XCE
 REP #$30 ;Set EOF on file
 STZ :EPARMS+2
 STZ :EPARMS+4
 STZ :EPARMS2+2
 STZ :EPARMS2+4
 LDX :NFRE1
]LOOP LDA :EPARMS+2
 CLC
 ADC #MSGINDXRECLEN
 STA :EPARMS+2
 LDA :EPARMS+4
 ADC #0
 STA :EPARMS+4

 LDA :EPARMS2+2
 CLC
 ADC #MSGRECLEN
 STA :EPARMS2+2
 LDA :EPARMS2+4
 ADC #0
 STA :EPARMS2+4

 DEX
 BPL ]LOOP
 SEC
 XCE

 JSR CLOSEALL

 MLI_OPEN :OPARMS
 JSR MLIERR
 LDA :OPARMS+5
 STA :EPARMS+1
 MLI_SET_EOF :EPARMS
 JSR MLIERR
 JSR CLOSEALL

 MLI_OPEN :OPARMS2
 JSR MLIERR
 LDA :OPARMS2+5
 STA :EPARMS2+1
 MLI_SET_EOF :EPARMS2
 JSR MLIERR
:NOFREES JSR CLOSEALL
 NOTELOGNUM $F;"Messages crunched - ";:CRUNCHED
 RTS

:OPARMS DFB 3
 DA :PATH
 DA IOBUFFER
 DS 1

:EPARMS DFB 2
 DS 1
 DS 4

:OPARMS2 DFB 3
 DA :PATH2
 DA IOBUFFER
 DS 1

:EPARMS2 DFB 2
 DS 1
 DS 4

:PATH STR 'MSG.INDEX'
:PATH2 STR 'MESSAGES'

:CNTR DS 2
:INDX DS 2
:NFRE1 DS 2
:NEWMSG DS 2
:THIS1 DS 2
:CRUNCHED DS 4

STOCKUP LDX #0
 LDA #0
 JSR LOADITEM
 LDA ITEMBUFF
 STA :RECS
]LOOP LDX :RECS
 BEQ :DONE
 LDA #0
 JSR LOADINV
 BIT INVFREE
 BMI :NEXT
 LDA INVSTOCK ;Currently in stock
 CMP INVMAX
 BCS :NEXT ;Already has enough (more likely too much)
 LDA INVSTOCK ;Currently in stock
 CLC
 ADC INVORDER ;Add order amount
 STA INVSTOCK
 BCC :OK
 LDA INVMAX ;> 255..
:OK CMP INVMAX
 BCC :SAVE
 LDA INVMAX
 STA INVSTOCK
:SAVE LDX :RECS
 LDA #0
 JSR SAVEINV
:NEXT DEC :RECS
 BRA ]LOOP
:DONE RTS

:RECS DS 1

EXIT LDX #0
 LDA #0
 JSR LOADSCEN
 LDA SCENBUFF
 STA SCENARIO
 JSR SAVEVARS
 RETURN

CHARITEMS LDX #0
 LDA #0
 JSR LOADITEM2
 LDA ITEM2BUFF
 STA IRECS
 LDA PLRGOLD
 ORA PLRGOLD+1
 ORA PLRGOLD+2
 ORA PLRGOLD+3
 BEQ :NOGOLD
 JSR GETITEM
 STZ INUM ;0 = gold
 LDA PLRXPOS
 STA IXPOS
 LDA PLRYPOS
 STA IYPOS
 LDA PLRZPOS
 STA IZPOS
 LDX #3
]LOOP LDA PLRGOLD,X
 STA IDATA,X
 DEX
 BPL ]LOOP
 STZ IFREE
 STZ IBURIED
 JSR SAVEI
:NOGOLD LDX #0 ;Put all chars items into maze item file
]LOOP LDA PLRITEM ;ie. drop all his items (or hers)
 BEQ :DONE
 JSR GETITEM
 LDA PLRITEM
 STA INUM
 LDA PLRXPOS
 STA IXPOS
 LDA PLRYPOS
 STA IYPOS
 LDA PLRZPOS
 STA IZPOS
 STZ IDATA
 STZ IDATA+1
 STZ IDATA+2
 STZ IDATA+3
 STZ IFREE
 STZ IBURIED
 PHX
 JSR SAVEI
 LDX #0
]LOOP2 LDA PLRITEM+1,X ;Crunch items
 STA PLRITEM,X
 LDA PLRITEMX+1,X
 STA PLRITEMX,X
 INX
 CPX #7
 BNE ]LOOP2
 STZ PLRITEM+7
 STZ PLRITEMX+7
 PLX
 INX
 CPX #8
 BNE ]LOOP
:DONE LDA IRECS ;Update Maze Items (total)
 STA ITEM2BUFF
 STZ ITEM2BUFF+1
 LDX #0
 LDA #0
 JSR SAVEITEM2
 LDA PLRITEM ;Got anything?
 BEQ :NONE
 JSR PRINT
 SOUND $0E;1;$80
 NULL
 RTS
:NONE JSR PRINT
 SOUND $0D;1;$80
 NULL
 RTS

GETITEM LDA IRECS
 BEQ :NEXT
 LDA :RECS
 CMP IRECS
 BEQ :NEXT
]LOOP INC :RECS
 LDX :RECS
 LDA #0
 JSR LOADITEM2
 LDA IFREE
 BMI :GOTIT
 LDA :RECS
 CMP IRECS
 BCC ]LOOP
:NEXT INC IRECS
 LDA IRECS
 STA NEWITEM
 STA :RECS
 RTS
:GOTIT LDA :RECS
 STA NEWITEM
 RTS
:RECS DS 1

IRECS DS 2
NEWITEM DS 1

SAVEI LDX NEWITEM
 LDA #0
 JMP SAVEITEM2

SHAPETYPE DS 1

FINDPARTY LDX #0
 LDA #0
 JSR LOADPN
 LDX PNBUFF
]LOOP CPX #0
 BEQ :NONE
 PHX
 LDA #0
 JSR LOADPN
 PLX
 LDA PNFREE
 BMI :NEXT
 LDA PNSCENARIO
 CMP SCENARIO
 BEQ :YES
:NEXT DEX
 BRA ]LOOP
:YES CLC
 RTS
:NONE SEC
 RTS

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/GAME.NEXTURN
 fin

 END
