*-------------------------------
* GAME.PHIST
*-------------------------------
 DAT
 LST OFF

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE VARS
 USE LIB.JMP

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/GAME.PHIST
 fin

 MODID "GAME.PHIST"

START LDA VTEMP ;Get lines to use
 STA TOPLINE
 LDA VTEMP+1
 STA BOTLINE

 LDA $C022 ;Make sure any other part of the screen doesn't
 LSR ; get 'blacked out'
 LSR
 LSR
 LSR
 LDX #23
]LOOP STA :HILITE,X
 DEX
 BPL ]LOOP

 JSR GETLOGLEN
 STZ :RECORD
 STZ :RECORD+1
 STZ :RECORD+2
 STZ :RECORD+3
 STZ :RECS
 LDA #$FF
 STA :TOP
 STA :BOT
 JSR CLEARBOT
 LDA $C022
 STA :TEMP1
 MLI_OPEN :OPARMS
 JSR MLIERR
 LDA :OPARMS+5
 STA :MPARMS+1
 STA :RPARMS+1
 STA :RPARMS2+1
 JMP :LATEST

:MARK MLI_SET_MARK :MPARMS
 JSR MLIERR

:READ LDA :TEMP1
 STA $C022
 MLI_READ :RPARMS
 CMP #$4C ;EOF
 BNE :NOTEOF
 LDA #$FF
 STA :BOT
 JMP :DONE
:NOTEOF JSR MLIERR
 STZ :BOT

:SHOW LDA #<BUFFER
 STA CADD
 LDA #>BUFFER
 STA CADD+1
 LDX CV
 LDY #5
 LDA (CADD),Y
 STA :HILITE,X
 TAX
 LDA :SHRCOLORS,X
 STA :CL+2
 PUSH CADD
 JSR PRINT
:CL COLOR WHITE
 DATE BUFFER
 ASC " "
 TIME BUFFER+2
 ASC ":"
 PAD2 BUFFER+4
 ASC " "
 NULL
 PULL CADD
 LDX #0
 LDY #6
 LDA (CADD),Y ;Length of entry
 STA :LEN
]LOOP INY
 LDA (CADD),Y
 JSR COUT
 INX
 CPX :LEN
 BNE ]LOOP
 LDA :RECORD
 CLC
 ADC #LOGRECLEN
 STA :RECORD
 LDA :RECORD+1
 ADC #0
 STA :RECORD+1
 LDA :RECORD+2
 ADC #0
 STA :RECORD+2
 INC :RECS
 LDA #$0D
 JSR COUT
 LDA CV
 CMP BOTLINE
 BEQ :DONE2
 JMP :READ

:SHRCOLORS DFB $0 ;0=Black
 DFB $D ;1=Deep red (pink)
 DFB $4 ;2=Dark blue (dark blue)
 DFB $7 ;3=Purple (purple)
 DFB $2 ;4=Dark green (dark green)
 DFB $3 ;5=Dark gray (gray)
 DFB $4 ;6=Medium blue (dark blue)
 DFB $6 ;7=Light blue (aqua)
 DFB $8 ;8=Brown (poo brown)
 DFB $9 ;9=Orange (orange)
 DFB $C ;A=Light gray (lighter gray)
 DFB $D ;B=Pink (pink)
 DFB $A ;C=Green (green)
 DFB $B ;D=Yellow (yellow)
 DFB $E ;E=Aquamarine (aquamarine)
 DFB $F ;F=White (white)

:DONE LDX CV
]LOOP CPX BOTLINE
 BEQ :DONE2
 STZ :HILITE,X
 INX
 BRA ]LOOP
:DONE2 LDA BOTLINE
 STA :V2+3
 CLC
 XCE
 REP #$30
 PushLong #0
 PushLong #0
 PushLong :RECORD
 PushLong #LOGRECLEN
 Tool $0D0B ;LongDivide
 PullLong :LINE
 PLA ;Remainder
 PLA
 SEC
 XCE
 JSR PRINT
:V2 GOTOXY 0;0
 CLEOL
 COLOR WHITE
 CURSORON
 ASC "Line "
 COLOR YELLOW
 DEC32 :LINE
 COLOR WHITE
 ASC " of "
 COLOR YELLOW
 DEC32 TOTLINES
 COLOR WHITE
 ASC ". "
 MTON
 INVERSE
 ASC "K"
 NORMAL
 ASC ", "
 INVERSE
 ASC "J"
 NORMAL
 MTOFF
 ASC " to scroll, [B]eginning, [E]nd, [L]atest, [Q]uit : "
 NULL

:GETKEY LDY :HILITE
 LDA :HUES,Y
 STA $C022

 LDX #1
]LOOP LDA :HILITE-1,X
 BEQ :NEXT

 TAY
 LDA :HUES,Y
 TAY
 TXA
 DEC
 ASL
 ASL
 ORA #%1000_0000
 STA :TEMP2
 CLC
 ADC #4
 STA :TEMP3
 LDA :TEMP2
]LOOP1 CMP $C02E
 BNE ]LOOP1
 STY $C022
 LDA :TEMP3
]LOOP2 CMP $C02E
 BNE ]LOOP2
 LDA :HILITE,X
 CMP $C022
 BEQ :NEXT
 TAY
 LDA :HUES,Y
 STA $C022
:NEXT INX
 CPX #25
 BNE ]LOOP
:CDONE JSR TICKTOCK
 JSR CHECKCTRLX
 JSR CHECKIN ;Get anything from modem
 BCS :YEPIN
 LDA $C000
 BPL :GETKEY
:YEPIN STA $C010
 PHA
 JSR INITCNTR
 PLA
 JSR UPPER
 CMP #"J"-$40
 BEQL :DOWN
 CMP #"B"
 BEQ :BEG
 CMP #"E"
 BEQL :LEND
 CMP #"L"
 BEQ :LATEST
 CMP #"K"-$40
 BEQL :UP
 CMP #$9B
 BEQ :EXIT
 CMP #"W"-$40
 BEQ :REFRESH
 CMP #"Q"
 BNEL :GETKEY
:EXIT JSR PRINT
 ZAPLINE
 NULL
 LDA :TEMP1
 STA $C022
 JSR CLOSEALL
 RETURN ;Return from module

:REFRESH JSR REFRESH
 JMP :GETKEY

:BEG STZ :RECORD
 STZ :RECORD+1
 STZ :RECORD+2
 STZ :RECORD+3
 JSR CLEARBOT
 LDA #$FF
 STA :TOP
 JMP :MARK

:LATEST JSR PRINT
 HTAB 0
 CLEOL
 ASC "Wait.."
 NULL
 MLI_GET_EOF :MPARMS
 JSR MLIERR
]LOOP JSR :SUBREC
 MLI_SET_MARK :MPARMS
 BCS :BEG
 MLI_READ :RPARMS
 JSR MLIERR
 LDX BUFFER+6
 CPX :LOGOFF
 BNE ]LOOP
]LOOP2 LDA BUFFER+6,X
 CMP :LOGOFF,X
 BNE ]LOOP
 DEX
 BNE ]LOOP2
 JSR CLEARBOT
 STZ :RECS
 STZ :TOP
 STZ :BOT
 JMP :MARK
:LOGOFF STR "Logoff"

:SUBREC CLC
 XCE
 REP #$30
 LDA :RECORD
 SEC
 SBC #LOGRECLEN
 STA :RECORD
 LDA :RECORD+2
 SBC #0
 STA :RECORD+2
 SEC
 XCE
 RTS

:LEND BIT :BOT
 BMIL :GETKEY
 MLI_GET_EOF :MPARMS
 JSR MLIERR
 LDA BOTLINE
 SEC
 SBC TOPLINE
 TAX
 CLC
 XCE
 REP #$30
]LOOP LDA :RECORD
 SEC
 SBC #LOGRECLEN
 STA :RECORD
 LDA :RECORD+2
 SBC #0
 STA :RECORD+2
 DEX
 BNE ]LOOP
 SEC
 XCE
 STZ :TOP
 STZ :RECS
 JSR CLEARBOT
 JMP :MARK

:DOWN LDA :BOT ;Can we display any more?
 BMIL :GETKEY
 LDX #2
]LOOP LDA :RECORD,X
 CMP LOGLEN,X
 BNE :DOK
 DEX
 BPL ]LOOP
 LDA #$FF
 STA :BOT
 JMP :GETKEY
:DOK STZ :TOP
 STZ :RECS
 JSR CLEARBOT
 JMP :READ

:UP LDA :TOP ;Ditto..?
 BMIL :GETKEY
 LDA BOTLINE
 SEC
 SBC TOPLINE
 CLC
 ADC :RECS
 TAX
 STZ TEMP
 STZ TEMP+1
]LOOP LDA TEMP
 CLC
 ADC #LOGRECLEN
 STA TEMP
 LDA TEMP+1
 ADC #0
 STA TEMP+1
 DEX
 BNE ]LOOP
 CLC
 XCE
 REP #$30
 LDA :RECORD
 SEC
 SBC TEMP
 STA :RECORD
 LDA :RECORD+2
 SBC #0
 STA :RECORD+2
 BMI :ZTOP
 BNE :NOTOP
 LDA :RECORD
 BNE :NOTOP
 BRA :YESTOP
:ZTOP STZ :RECORD
 STZ :RECORD+2
:YESTOP SEC
 XCE
 LDA #$FF
 STA :TOP
:NOTOP SEC
 XCE
 STZ :RECS
 STZ :BOT
 JSR CLEARBOT
 JMP :MARK

:LEN DS 1
:TOP DS 1
:BOT DS 1
:RECS DS 1
:TEMP1 DS 1
:TEMP2 DS 1
:TEMP3 DS 1
:HILITE DS 24
 DFB 0 ;Don't delete this line
:HUES HEX 00 ;Black
 HEX 10 ;Deep red
 HEX 20 ;Dark blue
 HEX 30 ;Purple
 HEX 40 ;Dark green
 HEX 50 ;Dark gray
 HEX 60 ;Medium blue
 HEX 70 ;Light blue
 HEX 80 ;Brown
 HEX 90 ;Orange
 HEX A0 ;Light gray
 HEX B0 ;Pink
 HEX C0 ;Green
 HEX D0 ;Yellow
 HEX E0 ;Aquamarine
 HEX F0 ;White

:OPARMS DFB 3
 DA PATH
 DA IOBUFFER
 DS 1

:MPARMS DFB 2
 DS 1
:RECORD DS 4

:LINE DS 4

:RPARMS DFB 4
 DS 1
 DA BUFFER
 DA LOGRECLEN
 DS 2

:RPARMS2 DFB 4
 DS 1
 DA BUFFER
 DA LOGRECLEN*22
 DS 2

CLEARBOT LDA BOTLINE
 STA :V+3
 JSR PRINT
 CURSOROFF
 NULL
]LOOP JSR PRINT
:V GOTOXY 0;0
 ZAPLINE
 NULL
 DEC :V+3
 LDA :V+3
 CMP TOPLINE
 BNE ]LOOP
 JSR PRINT
 CURSORUP
 ZAPLINE
 NULL
 RTS

GETLOGLEN LDA PARTYNUM
 JSR GETHEX
 STX PATH+15 ;Make sure these match -\
 STY PATH+16 ;                       |
 MLI_OPEN :OPARMS
 JSR MLIERR
 LDA :OPARMS+5
 STA :GPARMS+1
 MLI_GET_EOF :GPARMS
 JSR MLIERR
 LDX #2
]LOOP LDA :GPARMS+2,X
 STA LOGLEN,X
 DEX
 BPL ]LOOP
 JSR CLOSEALL
 CLC
 XCE
 REP #$30
 PushLong #0
 PushLong #0
 PushLong LOGLEN
 PushLong #LOGRECLEN
 Tool $0D0B ;LongDivide
 PullLong TOTLINES
 PLA ;Remainder
 PLA
 SEC
 XCE
 RTS
:OPARMS DFB 3
 DA PATH
 DA IOBUFFER
 DS 1
:GPARMS DFB 2
 DS 1
 DS 3
PATH STR "DATA/PARTYLOG.XX" ;<------------/
LOGLEN DS 4

TEMP DS 2
TOTLINES DS 4

TOPLINE DS 1
BOTLINE DS 1

BUFFER DS LOGRECLEN*22

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/GAME.PHIST
 fin

 END
