*-------------------------------
* GAME.PRAY
*-------------------------------
 DAT
 LST OFF

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE VARS
 USE PLR.DSECT
 USE LIB.JMP
 USE TABLES
 USE SPELL.DSECT

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/GAME.PRAY
 fin

 MODID "GAME.PRAY"

START STZ MAZEFLAG
 LDX #79
 LDY #79
 LDA #23
 JSR PICKLINE
 LDA $200
 CMP #" "
 BNE START2
 JSR PRINT
 GOTOXY 0;15
 CLEOS
 NULL
 BRA GOGO
START2 JSR CLRBOT
 DEC MAZEFLAG

GOGO JSR CALCPLR
 LDA PLRLEVEL ;Calculated experience level
 CMP PLRLVLREAL ;Real experience level
 BEQ :SAME
 BCS :UPLVL

:SAME LDY #0
 SEC
 PHP
]LOOP PLP
 LDA (CADD2),Y
 SBC PLREXP,Y
 STA :EXP,Y
 PHP
 INY
 CPY #4
 BNE ]LOOP
 PLP
 JMP :CONT

:UPLVL INC PLRLVLREAL
 INC PLRAGE ;You get older..
 JSR PRINT
 GOTOXY 0;16
 COLOR YELLOW
 ASC "You gained a level!"
 SOUND $15;1;LOUD
 NULL
 PNOTELOGSTR $B;"Exp. level advancement : ";PLRNAME
 JSR PRINT
 ASC " You are now level "
 COLOR ORANGE
 DEC8 PLRLVLREAL
 COLOR YELLOW
 ASC "!"
 CR
 CR
 COLOR WHITE
 NULL

 RANDNUM #15 ;Attributes will be changed
 STX :RND
 LDA #%0000_1000
 STA :ANDX
 STZ :FLAG
 LDX #0
]LOOP LDA :RND
 AND :ANDX
 BEQ :NEXTA
 LDA PLRST,X
 CMP #20
 BCS :NEXTA
 LDA :FLAG
 BPL :OFF
 JSR PRINT
 ASC ", "
 NULL
 BRA :OFF2
:OFF JSR PRINT
 COLOR AQUAMARINE
 ASC "You gained "
 NULL
 LDA #$FF
 STA :FLAG
:OFF2 TXA
 ASL
 TAY
 LDA :ATTR,Y
 JSR COUT
 LDA :ATTR+1,Y
 JSR COUT
 INC PLRST,X
:NEXTA LSR :ANDX
 INX
 CPX #4
 BNE ]LOOP
 BIT :FLAG
 BPL :OFF3
 JSR PRINT
 LINE "."
 COLOR WHITE
 SOUND $25;1;$80
 NULL

 LDA PLRCLASS
 CMP #1
 BEQ :OFF3
 CMP #2
 BEQ :OFF3
 CMP #5
 BEQ :OFF3
 LDA PLRLVLREAL
 LSR
 CLC
 ADC #4
 TAX
 LDA #0
 JSR RANDOM ;1d(4+(level/2))+2 spell points added
 TXA
 CLC
 ADC #2
 ADC PLRMAGICMAX
 CMP #128
 BCC :MMOK
 LDA #127
:MMOK STA PLRMAGIC
 STA PLRMAGICMAX

:OFF3 STZ :SPFLAG ;For spells
 STZ :TOPCNTR
]LOOP LDA :TOPCNTR
 ASL
 TAX
 LDA :TBL,X
 STA CADD
 LDA :TBL+1,X
 STA CADD+1
 LDY PLRCLASS
 DEY
 LDA (CADD),Y
 BEQ :NXTS
 STA :CNTR2 ;Max amount of spells this division you can learn
 LDX #1
 STX :CNTR
 LDA :TOPCNTR
 INC
 STA :SPELLCL
]LOOP2 LDX :CNTR
 LDA #0
 JSR LOADSPELL
 LDA SPNAME+1
 CMP #"?" ;Spell doesn't exist
 BEQ :NEXTSP
 LDA :SPELLCL ;Spell class
 LDX :CNTR ;Spell number in this class
 JSR KNOWNSP ;Player know this spell already?
 BCS :NEXTSP
 LDX PLRIQ
 LDA :TBLIQ-1,X
 STA :SPEL
 RANDNUM #100 ;Chance of learning spell (%)
 INX
 CPX :SPEL
 BCS :NOLEARN ;No he didn't
 LDA :SPELLCL
 LDX :CNTR
 LDY #1
 JSR ALTERSP ;Add the spell into the 'books'
 LDA #$FF
 STA :SPFLAG
:NOLEARN DEC :CNTR2
 LDA :CNTR2
 BEQ :NXTS
:NEXTSP INC :CNTR
 LDA :CNTR
 CMP #33
 BNE ]LOOP2
:NXTS INC :TOPCNTR
 LDA :TOPCNTR
 CMP #3
 BNEL ]LOOP
 LDA :SPFLAG
 BEQ :DOSAVE
 JSR PRINT
 COLOR ORANGE
 ASC "You learned new spells!"
 SOUND $27;1;$80
 COLOR WHITE
 NULL
:DOSAVE LDX PLRHT ;Inc HP depending on Health
 LDA #0
 JSR RANDOM
 TXA
 CLC
 ADC #2
 ADC PLRHP+1
 CMP #128
 BCC :HPOK
 LDA #127
:HPOK STA PLRHP+1
 STA PLRHP
 JSR CALCPLR
 LDA PLRSPEED ;Add action points : RND(SPEED / 2)
 LSR
 TAX
 LDA #0
 JSR RANDOM
 TXA
 CLC
 ADC PLRMAXPNTS
 STA PLRMAXPNTS
 CMP #128
 BCC :POK
 LDA #127
 STA PLRMAXPNTS
:POK BIT MAZEFLAG
 BMI :MAZE
 JSR PRINT
 GOTOXY 0;23
 NULL
 GETRETURN
 JMP START
:MAZE JSR PRINT
 CURSOROFF
 VTAB 23
 COLOR PINK
 CENTER " [Press any key] "
 NULL
 JSR KEYIN
 JSR PRINT
 INVERSE
 COLOR YELLOW
 ZAPLINE
 COLOR WHITE
 NORMAL
 NULL
 JMP START

:ATTR ASC "STDXIQHT"
:FLAG DS 1
:RND DS 1
:ANDX DS 1
:CNTR DS 1
:CNTR2 DS 1
:SPEL DS 1
:SPFLAG DS 1
:SPELLCL DS 1
:TOPCNTR DS 1

* Table of "how many spells you can learn" for a class, every time you
* advance a level (eg; a Lord can learn up to 2 spells in each spell
* division)
:TBL DA :TBL1
 DA :TBL2
 DA :TBL3

*              1 2 3 4 5 6 7 8 9 - Classes (1=Fighter, 2=Thief, etc)
:TBL1 DFB 0,0,4,0,0,0,4,0,2 ;Wizard
:TBL2 DFB 0,0,0,4,0,0,0,4,2 ;Cleric
:TBL3 DFB 0,0,0,0,0,4,0,0,2 ;Sage

* Change of learning spells (depending on IQ)
:TBLIQ DFB 0,0,0,0,0,0,0,0,0 ;(1 - 10)
 DFB 40,45,50,55,60,65,70,75,85 ;(11 - 18)
 DFB 87,89 ;(19 - 20)

:CONT LDA PLRLVLREAL
 INC
 STA :PLRS
 JSR PRINT
 CR
 ASC "..and needs "
 DEC32 :EXP
 ASC " more experience points to make level "
 DEC8 :PLRS
 LINE "."
 SOUND $25;1;$80
 NULL
 JSR PRINT
 CURSOROFF
 NULL
 JMP EXIT
:EXP DS 4
:PLRS DS 1

EXIT RETURN

CLRBOT JSR PRINT
 GOTOXY 0;22
 LUP 6
 ZAPLINE
 CURSORUP
 --^
 ZAPLINE
 NULL
 RTS

MAZEFLAG DS 1

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/GAME.PRAY
 fin

 END
