*-------------------------------
* GAME.PRECSTLE
*-------------------------------
 DAT
 LST OFF

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE VARS
 USE LIB.JMP
 USE PLR.DSECT
 USE ITEM.DSECT
 USE INV.DSECT

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/GAME.PRECSTLE
 fin

 MODID "GAME.PRECSTLE"

START LDA VTEMP
 BMIL DOPLAYER

 LDX NUMPARTY ;Restore HP and some conditions upon entry
]LOOP PHX ; to the Castle
 LDA CURPARTY-1,X
 STA :REC
 LDA CURPARTY2-1,X
 STA :REC+1
 BNE :OK
 LDA :REC
 BEQL :NXTC
:OK LDX :REC
 LDA :REC+1
 JSR LOADPLR
 LDA PLRZPOS
 BNEL :NXTC
 INC :TOTAL
 JSR CALCPLR
 LDA PLRCOND
 AND #%1000_0000
 BMI :DEAD
 LDA PLRHP+1 ;Fix HP to full
 STA PLRHP
:DEAD LDA PLRCOND ;Reset everything except death
 AND #%1000_0000
 STA PLRCOND
 LDX #0
]LOOP2 STZ PLRCONDX,X
 INX
 CPX #7
 BNE ]LOOP2
 LDA PLRPKILLS
 ORA PLRPASSAULTS
 BEQL :CLEAN
 LDA #10
 STA :CHANCE
 LDA PLRCLASS
 CMP #2
 BEQ :THIEF
 CMP #5
 BEQ :NINJA
 CMP #9
 BEQ :LORD
 CMP #6 ;Elite should be slightly better..
 BCC :OTHER
 BRA :THIEF
:LORD DEC :CHANCE
:NINJA DEC :CHANCE
:THIEF DEC :CHANCE
:OTHER RANDNUM #10
 CPX :CHANCE
 BCS :CLEAN ;Slipped past guards at front gate..
 LDA :CNTR ;Caught!
 ASL
 TAX
 LDA :REC
 STA :TABLE,X
 LDA :REC+1
 STA :TABLE+1,X
 INC :CNTR
 LDA PLRARRESTFLAG
 ORA #%0100_0000
 STA PLRARRESTFLAG
 NOTELOGSTR $1;"Character jailed : ";PLRNAME
 PNOTELOGSTR $E;"Party member jailed : ";PLRNAME
:CLEAN LDX :REC
 LDA :REC+1
 JSR SAVEPLR
:NXTC PLX
 DEX
 BNEL ]LOOP
 JSR :JAILS
 RETURN
:REC DS 2

:CNTR DS 1
:TABLE DS 8*2
:CHANCE DS 1

:TOTAL DS 1
:JAILED DS 1

:JAILS LDA :CNTR
 BNE :SOME
 RTS
:SOME STA :JAILED
 STZ ITEMFLAG
 JSR PRINT
 HOME
 CURSORON
 ASC "Upon entering the Castle, the following were caught by the "
 ASC "guards and thrown in jail :"
 CR
 CR
 NULL
]LOOP DEC :CNTR
 LDA :CNTR
 ASL
 TAX
 LDA :TABLE,X
 STA :REC
 LDA :TABLE+1,X
 STA :REC+1
 LDX :REC
 LDA :REC+1
 JSR LOADPLR
 JSR CALCSENT
 STA PLRJAILDAYS
 INC PLRJAILED
 JSR PRINT
 COLOR GREEN
 PRSTRING PLRNAME
 COLOR WHITE
 HTAB 22
 ASC "- "
 NULL
 LDA PLRPKILLS
 ORA PLRPKILLS+1
 BEQ :ASS
 JSR PRINT
 COLOR PINK
 ASC "murder"
 COLOR WHITE
 ASC " ("
 COLOR YELLOW
 DEC16 PLRPKILLS
 COLOR WHITE
 ASC " count"
 NULL
 LDA PLRPKILLS
 CLC
 ADC PLRPKILLS+1
 CMP #1
 BEQ :OVK
 JSR PRINT
 ASC "s"
 NULL
:OVK JSR PRINT
 ASC ")"
 NULL
:ASS LDA PLRPASSAULTS
 ORA PLRPASSAULTS+1
 BEQ :SCONT
 LDA PLRPKILLS
 ORA PLRPKILLS+1
 BEQ :ASS2
 JSR PRINT
 ASC ", "
 NULL
:ASS2 JSR PRINT
 COLOR YELLOW
 ASC "assault"
 COLOR WHITE
 ASC " ("
 COLOR YELLOW
 DEC16 PLRPASSAULTS
 COLOR WHITE
 ASC " count"
 NULL
 LDA PLRPASSAULTS
 CLC
 ADC PLRPASSAULTS+1
 CMP #1
 BEQ :OVA
 JSR PRINT
 ASC "s"
 NULL
:OVA JSR PRINT
 ASC ")"
 NULL
:SCONT JSR PRINT
 CR
 HTAB 24
 ASC "["
 COLOR AQUAMARINE
 ASC "sentence "
 COLOR YELLOW
 DEC8 PLRJAILDAYS
 COLOR AQUAMARINE
 ASC " days"
 COLOR WHITE
 ASC "]"
 CR
 NULL

 JSR DONATE ;Donate some items to Shoppe
 LDX :REC
 LDA :REC+1
 JSR SAVEPLR

 LDA :CNTR
 BNEL ]LOOP
 JSR PRINT
 CR
 NULL
 BIT ITEMFLAG
 BPL :NOSTUFF
 JSR PRINT
 ASC "Some equipment has been 'donated' to The Shoppe. "
 NULL

:NOSTUFF LDY :JAILED ;Remove jailed members from current party
]LOOP TYA ; (effectively putting them in jail)
 ASL
 TAX
 LDA :TABLE,X
 STA :REC
 LDA :TABLE+1,X
 STA :REC+1
 LDX NUMPARTY
]LOOP2 LDA CURPARTY-1,X
 CMP :REC
 BNE :NAH
 LDA CURPARTY2-1,X
 CMP :REC+1
 BNE :NAH
 STZ CURPARTY-1,X
 STZ CURPARTY2-1,X
:NAH DEX
 BNE ]LOOP2
 DEY
 BPL ]LOOP

 LDX #0 ;Crunch..
]LOOP LDA CURPARTY,X
 ORA CURPARTY2,X
 BNE :NEXT1
 PHX
]LOOP2 LDA CURPARTY+1,X
 STA CURPARTY,X
 LDA CURPARTY2+1,X
 STA CURPARTY2,X
 INX
 CPX NUMPARTY
 BNE ]LOOP2
 STZ CURPARTY-1,X
 STZ CURPARTY2-1,X
 PLX
:NEXT1 INX
 CPX NUMPARTY
 BNE ]LOOP

 GETRETURN
 JSR PRINT
 HOME
 NULL
 RTS

ITEMFLAG DS 1

CALCSENT CLC ;Calculate sentence
 XCE
 REP #$30
 STZ :TEMP
 LDX PLRPKILLS
]LOOP CPX #0
 BEQ :DOASS
 LDA :TEMP
 CLC
 ADC #10 ;Days for murder
 STA :TEMP
 DEX
 BRA ]LOOP

:DOASS LDX PLRPASSAULTS
]LOOP CPX #0
 BEQ :DONE
 LDA :TEMP
 CLC
 ADC #2 ;Days for assault
 STA :TEMP
 DEX
 BRA ]LOOP

:DONE SEC
 XCE

 LDA :TEMP+1
 BNE :MAX
 LDA :TEMP
 RTS
:MAX LDA #255
 RTS

:TEMP DS 2

DONATE LDX #7
]LOOP2 STX :TEMPX
 LDA PLRITEM,X
 BEQ :NXT1
 TAX
 LDA #0
 JSR LOADITEM
 LDA ITYPE
 CMP #6 ;Misc
 BEQ :NXT1
 LDX :TEMPX
 LDA PLRITEM,X
 TAX
 LDA #0
 JSR LOADINV
 LDA INVSTOCK
 CMP INVMAX
 BCS :NXT1
 LDA #$FF
 STA ITEMFLAG
 INC INVSTOCK ;Put item 'on the shelf'
 LDX :TEMPX
 LDA PLRITEM,X
 TAX
 LDA #0
 JSR SAVEINV
 LDX :TEMPX
]LOOP3 CPX #7
 BEQ :NXT1Z
 LDA PLRITEM+1,X
 STA PLRITEM,X
 LDA PLRITEMX+1,X
 STA PLRITEMX,X
 INX
 BRA ]LOOP3
:NXT1Z STZ PLRITEM,X
 STZ PLRITEMX,X
:NXT1 LDX :TEMPX
 DEX
 BPLL ]LOOP2
 RTS
:TEMPX DS 1

DOPLAYER
* JSR CALCSENT ;Player taken to Jail from Dungeon by Guard
* STA PLRJAILDAYS
* INC PLRJAILED
 JSR CALCPLR
 LDA PLRCOND
 AND #%1000_0000
 BMI :DEAD
 LDA PLRHP+1 ;Fix HP to full
 STA PLRHP
:DEAD LDA PLRCOND ;Reset everything except death
 AND #%1000_0000
 STA PLRCOND
 LDX #0
]LOOP STZ PLRCONDX,X
 INX
 CPX #7
 BNE ]LOOP

 LDA PLRPKILLS
 ORA PLRPASSAULTS
 BNE :JDO
 RETURN
:JDO JSR CALCSENT
 STA PLRJAILDAYS
 INC PLRJAILED

 LDA #%0100_0000
 TSB PLRARRESTFLAG ;In jail..
 LDA #%1000_0000
 TRB PLRARRESTFLAG ;No under arrest anymore..
 LDA PLRJAILDAYS
 STA :DAYS
 LDA PARTYNUM
 PHA
 LDA PLRPARTY
 STA PARTYNUM
 NOTELOGSTR $E;"Character jailed : ";PLRNAME
 PNOTELOGSTR $E;"Party member jailed : ";PLRNAME
 NOTELOGNUM $E;"Days sentenced : ";:DAYS
 PNOTELOGNUM $E;"Days sentenced : ";:DAYS
 PLA
 STA PARTYNUM
 JSR DONATE
 BIT ITEMFLAG ;Anything donated?
 BPL :NO
 PNOTELOG $E;"Some items were 'donated' to The Shoppe"
:NO RETURN

:DAYS DS 4

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/GAME.PRECSTLE
 fin

 END
