*-------------------------------
* GAME.START
*-------------------------------
 DAT
 LST OFF

 XC
 XC

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE LIB.JMP
 USE VARS
 USE PN.DSECT
 USE GLOSS.DSECT
 USE INV.DSECT

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/GAME.START
 fin

 MODID "GAME.START"

*------------------------------- Files loaded into RAM
*  1 - Items
*  2 - Players
*  3 - Monsters
*  4 - Maze monsters
*  5 - Maze Items
*  6 - Spells
*  7 - Message BitMap
*  8 - Party names
*  x - Pageout area (modules)
*  f - Font (character set)
*-------------------------------

START LDA #$FF
 STA DUMBTERM
 STZ CONNECTED

 JSR PRINT2
 LINE "Loading 'VARIABLES'"
 NULL
 LDA BORDER
 PHA
 LDA TBCOLOR
 PHA
 JSR LOADVARS
 PLA
 STA TBCOLOR
 PLA
 STA BORDER

 LDA #$FF
 STA DUMBTERM
 STZ CONNECTED

 LDA $C035
 STA QSAVE
 AND #%1110_0111 ;Enable SHR shadowing
 STA $C035

 LDA $C02D ;Slot settings
 STA SLOTSAVE

 STZ COMSPROG

 JSR PRINT2
 LINE "Starting Tools.."
 NULL
 CLC
 XCE
 REP #$30

 Tool $0201 ;TLStartUp

 PushWord #0
 Tool $0202 ;MMStartUp

 PushWord #0
 PushWord #%0001_0000_0000000_0 ;Type = application
 Tool $2003 ;GetNewID
 PullWord USERID
 ORA #$0100
 STA MYID ;Make and ID of $0100 for me
 JSR ERROR

 Tool $0203 ;MTStartUp

*
* Get address of SHR screen table
*
 PushLong #0
 PushWord #$0001 ;screenTable
 Tool $0904 ;GetAddress
 PullLong SCRNPNTR

 SEC
 XCE
 JSR PRINT2
 LINE "Getting memory.."
 NULL
 CLC
 XCE
 REP #$30

 Tool $1F02 ;CompactMem

 Tool $020B ;IMStartUp

 SEC
 XCE

 LDX #0
]LOOP PHX
 TXA
 ASL
 ASL
 TAX
 LDA BKSIZES,X
 STA BLOCKSIZE
 LDA BKSIZES+1,X
 STA BLOCKSIZE+1
 LDA BKSIZES+2,X
 STA BLOCKSIZE+2
 CLC
 XCE
 REP #$30
 PushLong #0 ;Space
 PushLong BLOCKSIZE ;Block size for this Handle
 PushWord MYID ;User ID
 PushWord #%0000_0000_0000_1000 ;Attributes
 PushLong #0 ;Pointer to where in memory the block begins
 Tool $0902 ;NewHandle
 JSR ERROR
 LDX :PNTR
 PLA
 STA HANDLES,X ;Handle of new block
 PLA
 STA HANDLES+2,X
 LDA :PNTR
 CLC
 ADC #4
 STA :PNTR
 SEC
 XCE
 PLX
 INX
 CPX #NUMFILES
 BNE ]LOOP
 JMP START2
:PNTR DS 2
BLOCKSIZE DS 4
BKSIZES ADRL $10000 ;1-Item
 ADRL $20000 ;2-Player
 ADRL $10000 ;3-Monster
 ADRL $10000 ;4-Maze monster
 ADRL $10000 ;5-Maze item
 ADRL $C20 ;6-Spell
 ADRL $2000 ;7-Message BitMap
 ADRL $10000 ;8-Party names
 ADRL $19D00 ;x-Pageout area (modules)
 ADRL 80*25+$1000 ;f-Font (character set)

START2 JSR PRINT2
 LINE "Checking 'LOG'"
 NULL

 JSR CHECKFILE ;Does the file
 STR "LOG" ;'LOG'
 BCC :THERE ;exist?
 MLI_CREATE :CRPARMS
 JSR MLIERR
 NOTELOG $1;"Log created"

:THERE NOTELOG $E;"*------------------------ Boot ------------------------*"

 MLI_GET_PREFIX :PFXPARMS
 JSR MLIERR
 LDX :PREFIX
]LOOP LDA :PREFIX,X
 ORA #%1000_0000
 STA :PREFIX,X
 DEX
 BNE ]LOOP
 NOTELOGSTR $7;"// Prefix ";:PREFIX
 LDX #0
]LOOP INX
 LDA :PREFIX+1,X
 CMP #"/"
 BEQ :SLASH
 CPX :PREFIX
 BNE ]LOOP
 DEX
:SLASH INX
 STX :PREFIX
 MLI_GET_FILE_INFO :GETPARMS
 JSR MLIERR
 LDA :GETPARMS+5
 STA :BLOCKS
 LDA :GETPARMS+6
 STA :BLOCKS+1
 NOTELOGNUM $7;"// Total blocks : ";:BLOCKS
 LDA :GETPARMS+5
 SEC
 SBC :GETPARMS+8
 STA :FREBLOCKS
 LDA :GETPARMS+6
 SBC :GETPARMS+9
 STA :FREBLOCKS+1
 NOTELOGNUM $7;"// Free blocks  : ";:FREBLOCKS
 MLI_GET_FILE_INFO :GPARMS
 LDA :GPARMS+8
 STA :LIBSIZE
 LDA :GPARMS+9
 STA :LIBSIZE+1
 LSR :LIBSIZE+1
 ROR :LIBSIZE
 NOTELOGNUM $7;"// Library size (K) = ";:LIBSIZE

 LDX #0
 LDA #0
 JSR LOADSCEN
 LDA SCENBUFF
 STA SCENARIO

 JSR PRINT2
 LINE "Checking 'LOGFILE.x' files"
 NULL

 LDA SCENARIO
 PHA
 STZ VTEMP

]LOOP INC VTEMP
 LDA VTEMP
 ORA #"0"
 STA :LF1+18
 STA :LF2+9
 STA :LF3+9
 STA :LF4+22
 STA :PATH2+9
 JSR PRINT2
:LF1 LINE "Checking 'LOGFILE.0'"
 NULL
 JSR CHECKFILE
:LF2 STR "LOGFILE.0"
 BCCL :THERE2
 MLI_CREATE :CRPARMS2
 JSR MLIERR
 JSR PRINT2
:LF3 LINE "'LOGFILE.0' not found - file created"
 NULL
:LF4 NOTELOG $F;"Created 'LOGFILE.0' file"
 LDA VTEMP
 STA SCENARIO
 STZ LOGBUFF
 STZ LOGBUFF+1
 LDX #0
 LDA #0
 JSR SAVELOGFILE

:THERE2 LDA VTEMP
 CMP #9
 BNEL ]LOOP
 PLA
 STA SCENARIO

 JSR PRINT2
 LINE "Checking 'ITEMS'"
 NULL
 JSR CHECKFILE
 STR "ITEMS"
 BCC :THERE3
 MLI_CREATE :CRPARMS5
 JSR MLIERR
 JSR PRINT2
 LINE "'ITEMS' not found - file created"
 NULL
 NOTELOG $F;"Created 'ITEMS' file"
 STZ ITEMBUFF
 STZ ITEMBUFF+1
 LDX #0
 LDA #0
 JSR SAVEITEM
 JMP :IDONE

:THERE3 JSR PRINT2
 LINE "Loading 'ITEMS'"
 NULL
 JSR LOADSLICE
 STR "ITEMS"
 DA ITEMBUFF
 DA 0
 DA ITEMRECLEN
 LDA ITEMBUFF
 STA TOTAL
 LDA ITEMBUFF+1
 STA TOTAL+1
 NOTELOGNUM $7;"// ITEMS on file = ";TOTAL

 STZ :ITEM
 STZ :ITEM+1
]LOOP LDA :ITEM+1
 CMP TOTAL+1
 BEQ :I2
 BCS :IDONE
 BCC :IL
:I2 LDA :ITEM
 CMP TOTAL
 BEQ :IL
 BCS :IDONE
:IL JSR LOADSLICE
 STR "ITEMS"
 DA ITEMBUFF
:ITEM DA 0
 DA ITEMRECLEN
 LDX :ITEM
 LDA :ITEM+1
 LDY #FILEITEMS
 JSR METOMEM
 INCR :ITEM
 JMP ]LOOP

:IDONE JSR PRINT2
 LINE "Checking 'MAZE.ITEMS.x' files"
 NULL
 LDA SCENARIO
 PHA
 STZ VTEMP

]LOOP INC VTEMP
 LDA VTEMP
 ORA #"0"
 STA :MI1+21
 STA :MI2+12
 STA :MI3+12
 STA :MI4+25
 STA :PATH11+12
 JSR PRINT2
:MI1 LINE "Checking 'MAZE.ITEMS.0'"
 NULL
 JSR CHECKFILE
:MI2 STR "MAZE.ITEMS.0"
 BCCL :THERE4
 MLI_CREATE :CRPARMS11
 JSR MLIERR
 JSR PRINT2
:MI3 LINE "'MAZE.ITEMS.0' not found - file created"
 NULL
:MI4 NOTELOG $F;"Created 'MAZE.ITEMS.0' file"
 LDA VTEMP
 STA SCENARIO
 STZ ITEM2BUFF
 STZ ITEM2BUFF+1
 LDX #0
 LDA #0
 JSR SAVEITEM2

:THERE4 LDA VTEMP
 CMP #9
 BNEL ]LOOP
 PLA
 STA SCENARIO

 JSR PRINT2
 LINE "Loading 'MAZE.ITEMS'"
 NULL
 LDA SCENARIO
 ORA #"0"
 STA :MIS+12
 STA :MIS2+12
 JSR LOADSLICE
:MIS STR "MAZE.ITEMS.0"
 DA ITEM2BUFF
 DA 0
 DA ITEM2RECLEN
 LDA ITEM2BUFF
 STA TOTAL
 LDA ITEM2BUFF+1
 STA TOTAL+1
 NOTELOGNUM $7;"// MAZE ITEMS on file = ";TOTAL

 STZ :ITEM2
 STZ :ITEM2+1
]LOOP LDA :ITEM2+1
 CMP TOTAL+1
 BEQ :II2
 BCS :IDONE2
 BCC :IIL
:II2 LDA :ITEM2
 CMP TOTAL
 BEQ :IIL
 BCS :IDONE2
:IIL JSR LOADSLICE
:MIS2 STR "MAZE.ITEMS.0"
 DA ITEM2BUFF
:ITEM2 DA 0
 DA ITEM2RECLEN
 LDX :ITEM2
 LDA :ITEM2+1
 LDY #FILEITEMS2
 JSR METOMEM
 INCR :ITEM2
 JMP ]LOOP

:IDONE2 JSR PRINT2
 LINE "Checking 'PLAYERS'"
 NULL
 JSR CHECKFILE
 STR "PLAYERS"
 BCC :THERE5
 MLI_CREATE :CRCHAR
 JSR MLIERR
 JSR PRINT2
 LINE "'PLAYERS' not found - file created"
 NULL
 NOTELOG $F;"Created 'PLAYERS' file"
 STZ PLRBUFF
 STZ PLRBUFF+1
 LDX #0
 LDA #0
 JSR SAVEPLR
 JMP :PDONE

:THERE5 JSR PRINT2
 LINE "Loading 'PLAYERS'"
 NULL
 JSR LOADSLICE
 STR "PLAYERS"
 DA PLRBUFF
 DA 0
 DA PLRRECLEN
 LDA PLRBUFF
 STA TOTAL
 LDA PLRBUFF+1
 STA TOTAL+1
 NOTELOGNUM $7;"// PLAYERS on file = ";TOTAL

 STZ :PLR
 STZ :PLR+1
]LOOP LDA :PLR+1
 CMP TOTAL+1
 BEQ :P2
 BCS :PDONE
 BCC :PL
:P2 LDA :PLR
 CMP TOTAL
 BEQ :PL
 BCS :PDONE
:PL JSR LOADSLICE
 STR "PLAYERS"
 DA PLRBUFF
:PLR DA 0
 DA PLRRECLEN
 LDX :PLR
 LDA :PLR+1
 LDY #FILEPLRS
 JSR METOMEM
 INCR :PLR
 JMP ]LOOP

:PDONE JSR PRINT2
 LINE "Checking 'MONSTERS'"
 NULL
 JSR CHECKFILE
 STR "MONSTERS"
 BCC :THERE6
 MLI_CREATE :CRPARMS3
 JSR MLIERR
 JSR PRINT2
 LINE "'MONSTERS' not found - file created"
 NULL
 NOTELOG $F;"Created 'MONSTERS' file"
 STZ MONBUFF
 STZ MONBUFF+1
 LDX #0
 LDA #0
 JSR SAVEMON
 JMP :MDONE

:THERE6 JSR PRINT2
 LINE "Loading 'MONSTERS'"
 NULL
 JSR LOADSLICE
 STR "MONSTERS"
 DA MONBUFF
 DA 0
 DA MONRECLEN
 LDA MONBUFF
 STA TOTAL
 LDA MONBUFF+1
 STA TOTAL+1
 NOTELOGNUM $7;"// MONSTERS on file = ";TOTAL

 STZ :MON
 STZ :MON+1
]LOOP LDA :MON+1
 CMP TOTAL+1
 BEQ :M2
 BCS :MDONE
 BCC :ML
:M2 LDA :MON
 CMP TOTAL
 BEQ :ML
 BCS :MDONE
:ML JSR LOADSLICE
 STR "MONSTERS"
 DA MONBUFF
:MON DA 0
 DA MONRECLEN
 LDX :MON
 LDA :MON+1
 LDY #FILEMONS
 JSR METOMEM
 INCR :MON
 JMP ]LOOP

:MDONE JSR PRINT2
 LINE "Checking 'MAZE.MONSTERS.x' files"
 NULL

 LDA SCENARIO
 PHA
 STZ VTEMP

]LOOP INC VTEMP
 LDA VTEMP
 ORA #"0"
 STA :MM1+24
 STA :MM2+15
 STA :MM3+15
 STA :MM4+28
 STA :PATH8+15
 JSR PRINT2
:MM1 LINE "Checking 'MAZE.MONSTERS.0'"
 NULL
 JSR CHECKFILE
:MM2 STR "MAZE.MONSTERS.0"
 BCCL :THERE7
 MLI_CREATE :CRPARMS8
 JSR MLIERR
 JSR PRINT2
:MM3 LINE "'MAZE.MONSTERS.0' not found - file created"
 NULL
:MM4 NOTELOG $F;"Created 'MAZE.MONSTERS.0' file"
 LDA VTEMP
 STA SCENARIO
 STZ MON2BUFF
 STZ MON2BUFF+1
 LDX #0
 LDA #0
 JSR SAVEMON2

:THERE7 LDA VTEMP
 CMP #9
 BNEL ]LOOP
 PLA
 STA SCENARIO

 JSR PRINT2
 LINE "Loading 'MAZE.MONSTERS'"
 NULL
 LDA SCENARIO
 ORA #"0"
 STA :MMS+15
 STA :MMS2+15
 JSR LOADSLICE
:MMS STR "MAZE.MONSTERS.0"
 DA MON2BUFF
 DA 0
 DA MON2RECLEN
 LDA MON2BUFF
 STA TOTAL
 LDA MON2BUFF+1
 STA TOTAL+1
 NOTELOGNUM $7;"// MAZE MONSTERS on file = ";TOTAL

 STZ :MON2
 STZ :MON2+1
]LOOP LDA :MON2+1
 CMP TOTAL+1
 BEQ :M22
 BCS :MDONE2
 BCC :ML2
:M22 LDA :MON2
 CMP TOTAL
 BEQ :ML2
 BCS :MDONE2
:ML2 JSR LOADSLICE
:MMS2 STR "MAZE.MONSTERS.0"
 DA MON2BUFF
:MON2 DA 0
 DA MON2RECLEN
 LDX :MON2
 LDA :MON2+1
 LDY #FILEMONS2
 JSR METOMEM
 INCR :MON2
 JMP ]LOOP

:MDONE2 JSR PRINT2
 LINE "Checking 'SCENARIOS'"
 NULL
 JSR CHECKFILE
 STR "SCENARIOS"
 BCC :THERE8
 MLI_CREATE :CRPARMS9
 JSR MLIERR
 JSR PRINT2
 LINE "'SCENARIOS' not found - file created"
 NULL
 NOTELOG $F;"Created 'SCENARIOS' file"
 STZ SCENBUFF
 STZ SCENBUFF+1
 LDX #0
 LDA #0
 JSR SAVESCEN

:THERE8 LDX #0
 LDA #0
 JSR LOADSCEN
 LDA SCENBUFF

 JSR PRINT2
 LINE "Checking 'MAP.x' files"
 NULL
 LDA SCENARIO
 PHA
 LDA #-1
 STA VTEMP

]LOOP INC VTEMP
 LDA VTEMP
 ORA #"0"
 STA :MP1+14
 STA :MP2+5
 STA :MP3+5
 STA :MP4+18
 STA :PATH4+5
 JSR PRINT2
:MP1 LINE "Checking 'MAP.0'"
 NULL
 JSR CHECKFILE
:MP2 STR "MAP.0"
 BCCL :THERE9
 MLI_CREATE :CRPARMS4
 JSR MLIERR
 JSR PRINT2
:MP3 LINE "'MAP.0' not found - file created"
 NULL
:MP4 NOTELOG $F;"Created 'MAP.0' file"
 LDA VTEMP
 STA SCENARIO
 LDA #1
 STA MAP
 STZ MAP+1
 LDX #0
 LDA #0
 JSR SAVEMAP
 LDX #0 ;..create 1 level anyway
]LOOP2 STZ MAP,X
 INX
 BNE ]LOOP2
 LDX #1
 LDA #0
 JSR SAVEMAP

:THERE9 LDA VTEMP
 CMP #9
 BNEL ]LOOP
 PLA
 STA SCENARIO

 JSR PRINT2
 LINE "Checking 'MAP2.x' files"
 NULL

 LDA SCENARIO
 PHA
 STZ VTEMP

]LOOP INC VTEMP
 LDA VTEMP
 ORA #"0"
 STA :MP21+15
 STA :MP22+6
 STA :MP23+6
 STA :MP24+19
 STA :PATH6+6
 JSR PRINT2
:MP21 LINE "Checking 'MAP2.0'"
 NULL
 JSR CHECKFILE
:MP22 STR "MAP2.0"
 BCCL :THERE10
 MLI_CREATE :CRPARMS6
 JSR MLIERR
 JSR PRINT2
:MP23 LINE "'MAP2.0' not found - file created"
 NULL
:MP24 NOTELOG $F;"Created 'MAP2.0' file"
 LDA VTEMP
 STA SCENARIO
 LDA #1
 STA MAP2
 STZ MAP2+1
 LDX #0
 LDA #0
 JSR SAVEMAP2
 LDX #0
]LOOP2 STZ MAP2,X
 INX
 BNE ]LOOP2
 LDX #0
 LDA #0
 JSR LOADMAP
 LDY MAP
 LDX #0
]LOOP2 INX
 PHX
 PHY
 LDA #0
 JSR SAVEMAP2
 PLY
 PLX
 DEY
 BNE ]LOOP2

:THERE10 LDA VTEMP
 CMP #9
 BNEL ]LOOP
 PLA
 STA SCENARIO

 JSR PRINT2
 LINE "Checking 'STAIRS.TPORT.x' files"
 NULL
 LDA SCENARIO
 PHA
 LDA #-1
 STA VTEMP

]LOOP INC VTEMP
 LDA VTEMP
 ORA #"0"
 STA :ST1+23
 STA :ST2+14
 STA :ST3+14
 STA :ST4+27
 STA :PATH7+14

 JSR PRINT2
:ST1 LINE "Checking 'STAIRS.TPORT.0'"
 NULL
 JSR CHECKFILE
:ST2 STR "STAIRS.TPORT.0"
 BCC :THERE11
 MLI_CREATE :CRPARMS7
 JSR MLIERR
 JSR PRINT2
:ST3 LINE "'STAIRS.TPORT.0' not found - file created"
 NULL
:ST4 NOTELOG $F;"Created 'STAIRS.TPORT.0' file"
 LDA VTEMP
 STA SCENARIO
 STZ STBUFF
 STZ STBUFF+1
 LDX #0
 LDA #0
 JSR SAVEST

:THERE11 LDA VTEMP
 CMP #9
 BNEL ]LOOP
 PLA
 STA SCENARIO

 JSR PRINT2
 LINE "Checking 'PARTY.NAMES'"
 NULL
 JSR CHECKFILE
 STR "PARTY.NAMES"
 BCC :THERE12A
 MLI_CREATE :CRPARMS10
 JSR MLIERR
 JSR PRINT2
 LINE "'PARTY.NAMES' not found - file created"
 NULL
 NOTELOG $F;"Created 'PARTY.NAMES' file"
 STZ PNBUFF
 STZ PNBUFF+1
 LDX #0
 LDA #0
 JSR SAVEPN
 JMP :THERE12

:THERE12A JSR PRINT2
 LINE "Loading 'PARTY.NAMES'"
 NULL
 JSR LOADSLICE
 STR "PARTY.NAMES"
 DA PNBUFF
 DA 0
 DA PNRECLEN
 LDA PNBUFF
 STA TOTAL
 LDA PNBUFF+1
 STA TOTAL+1
 NOTELOGNUM $7;"// PARTY NAMES on file = ";TOTAL

 STZ :PN
 STZ :PN+1
]LOOP LDA :PN+1
 CMP TOTAL+1
 BEQ :PN2
 BCS :THERE12B
 BCC :PNL
:PN2 LDA :PN
 CMP TOTAL
 BEQ :PNL
 BCS :THERE12B
:PNL JSR LOADSLICE
 STR "PARTY.NAMES"
 DA PNBUFF
:PN DA 0
 DA PNRECLEN
 LDX :PN
 LDA :PN+1
 LDY #FILEPN
 JSR METOMEM
 INCR :PN
 JMP ]LOOP

:THERE12B JSR PRINT2
 LINE "Checking 'DATA/PARTYLOG.xx' files"
 NULL
 LDX #0
 LDA #0
 JSR LOADPN
 LDX PNBUFF
 STX :PNUM
]LOOP LDX :PNUM
 BEQL :THERE12
 LDA #0
 JSR LOADPN
 BIT PNFREE
 BMIL :NXT12B
 LDA :PNUM
 JSR GETHEX
 STX :PL1+24
 STY :PL1+25
 STX :PL2+15
 STY :PL2+16
 STX :PL3+15
 STY :PL3+16
 STX :PL4+28
 STY :PL4+29
 STX :PATH16+15
 STY :PATH16+16

 JSR PRINT2
:PL1 LINE "Checking 'DATA/PARTYLOG.00'"
 NULL
 JSR CHECKFILE
:PL2 STR "DATA/PARTYLOG.00"
 BCC :NXT12B
 MLI_CREATE :CRPARMS16
 JSR MLIERR
 JSR PRINT2
:PL3 LINE "'DATA/PARTYLOG.00' not found - file created"
 NULL
:PL4 NOTELOG $F;"Created 'DATA/PARTYLOG.00' file"

:NXT12B DEC :PNUM
 JMP ]LOOP
:PNUM DS 1

:THERE12 JSR PRINT2
 LINE "Checking 'HALL.OF.FAME'"
 NULL
 JSR CHECKFILE
 STR "HALL.OF.FAME"
 BCC :THERE13
 MLI_CREATE :CRPARMS12
 JSR MLIERR
 JSR PRINT2
 LINE "'HALL.OF.FAME' not found - file created"
 NULL
 NOTELOG $F;"Created 'HALL.OF.FAME' file"
 STZ MISCBUFF
 STZ MISCBUFF+1
 LDX #0
 LDA #0
 JSR SAVEHOF

:THERE13 JSR PRINT2
 LINE "Loading 'TABLES'"
 NULL
 JSR LOADFILE
 STR "TABLES"
 DA TABLES
 ADRL 0

 JSR PRINT2
 LINE "Checking 'SPELLS'"
 NULL
 JSR CHECKFILE
 STR "SPELLS"
 BCC :THERE14
 JSR PRINT2
 LINE "No spells to load."
 NULL
 DEATH ;Too bad..

:THERE14 JSR PRINT2
 LINE "Loading 'SPELLS'"
 NULL
 JSR LOADSLICE
 STR "SPELLS"
 DA SPELLBUFF
 DA 0
 DA SPELLRECLEN
 LDA SPELLBUFF
 STA TOTAL
 LDA SPELLBUFF+1
 STA TOTAL+1

 STZ :SPEL
 STZ :SPEL+1
]LOOP LDA :SPEL+1
 CMP TOTAL+1
 BEQ :S2
 BCS :SDONE
 BCC :SL
:S2 LDA :SPEL
 CMP TOTAL
 BEQ :SL
 BCS :SDONE
:SL JSR LOADSLICE
 STR "SPELLS"
 DA SPELLBUFF
:SPEL DA 0
 DA SPELLRECLEN
 LDX :SPEL
 LDA :SPEL+1
 LDY #FILESPELLS
 JSR METOMEM
 INCR :SPEL
 JMP ]LOOP

:SDONE JSR PRINT2
 LINE "Checking 'MSG.INDEX'"
 NULL
 JSR CHECKFILE
 STR "MSG.INDEX"
 BCC :THERE15
 MLI_CREATE :CRPARMS13
 JSR MLIERR
 JSR PRINT2
 LINE "'MSG.INDEX' not found - file created"
 NULL
 NOTELOG $F;"Created 'MSG.INDEX' file"
 STZ MSGINDXBUFF
 STZ MSGINDXBUFF+1
 LDX #0
 LDA #0
 JSR SAVEMSGINDX
 JMP :MSDONE

:THERE15 JSR LOADSLICE
 STR "MSG.INDEX"
 DA MSGINDXBUFF
 DA 0
 DA MSGINDXRECLEN
 LDA MSGINDXBUFF
 STA TOTAL
 LDA MSGINDXBUFF+1
 STA TOTAL+1
 NOTELOGNUM $7;"// MESSAGES (indexed) on file = ";TOTAL

:MSDONE JSR PRINT2
 LINE "Checking 'MESSAGES'"
 NULL
 JSR CHECKFILE
 STR "MESSAGES"
 BCC :THERE16
 MLI_CREATE :CRPARMS14
 JSR MLIERR
 JSR PRINT2
 LINE "'MESSAGES' not found - file created"
 NULL
 NOTELOG $F;"Created 'MESSAGES' file"
 STZ MSGBUFF
 STZ MSGBUFF+1
 LDX #0
 LDA #0
 JSR SAVEMSG
 JMP :MBDONE

:THERE16 JSR LOADSLICE
 STR "MESSAGES"
 DA MSGBUFF
 DA 0
 DA MSGRECLEN
 LDA MSGBUFF
 STA TOTAL
 LDA MSGBUFF+1
 STA TOTAL+1
 NOTELOGNUM $7;"// MESSAGES on file = ";TOTAL

:MBDONE JSR PRINT2
 LINE "Checking 'MSG.BITMAP'"
 NULL
 JSR CHECKFILE
 STR "MSG.BITMAP"
 BCCL :THERE17
 MLI_CREATE :CRPARMS15
 JSR MLIERR
 JSR PRINT2
 LINE "'MSG.BITMAP' not found - file created"
 NULL
 NOTELOG $F;"Created 'MSG.BITMAP' file"
 CLC
 XCE
 REP #$30
 LDX #0
]LOOP STZ BITMAPBUFF,X
 INX
 INX
 CPX #BITMAPRECLEN
 BNE ]LOOP
 SEC
 XCE
 STZ :BMC+1
]LOOP LDA #0
:BMC LDX #0
 JSR SAVEBITMAP
 INC :BMC+1
 LDA :BMC+1
 CMP #$20 ;This will hold 65535 messages (effectively)
 BNE ]LOOP
 LDX #0
 LDA #0
 JSR MARKUSED ;Message 0 shouldn't be used (so make it 'not free')
 JMP :BMDONE

:THERE17 JSR PRINT2
 LINE "Loading 'MSG.BITMAP'"
 NULL
 LDA #$20-1
 STA TOTAL
 LDA #0
 STA TOTAL+1
 STZ :BMAP
 STZ :BMAP+1
]LOOP LDA :BMAP+1
 CMP TOTAL+1
 BEQ :BM2
 BCS :BMDONE
 BCC :BM
:BM2 LDA :BMAP
 CMP TOTAL
 BEQ :BM
 BCS :BMDONE
:BM JSR LOADSLICE
 STR "MSG.BITMAP"
 DA BITMAPBUFF
:BMAP DA 0
 DA BITMAPRECLEN
 LDX :BMAP
 LDA :BMAP+1
 LDY #FILEBITMAP
 JSR METOMEM
 INCR :BMAP
 JMP ]LOOP

:BMDONE JSR PRINT2
 LINE "Checking dungeon levels.."
 NULL
 LDA SCENARIO
 PHA
 STZ SCENARIO
]LOOP INC SCENARIO
 LDX #0
 LDA #0
 JSR LOADMAP
 LDX SCENARIO
 LDA MAP
 STA MAPLEVELS-1,X
 LDA SCENARIO
 CMP #9
 BNE ]LOOP
 PLA
 STA SCENARIO

 JSR PRINT2
 LINE "Checking 'GLOSSARY'"
 NULL
 JSR CHECKFILE
 STR "HELP/GLOSSARY"
 BCC :THERE18
 MLI_CREATE :CRGLOSS
 JSR MLIERR
 NOTELOG $F;"Created 'GLOSSARY' file"
 JSR PRINT2
 LINE "'GLOSSARY' not found - file created"
 NULL
 STZ MISCBUFF
 STZ MISCBUFF+1
 STZ GLWORD
 STZ GLLEN
 STZ GLLEN+1
 JSR SAVESLICE
 STR "HELP/GLOSSARY"
 DA MISCBUFF
 DA 0
 DA GLRECLEN

:THERE18 JSR PRINT2
 LINE "Checking 'SPELL.DESCR'"
 NULL
 JSR CHECKFILE
 STR "HELP/SPELL.DESCR"
 BCCL :THERE18B
 MLI_CREATE :CRSPDESC
 JSR MLIERR
 NOTELOG $F;"Created 'SPELL.DESCR' file"
 JSR PRINT2
 LINE "'SPELL.DESCR' not found - file created"
 NULL
 CLC
 XCE
 REP #$30
 LDX #0
]LOOP STZ MISCBUFF,X
 INX
 INX
 CPX #SDRECLEN
 BNE ]LOOP
 SEC
 XCE
]LOOP JSR SAVESLICE
 STR "HELP/SPELL.DESCR"
 DA MISCBUFF
:SDREC DA 0
 DA SDRECLEN
 INC :SDREC
 LDA :SDREC
 CMP #32*3+1 ;32 spells per class, 3 classes (record 0 not used)
 BNE ]LOOP

:THERE18B JSR PRINT2
 LINE "Checking 'SIGN.x' files"
 NULL
 LDA SCENARIO
 PHA
 LDA #-1
 STA VTEMP

]LOOP INC VTEMP
 LDA VTEMP
 ORA #"0"
 STA :SG1+15
 STA :SG2+6
 STA :SG3+6
 STA :SG4+19
 STA :PATHSG+6
 JSR PRINT2
:SG1 LINE "Checking 'SIGN.0'"
 NULL
 JSR CHECKFILE
:SG2 STR "SIGN.0"
 BCCL :THERE19
 MLI_CREATE :CRSIGN
 JSR MLIERR
 JSR PRINT2
:SG3 LINE "'SIGN.0' not found - file created"
 NULL
:SG4 NOTELOG $F;"Created 'SIGN.0' file"
 LDA VTEMP
 STA SCENARIO
 STZ MISCBUFF
 STZ MISCBUFF+1
 LDX #0
 LDA #0
 JSR SAVESIGN

:THERE19 LDA VTEMP
 CMP #9
 BNEL ]LOOP
 PLA
 STA SCENARIO

 LDX #0
 LDA #0
 JSR SAVESCEN

 JSR PRINT2
 LINE "Checking 'INVENTORY.x' files"
 NULL

 LDA SCENARIO
 PHA
 STZ VTEMP

]LOOP INC VTEMP
 LDA VTEMP
 ORA #"0"
 STA :IN1+20
 STA :IN2+11
 STA :IN3+11
 STA :IN4+24
 STA :PATH17+11
 JSR PRINT2
:IN1 LINE "Checking 'INVENTORY.0'"
 NULL
 JSR CHECKFILE
:IN2 STR "INVENTORY.0"
 BCCL :THERE20
 MLI_CREATE :CRPARMS17
 JSR MLIERR
 JSR PRINT2
:IN3 LINE "'INVENTORY.0' not found - file created"
 NULL
:IN4 NOTELOG $F;"Created 'INVENTORY.0' file"
 LDA VTEMP
 STA SCENARIO
 LDX #0
 LDA #0
 JSR LOADITEM
 LDA ITEMBUFF
 STA MISCBUFF
 STZ MISCBUFF+1
 LDX #0
 LDA #0
 JSR SAVEINV
 LDX #0
]LOOP2 CPX ITEMBUFF
 BEQ :THERE20
 STZ INVFREE
 STZ INVSTOCK
 STZ INVMAX
 STZ INVORDER
 INX
 PHX
 LDA #0
 JSR SAVEINV
 PLX
 BRA ]LOOP2

:THERE20 LDA VTEMP
 CMP #9
 BNEL ]LOOP
 PLA
 STA SCENARIO

 JSR PRINT2
 LINE "Checking 'FILES/WALL.DATA.x' files"
 NULL

 LDA SCENARIO
 PHA
 STZ VTEMP

]LOOP INC VTEMP
 LDA VTEMP
 ORA #"0"
 STA :WD1+26
 STA :WD2+17
 STA :WD3+17
 STA :WD4+30
 STA :PATH18+17
 JSR PRINT2
:WD1 LINE "Checking 'FILES/WALL.DATA.0'"
 NULL
 JSR CHECKFILE
:WD2 STR "FILES/WALL.DATA.0"
 BCCL :THERE21
 MLI_CREATE :CRPARMS18
 JSR MLIERR
 JSR PRINT2
:WD3 LINE "'FILES/WALL.DATA.0' not found - file created"
 NULL
:WD4 NOTELOG $F;"Created 'FILES/WALL.DATA.0' file"
 LDA VTEMP
 STA SCENARIO
 MLI_OPEN :WOPARMS
 JSR MLIERR
 LDA :WOPARMS+5
 STA :WRWPARMS+1
 STA :WCPARMS+1
 MLI_WRITE :WRWPARMS
 JSR MLIERR
 MLI_CLOSE :WCPARMS
 JSR MLIERR

:THERE21 LDA VTEMP
 CMP #9
 BNEL ]LOOP
 PLA
 STA SCENARIO

 JSR PRINT2
 LINE "Checking 'FILES/WISH.LIST'"
 NULL
 JSR CHECKFILE
 STR "FILES/WISH.LIST"
 BCC :THERE22
 MLI_CREATE :CRPARMSWL
 JSR MLIERR
 NOTELOG $F;"Created 'FILES/WISH.LIST' file"
 STZ MISCBUFF
 STZ MISCBUFF+1
 JSR SAVESLICE
 STR "FILES/WISH.LIST"
 DA MISCBUFF
 DA 0
 DA WLRECLEN

:THERE22 JSR SETRANDSEED
 JSR PRINT2
 LINE "Random number seed generated"
 NULL

 STZ CALLSTS
 STZ CALLSTS+1
 STZ LOGONSTS
 STZ LOGONSTS+1

 JSR PRINT2
 LINE "Loading 'FONT' (character set)"
 NULL
 JSR LOADFILE
 STR "TC2.FONT"
 DA TEMPBUFF
 ADRL 0

 CLC ;Set up Font address in memory
 XCE
 REP #$30
 LDA #NUMFILES
 DEC
 ASL
 ASL
 TAX
 LDA HANDLES,X
 STA CADD
 LDA HANDLES+2,X
 STA CADD+2
 LDY #0
 LDA [CADD],Y
 STA FONTLOC
 INY
 INY
 LDA [CADD],Y
 STA FONTLOC+2

 PushLong :FONTPNTR
 PushLong FONTLOC
 PushLong #$1000
 Tool $2B02 ;BlockMove
 JSR ERROR
 SEC
 XCE

 JSR PRINT2
 LINE "Loading 'SHAPES'"
 NULL
 JSR LOADSLICE ;Load shapes into memory
 STR "SHAPES"
 DA TEMPBUFF
 DA 0
 DA $1000

 CLC
 XCE
 REP #$30
 LDX #0
]LOOP LDA TEMPBUFF,X
 STAL SHAPES,X
 INX
 INX
 CPX #$1000
 BNE ]LOOP
 SEC
 XCE

 JSR LOADSLICE ;Load shapes into memory
 STR "SHAPES"
 DA TEMPBUFF
 DA 1
 DA $1000

 CLC
 XCE
 REP #$30
 LDX #0
]LOOP LDA TEMPBUFF,X
 STAL SHAPES+$1000,X
 INX
 INX
 CPX #$1000
 BNE ]LOOP

 LDX #0
 LDA #0
]LOOP STAL SHAPEMAP,X
 INX
 INX
 CPX #80*25
 BNE ]LOOP

 SEC
 XCE

 JSR PRINT2
 LINE "Loading 'TEXT.SHAPES'"
 NULL
 JSR LOADFILE
 STR "TEXT.SHAPES"
 DA TEMPBUFF
 ADRL 0
 CLC
 XCE
 REP #$30
 LDX #0
]LOOP LDA TEMPBUFF,X
 STAL TEXTSHAPES,X
 INX
 INX
 CPX #$100*4
 BNE ]LOOP
 SEC
 XCE

 JSR PRINT2
 LINE "Saving 'VARIABLES'"
 NULL
 JSR SAVEVARS

 JSR PRINT2
 LINE "Session is now in progress.."
 PRPAUSE 1
 NULL
 NOTELOG $7;"*** Start of Session ***"
 JSR CLOSEALL

 LDA $3F2
 STA RVEC
 LDA $3F3
 STA RVEC+1

 JSR INITHOOK

 EXEC "GAME.INIT" ;Run Game.Init

:FONTPNTR ADRL TEMPBUFF

:CRPARMSWL DFB 7
 DA :PATHWL
 DFB %11000011 ;Access bits ($C3)
 DFB $F2 ;Filetype
 DA WLRECLEN ;Aux type
 DFB 1 ;Storage type
 DA 0 ;Creation date
 DA 0 ;     & time
:PATHWL STR "FILES/WISH.LIST"

:CRPARMS DFB 7
 DA :PATH
 DFB %11000011 ;Access bits ($C3)
 DFB $F2 ;Filetype
 DA LOGRECLEN ;Aux type
 DFB 1 ;Storage type
 DA 0 ;Creation date
 DA 0 ;     & time
:PATH STR "LOG"

:CRPARMS2 DFB 7
 DA :PATH2
 DFB %11000011 ;Access bits ($C3)
 DFB $F2 ;Filetype
 DA LOGRECLEN ;Aux type
 DFB 1 ;Storage type
 DA 0 ;Creation date
 DA 0 ;     & time
:PATH2 STR "LOGFILE.0"

:CRPARMS3 DFB 7
 DA :PATH3
 DFB %11000011 ;Access bits ($C3)
 DFB $F2 ;Filetype
 DA MONRECLEN ;Aux type
 DFB 1 ;Storage type
 DA 0 ;Creation date
 DA 0 ;     & time
:PATH3 STR "MONSTERS"

:CRPARMS4 DFB 7
 DA :PATH4
 DFB %11000011 ;Access bits ($C3)
 DFB $F2 ;Filetype
 DA MAPRECLEN ;Aux type
 DFB 1 ;Storage type
 DA 0 ;Creation date
 DA 0 ;     & time
:PATH4 STR "MAP.0"

:CRPARMS5 DFB 7
 DA :PATH5
 DFB %11000011 ;Access bits ($C3)
 DFB $F2 ;Filetype
 DA ITEMRECLEN ;Aux type
 DFB 1 ;Storage type
 DA 0 ;Creation date
 DA 0 ;     & time
:PATH5 STR "ITEMS"

:CRPARMS6 DFB 7
 DA :PATH6
 DFB %11000011 ;Access bits ($C3)
 DFB $F2 ;Filetype
 DA MAPRECLEN ;Aux type
 DFB 1 ;Storage type
 DA 0 ;Creation date
 DA 0 ;     & time
:PATH6 STR "MAP2.0"

:CRPARMS7 DFB 7
 DA :PATH7
 DFB %11000011 ;Access bits ($C3)
 DFB $F2 ;Filetype
 DA STRECLEN ;Aux type
 DFB 1 ;Storage type
 DA 0 ;Creation date
 DA 0 ;     & time
:PATH7 STR "STAIRS.TPORT.0"

:CRPARMS8 DFB 7
 DA :PATH8
 DFB %11000011 ;Access bits ($C3)
 DFB $F2 ;Filetype
 DA MON2RECLEN ;Aux type
 DFB 1 ;Storage type
 DA 0 ;Creation date
 DA 0 ;     & time
:PATH8 STR "MAZE.MONSTERS.0"

:CRPARMS9 DFB 7
 DA :PATH9
 DFB %11000011 ;Access bits ($C3)
 DFB $F2 ;Filetype
 DA SCRECLEN ;Aux type
 DFB 1 ;Storage type
 DA 0 ;Creation date
 DA 0 ;     & time
:PATH9 STR "SCENARIOS"

:CRPARMS10 DFB 7
 DA :PATH10
 DFB %11000011 ;Access bits ($C3)
 DFB $F2 ;Filetype
 DA PNRECLEN ;Aux type
 DFB 1 ;Storage type
 DA 0 ;Creation date
 DA 0 ;     & time
:PATH10 STR "PARTY.NAMES"

:CRPARMS11 DFB 7
 DA :PATH11
 DFB %11000011 ;Access bits ($C3)
 DFB $F2 ;Filetype
 DA ITEM2RECLEN ;Aux type
 DFB 1 ;Storage type
 DA 0 ;Creation date
 DA 0 ;     & time
:PATH11 STR "MAZE.ITEMS.0"

:CRPARMS12 DFB 7
 DA :PATH12
 DFB %11000011 ;Access bits ($C3)
 DFB $F2 ;Filetype
 DA HOFRECLEN ;Aux type
 DFB 1 ;Storage type
 DA 0 ;Creation date
 DA 0 ;     & time
:PATH12 STR "HALL.OF.FAME"

:CRPARMS13 DFB 7
 DA :PATH13
 DFB %11000011 ;Access bits ($C3)
 DFB $F2 ;Filetype
 DA MSGINDXRECLEN ;Aux type
 DFB 1 ;Storage type
 DA 0 ;Creation date
 DA 0 ;     & time
:PATH13 STR "MSG.INDEX"

:CRPARMS14 DFB 7
 DA :PATH14
 DFB %11000011 ;Access bits ($C3)
 DFB $F2 ;Filetype
 DA MSGRECLEN ;Aux type
 DFB 1 ;Storage type
 DA 0 ;Creation date
 DA 0 ;     & time
:PATH14 STR "MESSAGES"

:CRPARMS15 DFB 7
 DA :PATH15
 DFB %11000011 ;Access bits ($C3)
 DFB $F2 ;Filetype
 DA BITMAPRECLEN ;Aux type
 DFB 1 ;Storage type
 DA 0 ;Creation date
 DA 0 ;     & time
:PATH15 STR "MSG.BITMAP"

:CRPARMS16 DFB 7
 DA :PATH16
 DFB %11000011 ;Access bits ($C3)
 DFB $F2 ;Filetype
 DA LOGRECLEN ;Aux type
 DFB 1 ;Storage type
 DA 0 ;Creation date
 DA 0 ;     & time
:PATH16 STR "DATA/PARTYLOG.00"

:CRPARMS17 DFB 7
 DA :PATH17
 DFB %11000011 ;Access bits ($C3)
 DFB $F2 ;Filetype
 DA INVRECLEN ;Aux type
 DFB 1 ;Storage type
 DA 0 ;Creation date
 DA 0 ;     & time
:PATH17 STR "INVENTORY.0"

:CRPARMS18 DFB 7
 DA :PATH18
 DFB %11000011 ;Access bits ($C3)
 DFB $F2 ;Filetype
 DA 80*21+2 ;Aux type
 DFB 1 ;Storage type
 DA 0 ;Creation date
 DA 0 ;     & time
:PATH18 STR "FILES/WALL.DATA.0"

:CRCHAR DFB 7
 DA :PATHC
 DFB %11000011 ;Access bits ($C3)
 DFB $F2 ;Filetype
 DA PLRRECLEN ;Aux type
 DFB 1 ;Storage type
 DA 0 ;Creation date
 DA 0 ;     & time
:PATHC STR "PLAYERS"

:CRGLOSS DFB 7
 DA :PATHGL
 DFB %11000011 ;Access bits ($C3)
 DFB $F2 ;Filetype
 DA GLRECLEN ;Aux type
 DFB 1 ;Storage type
 DA 0 ;Creation date
 DA 0 ;     & time
:PATHGL STR "HELP/GLOSSARY"

:CRSPDESC DFB 7
 DA :PATHSD
 DFB %11000011 ;Access bits ($C3)
 DFB $F2 ;Filetype
 DA SDRECLEN ;Aux type
 DFB 1 ;Storage type
 DA 0 ;Creation date
 DA 0 ;     & time
:PATHSD STR "HELP/SPELL.DESCR"

:CRPAG DFB 7
 DA :PATHPAG
 DFB %11000011 ;Access bits ($C3)
 DFB $F3 ;Filetype
 DA 0 ;Aux type
 DFB 1 ;Storage type
 DA 0 ;Creation date
 DA 0 ;     & time
:PATHPAG STR "PAGEOUT.0"

:CRSIGN DFB 7
 DA :PATHSG
 DFB %11000011 ;Access bits ($C3)
 DFB $F2 ;Filetype
 DA SIGNRECLEN ;Aux type
 DFB 1 ;Storage type
 DA 0 ;Creation date
 DA 0 ;     & time
:PATHSG STR "SIGN.0"

:PFXPARMS DFB 1
 DA :PREFIX

:PREFIX DS 1+63

:GETPARMS DFB $A
 DA :PREFIX
 DS 15
:BLOCKS DS 4
:FREBLOCKS DS 4

:GPARMS DFB $A
 DA :LIBPATH
 DS 15
:LIBPATH STR "LIBRARY"
:LIBSIZE DS 4

:WOPARMS DFB 3
 DA :PATH18
 DA IOBUFFER
 DS 1

:WRWPARMS DFB 4
 DS 1
 DA :BUFFER
 DA 80*21+2
 DS 2

:WCPARMS DFB 1
 DS 1

:BUFFER DS 80*21,$8D
 DFB 0,1

PFXPARMS DFB 1
 DA PREFIX
PREFIX DS 1+63

TOTAL DS 4

PRINT2 LDA #%0000_1111
 TRB $C034
 BIT $C061
 BMI :TEXT
 LDA STARTUPPATH
 BNE :TEXT
:SHR LDA #%1000_0000
 TSB $C029
 JMP PRINT
:TEXT LDA #%1000_0000
 TRB $C029
 JMP PRINT

TEMPBUFF DS $1000 ;No buffer big enuff (temporary anyway)

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/GAME.START
 fin

 END
