*-------------------------------
* GAME.UPDATE
*-------------------------------
 DAT
 LST OFF

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE VARS
 USE LIB.JMP
 USE PLR.DSECT
 USE PN.DSECT
 USE MSG.DSECT

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/GAME.UPDATE
 fin

 MODID "GAME.UPDATE"

START LDA VTEMP ;00=no map reclaim, 80=one map, C0=everything
 STA WHAT

 JSR PRINT
 HOME
 COLOR WHITE
 LINE "Updating.."
 CR
 CURSOROFF
 NULL

 LDX #0
 LDA #0
 JSR LOADSCEN
 LDA SCENBUFF
 STA TOTSCEN

 JSR CHKMAP ;Fix physical map from INSPECT, SPELL
 BIT WHAT
 BPL :SKIP
 BIT $C061 ;OA?
 BMI :SKIP
 JSR DORECLAIM ;Fix any map errors
:SKIP JSR DOPLRS ;Count active players
 JSR DOPARTIES ;Count active parties
 JSR MSG2GM ;Count GM messages not read
 JSR PRINT
 CR
 LINE "Finished."
 NULL
 LDA TOTSCEN
 STA SCENARIO
 RETURN

DORECLAIM JSR PRINT
 ASC "Reclaiming.."
 NULL
 LDA SCENARIO
 PHA
 BIT WHAT
 BVS :ALL
 LDA PNSCENARIO
 JSR :DO1
 BRA :DONE
:ALL LDA TOTSCEN
 STA :SCEN
]LOOP LDA :SCEN
 BEQ :DONE
 JSR :DO1
 DEC :SCEN
 BRA ]LOOP
:DONE PLA
 STA SCENARIO
 RTS

:DO1 STA SCENARIO
 JSR PRINT
 CR
 CR
 COLOR AQUAMARINE
 ASC "Scenario #"
 COLOR YELLOW
 DEC8 SCENARIO
 COLOR WHITE
 NULL
 JMP RECLAIM
:SCEN DS 1

DOPLRS JSR PRINT
 CR
 CR
 LINE "Counting active players.."
 NULL
 LDX #9*2
]LOOP STZ PLAYERS-1,X
 DEX
 BNE ]LOOP
 STZ :REC
 STZ :REC+1
 LDX #0
 LDA #0
 JSR LOADPLR
 LDA PLRBUFF
 STA :PLRS
 LDA PLRBUFF+1
 STA :PLRS+1
]LOOP LDA :REC+1
 CMP :PLRS+1
 BNE :LOAD
 LDA :REC
 CMP :PLRS
 BEQ :DONE
:LOAD INCR :REC
 LDX :REC
 LDA :REC+1
 JSR LOADPLR
 LDA PLRFREE
 BMI :NEXT
 LDA PLRSCENARIO
 DEC
 ASL
 TAX
 INCR PLAYERS,X
:NEXT JMP ]LOOP
:DONE RTS
:REC DS 2
:PLRS DS 2

DOPARTIES JSR PRINT
 CR
 LINE "Counting active parties.."
 NULL
 STZ VTEMP
 STZ VTEMP+1
 CALL "GAME.CHKEXP"
 RTS

MSG2GM JSR PRINT
 CR
 LINE "Checking GM's mailbox.."
 NULL
 LDX #0
 LDA #0
 JSR LOADMSGINDX
 LDA MSGINDXBUFF
 STA :INDX
 LDA MSGINDXBUFF+1
 STA :INDX+1
 ORA :INDX
 BEQ :DONE
]LOOP LDX :INDX
 LDA :INDX+1
 JSR LOADMSGINDX
 BIT MSGINDXBUFF
 BMI :NEXTI
 LDA MSGFROM ;Msg to GM if MSGFROM = MSGTO
 CMP MSGTO
 BNE :NEXTI
 LDA MSGFROM+1
 CMP MSGTO+1
 BNE :NEXTI
 BIT MSGSYSOP ;Msg to the GM?
 BMI :NEXTI
 INC :GMTOTAL
 BIT MSGREAD+1 ;Msg been read by receiver (ie; GM)?
 BMI :NEXTI
 INC :GMNOTREAD
:NEXTI DECR :INDX
 LDA :INDX+1
 BNE ]LOOP
 LDA :INDX
 BNE ]LOOP
:DONE LDA :GMNOTREAD
 STA VTEMP
 LDA :GMTOTAL
 STA VTEMP+1
 RTS
:INDX DS 2
:CNTR DS 2
:GMNOTREAD DS 1
:GMTOTAL DS 1

*
* Change all SHPSWALL2's    back to SHPWALL's (from GAME.INSPECT)
* Change all SHPHFF2's      back to SHPHFF's  (from GAME.SPELL2)
* Change all SHPVFF2's      back to SHPVFF's  (from GAME.SPELL2)
*
CHKMAP JSR PRINT
 LINE "Checking/restoring map.."
 NULL
 LDA SCENARIO
 PHA
 LDA TOTSCEN
 STA :SCEN
]TOPLOOP LDA :SCEN
 BEQL :FIN
 STA SCENARIO
 LDX #0
 LDA #0
 JSR LOADMAP
 LDA MAP
 STA VTEMP
]LOOP LDA VTEMP
 BEQ :DONE
 LDX VTEMP
 LDA #0
 JSR LOADMAP
 STZ :FLAG

 LDX #0
 LDY #0
]LOOP2 PHX
 PHY
 JSR GETMAP
 CMP #SHPWALL ;Any secret passages?
 BNE :NO1
 CPX #WALLSECRETVIS
 BNE :NO1
 LDSHP #SHPWALL;#WALLSECRET
 BRA :DOIT
:NO1 CMP #SHPFF
 BNE :NO2
 CPX #FFDIMHORIZ
 BNE :NODIM
 LDSHP #SHPFF;#FFHORIZ
 BRA :DOIT
:NODIM CPX #FFDIMVERT
 BNE :NO2
 LDSHP #SHPFF;#FFVERT
:DOIT TAY
 LDA $1,S
 ASL
 ASL
 ASL
 ASL
 ORA $2,S
 TAX
 TYA
 STA MAP,X
 LDA #$FF
 STA :FLAG
:NO2 PLY
 PLX
 INX
 CPX #$10
 BNE ]LOOP2
 LDX #$00
 INY
 CPY #$10
 BNE ]LOOP2

 BIT :FLAG
 BPL :NOPE
 LDX VTEMP
 LDA #0
 JSR SAVEMAP
:NOPE DEC VTEMP
 BRA ]LOOP
:DONE DEC :SCEN
 JMP ]TOPLOOP
:FIN PLA
 STA SCENARIO
 RTS

:FLAG DS 1
:SCEN DS 1

TOTSCEN DS 1

WHAT DS 1

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/GAME.UPDATE
 fin

 END
