*-------------------------------
* GAME.USE
*-------------------------------
 DAT
 LST OFF

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE VARS
 USE LIB.JMP
 USE PLR.DSECT
 USE ITEM.DSECT
 USE PN.DSECT
 USE SCEN.DSECT

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/GAME.USE
 fin

 MODID "GAME.USE"

START JSR PRINT
 GOTOXY 0;14
 CURSOROFF
 INVERSE
 COLOR YELLOW
 ZAPLINE
 NORMAL
 VTAB 14
 COLOR ORANGE
 CENTER " Use "
 COLOR YELLOW
 CR
 COLOR WHITE
 CURSORON
 NULL

START2 JSR CLRBOT
 JSR PRINT
 GOTOXY 0;15
 CURSORON
 NULL
 LDX NUMPARTY
]LOOP LDA CURPARTY2-1,X
 BNE :OK
 LDA CURPARTY-1,X
 BNE :OK
 DEX
 BNE ]LOOP
 DEATH ;Should be at least one person in the party
:OK STX PLRS
 JSR PRINT
 ASC "Who will use (1-"
 DEC8 PLRS
 ASC ")? : "
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 CMP #$9B
 BEQL EXIT
 SEC
 SBC #"1"
 CMP PLRS
 BCS ]LOOP
 TAX
 CLC
 ADC #"1"
 JSR COUT
 LDA CURPARTY,X
 STA PREC
 LDA CURPARTY2,X
 STA PREC+1
 JSR LOADMAST
 LDA PLRCOND
 AND #%1100_1001 ;Can you physically move?
 BEQ :PLROK
 JSR PRINT
 CR
 COLOR PINK
 PRSTRING PLRNAME
 ASC " is out of action. "
 SOUND $13;1;$40
 COLOR WHITE
 NULL
 GETRETURN
 JMP START2

:PLROK LDA PLRZPOS
 STA MSTRZ
 LDA PLRXPOS
 STA MSTRX
 LDA PLRYPOS
 STA MSTRY

 LDA PREC
 STA MPLR
 LDA PREC+1
 STA MPLR+1

 LDA PLRZPOS
 CMP LEVEL
 BEQ :LVLOK
 LDX PLRZPOS
 LDA #0
 JSR LOADMAP
 LDX PLRZPOS
 LDA #0
 JSR LOADMAP2
 LDA PLRZPOS
 STA LEVEL
:LVLOK LDX PLRXPOS
 LDY PLRYPOS
 LDA PLRZPOS
 JSR SHOWMAP
 JSR LOADMAST

 JSR ONSQUARE ;See how many people are on this square

 JSR LOADMAST

SHOWEM JSR CLRBOT
 LDA #<PLRITEM
 STA :I+2
 LDA #15
 STA :V+3
 LDX #1
]LOOP STX TEMPX
 LDA PLRITEM-1,X
 BEQ :NEXT
 LDA PLRITEMX-1,X
 AND #%11
 TAX
 LDA :ICOLORS,X
 STA :IC+2
 JSR PRINT
:V GOTOXY 56;15
 DEC8 TEMPX
 ASC ")"
:IC COLOR WHITE
:I PRITEM PLRITEM
 COLOR WHITE
 NULL
:NEXT INC :V+3
 INC :I+2
 INC TEMPX
 LDX TEMPX
 CPX #9
 BNE ]LOOP

 JSR PRINT
 GOTOXY 0;15
 CURSORON
 PRSTRING PLRNAME
 NULL
 LDA PLRITEM
 BNE :ITEMOK
 JSR PRINT
 ASC " has no items to use. "
 SOUND $13;1;$40
 NULL
 GETRETURN
 JMP START2
:ITEMOK JSR PRINT
 ASC ", use item #"
 NULL

]LOOP JSR KEYIN
 CMP #$9B
 BEQL START2
 SEC
 SBC #"1"
 CMP #8
 BCS ]LOOP
 STA TEMPX
 STA ITEMPLR
 LDX #56
 LDY #57
 LDA TEMPX
 CLC
 ADC #15
 JSR PICKLINE
 LDA $200
 CMP #" "
 BEQ ]LOOP

 LDA TEMPX
 CLC
 ADC #"1"
 JSR COUT

 LDX TEMPX
 LDA PLRITEM,X
 TAX
 LDA #0
 JSR LOADITEM
 BIT PLRARRESTFLAG
 BMI :CANTUSE
 LDA ITYPE
 CMP #6 ;Misc item?
 BNE NOTHING

 LDA IDAT1 ;Misc item number
 CMP #TBLEN+1
 BCS :ERR
 DEC
 ASL
 TAX
 JMP (ITABLE,X)

:ERRITEM DS 4
:ICOLORS DFB $F,$E,$D,$D

:ERR STA :ERRITEM
 NOTELOGNUM $1;"Error: [USE] Misc.Item #";:ERRITEM
 NOTELOGSTR $1;"Item = ";INAME
 BRA NOTHING

:CANTUSE JSR PRINT
 GOTOXY 0;17
 COLOR PINK
 LINE "The guard stops you.."
 COLOR WHITE
 NULL
 GETRETURN
 JMP SHOWEM

ITABLE DA USE1 ;GOOD Card
 DA USE2 ;IT's brain
 DA USE3 ;The Holy Grail
 DA USE4 ;Key
 DA USE5 ;Freddy's gauntlet
 DA USE6 ;Teddy
 DA USE7 ;Key (Guardian's)
TBLEN = *-ITABLE/2

NOTHING JSR PRINT
 GOTOXY 0;17
 COLOR PINK
 LINE "Nothing happens"
 COLOR WHITE
 NULL
 GETRETURN
 JMP SHOWEM

*
* Make sure this section is updated according to the ITEMS file.
* A Misc.Item number must correspond to the ITABLE above. This is
* because the U)se of Misc.Items must be programmed in, otherwise
* a huge table will have to be used and a 'global' routine written
* to cater for it (next to impossible?).
*
*-------------------------------------------------
USE1 JSR CLRBOT
 LDA PLRCURRPNTS
 DEC
 BRA :PNTSOK
 JSR PRINT
 GOTOXY 0;15
 COLOR PINK
 ASC "Not enough points left. "
 SOUND $25;1;$40
 COLOR WHITE
 NULL
 GETRETURN
 JMP SHOWEM
:PNTSOK JSR PRINT
 GOTOXY 0;15
 ASC "You hold the card in the air. Within seconds "
 ASC "a taxi pulls up next to you."
 SOUND $15;1;LOUD
 ASC " A sign on the door reads : "
 QUOTE
 COLOR YELLOW
 ASC "111 Taxi - 1 person, 1 trip, 1 way"
 COLOR WHITE
 QUOTE
 ASC "."
 CR
 CR
 ASC "The driver leans out the window"
 NULL
 LDX SCENARIO
 LDA #0
 JSR LOADSCEN
 LDX #7
]LOOP LDA PLRITEM,X
 CMP SCITEM
 BEQ :HOT
 DEX
 BPL ]LOOP
 JMP :PUNCH
:HOT JSR PRINT
 ASC ", takes one look at you and says :"
 CR
 QUOTE
 ASC "That's hot merchandise you've got there, pal! I'm not "
 ASC "authorized for this sort of thing..."
 QUOTE
 CR
 CR
 NULL
 GETRETURN
 JSR CLRBOT
 JMP :NNO
:PUNCH JSR PRINT
 ASC " and punches a few buttons on his calculator. "
 SOUND $25;1;$80
 NULL
 JSR LOADMAST
 LDA PREC
 STA :USER
 LDA PREC+1
 STA :USER+1
 LDA PLRZPOS
 STA :COST
 CLC
 XCE
 REP #$30
 STZ :AMT
 STZ :AMT+2
 LDX :COST
]LOOP LDA :AMT
 CLC
 ADC #100
 STA :AMT
 LDA :AMT+2
 ADC #0
 STA :AMT+2
 DEX
 BNE ]LOOP
 SEC
 XCE
 JSR PRINT
 QUOTE
 ASC "That'll be "
 COLOR YELLOW
 DEC32 :AMT
 COLOR WHITE
 ASC " GP."
 QUOTE
 CR
 CR
 ASC "Pay the taxi driver (y/n)? : "
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 CMP #"Y"
 BEQ :YES
 CMP #"N"
 BNE ]LOOP
 JSR PRINT
 ASC "No"
 NULL
 JSR CLRBOT
 JMP :NNO

:YES JSR PRINT
 ASC "Yes"
 NULL
 LDX #3
]LOOP LDA PLRGOLD,X
 CMP :AMT,X
 BEQ :NXT
 BCS :CANPAY
 BCCL :CANT
:NXT DEX
 BPL ]LOOP
:CANPAY JSR CLRBOT
:TAKEWHO JSR ONSQUARE
 LDA NUMTBL
 CMP #1 ;Just one player here?
 BEQL :JUST1

 LDA #15
 STA :V+3
 STZ VTEMP
 LDX #0
]LOOP PHX
 LDA CHTBL,X
 TAY
 LDA CHTBL2,X
 TYX
 JSR LOADPLR
 INC VTEMP
 JSR PRINT
:V GOTOXY 40;15
 DEC8 VTEMP
 ASC ") "
 PRSTRING PLRNAME
 NULL
 INC :V+3
 PLX
 INX
 CPX NUMTBL
 BNE ]LOOP

 JSR PRINT
 GOTOXY 0;15
 QUOTE
 ASC "Who's going.."
 QUOTE
 ASC " (1-"
 DEC8 NUMTBL
 ASC ")? : "
 NULL

]LOOP JSR KEYIN
 CMP #$9B
 BEQL :MNO2
 SEC
 SBC #"1"
 CMP NUMTBL
 BCS ]LOOP
 TAX
 LDA CHTBL,X ;Load in player going for 'trip' to Castle
 STA PREC
 LDA CHTBL2,X
 STA PREC+1
 JSR LOADMAST
 JSR CLRBOT
 LDA PREC
 CMP :USER
 BNE :DIFF1
 LDA PREC+1
 CMP :USER+1
 BNE :DIFF1
 JMP :JUST1
:DIFF1 LDA PLRPARTY
 CMP PARTYNUM
 BEQ :SAMEP
 LDA PLRPASSAULTS
 ORA PLRPASSAULTS+1
 ORA PLRPKILLS
 ORA PLRPKILLS+1
 BNE :SAMEP
 LDA PLRCOND
 AND #%1100_1000 ;Can you physically move?
 BNE :SAMEP
 JSR PRINT
 GOTOXY 0;15
 COLOR PINK
 ASC "Sorry, I'm not allowed to take "
 COLOR AQUAMARINE
 PRSTRING PLRNAME
 COLOR PINK
 ASC ". "
 COLOR WHITE
 SOUND $25;1;LOUD
 NULL
 GETRETURN
 JSR CLRBOT
 JMP :TAKEWHO
:SAMEP JSR PRINT
 GOTOXY 0;15
 ASC "Send "
 PRSTRING PLRNAME
 ASC " (y/N)? : "
 NULL
 JSR KEYIN
 JSR UPPER
 CMP #"Y"
 BNEL :CANPAY
 JSR COUT
 JSR PRINT
 HTAB 0
 ZAPLINE
 NULL
 JSR :PAYUP
 JSR LOADMAST
 JSR PRINT
 GOTOXY 0;15
 ASC "The taxi speeds off with "
 COLOR AQUAMARINE
 PRSTRING PLRNAME
 COLOR WHITE
 ASC ".. "
 SOUND $09;1;LOUD
 NULL
 LDX PLRXPOS
 LDY PLRYPOS
 LDA #-1
 JSR PUTMAP2
 LDX PLRZPOS
 LDA #0
 JSR SAVEMAP2
 JSR PLOGTAXI ;Log other party "xxx sent to Castle"
 STZ PLRXPOS ;Update player
 STZ PLRYPOS
 STZ PLRZPOS
 JSR SAVEMAST
 GETRETURN
 LDA PLRPARTY
 CMP PARTYNUM
 BEQ :SAMEP2
 LDA #$FF ;Reward 'driven back by taxi'
 STA VTEMP
 CALL "GAME.REWARD"
 LDX :USER
 LDA :USER+1
 JSR LOADPLR
 CLC
 XCE
 REP #$30
 LDA PLRGOLD
 CLC
 ADC $200
 STA PLRGOLD
 LDA PLRGOLD+2
 ADC #0
 STA PLRGOLD+2
 SEC
 XCE
 LDX :USER
 LDA :USER+1
 JSR SAVEPLR
:SAMEP2 JSR LOADMAST
 LDA #$FF
 STA VTEMP
 CALL "GAME.PRECSTLE"
 JSR SAVEMAST
 LDY #0 ;Crunch party members
]LOOP LDA CURPARTY,Y
 CMP PREC
 BNE :NXTG
 LDA CURPARTY2,Y
 CMP PREC+1
 BEQ :GOTITG
:NXTG INY
 CPY NUMPARTY
 BNE ]LOOP
 JMP :ZZFIN
:GOTITG INY
 LDA CURPARTY,Y
 STA CURPARTY-1,Y
 LDA CURPARTY2,Y
 STA CURPARTY2-1,Y
 CPY NUMPARTY
 BNE :GOTITG
 LDA #0
 STA CURPARTY,Y
 STA CURPARTY2,Y
 LDA #$FF ;Draw player stats only
 STA VTEMP
 CALL "DRAW.SCREEN"
:ZZFIN LDA :USER
 STA PREC
 LDA :USER+1
 STA PREC+1
 JSR LOADMAST
 JMP SHOWEM

:JUST1 JSR :PAYUP
 JSR PRINT
 GOTOXY 0;15
 QUOTE
 ASC "Hold on.."
 QUOTE
 CR
 CR
 ASC "You fasten your seat-belt as the taxi takes off.."
 PRPAUSE 2
 CR
 CR
 ASC "You pass out as the taxi reaches Mach 3.."
 SOUND RESET
 SOUND $0A;1;LOUD
 PRPAUSE 4
 CURSOROFF
 VTAB 23
 COLOR PINK
 CENTER " [Press any key] "
 COLOR WHITE
 NULL
 JSR KEYIN
 JSR PRINT
 INVERSE
 COLOR PINK
 HOME
 SOUND $09;1;LOUD
 PRPAUSE 1
 COLOR WHITE
 NORMAL
 HOME
 CURSORON
 PRPAUSE 2
 NULL
 JSR LOADMAST
 LDX PLRXPOS
 LDY PLRYPOS
 LDA #-1
 JSR PUTMAP2
 LDX PLRZPOS
 LDA #0
 JSR SAVEMAP2
 STZ PLRXPOS ;Update player
 STZ PLRYPOS
 STZ PLRZPOS
 JSR SAVEMAST
 PNOTELOGSTR $B;"111 Taxi taken to Castle by ";PLRNAME
 STZ VTEMP
 CALL "GAME.PRECSTLE" ;Update conds, points, HP, etc
 JSR POPMOD
 EXEC "GAME.CASTLE"

:CANT JSR CLRBOT
 JSR PRINT
 QUOTE
 ASC "Hey, you 'aint got enough for the ride! Call me when you've "
 ASC "got more cash, 'moneybags'.."
 QUOTE
 PRPAUSE 2
 CR
 CR
 NULL
:NNO JSR PRINT
 ASC "The taxi speeds off.."
 SOUND $0A;1;LOUD
 PRPAUSE 4
 CR
 CR
 NULL
 GETRETURN
 JMP SHOWEM
:MNO2 JSR CLRBOT
 LDA :USER
 STA PREC
 LDA :USER+1
 STA PREC+1
 JSR LOADMAST
 BRA :NNO

:PAYUP LDA PREC
 PHA
 LDA PREC+1
 PHA
 LDA :USER
 STA PREC
 LDA :USER+1
 STA PREC+1
 JSR LOADMAST
 CLC ;Subtract amount from player paying
 XCE
 REP #$30
 LDA PLRGOLD
 SEC
 SBC :AMT
 STA PLRGOLD
 LDA PLRGOLD+2
 SBC :AMT+2
 STA PLRGOLD+2
 SEC
 XCE
 LDX ITEMPLR ;Remove GOOD card
]LOOP LDA PLRITEM+1,X
 STA PLRITEM,X
 LDA PLRITEMX+1,X
 STA PLRITEMX,X
 INX
 CPX #8
 BCC ]LOOP
 STZ PLRITEM+7
 STZ PLRITEMX+7
 JSR SAVEMAST
 PLA
 STA PREC+1
 PLA
 STA PREC
 RTS
:COST DS 2
:AMT DS 4

:USER DS 2
*-------------------------------------------------
USE2 JSR CLRBOT ;IT's brain
 JSR LOADMAST
 LDA PLRHP
 CMP PLRHP+1
 BNE :BETTER
 JMP NOTHING
:BETTER JSR PRINT
 GOTOXY 0;15
 COLOR AUQAMARINE
 PRSTRING PLRNAME
 COLOR PINK
 ASC " feels better.."
 COLOR WHITE
 NULL
 LDA PLRHP+1
 STA PLRHP
 JSR SAVEMAST
 LDA #$FF ;Draw player stats only
 STA VTEMP
 CALL "DRAW.SCREEN"
 JSR LOADMAST
 LDX PLRXPOS
 LDY PLRYPOS
 LDA PLRZPOS
 JSR SHOWMAP
 JSR PRINT
 GOTOXY 0;16
 CURSORON
 NULL
 GETRETURN
 JMP START2
*-------------------------------------------------
USE3 JSR CLRBOT ;Amulet
 JSR PRINT
 GOTOXY 0;15
 COLOR AQUAMARINE
 ASC "Everyone in the party feels strange.. "
 COLOR WHITE
 NULL
 LDX NUMPARTY ;Restore HP and some conditions upon entry
]LOOP PHX ; to the Castle
 LDA CURPARTY-1,X
 STA :REC
 LDA CURPARTY2-1,X
 STA :REC+1
 BNE :OK
 LDA :REC
 BEQ :NXTC
:OK LDX :REC
 LDA :REC+1
 JSR LOADPLR
 LDA PLRHP+1 ;Fix HP to full
 STA PLRHP
 LDA PLRCOND ;Reset everything (except invisibility & levitation)
 AND #%0001_0100
 STA PLRCOND
 LDX #0
]LOOP2 STZ PLRCONDX,X
 INX
 CPX #7
 BNE ]LOOP2
 LDX :REC
 LDA :REC+1
 JSR SAVEPLR
:NXTC PLX
 DEX
 BNE ]LOOP
 LDA #$FF ;Draw player stats only
 STA VTEMP
 CALL "DRAW.SCREEN"
 JSR LOADMAST
 LDX PLRXPOS
 LDY PLRYPOS
 LDA PLRZPOS
 JSR SHOWMAP
 JSR PRINT
 GOTOXY 0;16
 CURSORON
 NULL
 GETRETURN
 JMP START2
:REC DS 2
*-------------------------------------------------
USE4 JSR CLRBOT ;Key
 LDA PLRCURRPNTS
 DEC
 BRA :PNTSOK
 JSR PRINT
 GOTOXY 0;15
 COLOR PINK
 ASC "Not enough points left. "
 SOUND $25;1;$40
 COLOR WHITE
 NULL
 GETRETURN
 JMP SHOWEM
:PNTSOK JSR PRINT
 GOTOXY 0;15
 COLOR AQUAMARINE
 LINE " 7 8 9"
 LINE "  \|/"
 LINE " 4-x-6"
 LINE "  /|\"
 LINE " 1 2 3"
 COLOR WHITE
 CR
 ASC "Use in which direction? : "
 NULL
 JSR LOADMAST
]LOOP JSR KEYIN
 JSR UPPER
 LDX :KEYS
]LOOP2 CMP :KEYS,X
 BEQ :GOTONE
 DEX
 BNE ]LOOP2
 BRA ]LOOP
:GOTONE DEX
 TXA
 ASL
 TAX
 JMP (:TABLE,X)

:KEYS DFB :ENDKEYS-*-1
 DFB "1"
 DFB "2"
 DFB "3"
 DFB "4"
 DFB "5"
 DFB "6"
 DFB "7"
 DFB "8"
 DFB "9"
 DFB "H"-$40
 DFB "U"-$40
 DFB "J"-$40
 DFB "K"-$40
 DFB $9B
:ENDKEYS

:TABLE DA :GO1
 DA :GO2
 DA :GO3
 DA :GO4
 DA :GO5
 DA :GO6
 DA :GO7
 DA :GO8
 DA :GO9
 DA :GO4
 DA :GO6
 DA :GO2
 DA :GO8
 DA :ESC

:ESC JSR CLRBOT
 JMP SHOWEM

:GO1 LDX #-1
 LDY #1
 LDA #1
 JMP :GOGO

:GO2 LDX #0
 LDY #1
 LDA #2
 JMP :GOGO

:GO3 LDX #1
 LDY #1
 LDA #3
 JMP :GOGO

:GO4 LDX #-1
 LDY #0
 LDA #4
 JMP :GOGO

:GO5 LDX #0
 LDY #0
 LDA #5
 JMP :GOGO

:GO6 LDX #1
 LDY #0
 LDA #6
 JMP :GOGO

:GO7 LDX #-1
 LDY #-1
 LDA #7
 JMP :GOGO

:GO8 LDX #0
 LDY #-1
 LDA #8
 JMP :GOGO

:GO9 LDX #1
 LDY #-1
 LDA #9
 JMP :GOGO

:GOGO STX :GOTOX ;X and Y come as offsets
 STY :GOTOY
 STA :PDIR
 LDA PLRXPOS ;Re-calculate position
 CLC
 ADC :GOTOX
 STA :GOTOX
 LDA PLRYPOS
 CLC
 ADC :GOTOY
 STA :GOTOY

 LDX :GOTOX
 LDY :GOTOY
 JSR CHECKPOS ;Place to move to on the map (within 16 x 16)?
 BCS :NOTOK
 LDX :GOTOX
 LDY :GOTOY
 JSR GETMAP
 CMP #SHPGATE
 BNE :NOTOK
 CPX #GATECLOSED
 BEQ :OPENIT
 CPX #GATEOPEN
 BEQ :CLOSEIT
:NOTOK JSR CLRBOT
 JMP NOTHING ;Nothing happens

:OPENIT LDX :GOTOX
 LDY :GOTOY
 LDA #GATEOPEN
 XBA
 LDA #SHPGATE
 JSR PUTMAP
 LDX PLRZPOS ;Save map 'coz other modules (GAME.MOVE) will load
 LDA #0 ; maps in and overwrite the change in memory.
 JSR SAVEMAP
 LDX PLRXPOS
 LDY PLRYPOS
 LDA PLRZPOS
 JSR SHOWMAP
 JSR CLRBOT
 JSR PRINT
 CURSORON
 COLOR AQUAMARINE
 ASC "The gate opens! "
 COLOR WHITE
 SOUND $15;1;LOUD
 NULL
 GETRETURN
 JMP SHOWEM

:CLOSEIT LDX :GOTOX
 LDY :GOTOY
 LDA #GATECLOSED
 XBA
 LDA #SHPGATE
 JSR PUTMAP
 LDX PLRZPOS ;Save map 'coz other modules (GAME.MOVE) will load
 LDA #0 ; maps in and overwrite the change in memory.
 JSR SAVEMAP
 LDX PLRXPOS
 LDY PLRYPOS
 LDA PLRZPOS
 JSR SHOWMAP
 JSR LOADMAST
 JSR CLRBOT
 JSR PRINT
 CURSORON
 COLOR AQUAMARINE
 ASC "The gate is now closed. "
 COLOR WHITE
 NULL
 GETRETURN
 JMP :ESC
:GOTOX DS 1
:GOTOY DS 1
:PDIR DS 1
*-------------------------------------------------
USE6
USE7
USE5 JSR CLRBOT
 JMP NOTHING
*-------------------------------------------------

CHECKPOS CPX #$10
 BCS :RTS
 CPY #$10
:RTS RTS

CLRBOT JSR PRINT
 GOTOXY 0;22
 LUP 7
 ZAPLINE
 CURSORUP
 --^
 ZAPLINE
 NULL
 RTS

LOADMAST LDX PREC
 LDA PREC+1
 JMP LOADPLR

SAVEMAST LDX PREC
 LDA PREC+1
 JMP SAVEPLR

EXIT JSR PRINT
 ZAPLINE
 NULL
 RETURN

LEVEL DS 1

MSTRX DS 1
MSTRY DS 1
MSTRZ DS 1
PREC DS 2
TEMPX DS 1
PLRS DS 1
NUMTBL DS 1
CHTBL DS $100
CHTBL2 DS $100
ITEMPLR DS 1 ;Item used (1-8) that player is holding

ONSQUARE LDX #0
 LDA #0
 JSR LOADPLR
 LDA PLRBUFF
 STA :CHAR
 LDA PLRBUFF+1
 STA :CHAR+1
 LDY #0
]LOOP PHY
 LDX :CHAR
 LDA :CHAR+1
 JSR LOADPLR
 BIT PLRFREE
 BMI :NXTP
 LDA PLRZPOS
 CMP MSTRZ
 BNE :NXTP
 LDA PLRXPOS
 CMP MSTRX
 BNE :NXTP
 LDA PLRYPOS
 CMP MSTRY
 BNE :NXTP
 LDA PLRARRESTFLAG
 BMI :NXTP
 PLY
 LDA :CHAR
 STA CHTBL,Y
 LDA :CHAR+1
 STA CHTBL2,Y
 INY
 PHY
:NXTP PLY
 DECR :CHAR
 LDA :CHAR
 ORA :CHAR+1
 BNE ]LOOP
 STY NUMTBL
 RTS
:CHAR DS 2

PLOGTAXI LDA PARTYNUM
 PHA
 LDA PLRPARTY
 STA PARTYNUM
 JSR LOADMAST
 LDY #0
]LOOP LDA PLRNAME+1,Y
 STA MISCBUFF+1,Y
 INY
 CPY PLRNAME
 BNE ]LOOP
 INY
 LDX #0
]LOOP LDA :STR1+1,X
 STA MISCBUFF,Y
 INY
 INX
 CPX :STR1
 BNE ]LOOP
 LDA PLRXPOS
 JSR CONVERT
 STA MISCBUFF,Y
 INY
 TXA
 STA MISCBUFF,Y
 INY
 LDA #","
 STA MISCBUFF,Y
 INY
 LDA PLRYPOS
 JSR CONVERT
 STA MISCBUFF,Y
 INY
 TXA
 STA MISCBUFF,Y
 INY
 LDX #0
]LOOP LDA :STR2+1,X
 STA MISCBUFF,Y
 INY
 INX
 CPX :STR2
 BNE ]LOOP
 LDA PLRZPOS
 JSR CONVERT
 STA MISCBUFF,Y
 INY
 TXA
 STA MISCBUFF,Y
 INY
 LDX #0
]LOOP LDA :STR3+1,X
 STA MISCBUFF,Y
 INY
 INX
 CPX :STR3
 BNE ]LOOP
 PLX
 PHX
 PHY
 LDA #0
 JSR LOADPN
 PLY
 LDX #0
]LOOP LDA PNNAME+1,X
 STA MISCBUFF,Y
 INY
 INX
 CPX PNNAME
 BNE ]LOOP
 LDX #0
]LOOP LDA :STR4+1,X
 STA MISCBUFF,Y
 INY
 INX
 CPX :STR4
 BNE ]LOOP
 DEY
 STY MISCBUFF
 PNOTELOGBUFF $1;MISCBUFF
 PLA
 STA PARTYNUM
 RTS
:STR1 STR " at "
:STR2 STR " lvl "
:STR3 STR " sent by Taxi to the Castle by Party '"
:STR4 STR "'"

CONVERT STZ :CHAR+1
 CMP #10
 BCC :LESS
 INC :CHAR+1
 SEC
 SBC #10
:LESS STA :CHAR
 ORA #"0"
 TAX
 LDA :CHAR+1
 ORA #"0"
 RTS
:CHAR DS 2

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/GAME.USE
 fin

 END
