*-------------------------------------------------
* XMODEM receive
*
* Modified by Sean Craig to work
* with The Complex II
*-------------------------------------------------
 DAT
 LST OFF

 XC OFF ;Make sure 65c02 opcodes are allowed only!
 XC ;

 ORG $8000

 USE MACROS
 USE EQUATES
 USE VARS
 USE LIB.JMP

FILET MAC
 DFB ]1
 ASC ]2
 <<<

* USE TP.EQUATES
* USE TP.MACROS

* EXT PRINT,GET_LINE,MLIERR,PICKLINE,ONLINE,UPPER ;Lib
* EXT DUMBTERM,PADFLAG,PADCHAR ;Vars
* EXT MSENDBYTE,CHECKIN ;Coms

*MEMTOP EQU BUFFER+2048

*-------------------------------
* XRECEIVE - XMODEM upload module
*            Copyright (c) 1990-1991 by Oz Data, written by Richard Bennett
*
* For use with Eclipse, although it may be modified for other uses.
*
* MLOAD "XRECEIVE"
* USERCALL WITH filename$ COLLECT errcount xfermode$
*
* Sends the requested file to the user
*
* Errors: 0 = No errors, xfer worked ok!
*         1 = No file specified
*         2 = Timeout on xfer start command. User mucking around!
*         3 = No buffers available for disk reading. CLEAR some vars!
*         4 = Sender response lost
*         5 = User cancelled the xfer
*     AE: 6 = No ETB received from the sender
*     AE: 7 = Sender getting errors trying to receive the AE block
*     AE: 8 = Invalid AE block
*         MLI errors intact
*-------------------------------

INCR3 MAC
 INC ]1
 BNE OK
 INC ]1+1
 BNE OK
 INC ]1+2
OK <<<
LXA MAC ; LXA location
 LDX ]1
 LDA ]1+1
 <<<
LXADR MAC
 LDX #<]1
 LDA #>]1
 <<<
STXA MAC ; STXA location
 STX ]1
 STA ]1+1
 <<<
INXA MAC
INCXA MAC
 INX
 BNE OK
 INC
OK <<<

USERWORK EQU $60

UERR_DATATYPE = 91 ;For user modules
UERR_PARMCOUNT = 92


SOH = 1
EOT = 4
ACK = 6
NAK = $15
SYN = $16
ETB = $17
CAN = $18
CRC = 'C' ;$43
ZAP = $1A

ERR_NOFILE = 1
ERR_TIMEOUT = 2
ERR_NOBUFFAVAIL = 3
ERR_SENDLOST = 4
ERR_USERCANX = 5
ERR_NOETB = 6
ERR_ERRAE = 7
ERR_BADAE = 8

ALTCHARSET EQU $C01E
SETALTCHAR EQU $C00F
CLRALTCHAR EQU $C00E

 DUM USERWORK
CRCMODE DS 1 ;CRCMODE on/off
AEMODE DS 1 ;AEMODE on/off
RETRIES DS 1 ;Retry counter
STACK DS 1 ;Entry/exit stack
EXTENDCNT DS 1 ;AE extension retry counter
BLOCKUPTO ADR 0 ;Current block in progress
T1 DS 1 ;Anything
PTR DA 0 ;Anything
SENDADR DA 0 ;Address of current block
SUM DS 1
HERTZMOD DS 1
CRC1 DS 1
CRC2 DS 1
OUTSAVE DS 1
SAVECV DS 1
SAVECH DS 1
SAVECHARSET DS 1
MODES? DS 1
 DEND

*-------------------------------

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/GAME.XR
 fin

 MODID "GAME.XR"

XRECEIVE ENT
 LDA DUMBTERM
 STA DTERMSAVE
 MLI_GET_PREFIX PFXPARMS
 JSR MLIERR
 LDA CURRPFX
 STA PFXLEN
 LDA #$FF
 STA VTEMP+1
XRECEIVE2 LDA DTERMSAVE
 STA DUMBTERM

 LDX VTEMP ;Set up by previous module?
 BMI :SPECIAL
 BNE :NOT1 ;Yes
 JMP EXITPLIST

:SPECIAL JSR PRINT
 CR
 CR
 ASC "Enter file to upload ('*' = show files)"
 CR
 ASC "> "
 NULL
 GETLINE #15
 BCSL EXITPLIST
 CPX #0
 BEQ XRECEIVE2
 CPX #1
 BNEL :NOT1
 LDA $200
 CMP #"*"
 BNEL :NOT1
 JSR CAT
 JMP XRECEIVE2

:NOT1 STX PATHNAME
]LOOP LDA $200-1,X
 JSR UPPER
 STA PATHNAME,X
 DEX
 BNE ]LOOP

 LDA PFXLEN ;Add 'DRAWER/' to pathname
 TAX
 CLC
 ADC NEWPFX
 STA CURRPFX
 LDY #0
]LOOP INX
 INY
 LDA NEWPFX,Y
 AND #$7F
 STA CURRPFX,X
 CPY NEWPFX
 BNE ]LOOP

 LDA CURRPFX ;Add '{file}' to pathname
 TAX
 CLC
 ADC PATHNAME
 STA CURRPFX
 LDY #0
]LOOP INX
 INY
 LDA PATHNAME,Y
 AND #$7F
 STA CURRPFX,X
 CPY PATHNAME
 BNE ]LOOP

 MLI_GET_FILE_INFO GPARMS
 BCC :EXISTS
 CMP #$46 ;Not found?
 BEQL :FILEOK
:ANERR STA :TEMP
 JSR PRINT
 CR
 ASC "MLI error $"
 HEX8 :TEMP
 LINE " occurred. "
 NULL
:NOGOOD GETRETURN
 STZ VTEMP
 JMP XRECEIVE2
:EXISTS JSR PRINT
 CR
 ASC "File already exists. "
 NULL
 LDA VTEMP
 BPL :NOGOOD
 JSR PRINT
 ASC "Overwrite (y/N)? : "
 NULL
 JSR KEYIN
 JSR UPPER
 CMP #"Y"
 BEQ :EATIT
 JSR PRINT
 LINE "No"
 NULL
 JMP XRECEIVE2
:EATIT JSR PRINT
 LINE "Yes"
 NULL
 MLI_DESTROY :DPARMS
 JSR MLIERR
:FILEOK STZ VTEMP
 JMP STARTZ
*-------------------------------------------------

:TEMP DS 1

:DPARMS DFB 1
 DA CURRPFX ;PATHNAME

GPARMS DFB $A
 DA CURRPFX ;PATHNAME
 DS 15

*-------------------------------------------------

STARTZ LDX #<CURRPFX-1 ;PATHNAME-1
 LDA #>CURRPFX-1 ;PATHNAME-1
 STX PTR
 STA PTR+1
 LDY #1 ;Parameter count
 JSR GOGO
 JSR CLOSEIT ;Just in case..
 LDA LASTERROR
 BNEL ABORT
 JSR PRINT
 CR
 CURSORON
 LINE "Transfer completed."
 NULL
 MLI_GET_FILE_INFO GPARMS
 LDX #0
]LOOP LDA GPARMS,X
 STA $200,X
 INX
 CPX #$12
 BNE ]LOOP
 LDX #0
]LOOP LDA EOF,X
 STA $200+$12,X
 INX
 CPX #3
 BNE ]LOOP
 STZ VTEMP+1
 JMP XRECEIVE2

GOGO STX :X
 STA :A
 STY :Y
 INCR PTR
 JSR PRINT
 HOME
 CR
 ASC "Receiving : "
 QUOTE
 PRSTRING PATHNAME
 QUOTE
 CR
 CR
 ASC "Host ready to receive"
 CR
 NULL
 LDA #$FF
 STA DUMBTERM
 LDX :X
 LDY :Y
 LDA :A
 BRA ENTRY

:X DS 1
:A DS 1
:Y DS 1

*-------------------------------

 ASC "(c) 1990-1991 Oz Data. RJB 31-Dec-91"
ENTRY

* 1. Init variables

* CPY #1 ;Check parm count
* BEQ :PCOK
* LDA #UERR_PARMCOUNT
* STA LASTERROR
* JMP EXITPLIST
*:PCOK
* STXA PTR
* LDA (PTR) ;Check datatype
* CMP #4
* BEQ :DTOK
* LDA #UERR_DATATYPE
* STA LASTERROR
* JMP EXITPLIST
*:DTOK
* LXA PTR
* INXA
* JSR P3MAKEPSTR

 TSX
 STX STACK
 STZ CRCMODE ;No
 STZ AEMODE ;No
 STZ LASTERROR
 LDA HERTZ
 SEC
 SBC #5
 STA HERTZMOD ;To allow for code movements...
* LDA OUTFLAG
* STA OUTSAVE
* LDA #$80
* STA OUTFLAG
* JSR INITSCREEN

* LDA (FREEPTR) ;Get name length
* LDX FREEPTR+1
* SEC ;+1 to skip length
* ADC FREEPTR
* BCC :PTROK1
* INX
*:PTROK1 STA T1
* AND #$80
* CMP T1 ;On a boundary?
* BEQ :GOTBOUND
* CLC
* ADC #$80 ;Bump to next then
* BCC :GOTBOUND
* INX
*:GOTBOUND STA WRITEADR ;Got the buffer start
* STX WRITEADR+1
* EOR #$FF ;Trick- Subtract XA from MEMTOP to get buffer size
* SEC ;EOR $FFFF +1
* ADC MEMTOP
* STA WRITELEN
* TAY
* TXA
* EOR #$FF
* ADC MEMTOP+1
* STA WRITELEN+1
* PHP
* LDA #2
* PLP
* BMIL EXIT ;High byte minus, no room
* BNE :BUFFOK
* CPY #0
* BEQL EXIT ;Both zero, bang on no room...
*:BUFFOK
* LXA WRITEADR
* STXA SENDADR

 LDA #<BUFFER
 STA SENDADR
 STA WRITEADR
 LDA #>BUFFER
 STA SENDADR+1
 STA WRITEADR+1

* 2. Create the file, and open it

 JSR $BF00
 HEX 82
 DA 0
 LDX #3
]L1 LDA $BF90,X
 STA DATETIME,X
 DEX
 BPL ]L1
* LXA FREEPTR
* STXA PATHADRC
* STXA PATHADRO
 LDA #<CURRPFX ;PATHNAME
 STA PATHADRC
 STA PATHADRO
 LDA #>CURRPFX ;PATHNAME
 STA PATHADRC+1
 STA PATHADRO+1
 JSR $BF00
 HEX C0
 DA CREATE
 BCSL EXIT
 JSR $BF00
 HEX C8
 DA OPEN
 BCSL EXIT

* 3. Setup stuff

 JSR PRINT
 CURSOROFF
 NULL
 JSR PRBLOCKS

 LDA REFNUM
 STA REFW

 LDA #1
 STA BLOCKUPTO
 STZ BLOCKUPTO+1
 STZ BLOCKUPTO+2

 STZ MODES?

* 4. Send initial "C" and wait ten timeout (contrary to standard CRC doc,
*    as if the standard 3 second timeout, send only was done, then
*    nothing would ever switch to CRC mode. No one is that quick!), then
*    fall back to standard 3 second timeout.

 LDA #2
 STA RETRIES ;Try twice. 1=10sec,2=3sec
 LDX #10 ;Wait 10 seconds
 BRA :CRC3
:CRC1 LDX #3 ;Wait 3 seconds
:CRC3 PHX
 JSR CHECKCANX
 LDA #CRC
 JSR MSENDBYTE ;MDRFORCE
 PLX
:CRC2 JSR TIMEGET
 BCC :CHECKSTARTC
 DEC RETRIES
 BNE :CRC1

 LDA #10
 STA RETRIES ;Try 10 times...
:NAK1 JSR CHECKCANX
 LDA #NAK
 JSR MSENDBYTE ;MDRFORCE ;Send the NAK
 LDX #10
 JSR TIMEGET
 BCC :CHECKSTARTN
:NAK2 DEC RETRIES
 BNE :NAK1
 LDA #ERR_TIMEOUT
 JMP EXITCLOSE
:CHECKSTARTC
 CMP #$80+SOH
 BEQ :DOAECRC
 CMP #SOH
 BEQ :DOCRC
 CMP #CAN
 BEQ :USERCANX
 JMP :CRC1
:CHECKSTARTN ;Here if character received from NAK
 CMP #$80+SOH
 BEQ :DOAE1
 CMP #SOH
 BEQL :GO
 JMP :NAK2
:USERCANX LDA #ERR_USERCANX
 JMP EXITCLOSE

:DOCRC DEC CRCMODE
 BRA :GO

* 5. Look for the AE extension block

:DOAECRC DEC CRCMODE
:DOAE1 LDX #10
 JSR TIMEGET
 BCS :NAK1
 CMP #0
 BNE :NAKAECLR
 LDX #10
 JSR TIMEGET
 BCS :NAK1
 CMP #$FF
 BNE :NAKAECLR
 DEC AEMODE
 JSR CHECKCANX
 LDA #ACK
 JSR MSENDBYTE ;MDRFORCE
 BRA :STARTREC
:NAKAECLR JSR CLR
 JMP :NAK1

* 6. Receive the first block

:GETBLOCK INC BLOCKUPTO
 BNE :OK1
 INC BLOCKUPTO+1
 BNE :OK1
 INC BLOCKUPTO+2
:OK1

:STARTREC BIT MODES?
 BMI :SKIPZ
 JSR PRMODES
:SKIPZ

 LDA #10
 STA RETRIES
]L1 LDX #10
 JSR TIMEGET
 BCC :CHECKSOH
:NAKBLK JSR CHECKCANX
 LDA #NAK
 JSR MSENDBYTE ;MDRFORCE
 JSR BUMPERR
 DEC RETRIES
 BNE ]L1
 LDA #ERR_SENDLOST
 JMP EXITCLOSE
:CHECKSOH CMP #SOH
 BEQ :GO
 CMP #CAN
 BEQ :USERCANX
 CMP #EOT
 BEQL :EOT
:RESEND JSR CLR
 BRA :NAKBLK
:RESENDPL1 PLA
 BRA :RESEND
:GO
 LDX #1
 JSR TIMEGET
 BCS :RESEND
 CMP BLOCKUPTO
 BNE :RESEND
 LDX #1
 JSR TIMEGET
 BCS :RESEND
 CLC
 ADC BLOCKUPTO
 CMP #255
 BNE :RESEND
 BIT CRCMODE ;Which method?
 BPL :CKSUMODE

:CRCMODE STZ CRC1
 STZ CRC2
 LDY #0
]L1 PHY
 LDX #1
 JSR TIMEGET
 BCS :RESENDPL1
 PLY
 STA (SENDADR),Y
 JSR CRCCALC
 INY
 BPL ]L1
 LDX #1
 JSR TIMEGET
 BCS :RESEND
 CMP CRC1
 BNE :RESEND
 LDX #1
 JSR TIMEGET
 BCS :RESEND
 CMP CRC2
 BNE :RESEND
 BRA :JOIN

:CKSUMODE STZ SUM
 LDY #0
]L1 PHY
 LDX #1
 JSR TIMEGET
 BCS :RESENDPL1
 PLY
 STA (SENDADR),Y
 CLC
 ADC SUM
 STA SUM
 INY
 BPL ]L1
 LDX #1
 JSR TIMEGET
 BCS :RESEND
 CMP SUM
 BNE :RESEND
:JOIN

* 7. Check all the buffer stuff before the ACK

 JSR BUMPBLK

 LDA SENDADR
 EOR #$80
 STA SENDADR
 BNE :BUMPOK
 INC SENDADR+1
:BUMPOK LDA SENDADR+1 ;Finished this buffer
 CMP #>BUFFER+2048 ;MEMTOP
 BNEL :RECOK
 LDA SENDADR
 CMP #<BUFFER+2048 ;MEMTOP
 BNEL :RECOK
 JSR XSAVEFILE
:RECOK JSR CHECKCANX
 LDA #ACK
 JSR MSENDBYTE ;MDRFORCE
 JMP :GETBLOCK

* 8. EOT, wait for AE extension, or just exit

:EOT JSR XSAVEFILE
 JSR CHECKCANX

 LDA #ACK
 JSR MSENDBYTE ;MDRFORCE

 BIT AEMODE
 BMI :DOAE
 JMP EXITOK

* 9. Do the AE pro extension

:DOAE JSR CHECKCANX
 LDA #SYN
 JSR MSENDBYTE ;MDRFORCE
 LDA #3-1 ;One already sent
 STA RETRIES
]L1 LDX #10
 JSR TIMEGET
 BCC :CHECKETB
 LDA #SYN
 JSR MSENDBYTE ;MDRFORCE
:ETB1 JSR BUMPERR
 DEC RETRIES
 BNE ]L1
 LDA #ERR_NOETB
 JMP EXITCLOSE
:CHECKETB CMP #ETB
 BNE :ETB1
 LDA #NAK
 JSR MSENDBYTE ;MDRFORCE

 LDA #3
 STA RETRIES
:TRYAE LDX #10
 JSR TIMEGET
 BCC :CHECKAE
:NAKAE JSR CHECKCANX
 LDA #NAK
 JSR MSENDBYTE ;MDRFORCE
 JSR BUMPERR
 DEC RETRIES
 BNE :TRYAE
 LDA #ERR_ERRAE
 JMP EXITCLOSE
:CHECKAE CMP #SOH
 BEQ :RECAE
:CLRAEPL1 PLA
:CLRAE JSR CLR
 BRA :NAKAE
:RECAE LDX #1
 JSR TIMEGET
 BCS :CLRAE
 STA CRC1 ;Block really
 LDX #1
 JSR TIMEGET
 BCS :CLRAE
 STA CRC2 ;255-Block really
 CLC
 ADC CRC1 ;Validates?
 CMP #255
 BNE :CLRAE
 LDA CRC1 ;Was it AE block
 CMP #$AA
 BEQ :AEOK
 CMP BLOCKUPTO ;Was it "next" AE block
 BNE :CLRAE
:AEOK
 BIT CRCMODE
 BPL :AESUM
:AECRC STZ CRC1
 STZ CRC2
 LDY #0
]L1 PHY
 LDX #1
 JSR TIMEGET
 BCS :CLRAEPL1
 PLY
 CPY #23
 BCS :SKIP
 STA SETINFO,Y
:SKIP JSR CRCCALC
 INY
 BPL ]L1
 LDX #1
 JSR TIMEGET
 BCS :CLRAE
 CMP CRC1
 BNE :CLRAE
 LDX #1
 JSR TIMEGET
 BCS :CLRAE
 CMP CRC2
 BNE :CLRAE
 BRA :JOINAE

:AESUM STZ SUM
 LDY #0
]L1 PHY
 LDX #1
 JSR TIMEGET
 BCS :CLRAEPL1
 PLY
 CPY #23
 BCS :SKIP1
 STA SETINFO,Y
:SKIP1 CLC
 ADC SUM
 STA SUM
 INY
 BPL ]L1
 LDX #1
 JSR TIMEGET
 BCSL :CLRAE
 CMP SUM
 BNEL :CLRAE
:JOINAE
 JSR CHECKCANX
 LDA #ACK
 JSR MSENDBYTE ;MDRFORCE
 LDA SETINFO+1
 CMP #$D4
 BNEL :CLRAE
 LDA SETINFO+2
 CMP #$41
 BNEL :CLRAE
 LDA #7
 STA SETINFO
 LXA PATHADRO
 STXA SETINFOADR
 JSR $BF00
 HEX C3
 DA SETINFO
 BCSL EXITCLOSE
 LDA SETINFO+18
 CMP #2
 BEQ :SETEOF
 LDA SETINFO+17 ;Check for "Talk is Cheap" bug...
 CMP #2
 BNE :INVALID
 LDA SETINFO+22
 CMP #$FF
 BNE :INVALID
 LDA SETINFO+23
 CMP #$FF
 BNE :INVALID
 LDA REFNUM
 STA SETEOFREF-1
 JSR $BF00
 HEX D0
 DA SETEOF-1
 BCSL EXITCLOSE
 JMP EXITOK
:INVALID LDA #ERR_BADAE
 JMP EXITCLOSE
:SETEOF LDA REFNUM
 STA SETEOFREF
 JSR $BF00
 HEX D0
 DA SETEOF
 BCSL EXITCLOSE
 JMP EXITOK

* Subroutines

* CLR Wait until at least 1 second delay with no characters in
CLRZ PLY
CLR LDY HERTZMOD
:TOP PHY
]L1 JSR CHECKIN2 ;MDRGET
 BCS CLRZ
 BIT $C019
 BMI ]L1
]L1 JSR CHECKIN2 ;MDRGET
 BCS CLRZ
 BIT $C019
 BPL ]L1
 PLY
 DEY
 BNE :TOP
 RTS

* TIMEGET exits if no character is received within X seconds of entering
*  with carry reflecting the status
TIMEGET ;X second timeout
 LDY HERTZMOD ;for a second
 PHX
]L1 PHY
]L2 JSR CHECKIN2 ;MDRGET
 BCS :GOTRESP
 BIT $C019
 BMI ]L2
]L3 JSR CHECKIN2 ;MDRGET
 BCS :GOTRESP
 BIT $C019
 BPL ]L3
 PLY
:NEXTVBL DEY
 BNE ]L1
 PLX
 DEX
 BPL TIMEGET
:GET1 SEC
 RTS
:GOTRESP PLY
 PLX
 CLC
 RTS

CRCCALC STA T1
 LDA #0
 LDX #8
]L1 ASL T1
 ROR
 AND #$80
 EOR CRC1
 ASL CRC2
 ROL
 BCC :NEXT
 PHA
 LDA CRC2
 EOR #$21
 STA CRC2
 PLA
 EOR #$10
:NEXT STA CRC1
 DEX
 BNE ]L1
 RTS

EXITCLOSE PHA
 JSR CLOSEIT
 PLA
EXIT STA LASTERROR
 LDA #CAN
 JSR MSENDBYTE ;MDRFORCE
EXITOK ;JSR RESTSCREEN
* LDA OUTSAVE
* STA OUTFLAG
 LDX STACK
 TXS
 RTS

EXITPLIST JSR PRINT
 CURSORON
 NULL
 LDA DTERMSAVE
 STA DUMBTERM
 LXADR PLIST
 LDY #2
 RETURN

CHECKCANX PHP
 PHA
 LDA $C000
 BPL :OUT
 STA $C010
 CMP #$9B
 BNE :OUT
:DOCANX LDA #CAN
 JSR MSENDBYTE ;MDRFORCE
 LDA #ERR_USERCANX
 JMP EXITCLOSE
:OUT PLA
 PLP
 RTS

CLOSEIT LDA REFNUM
 STA SETEOFREF
 STA CLOSE+1
 JSR $BF00
 HEX D1
 DA SETEOF
 JSR $BF00
 HEX CC
 DA CLOSE
 RTS

XSAVEFILE LDA SENDADR
 SEC
 SBC WRITEADR
 STA WRITELEN
 LDA SENDADR+1
 SBC WRITEADR+1
 STA WRITELEN+1
 JSR $BF00
 HEX CB
 DA WRITE
 BCS EXITCLOSE
 LXA WRITEADR
 STXA SENDADR
 RTS

* MLI parameters

CREATE DFB 7
PATHADRC DA 0
 DFB $C3,4
 DA 0
 DFB 1
DATETIME DS 4

OPEN DFB 3
PATHADRO DA 0
 DA IOBUFFER
REFNUM DFB 0

CLOSE DFB 1,0

*------------------------------- This chunk received as block
SETINFO DFB $A
SETINFOADR DA 0
 DS 1
FILETYPE DS 1
AUXTYPE DA 0
 DS 1
BLKS DA 0
 DS 2+2+2+2

SETEOF DFB 2
SETEOFREF DS 1
EOF ADR 0
*-------------------------------

WRITE DFB 4
REFW DS 1
WRITEADR DA BUFFER
WRITELEN DA 2048
WRITEXFER DA 0

*-------------------------------
* Screen stuff from here down

*INITSCREEN LDA CV
* STA SAVECV
* LDA CH
* STA SAVECH
* ROL ALTCHARSET
* ROR SAVECHARSET
* LDA #TEXTSAVE
* STA PTR
* LDA #>TEXTSAVE
* STA PTR+1
* LDA #6
* STA CV
* LDA #20
* STA CH
*]L1 SCRPICK
* STA (PTR)
* INCR PTR
* INC CH
* LDA CH
* CMP #60
* BCC ]L1
* LDA #20
* STA CH
* INC CV
* LDA CV
* CMP #17
* BCC ]L1
* LDA #6
* STA CV
* LDA #21
* STA CH
* LDA #"_"
* LDX #59
* JSR :LINE
* INC CV
*]L1 LDA #20
* STA CH
* LDA #$5A
* SCRPUT
* INC CH
* LDA #$A0
* LDX #59
* JSR :LINE
* LDA #$5F
* SCRPUT
* INC CV
* LDA CV
* CMP #16
* BCC ]L1
* LDA #21
* STA CH
* LDA #$4C
* LDX #59
* JSR :LINE
* LDA #8
* STA CV
* LDA #32
* STA CH
* JSR P3PRINT
* ASC "XMODEM/Receive",00
* INC CV
* LDA #32
* STA CH
* LDA #$4C
* LDX #46
* JSR :LINE
* INC CV
* LDA #22
* STA CH
* JSR P3PRINT
* ASC "File: "
* DFB '"'.$80,0
* LDA (FREEPTR)
* BEQ :NOPATH
* LDY #0
*]L1 INY
* LDA (FREEPTR),Y
* STA :MOD1
* PHY
* JSR P3PRINT
*:MOD1 DFB 0,0
* PLY
* TYA
* CMP (FREEPTR)
* BNE ]L1
*:NOPATH JSR P3PRINT
* DFB '"'.$80,0
* RTS
*:LINE PHX
* SCRPUT
* INC CH
* PLX
* CPX CH
* BNE :LINE
* RTS

*RESTSCREEN LDA #TEXTSAVE
* STA PTR
* LDA #>TEXTSAVE
* STA PTR+1
* LDA #6
* STA CV
* LDA #20
* STA CH
*]L1 LDA (PTR)
* SCRPUT
* INCR PTR
* INC CH
* LDA CH
* CMP #60
* BCC ]L1
* LDA #20
* STA CH
* INC CV
* LDA CV
* CMP #17
* BCC ]L1
* LDA SAVECH
* STA CH
* LDA SAVECV
* STA CV
* RTS

PRBLOCKS JSR PRINT
:V GOTOXY 29;10
 LINE "Received :"
 HTAB 29
 LINE "  Errors :"
 HTAB 29
 LINE "    Mode :"
 NULL
 LDA :V+3
 STA BLKCV
 INC
 STA ERRCV
 INC
 STA MODECV
 RTS

*PRBLOCKS INC CV
* INC CV
* LDA #31
* STA CH
* JSR P3PRINT
* ASC "Received:",00
* LDA CV
* STA BLKCV
* LDA #47
* STA CH
* LDA #"0"
* SCRPUT
* INC CV
* LDA #31
* STA CH
* JSR P3PRINT
* ASC "Errors:",00
* LDA CV
* STA ERRCV
* LDA #47
* STA CH
* LDA #"0"
* SCRPUT
* INC CV
* LDA #31
* STA CH
* JSR P3PRINT
* ASC "Mode:",00
* LDA CV
* STA MODECV
* RTS

BLKCV DS 1
MODECV DS 1
ERRCV DS 1

PRMODES LDA #48
 STA XCH
 LDA MODECV
 STA XCV
 STA :HV1+3
 STA :HV2+3
 STA :HV3+3
 LDA AEMODE
 ORA CRCMODE
 BNE :DOMODES
 LDA #48-8
 STA XCH
 STA :HV1+2
 JSR PRINT
:HV1 GOTOXY 0;0
 ASC "Standard"
 NULL
 BRA :OUT
:DOMODES BIT AEMODE
 BPL :NOAE
 LDA XCH
 SEC
 SBC #2
 STA XCH
 STA :HV2+2
 JSR PRINT
:HV2 GOTOXY 0;0
 ASC "AE"
 NULL
 LDA #'A'
 STA PLISTMODES
 LDA XCH
 SEC
 SBC #3
 STA XCH
:NOAE BIT CRCMODE
 BPL :NOCRC
 LDA XCH
 SEC
 SBC #3
 STA XCH
 STA :HV3+2
 JSR PRINT
:HV3 GOTOXY 0;0
 ASC "CRC"
 NULL
 LDA #'C'
 STA PLISTMODES+1
 LDA XCH
 SEC
 SBC #4
 STA XCH
 STA :HTAB+2
:NOCRC JSR PRINT
:HTAB HTAB 0
 NULL
 LDA CH
 STA XCH
:OUT DEC MODES?
 RTS

BUMPERR INCR3 PLISTERRS
 LDA ERRCV
 STA XCV
 BRA BUMPVAL
BUMPBLK LDA BLKCV
 STA XCV
BUMPVAL LDA #47
 STA XCH
]L1 JSR SCRPICK
 CMP #$A0
 BNE :SKIP
 LDA #"0"
:SKIP CMP #"9"
 BCC :INC
 LDA #"0"
 JSR SCRPUT
 DEC XCH
 BRA ]L1
:INC INC
 JSR SCRPUT
 RTS

LASTERROR DS 1
FREEPTR DS 2

XCH DS 1
XCV DS 1

HERTZ DFB 60

PLIST DFB 1 ;ERRORS numeric
 DFB 0 ; sign
PLISTERRS DS 3,0 ; low/mid/high
 DFB 4 ;MODE gstring
 DA 2 ; length word
PLISTMODES ASC '  ' ; 'AC'

SCRPICK LDX XCH
 LDY XCH
 LDA XCV
 JSR PICKLINE
 LDA $200
 RTS

SCRPUT STA :CHAR
 LDA CH
 STA :HV2+2
 LDA CV
 STA :HV2+3
 LDA XCH
 STA :HV1+2
 LDA XCV
 STA :HV1+3
 JSR PRINT
:HV1 GOTOXY 0;0
:CHAR DS 1
:HV2 GOTOXY 0;0
 NULL
 RTS

ABORT JSR PRINT
 CR
 ASC "Transfer aborted (error "
 DEC8 LASTERROR
 LINE ")."
 NULL
 JMP XRECEIVE2

 DFB 4
PATHNAME DS 1
 ASC '/'
 DS 15

PFXPARMS DFB 1
 DA CURRPFX
CURRPFX DS 1+65

PFXLEN DS 1
NEWPFX STR 'DRAWER/'

DTERMSAVE DS 1

CAT LDA PADFLAG
 STA :PADFLAG
 LDA PADCHAR
 STA :PADCHAR
 LDA #$FF
 STA PADFLAG
 LDA #" "
 STA PADCHAR

 MLI_GET_PREFIX :GPPARMS
 JSR MLIERR
 LDA :PREFIX
 TAX
 CLC
 ADC NEWPFX
 STA :PREFIX
 LDY #0
]LOOP INX
 INY
 LDA NEWPFX,Y
 STA :PREFIX,X
 CPY NEWPFX
 BNE ]LOOP

 STZ :CNTR

 JSR PRINT
 HOME
 ASC "  File            Type  Modified         Created"
 LINE "              Size"
 CR
 MTON
 NULL

 MLI_OPEN :OPARMS
 JSR MLIERR
 LDA :OPARMS+5
 STA :RPARMS+1
 STA :CPARMS+1

 MLI_READ :RPARMS
 JSR MLIERR

 LDA #<:BUFFER
 STA CADD4
 LDA #>:BUFFER
 STA CADD4+1

 LDY #$23
 LDA (CADD4),Y
 STA ENTRY_LENGTH
 INY
 LDA (CADD4),Y
 STA ENTRIES_PER_BLOCK
 INY
 LDA (CADD4),Y
 STA FILE_COUNT
 INY
 LDA (CADD4),Y
 STA FILE_COUNT+1

 LDA ENTRY_LENGTH
 CLC
 ADC #4
 STA ENTRY_POINTER
 STZ ENTRY_POINTER+1
 LDA CADD4
 CLC
 ADC ENTRY_POINTER
 STA CADD4
 LDA CADD4+1
 ADC #0
 STA CADD4+1

 LDA #2
 STA BLOCK_ENTRIES

 STZ ACTIVE_ENTRIES
 STZ ACTIVE_ENTRIES+1

:FREAD LDA ACTIVE_ENTRIES+1
 CMP FILE_COUNT+1
 BEQ :HMM
 BCSL :EXIT
:HMM LDA ACTIVE_ENTRIES
 CMP FILE_COUNT
 BCSL :EXIT

 LDY #0 ;ENTRY_POINTER
 LDA (CADD4),Y ;Does the file exist?
 AND #$F0
 BEQ :SKIP ;No it doesn't.. so skip it
 JSR :PROCESS
 INCR ACTIVE_ENTRIES

:SKIP LDA ACTIVE_ENTRIES+1
 CMP FILE_COUNT+1
 BEQ :HMM2
 BCS :FREAD
:HMM2 LDA ACTIVE_ENTRIES
 CMP FILE_COUNT
 BCS :FREAD

 LDA BLOCK_ENTRIES
 CMP ENTRIES_PER_BLOCK
 BNE :DIFF

 MLI_READ :RPARMS
 JSR MLIERR
 LDA #1
 STA BLOCK_ENTRIES
 LDA #4
 STA ENTRY_POINTER
 STZ ENTRY_POINTER+1
 LDA #<:BUFFER
 CLC
 ADC #4
 STA CADD4
 LDA #>:BUFFER
 ADC #0
 STA CADD4+1
 JMP :FREAD

:DIFF LDA ENTRY_POINTER
 CLC
 ADC ENTRY_LENGTH
 STA ENTRY_POINTER
 LDA ENTRY_POINTER+1
 ADC #0
 STA ENTRY_POINTER+1
 LDA #<:BUFFER
 CLC
 ADC ENTRY_POINTER
 STA CADD4
 LDA #>:BUFFER
 ADC ENTRY_POINTER+1
 STA CADD4+1
 INC BLOCK_ENTRIES
 JMP :FREAD

:PROCESS BIT $C061
 BPL :OANO
 LDY #$10
 LDA (CADD4),Y
 CMP #$0F ;DIR?
 BEQ :OANO
 RTS
:OANO LDY #0 ;ENTRY_POINTER
 LDA (CADD4),Y
 AND #$0F
 STA :FILE
 LDX #0
]LOOP INY
 LDA (CADD4),Y
 ORA #%1000_0000
 INX
 STA :FILE,X
 CPX :FILE
 BNE ]LOOP

 LDY #$1E
 LDA (CADD4),Y
 AND #%1100_0010
 BEQ :LOCKED
:UNLOCKED LDA #" "
 HEX 2C
:LOCKED LDA #"*"
 STA :LOCKATTR
 LDA (CADD4),Y
 AND #%0000_0100
 BEQ :VISIBLE
:INVISIBLE LDA :LOCKATTR
 CMP #"*"
 BNE :INVUNL
:INVLOCK JSR PRINT
 INVERSE
 ASC "@"
 NORMAL
 NULL
 BRA :DONAME
:INVUNL JSR PRINT
 INVERSE
 ASC "A"
 NORMAL
 NULL
 BRA :DONAME
:VISIBLE LDA :LOCKATTR
 JSR COUT

:DONAME JSR PRINT
 ASC " "
 COLOR AQUAMRINE
 PRSTRING :FILE
 HTAB 19
 COLOR GREEN
 NULL

 PushWord CADD3
 LDA #<:FTYPES
 STA CADD3
 LDA #>:FTYPES
 STA CADD3+1

 LDY #$10
 LDA (CADD4),Y
 STA :TYPE
]LOOP LDY #0
 LDA (CADD3),Y
 CMP :TYPE
 BNE :FNEXT
 INY
 LDA (CADD3),Y
 JSR COUT
 INY
 LDA (CADD3),Y
 JSR COUT
 INY
 LDA (CADD3),Y
 JSR COUT
 BRA :FCONT
:FNEXT INY
 LDA (CADD3),Y
 BEQ :UNKNOWN
 LDA CADD3
 CLC
 ADC #4
 STA CADD3
 LDA CADD3+1
 ADC #0
 STA CADD3+1
 BRA ]LOOP

:UNKNOWN JSR PRINT
 ASC "$"
 HEX8 :TYPE
 NULL

:FCONT PullWord CADD3

 LDY #$18
 LDA (CADD4),Y
 STA :CRDATE
 INY
 LDA (CADD4),Y
 STA :CRDATE+1
 INY
 LDA (CADD4),Y
 STA :CRTIME
 INY
 LDA (CADD4),Y
 STA :CRTIME+1

 LDY #$21
 LDA (CADD4),Y
 STA :MODATE
 INY
 LDA (CADD4),Y
 STA :MODATE+1
 INY
 LDA (CADD4),Y
 STA :MODTIME
 INY
 LDA (CADD4),Y
 STA :MODTIME+1

 JSR PRINT
 COLOR ORANGE
 ASC "  "
 DATE :MODATE
 ASC " "
 TIME :MODTIME
 COLOR PINK
 ASC "  "
 DATE :CRDATE
 ASC " "
 TIME :CRTIME
 COLOR YELLOW
 NULL

 LDY #$15
 LDA (CADD4),Y
 STA :BLOCKS
 INY
 LDA (CADD4),Y
 STA :BLOCKS+1
 INY
 LDA (CADD4),Y
 STA :BLOCKS+2
 CMP #1
 BCS :DOK
 LDA :BLOCKS+1 ;Get size in K
 CMP #4
 BCC :DOBYTES
:DOK LDA $C062
 BMI :DOBYTESHEX
 LSR :BLOCKS+2
 ROR :BLOCKS+1
 ROR :BLOCKS
 LSR :BLOCKS+2
 ROR :BLOCKS+1
 ROR :BLOCKS
 LDA :BLOCKS
 BEQ :DOK2
 INCR :BLOCKS+1
:DOK2 JSR PRINT
 DEC32 :BLOCKS+1
 COLOR WHITE
 ASC " k"
 NULL
 BRA :CONT
:DOBYTESHEX JSR PRINT
 ASC "   $"
 HEX8 :BLOCKS+2
 HEX16 :BLOCKS
 COLOR WHITE
 ASC " bytes"
 NULL
 BRA :CONT
:DOBYTES LDA $C062
 BMI :DOBYTESHEX
 JSR PRINT
 DEC32 :BLOCKS
 COLOR WHITE
 ASC " bytes"
 NULL

:CONT JSR PRINT
 CR
 NULL
 INC :CNTR
 JSR CHECKIN2
 BCC :NOIN
 CMP #$9B
 BNE :NOKEY
:NOIN LDA $C000
 BPL :NOKEY
 STA $C010
 AND #%0111_1111
 CMP #$1B
 BNE :NOKEY
 PLA
 PLA
 JSR PRINT
 CR
 COLOR PINK
 LINE "Aborted."
 COLOR WHITE
 NULL
 JMP :ABORTZ
:NOKEY LDA :CNTR
 CMP #20
 BNE :CONT3
 STZ :CNTR
 JSR PRINT
 ASC "Press any key to continue; [ESC] aborts"
 NULL
 JSR KEYIN
 CMP #$1B
 BEQ :EXITZ
 JSR PRINT
 ZAPLINE
 HTAB 0
 NULL
:CONT3 RTS

:EXITZ JSR PRINT
 ZAPLINE
 NULL
 PLA ;We got JSR'd
 PLA
:EXIT JSR PRINT
 CR
 NULL

 LDA :PREFIX+1
 AND #%0111_1111
 CMP #'/'
 BEQ :PFOK
 MLI_GET_PREFIX :GPPARMS
 JSR MLIERR
:PFOK LDX #1
]LOOP INX
 CPX :PREFIX
 BEQ :MASTER
 LDA :PREFIX,X
 AND #%0111_1111
 CMP #'/'
 BNE ]LOOP
:MASTER STX :PREFIX

 MLI_GET_FILE_INFO :GPARMS
 JSR MLIERR

 LDA :GPARMS+5 ;Calculate blocks free
 SEC
 SBC :GPARMS+8
 STA :FREE
 LDA :GPARMS+6
 SBC :GPARMS+9
 STA :FREE+1

 JSR PRINT
 ASC "Blocks free : "
 COLOR YELLOW
 DEC16 :FREE
 COLOR WHITE
 ASC "  Blocks used : "
 COLOR YELLOW
 DEC16 :GPARMS+8
 COLOR WHITE
 ASC "    Total blocks : "
 COLOR YELLOW
 DEC16 :GPARMS+5
 COLOR WHITE
 CR
 NULL

:ABORTZ LDA :PADFLAG
 STA PADFLAG
 LDA :PADCHAR
 STA PADCHAR
 MLI_CLOSE :CPARMS
 JSR MLIERR
:ABORT RTS

:FTYPES FILET $00;"NON"
 FILET $01;"BAD"
 FILET $04;"TXT"
 FILET $06;"BIN"
 FILET $0F;"DIR"
 FILET $19;"ADB"
 FILET $1A;"AWP"
 FILET $1B;"ASP"
 FILET $B0;"SRC"
 FILET $B1;"OBJ"
 FILET $B2;"LIB"
 FILET $B3;"S16"
 FILET $B5;"EXE"
 FILET $B6;"PIF"
 FILET $B7;"TIF"
 FILET $B8;"NDA"
 FILET $B9;"CDA"
 FILET $BA;"TOL"
 FILET $BB;"DRV"
 FILET $BD;"FST"
 FILET $BF;"DOC"
 FILET $C0;"PNT"
 FILET $C1;"PIC"
 FILET $C8;"FON"
 FILET $CA;"ICN"
 FILET $FC;"BAS"
 FILET $FD;"VAR"
 FILET $FF;"SYS"
 DFB 0,0

:GPPARMS DFB 1
 DA :PREFIX

:GPARMS DFB $A
 DA :PREFIX
 DS 15

:OPARMS DFB 3
 DA :PREFIX
 DA IOBUFFER
 DS 1

:RPARMS DFB 4
 DS 1
 DA :BUFFER
 DA $200
 DS 2

:CPARMS DFB 1
 DS 1

:PREFIX DS 1+63

:PADFLAG DS 1
:PADCHAR DS 1

:DTERMSAVE DS 1

:LOCKATTR DS 1
:FILE DS 1+15
:TYPE DS 1
:CRDATE DS 2
:CRTIME DS 2
:MODATE DS 2
:MODTIME DS 2
:BLOCKS DS 5

:CNTR DS 1
:FREE DS 2

:BUFFER DS $200

ENTRY_LENGTH DS 1
ENTRIES_PER_BLOCK DS 1
FILE_COUNT DS 2

BLOCK_ENTRIES DS 1
ACTIVE_ENTRIES DS 2
ENTRY_POINTER DS 2

 DS \
BUFFER DS 2048

* LST ON
*TEXTSAVE DS 1 ;$400 max required
* LST OFF

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/GAME.XR
 fin

 END
