*-------------------------------
* XMODEM send
*
* Modified by Sean Craig to work
* with The Complex II
*-------------------------------
 DAT
 LST OFF

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE VARS
 USE LIB.JMP

*-------------------------------
* XSEND - XMODEM download module
*         Copyright (c) 1990-1991 by Oz Data, written by Richard Bennett
*
* For use with Eclipse, although it may be modified for other uses.
*
* MLOAD "XSEND"
* USERCALL WITH filename$ COLLECT errcount xfermode$
*
* Sends the requested file to the user
*
* Errors: 0 = No errors, xfer worked ok!
*         1 = No file specified
*         2 = Timeout on xfer start command. User mucking around!
*         3 = No buffers available for disk reading. CLEAR some vars!
*         4 = Receiver response lost
*         5 = User cancelled the xfer
*         6 = No ACK received from the receiver in response to my block
*     AE: 7 = No NAK received from the receiver in response to my AE request
*     AE: 8 = Receiver getting errors trying to receive the AE block
*     AE: 9 = Timeout waiting for receiver to ACK the AE extension block
*         MLI errors intact
*-------------------------------

INCR3 MAC
 INC ]1
 BNE OK
 INC ]1+1
 BNE OK
 INC ]1+2
OK <<<
LXA MAC ; LXA location
 LDX ]1
 LDA ]1+1
 <<<
LXADR MAC
 LDX #<]1
 LDA #>]1
 <<<
STXA MAC ; STXA location
 STX ]1
 STA ]1+1
 <<<
INXA MAC
INCXA MAC
 INX
 BNE OK
 INC
OK <<<

USERWORK EQU $60

UERR_DATATYPE = 91 ;For user modules
UERR_PARMCOUNT = 92

 DUM USERWORK
CRCMODE DS 1 ;CRCMODE on/off
AEMODE DS 1 ;AEMODE on/off
RETRIES DS 1 ;Retry counter
STACK DS 1 ;Entry/exit stack
EXTENDCNT DS 1 ;AE extension retry counter
BLOCKS ADR 0 ;Total xfer blocks in file
BLOCKUPTO ADR 0 ;Current block in progress
T1 DS 1 ;Anything
PTR DA 0 ;Anything
SENDADR DA 0 ;Address of current block
SUM DS 1
HERTZMOD DS 1
CRC1 DS 1
CRC2 DS 1
OUTSAVE DS 1
SAVECV DS 1
SAVECH DS 1
SAVECHARSET DS 1
 DEND

SOH = 1
EOT = 4
ACK = 6
NAK = $15
SYN = $16
ETB = $17
CAN = $18
CRC = 'C' ;$43
ZAP = $1A

ERR_NOFILE = 1
ERR_TIMEOUT = 2
ERR_NOBUFFAVAIL = 3
ERR_RECLOST = 4
ERR_USERCANX = 5
ERR_NOACK = 6
ERR_NONAKAE = 7
ERR_BLKERRAE = 8
ERR_TIMEOUTAE = 9

ZAPPER = 1 ;Zap unused bytes in last block with $1A?

ALTCHARSET EQU $C01E
SETALTCHAR EQU $C00F
CLRALTCHAR EQU $C00E

*-------------------------------

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/GAME.XSEND
 fin

 MODID "GAME.XSEND"

START JSR PRINT
 COLOR WHITE
 HOME
 PRPAUSE 1
 ASC "The XMODEM routines used here are "
 ASC "Copyright (c) 1990-1991 by Oz Data, written by Richard Bennett"
 ASC " and are used here by permission."
 CR
 CR
 LINE "ShrinkIT is a trademark of Andrew E. Nicholas."
 CR
 CR
 LINE "** Notes : sound has not changed from previous version;"
 LINE "         : transfers use 128 byte blocks only."
 NULL
 MLI_GET_FILE_INFO TPGPARMS
 JSR MLIERR
 MLI_GET_FILE_INFO TP2EGPARMS
 JSR MLIERR
 MLI_GET_FILE_INFO SNDGPARMS
 JSR MLIERR
 MLI_GET_FILE_INFO MACGPARMS
 JSR MLIERR
 JSR FIXBLOCKS
 JSR PRINT
 CR
 ASC "A) Apple IIGS terminal program (ShrinkIT format; "
 DEC16 TPBLOCKS
 ASC " blocks; "
 DATE TPDATE
 LINE ")"
 ASC "B) Apple IIe terminal program (ShrinkIT format; "
 DEC16 TP2EBLOCKS
 ASC " blocks; "
 DATE TP2EDATE
 LINE ")"
 ASC "C) Digitized sound (ShrinkIT format; "
 DEC16 SNDBLOCKS
 ASC " blocks; "
 DATE SNDDATE
 LINE ")"
 ASC "D) Mac terminal program (self-extracting archive; "
 DEC16 MACBLOCKS
 ASC " blocks; "
 DATE MACDATE
 LINE ")"
 CR
 ASC "Select method, or [ESC] to abort transfer : "
 NULL
 GETLINE #1
 BCSL ESCAPE2
 CPX #0
 BEQL START
 LDA $200
 JSR UPPER
 CMP #"A"
 BEQ :FILE1
 CMP #"B"
 BEQ :FILE2
 CMP #"C"
 BEQ :FILE3
 CMP #"D"
 BEQ :FILE4
 JMP START

:FILE1 LDA #<DATA1
 STA :DATA
 LDA #>DATA1
 STA :DATA+1
 BRA :CONT

:FILE2 LDA #<DATA2
 STA :DATA
 LDA #>DATA2
 STA :DATA+1
 BRA :CONT

:FILE3 LDA #<DATA3
 STA :DATA
 LDA #>DATA3
 STA :DATA+1
 BRA :CONT

:FILE4 LDA #<DATA4
 STA :DATA
 LDA #>DATA4
 STA :DATA+1

:CONT STZ :PNTR
]LOOP LDA :DATA
 CLC
 ADC :PNTR
 TAX
 LDA :DATA+1
 ADC #0
 STX PTR
 STA PTR+1
 LDY #1 ;Parameter count
 JSR GOGO
 JSR CLOSEIT ;Just in case..
 JSR PRINT
 PRPAUSE 4
 CURSORON
 CR
 PRTABLE LASTERROR;ERRTABLE
 LINE ". "
 CR
 NULL
 GETRETURN
 LDA :DATA
 STA PTR
 LDA :DATA+1
 STA PTR+1
 INC :PNTR
 LDY :PNTR
 LDA (PTR),Y
 SEC
 ADC :PNTR
 STA :PNTR
 TAY
 LDA (PTR),Y
 BNE ]LOOP

 LDA LASTERROR
 BEQ :ORRITE
 JSR PRINT
 HOME
 PRPAUSE 2
 HOME
 ASC "Transfer unsuccessful. "
 NULL
 GETRETURN
 JMP START

:ORRITE JSR PRINT
 HOME
 PRPAUSE 2
 HOME
 ASC "Transfer complete. "
 NULL
 GETRETURN
 JMP GORETURN

:PNTR DS 1
:DATA DS 2

TENTRY MAC
HERE STR ]1
 DS HERE-*+]LEN+1
 <<<

]LEN = 32
ERRTABLE DFB ]LEN
 TENTRY "Transfer OK"
 TENTRY "No file specified"
 TENTRY "Timed out"
 TENTRY "No buffers available"
 TENTRY "Response lost"
 TENTRY "Transfer cancelled"
 TENTRY "No ACK received"
 TENTRY "No NAK received"
 TENTRY "AE block receive error"
 TENTRY "No ACK for AE block received"
 TENTRY "File skipped"

ESCAPE PLA
 PLA
ESCAPE2 JSR PRINT
 HOME
 PRPAUSE 4
 HOME
 ASC "Transfer aborted. "
 NULL
 GETRETURN
 JMP GORETURN

GOGO STX :X
 STA :A
 STY :Y
 INCR PTR
 LDY #0
 LDA (PTR),Y
 STA PATHNAME
]LOOP INY
 LDA (PTR),Y
 ORA #%1000_0000
 STA PATHNAME,Y
 CPY PATHNAME
 BNE ]LOOP
 LDY #0
]LOOP INY
 LDA (PTR),Y
 ORA #%1000_0000
 CMP #"/"
 BNE ]LOOP
 LDX #0
]LOOP INY
 LDA (PTR),Y
 ORA #%1000_0000
 INX
 STA FNAME,X
 CPY PATHNAME
 BNE ]LOOP
 STX FNAME
 JSR PRINT
 HOME
 CR
 ASC "Sending : "
 QUOTE
 PRSTRING FNAME
 QUOTE
 CR
 CR
 LINE "[RETURN]-transfer this file"
 LINE "[ESC]-abort transfer"
 CR
 ASC "Select an option : "
 NULL
 DECR PTR
]LOOP JSR KEYIN
 CMP #$9B
 BEQ :ESC
* CMP #$89
* BEQ :SKIP
 CMP #$8D
 BNE ]LOOP
 JSR PRINT
 HOME
 CR
 ASC "Sending : "
 QUOTE
 PRSTRING FNAME
 QUOTE
 CR
 CR
 NULL
 LDX :X
 LDY :Y
 LDA :A
 BRA ENTRY

:ESC JSR PRINT
 ASC "ESC"
 NULL
 JMP ESCAPE

:SKIP LDA #10
 STA LASTERROR
 JSR PRINT
 ASC "TAB"
 NULL
 JMP EXITPLIST

:X DS 1
:A DS 1
:Y DS 1

*-------------------------------

 BRA ENTRY
 ASC "(c) 1990-1991 Oz Data. RJB 30-Dec-91"
ENTRY

* 1. Init variables

 CPY #1 ;Check parm count
 BEQ :PCOK
 LDA #UERR_PARMCOUNT
 STA LASTERROR
 JMP EXITPLIST
:PCOK
 STXA PTR
 LDA (PTR) ;Check datatype
 CMP #4
 BEQ :DTOK
 LDA #UERR_DATATYPE
 STA LASTERROR
 JMP EXITPLIST
:DTOK
* LXA PTR
* INXA
* JSR P3MAKEPSTR

 TSX
 STX STACK
 STZ CRCMODE ;No
 STZ AEMODE ;No
 STZ LASTERROR
 LDA HERTZ
 SEC
 SBC #5
 STA HERTZMOD ;To allow for code movements...
 LDA DUMBTERM
 STA DTERMSAVE
 LDA #$FF
 STA DUMBTERM
* LDA OUTFLAG
* STA OUTSAVE
* LDA #$80
* STA OUTFLAG
* JSR INITSCREEN

 LXA PTR ;Point FREEPTR to first filename
 INXA
 STXA FREEPTR

* LDA (FREEPTR) ;Get name length
* LDX FREEPTR+1
* SEC ;+1 to skip length
* ADC FREEPTR
* BCC :PTROK1
* INX
*:PTROK1 STA T1
* AND #$80
* CMP T1 ;On a boundary?
* BEQ :GOTBOUND
* CLC
* ADC #$80 ;Bump to next then
* BCC :GOTBOUND
* INX
*:GOTBOUND STA READADR ;Got the buffer start
* STX READADR+1
* EOR #$FF ;Trick- Subtract XA from MEMTOP to get buffer size
* SEC ;EOR $FFFF +1
* ADC MEMTOP
* STA READLEN
* TAY
* TXA
* EOR #$FF
* ADC MEMTOP+1
* STA READLEN+1
* PHP
* LDA #2
* PLP
* BMIL EXIT ;High byte minus, no room
* BNE :BUFFOK
* CPY #0
* BEQL EXIT ;Both zero, bang on no room...
*:BUFFOK

* 2. Open the file, get it's info and setup up xfer/buffer sizes

 LXA FREEPTR
 STXA PATHADR
 STXA GETINFOADR
 JSR $BF00
 HEX C8
 DA OPEN
 BCSL EXIT
 JSR $BF00
 HEX C4
 DA GETINFO
 BCSL EXITCLOSE
 LDA REFNUM
 STA GETEOFREF
 JSR $BF00
 HEX D1
 DA GETEOF
 BCSL EXITCLOSE

 LDA EOF
 ROL
 LDA EOF+1
 ROL
 STA BLOCKS
 LDA EOF+2
 ROL
 STA BLOCKS+1
 ROL
 AND #1
 STA BLOCKS+2
 LDA EOF ;Partial block left out?
 AND #$7F
 BEQ :BLKSDONE ;Add it in then....
 INC BLOCKS
 BNE :BLKSDONE
 INC BLOCKS+1
 BNE :BLKSDONE
 INC BLOCKS+2
:BLKSDONE

 JSR PRINT
 CURSOROFF
 NULL
 JSR PRBLOCKS

* 3. Read a buffer full

 LDA REFNUM
 STA REFR
 JSR XLOADFILE

* 4. Wait for user to send NAK (xfer start) or "C" (CRC start), then attempt
*    to start up in AE extension mode. Fall through once a method has been
*    decided.

:STARTWAIT LDA #6 ;60 seconds timeout (6 lots of 10 seconds)
 STA RETRIES
:WAITLOOP JSR TIMEGET ;Get with 10 second timeout
 JSR CHECKCANX
 BCC :GOTSTART
 DEC RETRIES
 BNE :WAITLOOP
 LDA #ERR_TIMEOUT
 JMP EXITCLOSE
:GOTSTART CMP #NAK
 BEQ :DOIT
 CMP #CAN
 BEQL :USERCANX
 CMP #CRC
 BEQ :CRCON
 JSR BUMPERR
 BRA :STARTWAIT
:CRCON DEC CRCMODE
:DOIT
 LDA #3 ;See if receiver is AE pro extension aware (x3)
 STA RETRIES
:SENDIB JSR CHECKCANX
 LDA #$80+SOH
 JSR MSENDBYTE ;MDRFORCE
 LDA #0
 JSR MSENDBYTE ;MDRFORCE
 LDA #$FF
 JSR MSENDBYTE ;MDRFORCE
:ACKWAIT JSR TIMEGET
 JSR CHECKCANX
 BCC :CHECKACKZ
 DEC RETRIES
 BNE :SENDIB
 BRA :DOXFER ;Obviously not
:CHECKACKZ CMP #ACK
 BEQ :DOAEFLAG
 CMP #CRC ;Didn't understand and send CRC again?
 BEQ :DOXFER ; help the guy out and assume CRC no-AEPRO
 DEC RETRIES
 BNE :SENDIB
 BRA :DOXFER
:DOAEFLAG DEC AEMODE ;No
:DOXFER

* 5. Send first block

 JSR PRMODES

 STZ BLOCKUPTO
 STZ BLOCKUPTO+1
 STZ BLOCKUPTO+2

:SENDNEXT

 LDA #10
 STA RETRIES

 INC BLOCKUPTO
 BNE :INCOK
 INC BLOCKUPTO+1
 BNE :INCOK
 INC BLOCKUPTO+2
:INCOK

 JSR BUMPBLK

:SENDBLOCK

 JSR CHECKCANX

 LDA #SOH
 JSR MSENDBYTE ;MDRFORCE
 LDA BLOCKUPTO
 JSR MSENDBYTE ;MDRFORCE
 LDA #255
 SEC
 SBC BLOCKUPTO
 JSR MSENDBYTE ;MDRFORCE

 BIT CRCMODE ;Which method?
 BPL :CKSUMODE

:CRCMODE STZ CRC1
 STZ CRC2
 LDY #0
]L1 PHY
 LDA (SENDADR),Y
 PHA
 JSR CRCCALC
 PLA
 JSR MSENDBYTE ;MDRFORCE
 PLY
 INY
 BPL ]L1
 LDA CRC1
 JSR MSENDBYTE ;MDRFORCE
 LDA CRC2
 JSR MSENDBYTE ;MDRFORCE
 BRA :JOIN

:CKSUMODE STZ SUM
 LDY #0
]L1 PHY
 LDA (SENDADR),Y
 PHA
 CLC
 ADC SUM
 STA SUM
 PLA
 JSR MSENDBYTE ;MDRFORCE
 PLY
 INY
 BPL ]L1
 LDA SUM
 JSR MSENDBYTE ;MDRFORCE
:JOIN

* 6. Wait for acknowledgement

 JSR TIMEGET
 JSR CHECKCANX
 BCC :CHECKACK
 JSR BUMPERR
 DEC RETRIES
 BNE :SENDBLOCK
 LDA #ERR_RECLOST
 JMP EXITCLOSE
:CHECKACK CMP #ACK
 BEQ :NEXTBLOCK
:CHECKMORE CMP #CAN
 BEQ :USERCANX
 JSR BUMPERR
 DEC RETRIES
 BNEL :SENDBLOCK
 LDA #ERR_NOACK
 JMP EXITCLOSE
:USERCANX LDA #ERR_USERCANX
 JMP EXITCLOSE

* 7. Do the next block

:NEXTBLOCK LDA BLOCKUPTO+2
 CMP BLOCKS+2
 BNE :CONTINUE
 LDA BLOCKUPTO+1
 CMP BLOCKS+1
 BNE :CONTINUE
 LDA BLOCKUPTO
 CMP BLOCKS
 BEQ :DONESEND
:CONTINUE
 LDA SENDADR
 EOR #$80
 STA SENDADR
 BNE :BUMPOK
 INC SENDADR+1
:BUMPOK LDA SENDADR+1 ;Finished this buffer
 CMP #>MEMTOP
 BNEL :SENDNEXT
 LDA SENDADR
 CMP #<MEMTOP
 BNEL :SENDNEXT
 JSR XLOADFILE
 JMP :SENDNEXT
:DONESEND

* 8. Signal end of xfer

 LDA #10
 STA RETRIES

:EOTACK LDA #EOT
 JSR MSENDBYTE ;MDRFORCE
 JSR TIMEGET
 BCS :NOEOT
 CMP #ACK
 BEQ :GOTEOTACK
:NOEOT JSR BUMPERR
 DEC RETRIES
 BNE :EOTACK
 LDA #ERR_NOACK
 JMP EXIT

:GOTEOTACK BIT AEMODE
 BMI :DOAE
 JMP EXITOK

* 9. Do the AE pro extension

:DOAE JSR TIMEGET ;If SYN then continue. If not then I've timed out
; 10 seconds and can continue anyway.

 LDA #3
 STA RETRIES
 LDA #ETB
 JSR MSENDBYTE ;MDRFORCE
:RETRYAE JSR TIMEGET
 BCC :GOTAE
:TESTRAE JSR BUMPERR
 DEC RETRIES
 BNE :RETRYAE
 LDA #ERR_NONAKAE
 JMP EXITCLOSE
:GOTAE CMP #NAK
 BNE :TESTRAE

 LDA #$D4
 STA GETINFO+1
 LDA #$41
 STA GETINFO+2
 LDA #0
 STA GETEOF+1

 LDA #3
 STA RETRIES
:SENDAE JSR CHECKCANX
 LDA #SOH
 JSR MSENDBYTE ;MDRFORCE
 LDA #$AA
 JSR MSENDBYTE ;MDRFORCE
 LDA #$55
 JSR MSENDBYTE ;MDRFORCE
 BIT CRCMODE
 BPL :AESUM
:AECRC STZ CRC1
 STZ CRC2
 LDX #0
]L1 PHX
 LDA GETINFO,X
 PHA
 JSR CRCCALC
 PLA
 JSR MSENDBYTE ;MDRFORCE
 PLX
 INX
 CPX #23
 BCC ]L1
]L1 PHX
 LDA #$1A
 JSR CRCCALC
 LDA #$1A
 JSR MSENDBYTE ;MDRFORCE
 PLX
 INX
 BPL ]L1
 LDA CRC1
 JSR MSENDBYTE ;MDRFORCE
 LDA CRC2
 JSR MSENDBYTE ;MDRFORCE
 BRA :JOINAE

:AESUM STZ SUM
 LDX #0
]L1 LDA GETINFO,X
 PHA
 CLC
 ADC SUM
 STA SUM
 PLA
 PHX
 JSR MSENDBYTE ;MDRFORCE
 PLX
 INX
 CPX #23
 BCC ]L1
]L1 PHX
 LDA #$1A
 CLC
 ADC SUM
 STA SUM
 LDA #$1A
 JSR MSENDBYTE ;MDRFORCE
 PLX
 INX
 BPL ]L1
 LDA SUM
 JSR MSENDBYTE ;MDRFORCE
:JOINAE
 JSR TIMEGET
 JSR CHECKCANX
 BCC :CHECKAE
 JSR BUMPERR
 DEC RETRIES
 BNEL :SENDAE
 LDA #ERR_TIMEOUTAE
 JMP EXITCLOSE
:CHECKAE CMP #ACK
 BEQ :FINAE
 JSR BUMPERR
 DEC RETRIES
 BNEL :SENDAE
 LDA #ERR_BLKERRAE
 JMP EXITCLOSE
:FINAE JMP EXITOK

* Subroutines

* TIMEGET exits if no character is received within 10 seconds of entering
*  with carry reflecting the status
TIMEGET LDX #10 ;10 second timeout
:TOP LDY HERTZMOD ;for a second
 PHX
:WVBL PHY
]L1 JSR CHECKIN2 ;MDRGET
 BCS :GOTRESP
 BIT $C019
 BMI ]L1
]L1 JSR CHECKIN2 ;MDRGET
 BCS :GOTRESP
 BIT $C019
 BPL ]L1
 PLY
:NEXTVBL DEY
 BNE :WVBL
 PLX
 DEX
 BPL :TOP
:GET1 SEC
 RTS
:GOTRESP PLY
 PLX
 CLC
 RTS

CRCCALC STA T1
 LDA #0
 LDX #8
]L1 ASL T1
 ROR
 AND #$80
 EOR CRC1
 ASL CRC2
 ROL
 BCC :NEXT
 PHA
 LDA CRC2
 EOR #$21
 STA CRC2
 PLA
 EOR #$10
:NEXT STA CRC1
 DEX
 BNE ]L1
 RTS

EXITCLOSE PHA
 JSR CLOSEIT
 PLA
EXIT STA LASTERROR
 LDA #CAN
 JSR MSENDBYTE ;MDRFORCE
EXITOK ;JSR RESTSCREEN
* LDA OUTSAVE
* STA OUTFLAG
 LDA DTERMSAVE
 STA DUMBTERM
 LDX STACK
 TXS
EXITPLIST LXADR PLIST
 LDY #2
 RTS

CHECKCANX PHP
 PHA
 LDA $C000
 BPL :OUT
 STA $C010
 CMP #$9B
 BNE :OUT
:DOCANX LDA #CAN
 JSR MSENDBYTE ;MDRFORCE
 LDA #ERR_USERCANX
 JMP EXITCLOSE
:OUT PLA
 PLP
 RTS

CLOSEIT LDA REFNUM
 STA CLOSE+1
 JSR $BF00
 HEX CC
 DA CLOSE
 RTS

XLOADFILE JSR $BF00
 HEX CA
 DA READ
 BCS EXITCLOSE
 do ZAPPER
 LDA READXFER+1 ;High the same?
 CMP READLEN+1
 BCC :NOTALL
 LDA READXFER
 CMP READLEN
 BEQ :DONE
:NOTALL LDA READXFER ;Must be less of course!
 AND #$7F
 BEQ :DONE ;Must be multiple of 128
 TAY
 LDA READADR
 CLC
 ADC READXFER
 AND #$80
 STA PTR
 LDA READADR+1
 ADC READXFER+1
 STA PTR+1
 LDA #$1A
]L1 STA (PTR),Y
 INY
 BPL ]L1
 fin
:DONE LXA READADR
 STXA SENDADR
 RTS

* MLI parameters

OPEN DFB 3
PATHADR DA 0
 DA IOBUFFER
REFNUM DFB 0

CLOSE DFB 1,0

*------------------------------- This chunk sent as block
GETINFO DFB $A
GETINFOADR DA 0
 DS 1
FILETYPE DS 1
AUXTYPE DA 0
 DS 1
BLKS DA 0
 DS 2+2+2+2

GETEOF DFB 2
GETEOFREF DS 1
EOF ADR 0
*-------------------------------

READ DFB 4
REFR DS 1
READADR DA READBUFF
READLEN DA 2048
READXFER DA 0

*-------------------------------
* Screen stuff from here down

*INITSCREEN LDA CV
* STA SAVECV
* LDA CH
* STA SAVECH
* ROL ALTCHARSET
* ROR SAVECHARSET
* LDA #TEXTSAVE
* STA PTR
* LDA #>TEXTSAVE
* STA PTR+1
* LDA #6
* STA CV
* LDA #20
* STA CH
*]L1 SCRPICK
* STA (PTR)
* INCR PTR
* INC CH
* LDA CH
* CMP #60
* BCC ]L1
* LDA #20
* STA CH
* INC CV
* LDA CV
* CMP #18
* BCC ]L1
* LDA #6
* STA CV
* LDA #21
* STA CH
* LDA #"_"
* LDX #59
* JSR :LINE
* INC CV
*]L1 LDA #20
* STA CH
* LDA #$5A
* SCRPUT
* INC CH
* LDA #$A0
* LDX #59
* JSR :LINE
* LDA #$5F
* SCRPUT
* INC CV
* LDA CV
* CMP #17
* BCC ]L1
* LDA #21
* STA CH
* LDA #$4C
* LDX #59
* JSR :LINE
* LDA #8
* STA CV
* LDA #34
* STA CH
* JSR P3PRINT
* ASC "XMODEM/Send",00
* INC CV
* LDA #34
* STA CH
* LDA #$4C
* LDX #45
* JSR :LINE
* INC CV
* LDA #22
* STA CH
* JSR P3PRINT
* ASC "File: "
* DFB '"'.$80,0
* LDA (FREEPTR)
* BEQ :NOPATH
* LDY #0
*]L1 INY
* LDA (FREEPTR),Y
* STA :MOD1
* PHY
* JSR P3PRINT
*:MOD1 DFB 0,0
* PLY
* TYA
* CMP (FREEPTR)
* BNE ]L1
*:NOPATH JSR P3PRINT
* DFB '"'.$80,0
* RTS
*:LINE PHX
* SCRPUT
* INC CH
* PLX
* CPX CH
* BNE :LINE
* RTS

*RESTSCREEN LDA #TEXTSAVE
* STA PTR
* LDA #>TEXTSAVE
* STA PTR+1
* LDA #6
* STA CV
* LDA #20
* STA CH
*]L1 LDA (PTR)
* SCRPUT
* INCR PTR
* INC CH
* LDA CH
* CMP #60
* BCC ]L1
* LDA #20
* STA CH
* INC CV
* LDA CV
* CMP #18
* BCC ]L1
* LDA SAVECH
* STA CH
* LDA SAVECV
* STA CV
* RTS

PRBLOCKS LDA BLOCKS
 STA :BLOCKS
 LDA BLOCKS+1
 STA :BLOCKS+1
 LDA BLOCKS+2
 STA :BLOCKS+2
 LDA DUMBTERM
 PHA
 STZ DUMBTERM
 JSR PRINT
 DEC32 :BLOCKS
 ASC " blocks"
 NULL
 PLA
 STA DUMBTERM
 JSR PRINT
:V GOTOXY 31;10
 ASC "Blocks : "
 DEC32 :BLOCKS
 CR
 HTAB 30
 LINE "Sending :"
 HTAB 30
 LINE " Errors :"
 HTAB 30
 LINE "   Mode :"
 NULL
 LDA :V+3
 INC
 STA BLKCV
 INC
 STA ERRCV
 INC
 STA MODECV
 RTS
:BLOCKS DS 4

*PRBLOCKS LXA BLOCKS
* LDY BLOCKS+2
* JSR P3FREEDEC
* INC CV
* INC CV
* LDA #31
* STA CH
* JSR P3PRINT
* ASC "Blocks:",00
* LDA #48
* SEC
* SBC (FREEPTR)
* STA CH
* LDY #1
*]L1 INY
* LDA (FREEPTR),Y
* PHY
* ORA #$80
* SCRPUT
* INC CH
* PLY
* TYA
* DEC
* CMP (FREEPTR)
* BCC ]L1
* INC CV
* LDA #31
* STA CH
* JSR P3PRINT
* ASC "Sending:",00
* LDA CV
* STA BLKCV
* LDA #47
* STA CH
* LDA #"0"
* SCRPUT
* INC CV
* LDA #31
* STA CH
* JSR P3PRINT
* ASC "Errors:",00
* LDA CV
* STA ERRCV
* LDA #47
* STA CH
* LDA #"0"
* SCRPUT
* INC CV
* LDA #31
* STA CH
* JSR P3PRINT
* ASC "Mode:",00
* LDA CV
* STA MODECV
* RTS

BLKCV DS 1
MODECV DS 1
ERRCV DS 1

PRMODES LDA #48
 STA XCH
 LDA MODECV
 STA XCV
 STA :HV1+3
 STA :HV2+3
 STA :HV3+3
 LDA AEMODE
 ORA CRCMODE
 BNE :DOMODES
 LDA #48-8
 STA XCH
 STA :HV1+2
 JSR PRINT
:HV1 GOTOXY 0;0
 ASC "Standard"
 NULL
 LDA CH
 STA XCH
 RTS
:DOMODES BIT AEMODE
 BPL :NOAE
 LDA XCH
 SEC
 SBC #2
 STA XCH
 STA :HV2+2
 JSR PRINT
:HV2 GOTOXY 0;0
 ASC "AE"
 NULL
 LDA CH
 STA XCH
 LDA #'A'
 STA PLISTMODES
 LDA XCH
 SEC
 SBC #3
 STA XCH
:NOAE BIT CRCMODE
 BPL :NOCRC
 LDA XCH
 SEC
 SBC #3
 STA XCH
 STA :HV3+2
 JSR PRINT
:HV3 GOTOXY 0;0
 ASC "CRC"
 NULL
 LDA CH
 STA XCH
 LDA #'C'
 STA PLISTMODES+1
 LDA XCH
 SEC
 SBC #4
 STA :HTAB+2
:NOCRC JSR PRINT
:HTAB HTAB 0
 NULL
 LDA CH
 STA XCH
 RTS

BUMPERR INCR3 PLISTERRS
 LDA ERRCV
 STA XCV
 BRA BUMPVAL
BUMPBLK LDA BLKCV
 STA XCV
BUMPVAL LDA #47
 STA XCH
]L1 JSR SCRPICK
 CMP #" "
 BNE :SKIP
 LDA #"0"
:SKIP CMP #"9"
 BCC :INC
 LDA #"0"
 JSR SCRPUT
 DEC XCH
 BRA ]L1
:INC INC
 JSR SCRPUT
 RTS

LASTERROR DS 1
FREEPTR DS 2

XCH DS 1
XCV DS 1

HERTZ DFB 60

PLIST DFB 1 ;ERRORS numeric
 DFB 0 ; sign
PLISTERRS DS 3,0 ; low/mid/high
 DFB 4 ;MODE gstring
 DA 2 ; length word
PLISTMODES ASC '  ' ; 'AC'

*TEXTSAVE DS $400 ;$400 max required

*-------------------------------
SCRPICK LDX XCH
 LDY XCH
 LDA XCV
 JSR PICKLINE
 LDA $200
 RTS

SCRPUT STA :CHAR
 LDA CH
 STA :HV2+2
 LDA CV
 STA :HV2+3
 LDA XCH
 STA :HV1+2
 LDA XCV
 STA :HV1+3
 JSR PRINT
:HV1 GOTOXY 0;0
:CHAR DS 1
:HV2 GOTOXY 0;0
 NULL
 RTS

GORETURN JSR EXITPLIST
 RETURN

FIXBLOCKS JSR CLOSEALL
 LDX #<DATA1+1
 LDA #>DATA1+1
 JSR :GETBLKS
 STX TPBLOCKS
 STA TPBLOCKS+1
 LDX #<DATA2+1
 LDA #>DATA2+1
 JSR :GETBLKS
 STX TP2EBLOCKS
 STA TP2EBLOCKS+1
 LDX #<DATA3+1
 LDA #>DATA3+1
 JSR :GETBLKS
 STX SNDBLOCKS
 STA SNDBLOCKS+1
 LDX #<DATA4+1
 LDA #>DATA4+1
 JSR :GETBLKS
 STX MACBLOCKS
 STA MACBLOCKS+1
 RTS

:GETBLKS STX :PATHPTR
 STA :PATHPTR+1
 MLI_OPEN :OPARMS
 JSR MLIERR
 LDA :OPARMS+5
 STA :EPARMS+1
 STA :CPARMS+1
 MLI_GET_EOF :EPARMS
 JSR MLIERR
 MLI_CLOSE :CPARMS
 JSR MLIERR
 LDA :EOF
 ROL
 LDA :EOF+1
 ROL
 STA :BLOCKS
 LDA :EOF+2
 ROL
 STA :BLOCKS+1
 ROL
 AND #1
 STA :BLOCKS+2
 LDA :EOF ;Partial block left out?
 AND #$7F
 BEQ :BLKSDONE ;Add it in then....
 INC :BLOCKS
 BNE :BLKSDONE
 INC :BLOCKS+1
 BNE :BLKSDONE
 INC :BLOCKS+2
:BLKSDONE LDX :BLOCKS
 LDA :BLOCKS+1
 RTS

:OPARMS DFB 3
:PATHPTR DA *
 DA IOBUFFER
 DS 1

:EPARMS DFB 2
 DS 1
:EOF DS 3

:CPARMS DFB 1
 DS 1

:BLOCKS DS 3

DTERMSAVE DS 1 ;Dumbterm save flag

PATHNAME DS 1+15

FNAME DS 1+31

DATA1 DFB 4 ;Data type 4 = string
 STR 'DRAWER/TERM.GS.SHK'
 DFB 0

DATA2 DFB 4
 STR 'DRAWER/TERM.2E.SHK'
 DFB 0

DATA3 DFB 4
 STR 'DRAWER/TERM.SND.SHK'
 DFB 0

DATA4 DFB 4
 STR 'DRAWER/TERM.MAC.SEA'
 DFB 0

TPGPARMS DFB $A
 DA DATA1+1
 DS 5
TPBLOCKS DS 2
TPDATE DS 2
 DS 6

TP2EGPARMS DFB $A
 DA DATA2+1
 DS 5
TP2EBLOCKS DS 2
TP2EDATE DS 2
 DS 6

SNDGPARMS DFB $A
 DA DATA3+1
 DS 5
SNDBLOCKS DS 2
SNDDATE DS 2
 DS 6

MACGPARMS DFB $A
 DA DATA4+1
 DS 5
MACBLOCKS DS 2
MACDATE DS 2
 DS 6

 DS \
READBUFF DS 2048
MEMTOP EQU *

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/GAME.XSEND
 fin

 END
