*-------------------------------
* GLOSS.EDITOR
*-------------------------------
 DAT
 LST OFF

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE VARS
 USE LIB.JMP
 USE GLOSS.DSECT

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/GLOSS.EDITOR
 fin

 MODID "GLOSS.EDITOR"

START JSR PRINT
 HOME
 CURSORON
 CENTER "Glossary Editor"
 GOTOXY 0;3
 INVERSE
 COLOR YELLOW
 ZAPLINE
 GOTOXY 0;22
 ZAPLINE
 NORMAL
 CR
 COLOR WHITE
 NULL
 JSR DISPBOT
 LDA CH
 STA BOTCH+2

 JSR SETXY

 MLI_OPEN OPARMS
 JSR MLIERR
 LDA OPARMS+5
 STA RWPARMS+1
 STA MPARMS+1
 STA CPARMS+1

 MLI_READ RWPARMS
 JSR MLIERR
 LDA MISCBUFF
 STA TOTWORDS
 LDA MISCBUFF+1
 STA TOTWORDS+1

 STZ GLLEN
 STZ GLLEN+1
 STZ GLWORD

 CLC
 XCE
 REP #$30
 LDA #GLRECLEN
 SEC
 SBC #20
 STA MAXLEN
 SEC
 XCE

TOP LDA CURRWORD
 ORA CURRWORD+1
 BNE :OK
 STZ GLWORD
:OK JSR PRINT
 GOTOXY 0;2
 ZAPLINE
 ASC "Word : "
 COLOR AQUAMARINE
 PRSTRING GLWORD
 COLOR WHITE
 GOTOXY 55;0
 ASC "Current : "
 CLEOL
 COLOR YELLOW
 DEC16 CURRWORD
 COLOR WHITE
 GOTOXY 55;1
 ASC "Total   : "
 COLOR YELLOW
 DEC16 TOTWORDS
 COLOR WHITE
 NULL
 JSR PRLEN

BOT JSR PRINT
BOTCH GOTOXY 0;23
 CLEOL
 NULL

]LOOP JSR KEYIN
 JSR UPPER
 LDX :KEYS
]LOOP2 CMP :KEYS,X
 BEQ :GOTONE
 DEX
 BNE ]LOOP2
 JMP ]LOOP
:GOTONE DEX
 TXA
 ASL
 TAX
 JMP (:TABLE,X)

:KEYS DFB :ENDKEYS-*-1
 DFB $9B
 DFB "A"
 DFB "L"
 DFB "S"
 DFB "I"
 DFB "W"
 DFB "Q"
 DFB "H"-$40
 DFB "U"-$40
 DFB "G"
 DFB "H"
 DFB "O"
:ENDKEYS

:TABLE DA JUMP
 DA ADD
 DA LOAD
 DA SAVE
 DA INDEX
 DA WORD
 DA EXIT
 DA LEFT
 DA RIGHT
 DA GOTO
 DA HELP
 DA ORDER

ORDER LDA CURRWORD ;Sort glossary words in alphabetical order
 STA :CWORD
 LDA CURRWORD+1
 STA :CWORD+1
 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 COLOR PINK
 ASC "Sorting.."
 COLOR WHITE
 NULL
 LDA TOTWORDS
 STA CURRWORD
 LDA TOTWORDS+1
 STA CURRWORD+1
]LOOP LDA CURRWORD+1
 BNE :OK
 LDA CURRWORD
 CMP #1
 BEQL :DONE
:OK JSR DOMARK
 MLI_READ RWPARMS
 JSR MLIERR

 LDX GLWORD
 BEQL :BLANK
 STX :WORD
]LOOP2 LDA GLWORD,X
 JSR UPPER
 STA :WORD,X
 DEX
 BNE ]LOOP2

 LDA CURRWORD ;Remember where we are
 STA :BENCH
 LDA CURRWORD+1
 STA :BENCH+1

 STZ CURRWORD
 STZ CURRWORD+1

]LOOP2 LDA CURRWORD+1
 CMP :BENCH+1
 BNE :OK2
 LDA CURRWORD
 CMP :BENCH
 BEQL :OUT
:OK2 INCR CURRWORD
 JSR DOMARK
 MLI_READ RWPARMS
 JSR MLIERR
 LDX GLWORD
 BEQ :SWAP
 LDX #0
]LOOP3 LDA :WORD+1,X
 JSR UPPER
 CMP GLWORD+1,X
 BCC :SWAP
 BEQ :NX
 BCS ]LOOP2
:NX INX
 CPX :WORD
 BEQ :CHEKL
 CPX GLWORD
 BNE ]LOOP3
:CHEKL LDX :WORD
 CPX GLWORD
 BCS ]LOOP2
:SWAP CLC ;Move current word to 'storage'
 XCE
 REP #$10
 SEP #$20
 LDX #GLRECLEN
]LOOP3 LDA MISCBUFF,X
 STA BUFFER,X
 DEX
 BNE ]LOOP3
 SEC
 XCE
 PUSH CURRWORD
 LDA :BENCH ;Read other word
 STA CURRWORD
 LDA :BENCH+1
 STA CURRWORD+1
 JSR DOMARK
 MLI_READ RWPARMS
 JSR MLIERR
 PULL CURRWORD
 JSR DOMARK ;Save other word in lower position
 MLI_WRITE RWPARMS
 CLC ;Move 'storage' word back
 XCE
 REP #$10
 SEP #$20
 LDX #GLRECLEN
]LOOP3 LDA BUFFER,X
 STA MISCBUFF,X
 DEX
 BNE ]LOOP3
 SEC
 XCE
 PUSH CURRWORD
 LDA :BENCH ;Write 'storage' word
 STA CURRWORD
 LDA :BENCH+1
 STA CURRWORD+1
 JSR DOMARK ;Save 'storage' word in higher position
 MLI_WRITE RWPARMS
 PULL CURRWORD
 JMP ]LOOP2

:OUT LDA :BENCH
 STA CURRWORD
 LDA :BENCH+1
 STA CURRWORD+1

:BLANK DECR CURRWORD
 JMP ]LOOP

:DONE LDA :CWORD
 STA CURRWORD
 LDA :CWORD+1
 STA CURRWORD+1
 JSR DISPBOT
 JMP LOAD2
:CWORD DS 2
:WORD DS 1+15
:BENCH DS 2

GOTO LDA TOTWORDS
 ORA TOTWORDS+1
 BEQL BOT
 JSR PRINT
 GOTOXY 0;2
 ZAPLINE
 ASC "Goto word : "
 NULL
 GETLINE #15
 CPX #0
 BEQL TOP
 STX :WORD
]LOOP LDA $200-1,X
 JSR UPPER
 STA :WORD,X
 DEX
 BNE ]LOOP
 JSR PRINT
 HTAB 0
 ZAPLINE
 ASC "Searching.."
 NULL
 LDA CURRWORD
 STA :CURR
 LDA CURRWORD+1
 STA :CURR+1
 STZ CURRWORD
 STZ CURRWORD+1
]LOOP LDA CURRWORD+1
 CMP TOTWORDS+1
 BNE :OK
 LDA CURRWORD
 CMP TOTWORDS
 BEQ :DONE
:OK INCR CURRWORD
 JSR DOMARK
 MLI_READ RWPARMS
 JSR MLIERR
 LDX GLWORD
 BEQ ]LOOP
 CPX :WORD
 BNE ]LOOP
]LOOP2 LDA GLWORD,X
 JSR UPPER
 CMP :WORD,X
 BNE ]LOOP
 DEX
 BNE ]LOOP2
 JMP LOAD2
:DONE LDA :CURR
 STA CURRWORD
 LDA :CURR+1
 STA CURRWORD+1
 JSR PRINT
 HTAB 0
 ZAPLINE
 COLOR PINK
 ASC "Not found. "
 COLOR WHITE
 NULL
 GETRETURN
 LDA CURRWORD
 ORA CURRWORD+1
 BEQL TOP
 JMP LOAD2
:WORD DS 1+15
:CURR DS 2

LEFT LDA CURRWORD+1
 BNE :YES
 LDA CURRWORD
 CMP #2
 BCCL BOT
:YES DECR CURRWORD
 JMP LOAD2

RIGHT LDA CURRWORD+1
 CMP TOTWORDS+1
 BNE :YES
 LDA CURRWORD
 CMP TOTWORDS
 BEQL BOT
:YES INCR CURRWORD
 JMP LOAD2

WORD LDA TOTWORDS
 ORA TOTWORDS+1
 BEQL BOT
 LDA CURRWORD
 ORA CURRWORD+1
 BEQL BOT
 JSR PRINT
 GOTOXY 0;2
 ZAPLINE
 ASC "Change word to : "
 NULL
 GETLINE #15
 BCSL TOP
 STX GLWORD
]LOOP CPX #0
 BEQ :DONE
 LDA $200-1,X
 STA GLWORD,X
 DEX
 BRA ]LOOP
:DONE JMP TOP

INDEX LDA TOTWORDS
 ORA TOTWORDS+1
 BEQL BOT
 LDA CURRWORD
 PHA
 LDA CURRWORD+1
 PHA
 STZ CURRWORD
 STZ CURRWORD+1
 JSR DOMARK
 MLI_READ RWPARMS
 JSR MLIERR
]LOOP2 JSR CLEAR
 JSR SETXY
]LOOP LDA CURRWORD+1
 CMP TOTWORDS+1
 BNE :OK
 LDA CURRWORD
 CMP TOTWORDS
 BEQ :DONE
:OK INCR CURRWORD
 MLI_READ RWPARMS
 JSR MLIERR
 JSR PRINT
 DEC16 CURRWORD
 HTAB 7
 PRSTRING GLWORD
 CR
 NULL
 LDA CV
 CMP BOTLINE
 BNE ]LOOP
 JSR PRINT
 COLOR PINK
 CENTER "[Any key continues; ESC-exit]"
 COLOR WHITE
 CURSOROFF
 NULL
 JSR KEYIN
 CMP #$9B
 BEQ :EXIT
 JMP ]LOOP2
:EXIT JSR CLEAR
 JSR PRINT
 CURSORON
 NULL
 PLA
 STA CURRWORD+1
 PLA
 STA CURRWORD
 JMP LOAD2
:DONE LDA BOTLINE
 STA :IHV+2
 JSR PRINT
:IHV VTAB 0
 COLOR PINK
 CENTER "[Press any key]"
 COLOR WHITE
 CURSOROFF
 NULL
 JSR KEYIN
 BRA :EXIT

JUMP LDA CURRWORD
 ORA CURRWORD+1
 BEQL BOT
 LDA XPOS
 STA :GOTO+2
 LDA YPOS
 STA :GOTO+3
 JSR PRINT
:GOTO GOTOXY 0;0
 NULL
 JMP EDIT

ADD JSR PRINT
 GOTOXY 0;2
 ZAPLINE
 ASC "Enter word to add : "
 NULL
 GETLINE #15
 CPX #0
 BEQL TOP
 STX GLWORD
]LOOP LDA $200-1,X
 STA GLWORD,X
 DEX
 BNE ]LOOP
 STZ GLLEN
 STZ GLLEN+1
 INCR TOTWORDS
 LDA TOTWORDS
 STA CURRWORD
 LDA TOTWORDS+1
 STA CURRWORD+1
 JSR CLEAR
 JSR SETXY
 STZ GLLEN
 STZ GLLEN+1
 JSR PRLEN
 JMP TOP

CLEAR JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 NULL
]LOOP JSR PRINT
 CURSORUP
 ZAPLINE
 NULL
 LDA CV
 CMP TOPLINE
 BNE ]LOOP
 RTS

HELP JSR CLEAR
 LDA TOPLINE
 STA :LINE
 LDA BOTLINE
 DEC
 STA :LINE+1
 JSR GETFILE
:LINE DFB 4,21 ;Use lines x to y
 STR "HELP/GLOSS.ED"
 JSR PRINT
 GOTOXY 0;21
 COLOR PINK
 CENTER "[Press any key]"
 COLOR WHITE
 NULL
 JSR KEYIN
 JSR CLEAR
 JSR CLOSEALL
 MLI_OPEN OPARMS
 JSR MLIERR
 LDA OPARMS+5
 STA RWPARMS+1
 STA MPARMS+1
 STA CPARMS+1
 JMP LOAD2

LOAD JSR PRINT
 ASC "L"
 NULL
LOAD2 LDA CURRWORD
 ORA CURRWORD+1
 BEQL BOT
 JSR CLEAR
 JSR DOMARK
 MLI_READ RWPARMS
 JSR MLIERR
 LDA TOPLINE
 STA :LINES
 LDA BOTLINE
 STA :LINES+1
 LDX GLLEN ;Length
 STX ZLEN
 LDA GLLEN+1
 STA ZLEN+1
 JSR SHOWMSG
:LINES DS 2 ;Lines to use (top, bottom)
 DA GLTEXT
 JSR SETXY
 JSR PRLEN
 JMP TOP

SAVE JSR PRINT
 ASC "S"
 NULL
SAVE2 LDA CURRWORD
 ORA CURRWORD+1
 BEQL BOT
 LDA TOPLINE
 STA :LINES
 LDA BOTLINE
 STA :LINES+1
 JSR GETSCREEN ;PICKLINE the screen
:LINES DS 2 ;on these lines
 DA GLTEXT ;and put it here
 STX GLLEN ;X and A have length on return
 STX ZLEN
 STA GLLEN+1
 STA ZLEN+1
 CMP MAXLEN+1
 BCC :LENOK
 LDA ZLEN
 CMP MAXLEN
 BCC :LENOK
 LDA MAXLEN
 STA GLLEN
 LDA MAXLEN+1
 STA GLLEN+1
:LENOK JSR DOMARK
 MLI_WRITE RWPARMS
 JSR MLIERR
 JSR PRLEN
 JMP TOP

EDIT LDA XPOS
 STA :GOTO+2
 LDA YPOS
 STA :GOTO+3
 JSR PRINT
:GOTO GOTOXY 0;0
 NULL
 LDX TOPLINE
 LDA BOTLINE
 JSR MSGEDIT
 LDA CH
 STA XPOS
 LDA CV
 STA YPOS
 JMP BOT

EXIT STZ CURRWORD
 STZ CURRWORD+1
 STZ GLLEN
 STZ GLLEN+1
 STZ GLWORD
 LDA TOTWORDS
 STA MISCBUFF
 LDA TOTWORDS+1
 STA MISCBUFF+1
 JSR DOMARK
 MLI_WRITE RWPARMS
 JSR MLIERR
 JSR CLOSEALL
 RETURN

OPARMS DFB 3
 DA PATH
 DA IOBUFFER
 DS 1

RWPARMS DFB 4
 DS 1
 DA MISCBUFF
 DA GLRECLEN
 DS 2

MPARMS DFB 2
 DS 1
 DS 4

CPARMS DFB 1
 DS 1

SETXY LDA :TOP
 STA XPOS
 LDA :TOP+1
 STA YPOS
 RTS
:TOP DFB 0,4

PRLEN LDA GLLEN+1
 CMP MAXLEN+1
 BCC :OK
 LDA GLLEN
 CMP MAXLEN
 BCC :OK
 LDX #1
 HEX 2C
:OK LDX #0
 LDA :NI,X
 STA :YEAH
 JSR PRINT
 GOTOXY 0;1
 ASC "Length $"
 COLOR YELLOW
:YEAH NORMAL
 HEX16 ZLEN
 COLOR WHITE
 NORMAL
 NULL
 RTS
:NI NORMAL
 INVERSE
ZLEN DS 2
MAXLEN DS 2

XPOS DS 1
YPOS DS 1

TOPLINE DFB 4
BOTLINE DFB 21

PATH STR "HELP/GLOSSARY"

CURRWORD DS 2
TOTWORDS DS 2

DISPBOT JSR PRINT
 GOTOXY 0;23
 ASC "[ESC]-jump, A)dd, L)oad, S)ave, I)ndex, W)ord, G)oto, "
 ASC "O)rder, H)elp, Q)uit : "
 NULL
 RTS

DOMARK CLC
 XCE
 REP #$30
 STZ MPARMS+2
 LDX CURRWORD
]LOOP CPX #0
 BEQ :DONE
 LDA MPARMS+2
 CLC
 ADC #GLRECLEN
 STA MPARMS+2
 LDA MPARMS+4
 ADC #0
 STA MPARMS+4
 DEX
 BRA ]LOOP
:DONE SEC
 XCE
 MLI_SET_MARK MPARMS
 JMP MLIERR

BUFFER DS GLRECLEN

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/GLOSS.EDITOR
 fin

 END
