*-------------------------------
* HELP.EDITOR
*-------------------------------
 DAT
 LST OFF

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE VARS
 USE LIB.JMP

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/HELP.EDITOR
 fin

 MODID "HELP.EDITOR"

START JSR PRINT
 HOME
 CURSORON
 CENTER "Help Editor"
 GOTOXY 0;3
 INVERSE
 COLOR YELLOW
 ZAPLINE
 GOTOXY 0;22
 ZAPLINE
 NORMAL
 CR
 COLOR WHITE
 ASC "[ESC]-jump, [F]ilename, [N]ew, [L]oad, [S]ave, [H]elp, "
 ASC "[I]ndex, [Q]uit : "
 NULL
 LDA CH
 STA BOTCH+2

 JSR SETXY

TOP JSR PRINT
 GOTOXY 0;2
 ASC "File : "
 CLEOL
 COLOR AQUAMARINE
 PRSTRING PATH
 COLOR WHITE
 NULL
 JSR PRLEN

BOT JSR PRINT
BOTCH GOTOXY 0;23
 CLEOL
 NULL

]LOOP JSR KEYIN
 JSR UPPER
 LDX :KEYS
]LOOP2 CMP :KEYS,X
 BEQ :GOTONE
 DEX
 BNE ]LOOP2
 JMP ]LOOP
:GOTONE DEX
 TXA
 ASL
 TAX
 JMP (:TABLE,X)

:KEYS DFB :ENDKEYS-*-1
 DFB $9B
 DFB "F"
 DFB "N"
 DFB "L"
 DFB "S"
 DFB "H"
 DFB "Q"
 DFB "I"
:ENDKEYS

:TABLE DA JUMP
 DA FNAME
 DA NEW
 DA LOAD
 DA SAVE
 DA HELP
 DA EXIT
 DA INDEX

INDEX JSR CLEAR
 MLI_GET_PREFIX :PFXPARMS
 JSR MLIERR
 LDX :PREFIX ;Add "HELP/" to end of prefix
 LDA :HPFX
 CLC
 ADC :PREFIX
 STA :PREFIX
 LDY #0
]LOOP INY
 LDA :HPFX,Y
 INX
 STA :PREFIX,X
 CPY :HPFX
 BNE ]LOOP

 MLI_OPEN :OPARMS
 JSR MLIERR
 LDA :OPARMS+5
 STA :RPARMS+1
 STA :CPARMS+1

 MLI_READ :RPARMS
 JSR MLIERR

 LDA BUFFER+$23
 STA ENTRY_LENGTH
 LDA BUFFER+$24
 STA ENTRIES_PER_BLOCK
 LDA BUFFER+$25
 STA FILE_COUNT
 LDA BUFFER+$26
 STA FILE_COUNT+1

 LDA ENTRY_LENGTH
 CLC
 ADC #4
 STA ENTRY_POINTER
 STZ ENTRY_POINTER+1

 LDA #2
 STA BLOCK_ENTRIES

 STZ ACTIVE_ENTRIES
 STZ ACTIVE_ENTRIES+1

:FREAD LDA ACTIVE_ENTRIES+1
 CMP FILE_COUNT+1
 BEQ :HMM
 BCSL :EXIT
:HMM LDA ACTIVE_ENTRIES
 CMP FILE_COUNT
 BCSL :EXIT

 CLC
 XCE
 REP #$10
 SEP #$20
 LDX ENTRY_POINTER
 LDA BUFFER,X ;Does the file exist?
 AND #$F0
 BEQ :SKIP ;No it doesn't.. so skip it
 SEC
 XCE
 JSR :PROCESS
 INCR ACTIVE_ENTRIES

:SKIP SEC
 XCE
 LDA ACTIVE_ENTRIES+1
 CMP FILE_COUNT+1
 BEQ :HMM2
 BCS :FREAD
:HMM2 LDA ACTIVE_ENTRIES
 CMP FILE_COUNT
 BCS :FREAD

 LDA BLOCK_ENTRIES
 CMP ENTRIES_PER_BLOCK
 BNE :DIFF

 MLI_READ :RPARMS
 JSR MLIERR
 LDA #1
 STA BLOCK_ENTRIES
 LDA #4
 STA ENTRY_POINTER
 STZ ENTRY_POINTER+1
 JMP :FREAD

:DIFF LDA ENTRY_POINTER
 CLC
 ADC ENTRY_LENGTH
 STA ENTRY_POINTER
 LDA ENTRY_POINTER+1
 ADC #0
 STA ENTRY_POINTER+1
 INC BLOCK_ENTRIES
 JMP :FREAD

:PROCESS CLC
 XCE
 REP #$10
 SEP #$20
 LDX ENTRY_POINTER
 LDA BUFFER+$10,X ;File type
 CMP #$04 ;TXT
 BNE :PRTS
 LDA BUFFER,X
 AND #$0F
 STA :FILE
 LDY #0
]LOOP INX
 LDA BUFFER,X
 ORA #%1000_0000
 INY
 STA :FILE,Y
 TYA
 CMP :FILE
 BNE ]LOOP
 SEC
 XCE
 JSR PRINT
 PRSTRING :FILE
 CR
 NULL
 LDA CV
 CMP BOTLINE
 BNE :PRTS
 JSR PRINT
 COLOR PINK
 CENTER "[SPACE]-continue, [ESC]-exit"
 COLOR WHITE
 NULL
 JSR KEYIN
 CMP #$9B
 BEQ :EXIT2
 JSR CLEAR
:PRTS SEC
 XCE
 RTS

:EXIT LDA BOTLINE
 STA :V+3
 JSR PRINT
:V GOTOXY 0;0
 COLOR PINK
 NULL
 GETRETURN
 JSR PRINT
 COLOR WHITE
 NULL
:EXIT2 MLI_CLOSE :CPARMS
 JSR MLIERR
 JSR CLEAR
 JMP LOAD2
:NCNTR DS 1
:FILE DS 1+15

:OPARMS DFB 3
 DA :PREFIX
 DA IOBUFFER
 DS 1

:RPARMS DFB 4
 DS 1
 DA BUFFER
 DA $200
 DS 2

:CPARMS DFB 1
 DS 1

:PFXPARMS DFB 1
 DA :PREFIX
:PREFIX DS 1+63

:HPFX STR 'HELP/'

ENTRY_LENGTH DS 1
ENTRIES_PER_BLOCK DS 1
FILE_COUNT DS 2

BLOCK_ENTRIES DS 1
ACTIVE_ENTRIES DS 2
ENTRY_POINTER DS 2

HELP JSR CLEAR
 LDA TOPLINE
 STA :LINE
 LDA BOTLINE
 STA :LINE2+3
 DEC
 STA :LINE+1
 JSR GETFILE
:LINE DFB 4,20 ;Use lines x to y
 STR "HELP/HELP.ED"
 JSR PRINT
:LINE2 GOTOXY 0;21
 COLOR PINK
 CENTER "[Press any key]"
 COLOR WHITE
 NULL
 JSR KEYIN
 JSR CLEAR
 JMP LOAD2

JUMP LDA XPOS
 STA :GOTO+2
 LDA YPOS
 STA :GOTO+3
 JSR PRINT
:GOTO GOTOXY 0;0
 NULL
 JMP EDIT

FNAME JSR PRINT
 GOTOXY 7;2
 CLEOL
 NULL
 GETLINE #63
 CPX #0
 BEQL TOP
 STX PATH
]LOOP LDA $200-1,X
 JSR UPPER
 STA PATH,X
 DEX
 BNE ]LOOP
 MLI_GET_FILE_INFO :GPARMS
 BCC :OK
 STA VTEMP
 CMP #$46 ;Not found
 BEQ :NOTHING
 JSR PRINT
 CR
 ZAPLINE
 COLOR PINK
 ASC "MLI error $"
 COLOR YELLOW
 HEX8 VTEMP
 COLOR PINK
 ASC ". "
 COLOR WHITE
 NULL
 GETRETURN
 JSR PRINT
 INVERSE
 COLOR YELLOW
 ZAPLINE
 NORMAL
 COLOR WHITE
 NULL
 STZ PATH
 JMP FNAME
:NOTHING STZ RWPARMS+6
 STZ RWPARMS+7
 JSR PRLEN
 JMP EDIT
:OK LDA :GPARMS+4
 CMP #$04 ;TXT file
 BEQ :OK2
 JSR PRINT
 CR
 ZAPLINE
 COLOR PINK
 ASC "File is not a TXT file. "
 COLOR WHITE
 NULL
 GETRETURN
 JSR PRINT
 INVERSE
 COLOR YELLOW
 ZAPLINE
 NORMAL
 COLOR WHITE
 NULL
 STZ PATH
 JMP FNAME
:OK2 JMP LOAD2

:GPARMS DFB $A
 DA PATH
 DS 15

NEW JSR PRINT
 COLOR PINK
 ASC "New?"
 COLOR WHITE
 NULL
 JSR KEYIN
 JSR UPPER
 CMP #"Y"
 BNEL BOT
 JSR PRINT
 CURSORLEFT
 CURSORLEFT
 CURSORLEFT
 CURSORLEFT
 CLEOL
 NULL
 JSR CLEAR
 JSR SETXY
 STZ RWPARMS+6
 STZ RWPARMS+7
 JSR PRLEN
 JMP EDIT

CLEAR JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 NULL
]LOOP JSR PRINT
 CURSORUP
 ZAPLINE
 NULL
 LDA CV
 CMP TOPLINE
 BNE ]LOOP
 RTS

LOAD LDA PATH
 BEQL BOT
 JSR PRINT
 ASC "Load"
 NULL
LOAD2 LDA PATH
 BEQL BOT
 LDA #<$500
 STA RWPARMS+4
 LDA #>$500
 STA RWPARMS+5
 JSR CLEAR
 MLI_OPEN OPARMS
 CMP #$46 ;Not found?
 BEQ :NEW
 JSR MLIERR
 LDA OPARMS+5
 STA RWPARMS+1
 STA CPARMS+1
 MLI_READ RWPARMS
 CMP #$4C ;EOF?
 BNE :OK
 CLC
 LDA #0
:OK JSR MLIERR
 MLI_CLOSE CPARMS
 JSR MLIERR
 LDA TOPLINE
 STA :LINES
 LDA BOTLINE
 STA :LINES+1
 LDX RWPARMS+6 ;Length
 LDA RWPARMS+7
 JSR SHOWMSG
:LINES DS 2 ;Lines to use (top, bottom)
 DA BUFFER
 JSR PRINT
 COLOR YELLOW
 NULL
:NEW JSR SETXY
 JSR PRLEN
 JMP EDIT

SAVE LDA PATH
 BEQL BOT
 JSR PRINT
 ASC "Save"
 NULL
 LDA TOPLINE
 STA :LINES
 LDA BOTLINE
 STA :LINES+1
 JSR GETSCREEN ;PICKLINE the screen
:LINES DS 2 ;on these lines
 DA BUFFER ;and put it here
 STX RWPARMS+4 ;X and A have length on return
 STX EPARMS+2
 STA RWPARMS+5
 STA EPARMS+3
 BRA :OPEN

:MAKE MLI_CREATE CRPARMS
 JSR MLIERR
:OPEN MLI_OPEN OPARMS
 CMP #$46 ;Not found
 BEQ :MAKE
 JSR MLIERR
 LDA OPARMS+5
 STA RWPARMS+1
 STA EPARMS+1
 STA CPARMS+1
 MLI_WRITE RWPARMS
 JSR MLIERR
 MLI_SET_EOF EPARMS
 JSR MLIERR
 MLI_CLOSE CPARMS
 JSR MLIERR
 JSR PRLEN
 JMP BOT

EDIT LDA XPOS
 STA :GOTO+2
 LDA YPOS
 STA :GOTO+3
 JSR PRINT
:GOTO GOTOXY 0;0
 NULL
 LDX TOPLINE
 LDA BOTLINE
 JSR MSGEDIT
 LDA CH
 STA XPOS
 LDA CV
 STA YPOS
 JMP BOT

EXIT JSR CLOSEALL
 RETURN

CRPARMS DFB 7
 DA PATH
 DFB #%1110_0011 ;Access bits
 DFB 4 ;File type (TXT)
 DA 0 ;Aux type (TXT file = rec len)
 DFB 1 ;Storage type
 DA 0 ;Creation date
 DA 0 ;Creation time

OPARMS DFB 3
 DA PATH
 DA IOBUFFER
 DS 1

RWPARMS DFB 4
 DS 1
 DA BUFFER
 DA $500
 DS 2

EPARMS DFB 2
 DS 1
 DS 3

CPARMS DFB 1
 DS 1

SETXY LDA :TOP
 STA XPOS
 LDA :TOP+1
 STA YPOS
 RTS
:TOP DFB 0,4

PRLEN JSR PRINT
 GOTOXY 0;1
 COLOR WHITE
 ASC "Length $"
 COLOR YELLOW
 HEX16 RWPARMS+6
 COLOR WHITE
 NULL
 RTS

XPOS DS 1
YPOS DS 1

TOPLINE DFB 4
BOTLINE DFB 21

PATH DS 1+63

BUFFER DS 80*24 ;Allows for 24 lines (80 chars per line)

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/HELP.EDITOR
 fin

 END
