*-------------------------------
* HOF.EDITOR
*-------------------------------
 DAT
 LST OFF

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE VARS
 USE LIB.JMP
 USE HOF.DSECT

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/HOF.EDITOR
 fin

 MODID "HOF.EDITOR"

NUMHOFS = 6

START JSR PRINT
 HOME
 BOX "Hall Of Fame Editor"
 NULL

 LDX #0
 LDA #0
 JSR LOADHOF
 LDA MISCBUFF
 STA NUMHOF
 JMP :FORW1

:BOT JSR PRINT
 GOTOXY 1;1
 ASC "Total in file : "
 COLOR YELLOW
 DEC8 NUMHOF
 COLOR WHITE
 GOTOXY 0;23
 CLEOS
 ASC "[A]dd, [J]ump, [S]ave, [L]ist, [RETURN]-edit, "
 MTON
 INVERSE
 ASC "H"
 NORMAL
 ASC ", "
 INVERSE
 ASC "U"
 NORMAL
 MTOFF
 ASC ", [H]elp, [Q]uit : "
 CURSORON
 NULL
 LDA CH
 STA :BGOTO+2
:GETKEY JSR PRINT
:BGOTO GOTOXY 0;23
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 LDX :KEYS
]LOOP2 CMP :KEYS,X
 BEQ :GOTONE
 DEX
 BNE ]LOOP2
 JMP ]LOOP
:GOTONE DEX
 TXA
 ASL
 TAX
 JMP (:TABLE,X)

:KEYS DFB :ENDKEYS-*-1
 DFB "Q"
 DFB "A"
 DFB "L"
 DFB "J"
 DFB "S"
 DFB "H"-$40
 DFB "U"-$40
 DFB "K"-$40
 DFB "J"-$40
 DFB "M"-$40
 DFB "H"
:ENDKEYS

:TABLE DA EXIT
 DA :ADD
 DA :LIST
 DA :LOAD
 DA :SAVE
 DA :BACK1
 DA :FORW1
 DA :UP
 DA :DOWN
 DA :EDIT
 DA :HELP

:HELP JSR PRINT
 GOTOXY 0;4
 CLEOS
 NULL
 JSR GETFILE
 DFB 4,22 ;Use lines x to y
 STR "HELP/HOF.ED"
 JSR PRINT
 GOTOXY 0;23
 COLOR PINK
 NULL
 GETRETURN
 JSR PRINT
 GOTOXY 0;4
 COLOR WHITE
 CLEOS
 NULL
 LDX :HOF
 JMP :LOK

:DOPOINT LDA :OLDPNTR
 CMP #19
 BCC :PLEFT
 LDA #40
 STA :CH+2
 LDA :OLDPNTR
 SEC
 SBC #15
 STA :CV+2
 BRA :DOP1
:PLEFT STZ :CH+2
 LDA :OLDPNTR
 CLC
 ADC #3
 STA :CV+2
:DOP1 JSR PRINT
 NORMAL
 MTOFF
:CH HTAB 0
:CV VTAB 0
 ASC " "
 NULL
 LDA :PNTR
 CMP #19
 BCC :PLEFT2
 LDA #40
 STA :CH2+2
 LDA :PNTR
 SEC
 SBC #15
 STA :CV2+2
 BRA :DOP2
:PLEFT2 STZ :CH2+2
 LDA :PNTR
 CLC
 ADC #3
 STA :CV2+2
:DOP2 JSR PRINT
:CH2 HTAB 0
:CV2 VTAB 0
 NULL
 JSR SHOWPNTR
 LDA :PNTR
 STA :OLDPNTR
 RTS
:OLDPNTR DFB 1
:PNTR DFB 1

:UP LDA NUMHOF
 ORA NUMHOF+1
 BEQL :BOT
 LDA :PNTR
 CMP #1
 BNE :UPOK
 LDA #NUMHOFS+1
:UPOK DEC
 STA :PNTR
 JSR :DOPOINT
 JMP :GETKEY

:DOWN LDA NUMHOF
 ORA NUMHOF+1
 BEQL :BOT
 LDA :PNTR
 CMP #NUMHOFS
 BNE :DNOK
 LDA #0
:DNOK INC
 STA :PNTR
 JSR :DOPOINT
 JMP :GETKEY

:EDIT LDA NUMHOF
 ORA NUMHOF+1
 BEQL :BOT
 LDA :PNTR
 DEC
 ASL
 TAX
 JMP (:EDITS,X)

:EDITS DA :GAME
 DA :TURN
 DA :DATE
 DA :NAME
 DA :COMMENT
 DA :SCEN

:LOAD LDA NUMHOF
 ORA NUMHOF+1
 BEQL :BOT
 JSR PRINT
 GOTOXY 0;23
 CLEOS
 ASC "Jump to HOF #"
 CURSORON
 NULL
 GETLINE #5
 JSR GETNUM
 CPX #0
 BNE :LOK
:LOK CPX NUMHOF
 BEQ :RNGOK
 BCC :RNGOK
 JSR PRINT
 COLOR PINK
 ASC " No such HOF. "
 COLOR WHITE
 NULL
 GETRETURN
 JMP :BOT
:RNGOK STX :HOF
 JSR LOADFAME
 JSR :DISPLAY
 STZ :FLAG
 JMP :BOT

:SAVE LDA NUMHOF
 ORA NUMHOF+1
 BEQL :BOT
 BIT :FLAG
 BPLL :GETKEY
:SAVE2 LDX :HOF
 JSR SAVEFAME
 STZ :FLAG
 JMP :BOT

:BACK1 LDA NUMHOF
 ORA NUMHOF+1
 BEQL :BOT
 LDA :HOF
 CMP #2
 BCS :GOB
 JMP :BOT
:GOB DEC :HOF
 LDX :HOF
 JMP :LOK

:FORW1 LDA NUMHOF
 ORA NUMHOF+1
 BEQL :BOT
 LDA :HOF
 CMP NUMHOF
 BCC :GOF
 JMP :BOT
:GOF INC :HOF
 LDX :HOF
 JMP :LOK

:LIST LDA NUMHOF
 ORA NUMHOF+1
 BEQL :BOT
 JSR PRINT
 GOTOXY 0;23
 CLEOS
 ASC "Start from HOF #1"
 CURSORLEFT
 NULL
 LDA PADFLAG
 STA TEMP
 LDA #$FF
 STA PADFLAG
 LDA PADCHAR
 STA TEMP+1
 LDA #" "
 STA PADCHAR
 LDA #1
 STA :TOREAD
 GETLINE #5
 BCSL :LEXIT
 CPX #0
 BEQ :FROM1
 JSR GETNUM
 STX :TOREAD
:FROM1 LDA :TOREAD
 CMP NUMHOF
 BCC :VGO
 BEQ :VGO
 JSR PRINT
 ASC " - "
 COLOR PINK
 ASC "Last HOF is #"
 COLOR YELLOW
 DEC8 NUMHOF
 COLOR PINK
 ASC ". "
 COLOR WHITE
 NULL
 GETRETURN
 JSR PRINT
 ZAPLINE
 NULL
 JMP :LEXIT
:VGO LDA :TOREAD
 STA :HOFCNTR
 JSR PRINT
 GOTOXY 0;3
 CLEOS
 CR
 COLOR AQUAMARINE
 ASC "HOF /Game /Turn /Date      /Time  /Party name          "
 LINE "/ Comment"
 COLOR WHITE
 CURSOROFF
 NULL
]LOOP LDA :HOFCNTR
 CMP NUMHOF
 BCC :RREAD
 BEQ :RREAD
 JMP :RDONE
:RREAD LDX :TOREAD
 JSR LOADFAME
 INC :TOREAD
 LDA CV
 CMP #21
 BNE :VOK
 JSR PRINT
 CR
 CR
 CURSORON
 COLOR YELLOW
 CENTER "[SPACE]-continue, [ESC]-exit : "
 COLOR WHITE
 NULL
]LOOP3 JSR KEYIN
 CMP #$9B
 BEQL :RESC
 CMP #" "
 BNE ]LOOP3
 JSR PRINT
 GOTOXY 0;5
 CLEOS
 CURSOROFF
 NULL
:VOK JSR PRINT
 CR
 COLOR YELLOW
 DEC8 :HOFCNTR
 COLOR WHITE
 ASC ")  "
 COLOR YELLOW
 DEC8 HOFGAME
 ASC "   "
 DEC8 HOFTURN
 ASC "  "
 COLOR GREEN
 DATE HOFDATE
 ASC "  "
 TIME HOFDATE+2
 ASC "  "
 COLOR ORANGE
 PRSTRING HOFNAME
 HTAB 57
 COLOR PINK
 NULL
 JSR DOSTR
 JSR PRINT
 COLOR WHITE
 NULL
 INC :HOFCNTR
 LDA $C000
 BPLL ]LOOP
 STA $C010
 CMP #$9B
 BEQ :RDONE
 JMP ]LOOP
:RESC JSR PRINT
 ZAPLINE
 CURSORON
 NULL
 BRA :RDONE2
:RDONE JSR PRINT
 GOTOXY 0;23
 COLOR PINK
 CURSORON
 NULL
 GETRETURN
 JSR PRINT
 COLOR WHITE
 NULL
:RDONE2 LDA TEMP
 STA PADFLAG
 LDA TEMP+1
 STA PADCHAR
 LDX :HOF
 JMP :LOK
:LEXIT LDA TEMP
 STA PADFLAG
 LDA TEMP+1
 STA PADCHAR
 JMP :BOT
:HOFCNTR DS 1
:TOREAD DA 1

:DISPLAY LDA NUMHOF
 ORA NUMHOF+1
 BEQL :BOT
 JSR PRINT
 GOTOXY 60;1
 ASC "HOF #"
 COLOR YELLOW
 DEC8 :HOF
 COLOR WHITE
 ASC " "
 GOTOXY 0;4
 CLEOS
 CURSOROFF
 ASC "  1 - Game......."
 COLOR YELLOW
 DEC8 HOFGAME
 COLOR WHITE
 CR
 ASC "  2 - Turn......."
 COLOR YELLOW
 DEC8 HOFTURN
 COLOR WHITE
 CR
 ASC "  3 - Date/time.."
 COLOR GREEN
 DATE HOFDATE
 ASC "  "
 TIME HOFDATE+2
 COLOR WHITE
 CR
 ASC "  4 - Party name."
 COLOR ORANGE
 PRSTRING HOFNAME
 COLOR WHITE
 CR
 ASC "  5 - Comment...."
 COLOR AQUAMARINE
 NULL
 JSR DOSTR
 JSR PRINT
 COLOR WHITE
 CR
 ASC "  6 - Scenario..."
 COLOR PINK
 PRSTRING HOFSCEN
 COLOR WHITE
 CR
 CURSORON
 NULL
 JMP :DOPOINT
:HOF DS 1

:HOFBACK JSR PRINT
 GOTOXY 0;23
 CLEOS
 NULL
 JSR :DISPLAY
 LDA #$FF
 STA :FLAG
 JMP :BOT

:ADD JSR PRINT
 GOTOXY 0;23
 CLEOS
 ASC "Add to end of file (y/N)? : "
 NULL
 JSR KEYIN
 JSR UPPER
 CMP #"Y"
 BNEL :BOT
 LDA NUMHOF
 CMP #$FF
 BCC :AEOK
 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 COLOR PINK
 ASC "Cannot add any more HOFs. "
 COLOR WHITE
 NULL
 GETRETURN
 JMP :HOFBACK
:AEOK INC NUMHOF
 LDX NUMHOF
 STX MISCBUFF
 STX :HOF
 LDX #0
 JSR SAVEFAME
 LDX #0
]LOOP STZ MISCBUFF,X
 INX
 BNE ]LOOP
 JSR :DISPLAY
 JMP :SAVE2

:GAME LDX #5
 LDY #1
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :GRTS
 JSR GETNUM
 STX HOFGAME
:GRTS JMP :HOFBACK

:TURN LDX #5
 LDY #2
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :TRTS
 JSR GETNUM
 STX HOFTURN
:TRTS JMP :HOFBACK

:DATE LDX #4
 LDY #3
 JSR ASK
 GETLINE #11
 CPX #11
 BNEL :DLRTS
 LDX #8
]LOOP LDA $200+2,X
 STA :DENTRY,X
 DEX
 BPL ]LOOP
 LDA #$8D
 STA $202
 LDX #2
 JSR GETNUM
 STX :DDAY
 LDA :DENTRY
 STA $200
 LDA :DENTRY+1
 STA $201
 LDX #2
 JSR GETNUM
 STX :DMONTH
 LDA :DENTRY+2
 STA $200
 LDA :DENTRY+3
 STA $201
 LDX #2
 JSR GETNUM
 STX :DYEAR
 LDA :DMONTH
 ASL
 ASL
 ASL
 ASL
 ASL
 ROL :DYEAR
 ORA :DDAY
 STA HOFDATE
 LDA :DYEAR
 STA HOFDATE+1
 LDA :DENTRY+5
 STA $200
 LDA :DENTRY+6
 STA $201
 LDX #2
 JSR GETNUM
 STX HOFDATE+3
 LDA :DENTRY+7
 STA $200
 LDA :DENTRY+8
 STA $201
 LDX #2
 JSR GETNUM
 STX HOFDATE+2
:DLRTS JMP :HOFBACK

:NAME LDX #2
 LDY #4
 JSR ASK
 GETLINE #15
 CPX #0
 BEQ :NWRTS
 STX HOFNAME
]LOOP LDA $200-1,X
 STA HOFNAME,X
 DEX
 BNE ]LOOP
:NWRTS JMP :HOFBACK

:COMMENT LDX #2
 LDY #5
 JSR ASK
 GETLINE #40
 CPX #0
 BEQ :CRTS
 STX HOFCOMMENT
]LOOP LDA $200-1,X
 STA HOFCOMMENT,X
 DEX
 BNE ]LOOP
:CRTS JMP :HOFBACK

:SCEN LDX #2
 LDY #6
 JSR ASK
 GETLINE #15
 CPX #0
 BEQ :SCRTS
 STX HOFSCEN
]LOOP LDA $200-1,X
 STA HOFSCEN,X
 DEX
 BNE ]LOOP
:SCRTS JMP :HOFBACK

:FLAG DS 1
:DDAY DS 1
:DMONTH DS 1
:DYEAR DS 1
:DENTRY DS 9

DOSTR LDA HOFCOMMENT
 BNE :OK
 JSR PRINT
 PRSTRING HOFCOMMENT
 NULL
 RTS
:OK LDX #0
]LOOP LDA HOFCOMMENT+1,X
 JSR COUT
 LDA CH
 CMP #75
 BCS :DOTS
 INX
 CPX HOFCOMMENT
 BNE ]LOOP
 RTS
:DOTS JSR PRINT
 ASC ".."
 NULL
 RTS

EXIT JSR PRINT
 NORMAL
 MTOFF
 HOME
 NULL
 RETURN

LOADFAME LDA #0
 JMP LOADHOF

SAVEFAME LDA #0
 JMP SAVEHOF

NUMHOF DS 1
TEMP DS 2

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/HOF.EDITOR
 fin

 END
