*-------------------------------
* ITEM.EDITOR
*-------------------------------
 DAT
 LST OFF

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE VARS
 USE LIB.JMP
 USE TABLES
 USE ITEM.DSECT
 USE ITEM2.DSECT
 USE INV.DSECT

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/ITEM.EDITOR
 fin

 MODID "ITEM.EDITOR"

START JSR PRINT
 HOME
 CURSOROFF
 BOX "Item Editor"
 GOTOXY 0;0
 COLOR GREEN
 LINE "1 - Weapon, 2 - Armour"
 LINE "3 - Shield, 4 - Helmet"
 ASC "5 - Gloves, 6 - Misc."
 GOTOXY 0;4
 COLOR AQUAMARINE
 ASC " Item   Price  Data1  Data2  Data3  Data4  Data5 Type    Name"
 NULL

 LDX #0
 LDA #0
 JSR LOADITEM
 LDA ITEMBUFF
 STA NUMITEMS

TOP JSR DISPLAY
 JSR DOPOINT

BOT JSR PRINT
 GOTOXY 0;23
 CLEOS
 ASC "["
 MTON
 INVERSE
 ASC "K"
 NORMAL
 ASC "]-Up, ["
 INVERSE
 ASC "J"
 NORMAL
 ASC "]-Down, ["
 INVERSE
 ASC "H"
 NORMAL
 ASC "]-Page up, ["
 INVERSE
 ASC "U"
 NORMAL
 MTOFF
 ASC "]-Page down, [A]dd, [D]el, [H]elp, [Q]uit : "
 CURSORON
 NULL
 LDA CH
 STA BOTCH+2

BOT2 JSR PRINT
BOTCH GOTOXY 0;23
 CURSORON
 NULL

]LOOP JSR KEYIN
 JSR UPPER
 LDX :KEYS
]LOOP2 CMP :KEYS,X
 BEQ :GOTONE
 DEX
 BNE ]LOOP2
 JMP ]LOOP
:GOTONE DEX
 TXA
 ASL
 TAX
 JMP (:TABLE,X)

:KEYS DFB :ENDKEYS-*-1
 DFB "Q"
 DFB "K"-$40
 DFB "J"-$40
 DFB "H"-$40
 DFB "U"-$40
 DFB "M"-$40
 DFB "A"
 DFB "D"
 DFB "H"
:ENDKEYS

:TABLE DA EXIT
 DA UP
 DA DOWN
 DA LEFT
 DA RIGHT
 DA EDIT
 DA ADD
 DA DELETE
 DA HELP

HELP JSR PRINT
 GOTOXY 0;6
 CLEOS
 NULL
 JSR GETFILE
 DFB 6,22 ;Use lines x to y
 STR "HELP/ITEM.ED"
 JSR PRINT
 GOTOXY 0;23
 COLOR PINK
 NULL
 GETRETURN
 JMP TOP

LEFT LDA PAGENO
 CMP #1
 BEQL BOT
 DEC PAGENO
 LDA #1
 STA ILINE
 LDA PNTR
 AND #$F0
 SEC
 SBC #16
 STA PNTR
 JMP TOP

RIGHT LDA PNTR
 AND #$F0
 CLC
 ADC #16
 CMP NUMITEMS
 BEQ :OK
 BCSL BOT
:OK STA PNTR
 LDA #1
 STA ILINE
 INC PAGENO
 JMP TOP

ADD LDA NUMITEMS
 CMP #$FF
 BNE :OK
 JSR PRINT
 GOTOXY 0;23
 CLEOS
 COLOR PINK
 ASC "Cannot add any more items. "
 COLOR WHITE
 NULL
 GETRETURN
 JMP BOT
:OK INC
 STA :REC
 JSR PRINT
 GOTOXY 0;23
 CLEOS
 COLOR PINK
 ASC "Add item #"
 COLOR YELLOW
 DEC8 :REC
 COLOR PINK
 ASC " (y/n)? : "
 COLOR WHITE
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 CMP #"Y"
 BEQ :YES
 CMP #"N"
 BNE ]LOOP
 JMP BOT
:YES LDA :REC
 STA NUMITEMS
 STA PNTR
 LDA #1
 STA ITYPE
 STZ ICOST
 STZ ICOST+1
 STZ IUSEBY
 STZ IDAT1
 STZ IDAT2
 STZ IDAT3
 STZ IDAT4
 STZ IDAT5
 STZ INAME
 LDX NUMITEMS
 LDA #0
 JSR SAVEITEM
 LDX #0
 LDA #0
 JSR LOADITEM
 INC ITEMBUFF
 LDX #0
 LDA #0
 JSR SAVEITEM
 LDX #0
 LDA #0
 JSR LOADINV
 LDA NUMITEMS
 STA MISCBUFF
 STZ MISCBUFF+1
 LDX #0
 LDA #0
 JSR SAVEINV
 STZ INVFREE
 STZ INVSTOCK
 STZ INVMAX
 STZ INVORDER
 LDX NUMITEMS
 LDA #0
 JSR SAVEINV
 JMP EDIT
:REC DS 1

DELETE LDA PNTR
 BEQL BOT2
 JSR PRINT
 GOTOXY 0;23
 CLEOS
 COLOR PINK
 ASC "Delete item #"
 COLOR YELLOW
 DEC8 PNTR
 COLOR PINK
 ASC " [Note: will cause crunching] (y/n)? : "
 COLOR WHITE
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 CMP #"Y"
 BEQ :YES
 CMP #"N"
 BNE ]LOOP
 JMP BOT
:YES LDA PNTR
 STA :REC
 JSR PRINT
 GOTOXY 0;23
 CLEOS
 COLOR PINK
 ASC "Crunching.."
 COLOR WHITE
 NULL
]LOOP LDX :REC
 CPX NUMITEMS
 BEQ :DONE
 INX
 LDA #0
 JSR LOADITEM
 LDX :REC
 LDA #0
 JSR SAVEITEM
 INC :REC
 BRA ]LOOP
:DONE LDX #0
 LDA #0
 JSR LOADITEM
 DEC ITEMBUFF
 LDX #0
 LDA #0
 JSR SAVEITEM
 LDX #0
 LDA #0
 JSR LOADINV
 DEC MISCBUFF
 LDX #0
 LDA #0
 JSR SAVEINV
 DEC NUMITEMS
 JSR PRINT
 GOTOXY 0;23
 CLEOS
 COLOR PINK
 ASC "Deleted. "
 COLOR WHITE
 NULL
 GETRETURN
:BOT LDA PNTR
 CMP NUMITEMS
 BEQ :BOT2
 BCC :BOT2
 LDA NUMITEMS
 STA PNTR
 DEC ILINE
:BOT2 JMP TOP
:REC DS 1

EDIT LDA PNTR
 BNE :IOK
 JSR PRINT
 GOTOXY 0;23
 CLEOS
 COLOR YELLOW
 ASC "Change total items to #"
 COLOR WHITE
 NULL
 GETLINE #3
 CPX #0
 BEQL BOT
 JSR GETNUM
 STX NUMITEMS
 LDX #0
 LDA #0
 JSR LOADITEM
 LDA NUMITEMS
 STA ITEMBUFF
 LDX #0
 LDA #0
 JSR SAVEITEM
 JMP TOP
:IOK STA ITEM
 JSR PRINT
 GOTOXY 0;6
 CLEOS
 NULL
 JSR LOAD
 JSR DISPLAY2
 LDA ITYPE
 DEC
 ASL
 TAX
 JMP (:ETYPES,X)

:ETYPES DA :TYPE1
 DA :TYPE2
 DA :TYPE3
 DA :TYPE4
 DA :TYPE5
 DA :TYPE6

:TYPE1 JSR PRINT
 GOTOXY 0;8
 CLEOS
 ASC " 1 - Type................"
 COLOR GREEN
 DEC8 ITYPE
 COLOR WHITE
 CR
 ASC " 2 - Price..............."
 COLOR YELLOW
 DEC16 ICOST
 COLOR WHITE
 CR
 ASC " 3 - Damage amount......."
 COLOR YELLOW
 DEC8 IDAT1
 COLOR WHITE
 ASC "="
 COLOR ORANGE
 PRTABLE IDAT1;DAMTABLE
 COLOR WHITE
 CR
 ASC " 4 - Damage modifier....."
 COLOR YELLOW
 DEC8PNEG IDAT2
 COLOR WHITE
 CR
 ASC " 5 - Effective skill....."
 COLOR YELLOW
 DEC8NEG IDAT3
 COLOR WHITE
 CR
 ASC " 6 - Damage type........."
 COLOR YELLOW
 DEC8 IDAT4
 COLOR WHITE
 ASC "="
 COLOR ORANGE
 PRTABLE IDAT4;DAMTYPE
 COLOR WHITE
 CR
 ASC " 7 - Range..............."
 COLOR YELLOW
 DEC8 IDAT5
 COLOR WHITE
 CR
 ASC " 8 - Name................"
 COLOR AQUAMARINE
 PRSTRING INAME
 COLOR WHITE
 CR
 ASC " 9 - Can be used by......"
 COLOR PINK
 PRNIBBLE IUSEBY
 COLOR WHITE
 NULL
 JSR :PRCLASS
 JSR :GETBOT
 BCSL :TYPE1
 JMP (:TYPED1,X)

:TYPED1 DA :ED1
 DA :ED2
 DA :ED13
 DA :ED14
 DA :ED15
 DA :ED16
 DA :ED17
 DA :ED8
 DA :ED9

:ED1 LDX #5
 LDY #1
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :E2RTS
 JSR GETNUM
 CPX #0
 BEQ :ED1NO
 CPX #7
 BCC :ED1OK
:ED1NO LDX ITYPE
:ED1OK STX ITYPE
 DEX
 TXA
 ASL
 TAX
 JMP (:ETYPES,X)

:ED2 LDX #5
 LDY #2
 JSR ASK
 GETLINE #5
 CPX #0
 BEQ :E2RTS
 JSR GETNUM
 STX ICOST
 STY ICOST+1
:E2RTS LDX ITYPE
 DEX
 TXA
 ASL
 TAX
 JMP (:ETYPES,X)

:ED8 LDX #2
 LDY #8
 JSR ASK
 GETLINE #20
 CPX #0
 BEQ :E7RTS
 STX INAME
]LOOP LDA $200-1,X
 STA INAME,X
 DEX
 BNE ]LOOP
:E7RTS LDX ITYPE
 DEX
 TXA
 ASL
 TAX
 JMP (:ETYPES,X)

:ED9 LDX #6
 LDY #9
 JSR ASK
 GETLINE #8
 CPX #0
 BEQ :E9RTS
 JSR GETNIBBLE
 STX IUSEBY
:E9RTS LDX ITYPE
 DEX
 TXA
 ASL
 TAX
 JMP (:ETYPES,X)

:ED13 LDX #5
 LDY #3
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :E3RTS
 JSR GETNUM
 CPX #4
 BCS :E3RTS
 STX IDAT1
:E3RTS JMP :TYPE1

:ED14 LDX #5
 LDY #4
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :E4RTS
 JSR GETNUM
 STX IDAT2
:E4RTS JMP :TYPE1

:ED15 LDX #5
 LDY #5
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :E5RTS
 JSR GETNUM
 STX IDAT3
:E5RTS JMP :TYPE1

:ED16 LDX #5
 LDY #6
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :E16RTS
 JSR GETNUM
 CPX #4
 BCS :E16RTS
 STX IDAT4
:E16RTS JMP :TYPE1

:ED17 LDX #5
 LDY #7
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :E17RTS
 JSR GETNUM
 CPX #$11
 BCS :E17RTS
 STX IDAT5
:E17RTS JMP :TYPE1

:TYPE2 JSR PRINT
 GOTOXY 0;8
 CLEOS
 ASC " 1 - Type................"
 COLOR GREEN
 DEC8 ITYPE
 COLOR WHITE
 CR
 ASC " 2 - Price..............."
 COLOR YELLOW
 DEC16 ICOST
 COLOR WHITE
 CR
 ASC " 3 - Passive defense....."
 COLOR YELLOW
 DEC8 IDAT1
 COLOR WHITE
 CR
 ASC " 4 - Damage resistance..."
 COLOR YELLOW
 DEC8 IDAT2
 COLOR WHITE
 CR
 ASC " 5 - ?? <unused> ??......?"
 CR
 ASC " 6 - ?? <unused> ??......?"
 CR
 ASC " 7 - ?? <unused> ??......?"
 CR
 ASC " 8 - Name................"
 COLOR AQUAMARINE
 PRSTRING INAME
 COLOR WHITE
 CR
 ASC " 9 - Can be used by......"
 COLOR PINK
 PRNIBBLE IUSEBY
 COLOR WHITE
 NULL
 JSR :PRCLASS
 JSR :GETBOT
 BCSL :TYPE2
 JMP (:TYPED2,X)

:TYPED2 DA :ED1
 DA :ED2
 DA :ED23
 DA :ED24
 DA :ED25
 DA :ED26
 DA :ED27
 DA :ED8
 DA :ED9

:ED23 LDX #5
 LDY #3
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :E23RTS
 JSR GETNUM
 STX IDAT1
:E23RTS JMP :TYPE2

:ED24 LDX #5
 LDY #4
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :E24RTS
 JSR GETNUM
 STX IDAT2
:E24RTS JMP :TYPE2

:ED25
:ED26
:ED27 JMP :TYPE2

:TYPE3 JSR PRINT
 GOTOXY 0;8
 CLEOS
 ASC " 1 - Type................"
 COLOR GREEN
 DEC8 ITYPE
 COLOR WHITE
 CR
 ASC " 2 - Price..............."
 COLOR YELLOW
 DEC16 ICOST
 COLOR WHITE
 CR
 ASC " 3 - Passive defense....."
 COLOR YELLOW
 DEC8 IDAT1
 COLOR WHITE
 CR
 ASC " 4 - ?? <unused> ??......?"
 CR
 ASC " 5 - ?? <unused> ??......?"
 CR
 ASC " 6 - ?? <unused> ??......?"
 CR
 ASC " 7 - ?? <unused> ??......?"
 CR
 ASC " 8 - Name................"
 COLOR AQUAMARINE
 PRSTRING INAME
 COLOR WHITE
 CR
 ASC " 9 - Can be used by......"
 COLOR PINK
 PRNIBBLE IUSEBY
 COLOR WHITE
 NULL
 JSR :PRCLASS
 JSR :GETBOT
 BCSL :TYPE3
 JMP (:TYPED3,X)

:TYPED3 DA :ED1
 DA :ED2
 DA :ED33
 DA :ED34
 DA :ED35
 DA :ED36
 DA :ED37
 DA :ED8
 DA :ED9

:ED33 LDX #5
 LDY #3
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :E33RTS
 JSR GETNUM
 STX IDAT1
:E33RTS JMP :TYPE3

:ED34
:ED35
:ED36
:ED37 JMP :TYPE3

:TYPE4 JSR PRINT
 GOTOXY 0;8
 CLEOS
 ASC " 1 - Type................"
 COLOR GREEN
 DEC8 ITYPE
 COLOR WHITE
 CR
 ASC " 2 - Price..............."
 COLOR YELLOW
 DEC16 ICOST
 COLOR WHITE
 CR
 ASC " 3 - Passive defense....."
 COLOR YELLOW
 DEC8 IDAT1
 COLOR WHITE
 CR
 ASC " 4 - Damage resistance..."
 COLOR YELLOW
 DEC8 IDAT2
 COLOR WHITE
 CR
 ASC " 5 - ?? <unused> ??......?"
 CR
 ASC " 6 - ?? <unused> ??......?"
 CR
 ASC " 7 - ?? <unused> ??......?"
 CR
 ASC " 8 - Name................"
 COLOR AQUAMARINE
 PRSTRING INAME
 COLOR WHITE
 CR
 ASC " 9 - Can be used by......"
 COLOR PINK
 PRNIBBLE IUSEBY
 COLOR WHITE
 NULL
 JSR :PRCLASS
 JSR :GETBOT
 BCSL :TYPE4
 JMP (:TYPED4,X)

:TYPED4 DA :ED1
 DA :ED2
 DA :ED43
 DA :ED44
 DA :ED45
 DA :ED46
 DA :ED47
 DA :ED8
 DA :ED9

:ED43 LDX #5
 LDY #3
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :E43RTS
 JSR GETNUM
 STX IDAT1
:E43RTS JMP :TYPE4

:ED44 LDX #5
 LDY #4
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :E44RTS
 JSR GETNUM
 STX IDAT2
:E44RTS JMP :TYPE4

:ED45
:ED46
:ED47 JMP :TYPE4

:TYPE5 JSR PRINT
 GOTOXY 0;8
 CLEOS
 ASC " 1 - Type................"
 COLOR GREEN
 DEC8 ITYPE
 COLOR WHITE
 CR
 ASC " 2 - Price..............."
 COLOR YELLOW
 DEC16 ICOST
 COLOR WHITE
 CR
 ASC " 3 - Passive defense....."
 COLOR YELLOW
 DEC8 IDAT1
 COLOR WHITE
 CR
 ASC " 4 - Damage resistance..."
 COLOR YELLOW
 DEC8 IDAT2
 COLOR WHITE
 CR
 ASC " 5 - ?? <unused> ??......?"
 CR
 ASC " 6 - ?? <unused> ??......?"
 CR
 ASC " 7 - ?? <unused> ??......?"
 CR
 ASC " 8 - Name................"
 COLOR AQUAMARINE
 PRSTRING INAME
 COLOR WHITE
 CR
 ASC " 9 - Can be used by......"
 COLOR PINK
 PRNIBBLE IUSEBY
 COLOR WHITE
 NULL
 JSR :PRCLASS
 JSR :GETBOT
 BCSL :TYPE5
 JMP (:TYPED5,X)

:TYPED5 DA :ED1
 DA :ED2
 DA :ED53
 DA :ED54
 DA :ED55
 DA :ED56
 DA :ED57
 DA :ED8
 DA :ED9

:ED53 LDX #5
 LDY #3
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :E53RTS
 JSR GETNUM
 STX IDAT1
:E53RTS JMP :TYPE5

:ED54 LDX #5
 LDY #3
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :E54RTS
 JSR GETNUM
 STX IDAT2
:E54RTS JMP :TYPE5

:ED55
:ED56
:ED57 JMP :TYPE5

:TYPE6 JSR PRINT
 GOTOXY 0;8
 CLEOS
 ASC " 1 - Type................"
 COLOR GREEN
 DEC8 ITYPE
 COLOR WHITE
 CR
 ASC " 2 - Price..............."
 COLOR YELLOW
 DEC16 ICOST
 COLOR WHITE
 CR
 ASC " 3 - Misc item number...."
 COLOR YELLOW
 DEC8 IDAT1
 COLOR WHITE
 CR
 ASC " 4 - ?? <unused> ??......?"
 CR
 ASC " 5 - ?? <unused> ??......?"
 CR
 ASC " 6 - ?? <unused> ??......?"
 CR
 ASC " 7 - ?? <unused> ??......?"
 CR
 ASC " 8 - Name................"
 COLOR AQUAMARINE
 PRSTRING INAME
 COLOR WHITE
 CR
 ASC " 9 - Can be used by......"
 COLOR PINK
 PRNIBBLE IUSEBY
 COLOR WHITE
 NULL
 JSR :PRCLASS
 JSR :GETBOT
 BCSL :TYPE6
 JMP (:TYPED6,X)

:TYPED6 DA :ED1
 DA :ED2
 DA :ED63
 DA :ED64
 DA :ED65
 DA :ED66
 DA :ED67
 DA :ED8
 DA :ED9

:ED63 LDX #5
 LDY #3
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :E63RTS
 JSR GETNUM
 JSR CHEKI ;Unique misc item number?
 BCS :E63RTS ;No
 STX IDAT1
:E63RTS JMP :TYPE6

:ED64
:ED65
:ED66
:ED67 JMP :TYPE6

:PRCLASS LDA IUSEBY
 CMP #%1111_1111
 BNE :CL1
 JSR PRINT
 COLOR YELLOW
 ASC " <all>"
 COLOR WHITE
 NULL
 RTS
:CL1 LDA #$80
 STA :ANDX
 LDX #7
]LOOP PHX
 LDA IUSEBY
 AND :ANDX
 BEQ :NXTCL
 LDA #"/"
 JSR COUT
 TXA
 ASL
 ASL
 TAY
 LDA :CLNAMES,Y
 TAX
]LOOP2 INY
 LDA :CLNAMES,Y
 JSR COUT
 DEX
 BNE ]LOOP2
:NXTCL LSR :ANDX
 PLX
 DEX
 BPL ]LOOP
 RTS
:ANDX DS 1
:CLNAMES STR "Fig"
 STR "Thi"
 STR "Wiz"
 STR "Cle"
 STR "Nin"
 STR "Sag"
 STR "HMa"
 STR "HPr"

:GETBOT JSR PRINT
 GOTOXY 0;23
 CLEOS
 MTON
 INVERSE
 ASC "K"
 NORMAL
 ASC ", "
 INVERSE
 ASC "J"
 NORMAL
 MTOFF
 ASC ", [RETURN]-edit, [L]oad, [S]ave, [ESC] to exit : "
 NULL
 LDA CH
 STA :BCH+2
 JSR :DOPOINT
]LOOPC JSR PRINT
:BCH GOTOXY 0;23
 CURSORON
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 CMP #$9B
 BEQ :EXIT
 CMP #"L"
 BEQ :DOLOAD
 CMP #"S"
 BEQ :DOSAVE
 CMP #"K"-$40
 BEQ :GOUP
 CMP #"J"-$40
 BEQ :GODOWN
 CMP #$8D
 BNE :CHK19
 LDA :PNTR
 CLC
 ADC #"0"
:CHK19 CMP #"1"
 BCC ]LOOP
 CMP #"9"+1
 BCS ]LOOP
 SEC
 SBC #"1"
 ASL
 TAX
 CLC
 RTS
:DOLOAD JSR LOAD
 SEC
 RTS ;JMP :GETBOT
:DOSAVE JSR SAVE
 JMP :GETBOT
:EXIT LDA PAGENO
 DEC
 ASL
 ASL
 ASL
 ASL
 STA PNTR
 JSR DISPLAY
 LDA PNTR
 CLC
 ADC ILINE
 DEC
 STA PNTR
 JSR DOPOINT
 LDX #$FF ;Coz we JSR'd here
 TXS
 JMP BOT

:GOUP LDA :PNTR
 CMP #1
 BNE :UPOK
 LDA #10
:UPOK DEC
 STA :PNTR
 JSR :DOPOINT
 JMP ]LOOPC

:GODOWN LDA :PNTR
 CMP #9
 BNE :DNOK
 LDA #0
:DNOK INC
 STA :PNTR
 JSR :DOPOINT
 JMP ]LOOPC

:DOPOINT LDA :OLDPNTR
 CLC
 ADC #7
 STA :CV+3
 JSR PRINT
 NORMAL
 MTOFF
 CURSOROFF
:CV GOTOXY 0;0
 ASC " "
 NULL
 LDA :PNTR
 CLC
 ADC #7
 STA :CV2+3
 JSR PRINT
:CV2 GOTOXY 0;0
 NULL
 JSR SHOWPNTR
 LDA :PNTR
 STA :OLDPNTR
 RTS
:OLDPNTR DFB 1
:PNTR DFB 1

DISPLAY LDA NUMITEMS
 ORA NUMITEMS+1
 BEQ :ZIT
 JSR CHECKMISC
:ZIT JSR PRINT
 GOTOXY 50;0
 COLOR WHITE
 ASC "Total : "
 COLOR YELLOW
 DEC16 NUMITEMS
 COLOR WHITE
 ASC "  "
 GOTOXY 70;0
 ASC "Page #"
 CLEOL
 COLOR YELLOW
 DEC8 PAGENO
 COLOR WHITE
 ASC " "
 GOTOXY 50;2
 ASC "Lo/hi misc:"
 CLEOL
 COLOR YELLOW
 NULL
 LDA LOMISCITEM
 ORA LOMISCITEM+1
 BNE :LHMOK
 JSR PRINT
 ASC " <none>"
 COLOR WHITE
 NULL
 BRA :DOPNO
:LHMOK JSR PRINT
 DEC8 LOMISC
 COLOR WHITE
 ASC "("
 COLOR YELLOW
 DEC8 LOMISCITEM
 COLOR WHITE
 ASC ")/"
 COLOR YELLOW
 DEC8 HIMISC
 COLOR WHITE
 ASC "("
 COLOR YELLOW
 DEC8 HIMISCITEM
 COLOR WHITE
 ASC ")"
 NULL
:DOPNO JSR PRINT
 GOTOXY 0;6
 CLEOS
 CURSOROFF
 NULL
 LDA PAGENO
 DEC
 ASL
 ASL
 ASL
 ASL
 STA ITEM
 BNE :OK
 INC ITEM
 JSR PRINT
 COLOR YELLOW
 LINE "    0   *---*   *-*    *-*    *-*    *-*    *-*  *----*  *"
 COLOR WHITE
 NULL
:OK LDA NUMITEMS
 ORA NUMITEMS+1
 BEQ :EOD
]LOOP LDA ITEM
 CMP NUMITEMS
 BEQ :LOAD
 BCS :EOD
:LOAD JSR LOAD
 JSR DISPLAY2
 INC ITEM
 LDA CV
 CMP #22
 BNE ]LOOP
:EOD JSR PRINT
 CURSORON
 NULL
 RTS

DISPLAY2 LDA PADFLAG
 PHA
 LDA #$FF
 STA PADFLAG
 LDA PADCHAR
 PHA
 LDA #" "
 STA PADCHAR
 JSR PRINT
 ASC "  "
 DEC8 ITEM
 ASC "   "
 DEC16 ICOST
 ASC "   "
 DEC8NEG IDAT1
 ASC "    "
 DEC8NEG IDAT2
 ASC "    "
 DEC8NEG IDAT3
 ASC "    "
 DEC8NEG IDAT4
 ASC "    "
 DEC8NEG IDAT5
 ASC "  "
 NULL
 LDA ITYPE
 DEC
 ASL
 TAX
 LDA :TBL,X
 STA CADD2
 LDA :TBL+1,X
 STA CADD2+1
 LDY #0
 LDA (CADD2),Y
 TAX
]LOOP INY
 LDA (CADD2),Y
 JSR COUT
 DEX
 BNE ]LOOP
 JSR PRINT
 ASC "  "
 PRSTRING INAME
 CR
 NULL
 PLA
 STA PADCHAR
 PLA
 STA PADFLAG
 RTS

:TBL DA :TYPE1
 DA :TYPE2
 DA :TYPE3
 DA :TYPE4
 DA :TYPE5
 DA :TYPE6

:TYPE1 STR "Weapon"
:TYPE2 STR "Armour"
:TYPE3 STR "Shield"
:TYPE4 STR "Helmet"
:TYPE5 STR "Gloves"
:TYPE6 STR "Misc. "

DOPOINT LDA OLDLINE
 CLC
 ADC #5
 STA :CV+2
 JSR PRINT
 NORMAL
 MTOFF
 HTAB 0
:CV VTAB 0
 ASC " "
 NULL
 LDA ILINE
 CLC
 ADC #5
 STA :CV2+2
 JSR PRINT
 HTAB 0
:CV2 VTAB 0
 NULL
 JSR SHOWPNTR
 LDA ILINE
 STA OLDLINE
 RTS
OLDLINE DFB 1
PNTR DFB 0
PAGENO DFB 1
ILINE DFB 1

UP LDA ILINE
 CMP #1
 BNE :LINE
 LDA PAGENO
 CMP #1
 BEQ :NO
 DEC PAGENO
 LDA #16
 STA ILINE
 DEC PNTR
 JMP TOP
:LINE DEC ILINE
 DEC PNTR
 JSR DOPOINT
:NO JMP BOT2

DOWN LDA PNTR
 CMP NUMITEMS
 BCC :OK1
 JMP BOT
:OK1 LDA ILINE
 CMP #16
 BNE :OK2
 INC PAGENO
 LDA #1
 STA ILINE
 INC PNTR
 JMP TOP
:OK2 INC ILINE
 INC PNTR
 JSR DOPOINT
 JMP BOT2

EXIT JSR PRINT
 NORMAL
 MTOFF
 HOME
 NULL
 RETURN

LOAD LDX ITEM
 LDA ITEM+1
 JMP LOADITEM

SAVE LDX ITEM
 LDA ITEM+1
 JMP SAVEITEM
ITEM DA 0

NUMITEMS DS 2

CHECKMISC STZ HIMISC
 LDA #$FF
 STA LOMISC
 STZ LOMISCITEM
 STZ LOMISCITEM+1
 STZ HIMISCITEM
 STZ HIMISCITEM+1
 LDA NUMITEMS
 STA :ITEM
 LDA NUMITEMS+1
 STA :ITEM+1
]LOOP LDX :ITEM
 LDA :ITEM+1
 JSR LOADITEM
 LDA ITYPE
 CMP #6 ;Misc?
 BNE :NEXT
 LDA IDAT1 ;Misc item number
 CMP HIMISC
 BCC :CHECK2
 STA HIMISC
 LDX :ITEM
 STX HIMISCITEM
 LDX :ITEM+1
 STX HIMISCITEM+1
:CHECK2 CMP LOMISC
 BCS :NEXT
 STA LOMISC
 LDX :ITEM
 STX LOMISCITEM
 LDX :ITEM+1
 STX LOMISCITEM+1
:NEXT DECR :ITEM
 LDA :ITEM+1
 BNE ]LOOP
 LDA :ITEM
 BNE ]LOOP
 RTS
:ITEM DS 2

HIMISC DS 1
LOMISC DS 1
HIMISCITEM DS 2
LOMISCITEM DS 2

CHEKI STX :ITEMNUM
 LDX #0
]LOOP LDA ITEMBUFF,X
 STA MISCBUFF,X
 INX
 BNE ]LOOP
 LDA NUMITEMS
 STA :ITEM
 LDA NUMITEMS+1
 STA :ITEM+1
]LOOP LDX :ITEM
 LDA :ITEM+1
 CPX ITEM
 BNE :OK
 CMP ITEM+1
 BEQ :NEXT
:OK JSR LOADITEM
 LDA ITYPE
 CMP #6 ;Misc?
 BNE :NEXT
 LDA IDAT1 ;Misc item number
 CMP :ITEMNUM
 BEQ :SAME
:NEXT DECR :ITEM
 LDA :ITEM+1
 BNE ]LOOP
 LDA :ITEM
 BNE ]LOOP
 CLC
 BRA :FIN

:SAME JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 COLOR PINK
 ASC "Misc item number #"
 COLOR YELLOW
 DEC8 :ITEMNUM
 COLOR PINK
 ASC " already in use (item="
 COLOR YELLOW
 DEC16 :ITEM
 COLOR PINK
 ASC "). "
 COLOR WHITE
 NULL
 GETRETURN
 SEC
:FIN PHP
 LDX #0
]LOOP LDA MISCBUFF,X
 STA ITEMBUFF,X
 INX
 BNE ]LOOP
 LDX :ITEMNUM
 PLP
 RTS
:ITEM DS 2
:ITEMNUM DS 1

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/ITEM.EDITOR
 fin

 END
