*-------------------------------
* ITEM2.EDITOR
*-------------------------------
 DAT
 LST OFF

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE VARS
 USE ITEM.DSECT
 USE ITEM2.DSECT
 USE LIB.JMP
 USE TABLES

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/ITEM2.EDITOR
 fin

NUMITEM = 7 ;Number of entries for a MAZE.ITEM

 MODID "ITEM2.EDITOR"

START JSR PRINT
 HOME
 BOX "Maze Item Editor"
 NULL
 LDX #0
 LDA #0
 JSR LOADSCEN
 LDA SCENBUFF
 STA MAXSCEN
 STZ :FLAG
 STZ :MON
 STZ :MON+1
 LDX #0
 LDA #0
 JSR LOADMAP
 LDA MAP
 STA NUMLVLS
 LDX #0
 LDA #0
 JSR LOADITEM
 LDA ITEMBUFF
 STA TOTITEMS
 LDX #0
 LDA #0
 JSR LOADITEM2
 LDA ITEM2BUFF
 STA :RECS
 JMP :FORW1
:BOT JSR PRINT
 GOTOXY 1;1
 ASC "Total in file : "
 COLOR YELLOW
 DEC8 :RECS
 COLOR WHITE
 ASC "  "
 GOTOXY 1;2
 ASC "Scenario      : "
 COLOR YELLOW
 DEC8 SCENARIO
 COLOR WHITE
 ASC "  "
 NULL
:BOTBIT JSR PRINT
 GOTOXY 0;23
 CLEOS
 ASC "[A]dd, [J]ump, [S]ave, [L]ist, [X], [RETURN]-edit, "
 MTON
 INVERSE
 ASC "H"
 NORMAL
 ASC ", "
 INVERSE
 ASC "U"
 NORMAL
 MTOFF
 ASC ", [H]elp, [Q]uit : "
 CURSORON
 NULL
 LDA CH
 STA :BGOTO+2
:GETKEY JSR PRINT
:BGOTO GOTOXY 0;23
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 LDX :KEYS
]LOOP2 CMP :KEYS,X
 BEQ :GOTONE
 DEX
 BNE ]LOOP2
 JMP ]LOOP
:GOTONE DEX
 TXA
 ASL
 TAX
 JMP (:TABLE,X)

:KEYS DFB :ENDKEYS-*-1
 DFB "Q"
 DFB "A"
 DFB "L"
 DFB "J"
 DFB "S"
 DFB "H"-$40
 DFB "U"-$40
 DFB "K"-$40
 DFB "J"-$40
 DFB "M"-$40
 DFB "H"
 DFB "X"
:ENDKEYS

:TABLE DA EXIT
 DA :ADD
 DA :LIST
 DA :LOAD
 DA :SAVE
 DA :BACK1
 DA :FORW1
 DA :UP
 DA :DOWN
 DA :EDIT
 DA :HELP
 DA :SCEN

:SCEN LDA MAXSCEN
 BEQL :GETKEY
 JSR PRINT
 NORMAL
 MTOFF
 GOTOXY 0;23
 ZAPLINE
 ASC "Change scenario to (max="
 DEC8 MAXSCEN
 ASC ") : "
 NULL
 GETLINE #1
 CPX #0
 BEQ :NO
 JSR GETNUM
 CPX MAXSCEN
 BEQ :OK
 BCS :NO
:OK STX SCENARIO
 JSR PRINT
 GOTOXY 0;4
 CLEOS
 NULL
 LDX #0
 LDA #0
 JSR LOADITEM2
 LDA ITEM2BUFF
 STA :RECS
 STZ :MON
 STZ :MON+1
 JMP :FORW1
:NO JMP :BOTBIT

:HELP JSR PRINT
 GOTOXY 0;4
 CLEOS
 NULL
 JSR GETFILE
 DFB 4,22 ;Use lines x to y
 STR "HELP/ITEM2.ED"
 JSR PRINT
 GOTOXY 0;23
 COLOR PINK
 NULL
 GETRETURN
 JSR PRINT
 GOTOXY 0;4
 COLOR WHITE
 CLEOS
 NULL
 JMP :IBACK

:DOPOINT LDA :OLDPNTR
 CMP #19
 BCC :PLEFT
 LDA #40
 STA :CH+2
 LDA :OLDPNTR
 SEC
 SBC #15
 STA :CV+2
 BRA :DOP1
:PLEFT STZ :CH+2
 LDA :OLDPNTR
 CLC
 ADC #3
 STA :CV+2
:DOP1 JSR PRINT
 NORMAL
 MTOFF
:CH HTAB 0
:CV VTAB 0
 ASC " "
 NULL
 LDA :PNTR
 CMP #19
 BCC :PLEFT2
 LDA #40
 STA :CH2+2
 LDA :PNTR
 SEC
 SBC #15
 STA :CV2+2
 BRA :DOP2
:PLEFT2 STZ :CH2+2
 LDA :PNTR
 CLC
 ADC #3
 STA :CV2+2
:DOP2 JSR PRINT
:CH2 HTAB 0
:CV2 VTAB 0
 NULL
 JSR SHOWPNTR
 LDA :PNTR
 STA :OLDPNTR
 RTS
:OLDPNTR DFB 1
:PNTR DFB 1

:UP LDA :RECS
 ORA :RECS+1
 BEQL :BOT
 LDA :PNTR
 CMP #1
 BNE :UPOK
 LDA #NUMITEM+1
:UPOK DEC
 STA :PNTR
 JSR :DOPOINT
 JMP :GETKEY

:DOWN LDA :RECS
 ORA :RECS+1
 BEQL :BOT
 LDA :PNTR
 CMP #NUMITEM
 BNE :DNOK
 LDA #0
:DNOK INC
 STA :PNTR
 JSR :DOPOINT
 JMP :GETKEY

:EDIT LDA :RECS
 ORA :RECS+1
 BEQL :BOT
 LDA :PNTR
 DEC
 ASL
 TAX
 JMP (:EDITS,X)

:EDITS DA :FREE
 DA :NUM
 DA :XPOS
 DA :YPOS
 DA :ZPOS
 DA :DATA
 DA :BURIED

:LOAD LDA :RECS
 ORA :RECS+1
 BEQL :BOT
 JSR PRINT
 GOTOXY 0;23
 CLEOS
 ASC "Jump to maze item #"
 CURSORON
 NULL
 GETLINE #3
 JSR GETNUM
 CPX #0
 BNE :LOK
 CPY #0
 BEQL :BOT
:LOK CPY #0
 BNEL :BOT
 CPX :RECS
 BEQ :RNGOK
 BCC :RNGOK
 JSR PRINT
 COLOR PINK
 ASC " No such maze item. "
 COLOR WHITE
 NULL
 GETRETURN
 JMP :BOT
:RNGOK STX :MON
 STY :MON+1
 TYA
 JSR LOADITEM2
 JSR :DISPLAY
 STZ :FLAG
 JMP :BOT

:SAVE LDA :RECS
 ORA :RECS+1
 BEQL :BOT
 BIT :FLAG
 BPLL :GETKEY
:SAVE2 LDX :MON
 LDA :MON+1
 JSR SAVEITEM2
 LDA #$FF
 STA RFLAG
 STZ :FLAG
 JMP :IBACK

:BACK1 LDA :RECS
 ORA :RECS+1
 BEQL :BOT
 LDA :MON+1
 BNE :GOB
 LDA :MON
 CMP #2
 BCS :GOB
 JMP :BOT
:GOB DECR :MON
 LDX :MON
 LDY :MON+1
 JMP :LOK

:FORW1 LDA :RECS
 ORA :RECS+1
 BEQL :BOT
 LDA :MON+1
 CMP :RECS+1
 BCC :GOF
 LDA :MON
 CMP :RECS
 BCC :GOF
 JMP :BOT
:GOF INCR :MON
 LDX :MON
 LDY :MON+1
 JMP :LOK

:LIST LDA :RECS
 ORA :RECS+1
 BEQL :BOT
 JSR PRINT
 GOTOXY 0;23
 CLEOS
 ASC "Start from maze item #1"
 CURSORLEFT
 NULL
 LDA PADFLAG
 STA TEMP
 LDA #$FF
 STA PADFLAG
 LDA PADCHAR
 STA TEMP+1
 LDA #" "
 STA PADCHAR
 LDA #1
 STA :TOREAD
 STZ :TOREAD+1
 GETLINE #5
 BCSL :LEXIT
 CPX #0
 BEQ :FROM1
 JSR GETNUM
 STX :TOREAD
 STY :TOREAD+1
:FROM1 LDA :TOREAD+1
 CMP :RECS+1
 BCC :VGO
 BEQ :FROMLO
 BCS :FROMNO
:FROMLO LDA :TOREAD
 CMP :RECS
 BCC :VGO
 BEQ :VGO
:FROMNO JSR PRINT
 ASC " - "
 COLOR PINK
 ASC "Last maze item is #"
 COLOR YELLOW
 DEC16 :RECS
 COLOR PINK
 ASC ". "
 COLOR WHITE
 NULL
 GETRETURN
 JSR PRINT
 ZAPLINE
 NULL
 JMP :LEXIT
:VGO LDA :TOREAD
 STA :MCNTR
 LDA :TOREAD+1
 STA :MCNTR+1
 JSR PRINT
 GOTOXY 0;3
 CLEOS
 CR
 COLOR AQUAMARINE
 LINE "Item/?/ X/ Y/Lvl/ Data      /Buried/Name"
 COLOR WHITE
 CURSOROFF
 NULL
]LOOP LDA :MCNTR+1
 CMP :RECS+1
 BCC :RREAD
 LDA :MCNTR
 CMP :RECS
 BCC :RREAD
 BEQ :RREAD
 JMP :RDONE
:RREAD LDX :TOREAD
 LDA :TOREAD+1
 JSR LOADITEM2
 INCR :TOREAD
 LDA CV
 CMP #21
 BNE :VOK
 JSR PRINT
 CR
 CR
 CURSORON
 COLOR YELLOW
 CENTER "[SPACE]-continue, [ESC]-exit : "
 COLOR WHITE
 NULL
]LOOP3 JSR KEYIN
 CMP #$9B
 BEQL :RESC
 CMP #" "
 BNE ]LOOP3
 JSR PRINT
 GOTOXY 0;5
 CLEOS
 CURSOROFF
 NULL
:VOK STZ INAME
 LDX INUM
 CPX #0
 BEQ :VOK2
 LDA #0
 JSR LOADITEM
:VOK2 JSR PRINT
 CR
 COLOR YELLOW
 DEC8 :MCNTR
 COLOR WHITE
 ASC ") "
 PRFLAG IFREE
 ASC " "
 COLOR GREEN
 PAD2 IXPOS
 COLOR WHITE
 ASC ","
 COLOR GREEN
 PAD2 IYPOS
 ASC "  "
 PAD2 IZPOS
 COLOR WHITE
 ASC " "
 COLOR PINK
 DEC32 IDATA
 ASC "     "
 COLOR WHITE
 PRFLAG IBURIED
 ASC "   "
 NULL
 LDA INUM
 BNE :NOTG
 JSR PRINT
 COLOR YELLOW
 ASC "Gold"
 COLOR WHITE
 NULL
 BRA :MNEXT
:NOTG JSR PRINT
 COLOR ORANGE
 PRSTRING INAME
 COLOR WHITE
 NULL
:MNEXT INCR :MCNTR
 LDA $C000
 BPLL ]LOOP
 STA $C010
 CMP #$9B
 BEQ :RDONE
 JMP ]LOOP
:RESC JSR PRINT
 ZAPLINE
 CURSORON
 NULL
 BRA :RDONE2
:RDONE JSR PRINT
 GOTOXY 0;23
 COLOR PINK
 CURSORON
 NULL
 GETRETURN
 JSR PRINT
 COLOR WHITE
 NULL
:RDONE2 LDA TEMP
 STA PADFLAG
 LDA TEMP+1
 STA PADCHAR
 LDX :MON
 LDY :MON+1
 JMP :LOK
:LEXIT LDA TEMP
 STA PADFLAG
 LDA TEMP+1
 STA PADCHAR
 JMP :BOT
:MCNTR DS 2
:TOREAD DA 2
:NAME DS 1+20

:DISPLAY LDA :RECS
 ORA :RECS+1
 BEQL :BOT
 STZ INAME
 LDX INUM
 CPX #0
 BEQ :DISP2
 LDA #0
 JSR LOADITEM
:DISP2 JSR PRINT
 GOTOXY 60;1
 ASC "Maze item #"
 COLOR YELLOW
 DEC16 :MON
 COLOR WHITE
 ASC " "
 GOTOXY 0;4
 CLEOS
 CURSOROFF
 ASC "  1 - Free..........."
 PRFLAG IFREE
 CR
 ASC "  2 - Number........."
 COLOR YELLOW
 DEC8 INUM
 COLOR WHITE
 ASC "="
 NULL
 LDA INUM
 BNE :DISP3
 JSR PRINT
 COLOR YELLOW
 ASC "gold"
 COLOR WHITE
 NULL
 BRA :DISP4
:DISP3 JSR PRINT
 COLOR ORANGE
 PRSTRING INAME
 COLOR WHITE
 NULL
:DISP4 JSR PRINT
 CR
 ASC "  3 - X position....."
 COLOR GREEN
 PAD2 IXPOS
 COLOR WHITE
 CR
 ASC "  4 - Y position....."
 COLOR GREEN
 PAD2 IYPOS
 COLOR WHITE
 CR
 ASC "  5 - Level.........."
 COLOR GREEN
 DEC8 IZPOS
 COLOR WHITE
 CR
 ASC "  6 - Data..........."
 COLOR PINK
 DEC32 IDATA
 COLOR WHITE
 CR
 ASC "  7 - Buried?........"
 PRFLAG IBURIED
 CR
 CURSORON
 NULL
 JMP :DOPOINT
:MON DS 2

:IBACK JSR PRINT
 GOTOXY 0;23
 CLEOS
 NULL
 JSR :DISPLAY
 LDA #$FF
 STA :FLAG
 JMP :BOT

:ADD JSR PRINT
 GOTOXY 0;23
 CLEOS
 ASC "Add - [N]ext free one, [E]nd of file, [ESC] Exit : "
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 CMP #$9B
 BEQL :BOT
 CMP #"N"
 BEQ :ANEXT
 CMP #"E"
 BNE ]LOOP
 JSR COUT
:AEND LDX #0
 LDA #0
 JSR LOADITEM2
 LDA ITEM2BUFF
 CMP #$FF
 BCC :AEOK
 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 COLOR PINK
 ASC "Cannot add any more maze items. "
 COLOR WHITE
 NULL
 GETRETURN
 JMP :ADD
:AEOK INCR ITEM2BUFF ;Add 1 to the number of maze items
 LDX #0
 LDA #0
 JSR SAVEITEM2 ;Save it out
 INCR :RECS
 LDA :RECS
 STA :MON
 LDA :RECS+1
 STA :MON+1
:AGOTIT LDX #0
]LOOP STZ ITEM2BUFF,X
 INX
 BNE ]LOOP
 JMP :SAVE2
:ANEXT JSR COUT
 LDX :MON
 LDY :MON+1
 STX :MONN
 STY :MONN+1
 LDA :RECS
 BNE :NXTOK
 LDA :RECS+1
 BEQL :AEND
:NXTOK
]LOOP LDA :MONN+1
 CMP :RECS+1
 BCC :NRNGOK
 LDA :MONN
 CMP :RECS
 BEQ :NRNGOK
 BCSL :AEND
:NRNGOK LDX :MONN
 LDA :MONN+1
 JSR LOADITEM2
 INCR :MONN
 LDA IFREE
 BPL ]LOOP
 DECR :MONN
 LDA :MONN
 STA :MON
 LDA :MONN+1
 STA :MON+1
 JMP :AGOTIT
:MONN DS 2

:FREE LDX #1
 LDY #1
 JSR ASK
 GETLINE #1
 CPX #0
 BEQL :IBACK
 LDA $200
 CMP #"1"
 BEQ :A1
 CMP #"0"
 BNE :FREE
 LDA #0
 HEX 2C
:A1 LDA #$FF
 STA IFREE
 JMP :IBACK

:NUM LDX #5
 LDY #2
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :NRTS
 JSR GETNUM
 DEX
 CPX TOTITEMS
 BCS :NRTS
 INX
 STX INUM
:NRTS JMP :IBACK

:XPOS LDX #5
 LDY #3
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :XRTS
 JSR GETNUM
 CPX #$10
 BCS :XRTS
 STX IXPOS
:XRTS JMP :IBACK

:YPOS LDX #5
 LDY #4
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :YRTS
 JSR GETNUM
 CPX #$10
 BCS :YRTS
 STX IYPOS
:YRTS JMP :IBACK

:ZPOS LDX #5
 LDY #5
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :ZRTS
 JSR GETNUM
 DEX
 CPX NUMLVLS
 BCS :ZRTS
 INX
 STX IZPOS
:ZRTS JMP :IBACK

:DATA LDX #5
 LDY #6
 JSR ASK
 GETLINE #10
 CPX #0
 BEQ :DRTS
 JSR GETNUM
 STX IDATA
 STY IDATA+1
 LDA VTEMP
 STA IDATA+2
 LDA VTEMP+1
 STA IDATA+3
:DRTS JMP :IBACK

:BURIED LDX #1
 LDY #7
 JSR ASK
 GETLINE #1
 CPX #0
 BEQL :IBACK
 LDA $200
 CMP #"1"
 BEQ :B1
 CMP #"0"
 BNE :BURIED
 LDA #0
 HEX 2C
:B1 LDA #$FF
 STA IBURIED
 JMP :IBACK

:RECS DS 2
:FLAG DS 1
:DDAY DS 1
:DMONTH DS 1
:DYEAR DS 1
:DENTRY DS 9

EXIT JSR PRINT
 NORMAL
 MTOFF
 HOME
 NULL
 LDA RFLAG
 BEQ :SKIP
 JSR PRINT
 COLOR AQUAMARINE
 ASC "Reclaiming"
 COLOR WHITE
 NULL
 JSR RECLAIM
:SKIP RETURN

TEMP DS 2
TOTITEMS DS 1
NUMLVLS DS 1
MAXSCEN DS 1
RFLAG DFB 0

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/ITEM2.EDITOR
 fin

 END
