*-------------------------------
* LIB.COMS (Library)
*-------------------------------
 DAT
 LST OFF

 XC
 XC

 REL

 USE MACROS
 USE EQUATES
 USE VARS

 do M16PLUS-1
 DSK LIB.COMS.L
 fin

 EXT PRINT ;Print
 EXT DROP,LIB_DEATH,DELAY,CHATFLAG,MLIERR ;Main
 EXT LOGNOTE ;Log

RX = %0000_0001
TX = %0000_0100
GPI = %0000_1000 ;General purpose input (mini-din-8 pin 7)
HSKI = %0010_0000 ;DTR handshake in (mini-din-8 pin 2)
*CARRIER = GPI

INITMODEM ENT
MODEMTALK ENT
 RTS

CHECKCTRLX ENT
 LDY QPNTR2
]LOOP CPY QPNTR
 BEQ :DONE
 LDA INBUFF,Y
 ORA #%1000_0000
 CMP #"X"-$40
 BEQ GETALL
 INY
 BRA ]LOOP
:DONE RTS

GETALL ENT
 LDA SCCCOMMAND
 LDA SCCDATA
 LDA QPNTR
 STA QPNTR2
 RTS

MGETBYTE ENT
]LOOP LDY QPNTR2
 CPY QPNTR
 BEQ ]LOOP
 LDA INBUFF,Y
 INC QPNTR2
 RTS

MSENDBYTE ENT
 PHA
 LDA SCCCOMMAND
]LOOP LDA FLOWCONTROL
 BPL :SKIP
 LDA SCCCOMMAND
 BIT #HSKI
 BEQ ]LOOP
:SKIP LDA SCCCOMMAND
 BIT #TX ;Ready to send? (transmit empty...)
 BEQ ]LOOP
 PLA
 STA SCCDATA
 RTS

HANGUP ENT
 BIT TESTFLAG
 BMI :FIN
 LDA STARTUPPATH
 BNE :FIN
 JSR INITCARD
 SETREG #14;#0 ;BRG disable
 SETREG #5;#%1110_0010 ;Tx disable
 SETREG #3;#%11_000000 ;Rx disable
* SETREG #9;#%01_000000 ;Reset channel B
 LDA #0
 JSR WAIT
:FIN RTS

READY ENT
 BIT TESTFLAG
 BPL :OK
 RTS
:OK JSR INITCARD
 GETREG #5
 AND #%0111_1111
 SETREG #5;A
 LDA #0
 JMP WAIT

CHECKIN2 ENT
 JSR CHECKIN
 LDA CHARIN
 RTS

CHECKIN ENT
 BIT TESTFLAG
 BPL :OK
 CLC
 RTS
:OK JSR CHECKDCD
 LDY QPNTR2 ;Data waiting in buffer?
 CPY QPNTR
 BEQ :NOPE
 LDA INBUFF,Y
 INC QPNTR2
:YEP STA CHARIN
 ORA #%1000_0000
 SEC
 RTS
:NOPE CLC
 RTS

CHARIN DS 1

CHECKMODEM ENT
 BIT TESTFLAG
 BPL :SERIOUS
 LDA #0
 CLC
 RTS
:SERIOUS LDA SCCCOMMAND
 AND #%0010_1000
 CLC
 RTS

GETP ENT
 LDAL $FFFFFF
 RTS

SAVP ENT
 STAL $FFFFFF
 RTS

INT ENT ;Interrupt routine
 CLD
 PHP
 SEI
 PHA
 PHY
 LDA SCCCOMMAND
 LDA SCCCOMMAND
 AND #%0000_0001
 BEQ :NO
 LDA SCCDATA
 LDY QPNTR
 STA INBUFF,Y
 INC QPNTR
 PLY
 PLA
 PLP
 CLC
 RTI
:NO PLY
 PLA
 PLP
 SEC
 RTI

QPNTR DS 1
QPNTR2 DS 1

SCCINTON ENT
 PHP ;Set values for serial port
 SEI

 CLC
 XCE
 REP #$30
 JSR $FE1F
 CPY #0
 BEQ :ZERO
 PHA
 PHA
 PEA #$000E ;SCC interrupt flag
 Tool $1603 ;GetAddr
 PullLong SCCPOINTER
:ZERO SEC
 XCE
 LDX #2
]LOOP LDA SCCPOINTER,X
 STA GETP+1,X
 STA SAVP+1,X
 DEX
 BPL ]LOOP
 JSR GETP
 STA SERFLAG
 ORA #%0000_0111 ;Port 2
 JSR SAVP ;Activate interrupts for serial port

 LDA $3FE
 STA IRQLOC
 LDA $3FF
 STA IRQLOC+1
 LDA #<INT
 STA $3FE
 LDA #>INT
 STA $3FF

 LDA #$FF
 STA SCCINTFLAG

 PLP
 CLC
 RTS

SCCINTOFF ENT
 PHP
 SEI
 SETREG #1;#0

 LDA IRQLOC
 STA $3FE
 LDA IRQLOC+1
 STA $3FF

 STZ SCCINTFLAG

 PLP
 RTS

SCCINTFLAG ENT
 DFB 0

INITCARD ENT
 LDA #HSKI
 STA CARRIER
 LDA FLOWCONTROL
 BPL :GO
 LDA #GPI
 STA CARRIER
:GO BIT SCCINTFLAG
 BMI :INTOK
 JSR SCCINTON

:INTOK SETREG #9;#%10 ;Master interrupts off
 SETREG #1;#0 ;No interrupts
 SETREG #2;#0
 SETREG #4;#%01_00_01_00 ;Parity stuff
 SETREG #3;#%11_000000 ;8 bit and disable receiver
 SETREG #5;#%0110_0010 ;DTR and DSR stuff
 SETREG #10;#0
 SETREG #11;#%0_10_10_0_10 ;Set for no eliminator and software BRG

 LDA BAUDRATE
 JSR SETZBAUD ;Set BRG time constant

 SETREG #14;#0
 SETREG #15;#0 ;No interrupts

 SETREG #14;#%1 ;BRG enable
 SETREG #5;#%0110_1010 ;Tx enable
 SETREG #3;#%11_000001 ;Rx enable

 SETREG #9;#%1010
 SETREG #1;#%10000 ;Interrupt me

 LDA SCCCOMMAND

 LDA #0
 JMP WAIT

GETPORTREG ENT
 LDA SCCCOMMAND
 STX SCCCOMMAND
 LDA SCCCOMMAND
 RTS

SETPORTREG ENT
 PHA
 LDA SCCCOMMAND
 PLA
 STX SCCCOMMAND
 STA SCCCOMMAND
 RTS

*------------------------------- RB's stuff

SETZBAUD ASL
 TAY
 SETREG #12;:TBL,Y
 SETREG #13;:TBL+1,Y
 RTS

:TBL DA $0004 ;0=19200
 DA $017E ;1=300
 DA $005E ;2=1200
 DA $002E ;3=2400
 DA $0016 ;4=4800
 DA $000E ;5=7200
 DA $000A ;6=9600
 DA $0004 ;7=12000
 DA $0004 ;8=14400
 DA $0004 ;9=19200

*-------------------------------

CHECKDCD ENT
 BIT TESTFLAG
 BPL :OK
 RTS
:OK BIT CONNECTED
 BMI :OK2
 RTS
:OK2 LDA SCCCOMMAND
 LDA SCCCOMMAND
 BIT CARRIER
 BEQ :ERR
 RTS
:ERR LDA #$FF
 STA DUMBTERM
 STZ CONNECTED
 STZ CHATFLAG
 JSR PRINT
 MTOFF
 NORMAL
 CURSORON
 HOME
 ASC "Lost carrier"
 NULL
 NOTELOG $1;"Lost carrier"
 JMP DROP

CARRIER DS 1

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV LIB.COMS.L
 fin

 END
