*-------------------------------
* LIB.DISK (Library)
*-------------------------------
 DAT
 LST OFF

 XC
 XC

 REL

 USE MACROS
 USE EQUATES

 do M16PLUS-1
 DSK LIB.DISK.L
 fin

 EXT GETCADD ;Print
 EXT CLOSEALL,MLIERR ;Main
 EXT FILE ;Files

MSGFILE = 8 ;MESSAGES file

*-------------------------------
* Call format:
*
*        JSR   [routine]
*        STR   "[filename]"
*        DA    [buffer]
*        DA    [record to read/write from/to]
*        DA    [bytes to read/write] --> only for READ/WRITE SLICE
*-------------------------------
* For all calls:
*
* A = MLI call number
* X = whole/slice of file (flag)
*-------------------------------
CHECKFILE ENT
 LDA #$C4
 BRA DOFILE
LOADFILE ENT
 LDA #$CA
 LDX #$FF
 BRA DOFILE
SAVEFILE ENT
 LDA #$CB
 LDX #$FF
 BRA DOFILE
LOADSLICE ENT
 LDA #$CA
 LDX #0
 BRA DOFILE
SAVESLICE ENT
 LDA #$CB
 LDX #0
 BRA DOFILE

DOFILE STA MLICALL
 STX WHOLEFILE
 PLA
 STA CADD
 PLA
 STA CADD+1
 JSR GETCADD
 STA PATHNAME
 TAX
 LDY #0
]LOOP INY
 PHY
 JSR GETCADD
 PLY
 STA PATHNAME,Y
 DEX
 BNE ]LOOP

 LDA MLICALL
 CMP #$C4
 BNE :CONT
 MLI_GET_FILE_INFO VPARMS
 JMP DRETURN ;Return code is carry bit

:CONT JSR GETCADD
 STA DBUFF
 JSR GETCADD
 STA DBUFF+1
 STZ SKIPFLAG
 BRA :OPEN

:CLALL JSR CLOSEALL
 LDA #$FF
 STA CAFLAG
 BRA :OPEN2
:OPEN LDA #0
 STA CAFLAG
 LDX PATHNAME
 CPX OLDPATH
 BNE :OPEN2
]LOOP LDA PATHNAME,X
 ORA #%1000_0000
 CMP OLDPATH,X
 BNE :OPEN2
 DEX
 BNE ]LOOP
 BRA :OVER
:OPEN2 MLI_OPEN OPARMS ;Open the file
 BCC :BADB
 CMP #$50 ;File already open
 BEQ :OVER
 BIT CAFLAG ;We done a CLOSEALL?
 BMI :BADB
 CMP #$56 ;Bad buffer address
 BEQ :CLALL ;(have to close everything then)
:BADB JSR MLIERR
 LDA REFNUM
 STA SGPARMS+1
 STA GMPARMS+1
 STA RWPARMS+1
 STA CPARMS+1
 LDX PATHNAME
 STX OLDPATH
]LOOP LDA PATHNAME,X
 ORA #%1000_0000
 STA OLDPATH,X
 DEX
 BNE ]LOOP

:OVER BIT WHOLEFILE ;Going to read/write an entire file?
 BPL :SLICE

 BIT SKIPFLAG
 BMI :SKIP1
 LDX #0 ;Set the mark to read from
]LOOP JSR GETCADD
 STA POSITION,X
 INX
 CPX #4
 BNE ]LOOP
:SKIP1 LDX #2
]LOOP LDA POSITION,X
 BNE :DOMARK
 DEX
 BPL ]LOOP
 BRA :CONT2
:DOMARK MLI_SET_MARK SGPARMS
 JSR MLIERR

:CONT2 MLI_GET_EOF SGPARMS
 JSR MLIERR
 LDA POSITION
 STA REQLEN
 LDA POSITION+1
 STA REQLEN+1
 JMP :DO

:SLICE BIT SKIPFLAG
 BMI :SKIP2
 JSR GETCADD ;Get the record we want
 STA RECORD ;First record is 0
 JSR GETCADD
 STA RECORD+1
 JSR GETCADD
 STA REQLEN
 JSR GETCADD
 STA REQLEN+1
:SKIP2 STZ POSITION
 STZ POSITION+1
 STZ POSITION+2
 LDX RECORD
 LDY RECORD+1
]LOOP CPX #0
 BEQ :CHKY
]LOOP2 DEX
 LDA POSITION
 CLC
 ADC REQLEN
 STA POSITION
 LDA POSITION+1
 ADC REQLEN+1
 STA POSITION+1
 LDA POSITION+2
 ADC #0
 STA POSITION+2
 BRA ]LOOP
:CHKY CPY #0
 BEQ :SLDONE
 DEY
 BRA ]LOOP2
:SLDONE MLI_GET_MARK GMPARMS
 BCS :SETM
 LDX #2
]LOOP LDA GMPARMS+2,X
 CMP POSITION,X
 BNE :SETM
 DEX
 BPL ]LOOP
 BRA :DO

:SKIPPY LDA #$FF
 STA SKIPFLAG
 STZ OLDPATH
 JMP :CLALL

:SETM MLI_SET_MARK SGPARMS
 BCC :DO
 CMP #$43 ;Invalid ref num
 BEQ :SKIPPY
 CMP #$4D ;Past EOF? (for MESSAGES file only)
 BNE :MKERR
 LDX FILE
 CPX #MSGFILE ;MESSAGES
 BEQ :DO
:MKERR JSR MLIERR

:DO JSR MLI
MLICALL DS 1
 DA RWPARMS
 BCC :DOOK
 LDX FILE
 CPX #MSGFILE
 BNE :DOOK
 STZ MSGBUFF ;Message not found, so make it empty.
 CLC
 LDA #0
:DOOK JSR MLIERR

 BIT WHOLEFILE
 BPL DRETURN

 MLI_CLOSE CPARMS
 JSR MLIERR
 STZ OLDPATH

DRETURN LDA CADD+1
 PHA
 LDA CADD
 PHA
 RTS

OPARMS DFB 3 ;Open
 DA PATHNAME
 DA IOBUFFER
REFNUM DS 1

RWPARMS DFB 4 ;Read / Write
 DS 1
DBUFF DA 0
REQLEN DA 0
ACTLEN DA 0

CPARMS DFB 1 ;Close
 DS 1

SGPARMS DFB 2 ;Set_Mark / Get_Mark / Set_EOF / Get_EOF
 DS 1 ;Set_Buf / Get_Buf
POSITION DS 4

GMPARMS DFB 2 ;Get_Mark
 DS 1
 DS 3

VPARMS DFB $A ;Get_File_Info / Set_File_Info
 DA PATHNAME
 DS 15

OLDPATH DS 1+31

PATHNAME DS 1+31
WHOLEFILE DS 1 ;Flag (see top)
RECORD DS 2 ;Record to read/write

CAFLAG DS 1
SKIPFLAG DS 1 ;For slice reading/writing

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV LIB.DISK.L
 fin

 END
