*-------------------------------
* LIB.MAIN (Library)
*-------------------------------
 DAT
 LST OFF

 XC
 XC

 REL

 USE MACROS
 USE EQUATES
 USE VARS
 USE PLR.DSECT
 USE TABLES
 USE ITEM.DSECT
 USE PN.DSECT
 USE LOG.DSECT

 do M16PLUS-1
 DSK LIB.MAIN.L
 fin

 EXT PRINT,GETCADD,GETCADD2,GETADDR,BASCALC,TEXTCOLOR ;Print
 EXT CHECKIN,HANGUP,CHECKDCD,MSENDBYTE,SAVP,INITCARD ;Coms
 EXT SCCINTOFF,SCCINTFLAG,GETALL,CHECKCTRLX ;Coms
 EXT POPMOD,EXECUTE ;Mod
 EXT LOADPN,SAVEPN,LOADITEM,LOADLOGFILE,SAVELOGFILE ;Files
 EXT LOADMAP,SAVEMAP,SAVEVARS
 EXT NOTEPAD,GETSCREEN,SHOWMSG ;Msg
 EXT LOGNOTE,LOGNOTESTR,LOGNOTENUM,LOGNOTEBUFF ;Log
 EXT PLOGNOTE,PLOGNOTESTR,PLOGNOTENUM,PLOGNOTEBUFF
 EXT LOADFILE ;Disk
 EXT PRCOUT ;SHR

RESET ENT
 LDX #$FF
 TXS
 JSR CLOSEALL
 LDA QSAVE
 AND #%1110_0111
 STA $C035
 JSR SCCINTOFF
 JSR INITCARD
 LDA #$FF
 STA DUMBTERM
 JSR INITHOOK
 JSR PRINT
 NORMAL
 MTOFF
 HOME
 CURSORON
 LINE "[RESET]"
 NULL
 DEATH

ERROR ENT ;For Tool calls
 BCS :OOPS
 RTS
:OOPS SEC
 XCE
 JSR PRINT
 CR
 NORMAL
 ASC "Error $"
 HEX16 TOOLERR
 ASC " from tool $"
 HEX16 TOOLNUM
 CLEOL
 NULL
 LDA CV
 STA VTEMP
 JSR LOGERROR
 DEATH

MLIERR ENT
 EOR #0
 BNE :OOPS
 RTS
:OOPS PHA
 LDA #%1000_0000 ;Force text mode
 TRB $C029
 JSR PRINT
 CR
 NORMAL
 ASC "MLI error $"
 NULL
 LDA CV
 STA VTEMP
 PLA
 JSR PRBYTE
 JSR PRINT
 ASC " called from $"
 NULL
 LDA $BF9C
 SEC
 SBC #6
 PHA
 LDA $BF9D
 SBC #0
 JSR PRBYTE
 PLA
 JSR PRBYTE
 JSR PRINT
 CLEOL
 NULL
 JSR LOGERROR
 DEATH

INITHOOK ENT
 LDA #<RESET
 STA $3F2
 LDA #>RESET
 STA $3F3
 JSR $FB6F
 LDA #$8C
 JSR $C300
 LDA #<MYCOUT
 STA $36
 LDA #>MYCOUT
 STA $37
 LDA #<MYKEYIN
 STA $38
 LDA #>MYKEYIN
 STA $39

 LDA #%0000_1111
 TRB $C034 ;Make it black
 LDA #%1111_0000 ;White text, Black background
 STA $C022

 STZ CHATFLAG

 BIT SHRFLAG ;SHR or text?
 BMI :SHR

:TEXT LDX $C30D
 STX :MOD+1
 LDX #$C3
 LDY #$30
 LDA #$8C
:MOD JSR $C3FF
 LDA #%1000_0000
 TRB $C029 ;Text
 RTS

:SHR STA $C00D ;Enable 80-column hardware
 STA $C001 ;Enable 80-column store

 LDA #%0100_0000
 TSB $C029

 CLC ;Super Hi-Res stuff..
 XCE
 REP #$30
 LDX #$2000 ;Clean up SHR display
]LOOP LDA #0
 STAL SHRLOC,X
 INX
 INX
 CPX #$9D00
 BNE ]LOOP
 SEP #$20 ;Set 640 mode, interrupts off, fill mode off
]LOOP LDA #%1000_0000
 STAL SHRLOC,X
 INX
 CPX #$9DC8
 BNE ]LOOP
 REP #$20
 LDX #$9E00 ;Set up palette
 LDY #0
]LOOP LDA MYPALETTE,Y
 STAL SHRLOC,X
 INY
 INY
 INX
 INX
 CPX #$9E20
 BNE ]LOOP
 SEC
 XCE
 LDA #%1000_0000
 TSB $C029
 RTS

MYPALETTE DA $000 ;0
 DA $00F ;1
 DA $FF0 ;2
 DA $FFF ;3
 DA $000 ;4
 DA $D00 ;5
 DA $0E0 ;6
 DA $FFF ;7
 DA $000 ;8
 DA $00F ;9
 DA $FF0 ;A
 DA $FFF ;B
 DA $000 ;C
 DA $D00 ;D
 DA $0E0 ;E
 DA $FFF ;F

MYCOUT PHX
 PHY
 CMP #" "
 BCS :CHAR
 STA :A
 LDA VMODE
 AND #%0000_1000
 BNE :CHAR1 ;GOTOXY in progress
 LDA :A
 AND #%0111_1111
 CMP #$D
 BNE :CHAR1
 JSR COUT1
 LDA #$A
 BRA :CHAR
:CHAR1 LDA :A
:CHAR JSR COUT1
 PLY
 PLX
 RTS
:A DS 1

COUT1 STA :A
 BIT CONNECTED
 BPL :CONSOLE
 JSR CHECKDCD
 BIT DUMBTERM
 BMI :CONSOLE
 LDA :A
 AND #%0111_1111
 JSR MSENDBYTE
:CONSOLE LDA :A
 BIT SHRFLAG
 BMIL PRCOUT ;SHR output
 JMP PWRITE ;Text
:A DS 1

MYKEYIN JSR INITCNTR
 STA $C010
]LOOP JSR TICKTOCK
 BIT CONNECTED
 BPL :DUMB
 BIT DUMBTERM
 BMI :DUMB
 JSR CHECKDCD
:DUMB LDA #1
 JSR PSTATUS
 BCS :KEYT
 JSR CHECKIN ;We get byte from modem?
 BCC ]LOOP
 PHA
 JSR CHECKCTRLX
 PLA
 ORA #%1000_0000
 CMP #"R"-$40
 BEQL :CTRLR
 CMP #"^"-$40 ;Notepad
 BEQ :NPAD
 CMP #"W"-$40 ;Refresh screen
 BEQ :REFRESH
 CMP #"G"-$40 ;Bell
 BEQ ]LOOP
 JMP INITCNTR
:KEYT JSR PREAD
 ORA #%1000_0000
 CMP #"Q"-$40 ;Quit
 BEQL QUIT
 CMP #"@"-$40 ;Reboot
 BEQL REBOOT
 CMP #"^"-$40 ;Notepad
 BEQ :NPAD
 CMP #"A"-$40 ;Chat mode
 BEQ :CHAT
 CMP #"W"-$40 ;Refresh screen
 BEQ :REFRESH
 CMP #"R"-$40 ;Restart
 BEQL :RESTART
 CMP #"I"-$40 ;GM status toggle
 BEQL TOGGLEGM
 JMP INITCNTR

:CHAT BIT CHATFLAG
 BMI :NO
 LDA #%0000_1111
 TRB $C034 ;Make it black
 JSR CHAT
 JSR PRINT
 COLOR WHITE
 NULL
:NO JMP MYKEYIN

:REFRESH BIT CHATFLAG
 BMI :NO
 JSR REFRESH
 JMP MYKEYIN

:NPAD BIT :NPADFLAG
 BMI :NO
 LDA PARTYNUM
 BEQ :NO
 DEC :NPADFLAG
 JSR NOTEPAD
 JSR PRINT
 COLOR WHITE
 NULL
 STZ :NPADFLAG
 JMP MYKEYIN

:CTRLR LDA SYSOPFLAG
 BMI :CTRLR2
 RTS
:CTRLR2 NOTELOG $F;"RESTART initiated from remote console"
:CTRLR3 JSR POPMOD
 EXEC "GAME.SYSOP"

:RESTART NOTELOG $F;"RESTART initiated on master console"
 LDA SYSOPFLAG
 BMI :CTRLR3
 JMP RESTART

:NPADFLAG DFB 0
:TRFLAG DFB 0

CHATFLAG ENT
 DFB 0

INITCNTR ENT
 PHA
 BIT SHRFLAG
 BPL :FIN
 LDX HBYTE
]LOOP ASL BCNTR
 ASL BCNTR
 BCS :HMM
 LDAL SHRLOC+$9D00-$A0,X
 EOR BCNTR
 STAL SHRLOC+$9D00-$A0,X
 BRA ]LOOP
:HMM CPX #0
 BEQ :OK
]LOOP DEX
 CPX #$FF
 BEQ :OK
 LDAL SHRLOC+$9D00-$A0,X
 EOR #$FF
 STAL SHRLOC+$9D00-$A0,X
 BRA ]LOOP
:OK LDA #%1100_0000
 STA BCNTR
 STZ HBYTE
:FIN STZ MINUTE
 PLA
 RTS

TICKTOCK ENT
 CLC
 XCE
 REP #$30
 PushWord #0
 PushWord #0
 PushWord #0
 PushWord #0
 Tool $0D03 ;ReadTimeHex
 PLA
 PLX
 PLX
 PLX
 SEC
 XCE
 CMP GSECOND
 BNE :HMM
 RTS
:HMM STA GSECOND
 INC SECOND
 LDA SECOND
 CMP #60
 BNE :OK
 STZ SECOND
 INC MINUTE
 LDA MINUTE
 AND #%0000_0011
 BNE :OK
 BIT SOUNDFLAG
 BPL :BEEP
:OI JSR PRINT
 SOUND $2A;1;$FF
 NULL
 BRA :OK
:BEEP JSR PRINT
 BELL
 NULL
:OK LDA HBYTE
 CMP #$A0
 BCC :DOLINE
 JSR PRINT
 HOME
 LINE "Time-out period expired. Goodbye."
 NULL
 NOTELOG $F;"Timed out"
 LDA PARTYNUM
 BEQ :NOP
 PNOTELOG $F;"Time-out period expired"
:NOP JMP DROP

:DOLINE BIT SHRFLAG
 BPL :FIN
 LDX HBYTE
 LDAL SHRLOC+$9D00-$A0,X
 EOR BCNTR
 STAL SHRLOC+$9D00-$A0,X
 LSR BCNTR
 LSR BCNTR
 BCC :FIN
 LDA #%1100_0000
 STA BCNTR
 INC HBYTE
:FIN RTS

GSECOND DS 1

SECOND DS 1
MINUTE DS 1

HBYTE DS 1
BCNTR DFB %1100_0000

TOGGLEGM PHA
 BIT $C061
 BPL :EXIT
 LDA GMSTATUS
 EOR #$FF
 STA GMSTATUS
 LDA CH
 STA :XY+2
 LDA CV
 STA :XY+3
 LDA TEXTCOLOR
 STA :COLOR+2
 BIT SHRFLAG
 BMI :SHR
 BIT GMSTATUS
 BMI :TIN
:TOUT LDA #"O"
 HEX 2C
:TIN LDA #"I"
 BIT $C055
 STA $7D0+39
 BIT $C054
 BRA :EXIT
:SHR LDA DUMBTERM
 PHA
 LDA #$FF
 STA DUMBTERM
 BIT GMSTATUS
 BMI :IN
:OUT JSR PRINT
 GOTOXY 75;24
 COLOR AQUAMARINE
 ASC "Out"
 NULL
 BRA :FIN
:IN JSR PRINT
 GOTOXY 75;24
 COLOR PINK
 ASC "In "
 NULL
:FIN JSR PRINT
:XY GOTOXY 0;0
:COLOR COLOR 0
 NULL
 PLA
 STA DUMBTERM
:EXIT PLA
 RTS

DROP ENT
 LDA #$FF
 STA DUMBTERM
 STZ CONNECTED
 JSR HANGUP
RESTART ENT
 LDX #$FF
 TXS
 JSR POPMOD
 JSR INITCNTR
 JSR CLOSEALL
 JSR PRINT
 NORMAL
 MTOFF
 HOME
 CURSOROFF
 ASC "Wait.."
 NULL
 LDA SYSOPFLAG
 BMIL :EXIT
 MLI_GET_TIME
 LDX PARTYNUM
 CPX #0
 BEQ :EXIT
 LDX PARTYNUM
 LDA #0
 JSR LOADPN
 LDA $BF90
 STA PNLASTON
 LDA $BF91
 STA PNLASTON+1
 LDX PARTYNUM
 STX :PARTY
 LDA #0
 JSR SAVEPN
 PNOTELOG $F;"Logoff"
 NOTELOGSTR $F;"Logoff. Party = ";PNNAME
:EXIT JSR SAVEVARS
 LDA STARTUPCODE
 CMP #FUNC_USER
 BNE :EXIT2
 LDA #$FF ;Shutdown/quit
 STA STARTUPCODE
:EXIT2 EXEC "GAME.INIT"
:FLAG DS 1
:PARTY DS 4

PREAD LDX $C30E
 BRA PDO
PWRITE ENT
 LDX $C30F
 BRA PDO
PSTATUS LDX $C310
PDO STX :MOD+1
 LDX #$C3
 LDY #$30
:MOD JMP $C3FF

ROLLD6 ENT ;Result is in VTEMP
 STX VTEMP+1
 STZ VTEMP
 CPX #0
 BEQ :ZERO
]LOOP LDX #6
 LDA #0
 JSR RANDOM
 TXA
 CLC
 ADC VTEMP
 STA VTEMP
 DEC VTEMP+1
 BNE ]LOOP
:ZERO RTS

* Bit  Can only be used by
*-------------------------------
*  7 - High Priest           eg; 0001_0011 means that Ninjas, Theives,
*  6 - High Mage                 and Fighters can use this item
*  5 - Bard
*  4 - Ninja
*
*  3 - Cleric
*  2 - Wizard
*  1 - Thief
*  0 - Fighter
*
CHECKUSE ENT
 STA :CLASS
 CMP #0
 BNE :OK
:NOTOK SEC
 RTS
:OK LDA :CLASS
 CMP #9 ;Lord's can use everything
 BEQ :USEOK
 LDA #1
 LDX :CLASS
]LOOP DEX
 CPX #0
 BEQ :DONE
 ASL
 BRA ]LOOP
:DONE AND IUSEBY
 BEQ :NOTOK
:USEOK CLC
 RTS
:CLASS DS 1

DELAY ENT
 BIT DELAYFLAG
 BMI DELAY3
 RTS
DELAY2 ENT
 BIT SHRFLAG
 BPL DELAY3
 RTS
DELAY3 ENT
 LDY #16
 HEX 2C
 LDY #1
 STY :DELAY
]LOOP LDY :DELAY
]LOOP1 LDA $C061
 BMI :RTS
 LDA $C019
 BPL ]LOOP1
]LOOP2 LDA $C061
 BMI :RTS
 LDA $C019
 BMI ]LOOP2
 DEY
 BNE ]LOOP1
 DEX
 BNE ]LOOP
:RTS RTS
:DELAY DS 1

UPPER ENT
 CMP #$E0
 BCC :OK
 CMP #"z"+1
 BCS :OK
 AND #$DF
:OK RTS

SHUTDOWN CLC ;Discard all handles used and shutdown tools
 XCE
 REP #$30

 PushWord MYID
 Tool $1102 ;DisposeAll
 JSR ERROR

 Tool $030B ;IMShutDown

 Tool $0303 ;MTShutDown

 PushWord USERID
 Tool $0302 ;MMShutDown

 Tool $0301 ;TLShutDown

 SEC
 XCE

 LDA BORDER ;Restore border color
 STA $C034
 LDA TBCOLOR
 STA $C022
 RTS

QUIT ENT
 JSR DOWN
 JSR $FC58
 JSR $FE84
 JSR $FE89
 JSR $FE93
 STA $C000
 STA $C00C
 JSR $FB2F
 JSR $FC58
 LDA #%1000_0000
 TRB $C029
 LDA QSAVE
 STA $C035
 LDA SLOTSAVE
 STA $C02D
 LDA STARTUPPATH
 BNEL LAUNCHER
 LDA $D100
 CMP #$AD
 BEQ REBOOT2
 MLI_QUIT QPARMS

REBOOT ENT
 JSR DOWN
REBOOT2 LDX #$FF
 TXS
 STA $C00C
 JSR $FE84
 JSR $FE89
 JSR $FE93
 JSR $FB2F
 JSR $FC58
 JMP $FAA6

DOWN JSR CLOSEALL
 LDA #$FF
 STA DUMBTERM
 STZ CONNECTED
 JSR PRINT
 NORMAL
 MTOFF
 HOME
 CURSORON
 ASC "Shutdown in progress.."
 NULL

 BIT TESTFLAG
 BMI :CHKINT
 LDA STARTUPPATH
 BNE :CHKINT
 BIT SMARTMODEM
 BPL :DUMB
:SMART JSR INITCARD

 JSR GETALL

 LDX #0
]LOOP LDA :MTXT,X
 BEQ :CONT
 PHX
 JSR MSENDBYTE
 JSR GETALL
 PLX
 INX
 BRA ]LOOP

:DUMB JSR HANGUP
 BRA :CHKINT

:CONT JSR GETALL
 STZ VTEMP
]LOOP JSR CHECKIN
 BCS :CHAR
 INC VTEMP
 LDA VTEMP
 CMP #4
 BEQ :CHKINT
 JSR :VBL
:CHAR JSR GETALL
 BRA ]LOOP

:CHKINT LDA SCCINTFLAG
 BPL :NOINT
 JSR SCCINTOFF
:NOINT JSR SHUTDOWN ;Shutdown Tools

 LDA RVEC
 STA $3F2
 LDA RVEC+1
 STA $3F3
 JSR $FB6F
 JSR PRINT
 MTOFF
 NORMAL
 HOME
 NULL

 NOTELOG $7;"*** End of session ***"

 LDA #%1000_0000
 TRB $C029
 JMP CLOSEALL

:VBL LDY #30
]LOOP LDA $C019
 BPL ]LOOP
]LOOP2 LDA $C019
 BMI ]LOOP2
 DEY
 BNE ]LOOP
 RTS

:MTXT LINE 'ATZ'
 NULL

QPARMS DFB 4
 DS 6

CLOSEALL ENT
 MLI_CLOSE :CPARMS
 JMP MLIERR
:CPARMS DFB 1
 DFB 0

SETRANDSEED ENT
 CLC
 XCE
 REP #$30
 PushWord #0
 PushWord #0
 PushWord #0
 PushWord #0
 Tool $0D03 ;ReadTimeHex
 LDX #0
]LOOP PLA
 STA MISCBUFF,X
 INX
 INX
 CPX #4*2
 BNE ]LOOP
 PushLong MISCBUFF
 Tool $8704 ;SetRandSeed
 SEC
 XCE
SETDSKACC ENT
 RTS

RANDOM ENT
 STX :MAX
 STA :MAX+1
 CLC
 XCE
 REP #$30
 LDA :MAX
 BEQ :ZERO
 JSR :GETCLIP
 PHX
 JSR :RND
 PLX
 AND :TBL,X
]LOOP CMP :MAX
 BCC :OK
 SBC :MAX
 BRA ]LOOP
:OK INC
 STA :MAX
:ZERO SEC
 XCE
 LDX :MAX
 LDA :MAX+1
 RTS

 mx %00
:GETCLIP LDX #16*2
]LOOP DEX
 DEX
 ASL
 BCC ]LOOP
 RTS

:RND PHA
 Tool $8604 ;Random
 PLA
:MOD1 ADC #0
:MOD2 ADC #0
 INC :MOD2+1
 STA :MOD1+1
 SEP $20
 ADC $C02E
 ADC $C070
 REP $20
 RTS

:TBL DA $1,$F,$F,$1F
 DA $1F,$3F,$7F,$FF
 DA $1FF,$3FF,$7FF,$FFF
 DA $1FFF,$3FFF,$7FFF,$FFFF

:MAX DS 2
 mx %11

GETCR ENT
 JSR PRINT
 ASC "Press [RETURN] : "
 NULL
]LOOP JSR KEYIN
 CMP #$8D
 BNE ]LOOP
 RTS

* X = from
* Y = to
* A = line
PICKLINE ENT
 STX :FROM
 STY :TO
 JSR BASCALC
 LDA $28
 STA CADD3
 LDA $29
 STA CADD3+1
 LDX #0
]LOOP LDA :FROM
 LSR
 BCS :PAGE1
 STA $C055
:PAGE1 TAY
 LDA (CADD3),Y
 STA $C054
 STA $200,X
 INX
 INC :FROM
 LDA :FROM
 CMP :TO
 BCC ]LOOP
 BEQ ]LOOP
 RTS
:FROM DS 1
:TO DS 1

GET_LINE ENT
 STX :CHARMAX
 LDA #0
 STA :LENGTH
]LOOP JSR KEYIN
 CMP #$FF
 BEQ :DODEL
 CMP #$A0
 BCS :CHAR
 CMP #$8D
 BEQ :RETURN
 CMP #$88
 BEQ :DODEL ;BEQ :BS
 CMP #"X"-$40
 BEQ :CTRLX
 CMP #$9B
 BNE ]LOOP
 LDX #0
 SEC
 RTS
:CHAR LDX :LENGTH
 CPX :CHARMAX
 BCS ]LOOP
 STA $200,X
 BIT ECHO
 BMI :CECHO
 LDA #"x"
:CECHO JSR COUT
 INC :LENGTH
 BRA ]LOOP
:RETURN LDX :LENGTH
 STA $200,X
 CLC
 RTS
:BS LDA :LENGTH
 BEQ ]LOOP
 JSR :DOBS
 BRA ]LOOP
:CTRLX LDA :LENGTH
 BEQ ]LOOP
 JSR :DEL
 JMP :CTRLX
:DOBS DEC :LENGTH
 LDA #$08
 JMP COUT
:DODEL LDA :LENGTH
 BEQ :DELBRA
 JSR :DEL
:DELBRA JMP ]LOOP
:DEL DEC :LENGTH
 LDA #$08
 JSR COUT
 LDA #" "
 JSR COUT
 LDA #$08
 JMP COUT
:LENGTH DS 1
:CHARMAX DS 1

GETNIBBLE ENT
 STX :LEN
 STZ :NUM
 LDX #0
]LOOP CPX :LEN
 BEQ :DONE
 ASL :NUM
 LDA $200,X
 AND #%0000_0001
 ORA :NUM
 STA :NUM
 INX
 BRA ]LOOP
:DONE LDX :NUM
 LDA #0
 RTS
:LEN DS 1
:NUM DS 1

GETNUM ENT
 CPX #0
 BEQL :ZERO
 DEX
 STX :PTR
 LDA $200
 CMP #"-"
 BNE :POS
 LDA #$FF
 HEX 2C
:POS LDA #0
 STA :NEGFLAG
 INC
 EOR #%0000_0001
 TAY
 LDA $200,Y
 JSR ISDEC
 BCSL :ZERO
 LDY #0
 STY :VAL
 STY :NUM
 STY :NUM+1
 STY :NUM+2
 STY :NUM+3
]LOOP1 LDA $200,X
 CMP #" "
 BEQ :NEXT
 JSR ISDEC
 BCS :FIN
 TAX
]LOOP CPX #0
 BEQ :NEXT1
 LDY :VAL
 LDA :TABLE,Y
 CLC
 ADC :NUM
 STA :NUM
 LDA :TABLE+1,Y
 ADC :NUM+1
 STA :NUM+1
 LDA :TABLE+2,Y
 ADC :NUM+2
 STA :NUM+2
 LDA :TABLE+3,Y
 ADC :NUM+3
 STA :NUM+3
 DEX
 JMP ]LOOP
:NEXT1 LDA :VAL
 CLC
 ADC #4
 STA :VAL
:NEXT LDX :PTR
 DEX
 STX :PTR
 BPL ]LOOP1
:FIN BIT :NEGFLAG
 BPL :POS2
 LDX #3
]LOOP LDA :NUM,X
 EOR #$FF
 STA :NUM,X
 DEX
 BPL ]LOOP
 LDA :NUM
 CLC
 ADC #1
 STA :NUM
 LDA :NUM+1
 ADC #0
 STA :NUM+1
 LDA :NUM+2
 ADC #0
 STA :NUM+2
 LDA :NUM+3
 ADC #0
 STA :NUM+3
:POS2 LDX :NUM
 LDY :NUM+1
 LDA :NUM+2
 STA VTEMP
 LDA :NUM+3
 STA VTEMP+1
 RTS
:ZERO LDX #0
 LDY #0
 STZ VTEMP
 STZ VTEMP+1
 RTS
:VAL DS 1
:PTR DS 1
:NUM DS 4
:NEGFLAG DS 1
:TABLE ADRL 1
 ADRL 10
 ADRL 100
 ADRL 1000
 ADRL 10000
 ADRL 100000
 ADRL 1000000
 ADRL 10000000
 ADRL 100000000
 ADRL 1000000000

ISDEC CMP #"0"
 BCC :ERR
 CMP #"9"+1
 BCC :OK
:ERR SEC
 RTS
:OK SEC
 SBC #"0"
 CLC
 RTS

ISHEX CMP #"A"
 BCS :LETTER
 CMP #"9"+1
 BCS :ERR
 CMP #"0"
 BCC :ERR
 SBC #"0"
 CLC
 RTS
:LETTER CMP #"F"+1
 BCS :ERR
 SBC #"A"-$B
 CLC
 RTS
:ERR SEC
 RTS

LIB_DEATH ENT
 BIT DUMBTERM
 BMI :DUMB
 JSR PRINT
 NORMAL
 MTOFF
 COLOR WHITE
 CURSORON
 CR
 LINE "Fatal error. Call terminated."
 SOUND RESET
 NULL
 LDA #$FF
 STA DUMBTERM
 JSR HANGUP
:DUMB PLA
 SEC
 SBC #2
 STA TEMP
 PLA
 SBC #0
 STA TEMP+1
 JSR PRINT
 NORMAL
 MTOFF
 CR
 ASC "DEATH called from $"
 HEX16 TEMP
 CR
 ASC "[RESET]-reboot, [*]-monitor : "
 CURSORON
 NULL
 LDA #<RESET2
 STA $3F2
 LDA #>RESET2
 STA $3F3
 JSR $FB6F
]LOOP LDA #1
 JSR PSTATUS
 BCC ]LOOP
 JSR PREAD
 ORA #%1000_0000
 CMP #"*"
 BNE ]LOOP
 JSR SHUTDOWN ;Shutdown Tools
 LDA $C081
 STA $C00C
 STA $C00E
 STA $C000
 JSR $FB2F
 JSR $FE93
 JSR $FE89
 LDA #%1000_0000
 TRB $C029
 JMP $FF59 ;Bonk

RESET2 JSR SHUTDOWN ;Shutdown Tools
 JMP $FAA6

CALCPLR ENT
 JSR :SPEED
 JSR :AC
 JMP :LEVEL

:SPEED LDA PLRHT ;SPEED = (HT + DX)/4
 CLC
 ADC PLRDX
 LSR
 LSR
 STA PLRSPEED
 LDA PLRAGE
 CMP #50
 BCS :DOAGE
 RTS
:DOAGE SBC #50 ;We getting old?
 LSR
 LSR
 LSR
 INC
 SEC
 SBC PLRSPEED
 EOR #$FF
 CMP #$80
 BCC :SPEEDOK
 LDA #0 ;Min speed is 1
:SPEEDOK INC
 STA PLRSPEED
 RTS

:AC LDA #10
 STA PLRAC
 LDX #0
]LOOP STX TEMP
 LDA PLRITEM,X
 BEQ :NO
 TAX
 LDA #0
 JSR LOADITEM
 LDA PLRCLASS
 JSR CHECKUSE
 BCC :CANUSE
 LDX TEMP
 LDA #2 ;Unusable
 STA PLRITEMX,X
 BRA :USE2
:CANUSE LDX TEMP
 LDA PLRITEMX,X
 CMP #2
 BNE :USE2
 LDA #0
 STA PLRITEMX,X
:USE2 LDA ITYPE
 CMP #2
 BCC :NO
 CMP #6
 BCS :NO
 LDX TEMP
 LDA PLRITEMX,X
 CMP #1 ;Equipped?
 BNE :NO
 LDA PLRAC
 SEC
 SBC IDAT1 ;Passive defense
 STA PLRAC
:NO INC TEMP
 LDX TEMP
 CPX #8
 BNE ]LOOP
 LDA PLRCLASS
 CMP #5 ;Ninja
 BNE :ACRTS
 LDX PLRLVLREAL
 LDA :ACMOD-1,X
 CLC
 ADC PLRAC
 STA PLRAC
:ACRTS RTS
:ACMOD DFB 0,-1,-1,-2 ;Lvls 1-4
 DFB -2,-3,-3,-3 ;     5-8
 DFB -4,-4,-4,-4 ;     9-12
 DFB -5,-5,-6,-7 ;     13-16

:LEVEL STZ TEMP
 LDA PLRCLASS ;Use table depending on players Class
 DEC
 ASL
 TAX
 LDA EXPINDEX,X
 STA CADD2
 LDA EXPINDEX+1,X
 STA CADD2+1
]LOOP LDY #3
]LOOP2 LDA (CADD2),Y
 CMP PLREXP,Y
 BEQ :ENEXT
 BCS :DONE
 BCC :ENEXT1
:ENEXT DEY
 BPL ]LOOP2

:ENEXT1 LDA CADD2
 CLC
 ADC #4
 STA CADD2
 LDA CADD2+1
 ADC #0
 STA CADD2+1
 INC TEMP
 LDA TEMP
 CMP #16
 BNE ]LOOP
:DONE LDA TEMP
 STA PLRLEVEL
 RTS

ASK ENT
 STY :NUM
 JSR PRINT
 GOTOXY 0;23
 CLEOS
 ASC "Change ["
 DEC8 :NUM
 ASC "], format ("
 NULL
 TXA
 DEC
 ASL
 TAX
 LDA :FORMATS,X
 STA CADD
 LDA :FORMATS+1,X
 STA CADD+1
 LDY #0
]LOOP LDA (CADD),Y
 BEQ :ADONE
 JSR COUT
 INY
 BRA ]LOOP
:ADONE JSR PRINT
 ASC ") : "
 NULL
 RTS
:NUM DS 1

:FORMATS DA :FORMAT1
 DA :FORMAT2
 DA :FORMAT3
 DA :FORMAT4
 DA :FORMAT5
 DA :FORMAT6
 DA :FORMAT7

:FORMAT1 ASC "flag; 0=off, 1=on",00
:FORMAT2 ASC "string",00
:FORMAT3 ASC "date; DDMMYY",00
:FORMAT4 ASC "date; DDMMYY HHMM",00
:FORMAT5 ASC "number",00
:FORMAT6 ASC "nibble",00
:FORMAT7 ASC "time; HHMM",00

GETHEX ENT
 PHA
 LSR
 LSR
 LSR
 LSR
 AND #$F
 ORA #"0"
 CMP #"9"+1
 BCC :OK
 ADC #6
:OK TAX
 PLA
 AND #$F
 ORA #"0"
 CMP #"9"+1
 BCC :OK2
 ADC #6
:OK2 TAY
 RTS

SHOWPNTR ENT
 LDA YEPNTR
 BMI :MT
 BEQ :NORMAL
 BNE :INV
:MT LDA #$1B
 JSR COUT
:INV LDA #$F
 HEX 2C
:NORMAL LDA #$E
 JSR COUT
 LDA YEPNTR+1
 JSR COUT
 JSR PRINT
 NORMAL
 MTOFF
 NULL
 RTS

KPCHECK ENT
 STX :PNTR
 STY :MAX
 STA :CHAR
]LOOP INX
 CPX :MAX
 BEQ :CONT
 BCC :CONT
 LDX #0
:CONT PHX
 TXA
 ASL
 CLC
 ADC #2
 LDX #10
 LDY #10
 JSR PICKLINE
 LDA $200
 CMP :CHAR
 BEQ :YES
 PLX
 CPX :PNTR
 BNE ]LOOP
:DONE CLC
 RTS
:YES PLX
 SEC
 RTS
:PNTR DS 1
:CHAR DS 1
:MAX DS 1

CHAT PHP
 PHX
 PHY
 PHA
 LDX #79
]LOOP LDA $200,X
 STA BUFF200,X
 DEX
 BPL ]LOOP
 JSR SAVESCR
 DEC CHATFLAG
 JSR PRINT
 NORMAL
 MTOFF
 COLOR WHITE
 HOME
 CURSORON
 LINE "Chat mode [ESC-exit]"
 CR
 NULL
]LOOP JSR KEYIN ;Let's type..
 CMP #$9B
 BEQ :ESC
 CMP #$8D
 BEQ :CHAROK
 CMP #$88
 BEQ :CHAROK
 CMP #$FF
 BEQ :DEL
 CMP #$95
 BEQ :FORW
 CMP #" "
 BCC ]LOOP
:CHAROK JSR COUT
 BRA ]LOOP
:FORW JSR PRINT
 CURSORRIGHT
 NULL
 BRA ]LOOP
:DEL JSR PRINT
 CURSORLEFT
 ASC " "
 CURSORLEFT
 NULL
 BRA ]LOOP
:ESC JSR RESTSCR
 STZ CHATFLAG
 LDX #79
]LOOP LDA BUFF200,X
 STA $200,X
 DEX
 BPL ]LOOP
 PLA
 PLY
 PLX
 PLP
 RTS

SAVESCR LDA CH
 STA SCRHV+2
 LDA CV
 STA SCRHV+3
 LDA VMODE
 STA SCRVMODE
 JSR PRINT
 CURSOROFF
 NULL
 JSR GETSCREEN ;PICKLINE the screen
 DFB 0,23 ;on these lines
 DA SCRNBUFF ;and put it here
 STX SCRLEN ;X and A have length on return
 STA SCRLEN+1
 RTS

RESTSCR JSR PRINT
 NORMAL
 MTOFF
 HOME
 CURSOROFF
 NULL
 LDX SCRLEN ;Length
 LDA SCRLEN+1
 JSR SHOWMSG
 DFB 0,23 ;Lines to use (top, bottom)
 DA SCRNBUFF

* VMODE bits:
* 4 - cursor     0=on   1=off
* 2 - inverse    0=off  1=on
* 0 - mousetext  0=on   1=off

 LDA SCRVMODE
 AND #%0000_0001 ;MouseText?
 BNE :MTOFF
 LDA #$1B
 HEX 2C
:MTOFF LDA #$18
 JSR COUT
 LDA SCRVMODE
 AND #%0000_0100 ;Inverse?
 BEQ :INVOFF
 LDA #$0F
 HEX 2C
:INVOFF LDA #$0E
 JSR COUT
 LDA SCRVMODE
 AND #%0001_0000 ;Cursor?
 BNE :CURSOFF
 LDA #$05
 HEX 2C
:CURSOFF LDA #$06
 JSR COUT

 JSR PRINT
SCRHV GOTOXY 0;0
 NULL
 RTS

REFRESH ENT
 PHP
 PHX
 PHY
 PHA
 LDX #79
]LOOP LDA $200,X
 STA BUFF200,X
 DEX
 BPL ]LOOP
 JSR SAVESCR
 DEC CHATFLAG ;Used by SHOWMSG routine
 JSR PRINT
 GOTOXY 0;0
 NULL
 JSR RESTSCR
 STZ CHATFLAG
 LDX #79
]LOOP LDA BUFF200,X
 STA $200,X
 DEX
 BPL ]LOOP
 PLA
 PLY
 PLX
 PLP
 RTS
BUFF200 DS 80

SCRLEN DS 2
SCRVMODE DS 1

LOGERROR JSR CLOSEALL
 LDX #0
 LDY #79
 LDA VTEMP ;Line number error was displayed
 JSR PICKLINE
 LDY #79
 STY MISCBUFF
]LOOP LDA $200,Y
 STA MISCBUFF+1,Y
 DEY
 BPL ]LOOP
 NOTELOGBUFF $1;MISCBUFF
 NOTELOGBUFF $1;MODULE+1
 RTS

TEMP DS 2

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV LIB.MAIN.L
 fin

 END
