*-------------------------------
* LIB.SHR (Library)
*-------------------------------
 DAT
 LST OFF

 XC
 XC

 REL

 USE MACROS
 USE EQUATES
 USE VARS
 USE TABLES

 do M16PLUS-1
 DSK LIB.SHR.L
 fin

 EXT CHATFLAG ;Main
 EXT USERWAIT ;Print
 EXT PUTBLOK ;Map

PRCOUT ENT ;Super hi-res output
 STA AREG
 LDA VMODE
 AND #%0000_1000
 BNEL GETXY ;GOTOXY in progress
 LDA AREG
 CMP #" "
 BCC CTRL
 JSR DOCHAR
COUTRTS JSR DOCURS
 LDA AREG
 RTS

CTRL AND #%0111_1111
 CMP #' '
 BCS CTLDO
 ASL
 TAX
 JMP (:CHARS,X)

:CHARS DA CTL00 ;00
 DA CTL01 ;01
 DA CTL02 ;02
 DA CTL03 ;03
 DA CTL04 ;04
 DA PCURSON ;05 ^E - cursor on
 DA PCURSOFF ;06 ^F - cursor off
 DA PBEEP ;07 ^G - bell
 DA PCURSLEFT ;08 ^H - cursor left
 DA CTL09 ;09
 DA PCURSDOWN ;0A ^J - cursor down
 DA PCLEOS ;0B ^K - clear to end of screen
 DA PHOME ;0C ^L - clear screen
 DA PCR ;0D ^M - carriage return
 DA PNORMAL ;0E ^N - normal
 DA PINVERSE ;0F ^O - inverse
 DA CTL10 ;10
 DA CTL11 ;11
 DA CTL12 ;12
 DA CTL13 ;13
 DA CTL14 ;14
 DA CTL15 ;15
 DA PSCRNDN ;16 ^V - screen down
 DA PSCRNUP ;17 ^W - screen up
 DA PMTOFF ;18 ^X - mousetext off
 DA PCURSTOP ;19 ^Y - cursor home
 DA PZAPLINE ;1A ^Z - clear line
 DA PMTON ;1B ^[ - mousetext on
 DA PCURSRIGHT ;1C ^\ - cursor right
 DA PCLEOL ;1D ^] - clear to end of line
 DA PGOTOXY ;1E ^^ - cursor goto
 DA PCURSORUP ;1F ^_ - cursor up

CTL00 ;00
CTL01 ;01
CTL02 ;02
CTL03 ;03
CTL04 ;04
CTL09 ;09
CTL10 ;10
CTL11 ;11
CTL12 ;12
CTL13 ;13
CTL14 ;14
CTL15 ;15
CTLDO
 LDA CHAR
 JSR DOCHAR
 JMP COUTRTS

PCURSON LDA VMODE
 AND #%1110_1111
 STA VMODE
 JSR DOCURSOR
 JMP COUTRTS

PCURSOFF LDA VMODE
 ORA #%0001_0000
 STA VMODE
 JSR DOCURSOR
 JMP COUTRTS

PBEEP BIT DUMBTERM ;Don't wake the sysop!
 BPL :SKIP
 LDA $C036 ;Ding dong..
 PHA
 AND #%0111_1111
 STA $E0C036
 LDY #$70
]LOOP LDX #$30
 DEX
 BNE *-1
 LDA $C030
 LDX #$60
 DEX
 BNE *-1
 DEY
 BNE ]LOOP
 PLA
 STA $C036
:SKIP JMP COUTRTS

PCURSLEFT LDA VMODE ;Move cursor to the left
 PHA
 JSR DOCURSOFF ;Get rid of the cursor if it's on
 LDA CH
 BNE :BSOK
 LDA #80
 STA CH
 LDA CV
 BEQ :BSOK
 CMP #24 ;Bottom line?
 BEQ :BSOK
 DEC CV
:BSOK DEC CH
 PLA
 STA VMODE
 JMP COUTRTS

PCURSDOWN LDA VMODE ;Move cursor down
 PHA
 JSR DOCURSOFF ;Get rid of the cursor if it's on
 LDA CV
 CMP #24 ;If on the bottom line, don't scroll
 BEQ :LFOK
 CMP #23
 BEQ :DOSCR
 INC CV
:LFOK PLA
 STA VMODE
 JMP COUTRTS
:DOSCR JSR SCROLL ;Scroll screen (both of 'em)
 BRA :LFOK

PCLEOS JSR PCLEOL2 ;Clear from cursor to end of screen
 JSR GETIN
 LDA CV
 CMP #23
 BCC :OK
 JMP :CLEOS2
:OK CLC
 XCE
 REP #$30
 LDA CV
 AND #$FF
 INC
 ASL
 ASL
 ASL
 ASL
 TAY
 LDA [SCRNPNTR],Y
 TAX
 LDA INCHAR
]LOOP STAL SHRLOC,X
 INX
 INX
 CPX #$9D00-$500
 BNE ]LOOP
 SEP #$30
 LDA CV
 PHA
 LDA CH
 PHA
 LDA CV
 INC
 TAX
]LOOP TXA
 JSR BASCALC
 LDY #39
 LDA SPACE
]LOOP2 STA $C055
 STA (BAS),Y
 STA $C054
 STA (BAS),Y
 DEY
 BPL ]LOOP2

 PHX
 REP #$20
 JSR CALCTB ;Calc 'colour table' address for line X
 SEP #$30
 LDY #79
]LOOP2 STA [CADD6],Y
 DEY
 BPL ]LOOP2

 SEP #$30
 PLX

 INX
 CPX #24
 BCC ]LOOP
 PLA
 STA CH
 PLA
 STA CV
 JSR BASCALC
:CLEOS2 SEC
 XCE
 LDA #12
 JSR USERWAIT ;In case other end is a bit slow..
 JMP COUTRTS

PHOME JSR GETIN ;Clears screen
 LDA VMODE ;Move cursor to top-left of screen
 PHA
 JSR DOCURSOFF ;Get rid of the cursor if it's on
 PLA
 STA VMODE
 STZ CH
 LDA CV
 CMP #24 ;Bottom line?
 BNE :OK
 JMP PZAPLINE
:OK CLC
 XCE
 REP #$30
 LDX #$2000
 LDA INCHAR
]LOOP STAL SHRLOC,X
 INX
 INX
 CPX #$9D00-$500
 BNE ]LOOP
 SEP #$30
 LDX #23
]LOOP TXA
 JSR BASCALC
 LDY #39
 LDA SPACE
]LOOP2 STA $C055
 STA (BAS),Y
 STA $C054
 STA (BAS),Y
 DEY
 BPL ]LOOP2
 DEX
 BPL ]LOOP

 LDX #0
 JSR CALCTB ;Calc 'colour table' address for line X
 REP #$10
 SEP #$20
 LDY #0
]LOOP2 STA [CADD6],Y
 INY
 CPY #80*24
 BNE ]LOOP2

 SEP #$30

 LDA #0
 STA CH
 STA CV
 JSR BASCALC
 SEC
 XCE
 LDA #16
 JSR USERWAIT ;In case other end is a bit slow..
 JMP COUTRTS

PCR LDA VMODE ;Moves cursor to beginning of current line
 PHA
 JSR DOCURSOFF ;Get rid of the cursor if it's on
 PLA
 STA VMODE
 STZ CH
 JMP COUTRTS

PNORMAL LDA VMODE ;Most of us aren't..
 AND #%1111_1011
 STA VMODE
 JMP COUTRTS

PINVERSE LDA VMODE ;The opposite of normal..
 ORA #%0000_0100
 STA VMODE
 JMP COUTRTS

PSCRNDN LDA CV
 CMP #24 ;Bottom line?
 BNE :OK
 JMP :SDEXIT
:OK LDA VMODE ;Backward scroll
 PHA
 JSR DOCURSOFF ;Get rid of the cursor if it's on
 JSR GETIN
 CLC
 XCE
 REP #$30
 PHB
 LDX #$92FF
 LDY #$97FF
 LDA #$9D00-$2000-$500-$500-1
 MVP SHRLOC,SHRLOC
 PLB
 LDA INCHAR
 LDX #$2000
]LOOP STAL SHRLOC,X
 INX
 INX
 CPX #$2000+$500
 BNE ]LOOP
 SEP #$30
 PLA
 STA VMODE
 LDA CV
 PHA
 LDA CH
 PHA
 LDX #22
]LOOP TXA
 JSR BASCALC
 PHX
 LDY #39
]LOOP2 TYX
 STA $C055
 LDA (BAS),Y
 STA SCRLINE1,X
 STA $C054
 LDA (BAS),Y
 STA SCRLINE0,X
 DEY
 BPL ]LOOP2
 PLX
 TXA
 INC
 JSR BASCALC
 PHX
 LDY #39
]LOOP2 TYX
 STA $C055
 LDA SCRLINE1,X
 STA (BAS),Y
 STA $C054
 LDA SCRLINE0,X
 STA (BAS),Y
 DEY
 BPL ]LOOP2
 PLX
 DEX
 BMI :OK2
 JMP ]LOOP
:OK2 LDA #0
 STA CV
 JSR BASCALC
 LDY #39
 LDA SPACE
]LOOP STA $C055
 STA (BAS),Y
 STA $C054
 STA (BAS),Y
 DEY
 BPL ]LOOP

 LDX #23
 JSR CALCTB ;Calc 'colour table' address for line X
 SEP #$30
 PushZWord CADD6
 LDA CADD6+2
 STA :SBANK+1
 STA :SBANK+2
 LDX #22
 JSR CALCTB ;Calc 'colour table' address for line X
 REP #$30
 LDA CADD6
 CLC
 ADC #79
 TAX
 PLA
 CLC
 ADC #79
 TAY
 LDA #80*23-1
 PHB
:SBANK MVP $00,$00
 PLB

 LDX #0
 JSR CALCTB ;Calc 'colour table' address for line X
 SEP #$30
 LDY #79
]LOOP2 STA [CADD6],Y
 DEY
 BPL ]LOOP2

 SEP #$30

 PLA
 STA CH
 PLA
 STA CV
 JSR BASCALC
:SDEXIT SEC
 XCE
 LDA #16
 JSR USERWAIT ;In case other end is a bit slow..
 JMP COUTRTS

PSCRNUP LDA CV
 CMP #24 ;Bottom line?
 BEQ :SUEXIT
 JSR SCROLL ;Forward scroll
:SUEXIT JMP COUTRTS

PMTOFF LDA VMODE ;Turn mousetext off
 ORA #%0000_0001
 STA VMODE
 JMP COUTRTS

PCURSTOP LDA VMODE ;Move cursor to top-left of screen
 PHA
 JSR DOCURSOFF ;Get rid of the cursor if it's on
 STZ CH
 LDA CV
 CMP #24 ;Bottom line?
 BEQ :CTBOT
 STZ CV
:CTBOT PLA
 STA VMODE
 JMP COUTRTS

PZAPLINE JSR GETIN ;Clear current line
 CLC
 XCE
 REP #$30
 LDA CV
 AND #$FF
 ASL
 ASL
 ASL
 ASL
 TAY
 LDA [SCRNPNTR],Y
 TAX
 LDY #0
 LDA INCHAR
]LOOP STAL SHRLOC,X
 INX
 INX
 INY
 INY
 CPY #$500
 BNE ]LOOP
 SEP #$30
 LDA CH
 PHA
 LDA CV
 JSR BASCALC
 LDA CV
 CMP #24 ;Bottom line?
 BEQ :ZAPBOT
 LDY #39
 LDA SPACE
]LOOP STA $C055
 STA (BAS),Y
 STA $C054
 STA (BAS),Y
 DEY
 BPL ]LOOP

:ZAPEND REP #$20
 LDX CV
 JSR CALCTB ;Calc 'colour table' address for line X
 SEP #$30
 LDY #79
]LOOP2 STA [CADD6],Y
 DEY
 BPL ]LOOP2

 SEP #$30

 PLA
 STA CH
 SEC
 XCE
 LDA #6
 JSR USERWAIT ;In case other end is a bit slow..
 JMP COUTRTS
:ZAPBOT LDY #79
 LDA SPACE
]LOOP STA (BAS),Y
 DEY
 BPL ]LOOP
 BRA :ZAPEND

PMTON LDA VMODE ;Turn mousetext on
 AND #%1111_1110
 STA VMODE
 JMP COUTRTS

PCURSRIGHT LDA VMODE ;Move cursor to the right
 PHA
 JSR DOCURSOFF ;Get rid of the cursor if it's on
 LDA CH
 CMP #79
 BNE :FSOK
 LDA #-1
 STA CH
* LDA CV ;F/W doesn't wrap at window edge (on the IIgs anyway)
* CMP #23
* BCS :FSOK
* INC CV
:FSOK INC CH
 PLA
 STA VMODE
 JMP COUTRTS

PCLEOL JSR PCLEOL2 ;Clear from cursor to end of line
 JMP COUTRTS

PCLEOL2 JSR GETIN
 CLC
 XCE
 REP #$30
 LDA CV
 AND #$FF
 ASL
 ASL
 ASL
 ASL
 TAY
 LDA [SCRNPNTR],Y
 STA :TLBASE
 LDA CH
 AND #$FF
 ASL
 CLC
 ADC :TLBASE
 STA :TLBASE
 LDA CH
 AND #$FF
 SEC
 SBC #80
 EOR #$FFFF
 INC
 STA :LEN
 LDA #0
 STA :CNTR
]LOOP LDA :TLBASE
 TAX
 LDY #0
 LDA INCHAR
]LOOP2 STAL SHRLOC,X
 INX
 INX
 INY
 CPY :LEN
 BNE ]LOOP2
 LDA :TLBASE
 CLC
 ADC #$A0
 STA :TLBASE
 LDA :CNTR
 INC
 STA :CNTR
 CMP #8
 BNE ]LOOP
 SEP #$30
 LDA CV
 JSR BASCALC
 LDA CV
 CMP #24 ;Bottom line?
 BEQ :CLBOT
 LDY CH
 PHY
]LOOP PHY
 TYA
 LSR
 TAY
 BCS :SKPEOL
 STA $C055
:SKPEOL LDA SPACE
 STA (BAS),Y
 STA $C054
 PLY
 INY
 CPY #80
 BCC ]LOOP
 PLA
 STA CH

:EOLEND REP #$20
 LDX CV
 JSR CALCTB ;Calc 'colour table' address for line X
 SEP #$30
 LDY CH
]LOOP2 STA [CADD6],Y
 INY
 CPY #80
 BCC ]LOOP2

 SEC
 XCE
 LDA #6
 JMP USERWAIT ;In case other end is a bit slow..
:CLBOT LDY CH
 LDA SPACE
]LOOP STA (BAS),Y
 INY
 CPY #80
 BCC ]LOOP
 BRA :EOLEND

:CNTR DS 2
:TLBASE DS 2
:LEN DS 2

PGOTOXY LDA #$FF ;Reset XCOORD to "no we don't have X"
 STA XCOORD
 LDA VMODE
 ORA #%0000_1000 ;Turn on "GOTOXY in progress"
 STA VMODE
 JMP COUTRTS

GETXY LDA XCOORD ;We waiting for X?
 BPL :GETY ;No, this is Y
 LDA AREG
 AND #%0111_1111
 SEC
 SBC #32
 STA XCOORD
 JMP COUTRTS
:GETY LDA AREG ;Get Y
 AND #%0111_1111
 SEC
 SBC #32
 STA YCOORD
 LDA VMODE
 AND #%1111_0111 ;Turn off "GOTOXY in progress"
 STA VMODE
 PHA
 JSR DOCURSOFF ;Get rid of the cursor if it's on
 LDA XCOORD ;We don't support anything bigger than 80 x 24
 CMP #80
 BCC :XLOCOK
 LDA #79
:XLOCOK STA CH
 LDA YCOORD
 CMP #25 ;I lied.. it does..
 BCC :YLOCOK
 LDA #24
:YLOCOK STA CV
 JSR BASCALC
 PLA
 STA VMODE
 LDA #1
 JSR USERWAIT ;In case other end is a bit slow..
 JMP COUTRTS

PCURSORUP LDA VMODE ;Move cursor up
 PHA
 JSR DOCURSOFF ;Get rid of the cursor if it's on
 LDA CV
 BEQ :UPLFOK
 CMP #24 ;Bottom line?
 BEQ :UPLFOK
 DEC CV
:UPLFOK PLA
 STA VMODE
 JMP COUTRTS

GETIN LDA #" " ;For 'clearing' (eg; zapline, cleos, cleol, etc)
 STA SPACE
 LDA VMODE ;Inverse on?
 AND #%0000_0100
 BEQ :OFF
 LDA #' '
 STA SPACE
 LDA TEXTCOLOR
 BRA :CONT
:OFF LDA BGCOLOR
:CONT ASL
 TAX
 LDA COLORTBL,X
 STA INCHAR
 LDA COLORTBL+1,X
 STA INCHAR+1
 RTS

DOCURSOFF LDA VMODE ;If cursor on, turn it off, else nothing
 AND #%0001_0000 ;Cursor on?
 BEQ :ON
 RTS
:ON LDA VMODE
 ORA #%0001_0000
 STA VMODE
 BRA DOCURSOR

DOCURS LDA VMODE
 AND #%0001_0000 ;Cursor on?
 BEQ DOCURSOR
 RTS

DOCURSOR ENT
 JSR PICK
 PHA
 LDA VMODE
 AND #%0001_0000 ;Cursor on?
 BNE :OFF
:ON LDA #$FF
 HEX 2C
:OFF LDA #0
 STA INVMASK
 STA INVMASK+1
 PLA
 CMP #$FF
 BNE :NOSHP
 JMP PUTBLOK

:NOSHP STA CHAR
 CLC
 XCE
 REP #$20
 PushLong TEXTCOLOR ;Pushes TEXTCOLOR and BGCOLOR
 SEP #$30

 LDX CV
 JSR CALCTB ;Calc 'colour table' address for line X
 SEP #$30
 LDY CH
 LDA [CADD6],Y
 PHA
 AND #$F
 STA BGCOLOR
 PLA
 LSR
 LSR
 LSR
 LSR
 STA TEXTCOLOR

 JSR OUT8

 CLC
 XCE
 REP #$20
 PullLong TEXTCOLOR ;Restores TEXTCOLOR and BGCOLOR
 SEC
 XCE

 STZ INVMASK
 STZ INVMASK+1
 RTS

DOCHAR ENT
 LDA AREG ;Do a printable character
 ORA #%1000_0000
 STA CHAR

 LDA VMODE
 AND #%0000_0100 ;Inverse on?
 BEQ :GOGO ;No

 LDA VMODE
 AND #%0000_0001 ;MouseText on?
 BEQ :MTON ;Yes

 LDA AREG
 AND #%0111_1111
 CMP #'@'
 BCC :INVOK
 CMP #'_'+1
 BCS :INVOK
 LDA AREG
 AND #%0011_1111
:INVOK STA CHAR
 BRA :GOGO

:MTON LDA AREG
 AND #%0111_1111
 STA CHAR

:GOGO LDA CHAR
 JSR PUT

BUMPCURS ENT
 INC CH ;Inc cursor position
 LDA CH
 CMP #80
 BNE :CURSOK
 STZ CH
 LDA CV
 CMP #24 ;Bottom line?
 BEQ :CURSOK ;Wrap, don't scroll
 CMP #23
 BEQ :SCROLL ;Scroll if necessary
 INC CV
:CURSOK RTS
:SCROLL JMP SCROLL2

SCROLL LDA VMODE ;Scroll the screen up
 PHA
 JSR DOCURSOFF ;Get rid of the cursor if it's on
 BRA SCROLL3
SCROLL2 LDA VMODE
 PHA
SCROLL3 JSR GETIN
 CLC
 XCE
 REP #$30
 PHB
 LDX #$2500
 LDY #$2000
 LDA #$9D00-$2000-$500-$500-1
 MVN SHRLOC,SHRLOC
 PLB
 LDX #$9D00-$500-$500
 LDA INCHAR
]LOOP STAL SHRLOC,X
 INX
 INX
 CPX #$9D00-$500
 BNE ]LOOP
 SEP #$30
 PLA
 STA VMODE
 PHB
 LDA #0 ;So we can read the text screen
 PHA
 PLB
 LDA CV
 PHA
 LDA CH
 PHA
 LDX #1
]LOOP TXA
 JSR BASCALC
 PHX
 LDY #39
]LOOP2 TYX
 STA $C055
 LDA (BAS),Y
 STA SCRLINE1,X
 STA $C054
 LDA (BAS),Y
 STA SCRLINE0,X
 DEY
 BPL ]LOOP2
 PLX
 TXA
 DEC
 JSR BASCALC
 PHX
 LDY #39
]LOOP2 TYX
 STA $C055
 LDA SCRLINE1,X
 STA (BAS),Y
 STA $C054
 LDA SCRLINE0,X
 STA (BAS),Y
 DEY
 BPL ]LOOP2
 PLX
 INX
 CPX #24
 BCS :OK
 JMP ]LOOP
:OK LDA #23
 JSR BASCALC
 LDY #39
 LDA SPACE
]LOOP STA $C055
 STA (BAS),Y
 STA $C054
 STA (BAS),Y
 DEY
 BPL ]LOOP

 LDX #0
 JSR CALCTB ;Calc 'colour table' address for line X
 SEP #$30
 LDA CADD6+2
 STA :SBANK+1
 STA :SBANK+2
 PushZWord CADD6
 LDX #1
 JSR CALCTB ;Calc 'colour table' address for line X
 REP #$30
 PLY
 PHB
 LDX CADD6
 LDA #80*23-1
:SBANK MVN $00,$00 ;Should be in bank $00 (check EQUATES)
 PLB

 LDX #23
 JSR CALCTB ;Calc 'colour table' address for line X
 SEP #$30
 LDY #79
]LOOP2 STA [CADD6],Y
 DEY
 BPL ]LOOP2

 PLA
 STA CH
 PLA
 STA CV
 JSR BASCALC
 PLB
 SEC
 XCE
 LDA #16
 JMP USERWAIT ;In case other end is a bit slow..

XCOORD DFB $FF ;For GOTOXY
YCOORD DFB $FF ;For GOTOXY

AREG DS 2

BASCALC ENT
 PHX
 CMP #24 ;Bottom line?
 BEQ :BOTLINE
 ASL
 TAX
 LDA TEXTBL,X
 STA BAS
 LDA TEXTBL+1,X
 STA BAS+1
 PLX
 RTS
:BOTLINE LDA #<BOTLINE
 STA BAS
 LDA #>BOTLINE
 STA BAS+1
 PLX
 RTS

PICK LDA CV
 JSR BASCALC ;Get text screen base address
 LDA CV
 CMP #24 ;Bottom line?
 BEQ :BOT
 LDA CH
 LSR
 TAY
 BCS :SKIP
 STA $C055
:SKIP LDA (BAS),Y
 STA $C054
 RTS
:BOT LDX CH
 LDA BOTLINE,X
 RTS

PUT PHA
 LDA CV
 JSR BASCALC
 LDA CV
 CMP #24 ;Bottom line?
 BEQ :BOT
 LDA CH
 LSR
 TAY
 BCS :SKIP
 STA $C055
:SKIP PLA
 STA (BAS),Y
 STA $C054
 BRA :EXIT
:BOT LDX CH
 PLA
 STA BOTLINE,X
:EXIT STA CHAR ;Fall thru to OUT8

*-------------------------------------------------
* Put a character on the SHR screen
*-------------------------------------------------
OUT8 CLC
 XCE
 REP #$30 ;The big one!

 LDA CHATFLAG
 AND #$FF
 BNE :DONT

 SEP #$10
 LDX CV
 JSR CALCTB ;Calc 'colour table' address for line X
 SEP #$30
 LDY CH
 STA [CADD6],Y
 PHA
 AND #$F
 STA OUTBG
 PLA
 LSR
 LSR
 LSR
 LSR
 STA OUTTEXT
 REP #$30

:DONT LDA CV ;Get base address for this line
 AND #$FF
 ASL
 ASL
 ASL
 ASL
 TAY
 LDA [SCRNPNTR],Y
 STA ADDR
 LDA CH
 AND #$FF
 ASL
 CLC
 ADC ADDR
 STA ADDR

 LDA CHAR ;Select which one we need
 ASL
 ASL
 ASL
 ASL
 TAY
 LDX #8
]LOOP PHX
 LDA [FONTLOC],Y
 STA SHRBYTE
 EOR #$FFFF
 STA MASK ;Mask for background colour
 LDA OUTBG ;Get background colour from table
 ASL
 TAX
 LDA COLORTBL,X
 AND MASK
 STA BGDROP ;Setup background 'mould'
 LDA OUTTEXT ;Get text colour from table (same one)
 ASL
 TAX
 LDA COLORTBL,X
 AND SHRBYTE ;Set it to the right colour
 ORA BGDROP ;Combine with background 'mould'
 EOR INVMASK ;Invert if we need to
 LDX ADDR ;SHR location
 STAL SHRLOC,X ;Put onto screen
 LDA ADDR
 CLC
 ADC #$A0 ;Inc SHR line
 STA ADDR
 INY
 INY
 PLX
 DEX
 BNE ]LOOP

 SEC
 XCE
 RTS

*-------------------------------------------------
* Calculate offset for 'colour table'
*-------------------------------------------------

CALCTB ENT
 REP #$30
 TXA
 AND #$FF
 ASL
 TAX
 LDA SCRNTABLE,X
 CLC
 ADC FONTLOC
 ADC #$1000
 STA CADD6
 LDA FONTLOC+2
 ADC #0
 STA CADD6+2
 SEP #$20
 LDA TEXTCOLOR
 ASL
 ASL
 ASL
 ASL
 ORA BGCOLOR
 RTS

SCRNTABLE ENT
]X = 0
 LUP 25
 DA ]X
]X = ]X+80
 --^

*-------------------------------------------------

ADDR ENT
 DS 2

INCHAR DS 2
CHAR DS 2

TEXTCOLOR ENT ;Keep these two together
 DA $F ;White       |
BGCOLOR ENT ;<----------/
 DS $0 ;Black

COLORTBL DA $0000 ;Black
 DA $1111 ;Deep blue
 DA $2222 ;Yellow-brown (poo)
 DA $3333 ;Grey 1
 DA $4444 ;Red
 DA $5555 ;Purple
 DA $6666 ;Orange
 DA $7777 ;Pink
 DA $8888 ;Dark green
 DA $9999 ;Aquamarine
 DA $AAAA ;Bright green
 DA $BBBB ;Pale green
 DA $CCCC ;Grey 2
 DA $DDDD ;Periwinkle blue
 DA $EEEE ;Yellow
 DA $FFFF ;White

TEXTBL DA $400,$480,$500,$580,$600,$680,$700,$780
 DA $428,$4A8,$528,$5A8,$628,$6A8,$728,$7A8
 DA $450,$4D0,$550,$5D0,$650,$6D0,$750,$7D0
 DA $800 ;'Line 25' (for OUT8 only)

SCRLINE1 DS 40 ;Save area for scrolling, etc
SCRLINE0 DS 40

SPACE DS 1

SHRBYTE DS 2
BGDROP DS 2
MASK DS 2
INVMASK DS 2

BOTLINE ENT
 DS 80," "

OUTBG DS 2
OUTTEXT DS 2

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV LIB.SHR.L
 fin

 END
