*-------------------------------
* LOADER
*-------------------------------
 DAT
 LST OFF

 ORG $2000
 TYP $FF

 USE MACROS
 USE EQUATES
 USE LIB.JMP
 USE VARS

 do M16PLUS-1
 DSK RUN/TC2.LOAD.SYSTEM
 fin

 mx %11

START JMP GO
 DFB $EE,$EE,1+64
STARTPATH DS 1+64

GO CLI
 CLD
 LDX #$FF
 TXS
 LDA $C081
 STA $C00C
 STA $C00E
 STA $C000
 JSR $FB2F
 JSR $FE93
 JSR $FE89
 JSR $FE84
 JSR $FC58

 JSR $FE1F
 BCC :GS
 LDX #0
]LOOP LDA :TXT,X
 BEQ :DONE
 JSR COUT
 INX
 BRA ]LOOP
:DONE BIT $C010
]LOOP LDA $C000
 BPL ]LOOP
 STA $C010
 JSR $FC58
 JMP $FAA6
:TXT ASC "The Complex II requires an Apple IIgs."
 CR
 CR
 ASC "[Press any key to exit]"
 NULL

:GS LDA #<CODE ;Relocate to MODULE area
 STA CADD
 LDA #>CODE
 STA CADD+1

 LDA #<MODULE
 STA CADD2
 LDA #>MODULE
 STA CADD2+1

 LDY #0
]LOOP LDA (CADD),Y
 STA (CADD2),Y
 INY
 BNE ]LOOP
 INC CADD+1
 INC CADD2+1
 LDA CADD2+1
 CMP #$90
 BNE ]LOOP
 JMP MODULE ;Let's go..
*
* Load the Library in first, so that we can use it to perform
* any other calls that we may need.
*
CODE ORG MODULE

 LDA #$0C
 JSR $C300

 LDA $C034
 STA BORDER ;Save border color
 JSR GETVBL
 LDA #%0000_1111
 TRB $C034 ;Make it black

 LDA $C022
 STA TBCOLOR
 JSR GETVBL
 LDA #%1111_0000 ;White text, Black background
 STA $C022

 LDA #FUNC_NORMAL
 STA STARTUPCODE
 STZ STARTUPBAUD
 LDA STARTPATH
 STA STARTUPPATH
 BEQ :TPAGE
 TAX
]LOOP LDA STARTPATH,X
 STA STARTUPPATH,X
 DEX
 BNE ]LOOP
 LDA $2FE
 CMP #3
 BCC :SOK
 LDA #FUNC_CHECK
:SOK STA STARTUPCODE
 CMP #FUNC_USER
 BNE :SOK2
 LDA $2FF
 STA STARTUPBAUD
:SOK2 JSR MYPRINT
 ASC "The Complex II - starting up with start code $"
 NULL
 LDA STARTUPCODE
 JSR PRBYTE
 JSR MYPRINT
 CR
 NULL
 JSR MOVELCODE
 JMP :JOIN

:TPAGE LDA #%0100_0000 ;Set Linear Mode on
 TSB $C029

 MLI_OPEN :OPARMS
 JSR ERR
 LDA :OPARMS+5
 STA :RPARMS+1
 STA :CPARMS+1
]LOOP SEC
 XCE
 MLI_READ :RPARMS
 CMP #$4C
 BEQ :OK
 JSR ERR
:OK CLC
 XCE
 REP #$30
 PushWord #0
 PushLong BUFPTR
 PushWord BUFSIZE
 PushLong #PICPTR
 PushLong #PICSIZE
 Tool $2703 ;UnPackBytes
 PLA
 LDA PICSIZE
 BNE ]LOOP
 SEC
 XCE
 MLI_CLOSE :CPARMS
 JSR ERR

 JSR GETVBL
 LDA #%1000_0000 ;Show SHR screen
 TSB $C029

:JOIN JSR MYPRINT
 CR
 LINE "Loading Library"
 NULL

 MLI_OPEN OPARMS
 JSR ERR
 LDA OPARMS+5
 STA GPARMS+1
 STA RPARMS+1
 STA CPARMS+1

 MLI_GET_EOF GPARMS
 JSR ERR
 LDA GPARMS+2
 STA RPARMS+4
 LDA GPARMS+3
 STA RPARMS+5

 MLI_READ RPARMS
 JSR ERR

 MLI_CLOSE CPARMS
 JSR ERR

 EXEC "GAME.START"

:OPARMS DFB 3
 DA :PATH
 DA IOBUFFER
 DS 1

:RPARMS DFB 4
 DS 1
 DA BUFFER
 DA $8000
 DS 2

:CPARMS DFB 1
 DS 1

:PATH STR "TITLE.PAGE"

PICPTR ADRL $E12000
PICSIZE DA $8000
BUFPTR ADRL BUFFER
BUFSIZE DA $8000

MYPRINT PLA
 STA CADD
 PLA
 STA CADD+1
]LOOP INCR CADD
 LDA (CADD)
 BEQ :DONE
 JSR COUT
 BRA ]LOOP
:DONE LDA CADD+1
 PHA
 LDA CADD
 PHA
 RTS

ERR EOR #0
 BNE :OOPS
 RTS
:OOPS STA :ERR
 JSR MYPRINT
 CR
 ASC "MLI error $"
 NULL
 LDA :ERR
 JSR PRBYTE
 JMP $FF59 ;Crash
:ERR DS 1

GETVBL PHP ;Wait for a VBL
 SEC
 XCE
 PHP
]LOOP LDA $C019
 BPL ]LOOP
]LOOP LDA $C019
 BMI ]LOOP
]LOOP LDA $C02E
 CMP #$E4
 BCC ]LOOP
 PLP
 XCE
 PLP
 RTS

MOVELCODE LDX #0
]LOOP LDA :CODE,X
 STA LAUNCHER,X
 INX
 CPX #LAUNCHEND-LAUNCHCODE
 BNE ]LOOP
 RTS
:CODE
 ORG LAUNCHER
LAUNCHCODE LDX STARTUPPATH
 STX $280
]LOOP CPX #0
 BEQ :CONT
 LDA STARTUPPATH,X
 STA $280,X
 DEX
 BNE ]LOOP
:CONT MLI_CLOSE :CPARMS
 LDX #17
]LOOP STZ $BF58,X
 DEX
 BPL ]LOOP
 INC $BF6F
 LDA #$CF
 STA $BF58
 MLI_OPEN :OPARMS
 BCS :ERR
 LDA :OPARMS+5
 STA :GPARMS+1
 STA :RPARMS+1
 MLI_GET_EOF :GPARMS
 BCS :ERR
 LDA :GPARMS+2
 STA :RPARMS+4
 LDA :GPARMS+3
 STA :RPARMS+5
 MLI_READ :RPARMS
 BCS :ERR
 MLI_CLOSE :CPARMS
 BCS :ERR
 JMP $2000
:ERR MLI_CLOSE :CPARMS
 MLI_QUIT :QPARMS

:OPARMS DFB 3
 DA $280
 DA IOBUFFER
 DS 1

:GPARMS DFB 2
 DS 1
 DS 3

:RPARMS DFB 4
 DS 1
 DA $2000
 DS 2
 DS 2

:CPARMS DFB 1
 DFB 0

:QPARMS DFB 4
 DS 6

 LST ON
LAUNCHEND EQU *
 LST OFF
 ORG

OPARMS DFB 3
 DA PATH
 DA IOBUFFER
 DS 1

GPARMS DFB 2
 DS 1
 DS 3

RPARMS DFB 4
 DS 1
 DA LIBRARY
 DS 2
 DS 2

CPARMS DFB 1
 DS 1

PATH STR "LIBRARY"

BUFFER = *

 LST ON
LOADEND EQU * ;Don't go past $9000
 LST OFF
 ERR *-1/$8FFF

 do M16PLUS
 SAV RUN/TC2.LOAD.SYSTEM
 fin

 END
