*-------------------------------
* MON2.EDITOR
*-------------------------------
 DAT
 LST OFF

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE VARS
 USE LIB.JMP
 USE TABLES
 USE MON.DSECT
 USE MON2.DSECT
 USE PLR.DSECT

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/MON2.EDITOR
 fin

NUMMON = 8 ;Number of entries for a MAZE.MONSTER

 MODID "MON2.EDITOR"

START JSR PRINT
 HOME
 BOX "Maze Monster Editor"
 NULL
 LDX #0
 LDA #0
 JSR LOADSCEN
 LDA SCENBUFF
 STA MAXSCEN
 STZ :FLAG
 STZ :MON
 STZ :MON+1
 LDX #0
 LDA #0
 JSR LOADMAP
 LDA MAP
 STA NUMLVLS
 LDX #0
 LDA #0
 JSR LOADMON
 LDA MONBUFF
 STA TOTMONS
 LDX #0
 LDA #0
 JSR LOADMON2
 LDA MON2BUFF
 STA :RECS
 LDA MON2BUFF+1
 STA :RECS+1
 LDX #0
 LDA #0
 JSR LOADPLR
 LDA PLRBUFF
 STA TOTPLRS
 LDA PLRBUFF+1
 STA TOTPLRS+1
 JMP :FORW1
:BOT JSR PRINT
 GOTOXY 1;1
 ASC "Total in file : "
 COLOR YELLOW
 DEC16 :RECS
 COLOR WHITE
 ASC "  "
 GOTOXY 1;2
 ASC "Scenario      : "
 COLOR YELLOW
 DEC8 SCENARIO
 COLOR WHITE
 ASC "  "
 NULL
:BOTBIT JSR PRINT
 GOTOXY 0;23
 CLEOS
 ASC "[A]dd, [J]ump, [S]ave, [L]ist, [X], [RETURN]-edit, "
 MTON
 INVERSE
 ASC "H"
 NORMAL
 ASC ", "
 INVERSE
 ASC "U"
 NORMAL
 MTOFF
 ASC ", [H]elp, [Q]uit : "
 CURSORON
 NULL
 LDA CH
 STA :BGOTO+2
:GETKEY JSR PRINT
:BGOTO GOTOXY 0;23
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 LDX :KEYS
]LOOP2 CMP :KEYS,X
 BEQ :GOTONE
 DEX
 BNE ]LOOP2
 JMP ]LOOP
:GOTONE DEX
 TXA
 ASL
 TAX
 JMP (:TABLE,X)

:KEYS DFB :ENDKEYS-*-1
 DFB "Q"
 DFB "A"
 DFB "L"
 DFB "J"
 DFB "S"
 DFB "H"-$40
 DFB "U"-$40
 DFB "K"-$40
 DFB "J"-$40
 DFB "M"-$40
 DFB "H"
 DFB "X"
:ENDKEYS

:TABLE DA EXIT
 DA :ADD
 DA :LIST
 DA :LOAD
 DA :SAVE
 DA :BACK1
 DA :FORW1
 DA :UP
 DA :DOWN
 DA :EDIT
 DA :HELP
 DA :SCEN

:SCEN LDA MAXSCEN
 BEQL :GETKEY
 JSR PRINT
 NORMAL
 MTOFF
 GOTOXY 0;23
 ZAPLINE
 ASC "Change scenario to (max="
 DEC8 MAXSCEN
 ASC ") : "
 NULL
 GETLINE #1
 CPX #0
 BEQ :NO
 JSR GETNUM
 CPX MAXSCEN
 BEQ :OK
 BCS :NO
:OK STX SCENARIO
 JSR PRINT
 GOTOXY 0;4
 CLEOS
 NULL
 LDX #0
 LDA #0
 JSR LOADMON2
 LDA MON2BUFF
 STA :RECS
 LDA MON2BUFF+1
 STA :RECS+1
 STZ :MON
 STZ :MON+1
 JMP :FORW1
:NO JMP :BOTBIT

:HELP JSR PRINT
 GOTOXY 0;4
 CLEOS
 NULL
 JSR GETFILE
 DFB 4,22 ;Use lines x to y
 STR "HELP/MON2.ED"
 JSR PRINT
 GOTOXY 0;23
 COLOR PINK
 NULL
 GETRETURN
 JSR PRINT
 GOTOXY 0;4
 COLOR WHITE
 CLEOS
 NULL
 JMP :MBACK

:DOPOINT LDA :OLDPNTR
 CMP #19
 BCC :PLEFT
 LDA #40
 STA :CH+2
 LDA :OLDPNTR
 SEC
 SBC #15
 STA :CV+2
 BRA :DOP1
:PLEFT STZ :CH+2
 LDA :OLDPNTR
 CLC
 ADC #3
 STA :CV+2
:DOP1 JSR PRINT
 NORMAL
 MTOFF
:CH HTAB 0
:CV VTAB 0
 ASC " "
 NULL
 LDA :PNTR
 CMP #19
 BCC :PLEFT2
 LDA #40
 STA :CH2+2
 LDA :PNTR
 SEC
 SBC #15
 STA :CV2+2
 BRA :DOP2
:PLEFT2 STZ :CH2+2
 LDA :PNTR
 CLC
 ADC #3
 STA :CV2+2
:DOP2 JSR PRINT
:CH2 HTAB 0
:CV2 VTAB 0
 NULL
 JSR SHOWPNTR
 LDA :PNTR
 STA :OLDPNTR
 RTS
:OLDPNTR DFB 1
:PNTR DFB 1

:UP LDA :RECS
 ORA :RECS+1
 BEQL :BOT
 LDA :PNTR
 CMP #1
 BNE :UPOK
 LDA #NUMMON+1
:UPOK DEC
 STA :PNTR
 JSR :DOPOINT
 JMP :GETKEY

:DOWN LDA :RECS
 ORA :RECS+1
 BEQL :BOT
 LDA :PNTR
 CMP #NUMMON
 BNE :DNOK
 LDA #0
:DNOK INC
 STA :PNTR
 JSR :DOPOINT
 JMP :GETKEY

:EDIT LDA :RECS
 ORA :RECS+1
 BEQL :BOT
 LDA :PNTR
 DEC
 ASL
 TAX
 JMP (:EDITS,X)

:EDITS DA :TYPE
 DA :XPOS
 DA :YPOS
 DA :ZPOS
 DA :HP
 DA :DIR
 DA :ACHAR
 DA :COND

:LOAD LDA :RECS
 ORA :RECS+1
 BEQL :BOT
 JSR PRINT
 GOTOXY 0;23
 CLEOS
 ASC "Jump to maze monster #"
 CURSORON
 NULL
 GETLINE #5
 JSR GETNUM
 CPX #0
 BNE :LOK
 CPY #0
 BEQL :BOT
:LOK CPY :RECS+1
 BCC :RNGOK
 CPX :RECS
 BEQ :RNGOK
 BCC :RNGOK
 JSR PRINT
 COLOR PINK
 ASC " No such maze monster. "
 COLOR WHITE
 NULL
 GETRETURN
 JMP :BOT
:RNGOK STX :MON
 STY :MON+1
 TYA
 JSR LOADMON2
 JSR :DISPLAY
 STZ :FLAG
 JMP :BOT

:SAVE LDA :RECS
 ORA :RECS+1
 BEQL :BOT
 BIT :FLAG
 BPLL :GETKEY
:SAVE2 LDX :MON
 LDA :MON+1
 JSR SAVEMON2
 LDX SCENARIO
 BEQ :SZ
 LDA #$FF
 STA SCUPDATE-1,X
:SZ STZ :FLAG
 JMP :BOT

:BACK1 LDA :RECS
 ORA :RECS+1
 BEQL :BOT
 LDA :MON+1
 BNE :GOB
 LDA :MON
 CMP #2
 BCS :GOB
 JMP :BOT
:GOB DECR :MON
 LDX :MON
 LDY :MON+1
 JMP :LOK

:FORW1 LDA :RECS
 ORA :RECS+1
 BEQL :BOT
 LDA :MON+1
 CMP :RECS+1
 BCC :GOF
 LDA :MON
 CMP :RECS
 BCC :GOF
 JMP :BOT
:GOF INCR :MON
 LDX :MON
 LDY :MON+1
 JMP :LOK

:LIST LDA :RECS
 ORA :RECS+1
 BEQL :BOT
 JSR PRINT
 GOTOXY 0;23
 CLEOS
 ASC "Start from maze monster #1"
 CURSORLEFT
 NULL
 LDA PADFLAG
 STA TEMP
 LDA #$FF
 STA PADFLAG
 LDA PADCHAR
 STA TEMP+1
 LDA #" "
 STA PADCHAR
 LDA #1
 STA :TOREAD
 STZ :TOREAD+1
 GETLINE #5
 BCSL :LEXIT
 CPX #0
 BEQ :FROM1
 JSR GETNUM
 STX :TOREAD
 STY :TOREAD+1
:FROM1 LDA :TOREAD+1
 CMP :RECS+1
 BCC :VGO
 BEQ :FROMLO
 BCS :FROMNO
:FROMLO LDA :TOREAD
 CMP :RECS
 BCC :VGO
 BEQ :VGO
:FROMNO JSR PRINT
 ASC " - "
 COLOR PINK
 ASC "Last maze monster is #"
 COLOR YELLOW
 DEC16 :RECS
 COLOR PINK
 ASC ". "
 COLOR WHITE
 NULL
 GETRETURN
 JSR PRINT
 ZAPLINE
 NULL
 JMP :LEXIT
:VGO LDA :TOREAD
 STA :MCNTR
 LDA :TOREAD+1
 STA :MCNTR+1
 JSR PRINT
 GOTOXY 0;3
 CLEOS
 CR
 COLOR AQUAMARINE
 ASC "Monster/ X/ Y/Lvl/ HP/ Direction / Name"
 HTAB 54
 ASC "/ Arrested player"
 CR
 COLOR WHITE
 CURSOROFF
 NULL
]LOOP LDA :MCNTR+1
 CMP :RECS+1
 BCC :RREAD
 LDA :MCNTR
 CMP :RECS
 BCC :RREAD
 BEQ :RREAD
 JMP :RDONE
:RREAD LDX :TOREAD
 LDA :TOREAD+1
 JSR LOADMON2
 INCR :TOREAD
 LDA CV
 CMP #21
 BNE :VOK
 JSR PRINT
 CR
 CR
 CURSORON
 COLOR YELLOW
 CENTER "[SPACE]-continue, [ESC]-exit : "
 COLOR WHITE
 NULL
]LOOP3 JSR KEYIN
 CMP #$9B
 BEQL :RESC
 CMP #" "
 BNE ]LOOP3
 JSR PRINT
 GOTOXY 0;5
 CLEOS
 CURSOROFF
 NULL
:VOK LDX MTYPE
 LDA MTYPE+1
 JSR LOADMON
 JSR PRINT
 CR
 COLOR YELLOW
 DEC16 :MCNTR
 COLOR WHITE
 ASC ")  "
 COLOR YELLOW
 PAD2 MXPOS
 COLOR WHITE
 ASC ","
 COLOR YELLOW
 PAD2 MYPOS
 COLOR WHITE
 ASC "  "
 COLOR YELLOW
 PAD2 MZPOS
 COLOR WHITE
 ASC " "
 COLOR PINK
 DEC8NEG MCURHP
 COLOR WHITE
 ASC " "
 COLOR GREEN
 PRTABLE MDIR;DIRECTION
 COLOR WHITE
 HTAB 35
 COLOR ORANGE
 NULL
 LDA MLEVEL
 BNE :NOTG
 JSR PRINT
 COLOR AQUAMARINE
 NULL
:NOTG JSR PRINT
 PRSTRING MNAME
 COLOR WHITE
 NULL
 LDA MARRESTCHAR
 ORA MARRESTCHAR+1
 BEQ :MNEXT
 LDX MARRESTCHAR
 LDA MARRESTCHAR+1
 JSR LOADPLR
 JSR PRINT
 HTAB 56
 COLOR PINK
 PRSTRING PLRNAME
 COLOR WHITE
 NULL
:MNEXT INCR :MCNTR
 LDA $C000
 BPLL ]LOOP
 STA $C010
 CMP #$9B
 BEQ :RDONE
 JMP ]LOOP
:RESC JSR PRINT
 ZAPLINE
 CURSORON
 NULL
 BRA :RDONE2
:RDONE JSR PRINT
 GOTOXY 0;23
 COLOR PINK
 CURSORON
 NULL
 GETRETURN
 JSR PRINT
 COLOR WHITE
 NULL
:RDONE2 LDA TEMP
 STA PADFLAG
 LDA TEMP+1
 STA PADCHAR
 LDX :MON
 LDY :MON+1
 JMP :LOK
:LEXIT LDA TEMP
 STA PADFLAG
 LDA TEMP+1
 STA PADCHAR
 JMP :BOT
:MCNTR DS 2
:TOREAD DA 2

:DISPLAY LDA :RECS
 ORA :RECS+1
 BEQL :BOT
 LDX MTYPE
 LDA MTYPE+1
 JSR LOADMON
 JSR PRINT
 GOTOXY 60;1
 ASC "Monster #"
 COLOR YELLOW
 DEC16 :MON
 COLOR WHITE
 ASC " "
 GOTOXY 0;4
 CLEOS
 CURSOROFF
 ASC "  1 - Type / number.."
 COLOR AQUAMARINE
 DEC16 MTYPE
 COLOR WHITE
 ASC "  ("
 COLOR ORANGE
 PRSTRING MNAME
 COLOR WHITE
 LINE ")"
 ASC "  2 - X position....."
 COLOR YELLOW
 DEC8 MXPOS
 COLOR WHITE
 CR
 ASC "  3 - Y position....."
 COLOR YELLOW
 DEC8 MYPOS
 COLOR WHITE
 CR
 ASC "  4 - Level.........."
 COLOR YELLOW
 DEC8 MZPOS
 COLOR WHITE
 CR
 ASC "  5 - Curr HP........"
 COLOR PINK
 DEC8NEG MCURHP
 COLOR WHITE
 CR
 ASC "  6 - Direction......"
 COLOR YELLOW
 DEC8 MDIR
 COLOR WHITE
 ASC "="
 COLOR GREEN
 PRTABLE MDIR;DIRECTION
 COLOR WHITE
 CR
 ASC "  7 - Arrest char...."
 COLOR YELLOW
 DEC16 MARRESTCHAR
 COLOR WHITE
 ASC " = "
 NULL
 LDA MARRESTCHAR
 ORA MARRESTCHAR+1
 BNE :CHAROK
 JSR PRINT
 ASC "<none>"
 NULL
 BRA :CHCONT
:CHAROK LDX MARRESTCHAR
 LDA MARRESTCHAR+1
 JSR LOADPLR
 JSR PRINT
 ASC "("
 COLOR ORANGE
 PRSTRING PLRNAME
 COLOR WHITE
 ASC ")"
 NULL
:CHCONT JSR PRINT
 CR
 ASC "  8 - Condition......"
 COLOR YELLOW
 PRNIBBLE MCOND
 COLOR WHITE
 ASC "="
 COLOR AQUAMARINE
 PRCOND MCOND
 COLOR WHITE
 CR
 CURSORON
 NULL
 JMP :DOPOINT
:MON DS 2

:MBACK JSR PRINT
 GOTOXY 0;23
 CLEOS
 NULL
 JSR :DISPLAY
 LDA #$FF
 STA :FLAG
 JMP :BOT

:ADD JSR PRINT
 GOTOXY 0;23
 CLEOS
 ASC "Add - [N]ext free one, [E]nd of file, [ESC] Exit : "
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 CMP #$9B
 BEQL :BOT
 CMP #"N"
 BEQ :ANEXT
 CMP #"E"
 BNE ]LOOP
 JSR COUT
:AEND LDX #0
 LDA #0
 JSR LOADMON2
 LDA MON2BUFF
 CMP #$FF
 BCC :AEOK
 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 COLOR PINK
 ASC "Cannot add any more maze monsters. "
 COLOR WHITE
 NULL
 GETRETURN
 JMP :ADD
:AEOK INCR MON2BUFF ;Add 1 to the number of monsters
 LDX #0
 LDA #0
 JSR SAVEMON2 ;Save it out
 INCR :RECS
 LDA :RECS
 STA :MON
 LDA :RECS+1
 STA :MON+1
:AGOTIT LDX #0
]LOOP STZ MON2BUFF,X
 INX
 BNE ]LOOP
 JSR :DISPLAY
 JMP :SAVE2
:ANEXT JSR COUT
 LDX :MON
 LDY :MON+1
 STX :MONN
 STY :MONN+1
 LDA :RECS
 BNE :NXTOK
 LDA :RECS+1
 BEQL :AEND
:NXTOK
]LOOP LDA :MONN+1
 CMP :RECS+1
 BCC :NRNGOK
 LDA :MONN
 CMP :RECS
 BEQ :NRNGOK
 BCSL :AEND
:NRNGOK LDX :MONN
 LDA :MONN+1
 JSR LOADMON2
 INCR :MONN
 LDA MFREE
 BPL ]LOOP
 DECR :MONN
 LDA :MONN
 STA :MON
 LDA :MONN+1
 STA :MON+1
 JMP :AGOTIT
:MONN DS 2

:TYPE LDX #5
 LDY #1
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :TYRTS
 JSR GETNUM
 CPX TOTMONS
 BEQ :TYOK
 BCS :TYRTS
:TYOK STX MTYPE
:TYRTS JMP :MBACK

:XPOS LDX #5
 LDY #2
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :XRTS
 JSR GETNUM
 CPX #$10
 BCS :XRTS
 STX MXPOS
:XRTS JMP :MBACK

:YPOS LDX #5
 LDY #3
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :YRTS
 JSR GETNUM
 CPX #$10
 BCS :YRTS
 STX MYPOS
:YRTS JMP :MBACK

:ZPOS LDX #5
 LDY #4
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :ZRTS
 JSR GETNUM
 DEX
 CPX NUMLVLS
 BCS :ZRTS
 INX
 STX MZPOS
:ZRTS JMP :MBACK

:HP LDX #5
 LDY #5
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :HPRTS
 JSR GETNUM
 STX MCURHP
:HPRTS JMP :MBACK

:DIR LDX #5
 LDY #6
 JSR ASK
 GETLINE #2
 CPX #0
 BEQ :DIRTS
 JSR GETNUM
 CPX #11
 BCS :DIRTS
 STX MDIR
:DIRTS JMP :MBACK

:COND LDX #6
 LDY #8
 JSR ASK
 GETLINE #8
 CPX #0
 BEQ :COND2
 JSR GETNIBBLE
 STX MCOND
:COND2 LDA #$80
 STA :ANDX
 LDA MCOND
 LDX #7
]LOOP PHA
 STX TEMP
 AND :ANDX
 CMP #0
 BEQ :NXTM
 LDX #5
 LDY #18
 JSR ASK
 JSR PRINT
 CURSORLEFT
 CURSORLEFT
 ASC "bit = "
 DEC8 TEMP
 ASC " : "
 NULL
 GETLINE #3
 CPX #0
 BEQ :NXTM
 JSR GETNUM
 TXA
 LDX TEMP
 STA MCONDX,X
:NXTM DEC TEMP
 LSR :ANDX
 PLA
 LDX TEMP
 CPX #$FF
 BNE ]LOOP
 JMP :MBACK
:ANDX DS 1

:ACHAR LDX #5
 LDY #7
 JSR ASK
 GETLINE #5
 CPX #0
 BEQ :ACRTS
 JSR GETNUM
 STX MARRESTCHAR
 STY MARRESTCHAR+1
 CLC
 XCE
 REP #$30
 LDA MARRESTCHAR
 CMP TOTPLRS
 BEQ :CHAROK1
 BCC :CHAROK1
 STZ MARRESTCHAR
:CHAROK1 SEC
 XCE
:ACRTS JMP :MBACK

:RECS DS 2
:FLAG DS 1
:DDAY DS 1
:DMONTH DS 1
:DYEAR DS 1
:DENTRY DS 9

EXIT JSR PRINT
 NORMAL
 MTOFF
 HOME
 NULL
 LDA SCENARIO
 PHA
 LDX #0
 LDA #0
 JSR LOADSCEN
 LDA SCENBUFF
 STA :TOTSCEN
 STZ SCENARIO
]LOOP LDX SCENARIO
 CPX :TOTSCEN
 BEQ :DONE
 INC SCENARIO
 LDA SCUPDATE,X
 BEQ ]LOOP
 JSR PRINT
 COLOR AQUAMARINE
 ASC "Reclaiming"
 COLOR WHITE
 ASC " (scenario #"
 COLOR YELLOW
 DEC8 SCENARIO
 COLOR WHITE
 ASC ").."
 NULL
 JSR RECLAIM
 JSR PRINT
 CR
 CR
 NULL
 BRA ]LOOP
:DONE PLA
 STA SCENARIO
 RETURN
:TOTSCEN DS 1

TEMP DS 2
TOTMONS DS 1
NUMLVLS DS 1

TOTPLRS DS 2
MAXSCEN DS 1

SCUPDATE DS 9

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/MON2.EDITOR
 fin

 END
