*-------------------------------
* SCEN.EDITOR
*-------------------------------
 DAT
 LST OFF

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE VARS
 USE MON.DSECT
 USE ITEM.DSECT
 USE SCEN.DSECT
 USE LIB.JMP
 USE TABLES
 USE INV.DSECT

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/SCEN.EDITOR
 fin

NUMSC = 7 ;Number of entries for a SCENARIO

 MODID "SCEN.EDITOR"

START JSR PRINT
 HOME
 BOX "Scenario Editor"
 NULL
 STZ :FLAG
 STZ :SC
 STZ :SC+1
 LDX #0
 LDA #0
 JSR LOADMON
 LDA MONBUFF
 STA TOTMONS
 LDX #0
 LDA #0
 JSR LOADITEM
 LDA ITEMBUFF
 STA TOTITEMS
 LDX #0
 LDA #0
 JSR LOADSCEN
 LDA SCENBUFF
 STA TOTRECS
 JMP :FORW1
:BOT JSR PRINT
 GOTOXY 1;1
 ASC "Total in file : "
 COLOR YELLOW
 DEC16 TOTRECS
 COLOR WHITE
 GOTOXY 0;23
 CLEOS
 ASC "[A]dd, [J]ump, [S]ave, [L]ist, [RETURN]-edit, "
 MTON
 INVERSE
 ASC "H"
 NORMAL
 ASC ", "
 INVERSE
 ASC "U"
 NORMAL
 MTOFF
 ASC ", [H]elp, [Q]uit : "
 CURSORON
 NULL
 LDA CH
 STA :BGOTO+2
:GETKEY JSR PRINT
:BGOTO GOTOXY 0;23
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 LDX :KEYS
]LOOP2 CMP :KEYS,X
 BEQ :GOTONE
 DEX
 BNE ]LOOP2
 JMP ]LOOP
:GOTONE DEX
 TXA
 ASL
 TAX
 JMP (:TABLE,X)

:KEYS DFB :ENDKEYS-*-1
 DFB "Q"
 DFB "A"
 DFB "L"
 DFB "J"
 DFB "S"
 DFB "H"-$40
 DFB "U"-$40
 DFB "K"-$40
 DFB "J"-$40
 DFB "M"-$40
 DFB "H"
:ENDKEYS

:TABLE DA EXIT
 DA :ADD
 DA :LIST
 DA :LOAD
 DA :SAVE
 DA :BACK1
 DA :FORW1
 DA :UP
 DA :DOWN
 DA :EDIT
 DA :HELP

:HELP JSR PRINT
 GOTOXY 0;4
 CLEOS
 NULL
 JSR GETFILE
 DFB 4,22 ;Use lines x to y
 STR "HELP/SCEN.ED"
 JSR PRINT
 GOTOXY 0;23
 COLOR PINK
 NULL
 GETRETURN
 JSR PRINT
 GOTOXY 0;4
 COLOR WHITE
 CLEOS
 NULL
 JMP :CBACK

:DOPOINT LDA :OLDPNTR
 CMP #19
 BCC :PLEFT
 LDA #40
 STA :CH+2
 LDA :OLDPNTR
 SEC
 SBC #15
 STA :CV+2
 BRA :DOP1
:PLEFT STZ :CH+2
 LDA :OLDPNTR
 CLC
 ADC #3
 STA :CV+2
:DOP1 JSR PRINT
 NORMAL
 MTOFF
:CH HTAB 0
:CV VTAB 0
 ASC " "
 NULL
 LDA :PNTR
 CMP #19
 BCC :PLEFT2
 LDA #40
 STA :CH2+2
 LDA :PNTR
 SEC
 SBC #15
 STA :CV2+2
 BRA :DOP2
:PLEFT2 STZ :CH2+2
 LDA :PNTR
 CLC
 ADC #3
 STA :CV2+2
:DOP2 JSR PRINT
:CH2 HTAB 0
:CV2 VTAB 0
 NULL
 JSR SHOWPNTR
 LDA :PNTR
 STA :OLDPNTR
 RTS
:OLDPNTR DFB 1
:PNTR DFB 1

:UP LDA TOTRECS
 BEQL :BOT
 LDA :PNTR
 CMP #1
 BNE :UPOK
 LDA #NUMSC+1
:UPOK DEC
 STA :PNTR
 JSR :DOPOINT
 JMP :GETKEY

:DOWN LDA TOTRECS
 BEQL :BOT
 LDA :PNTR
 CMP #NUMSC
 BNE :DNOK
 LDA #0
:DNOK INC
 STA :PNTR
 JSR :DOPOINT
 JMP :GETKEY

:EDIT LDA TOTRECS
 BEQL :BOT
 LDA :PNTR
 DEC
 ASL
 TAX
 JMP (:EDITS,X)

:EDITS DA :FREE
 DA :M2KILL
 DA :ITEM
 DA :NAME
 DA :MPERLVL
 DA :GPERLVL
 DA :MINEXP

:LOAD LDA TOTRECS
 BEQL :BOT
 JSR PRINT
 GOTOXY 0;23
 CLEOS
 ASC "Jump to scenario #"
 CURSORON
 NULL
 GETLINE #5
 JSR GETNUM
 CPX #0
 BNE :LOK
 CPY #0
 BEQL :BOT
:LOK CPY TOTRECS+1
 BCC :RNGOK
 CPX TOTRECS
 BEQ :RNGOK
 BCC :RNGOK
 JSR PRINT
 COLOR PINK
 ASC " No such scenario. "
 COLOR WHITE
 NULL
 GETRETURN
 JMP :BOT
:RNGOK STX :SC
 STY :SC+1
 TYA
 JSR LOADSCEN
 JSR :DISPLAY
 STZ :FLAG
 JMP :BOT

:SAVE LDA TOTRECS
 BEQL :BOT
 BIT :FLAG
 BPLL :GETKEY
:SAVE2 LDX :SC
 LDA :SC+1
 JSR SAVESCEN
 STZ :FLAG
 JMP :BOT

:BACK1 LDA TOTRECS
 BEQL :BOT
 LDA :SC+1
 BNE :GOB
 LDA :SC
 CMP #2
 BCS :GOB
 JMP :BOT
:GOB DECR :SC
 LDX :SC
 LDY :SC+1
 JMP :LOK

:FORW1 LDA TOTRECS
 BEQL :BOT
 LDA :SC+1
 CMP TOTRECS+1
 BCC :GOF
 LDA :SC
 CMP TOTRECS
 BCC :GOF
 JMP :BOT
:GOF INCR :SC
 LDX :SC
 LDY :SC+1
 JMP :LOK

:LIST LDA TOTRECS
 BEQL :BOT
 JSR PRINT
 GOTOXY 0;23
 CLEOS
 ASC "Start from scenario #1"
 CURSORLEFT
 NULL
 LDA PADFLAG
 STA TEMP
 LDA #$FF
 STA PADFLAG
 LDA PADCHAR
 STA TEMP+1
 LDA #" "
 STA PADCHAR
 LDA #1
 STA :TOREAD
 STZ :TOREAD+1
 GETLINE #5
 BCSL :LEXIT
 CPX #0
 BEQ :FROM1
 JSR GETNUM
 STX :TOREAD
 STY :TOREAD+1
:FROM1 LDA :TOREAD+1
 CMP TOTRECS+1
 BCC :VGO
 BEQ :FROMLO
 BCS :FROMNO
:FROMLO LDA :TOREAD
 CMP TOTRECS
 BCC :VGO
 BEQ :VGO
:FROMNO JSR PRINT
 ASC " - "
 COLOR PINK
 ASC "Last scenario is #"
 COLOR YELLOW
 DEC16 TOTRECS
 COLOR PINK
 ASC ". "
 COLOR WHITE
 NULL
 GETRETURN
 JSR PRINT
 ZAPLINE
 NULL
 JMP :LEXIT
:VGO LDA :TOREAD
 STA :MCNTR
 LDA :TOREAD+1
 STA :MCNTR+1
 JSR PRINT
 GOTOXY 0;3
 CLEOS
 CR
 COLOR AQUAMARINE
 LINE "Scen/?/Monster to kill        /Item to get             /Name"
 COLOR WHITE
 CURSOROFF
 NULL
]LOOP LDA :MCNTR+1
 CMP TOTRECS+1
 BCC :RREAD
 LDA :MCNTR
 CMP TOTRECS
 BCC :RREAD
 BEQ :RREAD
 JMP :RDONE
:RREAD LDX :TOREAD
 LDA :TOREAD+1
 JSR LOADSCEN
 INCR :TOREAD
 LDA CV
 CMP #21
 BNE :VOK
 JSR PRINT
 CR
 CR
 CURSORON
 COLOR YELLOW
 CENTER "[SPACE]-continue, [ESC]-exit : "
 COLOR WHITE
 NULL
]LOOP3 JSR KEYIN
 CMP #$9B
 BEQL :RESC
 CMP #" "
 BNE ]LOOP3
 JSR PRINT
 GOTOXY 0;5
 CLEOS
 CURSOROFF
 NULL
:VOK STZ MNAME
 LDX SCMON2KILL
 CPX #0
 BEQ :VOK2
 LDA #0
 JSR LOADMON
:VOK2 STZ INAME
 LDX SCITEM
 CPX #0
 BEQ :VOK3
 LDA #0
 JSR LOADITEM
:VOK3 JSR PRINT
 CR
 COLOR YELLOW
 DEC8 :MCNTR
 COLOR WHITE
 ASC ") "
 PRFLAG SCFREE
 ASC " "
 COLOR AQUAMARINE
 DEC8 SCMON2KILL
 COLOR WHITE
 ASC "="
 COLOR ORANGE
 PRSTRING MNAME
 COLOR WHITE
 HTAB 31
 COLOR AQUAMARINE
 DEC8 SCITEM
 COLOR WHITE
 ASC "="
 COLOR PINK
 PRSTRING INAME
 COLOR WHITE
 HTAB 56
 COLOR ORANGE
 NULL
 LDA SCNAME
 CMP #21
 BCS :SQUASH
 JSR PRINT
 PRSTRING SCNAME
 NULL
 BRA :NAMEOK
:SQUASH LDX #0
]LOOP2 LDA SCNAME+1,X
 JSR COUT
 INX
 CPX #20
 BNE ]LOOP2
 JSR PRINT
 ASC ".."
 NULL
:NAMEOK JSR PRINT
 COLOR WHITE
 NULL
:MNEXT INCR :MCNTR
 LDA $C000
 BPLL ]LOOP
 STA $C010
 CMP #$9B
 BEQ :RDONE
 JMP ]LOOP
:RESC JSR PRINT
 ZAPLINE
 CURSORON
 NULL
 BRA :RDONE2
:RDONE JSR PRINT
 GOTOXY 0;23
 COLOR PINK
 CURSORON
 NULL
 GETRETURN
 JSR PRINT
 COLOR WHITE
 NULL
:RDONE2 LDA TEMP
 STA PADFLAG
 LDA TEMP+1
 STA PADCHAR
 LDX :SC
 LDY :SC+1
 JMP :LOK
:LEXIT LDA TEMP
 STA PADFLAG
 LDA TEMP+1
 STA PADCHAR
 JMP :BOT
:MCNTR DS 2
:TOREAD DA 2

:DISPLAY LDA TOTRECS
 BEQL :BOT
 STZ MNAME
 LDX SCMON2KILL
 CPX #0
 BEQ :DISP2
 LDA #0
 JSR LOADMON
:DISP2 STZ INAME
 LDX SCITEM
 CPX #0
 BEQ :DISP3
 LDA #0
 JSR LOADITEM
:DISP3 JSR PRINT
 GOTOXY 60;1
 ASC "Scenario #"
 COLOR YELLOW
 DEC8 :SC
 COLOR WHITE
 ASC " "
 GOTOXY 0;4
 CLEOS
 CURSOROFF
 ASC "  1 - Free............."
 PRFLAG SCFREE
 CR
 ASC "  2 - Monster to kill.."
 COLOR AQUAMARINE
 DEC8 SCMON2KILL
 COLOR WHITE
 ASC "="
 COLOR ORANGE
 PRSTRING MNAME
 COLOR WHITE
 CR
 ASC "  3 - Item to get......"
 COLOR AQUAMARINE
 DEC8 SCITEM
 COLOR WHITE
 ASC "="
 COLOR PINK
 PRSTRING INAME
 COLOR WHITE
 CR
 ASC "  4 - Name............."
 COLOR ORANGE
 PRSTRING SCNAME
 COLOR WHITE
 CR
 ASC "  5 - Monsters / lvl...?"
 CR
 ASC "  6 - Guardians / lvl.."
 COLOR YELLOW
 DEC8 SCGUARDSPERLVL
 COLOR WHITE
 CR
 ASC "  7 - Min exp lvl/play."
 COLOR YELLOW
 DEC8 SCMINEXPLVL ;Minimum exp level to play scenario
 COLOR WHITE
 CR
 CURSORON
 NULL
 JMP :DOPOINT
:SC DS 2

:CBACK JSR PRINT
 GOTOXY 0;23
 CLEOS
 NULL
 JSR :DISPLAY
 LDA #$FF
 STA :FLAG
 JMP :BOT

:ADD JSR PRINT
 GOTOXY 0;23
 CLEOS
 ASC "Add - [N]ext free one, [E]nd of file, [ESC] Exit : "
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 CMP #$9B
 BEQL :BOT
 CMP #"N"
 BEQ :ANEXT
 CMP #"E"
 BNE ]LOOP
 JSR COUT
:AEND LDX #0
 LDA #0
 JSR LOADSCEN
 LDA SCENBUFF
 CMP #9
 BCC :AEOK
 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 COLOR PINK
 ASC "Cannot add any more scenarios. "
 COLOR WHITE
 NULL
 GETRETURN
 JMP :ADD
:AEOK INC SCENBUFF ;Add 1 to the number of scenarios
 LDX #0
 LDA #0
 JSR SAVESCEN ;Save it out
 INCR TOTRECS
 LDA TOTRECS
 STA :SC
 LDA TOTRECS+1
 STA :SC+1
:AGOTIT LDX #0
]LOOP STZ SCENBUFF,X
 INX
 BNE ]LOOP
 LDA :SC
 JSR CHECKEM ;Check that files exist for the scenario
 JSR :DISPLAY
 JMP :SAVE2
:ANEXT JSR COUT
 LDX :SC
 LDY :SC+1
 STX :SCENN
 STY :SCENN+1
 LDA TOTRECS
 BNE :NXTOK
 LDA TOTRECS+1
 BEQL :AEND
:NXTOK
]LOOP LDA :SCENN+1
 CMP TOTRECS+1
 BCC :NRNGOK
 LDA :SCENN
 CMP TOTRECS
 BEQ :NRNGOK
 BCSL :AEND
:NRNGOK LDX :SCENN
 LDA :SCENN+1
 JSR LOADSCEN
 INCR :SCENN
 LDA SCFREE
 BPL ]LOOP
 DECR :SCENN
 LDA :SCENN
 STA :SC
 LDA :SCENN+1
 STA :SC+1
 JMP :AGOTIT
:SCENN DS 2

:FREE LDX #1
 LDY #1
 JSR ASK
 GETLINE #1
 CPX #0
 BEQL :CBACK
 LDA $200
 CMP #"1"
 BEQ :A1
 CMP #"0"
 BNE :FREE
 LDA #0
 HEX 2C
:A1 LDA #$FF
 STA SCFREE
 JMP :CBACK

:M2KILL LDX #5
 LDY #2
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :M2RTS
 JSR GETNUM
 DEX
 CPX TOTMONS
 BCS :M2RTS
 INX
 STX SCMON2KILL
:M2RTS JMP :CBACK

:ITEM LDX #5
 LDY #3
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :IRTS
 JSR GETNUM
 DEX
 CPX TOTITEMS
 BCS :IRTS
 INX
 STX SCITEM
:IRTS JMP :CBACK

:NAME LDX #2
 LDY #4
 JSR ASK
 GETLINE #40
 CPX #0
 BEQ :NRTS
 STX SCNAME
]LOOP LDA $200-1,X
 STA SCNAME,X
 DEX
 BNE ]LOOP
:NRTS JMP :CBACK

:MPERLVL JSR DOMONS
 JMP :CBACK

:GPERLVL LDX #5
 LDY #6
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :GPRTS
 JSR GETNUM
 STX SCGUARDSPERLVL
:GPRTS JMP :CBACK

:MINEXP LDX #5
 LDY #7
 JSR ASK
 GETLINE #2
 CPX #0
 BEQ :MERTS
 JSR GETNUM
 STX SCMINEXPLVL ;Minimum exp level to play scenario
:MERTS JMP :CBACK

:FLAG DS 1
:DDAY DS 1
:DMONTH DS 1
:DYEAR DS 1
:DENTRY DS 9
TOTRECS DS 2

DOMONS JSR PRINT
 GOTOXY 0;4
 CLEOS
 LINE "Monsters allocated per level"
 CR
 NULL
 LDX #0
]LOOP LDA SCMONPERLVL,X
 STA VTEMP+1
 INX
 STX VTEMP
 JSR PRINT
 PAD2 VTEMP
 ASC ") "
 DEC8 VTEMP+1
 CR
 NULL
 CPX #16
 BNE ]LOOP
:GETBOT JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 ASC "[E]dit, [ESC]-exit : "
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 CMP #$9B
 BEQL :MRTS
 CMP #"E"
 BNE ]LOOP
 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 ASC "Edit : "
 NULL
 GETLINE #2
 CPX #0
 BEQ :GETBOT
 JSR GETNUM
 CPX #0
 BEQ :GETBOT
 CPX #16
 BEQ :NOK
 BCS :GETBOT
:NOK STX :MP
 TXY
 LDX #5
 JSR ASK
 GETLINE #2
 CPX #0
 BEQL DOMONS
 JSR GETNUM
 TXA
 LDX :MP
 STA SCMONPERLVL-1,X
 LDA #0
 LDX #0
]LOOP CLC
 ADC SCMONPERLVL,X
 CMP #200
 BCS :TOOMUCH
 INX
 CPX MAP
 BNE ]LOOP
 JMP DOMONS
:TOOMUCH JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 COLOR PINK
 ASC "Too many monsters to allocate (in total). "
 COLOR WHITE
 NULL
 GETRETURN
 LDX :MP
 STZ SCMONPERLVL,X
 JMP DOMONS
:MRTS RTS
:MP DS 1

EXIT RETURN

CHECKEM STA :SCEN ;Make sure all files exist for this scenario
 JSR PRINT
 GOTOXY 0;4
 CLEOS
 ASC "Wait.."
 NULL
 LDA SCENARIO
 PHA

 LDA :SCEN
 STA SCENARIO
 ORA #"0"
 STA :F1+11
 STA :F2+9
 STA :F3+5
 STA :F4+6
 STA :F5+12
 STA :F6+15
 STA :F7+6
 STA :F8+14
 STA :F9+17

 STA :PATH1+11
 STA :PATH2+9
 STA :PATH3+5
 STA :PATH4+6
 STA :PATH5+12
 STA :PATH6+15
 STA :PATH7+6
 STA :PATH8+14
 STA :PATH9+17

 JSR CHECKFILE
:F1 STR "INVENTORY.0"
 BCCL :THERE1
 MLI_CREATE :CRPARMS1
 JSR MLIERR
 LDX #0
 LDA #0
 JSR LOADITEM
 LDA ITEMBUFF
 STA MISCBUFF
 STZ MISCBUFF+1
 LDX #0
 LDA #0
 JSR SAVEINV
 LDX #0
]LOOP2 CPX ITEMBUFF
 BEQ :THERE1
 STZ INVFREE
 STZ INVSTOCK
 STZ INVMAX
 STZ INVORDER
 INX
 PHX
 LDA #0
 JSR SAVEINV
 PLX
 BRA ]LOOP2

:THERE1 JSR CHECKFILE
:F2 STR "LOGFILE.0"
 BCC :THERE2
 MLI_CREATE :CRPARMS2
 JSR MLIERR
 STZ LOGBUFF
 STZ LOGBUFF+1
 LDX #0
 LDA #0
 JSR SAVELOGFILE

:THERE2 JSR CHECKFILE
:F3 STR "MAP.0"
 BCC :THERE3
 MLI_CREATE :CRPARMS3
 JSR MLIERR
 LDA #1
 STA MAP
 STZ MAP+1
 LDX #0
 LDA #0
 JSR SAVEMAP
 LDX #0 ;..create 1 level anyway
]LOOP2 STZ MAP,X
 INX
 BNE ]LOOP2
 LDX #1
 LDA #0
 JSR SAVEMAP

:THERE3 JSR CHECKFILE
:F4 STR "MAP2.0"
 BCCL :THERE4
 MLI_CREATE :CRPARMS4
 JSR MLIERR
 LDA #1
 STA MAP2
 STZ MAP2+1
 LDX #0
 LDA #0
 JSR SAVEMAP2
 LDX #0
]LOOP2 STZ MAP2,X
 INX
 BNE ]LOOP2
 LDX #0
 LDA #0
 JSR LOADMAP
 LDY MAP
 LDX #0
]LOOP2 INX
 PHX
 PHY
 LDA #0
 JSR SAVEMAP2
 PLY
 PLX
 DEY
 BNE ]LOOP2

:THERE4 JSR CHECKFILE
:F5 STR "MAZE.ITEMS.0"
 BCC :THERE5
 MLI_CREATE :CRPARMS5
 JSR MLIERR
 STZ ITEM2BUFF
 STZ ITEM2BUFF+1
 LDX #0
 LDA #0
 JSR SAVEITEM2

:THERE5 JSR CHECKFILE
:F6 STR "MAZE.MONSTERS.0"
 BCC :THERE6
 MLI_CREATE :CRPARMS6
 JSR MLIERR
 STZ MON2BUFF
 STZ MON2BUFF+1
 LDX #0
 LDA #0
 JSR SAVEMON2

:THERE6 JSR CHECKFILE
:F7 STR "SIGN.0"
 BCC :THERE7
 MLI_CREATE :CRPARMS7
 JSR MLIERR
 STZ MISCBUFF
 STZ MISCBUFF+1
 LDX #0
 LDA #0
 JSR SAVESIGN

:THERE7 JSR CHECKFILE
:F8 STR "STAIRS.TPORT.0"
 BCC :THERE8
 MLI_CREATE :CRPARMS8
 JSR MLIERR
 STZ STBUFF
 STZ STBUFF+1
 LDX #0
 LDA #0
 JSR SAVEST

:THERE8 JSR CHECKFILE
:F9 STR "FILES/WALL.DATA.0"
 BCC :THERE9
 MLI_CREATE :CRPARMS9
 JSR MLIERR
 MLI_OPEN :WOPARMS
 JSR MLIERR
 LDA :WOPARMS+5
 STA :WRWPARMS+1
 STA :WCPARMS+1
 MLI_WRITE :WRWPARMS
 JSR MLIERR
 MLI_CLOSE :WCPARMS
 JSR MLIERR

:THERE9 PLA
 STA SCENARIO
 JSR CLOSEALL
 JSR PRINT
 HTAB 0
 ZAPLINE
 NULL
 RTS

:CRPARMS1 DFB 7
 DA :PATH1
 DFB %11000011 ;Access bits ($C3)
 DFB $F2 ;Filetype
 DA INVRECLEN ;Aux type
 DFB 1 ;Storage type
 DA 0 ;Creation date
 DA 0 ;     & time
:PATH1 STR "INVENTORY.0"

:CRPARMS2 DFB 7
 DA :PATH2
 DFB %11000011 ;Access bits ($C3)
 DFB $F2 ;Filetype
 DA LOGRECLEN ;Aux type
 DFB 1 ;Storage type
 DA 0 ;Creation date
 DA 0 ;     & time
:PATH2 STR "LOGFILE.0"

:CRPARMS3 DFB 7
 DA :PATH3
 DFB %11000011 ;Access bits ($C3)
 DFB $F2 ;Filetype
 DA MAPRECLEN ;Aux type
 DFB 1 ;Storage type
 DA 0 ;Creation date
 DA 0 ;     & time
:PATH3 STR "MAP.0"

:CRPARMS4 DFB 7
 DA :PATH4
 DFB %11000011 ;Access bits ($C3)
 DFB $F2 ;Filetype
 DA MAPRECLEN ;Aux type
 DFB 1 ;Storage type
 DA 0 ;Creation date
 DA 0 ;     & time
:PATH4 STR "MAP2.0"

:CRPARMS5 DFB 7
 DA :PATH5
 DFB %11000011 ;Access bits ($C3)
 DFB $F2 ;Filetype
 DA ITEM2RECLEN ;Aux type
 DFB 1 ;Storage type
 DA 0 ;Creation date
 DA 0 ;     & time
:PATH5 STR "MAZE.ITEMS.0"

:CRPARMS6 DFB 7
 DA :PATH6
 DFB %11000011 ;Access bits ($C3)
 DFB $F2 ;Filetype
 DA MON2RECLEN ;Aux type
 DFB 1 ;Storage type
 DA 0 ;Creation date
 DA 0 ;     & time
:PATH6 STR "MAZE.MONSTERS.0"

:CRPARMS7 DFB 7
 DA :PATH7
 DFB %11000011 ;Access bits ($C3)
 DFB $F2 ;Filetype
 DA SIGNRECLEN ;Aux type
 DFB 1 ;Storage type
 DA 0 ;Creation date
 DA 0 ;     & time
:PATH7 STR "SIGN.0"

:CRPARMS8 DFB 7
 DA :PATH8
 DFB %11000011 ;Access bits ($C3)
 DFB $F2 ;Filetype
 DA STRECLEN ;Aux type
 DFB 1 ;Storage type
 DA 0 ;Creation date
 DA 0 ;     & time
:PATH8 STR "STAIRS.TPORT.0"

:CRPARMS9 DFB 7
 DA :PATH9
 DFB %11000011 ;Access bits ($C3)
 DFB $F2 ;Filetype
 DA 80*21+2 ;Aux type
 DFB 1 ;Storage type
 DA 0 ;Creation date
 DA 0 ;     & time
:PATH9 STR "FILES/WALL.DATA.0"

:SCEN DS 1

:WOPARMS DFB 3
 DA :PATH9
 DA IOBUFFER
 DS 1

:WRWPARMS DFB 4
 DS 1
 DA :BUFFER
 DA 80*21+2
 DS 2

:WCPARMS DFB 1
 DS 1

:BUFFER DS 80*21," "
 DFB 0,0

TEMP DS 2
TOTMONS DS 2
TOTITEMS DS 2

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/SCEN.EDITOR
 fin

 END
