*-------------------------------
* SPDESC.EDITOR
*-------------------------------
 DAT
 LST OFF

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE VARS
 USE LIB.JMP
 USE SPELL.DSECT
 USE SD.DSECT

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/SPDESC.EDITOR
 fin

 MODID "SPDESC.EDITOR"

ENTRY MAC
HERE STR ]1
 DS HERE-*+]LEN+1
 <<<

START JSR PRINT
 HOME
 CURSORON
 BOX "Spell Description Editor"
 GOTOXY 0;14
 INVERSE
 COLOR YELLOW
 ZAPLINE
 GOTOXY 0;22
 ZAPLINE
 NORMAL
 CR
 COLOR WHITE
 ASC "[ESC]-jump, [L]oad, [S]ave, [I]ndex, [G]oto, [H]elp, [Q]uit : "
 NULL
 LDA CH
 STA BOTCH+2

 JSR SETXY

 LDX #0
 LDA #0
 JSR LOADSPELL
 LDA SPELLBUFF
 STA TOTSPELLS

 STZ SPNAME

 STZ SDLEN
 STZ SDLEN+1

TOP JSR PRINT
 GOTOXY 0;7
 ZAPLINE
 ASC "Spell : "
 COLOR AQUAMARINE
 PRSTRING SPNAME
 COLOR WHITE
 NULL
 LDA CURRSP
 JSR CALCS
 JSR PRINT
 GOTOXY 0;4
 ASC "Current : "
 CLEOL
 COLOR YELLOW
 DEC16 CURRSP
 COLOR WHITE
 GOTOXY 0;5
 ASC "Total   : "
 COLOR YELLOW
 DEC16 TOTSPELLS
 COLOR WHITE
 NULL
 JSR PRLEN

BOT JSR PRINT
BOTCH GOTOXY 0;23
 CLEOL
 NULL

]LOOP JSR KEYIN
 JSR UPPER
 LDX :KEYS
]LOOP2 CMP :KEYS,X
 BEQ :GOTONE
 DEX
 BNE ]LOOP2
 JMP ]LOOP
:GOTONE DEX
 TXA
 ASL
 TAX
 JMP (:TABLE,X)

:KEYS DFB :ENDKEYS-*-1
 DFB $9B
 DFB "L"
 DFB "S"
 DFB "I"
 DFB "Q"
 DFB "H"-$40
 DFB "U"-$40
 DFB "G"
 DFB "H"
:ENDKEYS

:TABLE DA JUMP
 DA LOAD
 DA SAVE
 DA INDEX
 DA EXIT
 DA LEFT
 DA RIGHT
 DA GOTO
 DA HELP

GOTO JSR PRINT
 GOTOXY 0;12
 ZAPLINE
 ASC "Goto spell : "
 NULL
 GETLINE #15
 CPX #0
 BEQ :EXIT
 STX :SPELL
]LOOP LDA $200-1,X
 JSR UPPER
 STA :SPELL,X
 DEX
 BNE ]LOOP
 STZ :CNTR
]LOOP INC :CNTR
 LDX :CNTR
 LDA #0
 JSR LOADSPELL
 LDA SPNAME+1
 CMP #"?" ;Spell doesn't exist
 BEQ :NEXT
 LDX #0
]LOOP2 LDA :SPELL+1,X
 CMP SPNAME+1,X
 BNE :NEXT
 INX
 CPX :SPELL
 BNE ]LOOP2
 CPX SPNAME
 BNE :NEXT
 LDA :CNTR
 JMP :GOTIT
:NEXT LDA :CNTR
 CMP TOTSPELLS
 BNE ]LOOP
 JSR PRINT
 ASC " - "
 COLOR PINK
 ASC "not found. "
 COLOR WHITE
 NULL
 GETRETURN
:EXIT1 JSR PRINT
 ZAPLINE
 NULL
 JMP LOAD2
:EXIT JSR PRINT
 ZAPLINE
 NULL
 JMP TOP
:GOTIT LDA :CNTR
 STA CURRSP
 LDA :CNTR+1
 STA CURRSP+1
 BRA :EXIT1
:CNTR DS 2
:SPELL DS 1+15

LEFT LDA CURRSP+1
 BNE :YES
 LDA CURRSP
 CMP #2
 BCCL BOT
:YES DECR CURRSP
 JMP LOAD2

RIGHT LDA CURRSP+1
 CMP TOTSPELLS+1
 BNE :YES
 LDA CURRSP
 CMP TOTSPELLS
 BEQL BOT
:YES INCR CURRSP
 JMP LOAD2

INDEX LDA CURRSP
 PHA
 LDA CURRSP+1
 PHA
 STZ CURRSP
 STZ CURRSP+1
]LOOP2 JSR CLEAR
 JSR SETXY
]LOOP LDA CURRSP+1
 CMP TOTSPELLS+1
 BNE :OK
 LDA CURRSP
 CMP TOTSPELLS
 BEQ :DONE
:OK INCR CURRSP
 LDX CURRSP
 LDA CURRSP+1
 JSR LOADSPELL
 JSR PRINT
 DEC16 CURRSP
 HTAB 7
 PRSTRING SPNAME
 CR
 NULL
 LDA CV
 CMP BOTLINE
 BNE ]LOOP
 JSR PRINT
 COLOR PINK
 CENTER "[Any key continues; ESC-exit]"
 COLOR WHITE
 NULL
 JSR KEYIN
 CMP #$9B
 BNE ]LOOP2
:EXIT JSR CLEAR
 PLA
 STA CURRSP+1
 PLA
 STA CURRSP
 JMP LOAD2
:DONE LDA BOTLINE
 STA :IV+2
 JSR PRINT
:IV VTAB 0
 COLOR PINK
 CENTER "[Press any key]"
 COLOR WHITE
 NULL
 JSR KEYIN
 BRA :EXIT

JUMP LDA CURRSP
 ORA CURRSP+1
 BEQL BOT
 LDA XPOS
 STA :GOTO+2
 LDA YPOS
 STA :GOTO+3
 JSR PRINT
:GOTO GOTOXY 0;0
 NULL
 JMP EDIT

CLEAR JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 NULL
]LOOP JSR PRINT
 CURSORUP
 ZAPLINE
 NULL
 LDA CV
 CMP TOPLINE
 BNE ]LOOP
 RTS

HELP JSR CLEAR
 LDA TOPLINE
 STA :LINE
 LDA BOTLINE
 DEC
 STA :LINE+1
 JSR GETFILE
:LINE DFB 4,21 ;Use lines x to y
 STR "HELP/SPDESC.ED"
 JSR PRINT
 GOTOXY 0;21
 COLOR PINK
 CENTER "[Press any key]"
 COLOR WHITE
 NULL
 JSR KEYIN
 JSR CLEAR
 JMP LOAD2

LOAD JSR PRINT
 ASC "L"
 NULL
LOAD2 LDA CURRSP
 ORA CURRSP+1
 BEQL BOT
 JSR CLEAR
 LDX CURRSP
 LDA CURRSP+1
 JSR LOADSPELL
 JSR OPENIT
 JSR DOMARK
 MLI_READ RWPARMS
 JSR MLIERR
 LDA TOPLINE
 STA :LINES
 LDA BOTLINE
 STA :LINES+1
 LDX SDLEN ;Length
 LDA SDLEN+1
 JSR SHOWMSG
:LINES DS 2 ;Lines to use (top, bottom)
 DA SDTEXT
 JSR CLOSEALL
 JSR SETXY
 JSR PRLEN
 JMP TOP

SAVE JSR PRINT
 ASC "S"
 NULL
SAVE2 LDA CURRSP
 ORA CURRSP+1
 BEQL BOT
 LDA TOPLINE
 STA :LINES
 LDA BOTLINE
 STA :LINES+1
 JSR GETSCREEN ;PICKLINE the screen
:LINES DS 2 ;on these lines
 DA SDTEXT ;and put it here
 STX SDLEN ;X and A have length on return
 STA SDLEN+1
 CMP #>SDRECLEN
 BCC :LENOK
 LDA #<SDRECLEN
 STA SDLEN
 LDA #>SDRECLEN
 STA SDLEN+1
:LENOK JSR OPENIT
 JSR DOMARK
 MLI_WRITE RWPARMS
 JSR MLIERR
 JSR CLOSEALL
 JSR PRLEN
 JMP TOP

EDIT LDA XPOS
 STA :GOTO+2
 LDA YPOS
 STA :GOTO+3
 JSR PRINT
:GOTO GOTOXY 0;0
 NULL
 LDX TOPLINE
 LDA BOTLINE
 JSR MSGEDIT
 LDA CH
 STA XPOS
 LDA CV
 STA YPOS
 JMP BOT

EXIT RETURN

OPARMS DFB 3
 DA PATH
 DA IOBUFFER
 DS 1

RWPARMS DFB 4
 DS 1
 DA MISCBUFF
 DA SDRECLEN
 DS 2

MPARMS DFB 2
 DS 1
 DS 4

CPARMS DFB 1
 DS 1

SETXY LDA :TOP
 STA XPOS
 LDA :TOP+1
 STA YPOS
 RTS
:TOP DFB 0,15

PRLEN LDA SDLEN+1
 CMP #>SDRECLEN
 BCC :OK
 JSR PRINT
 INVERSE
 NULL
:OK JSR PRINT
 COLOR YELLOW
 GOTOXY 0;8
 COLOR WHITE
 ASC "Length $"
 COLOR YELLOW
 HEX16 SDLEN
 COLOR WHITE
 NORMAL
 NULL
 RTS

XPOS DS 1
YPOS DS 1

TOPLINE DFB 15
BOTLINE DFB 21

PATH STR "HELP/SPELL.DESCR"

CURRSP DS 2
TOTSPELLS DS 2

OPENIT MLI_OPEN OPARMS
 JSR MLIERR
 LDA OPARMS+5
 STA RWPARMS+1
 STA MPARMS+1
 STA CPARMS+1
 RTS

DOMARK CLC
 XCE
 REP #$30
 STZ MPARMS+2
 LDX CURRSP
]LOOP CPX #0
 BEQ :DONE
 LDA MPARMS+2
 CLC
 ADC #SDRECLEN
 STA MPARMS+2
 LDA MPARMS+4
 ADC #0
 STA MPARMS+4
 DEX
 BRA ]LOOP
:DONE SEC
 XCE
 MLI_SET_MARK MPARMS
 JMP MLIERR

CALCS STA :CNTR
 BEQ :RTS
 DEC
 LSR
 LSR
 LSR
 LSR
 LSR
 INC
 STA :TYPE
 LDA :CNTR
]LOOP CMP #33
 BCC :LOK
 SEC
 SBC #32
 BRA ]LOOP
:LOK DEC
 LSR
 LSR
 INC
 STA :LVL
 JSR PRINT
 ASC " (level "
 COLOR YELLOW
 DEC8 :LVL
 COLOR WHITE
 ASC " / "
 PRTABLE :TYPE;:TABLE
 ASC ")"
 NULL
:RTS RTS
:TYPE DS 1
:CNTR DS 1
:LVL DS 1

]LEN = 16
:TABLE DFB ]LEN
 ENTRY "<none>"
 ENTRY "Wizard"
 ENTRY "Cleric"
 ENTRY "Sage"

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/SPDESC.EDITOR
 fin

 END
