*-------------------------------
* Notes on Spells
*-------------------------------
*
* Name     - word used to cast spell
*
* Descr    - brief description of spell
*
* Type     - type of spell (Regular {affect one person})
*                          (Missile {fired in a direction})
*                          (Area {squares around caster})
*                          (Information {about someone/something})
*                          (Party {affects everyone in party})
*
* Cost     - magic point cost
*
* Time     - action point cost to cast spell
*
* Damage   - amount of damage done (or HP gained for healing)
*
* Duration - how long the spell lasts (instant or n/a)
*                                     (permanent {until removed})
*                                     (duration in turns)
*
*-------------------------------
* Wizard spells
*-------------+-------------------------+------+----+----+-----+-----------
* Name        | Description             | Type |Cost|Time| Dam | Duration
*-------------+-------------------------+------+----+----+-----+-----------
*--[Level 1]--|                         |      |    |    |     |
* Frebl       | Fire small fireball at  | Miss |  1 |  1 | 1-4 | instant
*             |  someone                |      |    |    |     |
* Slef        | Sleep someone for a     | Reg. |  2 |  2 | n/a | 1 turn
*             |  short time             |      |    |    |     |
* Snaf        | Stun someone for a short| Reg. |  2 |  2 | n/a | 1 turn
*             |  time                   |      |    |    |     |
* Lefca       | Lift caster off the     | Reg. |  1 |  1 | n/a | 1 turn
*             |  ground briefly         |      |    |    |     |
*--[Level 2]--|                         |      |    |    |     |
* Lenvi       | Lift a party member off | Reg. |  2 |  1 | n/a | 1-2 turns
*             |  the ground briefly     |      |    |    |     |
* Smalk       | Fire shower small rocks | Miss |  2 |  1 | 1-6 | instant
*             |  at someone             |      |    |    |     |
* Blocum      | Fire a huge boulder at  | Miss |  2 |  2 | 3-8 | instant
*             |  someone                |      |    |    |     |
* Pazcra      | Paralyze someone for a  | Reg. |  2 |  2 | n/a | 1-2 turns
*             |  short time             |      |    |    |     |
*--[Level 3]--|                         |      |    |    |     |
* Snablm      | Fire a large ball of    | Miss |  3 |  1 | 2-12| instant
*             |  ice at someone         |      |    |    |     |
* Freblma     | Fire a big fireball at  | Miss |  3 |  2 | 4-19| instant
*             |  someone                |      |    |    |     |
* Leftcasma   | Levitate the caster for | Reg. |  3 |  2 | n/a | permanent
*             |  an unlimited time      |      |    |    |     |
* Spedi       | Add 2 action points to  | Reg. |  3 |  2 | n/a | instant
*             |  a party member         |      |    |    |     |
*--[Level 4]--|                         |      |    |    |     |
* Difeld      | Diminish a force field  | Reg. |  4 |  2 | n/a | this turn
*             |  for a short time       |      |    |    |     |
* Levimaf     | Levitate a party member | Reg. |  4 |  2 | n/a | 1-4 turns
*             |  for a short time       |      |    |    |     |
* Spedimaf    | Add 4 action points to  | Reg. |  5 |  3 | n/a | instant
*             |  a party member         |      |    |    |     |
* Paraf       | Fire a poison arrow at  | Reg. |  5 |  2 | n/a | permanent
*             |  someone                |      |    |    |     |
*--[Level 5]--|                         |      |    |    |     |
* Ardatine    | Fire an arrow of death  | Miss |  8 |  5 |10-30| instant
*             |  at someone             |      |    |    |     |
* Telac       | Randomly teleport       | Reg. |  6 |  3 | n/a | instant
*             |  someone this level     |      |    |    |     |
* Telpi       | Teleport a party member | Reg. | 10 |  8 | n/a | instant
*             |  to a location          |      |    |    |     |
* Unlevi      | Levitate a party member | Reg. | 10 |  5 | n/a | permanent
*             |  for an unlimited time  |      |    |    |     |
*--[Level 6]--|                         |      |    |    |     |
* Klemna      | All monsters in the     | Area | 20 | 10 |30-80| instant
*             |  area take damage       |      |    |    |     |
* Gathpa      | Gather the party into   | Prty | 15 |  5 | n/a | instant
*             |  caster's square        |      |    |    |     |
* Gatelpi     | Gather the party and    | Prty | 15 | 10 | n/a | instant
*             |  teleport somewhere     |      |    |    |     |
* Spedimasup  | Add 3 action points to  | Prty | 20 |  5 | n/a | instant
*             |  all party members      |      |    |    |     |
* [24 spells]

*-------------------------------
* Cleric spells
*-------------+-------------------------+------+----+----+-----+-----------
* Name        | Description             | Type |Cost|Time| Dam | Duration
*-------------+-------------------------+------+----+----+-----+-----------
*--[Level 1]--|                         |      |    |    |     |
* Rizap       | Wake a party member     | Reg. |  1 |  1 | n/a | permanent
*             |  from sleep             |      |    |    |     |
* Minel       | Heal 1 to 4 HP to a     | Reg. |  1 |  1 | 1-4 | instant
*             |  party member           |      |    |    |     |
* Pazf        | Paralyze someone for a  | Reg. |  2 |  2 | n/a | 1 turn
*             |  short time             |      |    |    |     |
* Blaf        | Blind someone for a     | Reg. |  1 |  1 | n/a | 1 turn
*             |  short time             |      |    |    |     |
*--[Level 2]--|                         |      |    |    |     |
* Curbl       | Cure blindness from a   | Reg. |  2 |  1 | n/a | instant
*             |  party member           |      |    |    |     |
* Majel       | Heal 2 to 10 HP to a    | Reg. |  2 |  1 | 2-10| instant
*             |  party member           |      |    |    |     |
* Halcast     | Heal caster 1 to 6 HP   | Reg. |  1 |  1 | 1-6 | instant
*             |                         |      |    |    |     |
* Curpa       | Cure poison from a      | Reg. |  2 |  2 | n/a | permanent
*             |  party member           |      |    |    |     |
*--[Level 3]--|                         |      |    |    |     |
* Blaffak     | Blind all monsters in   | Area |  4 |  2 | n/a | 1-2 turns
*             |  area u can see briefly |      |    |    |     |
* Ledfal      | Cause someone to stop   | Reg. |  4 |  2 | n/a | parmanent
*             |  levitating             |      |    |    |     |
* Dispund     | Banish an undead        | Reg. |  5 |  2 | n/a | permanent
*             |  monster                |      |    |    |     |
* Curpza      | Cure paralysis from a   | Reg. |  5 |  3 | n/a | instant
*             |  party member           |      |    |    |     |
*--[Level 4]--|                         |      |    |    |     |
* Visep       | Detect passages in the  | Area |  5 |  3 | n/a | instant
*             |  area                   |      |    |    |     |
* Mawiv       | View the whole area     | Area |  7 |  5 | n/a | instant
*             |  around you             |      |    |    |     |
* Gretel      | Heal 10 to 30 HP to a   | Reg. |  5 |  3 |10-30| instant
*             |  party member           |      |    |    |     |
* Akrid       | Fire a small ball of    | Miss |  6 |  4 | 3-18| instant
*             |  acid at someone        |      |    |    |     |
*--[Level 5]--|                         |      |    |    |     |
* Invankh     | Make a party member     | Reg. |  7 |  3 | n/a | 1-4 turns
*             |  invisible (short time) |      |    |    |     |
* Blotnig     | Throw a bolt of         | Miss | 10 |  5 |10-30| instant
*             |  lightning at someone   |      |    |    |     |
* Contel      | Heal all HP & cure cond | Reg. | 10 |  5 | n/a | instant
*             |  from a party member    |      |    |    |     |
* Gredat      | All monsters within the | Area | 15 | 10 | 9-54| instant
*             |  area take damage       |      |    |    |     |
*--[Level 6]--|                         |      |    |    |     |
* Invacla     | Make a party member     | Reg. | 10 |  5 | n/a | permanent
*             |  invisible (unlimited)  |      |    |    |     |
* Polmyst     | Polymorph a monster     | Reg. | 10 |  7 | n/a | instant
*             |  (change monster type)  |      |    |    |     |
* Lywake      | Resurrect party member  | Reg. | 20 | 10 | n/a | instant
*             |  from the dead          |      |    |    |     |
* Recalst     | Return a party member   | Reg. | 20 | 10 | n/a | instant
*             |  to the castle          |      |    |    |     |
* [24 spells]

*-------------------------------
* Sage spells
*-------------+-------------------------+------+----+----+-----+-----------
* Name        | Description             | Type |Cost|Time| Dam | Duration
*-------------+-------------------------+------+----+----+-----+-----------
*--[Level 1]--|                         |      |    |    |     |
* Mestna      | Mentally stun someone   | Reg. |  1 |  1 | n/a | 1-2 turns
*             |  for a short time       |      |    |    |     |
* Melpan      | Cause someone to go to  | Reg. |  2 |  1 | n/a | 1-3 turns
*             |  sleep for a short time |      |    |    |     |
* Selif       | Detect beings in the    | Area |  3 |  2 | n/a | instant
*             |  area                   |      |    |    |     |
* Melevik     | Levitate the caster for | Reg. |  5 |  2 | n/a | permanent
*             |  an unlimited time      |      |    |    |     |
*--[Level 2]--|                         |      |    |    |     |
* Meclarv     | See area around the     | Area |  5 |  3 | n/a | instant
*             |  caster                 |      |    |    |     |
* Metelp      | Teleport caster to a    | Reg. |  5 |  2 | n/a | instant
*             |  square he can see      |      |    |    |     |
* Mebrash     | Mentally stun someone   | Reg. |  5 |  2 | n/a | 1-3 turns
*             |  for a short time       |      |    |    |     |
* Mecrum      | Mental crush on beings  | Area |  5 |  4 | 2-12| instant
*             |  in the area            |      |    |    |     |
*--[Level 3]--|                         |      |    |    |     |
* Mevisk      | Insight into someone's  | Info |  7 |  3 | n/a | instant
*             |  attributes             |      |    |    |     |
* Locap       | Locate someone          | Info |  2 |  2 | n/a | instant
*             |  within the dungeon     |      |    |    |     |
* Blipak      | Teleport a party member | Reg. |  6 |  2 | n/a | instant
*             |  within the area        |      |    |    |     |
* Vistar      | Detect stairs in the    | Area |  5 |  3 | n/a | instant
*             |  area                   |      |    |    |     |
*--[Level 4]--|                         |      |    |    |     |
* Fistol      | Hit someone with a huge | Miss |  6 |  3 | 6-16| instant
*             |  imaginary fist         |      |    |    |     |
* Parqui      | Acquire knowledge of a  | Info | 10 | 10 | n/a | instant
*             |  party's location       |      |    |    |     |
* [14 spells]
