*-------------------------------
* TEST.MODULE
*-------------------------------
 DAT
 LST OFF

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE VARS
 USE LIB.JMP

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/TEST.MODULE
 fin

 MODID "TEST.MODULE"

START JSR PRINT
 NORMAL
 MTOFF
 HOME
 CURSORON
 LINE "Test module"
 CR
 LINE "Numeric keypad options:"
 CR
 LINE "0 - display SCC read registers"
 LINE "1 - toggle modem-send on/off"
 LINE "2 - scroll screen down"
 LINE "3 - init SCC port"
 LINE "4 - init modem (string)"
 LINE "5 - toggle text/super hi-res"
 LINE "6 - long log note"
 LINE "7 - check DSR bit"
 LINE "8 - scroll screen up"
 LINE "9 - random 1-100"
 LINE "* - display this menu"
 CR
 LINE "[ESC]-exit"
 CR
 NULL

]TOPLOOP JSR CHECKIN
 BCC :NOPE
 ORA #%1000_0000
 CMP #$8A
 BEQ ]TOPLOOP
 JSR COUT
 BRA ]TOPLOOP
:NOPE LDA $C000
 BPL ]TOPLOOP
 STA $C010
 STA :CHAR+1
 CMP #$9B
 BEQ EXIT
 LDA $C025
 AND #%0001_0000
 BNE :KEYPAD
:CHAR LDA #"?"
 BIT MSFLAG
 BMI :MODEM
 JSR COUT
 BRA ]TOPLOOP
:MODEM JSR MSENDBYTE
 BRA ]TOPLOOP

:KEYPAD LDA :CHAR+1
 LDX :KEYS
]LOOP CMP :KEYS,X
 BEQ :GOTONE
 DEX
 BNE ]LOOP
 JMP ]TOPLOOP
:GOTONE DEX
 TXA
 ASL
 TAX
 JMP (:TABLE,X)

:KEYS DFB :ENDKEYS-*-1
 DFB "0"
 DFB "1"
 DFB "2"
 DFB "3"
 DFB "4"
 DFB "5"
 DFB "6"
 DFB "7"
 DFB "8"
 DFB "9"
 DFB "*"
:ENDKEYS

:TABLE DA REGS
 DA MSTOGG
 DA DOWN
 DA INITZ
 DA INITM
 DA TXTSHR
 DA LNOTE
 DA DSR
 DA UP
 DA ROLL
 DA START

EXIT JSR PRINT
 NORMAL
 MTOFF
 CURSORON
 HOME
 NULL
 RETURN

DSR LDX #0
 STX SCCCOMMAND
 LDA SCCCOMMAND
 AND #ZSCCDSR
 JSR PRBYTE
 JMP ]TOPLOOP

LNOTE NOTELOGSTR $9;"Prefix ";:PFX
 JMP ]TOPLOOP
:PFX STR "Macs suck:Desktop Folder:ComplexIIMac Folder:Terminal (B&W)"

REGS STZ :CNTR
]LOOP LDX :CNTR
 LDA :REGS,X
 CMP #$FF
 BEQ :DONE
 TAX
 STX :REG
 JSR GETPORTREG
 STA :VALUE
 JSR PRINT
 HEX8 :REG
 ASC " = "
 PRNIBBLE :VALUE
 ASC " ($"
 HEX8 :VALUE
 LINE ")"
 NULL
 INC :CNTR
 BRA ]LOOP
:DONE JSR PRINT
 CR
 NULL
 JMP ]TOPLOOP
:CNTR DS 1
:REG DS 1
:VALUE DS 1
:REGS DFB 0,1,2,3,10,12,13,15
 DFB $FF

MSTOGG LDA MSFLAG
 EOR #$FF
 STA MSFLAG
 JSR PRINT
 CR
 ASC "ModemSend : "
 PRFLAG MSFLAG
 CR
 NULL
 JMP ]TOPLOOP

TXTSHR LDA $C029
 EOR #%1000_0000
 STA $C029
 JMP ]TOPLOOP

DOWN JSR PRINT
 SCROLLDOWN
 NULL
 JMP ]TOPLOOP

UP JSR PRINT
 SCROLLUP
 NULL
 JMP ]TOPLOOP

MSFLAG DS 1

INITZ JSR INITCARD
 JMP ]TOPLOOP

INITM LDA TESTFLAG
 PHA
 STZ TESTFLAG
 JSR INITMODEM
 PHP
 PLA
 AND #%0000_0001
 JSR PRBYTE
 PLA
 STA TESTFLAG
 JMP ]TOPLOOP

ROLL RANDNUM #100
 STX :NUM
 STA :NUM+1
 LDX #3
 JSR ROLLD6
 LDA VTEMP
 STA :3D6
 LDX #1
 JSR ROLLD6
 LDA VTEMP
 STA :1D6
 JSR PRINT
 ASC "Random(100) = "
 DEC16 :NUM
 ASC " ($"
 HEX16 :NUM
 ASC ")."
 HTAB 30
 ASC "3d6 = "
 DEC8 :3D6
 ASC ", 1d6 = "
 DEC8 :1D6
 CR
 NULL
 JMP ]TOPLOOP
:NUM DS 2
:3D6 DS 1
:1D6 DS 1

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/TEST.MODULE
 fin

 END
