*-------------------------------
* WL.EDITOR
*-------------------------------
 DAT
 LST OFF

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE VARS
 USE LIB.JMP
 USE WISH.DSECT
 USE PN.DSECT

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/WL.EDITOR
 fin

 MODID "WL.EDITOR"

NUMWLST = 5

START JSR PRINT
 HOME
 BOX "Wish List Editor"
 NULL

 LDX #0
 LDA #0
 JSR LOADPN
 LDA PNBUFF
 STA TOTPN

 JSR LOADSLICE
 STR "FILES/WISH.LIST"
 DA MISCBUFF
 DA 0
 DA WLRECLEN
 LDA MISCBUFF
 STA NUMWL
 JMP :FORW1

:BOT JSR PRINT
 GOTOXY 1;1
 ASC "Total in file : "
 COLOR YELLOW
 DEC8 NUMWL
 COLOR WHITE
 GOTOXY 0;23
 CLEOS
 ASC "[A]dd, [J]ump, [S]ave, [L]ist, [RETURN]-edit, "
 MTON
 INVERSE
 ASC "H"
 NORMAL
 ASC ", "
 INVERSE
 ASC "U"
 NORMAL
 MTOFF
 ASC ", [H]elp, [Q]uit : "
 CURSORON
 NULL
 LDA CH
 STA :BGOTO+2
:GETKEY JSR PRINT
:BGOTO GOTOXY 0;23
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 LDX :KEYS
]LOOP2 CMP :KEYS,X
 BEQ :GOTONE
 DEX
 BNE ]LOOP2
 JMP ]LOOP
:GOTONE DEX
 TXA
 ASL
 TAX
 JMP (:TABLE,X)

:KEYS DFB :ENDKEYS-*-1
 DFB "Q"
 DFB "A"
 DFB "L"
 DFB "J"
 DFB "S"
 DFB "H"-$40
 DFB "U"-$40
 DFB "K"-$40
 DFB "J"-$40
 DFB "M"-$40
 DFB "H"
:ENDKEYS

:TABLE DA EXIT
 DA :ADD
 DA :LIST
 DA :LOAD
 DA :SAVE
 DA :BACK1
 DA :FORW1
 DA :UP
 DA :DOWN
 DA :EDIT
 DA :HELP

:HELP JSR PRINT
 GOTOXY 0;4
 CLEOS
 NULL
 JSR GETFILE
 DFB 4,22 ;Use lines x to y
 STR "HELP/WL.ED"
 JSR PRINT
 GOTOXY 0;23
 COLOR PINK
 NULL
 GETRETURN
 JSR PRINT
 GOTOXY 0;4
 COLOR WHITE
 CLEOS
 NULL
 LDX :WL
 JMP :LOK

:DOPOINT LDA :OLDPNTR
 CMP #19
 BCC :PLEFT
 LDA #40
 STA :CH+2
 LDA :OLDPNTR
 SEC
 SBC #15
 STA :CV+2
 BRA :DOP1
:PLEFT STZ :CH+2
 LDA :OLDPNTR
 CLC
 ADC #3
 STA :CV+2
:DOP1 JSR PRINT
 NORMAL
 MTOFF
:CH HTAB 0
:CV VTAB 0
 ASC " "
 NULL
 LDA :PNTR
 CMP #19
 BCC :PLEFT2
 LDA #40
 STA :CH2+2
 LDA :PNTR
 SEC
 SBC #15
 STA :CV2+2
 BRA :DOP2
:PLEFT2 STZ :CH2+2
 LDA :PNTR
 CLC
 ADC #3
 STA :CV2+2
:DOP2 JSR PRINT
:CH2 HTAB 0
:CV2 VTAB 0
 NULL
 JSR SHOWPNTR
 LDA :PNTR
 STA :OLDPNTR
 RTS
:OLDPNTR DFB 1
:PNTR DFB 1

:UP LDA NUMWL
 ORA NUMWL+1
 BEQL :BOT
 LDA :PNTR
 CMP #1
 BNE :UPOK
 LDA #NUMWLST+1
:UPOK DEC
 STA :PNTR
 JSR :DOPOINT
 JMP :GETKEY

:DOWN LDA NUMWL
 ORA NUMWL+1
 BEQL :BOT
 LDA :PNTR
 CMP #NUMWLST
 BNE :DNOK
 LDA #0
:DNOK INC
 STA :PNTR
 JSR :DOPOINT
 JMP :GETKEY

:EDIT LDA NUMWL
 ORA NUMWL+1
 BEQL :BOT
 LDA :PNTR
 DEC
 ASL
 TAX
 JMP (:EDITS,X)

:EDITS DA :FREE
 DA :FROM
 DA :DATE
 DA :COMMENT
 DA :REPLY

:LOAD LDA NUMWL
 ORA NUMWL+1
 BEQL :BOT
 JSR PRINT
 GOTOXY 0;23
 CLEOS
 ASC "Jump to WL #"
 CURSORON
 NULL
 GETLINE #5
 JSR GETNUM
 CPX #0
 BNE :LOK
:LOK CPX NUMWL
 BEQ :RNGOK
 BCC :RNGOK
 JSR PRINT
 COLOR PINK
 ASC " No such WL. "
 COLOR WHITE
 NULL
 GETRETURN
 JMP :BOT
:RNGOK STX :WL
 JSR LOADWL
 JSR :DISPLAY
 STZ :FLAG
 JMP :BOT

:SAVE LDA NUMWL
 ORA NUMWL+1
 BEQL :BOT
 BIT :FLAG
 BPLL :GETKEY
:SAVE2 LDX :WL
 JSR SAVEWL
 STZ :FLAG
 JMP :BOT

:BACK1 LDA NUMWL
 ORA NUMWL+1
 BEQL :BOT
 LDA :WL
 CMP #2
 BCS :GOB
 JMP :BOT
:GOB DEC :WL
 LDX :WL
 JMP :LOK

:FORW1 LDA NUMWL
 ORA NUMWL+1
 BEQL :BOT
 LDA :WL
 CMP NUMWL
 BCC :GOF
 JMP :BOT
:GOF INC :WL
 LDX :WL
 JMP :LOK

:LIST LDA NUMWL
 ORA NUMWL+1
 BEQL :BOT
 JSR PRINT
 GOTOXY 0;23
 CLEOS
 ASC "Start from WL #1"
 CURSORLEFT
 NULL
 LDA PADFLAG
 STA TEMP
 LDA #$FF
 STA PADFLAG
 LDA PADCHAR
 STA TEMP+1
 LDA #" "
 STA PADCHAR
 LDA #1
 STA :TOREAD
 GETLINE #5
 BCSL :LEXIT
 CPX #0
 BEQ :FROM1
 JSR GETNUM
 STX :TOREAD
:FROM1 LDA :TOREAD
 CMP NUMWL
 BCC :VGO
 BEQ :VGO
 JSR PRINT
 ASC " - "
 COLOR PINK
 ASC "Last WL is #"
 COLOR YELLOW
 DEC8 NUMWL
 COLOR PINK
 ASC ". "
 COLOR WHITE
 NULL
 GETRETURN
 JSR PRINT
 ZAPLINE
 NULL
 JMP :LEXIT
:VGO LDA :TOREAD
 STA :WLCNTR
 JSR PRINT
 GOTOXY 0;3
 CLEOS
 CR
 COLOR AQUAMARINE
 LINE "WL  /?/From/Date     /Comment & reply"
 COLOR WHITE
 CURSOROFF
 NULL
]LOOP LDA :WLCNTR
 CMP NUMWL
 BCC :RREAD
 BEQ :RREAD
 JMP :RDONE
:RREAD LDX :TOREAD
 JSR LOADWL
 INC :TOREAD
 LDA CV
 CMP #21
 BNE :VOK
 JSR PRINT
 CR
 CR
 CURSORON
 COLOR YELLOW
 CENTER "[SPACE]-continue, [ESC]-exit : "
 COLOR WHITE
 NULL
]LOOP3 JSR KEYIN
 CMP #$9B
 BEQL :RESC
 CMP #" "
 BNE ]LOOP3
 JSR PRINT
 GOTOXY 0;5
 CLEOS
 CURSOROFF
 NULL
:VOK JSR PRINT
 CR
 COLOR YELLOW
 DEC8 :WLCNTR
 COLOR WHITE
 ASC ") "
 PRFLAG WISHFREE
 ASC "  "
 COLOR YELLOW
 DEC8 WISHFROM
 ASC " "
 COLOR GREEN
 DATE WISHDATE
 ASC " "
 COLOR WHITE
 NULL
 JSR DOSTR
 JSR PRINT
 CR
 COLOR AQUAMARINE
 HTAB 22
 NULL
 JSR DOSTR2
 JSR PRINT
 COLOR WHITE
 NULL
 INC :WLCNTR
 LDA $C000
 BPLL ]LOOP
 STA $C010
 CMP #$9B
 BEQ :RDONE
 JMP ]LOOP
:RESC JSR PRINT
 ZAPLINE
 CURSORON
 NULL
 BRA :RDONE2
:RDONE JSR PRINT
 GOTOXY 0;23
 COLOR PINK
 CURSORON
 NULL
 GETRETURN
 JSR PRINT
 COLOR WHITE
 NULL
:RDONE2 LDA TEMP
 STA PADFLAG
 LDA TEMP+1
 STA PADCHAR
 LDX :WL
 JMP :LOK
:LEXIT LDA TEMP
 STA PADFLAG
 LDA TEMP+1
 STA PADCHAR
 JMP :BOT
:WLCNTR DS 1
:TOREAD DA 1

:DISPLAY LDA NUMWL
 ORA NUMWL+1
 BEQL :BOT
 JSR PRINT
 GOTOXY 60;1
 ASC "WL #"
 COLOR YELLOW
 DEC8 :WL
 COLOR WHITE
 ASC " "
 GOTOXY 0;4
 CLEOS
 CURSOROFF
 ASC "  1 - Free......."
 COLOR YELLOW
 PRFLAG WISHFREE
 COLOR WHITE
 CR
 ASC "  2 - From......."
 COLOR YELLOW
 DEC8 WISHFROM
 COLOR WHITE
 NULL
 LDX WISHFROM
 BEQ :DISP2
 LDA #0
 JSR LOADPN
 JSR PRINT
 ASC " ("
 COLOR ORANGE
 PRSTRING PNNAME
 COLOR WHITE
 ASC ")"
 NULL
:DISP2 JSR PRINT
 CR
 ASC "  3 - Date......."
 COLOR GREEN
 DATE WISHDATE
 COLOR WHITE
 CR
 ASC "  4 - Comment...."
 COLOR PINK
 NULL
 JSR DOSTR
 JSR PRINT
 COLOR WHITE
 CR
 ASC "  5 - GM reply..."
 COLOR AQUAMARINE
 NULL
 JSR DOSTR2
 JSR PRINT
 COLOR WHITE
 CR
 CURSORON
 NULL
 JMP :DOPOINT
:WL DS 1

:WLBACK JSR PRINT
 GOTOXY 0;23
 CLEOS
 NULL
 JSR :DISPLAY
 LDA #$FF
 STA :FLAG
 JMP :BOT

:ADD JSR PRINT
 GOTOXY 0;23
 CLEOS
 ASC "Add - [N]ext free one, [E]nd of file, [ESC] Exit : "
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 CMP #$9B
 BEQL :BOT
 CMP #"N"
 BEQ :ANEXT
 CMP #"E"
 BNE ]LOOP
 JSR COUT
:AEND LDA NUMWL
 CMP #$FF
 BCC :AEOK
 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 COLOR PINK
 ASC "Cannot add any more wish lists. "
 COLOR WHITE
 NULL
 GETRETURN
 JMP :ADD
:AEOK INC NUMWL
 LDA NUMWL
 STA MISCBUFF
 LDX #0
 JSR SAVEWL
:AGOTIT LDX #0
]LOOP STZ MISCBUFF,X
 INX
 BNE ]LOOP
 JSR :DISPLAY
 JMP :SAVE2
:ANEXT JSR COUT
 LDX :WL
 STX :WLL
]LOOP LDA :WLL
 CMP NUMWL
 BEQ :NRNGOK
 BCSL :AEND
:NRNGOK LDX :WLL
 JSR LOADWL
 INC :WLL
 LDA WISHFREE
 BPL ]LOOP
 DEC :WLL
 LDA :WLL
 STA :WL
 JMP :AGOTIT
:WLL DS 1

:FREE LDX #1
 LDY #1
 JSR ASK
 GETLINE #1
 CPX #0
 BEQL :WLBACK
 LDA $200
 CMP #"1"
 BEQ :A1
 CMP #"0"
 BNE :FREE
 LDA #0
 HEX 2C
:A1 LDA #$FF
 STA WISHFREE
 JMP :WLBACK

:FROM LDX #5
 LDY #2
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :GRTS
 JSR GETNUM
 DEX
 CPX TOTPN
 BCS :GRTS
 INX
 STX WISHFROM
:GRTS JMP :WLBACK

:DATE LDX #3
 LDY #3
 JSR ASK
 GETLINE #6
 CPX #6
 BNE :DCRTS
 LDX #3
]LOOP LDA $200+2,X
 STA :DENTRY,X
 DEX
 BPL ]LOOP
 LDA #$8D
 STA $202
 LDX #2
 JSR GETNUM
 STX :DDAY
 LDA :DENTRY
 STA $200
 LDA :DENTRY+1
 STA $201
 LDX #2
 JSR GETNUM
 STX :DMONTH
 LDA :DENTRY+2
 STA $200
 LDA :DENTRY+3
 STA $201
 LDX #2
 JSR GETNUM
 STX :DYEAR
 LDA :DMONTH
 ASL
 ASL
 ASL
 ASL
 ASL
 ROL :DYEAR
 ORA :DDAY
 STA WISHDATE
 LDA :DYEAR
 STA WISHDATE+1
:DCRTS JMP :WLBACK

:COMMENT LDX #2
 LDY #4
 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 ASC "Comment : "
 NULL
 GETLINE #65
 CPX #0
 BEQ :NWRTS
 STX WISHTEXT
]LOOP LDA $200-1,X
 STA WISHTEXT,X
 DEX
 BNE ]LOOP
:NWRTS JMP :WLBACK

:REPLY LDX #2
 LDY #5
 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 ASC "Reply : "
 NULL
 GETLINE #65
 BCS :CRTS
 STX WISHREPLY
 CPX #0
 BEQ :CRTS
]LOOP LDA $200-1,X
 STA WISHREPLY,X
 DEX
 BNE ]LOOP
:CRTS JMP :WLBACK

:FLAG DS 1
:DDAY DS 1
:DMONTH DS 1
:DYEAR DS 1
:DENTRY DS 9

DOSTR LDA WISHTEXT
 BNE :OK
 JSR PRINT
 PRSTRING WISHTEXT
 NULL
 RTS
:OK LDX #0
]LOOP LDA WISHTEXT+1,X
 JSR COUT
 LDA CH
 CMP #75
 BCS :DOTS
 INX
 CPX WISHTEXT
 BNE ]LOOP
 RTS
:DOTS JSR PRINT
 ASC ".."
 NULL
 RTS

DOSTR2 LDA WISHREPLY
 BNE :OK
 JSR PRINT
 PRSTRING WISHREPLY
 NULL
 RTS
:OK LDX #0
]LOOP LDA WISHREPLY+1,X
 JSR COUT
 LDA CH
 CMP #75
 BCS :DOTS
 INX
 CPX WISHREPLY
 BNE ]LOOP
 RTS
:DOTS JSR PRINT
 ASC ".."
 NULL
 RTS

EXIT JSR PRINT
 NORMAL
 MTOFF
 HOME
 NULL
 RETURN

LOADWL STX :REC
 JSR LOADSLICE
 STR "FILES/WISH.LIST"
 DA MISCBUFF
:REC DA 0
 DA WLRECLEN
 RTS

SAVEWL STX :REC
 JSR SAVESLICE
 STR "FILES/WISH.LIST"
 DA MISCBUFF
:REC DA 0
 DA WLRECLEN
 RTS

NUMWL DS 1
TEMP DS 2
TOTPN DS 1

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/WL.EDITOR
 fin

 END
